<?php
	call_user_func(function(){
		if (empty($_REQUEST['sc_id'])) return json_exit('404','error','empty sc_id');

		$s = "SELECT
				`id_schedule`,
				`start_datetime`,
				`only_date`,
				`time_zone`
			FROM `schedule`
			WHERE
				`id_schedule` in ({$_REQUEST['sc_id']})
			";

		$q = query($s);

		if ($q === false) return json_exit('404', 'error', 'schedule select error : '. error_db());
		$data_schedule = array();
		while ($d = fetch_assoc($q))
		{
			add_time_zone($d['start_datetime']);
			$format = $this->constant['email_date_format'];
			preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
			list($d['start_datetime'],$datetime_int,$datetime_int_tz) = get_date_arr_for_email($d['start_datetime'],$d['only_date'],$d['time_zone'],$format,$format_with_tz);
			$data_schedule[$d['id_schedule']] = $d;
		}

		if (empty($data_schedule) || count($data_schedule) != count(explode(',',$_REQUEST['sc_id'])))
		{
			 return json_exit('404', 'error', 'schedule not found');
		}

		$s = "SELECT
				`ticket`.`id_schedule`,
				`ticket`.`id_seat`,
				`ticket`.`id_trip`,
				`ticket`.`id_order`,
				`ticket`.`id_trip_seat`,
				`ticket`.`status`,
				`ticket`.`number`,
				`ticket`.`code`,
				`ticket`.`pass`,
				`ticket`.`pass_datetime`,
				`ticket`.`out_datetime`
			FROM `ticket`
			WHERE 
				 `ticket`.`id_schedule` in ({$_REQUEST['sc_id']}) AND (`ticket`.`id_order` IS NOT NULL OR `ticket`.`status` = 2)
			";

		$q = query($s);
		if ($q === false) json_exit('404','error','ticket select error : '. error_db());

		$data_ticket = $data_booking = $data_user = array();
		$booking = $user = array();
		while ($d = fetch_assoc($q))
		{
			if (!empty($d['id_order'])) $booking[$d['id_order']] = true;
			add_time_zone($d['pass_datetime']);
			add_time_zone($d['out_datetime']);
			$data_ticket[] = $d;
		}

		if (!empty($booking))
		{
			$s = "SELECT
					`order`.`id_order`,
					`order`.`id_order_status`,
					`order`.`create_datetime`,
					`order`.`id_payment_method`,
					`order`.`confirm_limit_datetime`,
					`order`.`sum`,
					`order`.`pay_datetime`,
					`order`.`options`,
					`order`.`currency`,
					`order`.`client`
				FROM `order`
				WHERE
					`id_order` in (" . implode(',',array_keys($booking)) . ")
				";

			$q = query($s);

			if ($q === false) return json_exit('404', 'error', 'booking select error : '. error_db());
			while ($d = fetch_assoc($q))
			{
				$user[$d['client']] = true;
				add_time_zone($d['create_datetime']);
				add_time_zone($d['confirm_limit_datetime']);
				add_time_zone($d['pay_datetime']);
				$d['options'] = json_decode($d['options'],true);
				if (empty($d['options']['tickets']['seats'])) json_exit('400','error',$d['id_order'] . ' with empty seats');
				$data_booking[$d['id_order']] = $d;
			}
		}

		if (!empty($user))
		{
			$s = "SELECT
					`users`.`id_user`,
					`users`.`id_role`,
					`users`.`name`,
					`users`.`family`,
					`users`.`middle`,
					`users`.`phone`,
					`users`.`email`
				FROM `users`
				WHERE
					`id_user` in (" . implode(',',array_keys($user)) . ")
				";

			$q = query($s);

			if ($q === false) return json_exit('404', 'error', 'user select error : '. error_db());
			while ($d = fetch_assoc($q))
			{
				$data_user[$d['id_user']] = $d;
			}
		}

		$csv_title_list_arr = array();
		$csv_title_list_arr['идентификатор заказа'] = true;
		$csv_title_list_arr['идентификатор статуса заказа'] = true;
		$csv_title_list_arr['дата создания заказа'] = true;
		$csv_title_list_arr['идентификатор способа оплаты'] = true;
		$csv_title_list_arr['дата истечения оплаты заказа'] = true;
		$csv_title_list_arr['общая сумма заказа'] = true;
		$csv_title_list_arr['дата оплаты заказа'] = true;
		$csv_title_list_arr['идентификатор клиента'] = true;
		$csv_title_list_arr['идентификатор роли клиента'] = true;
		$csv_title_list_arr['имя клиента'] = true;
		$csv_title_list_arr['фамилия клиента'] = true;
		$csv_title_list_arr['отчество клиента'] = true;
		$csv_title_list_arr['телефон клиента'] = true;
		$csv_title_list_arr['емейл клиента'] = true;
		$csv_title_list_arr['статус оплаты'] = true;

		$csv_title_list_arr['идентификатор события'] = true;
		$csv_title_list_arr['идентификатор блока билетов'] = true;
		$csv_title_list_arr['числовой идентификатор места'] = true;
		$csv_title_list_arr['идентификатор места'] = true;
		$csv_title_list_arr['категория места'] = true;
		$csv_title_list_arr['ряд места'] = true;
		$csv_title_list_arr['номер места'] = true;
		$csv_title_list_arr['цена билета на место'] = true;
		$csv_title_list_arr['код доступа на мероприятия'] = true;
		$csv_title_list_arr['строка доступа на мероприятия'] = true;
		$csv_title_list_arr['идентификатор статуса билета'] = true;
		$csv_title_list_arr['название места'] = true;

		$csv_title_list_arr['utm_source'] = true;
		$csv_title_list_arr['utm_medium'] = true;
		$csv_title_list_arr['utm_campaign'] = true;
		$csv_title_list_arr['utm_id'] = true;
		$csv_title_list_arr['utm_content'] = true;
		$csv_title_list_arr['utm_term'] = true;

		$csv_title_list_arr['флаг прохода'] = true;
		$csv_title_list_arr['дата прохода на мероприятие'] = true;
		$csv_title_list_arr['дата выхода с мероприятия'] = true;

		if (!empty($booking))
		{
			while (true)
			{
				$post_data = array(
					'data'	=>	array(
						url('',0,1) =>	array(
							CONFIG	=>	array_keys($booking)
						)
					),
					'hash'	=>	"It's~admin_post"
				);

				$c = curl_init();
				curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($c,CURLOPT_URL, "http://77.237.233.158:5001/get_order_by_admin");
				curl_setopt($c,CURLOPT_POST, 1);
				curl_setopt($c,CURLOPT_POSTFIELDS,json_encode($post_data));
				curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
				curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 60);
				curl_setopt($c, CURLOPT_TIMEOUT, 60);
				$headers = array(
					"Content-Type: application/json"
				);
				curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
				$response = curl_exec($c);
				if (empty($response)) break;
				@$response = json_decode($response,true);
				if (empty($response) || !is_array($response))
				{
					 break;
				}
				if (!empty($response['error']))
				{
					break;
				}
				if (empty($response['data']))
				{
					break;
				}
				foreach($response['data'] as $order_arr)
				{
					$redirect_arr[$order_arr['order']] = array('url'=>$order_arr['redirect']);
					$redirect_arr[$order_arr['order']]['utm'] = array();
					$url_query = parse_url($order_arr['redirect'], PHP_URL_QUERY);
					if ($url_query !== false && $url_query !== NULL)
					{
						parse_str($url_query, $query_arr);
						if (!empty($query_arr['appUrl']))
						{
							$query_arr['appUrl'] = trim($query_arr['appUrl']);
							$taxiAppUrl = $query_arr['appUrl'];
							if (substr($taxiAppUrl,0,1) === '{')
							{
								@$taxiAppUrl = json_decode($taxiAppUrl,true);
								if (empty($taxiAppUrl) || !is_array($taxiAppUrl))
								{
									$taxiAppUrl = $query_arr['appUrl'];
								}
								else
								{
									$taxiAppUrl = isset($taxiAppUrl['failed']) ? $taxiAppUrl['failed'] : (isset($taxiAppUrl['succeeded']) ? $taxiAppUrl['succeeded'] : '');
								}
							}
							$url_query = parse_url($taxiAppUrl, PHP_URL_QUERY);
							if ($url_query !== false && $url_query !== NULL)
							{
								parse_str($url_query, $query_arr);
								foreach($query_arr as $key=>$val)
								{
									if (substr($key,0,3) == 'utm')
									{
										$redirect_arr[$order_arr['order']]['utm'][$key] = $val;
										$csv_title_list_arr[$key] = true;
									}
								}
							}
						}
					}
				}
				break;
			}
		}

		$out = array();
		foreach($data_ticket as $d)
		{
			$data_row = array();
			if (!empty($d['id_order']))
			{
				$data_row['идентификатор заказа'] = $d['id_order'];
				$data_row['идентификатор статуса заказа'] = $data_booking[$d['id_order']]['id_order_status'];
				$data_row['дата создания заказа'] = $data_booking[$d['id_order']]['create_datetime'];
				$data_row['идентификатор способа оплаты'] = $data_booking[$d['id_order']]['id_payment_method'];
				$data_row['дата истечения оплаты заказа'] = $data_booking[$d['id_order']]['confirm_limit_datetime'];
				$data_row['общая сумма заказа'] = round((float)$data_booking[$d['id_order']]['sum'],2) . ' ' . $data_booking[$d['id_order']]['currency'];
				$data_row['дата оплаты заказа'] = $data_booking[$d['id_order']]['pay_datetime'];
				$data_row['идентификатор клиента'] = $data_booking[$d['id_order']]['client'];
				$data_row['идентификатор роли клиента'] = $data_user[$data_booking[$d['id_order']]['client']]['id_role'];
				$data_row['имя клиента'] = $data_user[$data_booking[$d['id_order']]['client']]['name'];
				$data_row['фамилия клиента'] = $data_user[$data_booking[$d['id_order']]['client']]['family'];
				$data_row['отчество клиента'] = $data_user[$data_booking[$d['id_order']]['client']]['middle'];
				$data_row['телефон клиента'] = $data_user[$data_booking[$d['id_order']]['client']]['phone'];
				$data_row['емейл клиента'] = $data_user[$data_booking[$d['id_order']]['client']]['email'];
				$data_row['статус оплаты'] = isset($data_booking[$d['id_order']]['options']['tickets']['payment']) ? $data_booking[$d['id_order']]['options']['tickets']['payment'] : NULL;
				if (!empty($redirect_arr[$d['id_order']]))
				{
					foreach($redirect_arr[$d['id_order']]['utm'] as $key=>$val)
					{
						$data_row[$key] = $val;
					}
				}
			}
			$data_row['идентификатор события'] = $d['id_schedule'];
			$data_row['идентификатор блока билетов'] = $d['id_trip'];
			$data_row['числовой идентификатор места'] = $d['id_trip_seat'];
			$seat_id = $d['id_seat'];
			$seat_s_b_r_s = explode(';',$seat_id);
			if (count($seat_s_b_r_s) < 4)
			{
				$parsed_block = '';
				$parsed_row = '';
				$parsed_seat = $seat_id;
			}
			else
			{
				$parsed_block = $seat_s_b_r_s[1];
				$parsed_row = $seat_s_b_r_s[2];
				$parsed_seat = $seat_s_b_r_s[3];
			}
			$data_row['идентификатор места'] = $d['id_seat'];
			$data_row['категория места'] = $parsed_block;
			$data_row['ряд места'] = $parsed_row;
			$data_row['номер места'] = $parsed_seat;
			if (!empty($d['id_order']) && !empty($data_booking[$d['id_order']]['options']['tickets']['seats'][$d['id_trip']][$d['id_trip_seat']]))
			{
				$price = $data_booking[$d['id_order']]['options']['tickets']['seats'][$d['id_trip']][$d['id_trip_seat']];
				$data_row['цена билета на место'] = round_price($price,2);
			}
			$data_row['код доступа на мероприятия'] = $d['code'];
			$data_row['строка доступа на мероприятия'] = implode(';',array($d['id_seat'],$d['code'],$data_schedule[$d['id_schedule']]['start_datetime']));
			$data_row['идентификатор статуса билета'] = $d['status'];
			$data_row['название места'] = $d['number'];
			$data_row['флаг прохода'] = $d['pass'];
			$data_row['дата прохода на мероприятие'] = $d['pass_datetime'];
			$data_row['дата выхода с мероприятия'] = $d['out_datetime'];	
			$out[] = $data_row;
		}
		$i_title = false;
		$null_str = '';
		$delimiter = '^';
		$not_exist_str = '';
		$csv_title_list_arr = array_keys($csv_title_list_arr);
		$arr = $out;

		$escaped_delimiter = strtr($delimiter,array(']'=>'\\]','\\'=>'\\\\'));
		$reg = "/[\\r\\n\"$escaped_delimiter]/";

		$csv = array();
		if (is_array($arr) && count($arr))
		{
			$csv_title_list = array();
			$csv_title_key = array();
			if (!empty($csv_title_list_arr) && is_array($csv_title_list_arr))
			{
				foreach($csv_title_list_arr as $key)
				{
					$csv_title_list[] = $key;
					$csv_title_key[$key] = true;
				}
			}
			if ($i_title !== false)
			{
				if (!isset($csv_title_key[$i_title])){
					$csv_title_list[] = $i_title;
					$csv_title_key[$i_title] = true;
				}
			}
			$str = array();
			if ($i_title === false){
				foreach($arr as $row)
				{
					if (!is_array($row)) continue;
					$str = array();
					foreach($csv_title_list as $key)
					{
						if (array_key_exists($key,$row))
						{
							$val = $row[$key];
							unset($row[$key]);
							if ($val === NULL)
							{
								$val = $null_str;
							}
							elseif (is_array($val))
							{
								$val = json_encode($val);
							}
						}
						else
						{
							$val = $not_exist_str;
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					foreach($row as $key=>$val)
					{
						$csv_title_list[] = $key;
						$csv_title_key[$key] = true;
						if ($val === NULL)
						{
							$val = $null_str;
						}
						elseif (is_array($val))
						{
							$val = json_encode($val);
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					$csv[] = implode($delimiter,$str);
				}
			} else {
				foreach($arr as $i=>$row)
				{
					if (!is_array($row)) continue;
					$str = array();
					foreach($csv_title_list as $key)
					{
						if (array_key_exists($key,$row))
						{
							$val = $row[$key];
							unset($row[$key]);
							if ($val === NULL)
							{
								$val = $null_str;
							}
							elseif (is_array($val))
							{
								$val = json_encode($val);
							}
						}
						elseif ($key == $i_title)
						{
							$val = $i;
						}
						else
						{
							$val = $not_exist_str;
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					foreach($row as $key=>$val)
					{
						$csv_title_list[] = $key;
						$csv_title_key[$key] = true;
						if ($val === NULL)
						{
							$val = $null_str;
						}
						elseif (is_array($val))
						{
							$val = json_encode($val);
						}
						if (preg_match($reg,$val)) $val = '"' . str_replace('"','""',$val) . '"';
						$str[] = $val;
					}
					$csv[] = implode($delimiter,$str);
				}
			}
			$str = array();
			foreach($csv_title_list as $key){
				if (preg_match($reg,$key))
				{
					$key = '"' . str_replace('"','""',$key) . '"';
				}
				$str[] = $key;
			}
			array_unshift($csv,implode($delimiter,$str));
		}
		$csv = chr(0xEF) . chr(0xBB) . chr(0xBF) . implode("\n",$csv);
		header('Content-Type: text/csv');
		header('Content-Length: ' . strlen($csv));
		header("Content-Disposition: attachment; filename=file.csv");
		echo $csv;
		exit;
	});