<?php
define('ROOT_URL', trim('/uventy/'));
function json_exit($code = '200', $status = 'success', $msg = NULL, $data = NULL)
{
	header('Content-Type: application/json;charset=UTF-8');
	$out = array(
		'code' 		=> $code,
		'status' 	=> $status
	);
	if ($msg !== NULL) $out['message'] = $msg;
	if ($data !== NULL) $out['data'] = $data;
	echo json_encode($out);
	exit;
}	
if (isset($_POST['form_flag'])) {
	if (empty($_POST['hash']) || $_POST['hash'] !== 'contr0l_confiG:!') json_exit('400', 'error', "wrong hash");
	foreach(array('config','role','USERNAME','PASSWORD') as $val)
	{
		if (!isset($_POST[$val]) || $_POST[$val] === '') json_exit('400', 'error', "empty $val");
	}
	if (!preg_match('/^[0-9A-z_.-]+$/',$_POST['config'])) json_exit('400', 'error', 'config with wrong chars');
	$folder = $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/list/' . $_POST['config'];
	if (is_file($folder)) json_exit('400', 'error', 'folder is file');
	if (!file_exists($folder)) 
	{
		@$dir = mkdir($folder,0777,true);
		if (!$dir) json_exit('404', 'error', "folder create error");
	}
	$path = "$folder/role{$_POST['role']}.php";
	if (is_dir($path)) json_exit('400', 'error', 'file is folder');
	$config_arr = array();
	foreach(array('USERNAME','PASSWORD') as $val)
	{
		$config_arr[$val] = $_POST[$val];
	}
	$content = '<?php $config_arr = ' . var_export($config_arr,true) . ';';
	if (!@file_put_contents($path,$content)) json_exit('400', 'error', 'file write error');
	json_exit('200', 'success', 'config role user saved');
}	
	?>
<!DOCTYPE html>
<!--[if lt IE 7]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="ru"> <![endif]-->  
<!--[if IE 7]><html class="no-js lt-ie9 lt-ie8" lang="ru"> <![endif]-->  
<!--[if IE 8]><html class="no-js lt-ie9 ie8" lang="ru"> <![endif]-->  
<!--[if gt IE 8]><!--><html class="no-js" lang="ru"> <!--<![endif]--> 
<head>
    <meta charset="utf-8">
    <title>Управление конфигами</title>
    <meta http-equiv="x-rim-auto-match" content="none">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
	<style>
		html,body{margin:0;padding:0;width:100%;height:100%;overflow:auto;font-size:14px;}
		.section{width: 500px; margin: 50px auto 50px auto; text-align: center;}
		fieldset{border-radius:5px;}input{width:95%;}
		.submit{margin-top:10px; width:30%;}
	</style>
<body>
	<div class="section">
		<form method="POST" enctype="application/x-www-form-urlencoded;charset=UTF-8" target="_blank">
			<fieldset><legend>Введите имя конфига (только символы 0-9A-z_.-)</legend>
				<input name="config" type="text">
			</fieldset>
			<fieldset><legend>Введите роль пользователя</legend>
				<input name="role" type="text">
			</fieldset>
			<fieldset><legend>Введите имя пользователя, от лица которого будут выполняться запросы</legend>
				<input name="USERNAME" type="text">
			</fieldset>
			<fieldset><legend>Введите пароль авторизации пользователя</legend>
				<input name="PASSWORD" type="password">
			</fieldset>
			<fieldset><legend>Введите хеш</legend>
				<input name="hash" type="text">
			</fieldset>
			<input name="form_flag" type="hidden">
			<input class="submit" type="submit" value="ОК">
		</form>
	</div>
</body>
</html>
