<?php
require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'models/google-api-php-client/vendor/autoload.php');

$clientID = '';
$clientSecret = '';
$redirectUri = url('google/',CONFIG_URL);			//'https://ibronevik.ru/taxi/c/0/google/'
$taxiAppUrl = '';

if (!empty(taxi::$data['site_constants']['taxi_app_url']['value'])) $taxiAppUrl = trim(taxi::$data['site_constants']['taxi_app_url']['value']);
if (empty($taxiAppUrl)) show_error('empty taxi app url');

if (!empty(taxi::$data_private['site_constants']['google_auth_client_id']['value'])) $clientID = trim(taxi::$data_private['site_constants']['google_auth_client_id']['value']);
if (!empty(taxi::$data_private['site_constants']['google_auth_client_secret']['value'])) $clientSecret = trim(taxi::$data_private['site_constants']['google_auth_client_secret']['value']);
if (empty($clientID) || empty($clientSecret)) header("Location: "."$taxiAppUrl?error=".urlencode('empty client_id or client_secret'));

$client = new Google_Client();
$client->setClientId($clientID);
$client->setClientSecret($clientSecret);
$client->setRedirectUri($redirectUri);
$client->addScope("email");
$client->addScope("profile");

if (isset($_GET['code'])) {
	$token = $client->fetchAccessTokenWithAuthCode($_GET['code']);
	$client->setAccessToken($token['access_token']);

	$google_oauth = new Google_Service_Oauth2($client);
	$google_account_info = $google_oauth->userinfo->get();
	$email =  $google_account_info->email;
	$name =  $google_account_info->name;
 
	$id = get_id_user("",$email,"");
	if (is_array($id))
	{
		if ($id['error'] == 'user not found')
		{
			redirect("$taxiAppUrl?u_email=".urlencode($email)."&u_name=".urlencode($name)); 
		}
		else
		{
		    if (substr($id['error'],0,6) == 'trying')
			{
				$auth_hash = auth_user($_SESSION[UID]);
				if (empty($auth_hash)) header("Location: "."$taxiAppUrl?error=".urlencode('deleted or banned user'));
				redirect("{$taxiAppUrl}?auth_hash=".urlencode($auth_hash));
			}			
			redirect("$taxiAppUrl?error=".urlencode($id['error']));
		}
	}
	else
	{
		$auth_hash = auth_user($id);
		if (empty($auth_hash)) header("Location: "."$taxiAppUrl?error=".urlencode('deleted or banned user'));
		redirect("{$taxiAppUrl}?auth_hash=".urlencode($auth_hash)); 
	}
} else {
	echo "<a href='".$client->createAuthUrl()."'>Google Login</a>";
}
?>