<?php
if (isset($_GET['par'][0]))
{
	if (($_GET['par'][0] == 'redirect' || $_GET['par'][0] == 'endpoint')
		&& isset($_REQUEST['order']) && isset($_REQUEST['c']) && isset($_REQUEST['site']) 
		&& isset($_REQUEST['status']) && isset($_REQUEST['hash']))
	{
		$order = trim($_REQUEST['order']);
		$c = trim($_REQUEST['c']);
		$site = trim($_REQUEST['site']);
		$status = trim($_REQUEST['status']);
		$hash = trim($_REQUEST['hash']);
		$warning = array();
		if ($c != CONFIG) $error[] = 'wrong c';
		if ($site != url('',0,1)) $error[] = 'wrong site';
		$key = "";
		if (!empty(taxi::$data_private['site_constants']['stripe_secret_key']['value'])) $key = trim(taxi::$data_private['site_constants']['stripe_secret_key']['value']);
		if ($hash != md5("$order$c$site$status$key")) $error[] = 'wrong hash';
	}
	elseif ($_GET['par'][0] == 'webhook' )
	{
		$key = "";
		if (!empty(taxi::$data_private['site_constants']['stripe_webhook_signing_secret']['value'])) $key = trim(taxi::$data_private['site_constants']['stripe_webhook_signing_secret']['value']);
		$h_arr = getallheaders();
		if (empty($h_arr['HTTP_STRIPE_SIGNATURE'])) json_exit('400', 'error', 'empty webhook signing secret');
		if ($h_arr['HTTP_STRIPE_SIGNATURE'] != $key) json_exit('400', 'error', 'wrong webhook signing secret');
		$input = @json_decode(file_get_contents('php://input'),true);
		if (empty($input['data']['object']['metadata']['order'])) json_exit('400', 'error', 'empty order');
		$order = $input['data']['object']['metadata']['order'];
		if (empty($input['type'])) json_exit('400', 'error', 'empty type');
		switch ($input['type'])
		{
			case 'payment_intent.canceled':
				$status = 'failed';
				break;
			case 'payment_intent.succeeded':
				$status = 'succeeded';
				break;
			default:
				json_exit('400', 'error', 'wrong type');
		}
	}
	elseif ($_GET['par'][0] == 'tilda_form_webhook')
	{
		if (empty($_REQUEST['hash'])) json_exit('400', 'error', 'empty tilda form webhook key');
		if (empty($_REQUEST['order'])) json_exit('400', 'error', 'empty tilda form webhook order');
		$order = trim($_REQUEST['order']);
		$hash = trim($_REQUEST['hash']);
		$key = "";
		if (!empty(taxi::$data_private['site_constants']['tilda_form_webhook_api_key']['value'])) $key = trim(taxi::$data_private['site_constants']['tilda_form_webhook_api_key']['value']);
		if ($hash != $key) json_exit('400', 'error', 'wrong tilda form webhook key');
		$status = 'succeeded';
	}
	elseif (isset($api_use) && $api_use === true)
	{
		if (is_array($order)) {
			$order_arr = $order;
			$i = 0;
		}
	}
	else
	{
		json_exit('400', 'error', 'wrong request');
	}
	while (true)
	{
		if (isset($order_arr))
		{
			if (!isset($order_arr[$i])) break;
			$order = $order_arr[$i];
			$i++;
		}
		$error = array();
		if (empty($error) && DEFAULT_PROFILE == 'stadium')
		{
			switch ($status){
				case 'pending':		
					break;
				case 'succeeded':
				case 'failed':
				case 'processing':
					$s = "SELECT
							`id_order`,
							`client`,
							`options`,
							`sum`,
							`currency`
						FROM `order` 
						WHERE
							`id_order` = '" . $order . "'
						";

					$q = query($s);
					if ($q === false) 
					{
						$error[] = 'database select failed';
						break;
					}
					$d = fetch_assoc($q);
					if (empty($d['id_order'])) 
					{
						$error[] = 'booking not found';
						break;
					}
					$d['options'] = json_decode($d['options'],true);
					$d_options = $d['options'];
					$d['options']['tickets']['payment'] = $status;
					$trips_seats = empty($d['options']['tickets']['seats']) ? array() : $d['options']['tickets']['seats'];
					if (!is_array($trips_seats))
					{
						$error[] = 'wrong booking seats';
						break;
					}
					if (empty($trips_seats))
					{
						$error[] = 'empty booking seats';
						break;
					}
					$trips = array();
					foreach($trips_seats as $id_trip=>$seats)
					{
						if (!is_array($seats))
						{
							$error[] = $id_trip . 'wrong booking seats';
							break;
						}
						$trips[] = $id_trip;
					}
					$trips = implode(",", $trips);
					$client = $d['client'];
					$sum = round((float)$d['sum'],2) . ' ' . $d['currency'];

					$sql_ticket = array();
					foreach($d['options']['tickets']['t_id'] as $t_id=>$sc_id)
					{
						$seat_id_arr = array();
						foreach($trips_seats[$t_id] as $seat_id=>$price)
						{
							$seat_id_arr[] = $seat_id;
						}
						$sql_ticket[] = "(`id_trip` ='$t_id' AND `id_trip_seat` in ('" . implode("','",$seat_id_arr) . "'))";
					}
					$sql_ticket = implode(" OR ", $sql_ticket);

					if ($status == 'succeeded' )
					{
						while (true)
						{
							$s = "SELECT
									`id_trip`,
									`id_seat`,
									`id_trip_seat`,
									`blob_link`,
									`blob_mime`,
									`blob_ext_w._dot`,
									`number`,
									`code`,
									`code_qr_base64`
								FROM `ticket`
								WHERE $sql_ticket
								";

							$q = query($s);
							if ($q === false)
							{
								$error[] = 'ticket select failed';
								break 2;
							}
							$fix_seats = array();
							$d_ticket = array();
							while ($d_t = fetch_assoc($q))
							{
								$fix_seats[$d_t['id_trip']][$d_t['id_trip_seat']] = $d_t['id_seat'];
								$d_ticket[] = $d_t;
							}

							$ticket = array();
							$trips_seat_id = array();
							$t_id_i = array();
							$sc_id_i = array();
							foreach($d['options']['tickets']['t_id'] as $t_id=>$sc_id)
							{
								$seats = array();
								foreach($trips_seats[$t_id] as $seat_id=>$price)
								{
									$seat_id = isset($fix_seats[$t_id][$seat_id]) ? $fix_seats[$t_id][$seat_id] : $seat_id;
									$seat_s_b_r_s = explode(';',$seat_id);
									if (count($seat_s_b_r_s) < 4)
									{
										$parsed_block = '';
										$parsed_row = '';
										$parsed_seat = $seat_id;
									}
									else
									{
										$parsed_block = $seat_s_b_r_s[1];
										$parsed_row = $seat_s_b_r_s[2];
										$parsed_seat = $seat_s_b_r_s[3];
									}
									$trips_seat_id[$t_id][$seat_id] =  array(
												'block'	=>	$parsed_block,
												'row'	=>	$parsed_row,
												'seat'	=>	$parsed_seat,
												'price'	=>	round_price($price,2),
												'file'	=>	0
									);
									$seats[] = $trips_seat_id[$t_id][$seat_id];
									$trips_seat_id[$t_id][$seat_id]['sc_id'] = $sc_id;
									$trips_seat_id[$t_id][$seat_id]['seat_id_i'] = count($seats) - 1;
								}
								if (isset($ticket[$sc_id]))
								{
									$ticket[$sc_id]['count'] += count($trips_seats[$t_id]);
									$ticket[$sc_id]['trips'][] = array(
																	't_id'	=>	$t_id,
																	'seats'	=>	$seats
																  );					
								}
								else
								{
									$ticket[$sc_id] = array(
															'schedule'	=>	$sc_id,
															'count'		=>	count($trips_seats[$t_id]),
															'trips'		=>	array(
																array(
																	't_id'	=>	$t_id,
																	'seats'	=>	$seats
																)
															)
													   );
									$sc_id_i[$sc_id] = count($ticket) - 1;
								}
								$t_id_i[$t_id] = count($ticket[$sc_id]['trips']) - 1;
							}

							$email_ticket_paid_subject = 'email_ticket_paid_subject';
							$email_ticket_paid_body = 'email_ticket_paid_body';
							$html_pdf_ticket_paid_body = 'html_pdf_ticket_paid_body';
							$s = "SELECT 
									`id_schedule` as id,
									`team1`,
									`team2`,
									`id_stadium` as stadium,
									`id_tournament` as tournament,
									`start_datetime` as datetime,
									`only_date`,
									`time_zone`,
									`code_ean_base64`
								FROM `schedule`
								WHERE
									`id_schedule` in (" . implode(",", array_keys($ticket)) . ")
								";

							$q = query($s);
							if ($q === false)
							{
								$error[] = 'schedule select failed';
								break 2;
							}
							$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
							$lang_name = taxi::$data['langs'][$lang]['iso'];
							$format = empty(taxi::$data['site_constants']['email_date_format']['value']) ? 'Y-m-d H:i:s' : taxi::$data['site_constants']['email_date_format']['value'];
							preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
							$schedule_count = num_rows($q);
							$d_sc_schedule = $d_sc_tournament = NULL;
							while ($d_sc = fetch_assoc($q))
							{
								add_time_zone($d_sc['datetime']);
								$datetime_for_str = $d_sc['datetime'];
								if (!empty($d_sc['only_date'])) $datetime_for_str = @substr($datetime_for_str,0,10);
								list($d_sc['datetime'],$datetime_int,$datetime_int_tz) = get_date_arr_for_email($d_sc['datetime'],$d_sc['only_date'],$d_sc['time_zone'],$format,$format_with_tz);
								$ticket[$d_sc['id']]['schedule'] = array(
									'sc_id' 			=>	$d_sc['id'],
									'team1' 			=>	empty($d_sc['team1']) ? '' : taxi::$data_stt['teams'][$d_sc['team1']][$lang_name],
									'team2' 			=>	empty($d_sc['team2']) ? '' : taxi::$data_stt['teams'][$d_sc['team2']][$lang_name],
									'stadium'			=>	empty($d_sc['stadium']) ? '' : taxi::$data_stt['stadiums'][$d_sc['stadium']][$lang_name],
									'datetime'			=>	$d_sc['datetime'],
									'tournament'		=>	empty($d_sc['tournament']) ? '' : taxi::$data_stt['tournaments'][$d_sc['tournament']][$lang_name],
									'str'				=>	empty($d_sc['team1']) || empty($d_sc['team2']) || empty($d_sc['tournament']) ? '' : taxi::$data_stt['teams'][$d_sc['team1']][$lang_name] . ' - ' . taxi::$data_stt['teams'][$d_sc['team2']][$lang_name] . ', ' . $datetime_for_str . ', '. taxi::$data_stt['tournaments'][$d_sc['tournament']][$lang_name],
									'datetime_int'		=>	$datetime_int,
									'datetime_int_tz'	=>	$datetime_int_tz,
									'code_ean_base64'	=>	$d_sc['code_ean_base64']
								);
								$d_sc_schedule = $d_sc['id'];
								$d_sc_tournament = $d_sc['tournament'];
							}
							if ($schedule_count == 1)
							{
								foreach(array($email_ticket_paid_subject,$email_ticket_paid_body,$html_pdf_ticket_paid_body) as $lang_vls_name_base)
								{
									foreach(array("_{$d_sc_schedule}","_tournament_{$d_sc_tournament}") as $suffix)
									{
										$lang_vls_name = "$lang_vls_name_base$suffix";
										if (isset(taxi::$data['lang_vls'][$lang_vls_name][$lang]) && substr(taxi::$data['lang_vls'][$lang_vls_name][$lang],0,1) !== chr(0))
										{
											$$lang_vls_name_base = $lang_vls_name;
											break;
										}
									}
								}
							}

							$file = array();
							$this_seat = array();
							foreach($d_ticket as $d_t)
							{
								$ticket[$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['sc_id']]['trips'][$t_id_i[$d_t['id_trip']]]['seats'][$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['seat_id_i']]['number'] = $d_t['number'];
								$ticket[$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['sc_id']]['trips'][$t_id_i[$d_t['id_trip']]]['seats'][$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['seat_id_i']]['code'] = $d_t['code'];
								$ticket[$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['sc_id']]['trips'][$t_id_i[$d_t['id_trip']]]['seats'][$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['seat_id_i']]['code_qr_base64'] = empty($d_t['code_qr_base64']) ? string_to_base64_png_qr(implode(';',array($d_t['id_seat'],$d_t['code'],$ticket[$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['sc_id']]['schedule']['datetime']))) : $d_t['code_qr_base64'];	
								$filename = implode(" - ",array($ticket[$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['sc_id']]['schedule']['str'],
								$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['block'],
								$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['row'],
								$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['seat']));								
								$this_seat[] = array(
									'sc_id_i'	=>	$sc_id_i[$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['sc_id']],
									't_id_i'	=>	$t_id_i[$d_t['id_trip']],
									'seat_i'	=>	$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['seat_id_i'],
									'filename'	=>	"$filename.pdf"
								);	

								if ($d_t['blob_link'] === '') continue;
								$folder = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH . "trips/{$d_t['id_trip']}/ticket/";
								$name = $d_t['blob_link'] !== NULL ? $d_t['blob_link'] : $seat;
								$path = "$folder$name";
								if (!file_exists($path)) continue;
								$ticket[$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['sc_id']]['trips'][$t_id_i[$d_t['id_trip']]]['seats'][$trips_seat_id[$d_t['id_trip']][$d_t['id_seat']]['seat_id_i']]['file'] = 1;
								$ticket_file = file_get_contents($path);
								$ext = '';
								if ($d_t['blob_ext_w._dot'] !== NULL && $d_t['blob_ext_w._dot'] !== '')
								{
									$ext = $d_t['blob_ext_w._dot'];
								}
								elseif ($d_t['blob_mime'] !== NULL && $d_t['blob_mime'] !== '')
								{
									$ext = mimeToext($d_t['blob_mime']);
									if (!empty($ext)) $ext = ".$ext";
								}
								$ticket_file_name = "$name$ext";
								$file[] = array('content' => $ticket_file, 'name' => "$filename $ticket_file_name");
							}

							$s = "SELECT 
									`email`,
									`name`,
									`family`,
									`middle`
								FROM `users`
								WHERE
									`id_user` = '" . $client . "'
								";		

							$q = query($s);
							if ($q === false)
							{
								$error[] = 'user select failed';
								break 2;
							}

							$d_u = fetch_assoc($q);
							if (!isset($email))
							{
								if (empty($d_u['email'])) break;
								$email = $d_u['email'];
							}
							$dataForEmail = array(
								'{$b_id}' 			=> $order,
								'{$locationPath}' 	=> url('',CONFIG_URL),
								'{$clientFullname}'	=> "{$d_u['name']} {$d_u['middle']} {$d_u['family']}",
								'{$u_name}' 		=> $d_u['name'],
								'{$u_family}' 		=> $d_u['family'],
								'{$u_middle}' 		=> $d_u['middle'],
								'{$this_seat}'		=> NULL,
								'{$ticket}' 		=> array_values($ticket),
								'{$sum}' 			=> $sum
							);

							$pdf = lang($html_pdf_ticket_paid_body);
							if (!empty($pdf))
							{
								foreach($this_seat as $t_s)
								{
									$dataForEmail['{$this_seat}'] = $t_s;
									list($pdf_body) = fill_in_template(array($pdf),$dataForEmail);
									$file[] = array('content' => html_to_pdf($pdf_body), 'name' => $t_s['filename']);
								}
							}
							unset($dataForEmail['{$this_seat}']);

							$subject = lang($email_ticket_paid_subject);
							$body = lang($email_ticket_paid_body);			
							list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);

							$out['email status'] = send_mail($email,$subject,$body,$file);
							if (isset($resend)) break 2;
							break;
						}
					}

					$s = "UPDATE `order`
						SET
							`options` = '" . real_escape_string(json_encode($d['options'])) . "',
							`pay_datetime` = " . ($status == 'succeeded' ? 'now()' : '`pay_datetime`') . ", 
							`last_edit_datetime` = now(),
							`last_edit_user` = '0'
							" . ($status == 'failed' ? ",`id_order_status` = '3'" : "") . "
						WHERE
							`id_order` = '" . $order . "'
						";

					$q = query($s);
					if ($q === false) 
					{
						$error[] = 'database update failed';
						break;
					}

					if ($status == 'failed')
					{
						$q = query("BEGIN");
						if ($q === false) 
						{
							$error[] = 'begin query failed';
							break;
						}

						$sql_where_ticket = $sql_ticket;

						$s = "SELECT
								`trip`.`id_trip`,
								`trip`.`json`,
								`trip`.`looking_for_clients`,
								count(ti.`id_seat`) as outer_ticket
							FROM `trip`
							LEFT JOIN (
									SELECT
										`id_seat`,
										`id_trip`,
										`id_trip_seat`
									FROM
										`ticket`
									WHERE
										" . $sql_where_ticket . "
								) ti USING (`id_trip`)
							WHERE `trip`.`id_trip` in (" . $trips . ")
							GROUP BY
								`trip`.`id_trip`
							FOR UPDATE
						";

						$q = query($s);
						if ($q === false) 
						{
							$error[] = 'select failed';
							break;
						}
						while ($d = fetch_assoc($q))
						{
							if ($d['id_trip'] === NULL) continue;
							$d['json'] = json_decode($d['json'],true);
							$looking_for_clients_update = false;

							if (empty($d['outer_ticket']))
							{			
								foreach($trips_seats[$d['id_trip']] as $seat=>$val)
								{
									if (is_array($d['json']['seats_sold'][$seat]) && count($d['json']['seats_sold'][$seat]) > 1)
									{
										if ($d['json']['seats_sold'][$seat][1] == $client && !empty($d['json']['seats_sold'][$seat][2]) && $d['json']['seats_sold'][$seat][2] = $order)
										{
											$d['json']['seats_sold'][$seat] = array($d['json']['seats_sold'][$seat][0]);
											$looking_for_clients_update = true;
										}
									}
								}
								if ($looking_for_clients_update === true && $d['looking_for_clients'] = 1) $looking_for_clients_update === false;

								$s = "UPDATE `trip`
									SET
										`json` = '" . real_escape_string(json_encode($d['json'])) . "',
										" . ($looking_for_clients_update === true ? "`looking_for_clients` = '1'," : "") . "
										`last_edit_datetime` = now(),
										`last_edit_user` = '0'
									WHERE
										`id_trip` = '" . $d['id_trip'] . "'
									";

								if (query($s) === false)
								{
									$error[] = $d['id_trip'] . ' update failed';
									break 2;
								}
							}
							else
							{
								if ($d['looking_for_clients'] = 0)
								{
									$s = "UPDATE `trip`
										SET
											`looking_for_clients` = '1',
											`last_edit_datetime` = now(),
											`last_edit_user` = '0'
										WHERE
											`id_trip` = '" . $d['id_trip'] . "'
										";

									if (query($s) === false)
									{
										$error[] = $d['id_trip'] . ': update failed';
										break 2;
									}
								}
							}

							$s = "UPDATE `ticket`
								SET
									`id_order` = NULL
								WHERE
									" . $sql_where_ticket . "
								";

							if (query($s) === false)
							{
								$error[] = 'ticket update failed';
								break 2;
							}
						}

						$q = query("COMMIT");
						if ($q === false) 
						{
							$error[] = 'commit query failed';
							break;
						}

						$s = "SELECT
								`id_trip`,
								`id_seat`,
								`id_trip_seat`,
								`blob_link`,
								`blob_mime`,
								`blob_ext_w._dot`,
								`number`
							FROM `ticket`
							WHERE $sql_ticket
							";

						$q = query($s);
						if ($q === false)
						{
							$warning[] = 'ticket: select failed';
							break;
						}
						$fix_seats = array();
						while ($d_t = fetch_assoc($q))
						{
							$fix_seats[$d_t['id_trip']][$d_t['id_trip_seat']] = $d_t['id_seat'];
						}
						foreach($d_options['tickets']['t_id'] as $t_id=>$sc_id)
						{
							if (empty(taxi::$data_sc['schedule'][$sc_id])) continue;
							$blocks = array(''=>true);
							foreach($trips_seats[$t_id] as $seat_id=>$price)
							{
								$seat_id = isset($fix_seats[$t_id][$seat_id]) ? $fix_seats[$t_id][$seat_id] : $seat_id;
								$seat_s_b_r_s = explode(';',$seat_id);
								if (count($seat_s_b_r_s) < 4)
								{
									$parsed_block = '';
								}
								else
								{
									$parsed_block = $seat_s_b_r_s[1];
								}
								$blocks[$parsed_block] = true;
							}
							$sql_where = array();
							foreach($blocks as $block=>$val)
							{
								$sql_where[] = "'$block'";
							}
							$sql_where = implode(',',$sql_where);
;
							$s = "SELECT 
									`cart_block`.`id_user`,
									`users`.`email`,
									`users`.`name`,
									`users`.`family`,
									`users`.`middle`,
									 GROUP_CONCAT(`id_cart_block` SEPARATOR ',') as cart_block,					 
									 GROUP_CONCAT(`property` SEPARATOR ';') as block_list
								FROM `cart_block`
								LEFT JOIN `users` USING (`id_user`)	
								WHERE
									`cart_block`.`product` = '" . $sc_id . "' AND `cart_block`.`property` in (" . $sql_where . ") AND `cart_block`.`active` = 1  AND `cart_block`.`notification` = 1 AND `users`.`email` IS NOT NULL
								GROUP BY
									`cart_block`.`id_user`
								";		

							$q = query($s);
							if ($q === false)
							{
								$warning[] = "$sc_id: users select failed";
								continue;
							}
							else
							{
								while ($d_cb_u = fetch_assoc($q))
								{
									$block_list = explode(';',$d_cb_u['block_list']);
									$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
									$lang = taxi::$data['langs'][$lang]['iso'];
									$lang_name = "{$lang}";
									$datetime_str = taxi::$data_sc['schedule'][$sc_id]['datetime'];				
									$datetime_for_str = $datetime_str;
									if (!empty(taxi::$data_sc['schedule'][$sc_id]['only_date'])) $datetime_for_str = substr($datetime_for_str,0,10);
									$format = empty(taxi::$data['site_constants']['email_date_format']['value']) ? 'Y-m-d H:i:s' : taxi::$data['site_constants']['email_date_format']['value'];
									preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
									list($datetime_for_str,$datetime_int,$datetime_int_tz) = get_date_arr_for_email($datetime_for_str,taxi::$data_sc['schedule'][$sc_id]['only_date'],taxi::$data_sc['schedule'][$sc_id]['time_zone'],$format,$format_with_tz);
									$dataForEmail = array(
										'{$u_id}' 			=> $d_cb_u['id_user'],		
										'{$locationPath}' 	=> url('',CONFIG_URL),
										'{$u_name}' 		=> $d_cb_u['name'],
										'{$u_family}' 		=> $d_cb_u['family'],
										'{$u_middle}' 		=> $d_cb_u['middle'],
										'{$schedule_arr}'	=>	array(
																	'sc_id' 			=>	$sc_id,
																	'team1' 			=>	empty(taxi::$data_sc['schedule'][$sc_id]['team1']) ? '' : taxi::$data_stt['teams'][taxi::$data_sc['schedule'][$sc_id]['team1']][$lang_name],
																	'team2' 			=>	empty(taxi::$data_sc['schedule'][$sc_id]['team2']) ? '' : taxi::$data_stt['teams'][taxi::$data_sc['schedule'][$sc_id]['team2']][$lang_name],
																	'stadium'			=>	empty(taxi::$data_sc['schedule'][$sc_id]['id_stadium']) ? '' : taxi::$data_stt['stadiums'][taxi::$data_sc['schedule'][$sc_id]['id_stadium']][$lang_name],
																	'datetime'			=>	$datetime_for_str,
																	'datetime_int'		=>	$datetime_int,
																	'datetime_int_tz'	=>	$datetime_int_tz,
																	'tournament'		=>	empty(taxi::$data_sc['schedule'][$sc_id]['tournament']) ? '' : taxi::$data_stt['tournaments'][taxi::$data_sc['schedule'][$sc_id]['tournament']][$lang_name]
																),
										'{$block}'		=>	implode(",", $block_list),
										'{$block_arr}'	=>	$block_list
									);
									$subject = lang('email_available_seats_subject','Message for user {$u_id} from {$locationPath}',2);
									$body = lang('email_available_seats_body','available seats',2);
									list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);
									$out['email status'] = send_mail($d_cb_u['email'],$subject,$body);
									if (!empty($out['email status']))
									{
										$s = "UPDATE `cart_block`
											SET 
												`status_sys` = IF(`status_sys` = 1,2,`status_sys`)
											WHERE
												`id_cart_block` in (" . $d_cb_u['cart_block'] . ")
											";

										query($s);
								
										if ($q === false) $warning[] = "$sc_id: cart_block update failed";

										$s = array();
										foreach (explode(',',$d_cb_u['cart_block']) as $id_cart_block)
										{
											$s[] = "('" . $id_cart_block. "', '" . $id_trip . "', 2)";
										}
										$s = "INSERT INTO `cart_block_trip` (`id_cart_block`, `id_trip`, `status_sys`) VALUES " . implode(",", $s) . "ON DUPLICATE KEY UPDATE `status_sys` = IF(`status_sys` = 1,2,`status_sys`)";				

										query($s);
								
										if ($q === false) $warning[] = "$sc_id: cart_block trip update failed";
									}
								}
							}								
						}
					}
					break;
				case 'unpaid':
					$error[] = 'unpaid order';
					break;
				default:
					$error[] = 'wrong status';
			}
		}
		if ($_GET['par'][0] == 'redirect')
		{
			$warning_str = '';
			if (!empty($warning)) $warning_str = "&warning=".urlencode(json_encode($warning));
			if (isset($_REQUEST['appUrl'])) 
			{
				$taxiAppUrl = trim($_REQUEST['appUrl']);
				if (substr($taxiAppUrl,0,1) === '{')
				{
					@$taxiAppUrl = json_decode($taxiAppUrl,true);
					$taxiAppUrl = isset($taxiAppUrl[$status]) ? $taxiAppUrl[$status] : '';
				}
			}
			if (empty($taxiAppUrl) && !empty(taxi::$data['site_constants']['taxi_app_url']['value'])) $taxiAppUrl = trim(taxi::$data['site_constants']['taxi_app_url']['value']);
			if (empty($taxiAppUrl)) 
			{
				$error[] = 'empty taxi app url';
				show_error($error);
			}
			if (empty($error))
			{
				redirect("$taxiAppUrl?status=".urlencode($status)."&b_id=".urlencode($order).$warning_str); 
			}
			else
			{
				redirect("$taxiAppUrl?error=".urlencode(json_encode($error)).$warning_str); 
			}
		}
		elseif ($_GET['par'][0] == 'endpoint')
		{
			if (empty($error))
			{
				echo 'success'; 
			}
		}
		elseif ($_GET['par'][0] == 'webhook' || $_GET['par'][0] == 'tilda_form_webhook')
		{
			if (empty($error))
			{
				json_exit('200', 'success');
			}
			else
			{
				json_exit('400', 'error', $error);
			}
		}
		elseif ($api_use === true)
		{
			if (isset($order_arr)) continue;
			if (empty($error))
			{
				return true;
			}
			else
			{
				return array('error'=>$error);
			}
		}
		break;
	}
}