<?php
	class API 
	{
		public function showError($code = "", $status = "", $message = "")
		{
			return array(
				'code' 		=> $code,
				'status' 	=> $status,
				'message' 	=> $message,
				'data' 		=> array()
			);
		}


		public function registerUser($role = 0, $phone = "", $email = "", $tg = "", $wa = "", $name = "", $referral_code = "", $reco = "", $ip = "", $data = "", $show_token = false, $roles = array())
		{
			$sql_user = "NULL";
			$referrer = "";
			if (empty($tg) && empty($wa))
			{
				if (empty($_SESSION[UID])) 
				{
					if ($role != 1 && $role != 2 && $role != 5)
					{
						return $this->showError('404', 'error', 'wrong user role');
					}
				}
				else
				{
					if ($this->id_role != 4) return $this->showError('404', 'error', 'user is already authorized');
					if (empty($roles[$role]))	return $this->showError('404', 'error', 'role not found');
					$sql_user = "'" . $_SESSION[UID] . "'";
				}
			}
			else
			{
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
				if (empty($roles[$role]))	return $this->showError('404', 'error', 'role not found');
				$sql_user = "'" . $_SESSION[UID] . "'";
			}

			if (empty($phone) && empty($email) && empty($tg) && empty($wa)) 
			{
				return $this->showError('404', 'error', 'empty user phone and email and tg and wa');
			} 
			else
			{
				$sql_email = "`email` = '" . $email . "'";
				$sql_phone = "`phone` = '" . preg_replace('/[^0-9]+/','',$phone) . "'";
				$sql_tg = "`tg` = '" . $tg . "'";
				$sql_wa = "`wa` = '" . $wa . "'";				
				
				$sql_field = array();
				$sql_where = array();
				if (empty($phone)) 
				{
					$sql_phone = "`phone` = NULL";
				}
				else
				{
					$sql_field[] = "COUNT(IF(" . $sql_phone . ",1,NULL)) as pflag";
					$sql_where[] = $sql_phone;
				}
				if (empty($email)) 
				{
					$sql_email = "`email` = NULL";
				}
				else
				{
					$sql_field[] = "COUNT(IF(" . $sql_email . ",1,NULL)) as eflag";
					$sql_where[] = $sql_email;
				}
				if (empty($tg)) 
				{
					$sql_tg = "`tg` = NULL";
				}
				else
				{
					$sql_field[] = "COUNT(IF(" . $sql_tg . ",1,NULL)) as tflag";
					$sql_where[] = $sql_tg;
				}
				if (empty($wa)) 
				{
					$sql_wa = "`wa` = NULL";
				}
				else
				{
					$sql_field[] = "COUNT(IF(" . $sql_wa . ",1,NULL)) as wflag";
					$sql_where[] = $sql_wa;
				}
				$sql_field = implode(",\n", $sql_field);
				$sql_where = implode(" OR ", $sql_where);
			}

			if (!empty($referral_code)) 
			{
				$s = "SELECT 
						`id_user` 
					FROM `users`
					WHERE `referral_code` = '" . $referral_code . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'ref_code database select failed');
				$d = fetch_assoc($q);			
				if (empty($d['id_user'])) return $this->showError('404', 'error', 'wrong ref_code');
				$referrer = $d['id_user'];
			}
			elseif(!empty($reco))
			{
				$s = "SELECT 
						`id_user` 
					FROM `users`
					WHERE `id_user` = '" . $reco . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'ref_code database select failed');
				$d = fetch_assoc($q);
				if (!empty($d['id_user'])) $referrer = $reco;
			}
			if (empty($referrer))
			{
					$s = "SELECT 
							`id_user`
						FROM `ip_referral`
						WHERE 
							`ip` = INET_ATON('" . $ip . "')
						LIMIT 1
						";
					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'ip database select failed');
					$d = fetch_assoc($q);
					if (!empty($d['id_user'])) $referrer = $d['id_user'];
			}

			$s = "SELECT 
					" . $sql_field . " 
				FROM `users`
				WHERE " . $sql_where . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			$d = fetch_assoc($q);
			$msg = array();
			if (!empty($d['pflag']))
			{
				$msg[] = 'double phone';
			}
			if (!empty($d['eflag']))
			{
				$msg[] = 'double email';
			}
			if (!empty($d['tflag']))
			{
				$msg[] = 'double tg';
			}
			if (!empty($d['wflag']))
			{
				$msg[] = 'double wa';
			}
			if (!empty($msg))return $this->showError('404', 'error', 'busy user data: ' . implode(", ", $msg));

			if (preg_match('/^(\S+)(?:\s+(?:(.*?)\s+)?(\S+))?$/',$name,$name_middle_family))
			{
				$name_sql = "`name` = '" . $name_middle_family[1] . "',\n";
				$name_sql .= empty($name_middle_family[2]) ? "" : "`middle` = '" .  $name_middle_family[2] . "',\n";
				$name_sql .= empty($name_middle_family[3]) ? "" : "`family` = '" . $name_middle_family[3] . "',\n";
			}
			else
			{
				$name_sql = "";
			}

			$sql_data = "";
			if (!empty($data)) 
			{
				$data = json_decode($data,true);
				if (!empty($data))
				{
					if (!is_array($data)) return $this->showError('404', 'error', 'wrong data');
					$allowed_fields = array(
											'u_details'				=>		'json'
					);

					$forbidden_fields = array();
					$affected_fields = array();
					$affected_keys = array();

					foreach ($data as $key => $value)
					{
						if (is_string($value)) $data[$key] = trim($value);

						if (!empty($allowed_fields[$key]))
						{
							$affected_fields[] = $key;
							$affected_keys[$key] = true;				
						}
						else
						{
							$forbidden_fields[] = $key;
						}
					}

					if (!empty($affected_keys['u_details']))
					{
						if (!empty($this->constant['u_details_valid_keys'])) 
						{
							if (!is_array($data['u_details'])) return $this->showError('404', 'error', 'u_details not array');

							if (!empty($data['u_details']))
							{
								if (array_includes_only_add_keys_from_assoc_list($data['u_details'],$this->constant['u_details_valid_keys']) === false) return $this->showError('404', 'error', 'wrong u_details keys');
							}
						}

						$data['u_details'] = real_escape_string(json_encode($data['u_details']));
					}

					if (!empty($affected_keys))
					{
						$sql_data = array();
						foreach ($affected_fields as $key)
						{
							$sql_data[] = "`" . $allowed_fields[$key] . "` = " 
								 . ($data[$key] === NULL ? "NULL" : "'" . $data[$key] . "'");
						}
						$sql_data = implode(",\n", $sql_data) . ',';
					}

					if (isset($data['password'])) 
					{
						$pwd = trim($data['password']);
						if ($pwd === '') return $this->showError('404', 'error', 'empty password');
						$user_pwd = true;
					}
				}	
			}

			if (empty($user_pwd)) $pwd = generate_password(10);

			$s = "INSERT INTO `users`
				SET 
					`id_role` = '" . $role . "',
					" . $name_sql . "
					" . $sql_phone . ",
					" . $sql_email . ",
					" . $sql_tg . ",
					$sql_wa,
					`pwd` = '" . md5(md5($pwd)) . "',
					" . (!empty($referrer) ? "`referrer` = '" . $referrer . "'," : "") . "		
					" . $sql_data . "
					`last_edit_datetime` = now(),
					`last_edit_user` = " . $sql_user . ",
					`create_datetime` = now(),
					`create_user` = " . $sql_user . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database insert failed');
			
			$out = array();
			$out['u_id'] = insert_id();

			$s = "UPDATE `users`
				SET 
					`referral_code` = 'uid" . $out['u_id'] . "',
					`last_edit_datetime` = now(),
					`last_edit_user` = " .  $sql_user . "
				WHERE `id_user` = '" . $out['u_id'] . "'
				";

			$q = query($s);
			if ($q === false) $out['warning'][] = 'ref_code update failed';

			if (empty($user_pwd))
			{
				if (empty($email))
				{
					$out['string'] = $pwd;
				}
				else
				{
					$dataForEmail = array(
						'{$u_id}' 			=> $out['u_id'],
						'{$password}' 		=> $pwd,			
						'{$locationPath}' 	=> url('',CONFIG_URL),
						'{$u_name}' 		=> isset($name_middle_family[1]) ? $name_middle_family[1] : '',
						'{$u_family}' 		=> isset($name_middle_family[3]) ? $name_middle_family[3] : '',
						'{$u_middle}' 		=> isset($name_middle_family[2]) ? $name_middle_family[2] : '',
						'{$u_email}' 		=> $email,
						'{$u_phone}' 		=> $phone,
						'{$u_tg}'			=> $tg,
						'{$u_wa}'			=> $wa
					);
					
					$subject = lang('email_register_subject','Password for user {$u_id} from {$locationPath}',2);
					$body = lang('email_register_body','Password: {$password}',2);
					list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);
					$out['email status'] = send_mail($email,$subject,$body);
				}
			}

			$s = "DELETE
				FROM `ip_referral`
				WHERE 
					`ip` = INET_ATON('" . $ip . "')
				";
			query($s);
			$q = query($s);
			if ($q === false) $out['warning'][] = 'ip database delete failed';

			if ($show_token === true)
			{
				$token[0] = get_token($out['u_id']);
				if (gettype($token[0]) !== 'string')
				{
					return $this->showError('404', 'error', 'token error: ' . $token[0]);
				}
				else
				{
					$token[1] = get_u_hash($token[0],$out['u_id']);
					$out['token'] = $token[0];
					$out['u_hash'] = $token[1];
				};
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		public function authUser($login = '', $password = '', $type = 'e-mail')
		{
			if (!empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'user is already authorized');
			}

			if ($type == 'e-mail' || $type == 'phone' || $type == 'tg' || $type == 'wa')
			{
				if (empty($login) || empty($password))
				{
					return $this->showError('404', 'error', 'empty login or password');
				}

				switch ($type){
					case 'e-mail':
						$sql = "`email` = '$login'";
						break;
					case 'phone':
						$sql = "`phone` = '" . preg_replace('/[^0-9]+/','',$login) . "'";
						break;
					case 'tg':
						$sql = "`tg` = '$login'";
						break;
					case 'wa':
						$sql = "`wa` = '$login'";
						break;
				}
				$s = "SELECT 
						`id_role`,
						`id_user`,
						`name`,
						`family`,
						`middle`,
						`phone`,
						`phone_is_verified`,
						`email`,
						`photo_link`,
						`pwd`,
						`id_lang`,
						`currency`,
						`id_city`,
						`tips`,
						`language_skills`,
						`description`,
						`id_navigation`,
						`id_verification_status`,
						`active`,
						`deleted`,
						`birthday_date`
					FROM `users`
					WHERE 
						$sql
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');
				$d = fetch_assoc($q);

				if (empty($d['id_user']))
				{
					return $this->showError('404', 'error', 'wrong login');
				}
				elseif (md5(md5($password)) != $d['pwd'])
				{
					return $this->showError('404', 'error', 'wrong password');
				}
				elseif (!empty($d['deleted']))
				{
					return $this->showError('404', 'error', 'deleted user');
				}
				$user_ban_status = get_user_ban_status($d['id_user']);
				if (!empty($user_ban_status['auth']))
				{
					return $this->showError('404', 'error', 'banned user');
				}
			}
			elseif ($type == 'whatsapp')
			{
				if (empty($login)) 
				{
					return $this->showError('404', 'error', 'empty phone');
				}
				$login = preg_replace('/[^0-9]+/','',$login);
				$s = "SELECT 
						`id_user`,
						`deleted`
					FROM `users`
					WHERE 
						`phone` = '" . $login . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select of database failed');
				$d = fetch_assoc($q);

				if (empty($d['id_user']))
				{
					return $this->showError('404', 'error', 'wrong phone');
				}
				elseif (!empty($d['deleted']))
				{
					return $this->showError('404', 'error', 'phone of deleted user');
				}
				$user_ban_status = get_user_ban_status($d['id_user']);
				if (!empty($user_ban_status['auth']))
				{
					return $this->showError('404', 'error', 'phone of banned user');
				}

				if (empty($password))
				{
					$code = generate_code(4);	
					$s = "INSERT INTO `users_code`
						SET 
							`id_user` = '" . $d['id_user'] . "',
							`code` = " . $code . ",
							`expire_datetime` = now() + INTERVAL 600 SECOND
						ON DUPLICATE KEY UPDATE 
							`code` = " . $code . ", `expire_datetime` = now() + INTERVAL " . $this->constant['auth_code_interval'] . " SECOND
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'database insert failed');
					if (!send_msg_to_whatsapp($login,$code)) return $this->showError('404', 'error', 'sending error');
					return array(
						'code' 		=>	'200',
						'status' 	=>	'success',
						'data'		=>	'code sent'
					);
				}
				else
				{
					$password = preg_replace('/[^0-9]+/','',$password);
					$s = "SELECT 
							`users_code`.`id_user`,
							IF(`users_code`.`expire_datetime` > now(),0,1) as active,
							`users`.`id_role`,
							`users`.`id_user`,
							`users`.`name`,
							`users`.`family`,
							`users`.`middle`,
							`users`.`phone`,
							`users`.`phone_is_verified`,
							`users`.`email`,
							`users`.`photo_link`,
							`users`.`pwd`,
							`users`.`id_lang`,
							`users`.`currency`,
							`users`.`id_city`,
							`users`.`tips`,
							`users`.`language_skills`,
							`users`.`description`,
							`users`.`id_navigation`,
							`users`.`id_verification_status`,
							`users`.`active`,
							`users`.`birthday_date`				
						FROM `users_code`					
						LEFT JOIN `users` USING (`id_user`)
						WHERE 
							`users_code`.`id_user` = '" . $d['id_user'] . "' AND 
							`users_code`.`code` = '" . $password . "'
						LIMIT 1
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'select failed');
					$d = fetch_assoc($q);
					if (empty($d['id_user']))
					{
						return $this->showError('404', 'error', 'wrong code');
					}
					if (empty($d['active']))
					{
						return $this->showError('404', 'error', 'expired code');
					}
				}
			}
			else
			{
				return $this->showError('404', 'error', 'wrong auth type');
			}

			$_SESSION['auth_time'] = time();
			$_SESSION[UID] = $d['id_user'];
			$_SESSION['name'] = $d['name'];
			$_SESSION['family'] = $d['family'];
			$_SESSION['middle'] = $d['middle'];
			$_SESSION['email'] = $d['email'];
			$_SESSION['phone'] = $d['phone'];
			$_SESSION['id_role'] = $d['id_role'];
			$_SESSION['id_verification_status'] = $d['id_verification_status'];
			$_SESSION['user_ban_status'] = $user_ban_status;
			$_SESSION['active'] = (int)$d['active'];
			$_SESSION['lang'] = $d['id_lang'] ? : (isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG);
			$_SESSION['photo_link'] = $d['photo_link'] ? url($d['photo_link'],FILE_PATH) : '';
			$_SESSION['birthday_date'] = $d['birthday_date'];
			$_SESSION['id_lang'] = $d['id_lang'];
			$_SESSION['currency'] = $d['currency'];
			$_SESSION['id_navigation'] = $d['id_navigation'];
			$vfoc = md5(session_id() . strtolower(dechex(crc32($_SESSION[UID]))));
			setcookie("vfoc", $vfoc, 0, ROOT_URL);
			$_SESSION['auth_hash'] = openssl____encrypt(session_id() . "|" . $vfoc);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_phone_checked' => (int)$d['phone_is_verified'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_city' => $d['id_city'],
									'u_tips' => $d['tips'],
									'u_lang_skills' => $d['language_skills'],
									'u_description' => $d['description'],
									'u_gps_software' => $_SESSION['id_navigation']
								),
				'auth_hash' => $_SESSION['auth_hash']
			);
		}

		public function logout()
		{
			unset($_SESSION[UID]);
			session_unset();
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'		
			);
		}
		
		public function selectUser($id_user = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			$sql_add = "
					`phone` as u_phone,
					`phone_is_verified` as u_phone_checked,
					`email` as u_email,
					`email_is_verified` as u_email_checked,
					`birthday_date` as u_birthday,
					`referral_code` as ref_code,
					`referrer` as referrer_u_id,
					`tg` as u_tg,
					`tg_is_verified` as u_tg_checked,
					`id_user_upper` as u_upper,
					`wa` as u_wa,
					`wa_is_verified` as u_wa_checked,";
			$sql_limit = "";
			if (empty($id_user))
			{	
				if ($this->id_role != 4)
				{
					$sql_where = "AND `id_user` = '" . $_SESSION[UID] . "'";
					$sql_limit = "LIMIT 1";
				}
				else
				{
					$sql_where = "";
					$sql_limit = "LIMIT " . $this->limit_offset . ", " . $this->limit_row_count;
				}
			}
			else
			{	
				if ($id_user == 'authorized' || $id_user == $_SESSION[UID]) 
				{
					$sql_where = "AND `id_user` = '" . $_SESSION[UID] . "'";
					$sql_limit = "LIMIT 1";
				}
				else
				{
					if ($this->id_role != 4) $sql_add = "";
					$sql_where = "AND `id_user` in (" . $id_user . ")";
					$sql_limit = "LIMIT " . $this->constant['limit_row_count_max'];
				}
			}

			$s = "SELECT 
					`id_user` as u_id,
					`id_role` as u_role,
					`name` as u_name,
					`family` as u_family,
					`middle` as u_middle,
					" . $sql_add . "
					`photo_link` as u_photo,
					`id_lang` as u_lang,
					`currency` as u_currency,
					`id_city` as u_city,
					`tips` as u_tips,
					`language_skills` as u_lang_skills,
					`description` as u_description,
					`id_navigation` as u_gps_software,
					`id_verification_status` as u_check_state,
					`active` as u_active,			
					`out_order` as out_drive,
					`out_order_to` as out_address,
					`out_order_to_lat` as out_latitude,
					`out_order_to_lng` as out_longitude,
					`out_order_complete_datetime` as out_est_datetime,
					`out_order_from` as out_s_address,
					`out_order_from_lat` as out_s_latitude,
					`out_order_from_lng` as out_s_longitude,
					`out_order_passengers_count` as out_passengers,
					`out_order_luggage_count` as out_luggage,
					`json` as u_details,
					(SELECT
						GROUP_CONCAT(`users_order_comment`.`id_order_comment` SEPARATOR ',')
					 FROM `users_order_comment`
					 WHERE `users_order_comment`.`id_user` = `users`.`id_user`
					) as b_comments,
					(SELECT
						GROUP_CONCAT(`users_service`.`id_service` SEPARATOR ',')
					 FROM `users_service`
					 WHERE `users_service`.`id_user` = `users`.`id_user`
					) as b_services,
					(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',`users_order_location`.`id_order_location`,`users_order_location`.`basic`) 
						SEPARATOR ';')
					 FROM `users_order_location`
					 WHERE `users_order_location`.`id_user` = `users`.`id_user`
					) as b_location_classes,
					`id_schedule` as sc_id
				FROM `users`
				WHERE
					`deleted` = '0'
				" . $sql_where . "
				" . $sql_limit . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('user' => array());
			while ($d = fetch_assoc($q))
			{
				$d['u_ban'] = get_user_ban_status($d['u_id']);
				$d['u_photo'] = $d['u_photo'] ? url($d['u_photo'],FILE_PATH) : '';
				add_time_zone($d['out_est_datetime']);
				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);		
				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);			
				if (!empty($d['b_location_classes']))
				{
					$d['b_location_classes'] = explode(';',$d['b_location_classes']);
					foreach ($d['b_location_classes'] as $key=>$value)
					{
						$d['b_location_classes'][$key] = array();
						list(
							$d['b_location_classes'][$key]['b_location_class'],
							$d['b_location_classes'][$key]['basic']
							)= explode('|',$value);
						$d['b_location_classes'][$key]['basic'] = (int)$d['b_location_classes'][$key]['basic'];
					}
				}
				if (isset($d['u_phone_checked'])) $d['u_phone_checked'] = (int)$d['u_phone_checked'];
				$d['u_active'] = (int)$d['u_active'];
				$d['out_drive'] = (int)$d['out_drive'];	
				$d['u_details'] = json_decode($d['u_details'],true);
				$out['user'][$d['u_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['user'] =  array_values($out['user']);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function editUser($data = "", $id_user = "", $roles = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}	
			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(
									'u_role'				=>		'id_role',
									'u_name'				=>		'name',
									'u_family'				=>		'family',
									'u_middle'				=>		'middle',
									'u_phone'				=>		'phone',
									'u_phone_checked'		=>		'phone_is_verified',
									'u_email'				=>		'email',
									'u_email_checked'		=>		'email_is_verified',
									'u_photo'				=>		'photo_link',
									'u_lang'				=>		'id_lang',
									'u_currency'			=>		'currency',
									'u_city'				=>		'id_city',
									'u_tips'				=>		'tips',
									'u_lang_skills'			=>		'language_skills',
									'u_description'			=>		'description',
									'u_gps_software'		=>		'id_navigation',
									'u_check_state'			=>		'id_verification_status',
									'u_active'				=>		'active',
									'u_is_deleted'			=>		'deleted',
									'u_birthday'			=>		'birthday_date',
									'out_drive'				=>		'out_order',
									'out_address'			=>		'out_order_to',
									'out_latitude'			=>		'out_order_to_lat',
									'out_longitude'			=>		'out_order_to_lng',
									'out_est_datetime'		=>		'out_order_complete_datetime',
									'out_s_address'			=>		'out_order_from',
									'out_s_latitude'		=>		'out_order_from_lat',
									'out_s_longitude'		=>		'out_order_from_lng',
									'out_passengers'		=>		'out_order_passengers_count',
									'out_luggage'			=>		'out_order_luggage_count',
									'ref_code'				=>		'referral_code',
									'referrer_u_id'			=>		'referrer',
									'u_tg'					=>		'tg',
									'u_tg_checked'			=>		'tg_is_verified',
									'u_upper'				=>		'id_user_upper'	,
									'b_comments'			=> 		array(
																		'table'		=>	'users_order_comment',
																		'field'		=>	'id_order_comment'
																	),
									'b_services'			=> 		array(
																		'table'		=>	'users_service',
																		'field'		=>	'id_service'
																	),
									'b_location_classes'	=> 		array(
																		'table'		=>	'users_order_location',
																		'field'		=>	'id_order_location',
																		'field_add'	=>	array(
																						'name'		=>	'basic',
																						'default'	=>	'1'
																						)
																	),
									'u_details'				=>		'json',
									'sc_id'					=>		'id_schedule',
									'u_wa'					=>		'wa',
									'u_wa_checked'			=>		'wa_is_verified'
			);
			if (empty($id_user) || $_SESSION[UID] == $id_user)
			{	
				$id_user = $_SESSION[UID];
				$id_role = $_SESSION['id_role'];
				$phone = $_SESSION['phone'];
				$email = $_SESSION['email'];
				$tg = $_SESSION['tg'];
				$wa = $_SESSION['wa'];
				switch ($this->id_role) {
					case '1':
						$allowed_fields = array(
												'u_role'				=>		'id_role',
												'u_name'				=>		'name',
												'u_family'				=>		'family',
												'u_middle'				=>		'middle',
												'u_phone'				=>		'phone',
												'u_email'				=>		'email',
												'u_photo'				=>		'photo_link',
												'u_lang'				=>		'id_lang',
												'u_currency'			=>		'currency',
												'ref_code'				=>		'referral_code',
												'u_details'				=>		'json'
						);
						break;
					case '2':
						if ($_SESSION['id_verification_status'] == 3)
						{
							return $this->showError('404', 'error', 'driver with rejected verification');
						}
						if ($_SESSION['id_verification_status'] == 4)
						{
							return $this->showError('404', 'error', 'blocked driver');
						}
						if ($_SESSION['id_verification_status'] == 2)
						{
							$allowed_fields = array(
										'u_role'				=>		'id_role',
										'u_lang'				=>		'id_lang',
										'u_currency'			=>		'currency',
										'u_gps_software'		=>		'id_navigation',
										'u_active'				=>		'active',
										'out_drive'				=>		'out_order',
										'out_address'			=>		'out_order_to',
										'out_latitude'			=>		'out_order_to_lat',
										'out_longitude'			=>		'out_order_to_lng',
										'out_est_datetime'		=>		'out_order_complete_datetime',
										'out_s_address'			=>		'out_order_from',
										'out_s_latitude'		=>		'out_order_from_lat',
										'out_s_longitude'		=>		'out_order_from_lng',
										'out_passengers'		=>		'out_order_passengers_count',
										'out_luggage'			=>		'out_order_luggage_count',
										'ref_code'				=>		'referral_code',
										'b_comments'			=> 		array(
																			'table'		=>	'users_order_comment',
																			'field'		=>	'id_order_comment'
																		),
										'b_services'			=> 		array(
																			'table'		=>	'users_service',
																			'field'		=>	'id_service'
																		),
										'b_location_classes'	=> 		array(
																			'table'		=>	'users_order_location',
																			'field'		=>	'id_order_location',
																			'field_add'	=>	array(
																							'name'		=>	'basic',
																							'default'	=>	'1'
																							)
																		),
										'u_details'				=>		'json'
							);
						}
						elseif (empty($_SESSION['id_verification_status']) 
								|| $_SESSION['id_verification_status'] == 1)
						{
							$allowed_fields = array(
													'u_role'				=>		'id_role',
													'u_name'				=>		'name',
													'u_family'				=>		'family',
													'u_middle'				=>		'middle',
													'u_phone'				=>		'phone',
													'u_email'				=>		'email',
													'u_photo'				=>		'photo_link',
													'u_city'				=>		'id_city',
													'u_lang_skills'			=>		'language_skills',
													'u_description'			=>		'description',
													'u_birthday'			=>		'birthday_datetime',
													'ref_code'				=>		'referral_code',
													'u_details'				=>		'json'
							);
						}			
						break;
					case '4':
						break;
					case '5':
						$allowed_fields = array(
												'u_role'				=>		'id_role',
												'u_name'				=>		'name',
												'u_family'				=>		'family',
												'u_middle'				=>		'middle',
												'u_phone'				=>		'phone',
												'u_email'				=>		'email',
												'u_photo'				=>		'photo_link',
												'u_lang'				=>		'id_lang',
												'u_currency'			=>		'currency',
												'ref_code'				=>		'referral_code',
												'u_details'				=>		'json'
						);
						break;
					case '6':
						$allowed_fields = array(
						);
						break;
					default:
						return $this->showError('404', 'error', 'wrong user role');
				}
			}
			else
			{
				if ($this->id_role != 4) 
				{
					return $this->showError('404', 'error', 'not enough rights');
				}
				
				$s = "SELECT 
						`id_role`,
						`id_user`,
						`phone`,
						`email`,
						`id_verification_status`,
						`tg`,
						`wa`
					FROM `users`
					WHERE 
						`id_user` = '" . $id_user . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');
				$d = fetch_assoc($q);
				
				if (empty($d['id_user'])) return $this->showError('404', 'error', 'user not found');

				$id_role = $d['id_role'];			
				$phone = $d['phone'];
				$email = $d['email'];
				$tg = $d['tg'];
				$wa = $d['wa'];
			}
			$forbidden_fields = array();
			$affected_fields = array();
			$affected_keys = array();
			$affected_array_fields = array();

			foreach ($data as $key => &$value)
			{
				if (is_string($value)) $data[$key] = trim($value);

				if (!empty($allowed_fields[$key]) && !is_array($allowed_fields[$key]))
				{
					$affected_fields[] = $key;
					$affected_keys[$key] = true;				
				}
				else
				{
					$key_base = preg_replace('/(=|\+|-)$/','',$key);

					if (!empty($allowed_fields[$key_base]))
					{
						$key_suffixes = array();

						if (array_key_exists($key = "$key_base".($key_suffix = '='),$data))
						{
							$affected_keys[$key] = true;
							$key_suffixes[] = $key_suffix;
							unset($data["$key_base+"]);
							unset($data["$key_base-"]);

						}
						else
						{

							if (array_key_exists($key = "$key_base".($key_suffix = '+'),$data))
							{
								$affected_keys[$key] = true;
								$key_suffixes[] = $key_suffix;
							}

							if (array_key_exists($key = "$key_base".($key_suffix = '-'),$data))
							{
								$affected_keys[$key] = true;
								$key_suffixes[] = $key_suffix;
							}
						}
						$affected_array_fields[$key_base] = $key_suffixes;
					}
					else
					{

						$forbidden_fields[] = $key;

					}
				}
			}
			unset($value);

			if (!empty($affected_keys['u_details']))
			{
				$s = "SELECT 
						`json`
					FROM `users`
					WHERE 
						`id_user` = '" . $id_user . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'u_details database select failed');
				$d = fetch_assoc($q);

				$details = json_decode($d['json'],true);
				if (!is_array($details)) $details = array();
				if (!is_array($data['u_details'])) return $this->showError('404', 'error', 'u_details not array');
				$details_is_updated = false;
				foreach($data['u_details'] as $details_element)
				{
					if (!is_array($details_element)) return $this->showError('404', 'error', 'u_details element not array');
					if (empty($details_element[0]))	return $this->showError('404', 'error', 'u_details element without operator');
					$details_element[0] = trim($details_element[0]);
					switch ($details_element[0]){
						case '=':
							if (!isset($details_element[1])) return $this->showError('404', 'error', 'empty u_details element keys for assignment');
							if (!is_array($details_element[1])) return $this->showError('404', 'error', 'u_details element keys for assignment not array');
							if (!isset($details_element[2])) return $this->showError('404', 'error', 'empty u_details element value for assignment');
							$details_prev = $details;
							$arr_d = &$details;
							$check_create_list = false;
							if (!empty($this->constant['u_details_valid_keys'])) 
							{
								$arr_v = $this->constant['u_details_valid_keys'];
								$check_create_list = true;
							}
							$details_element_is_updated = false;
							foreach($details_element[1] as $details_key)
							{
								@$details_key = (string)$details_key;
								if (!is_array($arr_d)) 
								{
									return $this->showError('404', 'error', 'u_details value for element key' . $details_key . ' for assignment not array');
								}
								if ($check_create_list === true)
								{
									if (!array_key_exists($details_key,$arr_v)) return $this->showError('404', 'error', 'wrong u_details element keys for addition');
									$arr_v = $arr_v[$details_key];
									if ($arr_v === true) 
									{
										$check_create_list = false;
									}
								}
								if (!array_key_exists($details_key,$arr_d)) 
								{
									$arr_d[$details_key] = array();
									$details_element_is_updated = true;
								}
								$arr_d = &$arr_d[$details_key];
							}
							if ($arr_d !== $details_element[2])
							{
								$arr_d = $details_element[2];
								$add = $details_element[2];								
								if ($check_create_list === true)
								{
									if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong u_details element value keys for assignment');
								}
								$check_create_list = false;
								$details_element_is_updated = true;
							}
							unset($arr_d);
							if ($details_element_is_updated === true && $check_create_list === false) 
							{
								$details_is_updated = true;
							}
							else
							{
								$details = $details_prev;
							}
							break;
						case '+':
							if (!isset($details_element[1])) return $this->showError('404', 'error', 'empty u_details element keys for addition');
							if (!is_array($details_element[1])) return $this->showError('404', 'error', 'u_details element keys for addition not array');
							if (!isset($details_element[2])) return $this->showError('404', 'error', 'empty u_details element value for addition');
							$details_prev = $details;
							$arr_d = &$details;
							$check_create_list = false;
							if (!empty($this->constant['u_details_valid_keys'])) 
							{
								$arr_v = $this->constant['u_details_valid_keys'];
								$check_create_list = true;
							}
							$details_element_is_updated = false;
							foreach($details_element[1] as $details_key)
							{
								@$details_key = (string)$details_key;
								if (!is_array($arr_d)) 
								{
									return $this->showError('404', 'error', 'u_details value for element key' . $details_key . ' for addition not array');
								}
								if ($check_create_list === true)
								{
									if (!array_key_exists($details_key,$arr_v)) return $this->showError('404', 'error', 'wrong u_details element keys for addition');
									$arr_v = $arr_v[$details_key];
									if ($arr_v === true) 
									{
										$check_create_list = false;
									}
								}
								if (!array_key_exists($details_key,$arr_d)) 
								{
									$arr_d[$details_key] = array();
									$details_element_is_updated = true;
								}
								$arr_d = &$arr_d[$details_key];
							}
							if (is_array($arr_d))
							{
								$arr_d[] = $details_element[2];
								end($arr_d);
								$add = array(key($arr_d)=>$details_element[2]);								
								if ($check_create_list === true)
								{
									if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong u_details element value keys for addition');
								}
								$check_create_list = false;
								$details_element_is_updated = true;
							}
							else
							{
								if ($check_create_list === false)
								{
									if (is_array($details_element[2]))
									{
										$arr_d .= json_encode($details_element[2]);
									}
									else
									{
										$arr_d .= $details_element[2];
									}
									$details_element_is_updated = true;
								}
								else
								{
									return $this->showError('404', 'error', 'wrong u_details structure for addition');
								}
							}
							unset($arr_d);
							if ($details_element_is_updated === true && $check_create_list === false) 
							{
								$details_is_updated = true;
							}
							else
							{
								$details = $details_prev;
							}
							break;
						case '-':
							if (!isset($details_element[1])) return $this->showError('404', 'error', 'empty u_details element keys for removal');
							if (!is_array($details_element[1])) return $this->showError('404', 'error', 'u_details element keys for removal not array');
							if (empty($details_element[1]) || !is_array($details) || empty($details)) break;
							$arr_d = &$details;
							$count_key = count($details_element[1]);
							$i = 0;
							$details_element_is_updated = true;
							foreach($details_element[1] as $details_key)
							{
								@$details_key = (string)$details_key;
								$i++;
								if (!is_array($arr_d) || !array_key_exists($details_key,$arr_d)) 
								{
									$details_element_is_updated = false;
									break;
								}
								if ($i < $count_key) {$arr_d = &$arr_d[$details_key];}
							}
							if ($details_element_is_updated === true) 
							{
								unset($arr_d[$details_key]);
								$details_is_updated = true;
							}
							unset($arr_d);
							break;
						default:
							return $this->showError('404', 'error', 'wrong u_details element operator');
					}
				}
				if ($details_is_updated === true)
				{
					$data['u_details'] = real_escape_string(json_encode($details));
				}
				else
				{
					unset($affected_keys['u_details']);
				}
			}

			$logins = array();
			$login_flags = array();
			if (!empty($affected_keys['u_phone'])) 
			{
				if ($data['u_phone'] !== NULL) @$data['u_phone'] = preg_replace('/[^0-9]+/','',$data['u_phone']);
				$logins[] = 'phone';
				$login_flags[] = 'pflag';
			}
			if (!empty($affected_keys['u_email'])) 
			{
				$logins[] = 'email';
				$login_flags[] = 'eflag';
			}
			if (!empty($affected_keys['u_tg'])) 
			{
				$logins[] = 'tg';
				$login_flags[] = 'tflag';
			}
			if (!empty($affected_keys['u_wa'])) 
			{
				$logins[] = 'wa';
				$login_flags[] = 'wflag';
			}
			$sql_field = array();
			$sql_where = array();
			foreach($logins as $i=>$login)
			{
				$u_login = "u_$login";
				if ($data[$u_login] !== $$login)
				{
					if ($data[$u_login] === "") return $this->showError('404', 'error', "empty user $login");
					if ($this->id_role != 4)
					{
						$key = "u_{$login}_checked";
						$affected_fields[] = $key;
						$affected_keys[$key] = true;
						$data[$key] = 0;
						$allowed_fields[$key] = "{$login}_is_verified";
					}
					if ($data[$u_login] !== NULL) 
					{
						$sql_where_str = "`$login` = '{$data[$u_login]}'";
						$sql_field[] = "COUNT(IF($sql_where_str,1,NULL)) as {$login_flags[$i]}";
						$sql_where[] = $sql_where_str;
					}
					$$login = $data[$u_login];
				}
				else
				{
					unset($affected_keys[$u_login]);
				}
			}

			if (empty($phone) && empty($email) && empty($tg) && empty($wa))
			{
				return $this->showError('404', 'error', 'empty user phone and email and tg and wa');
			}
			if (!empty($sql_where))
			{
				$sql_field = implode(",\n", $sql_field);
				$sql_where = implode(" OR ", $sql_where);
				$s = "SELECT 
						$sql_field 
					FROM `users`
					WHERE 
						$sql_where";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'mysql select failed');
				$d = fetch_assoc($q);
				$msg = array();
				foreach($login_flags as $i=>$login_flag)
				{
					if (!empty($d[$login_flag]))
					{
						$msg[] = "double $logins[$i]";
					}
				}
				if (!empty($msg))return $this->showError('404', 'error', 'busy user data: ' . implode(", ", $msg));
			}
			
			if (!empty($affected_keys['ref_code']))
			{
				if (strtolower(substr($data['ref_code'],0,3)) == "uid" && $data['ref_code'] != "uid$id_user")
				{
					return $this->showError('404', 'error', 'uid ref_code fot other user');
				}
				if ($data['ref_code'] === "")
				{
					return $this->showError('404', 'error', 'empty ref_code string');
				}
				elseif ($data['ref_code'] !== NULL)
				{
					$s = "SELECT 
							`id_user` 
						FROM `users`
						WHERE `referral_code` = '" . $data['ref_code'] . "'
						LIMIT 1";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'mysql ref_code select failed');
					$d = fetch_assoc($q);			
					if (!empty($d['id_user'])) 
					{
						if ($d['id_user'] == $id_user) 
						{
							unset($affected_keys['ref_code']);
						}
						else
						{
							return $this->showError('404', 'error', 'busy ref_code');
						}
					}
				}
			}

			if (!empty($affected_keys['u_role']))
			{
				if ($data['u_role'] !== $id_role)
				{
					if (empty($data['u_role'])) return $this->showError('404', 'error', 'empty user role');
					if ($_SESSION['id_role'] == 4)
					{
						if ($_SESSION[UID] == $id_user)
						{
							return $this->showError('404', 'error', 'admin cannot change own role');
						}
						else
						{
							if (empty($roles[$data['u_role']]))
							{
								return $this->showError('404', 'error', 'role not found');
							}
						}
					}
					else
					{
						if ($data['u_role'] == 4 || $data['u_role'] == 6 || empty($roles[$data['u_role']]))
						{
							return $this->showError('404', 'error', 'wrong user role');
						}
					}
				}
				else
				{
					unset($affected_keys['u_role']);
				}
			}

			if (empty($affected_keys)) return $this->showError('404', 'error', 'allowed data not found');

			if (!empty($affected_keys['u_photo']))
			{
				$data['u_photo'] = base64ImageToFile($data['u_photo']);
				if ($data['u_photo']['error'] === false)
				{
					$data['u_photo'] = $data['u_photo']['image'];
				}
				else
				{
					return $this->showError('404', 'error', $data['u_photo']['error']);
				}
			}

			if (!empty($affected_keys['out_est_datetime']))
			{
				preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$data['out_est_datetime'],$parsed_datetime);
				if (empty($parsed_datetime))
				{
					return $this->showError('404', 'error', 'wrong out_est_datetime');
				}
				else
				{
					preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
					$data['out_est_datetime'] = gmdate("Y-m-d H:i:s",strtotime($parsed_datetime[1] . " " . $parsed_datetime[2] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
				}
			}

			$s = array();
			foreach ($affected_fields as $key)
			{
				if (empty($affected_keys[$key])) continue;
				$s[] = "`" . $allowed_fields[$key] . "` = " 
					 . ($data[$key] === NULL ? "NULL" : "'" . $data[$key] . "'");
			}

			$q = query("BEGIN");

			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			if (!empty($s)) 
			{
				$s = "UPDATE `users`
					SET 
						" . implode(",\n", $s) ."
					WHERE `id_user` = '" . $id_user . "'
					";

				query($s);

				
				global $link;
				if (mysqli_affected_rows($link) === -1) 
				{
					return $this->showError('404', 'error', 'database update failed');
				}
				elseif (mysqli_affected_rows($link) === 0) 
				{
					$affected_fields = array();
				}
			}

			ksort($affected_array_fields);
			foreach ($affected_array_fields as $key_base=>$key_suffixes)
			{
				$table = $allowed_fields[$key_base]['table'];
				$field = $allowed_fields[$key_base]['field'];
				foreach ($key_suffixes as $key_suffix)
				{
					$key = "$key_base$key_suffix";
					$field_add = empty($allowed_fields[$key_base]['field_add']['name']) ? NULL : $allowed_fields[$key_base]['field_add']['name'];	
					$sql_select_where = array();
					$sql_values = array();
					$check_count = 0;
					if (empty($data[$key]))
					{
						if ($key_suffix !== '=') return $this->showError('404', 'empty ' . $key);

						$s = "SELECT
								'1' as check_count
							FROM `" .  $table  . "`			
							WHERE	
								 `id_user` = '" . $id_user . "'
							LIMIT 1
							";
						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', $key . ': database select failed');

						$d = fetch_assoc($q);
						if ($d['check_count'] == $check_count) continue;//return $this->showError('404', 'error', $key . ' already cleared');
						
						$s = "DELETE
							FROM `" .  $table  . "`
							WHERE 
								`id_user` = '" . $id_user . "'
							";
						$q = query($s);
						
						if ($q === false) return $this->showError('404', 'error', $key . ': database delete failed');
					}
					else
					{
						if (!is_array($data[$key])) 
						{
							return $this->showError('404', 'error', $key . ' not array');
						}
						foreach ($data[$key] as $val)
						{
							if (is_array($val))
							{
								if (empty($val[0])) 
								{
									return $this->showError('404', 'error', 'wrong data in ' . $key );
								}
								$field_val = $val[0];
								if (!empty($field_add))
								{
									if (array_key_exists(1,$val))
									{
										$field_add_val = $val[1]; 
									}
									else
									{
										if ($key_suffix !== '-')
										{
											$field_add_val = $allowed_fields[$key_base]['field_add']['default']; 
										}
										else
										{
											$field_add = NULL; 
										}
									}
								}
							}
							else
							{
								$field_val = $val;
								if (empty($field_val)) return $this->showError('404', 'error', 'empty data in ' . $key );
								if (!empty($field_add) && $key_suffix !== '-')
								{
									$field_add_val = $allowed_fields[$key_base]['field_add']['default']; 
								}
								else
								{
									$field_add = NULL;
								}
							}
							$sql_select_where[] = "`" . $field . "` = '" . $field_val .  "'" . (!empty($field_add) ? " AND `" . $field_add . "` " . ($field_add_val === NULL ? "IS NULL " : "= '" . $field_add_val . "'") : "");
							$sql_values[] = "('" . $id_user . "','" . $field_val . "'" . (!empty($field_add) ?  "," . ($field_add_val === NULL ? "NULL" : "'" . $field_add_val . "'") : "") . ")"; 
						}
						$check_count = count($sql_select_where);
						$sql_select_where = implode(' OR ',$sql_select_where);
						$sql_values = "(`id_user`, `" .$field . "`" . (!empty($field_add) ? ", `" . $field_add . "`" : "") . ") VALUES " . implode(',',$sql_values);

						if ($key_suffix === '=')
						{
							$s = "SELECT
									GROUP_CONCAT(IF(" . $sql_select_where . ",NULL,`" . $field . "`) SEPARATOR ',') as deleted_users,
									COUNT(IF(" . $sql_select_where . ",`id_user`,NULL)) as check_count
								FROM `" .  $table  . "`			
								WHERE	
									 `id_user` = '" . $id_user . "'
								";
							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', $key . ': database select failed');

							$d = fetch_assoc($q);
							if ($d['check_count'] == $check_count && empty($d['deleted_users'])) continue;//return $this->showError('404', 'error', $key . ' already has required');

							if (!empty($d['deleted_users']))
							{
								$s = "DELETE
									FROM `" .  $table  . "`
									WHERE 
										`id_user` = '" . $id_user . "' AND `" .  $field  . "` in (" . $d['deleted_users'] . ")
									";
								$q = query($s);
								
								if ($q === false) return $this->showError('404', 'error', $key . ': database delete failed');
							}
							if ($d['check_count'] != $check_count)
							{
								$s = "REPLACE  INTO `" .  $table  . "` " . $sql_values;

								$q = query($s);
								if ($q === false) return $this->showError('404', 'error', $key . ': database replace  failed');
							}
						}
						elseif ($key_suffix === '+')
						{
							$s = "SELECT
									COUNT(IF(" . $sql_select_where . ",`id_user`,NULL)) as check_count
								FROM `" .  $table  . "`			
								WHERE	
									 `id_user` = '" . $id_user . "'
								";
							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', $key . ': database select failed');

							$d = fetch_assoc($q);
							if ($d['check_count'] == $check_count) continue;//return $this->showError('404', 'error', $key . 'already has required');

							$s = "REPLACE  INTO `" .  $table  . "` " . $sql_values;

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', $key . ': database replace failed');
						}
						elseif ($key_suffix === '-')
						{
							$s = "SELECT
									GROUP_CONCAT(IF(" . $sql_select_where . ",`" . $field . "`,NULL) SEPARATOR ',') as deleted_users
								FROM `" .  $table  . "`			
								WHERE	
									 `id_user` = '" . $id_user . "'
								";
							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', $key . ': database select failed');

							$d = fetch_assoc($q);
							if (empty($d['deleted_users'])) continue;//return $this->showError('404', 'error', $key . 'already has required');

							$s = "DELETE
								FROM `" .  $table  . "`
								WHERE 
									`id_user` = '" . $id_user . "' AND `" .  $field  . "` in (" . $d['deleted_users'] . ")
								";
							$q = query($s);
							
							if ($q === false) return $this->showError('404', 'error', $key . ': database delete failed');
						}	
					}
					$affected_fields[] = $key;
				}
			}

			if (empty($affected_fields)) 
			{
				return $this->showError('404', 'error', 'user or modified data not found');
			}	
			
			$s = "UPDATE `users`
				SET 
					`last_edit_datetime` = now(),
					`last_edit_user` = " .  $id_user . "
				WHERE `id_user` = '" . $id_user . "'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');			

			foreach ($affected_fields as $i=>$key)
			{
				if (empty($affected_keys[$key])) unset($affected_fields[$i]);
			}
	
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	array(						
									'affected_fields' 	=> 	$affected_fields,
									'forbidden_fields'	=>	$forbidden_fields
								)
			);
		}

		public function updateCache($hash = "")
		{
			if ($hash === md5('checking' . md5(API_KEY)))
			{
				$res = update_cache();
				if (!empty($res['error']))
				{
					return $this->showError('404', 'error', $res);
				}
				unset($res['error']);
				return array(
					'code' 		=>	'200',
					'status' 	=>	'success',
					'data'		=>	$res
				);
			}
			return $this->showError('404', 'error', 'wrong hash');
		}

		public function selectCar($id_car = "", $id_user = "", $langs = array())
		{
			if (empty($_SESSION[UID])) return $this->showError('404', 'error', 'unauthorized access');
			$sql = $sql_json = $sql_left_join = "";
			if (!empty($id_user))
			{
				if ($id_user == 'authorized') 
				{
					if (empty($id_car))
					{
						$sql = "";
					}
					elseif ($id_car == 'driven')
					{
						$sql = "AND `used` = '1'";
					}
					else
					{
						$sql = "AND `id_car` in (" . $id_car . ")";
					}
					$sql_left_join = "
						LEFT JOIN (
								SELECT
									`id_car`	
								FROM
									`car_users`
								WHERE
									`id_user` = '" . $_SESSION[UID] . "' " . $sql . "
								GROUP BY

									`id_car`
							) cu USING (`id_car`)";
				}
				else
				{
					if (!empty($id_car))
					{
						$sql = "AND `id_car` in (" . $id_car . ")";
					}
					$sql_left_join = "
						LEFT JOIN (
								SELECT
									`id_car`	
								FROM
									`car_users`
								WHERE
									`id_user` in (" . $id_user . ") " . $sql . "
								GROUP BY
									`id_car`
							) cu USING (`id_car`)";
				}
				$sql = " AND cu.`id_car` IS NOT NULL";
			}
			else
			{
				if (!empty($id_car))
				{	
					$sql = "AND `car`.`id_car` in (" . $id_car . ")";
				}
			}
			if ($this->id_role == 4)
			{
				$sql_json = ",`car`.`json` as details";
			}
			$license_keys = array('id');
			$license_keys_name = array();
			$license_keys_desc = array();
			$sql_license = array();
			$sql_license_add = array();
			$null_check_keys = array();
			foreach ($langs as $lang)
			{
				$sql_license[] = "IFNULL(`name_{$lang['iso']}`,0x02)";
				$sql_license_add[] = "`description_{$lang['iso']}`";
				$license_keys_name[] = $lang['iso'];
				$license_keys_desc[] = "about_{$lang['iso']}";
				$null_check_keys[] = $lang['iso'];
			}	
			$license_keys = array_merge($license_keys,$license_keys_name,$license_keys_desc,array('active','b_l_c'));
			$sql_license = implode(',',$sql_license);
			$sql_license_add = implode(',',$sql_license_add);

			$s = "SELECT
					`car`.`id_car` as c_id,
					`car`.`id_car_model` as cm_id,
					GROUP_CONCAT(`car_users`.`id_user` SEPARATOR ',') as u_id,
					GROUP_CONCAT(IF(`car_users`.`used` = '1',`car_users`.`id_user`,NULL) SEPARATOR ',') as u_d_id,
					`car`.`seats`,
					`car`.`license_plate` as registration_plate,
					`car`.`id_car_color` as color,
					`car`.`photo_link` as photo
					" . $sql_json . ",
					`car`.`id_car_class` as cc_id,
					(SELECT
						IF(`id_car` IS NULL,NULL,
							GROUP_CONCAT(
								CONCAT_WS(0x00,
									`id_taxi_license`,
									$sql_license,
									$sql_license_add,
									`active`,
									IFNULL((SELECT
										IF(`id_order_location` IS NULL,NULL,
											GROUP_CONCAT(
												CONCAT_WS('|',
													`id_order_location`,
													`location_table_column_value`,
													IFNULL(`tariff`,0x02),
													IFNULL(`currency`,0x02)
												)
											SEPARATOR ';')
										)
									 FROM `taxi_license_order_location`
									 WHERE `id_taxi_license` = `taxi_license`.`id_taxi_license`
									),0x02)
								)
							SEPARATOR 0x01)
						)
					 FROM `taxi_license`
					 WHERE `id_car` = `car`.`id_car`
					) as licenses
				FROM `car`
					" . $sql_left_join . "
				LEFT JOIN `car_users` USING (`id_car`)
				WHERE
					`car_users`.`id_user` IS NOT NULL
					" . $sql . "
				GROUP BY
					`car_users`.`id_car`
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('car' => array());
			while ($d = fetch_assoc($q))
			{
				$d['photo'] = $d['photo'] ? url($d['photo'],FILE_PATH) : '';
				if (!empty($d['details'])) {$d['details'] = json_decode($d['details'],true);}
				if (!empty($d['licenses']))
				{
					$d['licenses'] = explode(chr(1),$d['licenses']);
					foreach ($d['licenses'] as $key=>$value)
					{
						$d['licenses'][$key] = array();
						$value = explode(chr(0),$value);
						foreach($license_keys as $i=>$l_key)
						{
							$d['licenses'][$key][$l_key] = $value[$i];
						}
						foreach($null_check_keys as $l_key)
						{
							if ($d['licenses'][$key][$l_key] == chr(2)) $d['licenses'][$key][$l_key] = NULL;
						}
						if ($d['licenses'][$key]['b_l_c'] == chr(2) ) {$d['licenses'][$key]['b_l_c'] = NULL; continue;}
						$d['licenses'][$key]['b_l_c'] = explode(';',$d['licenses'][$key]['b_l_c']);
						foreach ($d['licenses'][$key]['b_l_c'] as $blc_key=>$blc_value)
						{
							$d['licenses'][$key]['b_l_c'][$blc_key] = array();
							list(
								$d['licenses'][$key]['b_l_c'][$blc_key]['location'],
								$d['licenses'][$key]['b_l_c'][$blc_key]['value'],
								$d['licenses'][$key]['b_l_c'][$blc_key]['tariff'],
								$d['licenses'][$key]['b_l_c'][$blc_key]['currency']
								)= explode('|',$blc_value);
							if ($d['licenses'][$key]['b_l_c'][$blc_key]['tariff'] == chr(2)) 
							{
								$d['licenses'][$key]['b_l_c'][$blc_key]['tariff'] = NULL;
							}
							if ($d['licenses'][$key]['b_l_c'][$blc_key]['currency'] == chr(2)) 
							{
								$d['licenses'][$key]['b_l_c'][$blc_key]['currency'] = NULL;
							}
						}
					}
				}
				$out['car'][$d['c_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['car'] =  array_values($out['car']);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function controlCar($data = "", $id_car = "", $id_user = "", $langs = array(), $order_location = array(), $currency = array(), $country = array(),$region = array(),$city = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}	
			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(							
									'cm_id'					=>		'id_car_model',
									'seats'					=>		'seats',
									'registration_plate'	=>		'license_plate',
									'color'					=>		'id_car_color',
									'photo'					=>		'photo_link',
									'details'				=>		'json',
									'cc_id'					=>		'id_car_class',
									'licenses'				=>		empty($id_car) ? '' : 'licenses'
			);

			$forbidden_fields = array();
			$affected_fields = array();

			$affected_keys = array();
			$filtered_data = array();
			$reassign = array();		
			foreach ($data as $key => $value)
			{
				if (!empty($allowed_fields[$key]))
				{
					if (is_string($value)) $data[$key] = trim($value);

					$affected_fields[] = $key;		
					$affected_keys[$key] = true;		
					$filtered_data[$allowed_fields[$key]] = $data[$key];
				}
				else
				{
					if ($key != "assign") $forbidden_fields[] = $key;
				}
			}
			
			if (!empty($affected_keys['photo']))
			{
				$filtered_data['photo_link'] = base64ImageToFile($filtered_data['photo_link']);

				if ($filtered_data['photo_link']['error'] === false)
				{
					$filtered_data['photo_link'] = $filtered_data['photo_link']['image'];
				}
				else
				{
					return $this->showError('404', 'error', $filtered_data['photo_link']['error']);
				}
			}

			if (!empty($affected_keys['details']))
			{
				$filtered_data['json'] = real_escape_string(json_encode($filtered_data['json']));
			}

			if (empty($id_car))
			{
				if (empty($affected_fields)) return $this->showError('404', 'error', 'empty allowed data');
				if (empty($filtered_data['license_plate'])) 
				{
					return $this->showError('404', 'error', 'empty registration plate');
				}

				if (empty($id_user) || $_SESSION[UID] == $id_user) 
				{
					if ($this->id_role == 2)
					{
						if (empty($_SESSION['id_verification_status']) 
							|| $_SESSION['id_verification_status'] == 1)
						{						
							$car = $this->createCar($filtered_data,$_SESSION[UID]);
							if (!empty($car['error'])) 
							{
								return $this->showError('404', 'error', $car['error']);
							}
							$user = $_SESSION[UID];
						}
						else
						{
							return $this->showError('404', 'error', 'wrong user check state');
						}
					}
					else
					{
						return $this->showError('404', 'error', 'wrong user role');
					}
				}
				else
				{
					if ($this->id_role != 4) 
					{
						return $this->showError('404', 'error', 'not enough rights');
					}
					
					$s = "SELECT 
							`id_role`,
							`id_user`
						FROM `users`
						WHERE 
							`id_user` = '" . $id_user . "'
						LIMIT 1
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'database select failed');
					$d = fetch_assoc($q);

					if (empty($d['id_user'])) return $this->showError('404', 'error', 'user not found');
					if ($this->id_role != 2) return $this->showError('404', 'error', 'wrong role of user');
					
					$car = $this->createCar($filtered_data,$id_user);
					if (!empty($car['error'])) 
					{
						return $this->showError('404', 'error', $car['error']);
					}
					$user = $id_user;
				}
			}
			else
			{			
				if (!empty($id_user) && $this->id_role != 4) 
				{
					return $this->showError('404', 'error', 'not enough rights for assign');
				}
				
				$s = "SELECT
						`car`.`id_car`,
						`car`.`license_plate`,
						GROUP_CONCAT(`car_users`.`id_user` SEPARATOR ',') as u_id
					FROM `car`
					LEFT JOIN `car_users` USING (`id_car`)
					WHERE
						`car`.`id_car` = '" . $id_car . "'
					GROUP BY
						`car_users`.`id_car`
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'mysql select failed');
				$d = fetch_assoc($q);

				if (empty($d['id_car'])) return $this->showError('404', 'error', 'car not found');

				if (empty($id_user)) 
				{
					if ($this->id_role == 4 || (in_array($_SESSION[UID], explode(',',$d['u_id'])) 
						&& (empty($_SESSION['id_verification_status']) || $_SESSION['id_verification_status'] == 1)))
					{

						if (empty($affected_fields)) 
						{

							return $this->showError('404', 'error', 'allowed data not found');
						}
						if (!empty($affected_keys['registration_plate']))
						{
							if (empty($filtered_data['license_plate'])) 
							{
								return $this->showError('404', 'error', 'empty new registration plate');
							}
							if ($d['license_plate'] == $filtered_data['license_plate']) 
							{
								unset($filtered_data['license_plate']);
							}
						}						

						$car = $this->editCar($filtered_data,$id_car,"",$langs,$order_location, $currency,$country,$region,$city);

						if (!empty($car['error'])) 
						{
							return $this->showError('404', 'error', $car['error']);
						}
					}
					else
					{
						return $this->showError('404', 'error', 'not enough rights or wrong user role');
					}
				}
				else
				{
					$u_id_arr = explode(',',$d['u_id']); sort($u_id_arr);
					$id_user_arr = explode(',',$id_user); sort($id_user_arr);

					if ($u_id_arr == $id_user_arr)
					{
						if (empty($affected_fields)) 
						{
							return $this->showError('404', 'error', 'reassign and allowed data not found');
						}
						if (!empty($affected_keys['registration_plate'])) 
						{
							if (empty($filtered_data['license_plate']))
							{
								return $this->showError('404', 'error', 'new empty registration plate');
							}
							if ($d['license_plate'] == $filtered_data['license_plate']) 
							{
								unset($filtered_data['license_plate']);
							}
						}

						$car = $this->editCar($filtered_data,$id_car,"",$langs,$order_location, $currency,$country,$region,$city);
						if (!empty($car['error'])) 
						{
							return $this->showError('404', 'error', $car['error']);
						}
					}
					else
					{
						if (empty($data['assign'])) return $this->showError('404', 'error', 'assign not specified');
						$reassign = array('previous' => $d['u_id'], 'updated' => $id_user);

						$s = "SELECT 
								COUNT(`id_user`) as u_count
							FROM `users`
							WHERE 
								`id_user` in (" . $id_user . ") AND `id_role` = 2
							";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'select of database failed');
						$d = fetch_assoc($q);
						
						if ($d['u_count'] != count(explode(',',$id_user))) 
						{
							return $this->showError('404', 'error', 'user with wrong role');
						}
		
						if (!empty($affected_keys['registration_plate'])) 
						{
							if (empty($filtered_data['license_plate']))
							{
								return $this->showError('404', 'error', 'new empty registration plate');
							}
							if ($d['license_plate'] == $filtered_data['license_plate']) 
							{
								unset($filtered_data['license_plate']);
							}
						}

						$car = $this->editCar($filtered_data,$id_car,$id_user,$langs,$order_location, $currency,$country,$region,$city);
						if (!empty($car['error'])) 
						{
							return $this->showError('404', 'error', $car['error']);
						}
					}
				}
			}

			$out = array(						
						'affected_fields' 	=> 	$affected_fields,
						'forbidden_fields'	=>	$forbidden_fields
					);
			if (!empty($reassign)) $out['reassign'] = $reassign;
			if (!empty($user)) $out['created_car'] = array('c_id'=>$car,'u_id'=>$user);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		public function findLicensePlate($str = "")
		{
				$s = "SELECT
						`id_car`
					FROM `car`
					WHERE
						`license_plate` = '" . $str . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return array('error' => 'registration plate select failed');
				$d = fetch_assoc($q);

				return isset($d['id_car']) ? $d['id_car'] : NULL;
		}

		public function createCar($data = array(), $id_user = "")
		{
			$car = $this->findLicensePlate($data['license_plate']);
			if (!empty($car['error'])) 
			{
				return array('error' => $car['error']);
			}
			if (!empty($car)) 
			{
				return array('error' => 'busy registration plate');
			}
	
			$q = query("BEGIN");
			if ($q === false) return array('error' => 'begin query failed');

			$s = "SELECT
					`id_car`
				FROM `car_users`
				WHERE
					`id_user` = '" . $id_user . "'
				FOR UPDATE
				";
			$q = query($s);
			if ($q === false) return array('error' => 'update select failed');

			$s = array();
			foreach ($data as $key => $value)
			{
				$s[] = "`" . $key . "` = " 
					 . ($value === NULL ? "NULL" : "'" . $value . "'");
			}

			$s = "INSERT INTO `car`
				SET 
					" . implode(",\n", $s) ."
				";

			$q = query($s);
			if ($q === false) return array('error' => 'database insert failed');
			
			$id_car = insert_id();
			$s = "INSERT INTO `car_users`
				SET 
					`id_car` = '" . $id_car . "',
					`id_user` = '" . $id_user . "'
				";

			$q = query($s);
			if ($q === false) 
			{
				return array('error' => 'car assign failed');
			}

			$q = query("COMMIT");
			if ($q === false) return array('error' => 'commit query failed');

			return $id_car;
		}

		public function editCar($data = array(), $id_car = "", $id_user = "", $langs = array(), $order_location = array(), $currency = array(), $country = array(),$region = array(),$city = array())
		{
			if (!empty($data) || !empty($id_user))
			{
				$q = query("BEGIN");
				if ($q === false) return array('error' => 'begin query failed');

				$s = "SELECT
						`car`.`id_car`,
						`car_users`.`id_car`
					FROM `car`,`car_users`
					WHERE
						`car`.`id_car` = '" . $id_car . "' AND `car`.`id_car` = `car_users`.`id_car`
					FOR UPDATE
					";
				$q = query($s);
				if ($q === false) return array('error' => 'update select failed');
			}

			if (!empty($data))
			{
				if (!empty($data['license_plate'])) 
				{
					$car = $this->findLicensePlate($data['license_plate']);
					if (!empty($car['error'])) 
					{
						return array('error' => $car['error']);
					}
					if (!empty($car))
					{
						return array('error' => 'busy registration plate');
					}
				}
				if (!empty($data['licenses'])) {
					$licenses = $data['licenses'];
					unset($data['licenses']);
				}
				if (!empty($data))
				{
					$s = array();
					foreach ($data as $key => $value)
					{
						$s[] = "`" . $key . "` = " 
							 . ($value === NULL ? "NULL" : "'" . $value . "'");
					}

					$s = "UPDATE `car`
						SET 
							" . implode(",\n", $s) ."
						WHERE
							`id_car` = '" . $id_car . "'
						";

					query($s);

					global $link;
					if (mysqli_affected_rows($link) === -1) 
					{
						return array('error' => 'database update failed');
					}
					if (mysqli_affected_rows($link) === 0) 
					{
						return array('error' => 'car or modified data not found');
					}
				}
			}

			if (!empty($id_user))		
			{
				$s = "DELETE
					FROM `car_users`
					WHERE 
						`id_car ` = '" . $id_car . "'
					";
				$q = query($s);
				
				if ($q === false) return array('error' => 'database delete failed');
				$s = array();
				foreach (explode(',',$id_user) as $user)
				{
					$s[] = "('" . $id_car . "', '" . $user . "')";
				}
				$s = "INSERT INTO `car_users` (`id_car`,`id_user`) VALUES " . implode(",", $s);
				
				$q = query($s);
				if ($q === false) 
				{
					return array('error' => 'car assign failed');
				}
			}

			if (!empty($licenses))
			{
				if (!is_array($licenses)) return array('error' => 'wrong licenses'); 
				$countries_list = $country;
				$data_template = array(
					'licenses'	=>	array(
						'table'			=>	'taxi_license',
						'id'			=>	'id_taxi_license',
						'allowed_fields'=>	array(
							'active'	=>		array(
													'name'	=>	'active',
													'NULL'	=>	false,
													'format'=>	function($val){return empty($val) ? 0 : 1;}
												),
							'b_l_c'		=>		array(
													'name'	=>	NULL,
													'NULL'	=>	true,
													'table'	=>	'taxi_license_order_location',
													'key'	=>	NULL,
													'allowed_fields' => array(
														'location'	=>	array(
																			'name'	=>	'id_order_location',
																			'NULL'	=>	false,
																			'format'=>	function($val,$data_inner,$index_inner,$data,$index,$s_data)
																			{
																				if (empty($val))
																				{
																					return array('error'=>"$index $index_inner: empty location");
																				}
																				if (isset($s_data['order_location'][$val]))
																				{
																					return $val;
																				}
																				else
																				{
																					return array('error'=>"$index $index_inner: wrong location");
																				}
																			}
																		),
														'value'		=>	array(
																			'name'	=>	'location_table_column_value',
																			'NULL'	=>	false,
																			'format'=>	function($val,$data_inner,$index_inner,$data,$index,$s_data)
																			{
																				if (empty($val))
																				{
																					return array('error'=>"$index $index_inner: empty value");
																				}						
																				if (isset($data_inner['location']) && isset($s_data['order_location'][$data_inner['location']]))
																				{
																					if (isset($s_data['alias']) && isset($s_data['alias'][$s_data['order_location'][$data_inner['location']]['alias']][$val]))
																					{
																						return $val;
																					}
																					else
																					{
																						return array('error'=>"$index $index_inner: wrong value");
																					}
																				}
																			}
																		),
														'tariff'	=>	array(
																			'name'	=>	'tariff',
																			'NULL'	=>	true
																		),
														'currency'	=>	array(
																			'name'	=>	'currency',
																			'NULL'	=>	true,
																			'format'=>	function($val,$data_inner,$index_inner,$data,$index,$s_data)
																			{
																				if (empty($val))
																				{
																					if ($val === NULL)
																					{
																						return $val;
																					}
																					else
																					{
																						return array('error'=>"$index $index_inner: empty currency");
																					}
																				}
																				if (isset($s_data['currency'][$val]))
																				{
																					return $val;
																				}
																				else
																				{
																					return array('error'=>"$index $index_inner: wrong currency");
																				}
																			}
																		),
													)
												),
//							'exact'		=>		array()				
						)
					)
				);
				foreach ($langs as $lang)
				{
					$data_template['licenses']['allowed_fields'][$lang['iso']] = array(
																	'name'	=>	'name_' . $lang['iso'],
																	'NULL'	=>	true
					);
					$data_template['licenses']['allowed_fields']['about_'.$lang['iso']] = array(
																	'name'	=>	'description_' . $lang['iso'],
																	'NULL'	=>	false
					);
				}
				$s_data = array(
					'order_location'	=> $order_location,
					'alias'				=> compact('countries_list','region','city'),
					'currency'			=>	$currency
				);
				$forbidden_fields = array();
				$affected_fields = array();
				$affected_keys = array();
				foreach ($licenses as $i=>$l_data)
				{
					$filtered_data = array();
					$filtered_fields = array();
					$add_table = array();
					$forbidden_fields_inner = array();
					$affected_fields_inner = array();
					$allowed_fields = $data_template['licenses']['allowed_fields'];
					foreach ($l_data as $key => $value)
					{
						if (isset($allowed_fields[$key]))
						{
							$affected_fields_inner[] = $key;
							if (!empty($allowed_fields[$key]['format']))
							{
								$value = $allowed_fields[$key]['format']($value);
							}
							if (empty($value['error']))
							{
								if ($allowed_fields[$key]['name'] === NULL)
								{
									$add_table[] = array(
										$allowed_fields[$key]['table'],
										$allowed_fields[$key]['allowed_fields'],
										$value,
										$key
									);
								}
								else
								{
									$name = $allowed_fields[$key]['name'];
									if (gettype($name) === 'object')
									{
										$name = $name($value);
									}
									$null_on = $allowed_fields[$key]['NULL'];
									if ($null_on === true || $value !== NULL)
									{
										$filtered_data[$name] = $value;
										$filtered_fields[] = $key;
									}
									else
									{
										return array('error' => "$i: null $key");
									}
								}
							}
							else
							{
								return array('error' => $value['error']);
							}
						}
						else
						{
							if ($key !== 'id' && $key !== 'exact') $forbidden_fields_inner[] = $key;
						}
					}
					if (empty($affected_fields_inner)) return array('error' => "empty $i license allowed data");

					$s = array();
					foreach ($filtered_data as $key => $value)
					{
						$s[] = "`" . $key . "` = " 
							 . ($value === NULL ? "NULL" : "'" . (is_array($value) ? real_escape_string(json_encode($value)) : $value) . "'");
					}
					$s = implode(",", $s);
					if (empty($s)) {$affected_fields_inner = array();} else {$s = ", $s";}
					if (empty($l_data['id']))
					{
						$s = "INSERT INTO `taxi_license`
							SET 
								`id_car` = '" . $id_car . "'
								" . $s ."
							";

						$q = query($s);
						if ($q === false) return array('error' => "$i : insert failed");

						$id_val = insert_id();
					}
					else
					{
						$id_val = $l_data['id'];	
						$s = "UPDATE `taxi_license`
							SET 
								`id_car` = '" . $id_car . "'
								" . $s ."
							WHERE
								`id_taxi_license` = '" . $id_val . "'
							";

						query($s);

						global $link;
						if (mysqli_affected_rows($link) === -1) 
						{
							return array('error' => "$i : update failed'");
						}
						elseif (mysqli_affected_rows($link) === 0) 
						{
							$affected_fields_inner = array();
						}
					}

					if (!empty($affected_fields_inner))
					{
						$affected_fields_inner = $filtered_fields;
					}

					foreach($add_table as $arr) 
					{
						$table = $arr[0];
						$allowed_fields = $arr[1];
						$forbidden_fields_inner_add = array();
						$affected_fields_inner_add = array();
						if (!is_array($arr[2])) return array('error' => "$i {$arr[3]} wrong data");
						foreach ($arr[2] as $j=>$l_data_add)
						{	
							$filtered_data = array();
							if (!is_array($l_data_add)) return array('error' => "$i {$arr[3]} $j wrong data");
							foreach ($l_data_add as $key => $value)
							{
								if (isset($allowed_fields[$key]))
								{
									$affected_fields_inner_add[$j][] = $key;
									if (!empty($allowed_fields[$key]['format']))
									{
										$value = $allowed_fields[$key]['format']($value,$l_data_add,"{$arr[3]} $j",$l_data,$i,$s_data);
									}
									if (empty($value['error']))
									{
										if ($allowed_fields[$key]['name'] !== NULL)
										{
											$name = $allowed_fields[$key]['name'];
											if (gettype($name) === 'object')
											{
												$name = $name($value);
											}
											$null_on = $allowed_fields[$key]['NULL'];
											if ($null_on === true || $value !== NULL)
											{
												$filtered_data[$name] = $value;
											}
											else
											{
												return array('error' => "$i {$arr[3]} $j: null $key");
											}
										}
									}
									else
									{
										return array('error' => $value['error']);
									}
								}
								else
								{
									$forbidden_fields_inner_add[$j][] = $key;
								}
							}
							if (empty($affected_fields_inner_add[$j])) return array('error' => "empty $i license {$arr[3]} $j allowed data");

							$s = array();
							foreach ($filtered_data as $key => $value)
							{
								$s[] = "`" . $key . "` = " 
									 . ($value === NULL ? "NULL" : "'" . (is_array($value) ? real_escape_string(json_encode($value)) : $value) . "'");
							}
							$s = implode(",", $s);
							if (!empty($s)) $s = ", $s";
							$s = "`id_taxi_license` = '" . $id_val . "'" . $s;

							if (empty($l_data['exact']))
							{
								$s = "INSERT INTO `" . $table . "`
									SET 
										" . $s . " ON DUPLICATE KEY UPDATE " . $s . "
									";

								$q = query($s);
								if ($q === false) return array('error' => "$i {$arr[3]} $j: insert update failed");
							}
							else
							{
								$s_d = "DELETE
									FROM `" . $table . "`
									WHERE 
										`id_taxi_license` = '" . $id_val . "'
									";
								$q = query($s_d);
					
								if ($q === false) return array('error' => "$i {$arr[3]} $j: database delete failed");

								$s = "INSERT INTO `" . $table . "`
									SET 
										" . $s ."
									";

								$q = query($s);
								if ($q === false) return array('error' => "$i {$arr[3]} $j: insert failed");	
							}
						}
						$affected_fields_inner[] = array($arr[3]=>$affected_fields_inner_add);
						if (!empty($forbidden_fields_inner_add)) $forbidden_fields_inner[] = array($arr[3]=>$forbidden_fields_inner_add);
					}

					$affected_fields[$i] = $affected_fields_inner;
					if (!empty($forbidden_fields_inner)) $forbidden_fields[$i] = $forbidden_fields_inner;
				}
			}

			if (!empty($data) || !empty($id_user) || !empty($licenses))
			{
				$q = query("COMMIT");
				if ($q === false) return array('error' => 'commit query failed');
			}
		
			return true;
		}

		public function createOrder($data = array(), $langs = array(), $payment_method = array(), $payment_card = array(), $comment_items = array(), $order_service = array(), $contact = array(), $order_location = array(), $currency = array(), $unit_set = array(), $country = array(),$region = array(),$city = array(), $schedule = array(), $price_time_functions = array(), $stripe_seat_title_template = '', $stripe_request_duration = 0)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 5 && $this->id_role != 4)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}
			if (!empty($_SESSION['user_ban_status']['order']))
			{
				return $this->showError('404', 'error', 'user banned');
			}	
			
			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}
			$iso = array();
			foreach ($langs as $lang)
			{
				$iso[$lang['iso']] = array(
										'name'				=>$lang['iso'],
										'type'				=>'string',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>NULL
				);
			}
			$options_valid_keys = array();
			foreach ($this->constant['b_options_valid_keys'] as $key => $value)
			{
				$options_valid_keys[$key] = array(
										'name'				=>$key,
										'type'				=>'string',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>NULL
				);
			}
			foreach ($contact as $key => $value)
			{
				$contact[$key] = array(
										'name'				=>$key,
										'type'				=>'string',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>NULL
				);
			}
		
			$allowed_fields = array(						
				'b_start_address'			=>		array(
							'name'				=>'from',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(""),
							'error'				=>array(
								'requirement'     =>array(
									array('empty','from'),
									array('&&'),
									array(
										array('!isset','from_lat'),
										array('||'),
										array('!isset','from_lng'),
									)
								),
								'msg' 			=>'empty start address'
							)
				),
				'b_start_latitude'			=>		array(
							'name'				=>'from_lat',
							'type'				=>'latitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'b_start_longitude'			=>		array(
							'name'				=>'from_lng',
							'type'				=>'longitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'b_destination_address'		=>		array(
							'name'				=>'to',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array("")
				),
				'b_destination_latitude'	=>		array(
							'name'				=>'to_lat',
							'type'				=>'latitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'b_destination_longitude'	=>		array(
							'name'				=>'to_lng',
							'type'				=>'longitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'b_start_datetime'			=>		array(
							'name'				=>'datetime_start_plan',
							'type'				=>'datetime',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array('0000-00-00 00:00:00'),
							'error'				=>array(
								'requirement'     =>array(
									array('empty','datetime_start_plan')
								),
								'msg' 			=>'empty booking datetime'
							),
							'var'				=>array(
								'before' 			=>array(
									array('max_waiting_time',$this->constant['waiting_interval'])
								),
								'any'				=>array(
									array('max_waiting_time',$this->constant['waiting_interval_any'])
								)
							)
				),
				'b_custom_comment'			=>		array(
							'name'				=>'comment',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array("")
				),
				'b_flight_number'			=>		array(
							'name'				=>'flight_number',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array("")
				),
				'b_terminal'				=>		array(
							'name'				=>'terminal',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array("")
				),
				'b_passengers_count'		=>		array(
							'name'				=>'passenger_count',
							'type'				=>'unsigned integer',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(0)
				),
				'b_luggage_count'			=>		array(
							'name'				=>'luggage_count',
							'type'				=>'unsigned integer',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(0)
				),
				'b_placard'					=>		array(
							'name'				=>'placard',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array("")
				),
				'b_car_class'				=>		array(
							'name'				=>'id_car_class',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$this->car_class,
							'default'			=>array(NULL),
							'error'				=>array(
								'requirement'     =>array(
									array('isset','id_car_class'),
									array('&&'),
									array('empty_values','id_car_class')
								),
								'msg' 			=>'wrong car class'
							)			
				),
				'b_payment_way'				=>		array(
							'name'				=>'id_payment_method',
							'type'				=>'integer',
							'NULL'				=>false,
							'values'			=>$payment_method,
							'default'			=>array(0),
							'error'				=>array(
								'requirement'     =>array(
									array('empty','id_payment_method')
								),
								'msg' 			=>'empty payment way'
							)			
				),
				'b_payment_card'			=>		array(
							'name'				=>'id_payment_card',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$payment_card,
							'default'			=>array(NULL) 
				),
				'b_cars_count'				=>		array(
							'name'				=>'car_count',
							'type'				=>'unsigned integer',		
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(1)
				),
				'b_max_waiting'				=>		array(
							'name'				=>'max_waiting_datetime',
							'type'				=>'second to datetime',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array('0000-00-00 00:00:00'),
							
							'var'				=>array(
								'before' 			=>array(
									array('or',empty($data['b_services'])?false:@in_array('5', $data['b_services']))
								),
								'check'				=>array(
									array('or',array(
											array('code',$this->generateDriverCode()),
											array('max_waiting_time',$this->constant['waiting_interval_or']),
											@array('add_s|.',",`is_confirmed` = '0',`code` = '" .$code . "'"),
											array('car_count||fd',1)
										)
									)
								),
								'this'		=>'max_waiting_time'
							)
				),
				'b_options'					=>		array(
							'name'				=>'options',
							'type'				=>'associative for json',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(""),
							'keys'				=>$options_valid_keys ? : NULL
				),
				'b_comments'				=>		array(
							'name'				=>'order_comment_items',
							'type'				=>'array list for table',
							'NULL'				=>false,
							'values'			=>$comment_items,
							'default'			=>NULL
				),
				'b_services'				=>		array(
							'name'				=>'order_service',
							'type'				=>'array list for table',
							'NULL'				=>false,
							'values'			=>$order_service,
							'default'			=>NULL
				),
				'b_contact'					=>		array(
							'name'				=>'contact',
							'type'				=>'associative for json',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(""),
							'keys'				=>$contact
				),
				'b_location_class'			=>		array(
							'name'				=>'id_order_location',
							'type'				=>'integer',
							'NULL'				=>false,
							'values'			=>$order_location,
							'default'			=>array(1)
				),
				'b_currency'				=>		array(
							'name'				=>'currency',
							'type'				=>'ISO 4217 alpha code',
							'NULL'				=>true,
							'values'			=>$currency,
							'default'			=>array(NULL)
				),
				'b_cargo'					=>		array(
							'name'				=>NULL,
							'type'				=>'array list',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>NULL,
							'keys'				=>array(			
								'name'				=>'order_cargo',
								'type'				=>'associative for table',
								'NULL'				=>false,
								'values'			=>NULL,
								'default'			=>NULL,
								'keys'				=>array(
									'details'			=>array(
										'name'				=>'json',
										'type'				=>'associative for json',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(""),
										'keys'				=>array(
											'name'				=>array(
												'name'				=>'name',
												'type'				=>'associative',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL,
												'keys'				=>$iso
											),
											'about'				=>array(
												'name'				=>'about',
												'type'				=>'associative',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL,
												'keys'				=>$iso
											)
										)
									),					
									'weight'			=>array(
										'name'				=>'weight',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									'volume'			=>array(
										'name'				=>'volume',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									'height'			=>array(
										'name'				=>'height',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									'length'			=>array(
										'name'				=>'length',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									'width'				=>array(
										'name'				=>'width',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),	
									's_weight'			=>array(
										'name'				=>'summ_weight',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									's_volume'			=>array(
										'name'				=>'summ_volume',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									's_height'			=>array(
										'name'				=>'summ_height',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									's_length'			=>array(
										'name'				=>'summ_length',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									's_width'			=>array(
										'name'				=>'summ_width',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(0)
									),
									'count'				=>array(
										'name'				=>'count',
										'type'				=>'unsigned integer',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(1)
									),
									'units'				=>array(
										'name'				=>'unit_set',
										'type'				=>'unit set str',
										'NULL'				=>false,
										'values'			=>$unit_set,
										'default'			=>array('1_1_1_1_1')
									),
									's_units'			=>array(
										'name'				=>'unit_set_summ',
										'type'				=>'unit set str',
										'NULL'				=>false,
										'values'			=>$unit_set,
										'default'			=>array('1_1_1_1_1')
									),
									'photos'			=>array(
										'name'				=>'photo_links',
										'type'				=>'array list for json',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>array(""),
										'keys'				=>array(
											'content'			=>array(
												'name'				=>NULL,
												'type'				=>'base64',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL
											),	
											/*'basename'			=>array(
												'name'				=>'basename',
												'type'				=>'filename with extension',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL
											),*/
											'main'				=>array(
												'name'				=>'main',
												'type'				=>'boolean integer',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL
											),
											'index'				=>array(
												'name'				=>'index',
												'type'				=>'unsigned integer',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL
											),
											'title'				=>array(
												'name'				=>'about',
												'type'				=>'associative',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL,
												'keys'				=>$iso
											),
											'about'				=>array(
												'name'				=>'about',
												'type'				=>'associative',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL,
												'keys'				=>$iso
											),
											'file'				=>array(
												'name'				=>'file',
												'type'				=>'associative',
												'NULL'				=>false,
												'values'			=>NULL,
												'default'			=>NULL,
												'keys'				=>array(
													'name'				=>array(
														'name'				=>'name',
														'type'				=>'filename without extention',
														'NULL'				=>false,
														'values'			=>NULL,
														'default'			=>NULL
													),
													'extension'			=>array(
														'name'				=>'name',
														'type'				=>'file extension without dot',
														'NULL'				=>false,
														'values'			=>NULL,
														'default'			=>NULL
													),
													'lastModified'		=>array(
														'name'				=>'name',
														'type'				=>'unix time ms',
														'NULL'				=>false,
														'values'			=>NULL,
														'default'			=>NULL
													),
													'size'				=>array(
														'name'				=>'name',
														'type'				=>'bytes',
														'NULL'				=>false,
														'values'			=>NULL,
														'default'			=>NULL
													),
													'type'				=>array(
														'name'				=>'name',
														'type'				=>'mime',
														'NULL'				=>false,
														'values'			=>NULL,
														'default'			=>NULL
													),
												)
											)
										)
									),
									'categories'		=>array(				
										'name'				=>'order_cargo_category',
										'type'				=>'array list with parameter for table',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>NULL,
										'parameter'			=>array(
											'name'				=>'default',	
											'type'				=>'boolean integer',
											'NULL'				=>true,
											'values'			=>NULL,
											'default'			=>array('1')
										)
									)
								)
							)
				),
				'b_cargo_case'				=>		array(
							'name'				=>'order_users_case',
							'type'				=>'array list for table',
							'NULL'				=>false,
							'values'			=>$this->selectUsersCargoCase($_SESSION[UID]),
							'default'			=>NULL
				),
				'b_only_offer'				=>		array(
							'name'				=>'only_offer',
							'type'				=>'boolean integer',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(0)
				),
				'countries_list_start'		=>		array(
							'name'				=>'countries_list_from',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$country,
							'default'			=>array(NULL) 
				),
				'countries_list_destination'=>		array(
							'name'				=>'countries_list_to',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$country,
							'default'			=>array(NULL) 
				),
				'region_start'				=>		array(
							'name'				=>'region_from',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$region,
							'default'			=>array(NULL) 
				),
				'region_destination'		=>		array(
							'name'				=>'region_to',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$region,
							'default'			=>array(NULL) 
				),
				'city_start'				=>		array(
							'name'				=>'city_from',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$city,
							'default'			=>array(NULL) 
				),
				'city_destination'			=>		array(
							'name'				=>'city_to',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>$city,
							'default'			=>array(NULL) 
				),
				'u_id'						=>		array(
							'name'				=>NULL,
							'type'				=>'integer',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(0)
				),
				'b_pc'						=>		array(
							'name'				=>NULL,
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>NULL
				)
			);
			$forbidden_fields = array();
			$affected_fields = array();
			$affected_keys = array();
			$filtered_data = array();
			$wrong_data_fields = array();
			
			foreach ($data as $key => $value)
			{
				if (!empty($allowed_fields[$key]))
				{
					if (is_string($value)) $data[$key] = trim($value);
					$affected_fields[] = $key;
					$affected_keys[$key] = true;
					if ($allowed_fields[$key]['name'] !== NULL && !in_array($allowed_fields[$key]['type'], array('second to datetime','associative for json','array list for table','array list'))) $filtered_data[$allowed_fields[$key]['name']] = $data[$key];
				}
				else
				{

					$forbidden_fields[] = $key;
				}
			}		
			if (empty($affected_fields)) return $this->showError('404', 'error', 'allowed data not found');
			$add_s = '';

			$client = $_SESSION[UID];
			$email = $_SESSION['email'];
			if (array_key_exists('u_id',$data))
			{
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

				$s = "SELECT 
						`id_user`,
						`email`
					FROM `users`
					WHERE
						`id_user` = '" . $data['u_id'] . "'
					LIMIT 1
					";		

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'user select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_user'])) return $this->showError('404', 'error', "user $u_id not found");
				$client = $data['u_id'];
				$email = $d['email'];
			}

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			if (DEFAULT_PROFILE == 'stadium')
			{
				if (empty($affected_keys['b_options']) || empty($data['b_options']['tickets']['seats'])) return $this->showError('404', 'error', 'empty need b_options');
//				$seats = $data['b_options']['tickets']['seats'];
				$trips_seats = $data['b_options']['tickets']['seats'];
				if (!is_array($trips_seats)) return $this->showError('404', 'error', 'wrong need b_options');
				$data['b_only_offer'] = 1;
				$filtered_data['only_offer'] = 1;
				$filtered_data['datetime_start_plan'] = 'any';
				$sql_where_ticket = array();
				$trips = array();
				foreach($trips_seats as $id_trip=>$seats)
				{
					if (!is_array($seats)) return $this->showError('404', 'error', $id_trip .' wrong need b_options');
					foreach($seats as $seat=>$val)
					{
						$sql_where_ticket[] = "`id_trip` = '" . $id_trip . "' AND `id_seat` = '" . $seat . "'";
					}
					$trips[] = $id_trip;
				}	
				$sql_where_ticket = '((' . implode(") OR (", $sql_where_ticket) . '))';
				$trips = implode(",", $trips);
				$filtered_data['from'] = $trips;
				
				$try_count = 0;
				while (true)
				{
					$s = "SELECT
							`id_seat`,
							`id_trip`,
							`id_trip_seat`
						FROM
							`ticket`
						WHERE
							" . $sql_where_ticket . "
					";
				
					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'tickets select failed');
					$sql_where = array();
					$fix_seats = array();
					while ($d = fetch_assoc($q))
					{
						$sql_where[] = "`product` = '" . $d['id_trip'] . "' AND `property` = '" . $d['id_trip_seat'] . "'";
						$fix_seats[$d['id_trip']][$d['id_seat']] = $d['id_trip_seat'];
					}
					if (empty($sql_where)) return $this->showError('404', 'error', 'seats not found');
					$sql_where = '((' . implode(") OR (", $sql_where) . '))';

					$s = "SELECT
							`trip`.`id_trip`,
							`trip`.`json`,
							ca1.busy,
							ca2.booked,
							`trip`.`from`,
							`trip`.`id_price_time_function`,
							`trip`.`create_datetime`,
							`trip`.`currency`,
							`trip`.`currency_priority`,
							`trip`.`fee`,
							`trip`.`tariff`,
							`trip`.`tariff_priority`,							
							IF(ti.`id_trip` IS NULL,NULL,GROUP_CONCAT(CONCAT_WS(0x00,ti.`id_seat`,ti.`id_trip_seat`,IFNULL(ti.`tariff`,0x02),IFNULL(ti.`currency`,0x02),IFNULL(ti.`id_order`,0x02),ti.`status`) SEPARATOR 0x01)) as sold_seats,
							tr.looking_for_clients
						FROM `trip`
						LEFT JOIN (
								SELECT
									`product` as id_trip,
									1 as busy
								FROM
									`cart`
								WHERE
									" . $sql_where . " AND `id_user` != '" . $_SESSION[UID] . "' AND `booking_limit` > now()
								LIMIT 1
							) ca1 USING (`id_trip`)
						LEFT JOIN (
								SELECT
									`product` as id_trip,
									1 as booked
								FROM
									`cart`
								WHERE
									" . $sql_where . " AND `id_user` = '" . $_SESSION[UID] . "'
								LIMIT 1
							) ca2 USING (`id_trip`)
						LEFT JOIN (
								SELECT
									`id_seat`,
									`id_trip`,
									`id_trip_seat`,
									`id_order`,
									`tariff`,
									`currency`,
									`status`
								FROM
									`ticket`
								WHERE
									" . $sql_where_ticket . "
							) ti USING (`id_trip`)								
						LEFT JOIN (
								SELECT
									COUNT(`id_seat`) - COUNT(IF(`id_order` IS NULL,NULL,`id_seat`)) as looking_for_clients,
									`id_trip`
								FROM
									`ticket`
								WHERE
									`id_trip` in (" . $trips . ")
								GROUP BY
									`id_trip`
							) tr USING (`id_trip`)	
						WHERE `id_trip` in (" . $trips . ")
						GROUP BY
							`trip`.`id_trip`
						FOR UPDATE
					";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'database select failed');
					$trips = array();
					if (mysqli_num_rows($q) != count($trips_seats)) return $this->showError('404', 'error', 'trip not found');
					$sum = 0;
					$fee_sum = 0;
					$line_items = array();
					$booked = false;
					$sc_id_arr = array();
					while ($d = fetch_assoc($q))
					{
						$t_options = json_decode($d['json'],true);
						$outer_ticket = false;
						add_time_zone($d['create_datetime']);
						$sc_id = explode(chr(0),$d['from']);
						if (count($sc_id) > 1 || $sc_id[0] == 'sc_id')
						{
							$data['b_options']['tickets']['t_id'][$d['id_trip']] = $sc_id[1];
						}
						else
						{
							return $this->showError('404', 'error', 'sc_id not found');
						}
						if (empty($schedule[$sc_id[1]])) return $this->showError('404', 'error', 'schedule not found');

						if (!empty($d['sold_seats']))
						{
							if (!empty($schedule[$sc_id[1]]['datetime']))
							{
								$ptfd = $this->createPriceTimeFunctionData(array('price_time_function'=>$d['id_price_time_function'],'sc_price_time_function'=>$schedule[$sc_id[1]]['price_time_function'],'t_create_datetime'=>$d['create_datetime'],'sc_datetime'=>$schedule[$sc_id[1]]['datetime']),$price_time_functions);
							}							
							$currency = $currency_priority = NULL;
							if (isset($d['currency']))
							{
								$currency = $d['currency'];
							}
							elseif (isset($schedule[$sc_id[1]]['currency']))
							{
								$currency = $schedule[$sc_id[1]]['currency'];
							}
							if (isset($currency))
							{
								if (isset($d['currency_priority']))
								{
									$currency_priority = $d['currency_priority'];
								}
								else
								{
									$currency_priority = $schedule[$sc_id[1]]['currency_priority'];
								}
								if (empty($currency_priority))
								{
									$currency_function = 'getTripCurrencyString10';
								}
								else
								{
									$currency_function = 'getTripCurrencyString11';
								}
							}
							else
							{						
								$currency_function = 'getTripCurrencyString0';
							}
							$fee = isset($d['fee']) ? (float)$d['fee'] : (isset($schedule[$sc_id[1]]['fee']) ? (float)$schedule[$sc_id[1]]['fee'] : NULL);
							$tariff_ = $tariff_priority = NULL;
							if (isset($d['tariff']))
							{
								$tariff_ = $d['tariff'];
							}
							elseif (isset($schedule[$sc_id[1]]['tariff']))
							{
								$tariff_ = $schedule[$sc_id[1]]['tariff'];
							}
							if (isset($tariff_))
							{
								if (isset($d['tariff_priority']))
								{
									$tariff_priority = $d['tariff_priority'];
								}
								else
								{
									$tariff_priority = $schedule[$sc_id[1]]['tariff_priority'];
								}
								if (empty($tariff_priority))
								{
									$tariff_function = 'getTripTariff10';
								}
								else
								{
									$tariff_function = 'getTripTariff11';
								}
							}
							else
							{					
								$tariff_function = 'getTripTariff0';
							}
							$d['sold_seats'] = explode(chr(1),$d['sold_seats']);
							$t_options['seats_sold'] = array();
							$t_options['price'] = array();
							$price = array();
							$outer_ticket = true;
							foreach ($d['sold_seats'] as $key=>$value)
							{
								$d['sold_seats'][$key] = array();
								list(
									$d['sold_seats'][$key]['id_seat'],
									$d['sold_seats'][$key]['id_trip_seat'],
									$d['sold_seats'][$key]['tariff'],
									$d['sold_seats'][$key]['currency'],
									$d['sold_seats'][$key]['id_order'],
									$d['sold_seats'][$key]['status']
									)= explode(chr(0),$value);
								$seat = $d['sold_seats'][$key]['id_seat'];
								if ($d['sold_seats'][$key]['status'] == '2' || $d['sold_seats'][$key]['status'] == '2') return $this->showError('404', 'error', "busy $seat with status {$d['sold_seats'][$key]['status']}");						
								if ($fix_seats[$d['id_trip']][$d['sold_seats'][$key]['id_seat']] != $d['sold_seats'][$key]['id_trip_seat'])
								{
									if ($try_count > 0)
									{
										return $this->showError('404', 'error', 'try error');
									}
									else
									{
										$try_count++;
										continue 3;
									}
								}
								$d['sold_seats'][$key]['tariff'] = $this->$tariff_function($tariff_,$d['sold_seats'][$key]['tariff']);
								if ($d['sold_seats'][$key]['tariff'] !== '')
								{
									if (isset($ptfd['price_time_function']))
									{
										$var = $ptfd['var'];
										if (!empty($ptfd['dp'])) $var['dp'] = $d['sold_seats'][$key]['tariff'];
										$d['sold_seats'][$key]['tariff'] = $ptfd['price_time_function']($var);
									}									
									$tariff = $d['sold_seats'][$key]['tariff'] . $this->$currency_function($currency,$d['sold_seats'][$key]['currency']);
									$tariff = strtoupper($tariff);
									if (!isset($price[$tariff]))
									{
										$price[$tariff] = count($t_options['price']);
										$t_options['price'][] = $tariff;
									}
									$t_options['seats_sold'][$seat] = array($price[$tariff]);
								}
								else
								{
									$t_options['seats_sold'][$seat] = array('');
								}
								if ($d['sold_seats'][$key]['id_order'] !== chr(2)) $t_options['seats_sold'][$seat] = array(
									$t_options['seats_sold'][$seat][0],
									"",
									$d['sold_seats'][$key]['id_order']
								);
								unset($d['sold_seats']);
							}
						}

						if (empty($t_options['seats_sold'])) return $this->showError('404', 'error', 'trip ' . $d['id_trip'] . ' seats not found');
						if (!empty($d['busy'])) return $this->showError('404', 'error', "busy seats");	
						$price_arr = empty($t_options['price']) || !is_array($t_options['price']) ? array() : $t_options['price'];
						if (!empty($d['booked'])) $booked = true;
						$trips[$d['id_trip']]['t_options'] = $t_options;
						$trips[$d['id_trip']]['price_arr'] = $price_arr;
						$trips[$d['id_trip']]['looking_for_clients'] = $d['looking_for_clients'];
						$trips[$d['id_trip']]['outer_ticket'] = $outer_ticket;

						$sc_id_arr[$sc_id[1]] = isset($sc_id_arr[$sc_id[1]]) ? $sc_id_arr[$sc_id[1]] + count($trips_seats[$d['id_trip']]) : count($trips_seats[$d['id_trip']]);
					}
					if (array_key_exists('b_pc',$data))
					{
						$promocode_arr = $this->checkPromocode($data['b_pc'],true,array_keys($sc_id_arr));
						if (!empty($promocode_arr['error'])) return $this->showError('404', 'error', $promocode_arr['error']);
						if (empty($promocode_arr['data']['id_promocode'])) return $this->showError('404', 'error', 'wrong promocode');
						$pc_id = $promocode_arr['data']['id_promocode'];
						if (empty($promocode_arr['data']['active'])) return $this->showError('404', 'error', 'nonactive promocode');
						if (!empty($promocode_arr['data']['expire'])) return $this->showError('404', 'error', 'expired promocode');
						if (empty($promocode_arr['data']['id_schedule'])) return $this->showError('404', 'error', 'promocode for other schedules');
						$pc_schedules = array_flip($promocode_arr['data']['id_schedule']);
/*						$pc_required_number = 0;
						foreach($promocode_arr['data']['id_schedule'] as $pc_sc_id)
						{
							$pc_required_number += $sc_id_arr[$pc_sc_id];
						}*/
						if ($promocode_arr['data']['payments'] >= $promocode_arr['data']['max_payments'])
						{
							return $this->showError('404', 'error', 'payment limit reached for promocode');
						}
						if ($promocode_arr['data']['products'] >= $promocode_arr['data']['max_products'])
						{
							return $this->showError('404', 'error', 'seat limit reached for promocode');
						}
						$pc_available_number = $promocode_arr['data']['max_products'] - $promocode_arr['data']['products'];
						$pc_discount = ((float)$promocode_arr['data']['discount'])/100;
						$pc_current_number = 0;
						$pc_seat = array();
					}
					foreach($trips_seats as $id_trip=>$val_arr)
					{
						$d['id_trip'] = $id_trip;
						foreach($trips_seats[$d['id_trip']] as $seat=>$val)
						{
							if (!isset($trips[$d['id_trip']]['t_options']['seats_sold'][$seat]))
							{
								return $this->showError('404', 'error', "seat $seat not found");
							}
							else
							{
								$seats_sold_item = $trips[$d['id_trip']]['t_options']['seats_sold'][$seat];
							}
							if (empty($seats_sold_item) || !is_array($seats_sold_item) || count($seats_sold_item) == 1)
							{
								$price_arr = $trips[$d['id_trip']]['price_arr'];
								if (empty($seats_sold_item))
								{
									$seats_sold_item = array();
								}
								elseif (!is_array($seats_sold_item))
								{
									$seats_sold_item = array($seats_sold_item);
								}
								$price = isset($price_arr[$seats_sold_item[0]]) ? $price_arr[$seats_sold_item[0]] : "";
								if ($price != "")
								{
									$data['b_options']['tickets']['seats'][$d['id_trip']][$seat] = $price;
									$price_parsed =  explode(' ', $price);
									if (count($price_parsed) < 2)
									{
										$price_parsed[1] = '';
									}
									if (isset($seat_currency))
									{
										if ($price_parsed[1] !== $seat_currency) return $this->showError('404', 'error', "seats with different currencies");
									}
									else
									{
										$seat_currency = $price_parsed[1];
									}

									$price_float = (float)$price_parsed[0];
									
									if (isset($pc_id) && isset($pc_schedules[$data['b_options']['tickets']['t_id'][$id_trip]]) 
										&& $pc_current_number < $pc_available_number)
									{
										$price_float *= (1 - $pc_discount);
										$pc_current_number++;
										$pc_seat[$data['b_options']['tickets']['t_id'][$id_trip]][$fix_seats[$id_trip][$seat]] = true;
										$data['b_options']['tickets']['seats'][$d['id_trip']][$seat] = var_export($price_float,true) . ($price_parsed[1] = '' ? '' : ' ' . $price_parsed[1]);
									}

									if ($stripe_seat_title_template !== '')
									{
										$line_items[] = array(round($price_float,2),$this->fillStripeTitle($stripe_seat_title_template,$seat));
									}
									if (isset($fee)){
										$fee_sum_add = $price_float*$fee/100;
										$price_float = $price_float + $fee_sum_add;
										$data['b_options']['tickets']['seats'][$d['id_trip']][$seat] = var_export($price_float,true) . ($price_parsed[1] = '' ? '' : ' ' . $price_parsed[1]);
										$fee_sum += $fee_sum_add;
									}

									$sum += $price_float;
								}
								if (is_array($trips[$d['id_trip']]['t_options']['seats_sold'][$seat]))
								{
									$trips[$d['id_trip']]['t_options']['seats_sold'][$seat][] = $_SESSION[UID];
								}
								else
								{
									$trips[$d['id_trip']]['t_options']['seats_sold'][$seat] =  array(
										$trips[$d['id_trip']]['t_options']['seats_sold'][$seat],
										$_SESSION[UID]
									);
								}
							}
							else
							{
								return $this->showError('404', 'error', "busy seat: $seat");
							}
						}
					}
					break;
				}
				$b_options_seats = $data['b_options']['tickets']['seats'];
				$data['b_options']['tickets']['seats'] = array();
				$s_ticket_prop_pc = array();
				foreach($b_options_seats as $id_trip=>$seats)
				{
					foreach($seats as $seat=>$val)
					{
						$data['b_options']['tickets']['seats'][$id_trip][$fix_seats[$id_trip][$seat]] = $val;
						if (isset($pc_seat[$data['b_options']['tickets']['t_id'][$id_trip]][$fix_seats[$id_trip][$seat]]))
						{
							$s_ticket_prop_pc[] = "('7', '{$fix_seats[$id_trip][$seat]}', '$id_trip', '$pc_id')";
						}
					}
				}
				$filtered_data['sum'] = var_export($sum,true);	
				if (empty($seat_currency))
				{
					$seat_currency = DEFAULT_CURRENCY;
				}
				$filtered_data['currency'] = $seat_currency;
			}

			if (empty($filtered_data['from']) 
				&& (!isset($filtered_data['from_lat']) || !isset($filtered_data['from_lng'])))
			{
				return $this->showError('404', 'error', 'empty start address');
			}
			$max_waiting_time = $this->constant['waiting_interval'];
			if (empty($filtered_data['datetime_start_plan']))
			{
				return $this->showError('404', 'error', 'empty booking datetime');
			}
			else
			{
 
				switch ($filtered_data['datetime_start_plan']) {
					case 'any':
						$datetime_start_plan = '0000-00-00 00:00:00';
						$max_waiting_time = $this->constant['waiting_interval_any'];

						break;
					case 'now':
						preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
						$datetime_start_plan = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);

						break;
					default:
						preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['datetime_start_plan'],$parsed_datetime);

						if (empty($parsed_datetime))
						{
							return $this->showError('404', 'error', 'wrong booking datetime');
						}
						else
						{
							preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
							$datetime_start_plan = $parsed_datetime[1] . " " . $parsed_datetime[2];
							if ($datetime_start_plan == '0000-00-00 00:00:00')
							{
								$max_waiting_time = $this->constant['waiting_interval_any'];
							}
							else
							{
								$datetime_start_plan = gmdate("Y-m-d H:i:s",strtotime($datetime_start_plan .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
							}
						}
				}
				$add_s .= ",`datetime_start_plan` = '" . $datetime_start_plan . "'";
				unset($filtered_data['datetime_start_plan']);
			}
			if (empty($filtered_data['id_payment_method']))
			{
				return $this->showError('404', 'error', 'empty payment way');
			}
			elseif ($filtered_data['id_payment_method'] == 4)
			{
				if ($this->id_role != 4) return $this->showError('404', 'error', 'forbidden payment way');
			}

			if (!empty($affected_keys['b_options']))
			{
				if (!empty($this->constant['b_options_valid_keys']))
				{
					if (!is_array($data['b_options'])) return $this->showError('404', 'error', 'b_options not array');
					$wrong_b_options = array();
					foreach($data['b_options'] as $key => $value)
					{
						if (empty($this->constant['b_options_valid_keys'][$key])) $wrong_b_options[] = $key;
					}
					if (!empty($wrong_b_options)) return $this->showError('404', 'error', 'wrong b_options keys: ' . implode(",", $wrong_b_options));
				}
				$filtered_data['options'] = real_escape_string(json_encode($data['b_options']));
			}		
			if (!empty($affected_keys['b_contact']))
			{
				$filtered_data['contact'] = real_escape_string(json_encode($data['b_contact']));
			}

			if (isset($data['b_services']) && @in_array('5', $data['b_services'])) {
				$code = $this->generateDriverCode();
				$max_waiting_time = $this->constant['waiting_interval_or'];
				$add_s .= ",`is_confirmed` = '0',`code` = '" .$code . "'";
				$filtered_data['car_count'] = 1;
			}
			if (isset($data['b_max_waiting'])) $max_waiting_time = $data['b_max_waiting'];
			$add_s .= ",`max_waiting_datetime` = " . ($datetime_start_plan !== '0000-00-00 00:00:00' ?  "'" . $datetime_start_plan . "'" : "now()") . " + INTERVAL '" . $max_waiting_time . "' SECOND";

			if (isset($filtered_data['countries_list_from']))
			{
				if (empty($country[$filtered_data['countries_list_from']])) return $this->showError('404', 'error', 'wrong countries_list_start');
			}
			else
			{
				if (!empty(DEFAULT_COUNTRY)) $filtered_data['countries_list_from'] = DEFAULT_COUNTRY;
			}
			if (isset($filtered_data['countries_list_to']))
			{
				if (empty($country[$filtered_data['countries_list_to']])) return $this->showError('404', 'error', 'wrong countries_list_destination');
			}
			else
			{
				if (!empty(DEFAULT_COUNTRY)) $filtered_data['countries_list_to'] = DEFAULT_COUNTRY;
			}
			if (isset($filtered_data['countries_list_from']) && isset($filtered_data['countries_list_to']) && isset($filtered_data['region_from']) && isset($filtered_data['region_to']) && isset($filtered_data['city_from']) && isset($filtered_data['city_to']))
			{
				$countries_list = $country;
				if (empty($region[$filtered_data['region_from']])) return $this->showError('404', 'error', 'wrong region_start');
				if (empty($region[$filtered_data['region_to']])) return $this->showError('404', 'error', 'wrong region_destination');
				if (empty($city[$filtered_data['city_from']])) return $this->showError('404', 'error', 'wrong city_start');
				if (empty($city[$filtered_data['city_to']])) return $this->showError('404', 'error', 'wrong city_destination');
				$location_class = "";
				$location_class_all = array();
				$alias = array('countries_list'=>true,'region'=>true,'city'=>true);
				foreach($order_location as $id=>$loc)
				{
					if (!empty($loc['alias']))
					{
						if (isset($alias[$loc['alias']]))
						{
							if ($filtered_data["{$loc['alias']}_from"] != $filtered_data["{$loc['alias']}_to"]) break;
						}
						else
						{
							continue;
						}
					}
					elseif (!empty($loc['upper']))
					{
						continue;
					}
					$location_class = $id;
					$location_class_all[$id] = true;
				}
				if (empty($location_class)) return $this->showError('404', 'error', 'failed to determine b_location_class');
				if (isset($filtered_data['id_order_location']))
				{
					if ($filtered_data['id_order_location'] != $location_class) return $this->showError('404', 'error', 'wrong b_location_class');
				}
				else
				{
					$filtered_data['id_order_location'] = $location_class;
				}
				if (isset($filtered_data['id_car_class']))
				{
					$check_license = false;
					$valid_car_class = false;
					foreach($this->car_class as $cc_id=>$car_class)
					{
						if (!empty($car_class['booking_location_classes']))
						{
							$check_license = true;
							foreach($car_class['booking_location_classes'] as $id)
							{
								if (isset($location_class_all[$id]))
								{
									if ($filtered_data['id_car_class'] == $cc_id)
									{
										$valid_car_class = true;
										break 2;
									}
								}
							}
						}
					}
					if ($check_license === true && $valid_car_class === false)
					{
						return $this->showError('404', 'error', 'wrong b_car_class for b_location_class');
					}
				}	
			}

			if (empty($filtered_data['from']))
			{
				$place_from = get_place($filtered_data['from_lat'],$filtered_data['from_lng']);
			}
			else
			{
				if (!isset($filtered_data['from_lat']) || !isset($filtered_data['from_lng']))
				{
					list($filtered_data['from_lat'],$filtered_data['from_lng']) = address_to_lat_lng($filtered_data['from']);
				}
				$place_from = get_place($filtered_data['from_lat'],$filtered_data['from_lng']);
			}

			if (!isset($filtered_data['to_lat']) || !isset($filtered_data['to_lng']))
			{
				if (!empty($filtered_data['to']))
				{
					list($filtered_data['to_lat'],$filtered_data['to_lng']) = address_to_lat_lng($filtered_data['to']);
					$place_to = get_place($filtered_data['to_lat'],$filtered_data['to_lng']);
				}		
			}
			else
			{
				$place_to = get_place($filtered_data['to_lat'],$filtered_data['to_lng']);
			}

			if (!empty($place_from) && !empty($place_to) && $place_from['id'] == $place_to['id'])
			{
				$distance_estimate = get_distance($place_from['id'],lat_lng_to_square($filtered_data['from_lat'],$filtered_data['from_lng'],$place_from),lat_lng_to_square($filtered_data['to_lat'],$filtered_data['to_lng'],$place_from));
				if (gettype($distance_estimate) === 'double') 
				{
					$filtered_data['distance_estimate'] = $distance_estimate;					
				}
			}

			if (isset($filtered_data['car_count'])) {
				if (empty($filtered_data['car_count'])) 
				{
					$filtered_data['car_count'] = 1;
				}
				else
				{
					$filtered_data['car_count'] = (int)$filtered_data['car_count'];
				}
			}

			if (isset($filtered_data['id_car_class']) && empty($this->car_class[$filtered_data['id_car_class']]))
			{
				return $this->showError('404', 'error', 'wrong car class');
			}

			if ($datetime_start_plan !== '0000-00-00 00:00:00' && (!empty($place_from) || !empty($place_to)))
			{			
				 if (!empty($place_from)) 
				 {
					$timezone = $place_from['timezone'];
				 }
				 elseif (!empty($place_to))
				 {
					$timezone = $place_to['timezone'];
				 }
				
				preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',$timezone,$parsed_time_zone);
				$h = gmdate("H:i",strtotime($datetime_start_plan . MYSQL_TIME_ZONE) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
				$extra_charge_for_night_time = 1;
				$filtered_data['night_time'] = 0;
				if ($this->constant['the_end_of_the_night_time'] > $this->constant['start_of_night_time'])
				{
					if ($h >= $this->constant['start_of_night_time'] && $h < $this->constant['the_end_of_the_night_time']) 
					{

						$extra_charge_for_night_time = $this->constant['extra_charge_for_night_time'];
						$filtered_data['night_time'] = 1;

					}
				}
				else
				{
					if ($h >= $this->constant['start_of_night_time'] || $h < $this->constant['the_end_of_the_night_time']) 
					{
						$extra_charge_for_night_time = $this->constant['extra_charge_for_night_time'];
						$filtered_data['night_time'] = 1;
					}
				}

				if (isset($filtered_data['distance_estimate']) && isset($filtered_data['id_car_class']))
				{
					$courier_call_rate = (float)$this->car_class[$filtered_data['id_car_class']]['courier_call_rate'];
					$courier_fare_per_1_km = (float)$this->car_class[$filtered_data['id_car_class']]['courier_fare_per_1_km'];			
					
					$filtered_data['price_estimate'] = (isset($filtered_data['car_count']) ? $filtered_data['car_count'] : 1)*$extra_charge_for_night_time*($courier_call_rate + $courier_fare_per_1_km*round($this->constant['distance_coefficient']*$filtered_data['distance_estimate']/1000,2));

				}
			}

			$s = array();
			foreach ($filtered_data as $key => $value)
			{
				if ($value !== NULL) {
					$s[] = "`" . $key . "` = '" . $value . "'";
				}
			}
	
			if (!empty($data['b_only_offer']))
			{
				$add_status = "`id_order_status` = '6', `offer_datetime` = now()";
			}
			elseif (empty($this->constant['d_s_bot']) || $datetime_start_plan === '0000-00-00 00:00:00')
			{
				$add_status = "`id_order_status` = '1', `process_datetime` = now()";
			}
			else
			{
				$add_status = "`id_order_status` = '5', `pending_datetime` = now()";
			}

			$s = "INSERT INTO `order`
				SET 
					" . implode(",\n", $s) .",
					`client` = '" . $client . "',
					`last_edit_datetime` = now(),
					`last_edit_user` = '" . $_SESSION[UID] . "',
					`create_datetime` = now(),
					`create_user` = '" . $_SESSION[UID] . "'
					" . $add_s . ",
					" . $add_status . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database insert failed');

			$id_order = insert_id();
			$out = array(						
						'affected_fields' 	=> 	$affected_fields,
						'forbidden_fields'	=>	$forbidden_fields
					);
			$out['b_id'] = $id_order;
			if (isset($code)) $out['b_driver_code'] = $code;

			$s = "INSERT INTO `order_waiting_time`
				SET 
					`id_order` = '" . $id_order . "',
					`interval` = '" . $max_waiting_time . "',
					`datetime` = now(),
					`index` = '1'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'b_max_waiting insert failed');

			if (!empty($data['b_comments']))
			{
				if (is_array($data['b_comments'])) {
					$s = array();
					foreach ($data['b_comments'] as $comment)
					{
						$s[] = "('" . $id_order. "', '" . $comment . "')";
					}
					$s = "INSERT INTO `order_comment_items` (`id_order`,`id_order_comment`) VALUES " 
						 . implode(",", $s);
					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'comments insert failed');
				}
				else
				{
					$wrong_data_fields[] = 'b_comments';
				}
			}

			if (!empty($data['b_services']))
			{
				if (is_array($data['b_services'])) {
					$s = array();
					foreach ($data['b_services'] as $service)
					{
						$s[] = "('" . $id_order. "', '" . $service . "')";
					}
					$s = "INSERT INTO `order_service` (`id_order`,`id_service`) VALUES " . implode(",", $s);
					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'services insert failed');
				}
				else
				{
					$wrong_data_fields[] = 'b_services';
				}
			}

			if (DEFAULT_PROFILE == 'stadium')
			{
				foreach($trips as $id_trip=>$arr)
				{
					if ($arr['outer_ticket'] === false)
					{
						$t_options = $arr['t_options'];
						foreach($trips_seats[$id_trip] as $seat=>$val)
						{
							$t_options['seats_sold'][$seat][] = $id_order;
						}
						$looking_for_clients = 0;
						foreach($t_options['seats_sold'] as $val)
						{
							if (!is_array($val) || count($val) == 1){ $looking_for_clients = 1; break;}
						}

						$s = "UPDATE `trip`
							SET
								`json` = '" . real_escape_string(json_encode($t_options)) . "',
								" . ($looking_for_clients == 0 ? "`looking_for_clients` = '0'," : "") . "
								`last_edit_datetime` = now(),
								`last_edit_user` = '" .  $_SESSION[UID] . "'
							WHERE
								`id_trip` = '" . $id_trip . "'
							";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'trip ' . $id_trip .': database update failed');
					}
					else
					{
						if ((int)$arr['looking_for_clients'] - count($trips_seats[$id_trip]) == 0)
						{
							$s = "UPDATE `trip`
								SET
									`looking_for_clients` = '0',
									`last_edit_datetime` = now(),
									`last_edit_user` = '" .  $_SESSION[UID] . "'
								WHERE
									`id_trip` = '" . $id_trip . "'
								";

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', 'trip ' . $id_trip .': database update failed');
						}
					}
				}

				if ($arr['outer_ticket'] === true)
				{
					$s = "UPDATE `ticket`
						SET
							`id_order` = '" . $id_order . "'
						WHERE
							" . $sql_where_ticket . "
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'update failed');
				}
		
				if (!empty($booked))
				{			
					$s= "DELETE
						FROM `cart`
						WHERE 
							" . $sql_where . "
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'database delete failed');
				}				 

				if (isset($fee))
				{
					if ($stripe_seat_title_template === '')
					{
						$sum = array(
							array(round($sum-$fee_sum,2), 'Total'),
							array(round($fee_sum,2), 'Fee')
						);
					}
					else
					{
						$line_items[] = array(round($fee_sum,2), 'Fee');
						$sum = $line_items;
					}
				}
				else
				{
					if ($stripe_seat_title_template === '')
					{
						$sum = round($sum,2);
					}
					else
					{
						$sum = $line_items;
					}
				}

				$s = array();
				foreach ($sc_id_arr as $sc_id=>$val)
				{
					$s[] = "('$id_order', '1', '$sc_id')";
				}
				$s = "INSERT INTO `order_prop_items_int_some` (`id_order`,`id_order_prop`,`value`) VALUES " . implode(",", $s);
				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'schedule insert failed');

				if (isset($pc_id))
				{
					$s = "INSERT INTO `order_prop_items_int`
						SET 
							`id_order` = '$id_order',
							`id_order_prop` = '2',
							`value` = '$pc_id'
						";
					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'pc_id insert failed');
				}

				if (!empty($s_ticket_prop_pc))
				{
					$s = "INSERT INTO `ticket_prop_items_int` (`id_ticket_prop`,`id_trip_seat`,`id_trip`,`value`) VALUES " . implode(",", $s_ticket_prop_pc) . " ON DUPLICATE KEY UPDATE `value` = '$pc_id'";
					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'ticket prop insert failed');
				}

				if ($filtered_data['id_payment_method'] == 2)
				{
					if ($this->constant['order_payment'] == 1)
					{
						$payment = get_stripe_link($id_order,$sum,$seat_currency,$this->appUrl,$email);
						if (!empty($payment['error'])) return $this->showError('404', 'error', $payment['error']);
						$out['payment'] = $payment[0];

						$data['b_options']['tickets']['payment'] = $payment[0];
					}
				}

				if (!empty($pc_seat)) $data['b_options']['tickets']['pc_sc_id_seats'] = $pc_seat;

				$s = "UPDATE `order`
						SET
							`options` = '" . real_escape_string(json_encode($data['b_options'])) . "',
							`last_edit_datetime` = now(),
							`last_edit_user` = '" .  $_SESSION[UID] . "',
							`confirm_limit_datetime` = now() + INTERVAL " .  (isset($payment[1]) ? $payment[1] : $stripe_request_duration) . " SECOND
						WHERE
							`id_order` = '" . $id_order . "'
						";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'booking update failed');

			}

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			if (DEFAULT_PROFILE == 'stadium' && $filtered_data['id_payment_method'] == 4)
			{
				$api_use = true;
				$order = $id_order;
				$status = 'succeeded';
				$res = require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_stripe.php');
				if (!empty($res['error'])) return $this->showError('404', 'error', $res['error']);
			}

			if (!empty($wrong_data_fields)) $out['wrong_data_fields'] = $wrong_data_fields;

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		public function selectActiveOrder($fields = 0)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			$sql_order = $sql_order_driver = $sql_c_options = $sql_left_join = $sql_where = '';
						
			$field_flag = array();
			if (!empty($fields))
			{
				$field_arr	= get_field_arr('activeOrder',$this->id_role);
				$bin_arr = get_bin_arr();

				foreach(str_split($fields) as $index => $char)
				{
					$value = get_0_64($char);
					if (empty($value)) continue;
					foreach($bin_arr as $bin_i)
					{
						if ($value & $bin_i) 
						{
							if (isset($field_arr[$index][$bin_i]))
							{
								$field_flag[$field_arr[$index][$bin_i]] = true;
							}
						}
					}
				}
			}
			if (!empty($field_flag['b_offers']))
			{
				$sql_order .= "(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',
								`id_user`,
								`create_datetime`
							)
						SEPARATOR ';') 
					 FROM `order_driver_select`
					 WHERE `order_driver_select`.`id_order` = `order`.`id_order`
					 ORDER BY `order_driver_select`.`id_user`
					) as b_offers,";
			}
			if (!empty($field_flag['b_offer']))
			{
				$sql_order .= "(SELECT
						COUNT(`id_user`)
					 FROM `order_driver_select`
					 WHERE 
						`order_driver_select`.`id_order` = `order`.`id_order` AND
						`order_driver_select`.`id_user` = '" . $_SESSION[UID] . "'
					 LIMIT 1
					) as b_offer,";
			}
			if (DEFAULT_PROFILE == 'stadium')
			{
				$sql_order .= "(SELECT
							GROUP_CONCAT(CONCAT_WS(0x00,`id_seat`,`id_trip`,`id_trip_seat`) SEPARATOR 0x01)
						 FROM
							`ticket`
						 WHERE `ticket`.`id_order` = `order`.`id_order`
						) as fix_seats,";
			}

			if ($this->id_role == 1 || $this->id_role == 5)
			{
				$s = "SELECT
						`order`.`id_order` as b_id,
						" . $sql_order . "
						`order`.`client` as u_id,
						`order`.`from` as b_start_address,
						`order`.`from_lat` as b_start_latitude,
						`order`.`from_lng` as b_start_longitude,
						`order`.`to` as b_destination_address,
						`order`.`to_lat` as b_destination_latitude,
						`order`.`to_lng` as b_destination_longitude,
						`order`.`datetime_start_plan` as b_start_datetime,
						`order`.`comment` as b_custom_comment,
						`order`.`flight_number` as b_flight_number,
						`order`.`terminal` as b_terminal,
						`order`.`passenger_count` as b_passengers_count,
						`order`.`luggage_count` as b_luggage_count,
						`order`.`placard` as b_placard,
						`order`.`id_car_class` as b_car_class,
						`order`.`id_order_status` as b_state,
						`order`.`create_datetime` as b_created,
						`order`.`is_confirmed` as b_confirm_state,
						`order`.`car_count` as b_cars_count,
						`order`.`approve_datetime` as b_approved,
						`order`.`max_waiting_datetime` as b_max_waiting,
						`order`.`estimated_waiting_datetime` as b_estimate_waiting,
						`order`.`code` as b_driver_code,
						`order`.`options` as b_options,
						`order`.`contact` as b_contact,
						`order`.`id_order_location` as b_location_class,
						`order`.`distance_estimate` as b_distance_estimate,
						`order`.`price_estimate` as b_price_estimate,
						`order`.`currency` as b_currency,
						`order`.`night_time` as b_night,
						IF(`order_driver`.`id_order` IS NULL,NULL,
							GROUP_CONCAT(IF(`order_driver`.`id_order_driver_status` = 2,NULL,
								CONCAT_WS(0x00,
									`order_driver`.`id_user`,
									`order_driver`.`id_car`,
									`order_driver`.`id_order_driver_status`,
									IFNULL(`users_location`.`lat`,''),
									IFNULL(`users_location`.`lng`,''),
									IFNULL(`users_location`.`datetime`,''),
									`order_driver`.`candidacy_datetime`,
									`order_driver`.`appoint_datetime`,
									`order_driver`.`arrive_datetime`,
									`order_driver`.`start_datetime`,
									`order_driver`.`options`
								)
							) SEPARATOR 0x01)
						) as drivers,
						(SELECT
							GROUP_CONCAT(`order_comment_items`.`id_order_comment` SEPARATOR ',')
						 FROM `order_comment_items`
						 WHERE `order_comment_items`.`id_order` = `order`.`id_order`
						) as b_comments,
						(SELECT
							GROUP_CONCAT(`order_service`.`id_service` SEPARATOR ',')
						 FROM `order_service`
						 WHERE `order_service`.`id_order` = `order`.`id_order`
						) as b_services
					FROM `order` 
					LEFT JOIN `order_driver` USING (`id_order`)
					LEFT JOIN `users_location` ON `users_location`.`id_user` = `order_driver`.`id_user`
					WHERE	
						`order`.`client` = '" . $_SESSION[UID] . "' AND `order`.`id_order_status` in (1,2,5,6)
					GROUP BY `order`.`id_order`
					ORDER BY `order`.`last_edit_datetime` DESC
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";
			}
			else
			{
				$s = "SELECT
						`order`.`id_order` as b_id,
						" . $sql_order . "
						`order`.`client` as u_id,
						`order`.`from` as b_start_address,
						`order`.`from_lat` as b_start_latitude,
						`order`.`from_lng` as b_start_longitude,
						`order`.`to` as b_destination_address,
						`order`.`to_lat` as b_destination_latitude,
						`order`.`to_lng` as b_destination_longitude,
						`order`.`datetime_start_plan` as b_start_datetime,
						`order`.`comment` as b_custom_comment,
						`order`.`flight_number` as b_flight_number,
						`order`.`terminal` as b_terminal,
						`order`.`passenger_count` as b_passengers_count,
						`order`.`luggage_count` as b_luggage_count,
						`order`.`placard` as b_placard,
						`order`.`id_car_class` as b_car_class,
						`order`.`id_order_status` as b_state,
						`order`.`create_datetime` as b_created,
						`order`.`is_confirmed` as b_confirm_state,
						`order`.`car_count` as b_cars_count,
						`order`.`approve_datetime` as b_approved,
						`order`.`max_waiting_datetime` as b_max_waiting,
						`order`.`estimated_waiting_datetime` as b_estimate_waiting,
						`order`.`options` as b_options,
						`order`.`contact` as b_contact,
						`order`.`id_order_location` as b_location_class,
						`order`.`distance_estimate` as b_distance_estimate,
						`order`.`price_estimate` as b_price_estimate,
						`order`.`currency` as b_currency,
						`order`.`night_time` as b_night,
						IF(`order_driver`.`id_order` IS NULL,NULL,
							GROUP_CONCAT(
								CONCAT_WS(0x00,
									`order_driver`.`id_user`,
									`order_driver`.`id_car`,
									`order_driver`.`id_order_driver_status`,
									IFNULL(`users_location`.`lat`,''),
									IFNULL(`users_location`.`lng`,''),
									IFNULL(`users_location`.`datetime`,''),
									`order_driver`.`candidacy_datetime`,
									`order_driver`.`appoint_datetime`,
									`order_driver`.`arrive_datetime`,
									`order_driver`.`start_datetime`,
									IF(`order_driver`.`id_user` = '" . $_SESSION[UID] . "',
									`order_driver`.`options`,0x02)
								)
							SEPARATOR 0x01) 
						) as drivers,
						(SELECT
							GROUP_CONCAT(`order_comment_items`.`id_order_comment` SEPARATOR ',')
						 FROM `order_comment_items`
						 WHERE `order_comment_items`.`id_order` = `order`.`id_order`
						) as b_comments,
						(SELECT
							GROUP_CONCAT(`order_service`.`id_service` SEPARATOR ',')
						 FROM `order_service`
						 WHERE `order_service`.`id_order` = `order`.`id_order`
						) as b_services
					FROM `order` 
					LEFT JOIN `order_driver` as od USING (`id_order`)
					LEFT JOIN `order_driver` USING (`id_order`)
					LEFT JOIN `users_location` ON `users_location`.`id_user` = `order_driver`.`id_user`
					WHERE
						((`order`.`id_order_status` in (1,6) AND od.`id_user` = '" . $_SESSION[UID] . "' AND
						 ((od.`id_order_driver_status` = '1' AND 
						 `order`.`max_waiting_datetime` > now() AND
						 (SELECT
								COUNT(`order_driver_attempt`.`id_order`)

							 FROM `order_driver_attempt`
							 WHERE 
								`order_driver_attempt`.`id_order` = `order`.`id_order` AND 
								`order_driver_attempt`.`id_user`= '" . $_SESSION[UID] . "'
						 ) < " . $this->constant['driver_code_attempt_count_max'] . "
						 ) OR od.`id_order_driver_status` NOT in (1,2))) OR
						(`order`.`id_order_status` = '2' AND od.`id_user` = '" . $_SESSION[UID] . "' AND
						 od.`id_order_driver_status` NOT in (1,2))) AND
						(`order_driver`.`id_user` = '" . $_SESSION[UID] . "' OR 
						`order_driver`.`id_order_driver_status` NOT in (1,2))
					GROUP BY `order`.`id_order`
					ORDER BY `order`.`last_edit_datetime` DESC
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";
			}

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('booking' => array());
			while ($d = fetch_assoc($q))
			{
				if (!empty($d['b_offers']))
				{
					$d['b_offers'] = explode(';',$d['b_offers']);
					foreach ($d['b_offers'] as $key=>$value)
					{
						$d['b_offers'][$key] = array();
						list(
							$d['b_offers'][$key]['u_id'],
							$d['b_offers'][$key]['created']
							)= explode('|',$value);
						add_time_zone($d['b_offers'][$key]['created']);
					}
				}

				if (isset($d['b_offer']))
				{
					$d['b_offer'] = (int)$d['b_offer'];
				}
			
				if (!empty($d['drivers']))
				{
					$d['drivers'] = explode(chr(1),$d['drivers']);


					foreach ($d['drivers'] as $key=>$value)
					{
						$d['drivers'][$key] = array();
						list(
							$d['drivers'][$key]['u_id'],
							$d['drivers'][$key]['c_id'],
							$d['drivers'][$key]['c_state'],
							$d['drivers'][$key]['c_latitude'],
							$d['drivers'][$key]['c_longitude'],
							$d['drivers'][$key]['l_datetime'],
							$d['drivers'][$key]['c_becomed_candidate'],
							$d['drivers'][$key]['c_appointed'],
							$d['drivers'][$key]['c_arrived'],
							$d['drivers'][$key]['c_started'],
							$d['drivers'][$key]['c_options']
							)= explode(chr(0),$value);

						if ($d['drivers'][$key]['c_options'] === chr(2))
						{
							unset($d['drivers'][$key]['c_options']);
						}
						if ($d['drivers'][$key]['c_arrived'] == '0000-00-00 00:00:00')
						{
							$d['drivers'][$key]['c_arrive_state'] = 0;
						}
						else
						{
							$d['drivers'][$key]['c_arrive_state'] = 1;
						}

						add_time_zone($d['drivers'][$key]['l_datetime']);						
						add_time_zone($d['drivers'][$key]['c_becomed_candidate']);
						add_time_zone($d['drivers'][$key]['c_appointed']);
						add_time_zone($d['drivers'][$key]['c_arrived']);
						add_time_zone($d['drivers'][$key]['c_started']);
						if (!empty($d['drivers'][$key]['c_options'])) $d['drivers'][$key]['c_options'] = json_decode($d['drivers'][$key]['c_options'],true);
					}


				}


				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);
				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);
				

				if ($d['b_max_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_max_waiting'] = NULL;
				}
				else
				{
					$d['b_max_waiting'] = strtotime($d['b_max_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}

				if ($d['b_estimate_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_estimate_waiting'] = NULL;
				}
				else
				{
					$d['b_estimate_waiting'] = strtotime($d['b_estimate_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}


				$d['b_options'] = json_decode($d['b_options'],true);
				$d['b_contact'] = json_decode($d['b_contact'],true);
				

				if (isset($d['b_services']) && @in_array('5', $d['b_services'])) {$d['b_voting'] = 1;}


				add_time_zone($d['b_start_datetime']);
				add_time_zone($d['b_created']);
				add_time_zone($d['b_approved']);

				$d['b_confirm_state'] = (int)$d['b_confirm_state'];
				if ($d['b_night'] !== NULL) $d['b_night'] = (int)$d['b_night'];

				if (DEFAULT_PROFILE == 'stadium')
				{
					$fix_seats = array();
					if (!empty($d['fix_seats']))
					{
						$fix_seats = explode(chr(1),$d['fix_seats']);
						$d['fix_seats'] = array();
						foreach ($fix_seats as $key=>$value)
						{
							list(
								$id_seat,
								$id_trip,
								$id_trip_seat
								)= explode(chr(0),$value);
							$d['fix_seats'][$id_trip][$id_trip_seat] = $id_seat;
						}
						$fix_seats = $d['fix_seats'];
						unset($d['fix_seats']);
					}
					if (!empty($d['b_options']['tickets']['seats']))
					{
						$b_options_seats = $d['b_options']['tickets']['seats'];
						$d['b_options']['tickets']['seats'] = array();
						foreach($b_options_seats as $id_trip=>$seats)
						{
							if (is_array($seats))
							{
								foreach($seats as $seat=>$val)
								{
									$d['b_options']['tickets']['seats'][$id_trip][isset($fix_seats[$id_trip][$seat]) ? $fix_seats[$id_trip][$seat] : $seat] = $val;
								}
							}
							else
							{
								$d['b_options']['tickets']['seats'] = $seats;
							}
						}
					}
				}

				$out['booking'][$d['b_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['booking'] =  array_values($out['booking']);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function selectProcessingOrder($fields = 0, $filter = NULL, $order_location = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 2 && $this->id_role != 4)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			$sql_order = $sql_drivers = $sql_order_driver = $sql_c_options = $sql_payment = $sql_left_join = $sql_where_order = $sql_where = '';
		
			$field_flag = array();
			if (!empty($fields))
			{
				$field_arr	= get_field_arr('processingOrder',$this->id_role);
				$bin_arr = get_bin_arr();

				foreach(str_split($fields) as $index => $char)
				{
					$value = get_0_64($char);
					if (empty($value)) continue;
					foreach($bin_arr as $bin_i)
					{
						if ($value & $bin_i) 
						{
							if (isset($field_arr[$index][$bin_i]))
							{
								$field_flag[$field_arr[$index][$bin_i]] = true;
							}
						}
					}
				}
			}
			if (!empty($field_flag['b_offers']))
			{
				$sql_order .= "(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',
								`id_user`,
								`create_datetime`
							)
						SEPARATOR ';') 
					 FROM `order_driver_select`
					 WHERE `order_driver_select`.`id_order` = `order`.`id_order`
					 ORDER BY `order_driver_select`.`id_user`
					) as b_offers,";
			}
			if (!empty($field_flag['b_offer']))
			{
				$sql_order .= "(SELECT
						COUNT(`id_user`)
					 FROM `order_driver_select`
					 WHERE 
						`order_driver_select`.`id_order` = `order`.`id_order` AND
						`order_driver_select`.`id_user` = '" . $_SESSION[UID] . "'
					 LIMIT 1
					) as b_offer,";
			}

			if ($this->id_role == 4)
			{
				$sql_payment .= "					`order`.`id_payment_method` as b_payment_way,
					`order`.`id_payment_card` as b_payment_card,
					`order`.`code` as b_driver_code,";
				$sql_drivers .= "IF(`order_driver`.`id_order` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS('|',
								`order_driver`.`id_user`,
								`order_driver`.`id_car`,
								`order_driver`.`id_order_driver_status`,
								`order_driver`.`arrive_datetime`
							)
						SEPARATOR ';') 
					) as drivers,";
				$sql_where_order .= "`order`.`id_order_status`in (1,6)";
			} 
			elseif ($this->id_role == 2)
			{
				$sql_drivers .= "IF(`order_driver`.`id_order` IS NULL,NULL,
						GROUP_CONCAT(IF(`order_driver`.`id_order_driver_status` in (1,2),NULL,
							CONCAT_WS('|',
								`order_driver`.`id_user`,
								`order_driver`.`id_car`,
								`order_driver`.`id_order_driver_status`,
								`order_driver`.`arrive_datetime`
							)
						) SEPARATOR ';')
					) as drivers,";
				$sql_left_join .= "
					LEFT JOIN (
							SELECT
								`id_order`,
								`id_user`	
							FROM
								`order_driver`
							WHERE
								`id_user` = '" . $_SESSION[UID] . "'
						) od USING (`id_order`)";
				$sql_where_order .= "(`order`.`id_order_status` = '1' OR (`order`.`id_order_status` = '6' AND (SELECT
							`order_driver_select`.`cancel`
						FROM `order_driver_select`
						WHERE 
							`order_driver_select`.`id_order` = `order`.`id_order` AND 
							`order_driver_select`.`id_user` = '" . $_SESSION[UID] . "'
					) = 0))";
				$sql_where .= " AND od.`id_user` IS NULL AND
					(SELECT
							COUNT(`order_driver_attempt`.`id_order`)
						FROM `order_driver_attempt`
						WHERE 
							`order_driver_attempt`.`id_order` = `order`.`id_order` AND 
							`order_driver_attempt`.`id_user` = '" . $_SESSION[UID] . "'
					) < " . $this->constant['driver_code_attempt_count_max'] . " AND
					`order`.`client` != '" . $_SESSION[UID] . "'";
			}
			$sql_distance = "";
			$sql_group = "GROUP BY `order`.`id_order`";
			$sql_having = "";
			$sql_order_by = "ORDER BY `order`.`last_edit_datetime` DESC";
			$limit_offset = $this->limit_offset;
			$limit_row_count = $this->limit_row_count;
			$sql_limit = "LIMIT " . $limit_offset . ", " . $limit_row_count;
			$union = false;
			if (isset($filter) && $this->id_role == 2)
			{
				$s = "SELECT 	
						`users`.`id_user`,
						`users_location`.`lat`,
						`users_location`.`lng`,
						`car`.`id_car_class`,
						(SELECT
							GROUP_CONCAT(`users_order_comment`.`id_order_comment` SEPARATOR ',')
						 FROM `users_order_comment`
						 WHERE `users_order_comment`.`id_user` = `users`.`id_user`
						 ORDER BY `users_order_comment`.`id_order_comment`
						) as b_comments,
						(SELECT
							GROUP_CONCAT(`users_service`.`id_service` SEPARATOR ',')
						 FROM `users_service`
						 WHERE `users_service`.`id_user` = `users`.`id_user`
						 ORDER BY `users_service`.`id_service`
						) as b_services,
						(SELECT
							GROUP_CONCAT(`users_order_location`.`id_order_location` SEPARATOR ',')
						 FROM `users_order_location`
						 WHERE `users_order_location`.`id_user` = `users`.`id_user`
						) as b_location_classes,						
						IF(`taxi_license`.`id_car` IS NULL,NULL,
							GROUP_CONCAT(IF(`taxi_license`.`active` = '1' AND `taxi_license_order_location`.`id_order_location` IS NOT NULL,
								CONCAT_WS('|',
									`taxi_license_order_location`.`id_order_location`,
									`taxi_license_order_location`.`location_table_column_value`
								),
							NULL) SEPARATOR ';')
						) as license
					FROM `users`
					LEFT JOIN `users_location` USING (`id_user`)
					LEFT JOIN `car_users` ON `car_users`.`id_user` = `users`.`id_user`
					LEFT JOIN `car` ON `car`.`id_car` = `car_users`.`id_car`				
					LEFT JOIN `taxi_license` ON `taxi_license`.`id_car` = `car`.`id_car`	
					LEFT JOIN `taxi_license_order_location` ON `taxi_license_order_location`.`id_taxi_license` = `taxi_license`.`id_taxi_license`
					WHERE
						`users`.`id_user` = " . $_SESSION[UID]. " AND `car_users`.`used` = '1'
					GROUP BY `users`.`id_user`
					LIMIT 1
					";				

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'user select failed');
				$d = fetch_assoc($q);
				if (empty($d['id_user'])) return $this->showError('404', 'error', 'used car not found');
				if (empty($d['b_location_classes'])) return $this->showError('404', 'error', 'empty driver location classes');
				$license = array();
				if (!empty($d['license']))
				{
					$d['license'] = explode(';',$d['license']);
					foreach ($d['license'] as $key=>$value)
					{
						$d['license'][$key] = array();
						list(
							$d['license'][$key]['id_order_location'],
							$d['license'][$key]['location_table_column_value']
							)= explode('|',$value);
					}
					$license = $d['license'];
				}
				$sql_where .= " AND (`order`.`id_car_class` IS NULL" . (empty($d['id_car_class']) ? "" : " OR `order`.`id_car_class` = '" . $d['id_car_class'] . "'") . ") AND `order`.`id_order_location` in (" . $d['b_location_classes'] . ")";
				$sql_having = "HAVING (b_comments IS NULL" . (empty($d['b_comments']) ? "" : " OR '" . $d['b_comments'] . "' RLIKE CONCAT_WS('','(^|,)',REPLACE(b_comments,',',',([0-9],)*'),'(,|$)')") . ") AND (b_services IS NULL" . (empty($d['b_services']) ? "" : " OR '" . $d['b_services'] . "' RLIKE CONCAT_WS('','(^|,)',REPLACE(b_services,',',',([0-9],)*'),'(,|$)')") . ")";
				if (isset($d['lat']) && isset($d['lng']))
				{
					$union = true;
					$r_earth = 6371000; //м
					$lat_5km_in_degrees = 5000*180/$r_earth/pi();
					$lng_5km_in_degrees = 5000*180/$r_earth/pi()/cos(pi()/180*$d['lat']);
					$sql_where_union_0 = " AND `order`.`from_lat` AND `order`.`from_lng` AND `order`.`from_lat` < '" . $d['lat'] . "' + '" . $lat_5km_in_degrees . "' AND `order`.`from_lat` > '" . $d['lat'] . "' - '" . $lat_5km_in_degrees . "' AND `order`.`from_lng` < '" . $d['lng'] . "' + '" . $lng_5km_in_degrees . "' AND `order`.`from_lng` > '" . $d['lng'] . "' - '" . $lng_5km_in_degrees . "'";
					$lat_15km_in_degrees = $lat_5km_in_degrees*3;
					$lng_15km_in_degrees = $lng_5km_in_degrees*3;
					$sql_where_union_1 = " AND `order`.`from_lat` AND `order`.`from_lng` AND (((`order`.`from_lat` >= '" . $d['lat'] . "' + '" . $lat_5km_in_degrees . "' AND `order`.`from_lat` < '" . $d['lat'] . "' + '" . $lat_15km_in_degrees . "') OR (`order`.`from_lat` <= '" . $d['lat'] . "' - '" . $lat_5km_in_degrees . "' AND `order`.`from_lat` > '" . $d['lat'] . "' - '" . $lat_15km_in_degrees . "')) OR ((`order`.`from_lng` >= '" . $d['lng'] . "' + '" . $lng_5km_in_degrees . "' AND `order`.`from_lng` < '" . $d['lng'] . "' + '" . $lng_15km_in_degrees . "') OR (`order`.`from_lng` <= '" . $d['lng'] . "' - '" . $lng_5km_in_degrees . "' AND `order`.`from_lng` > '" . $d['lng'] . "' - '" . $lng_15km_in_degrees . "')))";
					$sql_where_union_2 = " AND `order`.`from_lat` IS NULL OR `order`.`from_lng` IS NULL OR ((`order`.`from_lat` >= '" . $d['lat'] . "' + '" . $lat_15km_in_degrees . "' OR `order`.`from_lat` <= '" . $d['lat'] . "' - '" . $lat_15km_in_degrees . "') || (`order`.`from_lng` >= '" . $d['lng'] . "' + '" . $lng_15km_in_degrees . "' OR `order`.`from_lng` <= '" . $d['lng'] . "' - '" . $lng_15km_in_degrees . "'))";
					$sql_distance = ",
					2*'" . $r_earth . "'*ASIN(SQRT(POW(SIN(PI()/360*(`order`.`from_lat` - '" . $d['lat'] . "')),2) + COS(PI()/360*'" . $d['lat'] . "')*COS(PI()/360*`order`.`from_lat`)*POW(SIN(PI()/360*(`order`.`from_lng` - '" . $d['lng'] . "')),2))) as b_co_distance,
					TIMESTAMPDIFF(SECOND,now(),`order`.`max_waiting_datetime`) as b_co_time";
					$sql_having .= " AND b_co_distance <= b_co_time*'" . $this->constant['average_speed'] . "'/3.6";
					$sql_order_by = "ORDER BY `order`.`max_waiting_datetime`";
/*	MAX(ABS())		DEGREES(PI())	180			RADIANS(180)	3.141592653689793	*/	
				}
			}

			$booking = array();
			$s = "SELECT
					`order`.`id_order` as b_id,
					" . $sql_order . "
					`order`.`client` as u_id,
					`order`.`from` as b_start_address,
					`order`.`from_lat` as b_start_latitude,
					`order`.`from_lng` as b_start_longitude,
					`order`.`to` as b_destination_address,
					`order`.`to_lat` as b_destination_latitude,
					`order`.`to_lng` as b_destination_longitude,
					`order`.`datetime_start_plan` as b_start_datetime,
					`order`.`comment` as b_custom_comment,
					`order`.`flight_number` as b_flight_number,
					`order`.`terminal` as b_terminal,
					`order`.`passenger_count` as b_passengers_count,
					`order`.`luggage_count` as b_luggage_count,
					`order`.`placard` as b_placard,
					`order`.`id_car_class` as b_car_class,
					" . $sql_payment . "
					`order`.`id_order_status` as b_state,
					`order`.`create_datetime` as b_created,
					`order`.`is_confirmed` as b_confirm_state,
					`order`.`car_count` as b_cars_count,
					`order`.`approve_datetime` as b_approved,
					`order`.`max_waiting_datetime` as b_max_waiting,
					`order`.`estimated_waiting_datetime` as b_estimate_waiting,
					`order`.`options` as b_options,
					`order`.`id_order_location` as b_location_class,
					`order`.`distance_estimate` as b_distance_estimate,
					`order`.`price_estimate` as b_price_estimate,
					`order`.`currency` as b_currency,	
					`order`.`night_time` as b_night,	
					" . $sql_drivers . "
					(SELECT
						GROUP_CONCAT(`order_comment_items`.`id_order_comment` SEPARATOR ',')
					 FROM `order_comment_items`
					 WHERE `order_comment_items`.`id_order` = `order`.`id_order`
					 ORDER BY `order_comment_items`.`id_order_comment`
					) as b_comments,
					(SELECT
						GROUP_CONCAT(`order_service`.`id_service` SEPARATOR ',')
					 FROM `order_service`
					 WHERE `order_service`.`id_order` = `order`.`id_order`
					 ORDER BY `order_service`.`id_service`
					) as b_services,
					`countries_list_from` as countries_list_start,
					`countries_list_to`	as countries_list_destination,
					`region_from` as region_start,
					`region_to` as region_destination,
					`city_from` as city_start,
					`city_to` as city_destination
					" . $sql_distance . "
				FROM `order`
					" . $sql_left_join . "
					LEFT JOIN `order_driver` USING (`id_order`)	
				WHERE	
					" . $sql_where_order . " AND 
					`order`.`max_waiting_datetime` > now()" . $sql_where;
			
			$check_license = false;
			foreach($this->car_class as $car_class)
			{
				if (!empty($car_class['booking_location_classes']))
				{
					$check_license = true;
				}
			}
			$rows = 0;
			$alias = array('countries_list'=>true,'region'=>true,'city'=>true);
			if ($union === true)
			{
				$lat_car = $d['lat'];
				$lng_car = $d['lng'];
				$place_car = get_place($d['lat'],$d['lng']);
				$ui = 0;
				while ($ui < 3) {
					$i = 0;
					$sql_where_union = "sql_where_union_$ui";
					$sql_where_union = $$sql_where_union;
					while (true) {
						$s_res = "$s$sql_where_union
						$sql_group
						$sql_having
						$sql_order_by
						$sql_limit
						";

						$q = query($s_res);
						if ($q === false) return $this->showError('404', 'error', "$ui.$i select failed");
						if (mysqli_num_rows($q) > 0)
						{
							while ($d = fetch_assoc($q))
							{
								if ($check_license === true)
								{
									if (empty($d['b_car_class']))
									{
										while (true)
										{
											foreach($order_location as $id=>$loc)
											{
												if (!empty($loc['alias']))
												{
													if (isset($alias[$loc['alias']]))
													{
														if ($d["{$loc['alias']}_start"] != $d["{$loc['alias']}_destination"]) break;
													}
													else
													{
														continue;
													}
												}
												elseif (!empty($loc['upper']))
												{
													continue;
												}										
												foreach($license as $lic)
												{
													if ($id == $lic['id_order_location'] && !empty($d[$loc['alias'].'_start']) && $d[$loc['alias'].'_start'] == $lic['location_table_column_value'])
													{
														break 3;
													}
												}
												if ($id == $d['b_location_class']) continue 3;
											}
											continue 2;
										}
									}
									else
									{
										if (empty($this->car_class[$d['b_car_class']]))
										{
											continue;
										}
										if (!empty($this->car_class[$d['b_car_class']]['booking_location_classes'])){
											while (true)
											{
												foreach($this->car_class[$d['b_car_class']]['booking_location_classes'] as $id)
												{
													if (!empty($order_location[$id]))
													{
														$loc = $order_location[$id];
														foreach($license as $lic)
														{
															if ($id == $lic['id_order_location'] && !empty($d[$loc['alias'].'_start']) && $d[$loc['alias'].'_start'] == $lic['location_table_column_value'])
															{
																break 3;
															}
														}
													}
												}
												continue 2;
											}
										}
									}
								}
								if (!empty($place_car))
								{
									if (empty($d['b_start_address']))
									{
										$place_order = get_place($d['b_start_latitude'],$d['b_start_longitude']);
										$lat_order = $d['b_start_latitude'];
										$lng_order = $d['b_start_longitude'];
									}
									else
									{
										if (!isset($d['b_start_latitude']) || !isset($d['b_start_longitude']))
										{
											list($lat_order,$lng_order) = address_to_lat_lng($d['b_start_address']);
										}
										else
										{
											$lat_order = $d['b_start_latitude'];
											$lng_order = $d['b_start_longitude'];
										}
										$place_from = get_place($lat_order,$lng_order);
									}
									if (!empty($place_order) && $place_car['id'] == $place_order['id']){
										$distance = get_distance($place_car['id'],lat_lng_to_square($lat_car,$lng_car,$place_car),lat_lng_to_square($lat_order,$lng_order,$place_order));
										if (gettype($distance) === 'double') 
										{
											if ($distance > $this->constant['average_speed']*$d['b_co_time']/3.6) continue;
											$d['b_co_distance_acc'] = $distance;
										}
									}
								}
								$booking[] = $d;
								$rows++;
								if ($rows = $this->limit_row_count) break 3;
							}
						}
						else
						{
							break;
						}
						$limit_offset += $limit_row_count;
						$limit_row_count += $limit_row_count - $rows;
						$sql_limit = "LIMIT " . $limit_offset . ", " . $limit_row_count;
						$i++;
					}
					$ui++;
				}
			}
			elseif (isset($filter) && $this->id_role == 2 && $check_license === true)
			{
				while (true) {
					$s_res = "$s
					$sql_group 
					$sql_having 
					$sql_order_by
					$sql_limit
					";

					$q = query($s_res);
					if ($q === false) return $this->showError('404', 'error', "$i select failed");
					if (mysqli_num_rows($q) > 0)
					{
						while ($d = fetch_assoc($q))
						{
							if ($check_license === true)
							{
								if (empty($d['b_car_class']))
								{
									while (true)
									{
										foreach($order_location as $id=>$loc)
										{
											if (!empty($loc['alias']))
											{
												if (isset($alias[$loc['alias']]))
												{
													if ($d["{$loc['alias']}_start"] != $d["{$loc['alias']}_destination"]) break;
												}
												else
												{
													continue;
												}
											}
											elseif (!empty($loc['upper']))
											{
												continue;
											}
											foreach($license as $lic)
											{
												if ($id == $lic['id_order_location'] && !empty($d[$loc['alias'].'_start']) && $d[$loc['alias'].'_start'] == $lic['location_table_column_value'])
												{
													break 3;
												}
											}
											if ($id == $d['b_location_class']) continue 3;
										}
										continue 2;
									}
								}
								else
								{
									if (empty($this->car_class[$d['b_car_class']]))
									{
										continue;
									}
									if (!empty($this->car_class[$d['b_car_class']]['booking_location_classes'])){
										while (true)
										{
											foreach($this->car_class[$d['b_car_class']]['booking_location_classes'] as $id)
											{
												if (!empty($order_location[$id]))
												{
													$loc = $order_location[$id];
													foreach($license as $lic)
													{
														if ($id == $lic['id_order_location'] && !empty($d[$loc['alias'].'_start']) && $d[$loc['alias'].'_start'] == $lic['location_table_column_value'])
														{
															break 3;
														}
													}
												}
											}
											continue 2;
										}
									}
								}
							}
							$booking[] = $d;
							$rows++;
							if ($rows = $this->limit_row_count) break 2;
						}
					}
					else
					{
						break;
					}
					$limit_offset += $limit_row_count;
					$limit_row_count += $limit_row_count - $rows;
					$sql_limit = "LIMIT " . $limit_offset . ", " . $limit_row_count;
					$i++;
				}
			}
			else
			{
				$s .= "
					$sql_group 
					$sql_having 
					$sql_order_by
					$sql_limit
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');
				while ($d = fetch_assoc($q))
				{
					$booking[] = $d;
				}
			}

			$out = array('booking' => array());
			foreach($booking as $d)
			{
				if (!empty($d['b_offers']))
				{
					$d['b_offers'] = explode(';',$d['b_offers']);
					foreach ($d['b_offers'] as $key=>$value)
					{
						$d['b_offers'][$key] = array();
						list(
							$d['b_offers'][$key]['u_id'],
							$d['b_offers'][$key]['created']
							)= explode('|',$value);
						add_time_zone($d['b_offers'][$key]['created']);
					}
				}

				if (isset($d['b_offer']))
				{
					$d['b_offer'] = (int)$d['b_offer'];
				}

				if (!empty($d['drivers']))
				{
					$d['drivers'] = explode(';',$d['drivers']);
					foreach ($d['drivers'] as $key=>$value)
					{
						$d['drivers'][$key] = array();
						list(
							$d['drivers'][$key]['u_id'],
							$d['drivers'][$key]['c_id'],
							$d['drivers'][$key]['c_state'],
							$d['drivers'][$key]['c_arrive_state']
							)= explode('|',$value);
						if ($d['drivers'][$key]['c_arrive_state'] == '0000-00-00 00:00:00')
						{
							$d['drivers'][$key]['c_arrive_state'] = 0;
						}
						else
						{
							$d['drivers'][$key]['c_arrive_state'] = 1;
						}
					}
				}
				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);
				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);

				if ($d['b_max_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_max_waiting'] = NULL;
				}
				else
				{
					$d['b_max_waiting'] = strtotime($d['b_max_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}
				if ($d['b_estimate_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_estimate_waiting'] = NULL;
				}
				else
				{
					$d['b_estimate_waiting'] = strtotime($d['b_estimate_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}

				$d['b_options'] = json_decode($d['b_options'],true);

				if (isset($d['b_services']) && @in_array('5', $d['b_services'])) {$d['b_voting'] = 1;}

				add_time_zone($d['b_start_datetime']);
				add_time_zone($d['b_created']);
				add_time_zone($d['b_approved']);

				$d['b_confirm_state'] = (int)$d['b_confirm_state'];
				if ($d['b_night'] !== NULL) $d['b_night'] = (int)$d['b_night'];
	
				$out['booking'][$d['b_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['booking'] =  array_values($out['booking']);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function selectArchiveOrder($fields = 0)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			$sql_order = $sql_order_driver = $sql_c_options = $sql_left_join = $sql_where = '';
						
			$field_flag = array();
			if (!empty($fields))
			{
				$field_arr	= get_field_arr('archiveOrder',$this->id_role);
				$bin_arr = get_bin_arr();

				foreach(str_split($fields) as $index => $char)
				{
					$value = get_0_64($char);
					if (empty($value)) continue;
					foreach($bin_arr as $bin_i)
					{
						if ($value & $bin_i) 
						{
							if (isset($field_arr[$index][$bin_i]))
							{
								$field_flag[$field_arr[$index][$bin_i]] = true;
							}
						}
					}
				}
			}
			if (!empty($field_flag['b_offers']))
			{
				$sql_order .= "(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',
								`id_user`,
								`create_datetime`
							)
						SEPARATOR ';') 
					 FROM `order_driver_select`
					 WHERE `order_driver_select`.`id_order` = `order`.`id_order`
					 ORDER BY `order_driver_select`.`id_user`
					) as b_offers,";
			}
			if (!empty($field_flag['b_offer']))
			{
				$sql_order .= "(SELECT
						COUNT(`id_user`)
					 FROM `order_driver_select`
					 WHERE 
						`order_driver_select`.`id_order` = `order`.`id_order` AND
						`order_driver_select`.`id_user` = '" . $_SESSION[UID] . "'
					 LIMIT 1
					) as b_offer,";
			}
			if (DEFAULT_PROFILE == 'stadium')
			{
				$sql_order .= "(SELECT
							GROUP_CONCAT(CONCAT_WS(0x00,`id_seat`,`id_trip`,`id_trip_seat`) SEPARATOR 0x01)
						 FROM
							`ticket`
						 WHERE `ticket`.`id_order` = `order`.`id_order`
						) as fix_seats,";
			}
		
			if ($this->id_role == 1 || $this->id_role == 5)
			{
				$s = "SELECT
						`order`.`id_order` as b_id,
						" . $sql_order . "
						`order`.`client` as u_id,
						`order`.`from` as b_start_address,
						`order`.`from_lat` as b_start_latitude,
						`order`.`from_lng` as b_start_longitude,
						`order`.`to` as b_destination_address,
						`order`.`to_lat` as b_destination_latitude,
						`order`.`to_lng` as b_destination_longitude,
						`order`.`datetime_start_plan` as b_start_datetime,
						`order`.`comment` as b_custom_comment,
						`order`.`flight_number` as b_flight_number,
						`order`.`terminal` as b_terminal,
						`order`.`passenger_count` as b_passengers_count,
						`order`.`luggage_count` as b_luggage_count,
						`order`.`placard` as b_placard,
						`order`.`id_car_class` as b_car_class,
						`order`.`id_payment_method` as b_payment_way,
						`order`.`id_payment_card` as b_payment_card,
						`order`.`tips` as b_tips,
						`order`.`id_order_status` as b_state,
						`order`.`rating` as b_rating,
						`order`.`create_datetime` as b_created,
						`order`.`is_confirmed` as b_confirm_state,
						`order`.`confirm_limit_datetime` as b_confirmation_limit,
						`order`.`confirm_datetime` as b_confirmation_datetime,
						`order`.`sum` as b_payment_sum,
						`order`.`pay_datetime` as b_payment_datetime,
						`order`.`car_count` as b_cars_count,
						`order`.`cancel_reason` as b_cancel_reason,
						(SELECT
							GROUP_CONCAT(
								CONCAT_WS('|',
									`id_user`,
									`id_order_cancel`
								)
							SEPARATOR ';')
							FROM `order_cancel_items`
							WHERE `order_cancel_items`.`id_order` = `order`.`id_order`
							ORDER BY `id_user`
						) as b_cancel_states,
						`order`.`approve_datetime` as b_approved,
						`order`.`cancel_datetime` as b_canceled,
						`order`.`complete_datetime` as b_completed,
						`order`.`max_waiting_datetime` as b_max_waiting,
						`order`.`estimated_waiting_datetime` as b_estimate_waiting,
						`order`.`code` as b_driver_code,
						`order`.`options` as b_options,
						`order`.`id_order_location` as b_location_class,
						`order`.`distance_estimate` as b_distance_estimate,
						`order`.`price_estimate` as b_price_estimate,
						`order`.`currency` as b_currency,
						`order`.`night_time` as b_night,
						IF(`order_driver`.`id_order` IS NULL,NULL,
							GROUP_CONCAT(
								CONCAT_WS(0x00,
									`order_driver`.`id_user`,
									`order_driver`.`id_car`,
									`order_driver`.`id_order_driver_status`,
									IFNULL(`order_driver`.`cancel_reason`,0x02),
									IFNULL(`order_driver`.`rating`,0x02),
									`order_driver`.`candidacy_datetime`,
									`order_driver`.`appoint_datetime`,
									`order_driver`.`cancel_datetime`,
									`order_driver`.`arrive_datetime`,
									`order_driver`.`start_datetime`,
									`order_driver`.`complete_datetime`,
									IFNULL(`order_driver`.`tips`,0x02),
									`order_driver`.`options`
								)
							SEPARATOR 0x01)
						) as drivers,
						(SELECT
							GROUP_CONCAT(`order_comment_items`.`id_order_comment` SEPARATOR ',')
						 FROM `order_comment_items`
						 WHERE `order_comment_items`.`id_order` = `order`.`id_order`
						) as b_comments,
						(SELECT
							GROUP_CONCAT(`order_service`.`id_service` SEPARATOR ',')
						 FROM `order_service`
						 WHERE `order_service`.`id_order` = `order`.`id_order`
						) as b_services
					FROM `order` 
					LEFT JOIN `order_driver` USING (`id_order`)			
					WHERE	
						`order`.`client` = '" . $_SESSION[UID] . "' AND `order`.`id_order_status` in (3,4)
					GROUP BY `order`.`id_order`
					ORDER BY `order`.`last_edit_datetime` DESC
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";
			}
			else
			{
				$s = "SELECT
						`order`.`id_order` as b_id,
						" . $sql_order . "
						`order`.`client` as u_id,
						`order`.`from` as b_start_address,
						`order`.`from_lat` as b_start_latitude,
						`order`.`from_lng` as b_start_longitude,
						`order`.`to` as b_destination_address,
						`order`.`to_lat` as b_destination_latitude,
						`order`.`to_lng` as b_destination_longitude,
						`order`.`datetime_start_plan` as b_start_datetime,
						`order`.`comment` as b_custom_comment,
						`order`.`flight_number` as b_flight_number,
						`order`.`terminal` as b_terminal,
						`order`.`passenger_count` as b_passengers_count,
						`order`.`luggage_count` as b_luggage_count,
						`order`.`placard` as b_placard,
						`order`.`id_car_class` as b_car_class,
						`order`.`tips` as b_tips,
						`order`.`id_order_status` as b_state,
						`order`.`rating` as b_rating,
						`order`.`create_datetime` as b_created,
						`order`.`is_confirmed` as b_confirm_state,					
						`order`.`car_count` as b_cars_count,
						`order`.`cancel_reason` as b_cancel_reason,
						(SELECT
							GROUP_CONCAT(
								CONCAT_WS('|',
									`id_user`,
									`id_order_cancel`
								)
							SEPARATOR ';')
							FROM `order_cancel_items`
							WHERE `order_cancel_items`.`id_order` = `order`.`id_order`
							ORDER BY `id_user`
						) as b_cancel_states,
						`order`.`approve_datetime` as b_approved,
						`order`.`cancel_datetime` as b_canceled,
						`order`.`complete_datetime` as b_completed,
						`order`.`max_waiting_datetime` as b_max_waiting,
						`order`.`estimated_waiting_datetime` as b_estimate_waiting,
						`order`.`options` as b_options,
						`order`.`id_order_location` as b_location_class,
						`order`.`distance_estimate` as b_distance_estimate,
						`order`.`price_estimate` as b_price_estimate,
						`order`.`currency` as b_currency,
						`order`.`night_time` as b_night,
						IF(`order_driver`.`id_order` IS NULL,NULL,
							GROUP_CONCAT(
								CONCAT_WS(0x00,
									`order_driver`.`id_user`,
									`order_driver`.`id_car`,
									`order_driver`.`id_order_driver_status`,							
									`order_driver`.`id_payment_method`,
									IFNULL(`order_driver`.`id_payment_card`,0x02),
									IFNULL(`order_driver`.`sum`,0x02),
									`order_driver`.`pay_datetime`,
									IFNULL(`order_driver`.`cancel_reason`,0x02),
									IFNULL(`order_driver`.`rating`,0x02),
									`order_driver`.`candidacy_datetime`,
									`order_driver`.`appoint_datetime`,
									`order_driver`.`cancel_datetime`,
									`order_driver`.`arrive_datetime`,
									`order_driver`.`start_datetime`,
									`order_driver`.`complete_datetime`,
									IFNULL(`order_driver`.`tips`,0x02),
									IF(`order_driver`.`id_user` = '" . $_SESSION[UID] . "',
									`order_driver`.`options`,0x02)
								)
							SEPARATOR 0x01) 
						) as drivers,	
						(SELECT
							GROUP_CONCAT(`order_comment_items`.`id_order_comment` SEPARATOR ',')
						 FROM `order_comment_items`
						 WHERE `order_comment_items`.`id_order` = `order`.`id_order`
						) as b_comments,
						(SELECT
							GROUP_CONCAT(`order_service`.`id_service` SEPARATOR ',')
						 FROM `order_service`
						 WHERE `order_service`.`id_order` = `order`.`id_order`
						) as b_services
					FROM `order` 

					LEFT JOIN `order_driver` as od USING (`id_order`)
					LEFT JOIN `order_driver` USING (`id_order`)			
					WHERE
						(`order`.`id_order_status` in (3,4) OR od.`id_order_driver_status` = '2') AND 
						od.`id_user` = '" . $_SESSION[UID] . "' 
					GROUP BY `order`.`id_order`
					ORDER BY `order`.`last_edit_datetime` DESC
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";
			}

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('booking' => array());
			while ($d = fetch_assoc($q))
			{
				if (!empty($d['b_offers']))
				{

					$d['b_offers'] = explode(';',$d['b_offers']);

					foreach ($d['b_offers'] as $key=>$value)
					{
						$d['b_offers'][$key] = array();
						list(
							$d['b_offers'][$key]['u_id'],
							$d['b_offers'][$key]['created']
							)= explode('|',$value);
						add_time_zone($d['b_offers'][$key]['created']);
					}
				}

				if (isset($d['b_offer']))
				{
					$d['b_offer'] = (int)$d['b_offer'];
				}

				if (!empty($d['drivers']))
				{
					if (!empty($d['b_cancel_states']))
					{
						$b_c_s = explode(';',$d['b_cancel_states']);
						$d['b_cancel_states'] = array();
						foreach ($b_c_s as $key=>$value)
						{
							$b_c_s[$key] = array();
							list(
								$b_c_s[$key]['u_id'],
								$b_c_s[$key]['id_order_cancel']
								)= explode('|',$value);
							$d['b_cancel_states'][$b_c_s[$key]['u_id']][] = $b_c_s[$key]['id_order_cancel'];
						}
					}

					$d['drivers'] = explode(chr(1),$d['drivers']);
					foreach ($d['drivers'] as $key=>$value)
					{
						$d['drivers'][$key] = array();
						if ($this->id_role == 1 || $this->id_role == 5)
						{


							list(
								$d['drivers'][$key]['u_id'],
								$d['drivers'][$key]['c_id'],
								$d['drivers'][$key]['c_state'],
								$d['drivers'][$key]['c_cancel_reason'],
								$d['drivers'][$key]['c_rating'],
								$d['drivers'][$key]['c_becomed_candidate'],
								$d['drivers'][$key]['c_appointed'],
								$d['drivers'][$key]['c_canceled'],
								$d['drivers'][$key]['c_arrived'],
								$d['drivers'][$key]['c_started'],
								$d['drivers'][$key]['c_completed'],
								$d['drivers'][$key]['c_tips'],
								$d['drivers'][$key]['c_options']							
								)= explode(chr(0),$value);


						}
						else
						{


							list(
								$d['drivers'][$key]['u_id'],
								$d['drivers'][$key]['c_id'],
								$d['drivers'][$key]['c_state'],
								$d['drivers'][$key]['c_payment_way'],
								$d['drivers'][$key]['c_payment_card'],
								$d['drivers'][$key]['c_payment_sum'],
								$d['drivers'][$key]['c_payment_datetime'],
								$d['drivers'][$key]['c_cancel_reason'],
								$d['drivers'][$key]['c_rating'],
								$d['drivers'][$key]['c_becomed_candidate'],
								$d['drivers'][$key]['c_appointed'],
								$d['drivers'][$key]['c_canceled'],
								$d['drivers'][$key]['c_arrived'],
								$d['drivers'][$key]['c_started'],
								$d['drivers'][$key]['c_completed'],
								$d['drivers'][$key]['c_tips'],
								$d['drivers'][$key]['c_options']
								)= explode(chr(0),$value);

								if ($d['drivers'][$key]['c_payment_card'] === chr(2))
								{

									$d['drivers'][$key]['c_payment_card'] = NULL;
								}
								if ($d['drivers'][$key]['c_payment_sum'] === chr(2))
								{
									$d['drivers'][$key]['c_payment_sum'] = NULL;
								}
								if ($_SESSION[UID] != $d['drivers'][$key]['u_id'])
								{
									unset($d['drivers'][$key]['c_payment_way']);
									unset($d['drivers'][$key]['c_payment_card']);
									unset($d['drivers'][$key]['c_payment_sum']);
									unset($d['drivers'][$key]['c_payment_datetime']);
								}
								if ($d['drivers'][$key]['c_options'] === chr(2))
								{
									unset($d['drivers'][$key]['c_options']);
								}
								else
								{
									add_time_zone($d['drivers'][$key]['c_payment_datetime']);
								}
						}
						if ($d['drivers'][$key]['c_cancel_reason'] === chr(2))
						{
							$d['drivers'][$key]['c_cancel_reason'] = NULL;
						}
						if ($d['drivers'][$key]['c_rating'] === chr(2))
						{
							$d['drivers'][$key]['c_rating'] = NULL;
						}
						if ($d['drivers'][$key]['c_tips'] === chr(2))
						{
							$d['drivers'][$key]['c_tips'] = NULL;
						}

						if ($d['drivers'][$key]['c_arrived'] === '0000-00-00 00:00:00')
						{
							$d['drivers'][$key]['c_arrive_state'] = 0;
						}
						else
						{
							$d['drivers'][$key]['c_arrive_state'] = 1;
						}
						add_time_zone($d['drivers'][$key]['c_becomed_candidate']);
						add_time_zone($d['drivers'][$key]['c_appointed']);
						add_time_zone($d['drivers'][$key]['c_canceled']);
						add_time_zone($d['drivers'][$key]['c_arrived']);
						add_time_zone($d['drivers'][$key]['c_started']);
						add_time_zone($d['drivers'][$key]['c_completed']);
						if (!empty($d['drivers'][$key]['c_options'])) $d['drivers'][$key]['c_options'] = json_decode($d['drivers'][$key]['c_options'],true);
					}
				}
				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);
				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);

				if ($d['b_max_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_max_waiting'] = NULL;
				}
				else
				{
					$d['b_max_waiting'] = strtotime($d['b_max_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}

				if ($d['b_estimate_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_estimate_waiting'] = NULL;
				}
				else
				{
					$d['b_estimate_waiting'] = strtotime($d['b_estimate_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}

				$d['b_options'] = json_decode($d['b_options'],true);

				if (isset($d['b_services']) && @in_array('5', $d['b_services'])) {$d['b_voting'] = 1;}

				add_time_zone($d['b_start_datetime']);
				add_time_zone($d['b_created']);
				if ($this->id_role == 1 || $this->id_role == 5)
				{
					add_time_zone($d['b_confirmation_limit']);
					add_time_zone($d['b_confirmation_datetime']);
					add_time_zone($d['b_payment_datetime']);
				}
				add_time_zone($d['b_approved']);
				add_time_zone($d['b_canceled']);
				add_time_zone($d['b_completed']);

				$d['b_confirm_state'] = (int)$d['b_confirm_state'];
				if ($d['b_night'] !== NULL) $d['b_night'] = (int)$d['b_night'];

				if (DEFAULT_PROFILE == 'stadium')
				{
					$fix_seats = array();
					if (!empty($d['fix_seats']))
					{
						$fix_seats = explode(chr(1),$d['fix_seats']);
						$d['fix_seats'] = array();
						foreach ($fix_seats as $key=>$value)
						{
							list(
								$id_seat,
								$id_trip,
								$id_trip_seat
								)= explode(chr(0),$value);
							$d['fix_seats'][$id_trip][$id_trip_seat] = $id_seat;
						}
						$fix_seats = $d['fix_seats'];
						unset($d['fix_seats']);
					}
					if (!empty($d['b_options']['tickets']['seats']))
					{
						$b_options_seats = $d['b_options']['tickets']['seats'];
						$d['b_options']['tickets']['seats'] = array();
						foreach($b_options_seats as $id_trip=>$seats)
						{
							if (is_array($seats))
							{
								foreach($seats as $seat=>$val)
								{
									$d['b_options']['tickets']['seats'][$id_trip][isset($fix_seats[$id_trip][$seat]) ? $fix_seats[$id_trip][$seat] : $seat] = $val;
								}
							}
							else
							{
								$d['b_options']['tickets']['seats'] = $seats;
							}
						}
					}
				}

				$out['booking'][$d['b_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['booking'] =  array_values($out['booking']);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function setDriver($data = '', $id_order = "", $id_user = "", $appointed_performer = 0, $code = NULL, $trips = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}
			
			if ($this->id_role == 1 || $this->id_role == 5)
			{
				$s = "SELECT
						`order`.`id_order`,
						`order`.`client`,
						`order`.`id_order_status`,
						`order`.`is_confirmed`,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $id_user 
							. "',`order_driver`.`id_user`,NULL)) as u_id,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $id_user 
							. "',`order_driver`.`id_order_driver_status`,NULL)) as c_state
					FROM `order` 
					LEFT JOIN `order_driver` USING (`id_order`)				
					WHERE	
						`order`.`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');
				
				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 1) return $this->showError('404', 'error', 'wrong booking state');

				if ($d['client'] != $_SESSION[UID]) 
				{
					return $this->showError('404', 'error', $_SESSION[UID] . ' is not author');
				}
				if (empty($d['u_id'])) 
				{
					return $this->showError('404', 'error', $id_user . ' is not performer');
				}
				if (empty($d['is_confirmed'])) return $this->showError('404', 'error', 'booking not confirmed');
				if ($d['c_state'] != 1) 
				{
					return $this->showError('404', 'error', 'wrong booking driver state');
				}

				$q = query("BEGIN");
				if ($q === false) return $this->showError('404', 'error', 'begin query failed');
	
				$s = "UPDATE `order`,`order_driver`,(
							SELECT

								'" . $id_order . "' as `id_order`,
								@c_c_count := COUNT(`id_order`) as current_car_count
							FROM
								`order_driver`
							WHERE
								`id_order` = '" . $id_order . "' AND 
								`id_order_driver_status` in (3,4,5,6)

						) od
					SET 
						`order`.`id_order_status` = (SELECT @id := 
							IF(od.`current_car_count` < `order`.`car_count`-1,1,2)),
						`order`.`approve_datetime` = 
							IF(od.`current_car_count` < `order`.`car_count`-1,`order`.`approve_datetime`,now()),	
						`order`.`car_count` = (SELECT @c_count := `order`.`car_count`),	
						`order_driver`.`id_order_driver_status` = 
							IF( od.`current_car_count` < `order`.`car_count`,3,1),
						`order_driver`.`appoint_datetime` = 
							IF( od.`current_car_count` < `order`.`car_count`,now(),
							`order_driver`.`appoint_datetime`)
					WHERE
						`order`.`id_order` = '" . $id_order . "' AND `order`.`id_order_status` = '1' AND
						`order`.`id_order` = `order_driver`.`id_order` AND 
						`order_driver`.`id_order`='" . $id_order . "' AND 
						`order_driver`.`id_user` = '" . $id_user . "' AND 
						`order_driver`.`id_order_driver_status` = '1' AND
						`order`.`id_order` = od.`id_order`
					";
				
				query($s);

				global $link;
				$rows = mysqli_affected_rows($link);				
				if ($rows === -1) 
				{
					return $this->showError('404', 'error', 'database update failed');
				}
				elseif ($rows === 0) 
				{
					return $this->showError('404', 'error', 'modified data not found');
				}
				
				$s = "SELECT @c_c_count,@c_count,@id";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'variable select failed');
				$d_u = fetch_assoc($q);

				$s = "UPDATE `order`
					SET 
						`last_edit_datetime` = now(),
						`last_edit_user` = '" .  $_SESSION[UID] . "',
						`price_estimate` = IF(`id_car_class` IS NULL,
							(SELECT 
								SUM(`price_estimate`)
							 FROM `order_driver`
							 WHERE
								`id_order` = '" . $id_order . "' AND 
								`id_order_driver_status` in (3,4,5,6)
							),`price_estimate`)
					WHERE `id_order` = '" . $id_order . "'
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');
				
				if (!empty($trips))
				{
					$s = "SELECT
							COUNT(`id_trip`) as trips_count
						FROM `trip` 		
						WHERE	
							`id_trip` in (" . $trips . ") AND `driver` = '" . $id_user . "'
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'select failed');

					$d = fetch_assoc($q);
					$trips = explode(',', $trips);
					if ($d['trips_count'] != count($trips)) return $this->showError('404', 'error', 'driver is not trip author');
					
					$s = array();
					foreach ($trips as $id_trip)
					{
						$s[] = "('" . $id_order . "', '" . $id_trip . "', now(), now())";
					}
					$s = "INSERT INTO `order_trip` (`id_order`,  `id_trip`, `create_datetime`, `select_trip_datetime`) VALUES " . implode(",", $s) . "ON DUPLICATE KEY UPDATE `select_trip_datetime` = IF(`select_trip_datetime` = 0,now(),`select_trip_datetime`)";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'insert in database failed');
				}		

				$q = query("COMMIT");
				if ($q === false) return $this->showError('404', 'error', 'commit query failed');

				if ($rows === 1 && $d_u['id'] == 2) 
				{
					return $this->showError('404', 'error', 'only booking state modified');	
				}
				
				$out = array('current_cars_count' => (int)$d_u['@c_c_count']+1,'b_cars_count' => $d_u['@c_count']);
				if ($d_u['@id'] == 2) $out['b_state'] = '1->2';
			
			}
			else
			{
				$allowed_fields = array(									
										'c_id'					=>		'id_car',
										'c_payment_way'			=>		'id_payment_method',
										'c_payment_card'		=>		'id_payment_card',
										'c_options'				=>		'options'
				);
				$forbidden_fields = array();
				$affected_fields = array();
				$affected_keys = array();
				$filtered_data = array();
				
				if (!empty($data))
				{
					$data = json_decode($data,true);
					
					if (!is_array($data)) 
					{
						return $this->showError('404', 'error', 'wrong data');
					}

					foreach ($data as $key => $value)
					{
						if (!empty($allowed_fields[$key]))
						{
							if (is_string($value)) $data[$key] = trim($value);
							$affected_fields[] = $key;		
							$affected_keys[$key] = true;		
							$filtered_data[$allowed_fields[$key]] = $data[$key];
						}
						else
						{
							$forbidden_fields[] = $key;
						}
					}
				}

				$q = query("BEGIN");
				if ($q === false) return $this->showError('404', 'error', 'begin query failed');

				
				$s = "SELECT
						`order`.`id_order`,
						`order`.`client`,
						`order`.`id_order_status`,
						`order`.`is_confirmed`,
						`order`.`car_count`,
						`order`.`code`,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $_SESSION[UID] 
							. "',`order_driver`.`id_user`,NULL)) as u_id,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $_SESSION[UID] 
							. "',`order_driver`.`id_order_driver_status`,NULL)) as c_state,
						GROUP_CONCAT(IF(`order_driver`.`id_car` = '" 
							. (!empty($filtered_data['id_car']) ? $filtered_data['id_car'] : "")
							. "' AND `order_driver`.`not_deleted` IS NOT NULL,`order_driver`.`id_car`,NULL)) as c_id,
						COUNT(IF(`order_driver`.`id_order_driver_status` in (3,4,5,6),
							1,NULL)) as current_car_count,
						COUNT(IF(`order_driver`.`id_order_driver_status` = '3',
							1,NULL)) as appointed_performer_count,
						IFNULL(MAX(`order_driver`.`index`),0) as max_index,
						(SELECT
							COUNT(`order_driver_attempt`.`id_order`)
						 FROM `order_driver_attempt`
						 WHERE 
							`order_driver_attempt`.`id_order` = `order`.`id_order` AND 
							`order_driver_attempt`.`id_user`= '" . $_SESSION[UID] . "'
						) as attempt,
						IF(`order`.`id_order_status` = '6',(
							SELECT
								`order_driver_select`.`id_user`
							 FROM `order_driver_select`
							 WHERE 
								`order_driver_select`.`id_order` = `order`.`id_order` AND 
								`order_driver_select`.`id_user`= '" . $_SESSION[UID] . "'
						),NULL) as selected,
						`order`.`night_time`,
						`order`.`distance_estimate`,
						`order`.`id_car_class`
					FROM `order` 
					LEFT JOIN `order_driver` USING (`id_order`)				
					WHERE	
						`order`.`id_order` = '" . $id_order . "'
					LIMIT 1
					FOR UPDATE
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');
				
				$d = fetch_assoc($q);
				$d['car_count'] = (int)$d['car_count'];  
				$d['current_car_count'] = (int)$d['current_car_count'];
				$d['appointed_performer_count'] = (int)$d['appointed_performer_count'];
				$d['max_index'] = (int)$d['max_index'];

				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['client'] == $_SESSION[UID]) return $this->showError('404', 'error', 'driver is author');
				if ((int)$d['attempt'] >= $this->constant['driver_code_attempt_count_max'])
				{
					return $this->showError('404', 'error', 'maximum attempts exceeded');
				}
				
				if (isset($code)) {
					if (strlen($d['code']) == 0) 
					{
						return $this->showError('404', 'error', 'booking with empty driver code');
					}
					if ($d['code'] == $this->prepareForDriverCode($code))
					{
						$appointed_performer = 1;
					}
					else
					{
						$s = "INSERT INTO `order_driver_attempt`
							SET 
								`id_order` = '" . $id_order . "',
								`id_user` = '" . $_SESSION[UID]  . "',
								`datetime` = now()
							";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'database attempt insert failed');
						$q = query("COMMIT");
						if ($q === false) return $this->showError('404', 'error', 'commit failed');
						return $this->showError('404', 'error', 'wrong driver code');
					}				
				}

				if ($d['c_state'] > $appointed_performer)
				{
					return $this->showError('404', 'error', 'user is already performer with booking driver state ' 
						. $d['c_state']);
				}

				if (empty($d['u_id'])) 
				{
					if ($_SESSION['id_verification_status'] != 2)
					{
						return $this->showError('404', 'error', 'wrong user check state');
					}
					if (!empty($_SESSION['user_ban_status']['order']))
					{
						return $this->showError('404', 'error', 'user banned');
					}
					if (!empty($d['c_id'])) 
					{
						return $this->showError('404', 'error', 'car is already used in this drive');
					}
					elseif (!empty($filtered_data['id_car']))
					{
						$s = "SELECT
								`car`.`id_car`,
								cu.`id_user`,
								`car`.`id_car_class`
							FROM `car`
							LEFT JOIN (
									SELECT
										`id_car`,
										`id_user`
									FROM
										`car_users`
									WHERE
										`id_user` = '" . $_SESSION[UID] . "'
								) cu USING (`id_car`)						
							WHERE
								`car`.`id_car` = '" . $filtered_data['id_car'] . "'
							";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'car database select failed');
						
						$d_c = fetch_assoc($q);
						if (empty($d_c['id_car'])) 
						{
							return $this->showError('404', 'error', 'car not found');
						}
						if (empty($d_c['id_user'])) 
						{
							return $this->showError('404', 'error', 'car is not this driver');
						}
						if (empty($d['id_car_class']))
						{
							if ($d['distance_estimate'] !== NULL && $d['night_time'] !== NULL)
							{
								if (!empty($this->car_class[$d_c['id_car_class']]))
								{
									$courier_call_rate = (float)$this->car_class[$d_c['id_car_class']]['courier_call_rate'];
									$courier_fare_per_1_km = (float)$this->car_class[$d_c['id_car_class']]['courier_fare_per_1_km'];
									if (empty($d['night_time'])) $extra_charge_for_night_time = 1; else $extra_charge_for_night_time = $this->constant['extra_charge_for_night_time'];
									
									$filtered_data['price_estimate'] = $extra_charge_for_night_time*($courier_call_rate + $courier_fare_per_1_km*round($this->constant['distance_coefficient']*$d['distance_estimate']/1000,2));
								}
							}
						}
						else
						{
							if ($d_c['id_car_class'] != $d['id_car_class'])
							{
								return $this->showError('404', 'error', 'driver car has wrong class');
							}
						}
					}
					if (!empty($affected_keys['c_options']))
					{
						if (!is_array($filtered_data['options'])) return $this->showError('404', 'error', 'c_options not array');
						if (!empty($this->constant['c_options_valid_keys']))
						{
							$wrong_c_options = array();
							foreach($filtered_data['options'] as $key => $value)
							{
								if (empty($this->constant['c_options_valid_keys'][$key])) $wrong_c_options[] = $key;
							}
							if (!empty($wrong_c_options)) return $this->showError('404', 'error', 'wrong c_options keys: ' . implode(",", $wrong_c_options));
						}
						$filtered_data['options'] = real_escape_string(json_encode($filtered_data['options']));
					}

					if (empty($affected_fields)) return $this->showError('404', 'error', 'empty allowed data');
					if (empty($filtered_data['id_car'])) 
					{
						return $this->showError('404', 'error', 'empty car id');
					}
					if (empty($filtered_data['id_payment_method'])) 
					{
						return $this->showError('404', 'error', 'empty payment way');
					}
				}

				if (!empty($code))
				{
					if ($d['id_order_status'] != 1 && $d['id_order_status'] != 2 && $d['id_order_status'] != 6) 
					{
						return $this->showError('404', 'error', 'booking with wrong state');
					}
					if ($d['car_count'] - ($d['current_car_count'] - $d['appointed_performer_count']) <= 0)
					{
						return $this->showError('404', 'error', 'busy performers vacancy');
					}
					$id_order_driver_status = '4';
					$datetime_prefix = 'arrive_datetime';
					$d['current_car_count']++;
				}
				else
				{
					if ($d['id_order_status'] != 1) 
					{
						if ($d['id_order_status'] == 6)
						{
							if (empty($d['selected'])) return $this->showError('404', 'error', 'not selected driver');
							$appointed_performer = 1;
						}
						else
						{
							return $this->showError('404', 'error', 'wrong booking state');
						}
					}
					if (empty($appointed_performer))
					{
						$id_order_driver_status = '1';
						$datetime_prefix = "candidacy_datetime";
					}
					else
					{
						if (empty($d['is_confirmed'])) 
						{
							return $this->showError('404', 'error', 'booking not confirmed');
						}
						$id_order_driver_status = '3';
						$datetime_prefix = "appoint_datetime";
						$d['current_car_count']++;
						$d['appointed_performer_count']++;
					}
				}

				global $link;
				if (empty($d['u_id'])) 
				{
					$s = array();
					foreach ($filtered_data as $key => $value)
					{
						if ($value !== NULL) 
						{
							$s[] = "`" . $key . "` = '" . $value . "'";
						}
					}	
					$index = $d['max_index'] + 1;
					$s = "INSERT INTO `order_driver`
						SET 
							" . implode(",\n", $s) .",
							`id_order` = '" . $id_order . "',
							`id_user` = '" . $_SESSION[UID]  . "',
							`index` = '" . $index . "',
							`id_order_driver_status` = '" . $id_order_driver_status  . "',
							`" . $datetime_prefix . "` = now()
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'database insert failed');

					$out = array('c_index' => $index,'current_cars_count' => $d['current_car_count'],'b_cars_count' => $d['car_count']);
				}
				else
				{
					$s = "UPDATE `order_driver`
						SET 
							`id_order_driver_status` = '" . $id_order_driver_status  . "',
							`" . $datetime_prefix . "` = now()
						WHERE
							`id_order` = '" . $id_order . "' AND `id_user` = '" . $_SESSION[UID] . "' AND 
							`id_order_driver_status` = '1'
						";
					
					query($s);

					if (mysqli_affected_rows($link) === -1) 
					{

						return $this->showError('404', 'error', 'driver database update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'driver modified data not found');
					}

					$out = array('current_cars_count' => $d['current_car_count'],'b_cars_count' => $d['car_count']);
				}

				if ($d['id_order_status'] != 2 && $d['current_car_count'] >= $d['car_count'])
				{
					$s = "UPDATE `order`
						SET 
							`id_order_status` = '2',
							`approve_datetime` = now()
						WHERE
							`order`.`id_order` = '" . $id_order . "' AND `id_order_status` in (1,6)
						";

					query($s);

					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'booking database update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'booking modified data not found');
					}

					$out['b_state'] = '1->2';
				}

				if (!empty($code) && 
					$d['car_count'] - ($d['current_car_count'] - $d['appointed_performer_count']) <= 0 
					&&	!empty($d['appointed_performer_count']))
				{
					$s = "UPDATE `order_driver`
						SET 
							`id_order_driver_status` = '2',
							`cancel_datetime` = now()
						WHERE
							`id_order` = '" . $id_order . "' AND `id_order_driver_status` = '3'
						";

					query($s);

					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'booking driver database update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'booking driver modified data not found');
					}

					$out['current_cars_count'] = $d['current_car_count'] - $d['appointed_performer_count'];
				}

				if (!empty($trips))
				{
					$s = "SELECT
							COUNT(`id_trip`) as trips_count
						FROM `trip` 		
						WHERE	
							`id_trip` in (" . $trips . ") AND `driver` = '" . $_SESSION[UID] . "'
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'select failed');

					$d = fetch_assoc($q);
					$trips = explode(',', $trips);
					if ($d['trips_count'] != count($trips)) return $this->showError('404', 'error', 'driver is not trip author');
					
					$s = array();
					
					if ($id_order_driver_status == '1')
					{
						foreach ($trips as $id_trip)
						{
							$s[] = "('" . $id_order . "', '" . $id_trip . "', now())";
						}
						$s = "INSERT IGNORE INTO `order_trip` (`id_order`,  `id_trip`, `create_datetime`) VALUES " . implode(",", $s);
					}
					elseif ($id_order_driver_status == '3')
					{
						foreach ($trips as $id_trip)
						{
							$s[] = "('" . $id_order . "', '" . $id_trip . "', now(), now())";
						}
						$s = "INSERT INTO `order_trip` (`id_order`,  `id_trip`, `create_datetime`, `select_trip_datetime`) VALUES " . implode(",", $s) . "ON DUPLICATE KEY UPDATE `select_trip_datetime` = IF(`select_trip_datetime` = 0,now(),`select_trip_datetime`)";
					}
					
					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'insert in database failed');
				}				

				$s = "UPDATE `order`
					SET 
						`last_edit_datetime` = now(),
						`last_edit_user` = '" .  $_SESSION[UID] . "',
						`price_estimate` = IF(`id_car_class` IS NULL,
							(SELECT 
								SUM(`price_estimate`)
							 FROM `order_driver`
							 WHERE
								`id_order` = '" . $id_order . "' AND 
								`id_order_driver_status` in (3,4,5,6)
							),`price_estimate`)
					WHERE `id_order` = '" . $id_order . "'
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');


				$q = query("COMMIT");
				if ($q === false) return $this->showError('404', 'error', 'commit query failed');
			}
	
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);	
		}

		public function setCarIsArrived($id_order = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 2)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			$s = "SELECT
					`order`.`id_order`,
					`order`.`id_order_status`,
					od.`id_user`,
					od.`id_order_driver_status`
				FROM `order` 
				LEFT JOIN (
						SELECT
							`id_order`,
							`id_user`,
							`id_order_driver_status`
						FROM
							`order_driver`
						WHERE
							`id_order` = '" . $id_order . "' AND `id_user` = '" . $_SESSION[UID] . "'
					) od USING (`id_order`)				
				WHERE	
					`order`.`id_order` = '" . $id_order . "'
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
			if ($d['id_order_status'] != 1 && $d['id_order_status'] != 2 
				&& $d['id_order_status'] != 6) 
			{
				return $this->showError('404', 'error', 'wrong booking state');
			}
			if (empty($d['id_user'])) 
			{
				return $this->showError('404', 'error', 'user is not performer');
			}		
			if ($d['id_order_driver_status'] == 1) 
			{
				return $this->showError('404', 'error', 'not appointed performer');
			}
			elseif ($d['id_order_driver_status'] == 2 )
			{
				return $this->showError('404', 'error', 'canceled performer');
			}
			elseif ($d['id_order_driver_status'] == 4 )
			{
				return $this->showError('404', 'error', 'arrive state has already been changed');
			}
			elseif ($d['id_order_driver_status'] == 5)
			{
				return $this->showError('404', 'error', 'started ride');
			}
			elseif ($d['id_order_driver_status'] == 6)
			{
				return $this->showError('404', 'error', 'completed booking');
			}
			
			$s = "UPDATE `order`,`order_driver`
				SET 
					`order`.`last_edit_datetime` = now(),
					`order`.`last_edit_user` = '" .  $_SESSION[UID] . "',
					`order_driver`.`id_order_driver_status` = '4',
					`order_driver`.`arrive_datetime` = now()
				WHERE
					`order`.`id_order` = '" . $id_order . "' AND `order`.`id_order` = `order_driver`.`id_order` AND
					`order_driver`.`id_order` = '" . $id_order . "' AND 
					`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND
					`order_driver`.`id_order_driver_status` = '3'
				";

			query($s);
	
			global $link;
			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database update failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'modified data not found');
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function completeOrder($id_order = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			if ($this->id_role == 1 || $this->id_role == 5)
			{
				$s = "SELECT
						`id_order`,
						`client`,
						`id_order_status`
					FROM `order` 		
					WHERE	
						`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 2) return $this->showError('404', 'error', 'wrong booking state');
				if ($d['client'] != $_SESSION[UID]) return $this->showError('404', 'error', 'user is not author');

				$s = "UPDATE `order`
					SET 
						`id_order_status` = '4',
						`complete_datetime` = now(),
						`last_edit_datetime` = now(),
						`last_edit_user` = '" .  $_SESSION[UID] . "'
					WHERE
						`id_order` = '" . $id_order . "' AND `id_order_status` = '2'
					";

				query($s);
		
				global $link;
				if (mysqli_affected_rows($link) === -1) 
				{
					return $this->showError('404', 'error', 'database update failed');
				}
				elseif (mysqli_affected_rows($link) === 0) 
				{

					return $this->showError('404', 'error', 'modified data not found');
				}
			}
			elseif ($this->id_role == 2)
			{		
				$s = "SELECT
						`order`.`id_order`,
						`order`.`id_order_status`,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $_SESSION[UID] 
							. "',`order_driver`.`id_user`,NULL)) as u_id,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $_SESSION[UID] 
							. "',`order_driver`.`id_order_driver_status`,NULL)) as c_state,
						COUNT(IF(`order_driver`.`id_user` != '" . $_SESSION[UID] 
							. "' AND `order_driver`.`id_order_driver_status` in (3,4,5),
							1,NULL)) as incomplete_count
					FROM `order` 

					LEFT JOIN `order_driver` USING (`id_order`)				
					WHERE	
						`order`.`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 2 && $d['id_order_status'] != 4)
				{
					return $this->showError('404', 'error', 'wrong booking state');
				}
				if (empty($d['u_id'])) 
				{
					return $this->showError('404', 'error', 'user is not performer');
				}			
				if ($d['c_state'] == 1) 
				{
					return $this->showError('404', 'error', 'not appointed performer');

				}
				elseif ($d['c_state'] == 2)
				{
					return $this->showError('404', 'error', 'canceled performer');
				}
				global $link;
				if ($d['c_state'] != 6)
				{
					$s = "UPDATE `order`,`order_driver`
						SET 
							`order`.`last_edit_datetime` = now(),
							`order`.`last_edit_user` = '" .  $_SESSION[UID] . "',
							`order_driver`.`id_order_driver_status` = '6',
							`order_driver`.`complete_datetime` = now()
						WHERE
							`order`.`id_order` = '" . $id_order . "' AND 
							`order`.`id_order` = `order_driver`.`id_order` AND
							`order_driver`.`id_order` = '" . $id_order . "' AND 
							`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND
							`order_driver`.`id_order_driver_status` in (3,4,5)
						";

					query($s);
					
					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'driver update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'driver modified data not found');
					}
				}
				if ($d['id_order_status'] == 2 && empty($d['incomplete_count']))
				{
					$s = "UPDATE `order`
						SET 
							`id_order_status` = '4',
							`complete_datetime` = now(),
							`last_edit_datetime` = now(),
							`last_edit_user` = '" .  $_SESSION[UID] . "'
						WHERE
							`id_order` = '" . $id_order . "' AND `id_order_status` = '2'
						";

					query($s);
			
					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'booking update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'booking modified data not found');
					}
				}			
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);	
		}

		public function cancelOrder($id_order = "", $forced = 0, $cancel_reason = "", $cancel_states = "", $site_cancel_states = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5 && $this->id_role != 4)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}
			if (!empty($cancel_states))
			{
				$s_cancel_states = array();
				$forbidden_cancel_states = array();
				foreach (explode(',', $cancel_states) as $c_s)
				{
					$c_s = trim($c_s);
					if (!empty($site_cancel_states[$c_s]['user_roles']) && in_array($this->id_role,$site_cancel_states[$c_s]['user_roles']))
					{
						$s_cancel_states[] = "('" . $id_order . "', '" . $c_s . "', '" . $_SESSION[UID] . "')";
					}
					else
					{
						$forbidden_cancel_states[] = $c_s;
					}
				}
				if (!empty($forbidden_cancel_states))
				{
					return $this->showError('404', 'error', 'wrong booking_cancel_states: ' . implode(",", $forbidden_cancel_states));
				}
				$s_cancel_states = "INSERT INTO `order_cancel_items` (`id_order`,`id_order_cancel`,`id_user`) VALUES " . implode(",", $s_cancel_states);
			}
	
			if ($this->id_role == 1 || $this->id_role == 5 || $this->id_role == 4)
			{
				$s = "SELECT
						`id_order`,
						`client`,
						`id_order_status`,
						`pay_datetime`,
						`options`
					FROM `order` 		
					WHERE	
						`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 1 && $d['id_order_status'] != 2 && $d['id_order_status'] != 5 
					&& $d['id_order_status'] != 6) 
				{
					return $this->showError('404', 'error', 'wrong booking state');
				}
				if ($this->id_role != 4 && $d['client'] != $_SESSION[UID]) 
				{
					return $this->showError('404', 'error', 'user is not author');
				}

				if (DEFAULT_PROFILE == 'stadium')
				{
					if ($d['pay_datetime'] !== '0000-00-00 00:00:00') return $this->showError('404', 'error', 'order has already been paid');
					$d['options'] = json_decode($d['options'],true);
					$d_options = $d['options'];
					if (empty($d['options']['tickets']['payment'])) $d['options']['tickets']['payment'] = '';
					if ($d['options']['tickets']['payment'] == 'succeeded')
					{
						return $this->showError('404', 'error', 'order with succeeded status');
					}

					if ($d['options']['tickets']['payment'] !== 'failed')
					{
						$api_use = true;
						$order = $id_order;
						$status = 'failed';
						$cancel_status = cancel_stripe_link($id_order);
						if (!empty($cancel_status['error'])) 
						{
							if (empty($cancel_status['error'][1]))
							{
								if (empty($forced)) return $this->showError('404', 'error', $cancel_status['error']);
							}
							elseif ($cancel_status['error'][1] === "Only Checkout Sessions with a status in [\"open\"] can be expired. This Checkout Session has a status of `complete`.")
							{
								$status = 'succeeded';
							}
							elseif ($cancel_status['error'][1] !== "Only Checkout Sessions with a status in [\"open\"] can be expired. This Checkout Session has a status of `expired`.")
							{
								if (empty($forced)) return $this->showError('404', 'error', $cancel_status['error']);
							}
						}
						$res = require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_stripe.php');
						if (!empty($res['error'])) return $this->showError('404', 'error', $res['error']);				
					}
				}
				if (empty($status) || $status != 'succeeded')
				{
					$q = query("BEGIN");
					if ($q === false) return $this->showError('404', 'error', 'begin query failed');

					if (!empty($s_cancel_states))
					{
						$q = query($s_cancel_states);
						if ($q === false) return $this->showError('404', 'error', 'booking_cancel_states insert failed');
					}

					$s = "UPDATE `order`
						SET 
							`id_order_status` = '3',
							`cancel_reason` = '" . str_replace(array(chr(0),chr(1),chr(2)),' ',$cancel_reason) . "',
							`cancel_datetime` = now(),
							`last_edit_datetime` = now(),
							`last_edit_user` = '" .  $_SESSION[UID] . "'
						WHERE
							`id_order` = '" . $id_order . "' AND `id_order_status`in (1,2,5,6)
						";

					query($s);
			
					global $link;
					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'booking update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						if (empty($status)) return $this->showError('404', 'error', 'booking modified data not found');
					}

					$q = query("COMMIT");
					if ($q === false) return $this->showError('404', 'error', 'commit query failed');
				}
			}
			else
			{
				$s = "SELECT
						`order`.`id_order`,
						`order`.`id_order_status`,
						od.`id_user`,
						od.`id_order_driver_status`
					FROM `order` 
					LEFT JOIN (
							SELECT
								`id_order`,
								`id_user`,
								`id_order_driver_status`
							FROM
								`order_driver`
							WHERE
								`id_order` = '" . $id_order . "' AND `id_user` = '" . $_SESSION[UID] . "'
						) od USING (`id_order`)	
						
					WHERE	
						`order`.`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 1 && $d['id_order_status'] != 2
					&& $d['id_order_status'] != 6) 
				{
					return $this->showError('404', 'error', 'wrong booking state');
				}
				if (empty($d['id_user'])) 
				{
					return $this->showError('404', 'error', 'user is not performer');
				}
				global $link;
				if ($d['id_order_driver_status'] == 1) 
				{
					$q = query("BEGIN");
					if ($q === false) return $this->showError('404', 'error', 'begin query failed');
					
					if (!empty($s_cancel_states))
					{
						$q = query($s_cancel_states);
						if ($q === false) return $this->showError('404', 'error', 'booking_cancel_states insert failed');
					}

					$s = "UPDATE `order`,`order_driver`
						SET 
							`order`.`last_edit_datetime` = now(),
							`order`.`last_edit_user` = '" .  $_SESSION[UID] . "',
							`order_driver`.`id_order_driver_status` = '2',
							`order_driver`.`cancel_reason` = '" . str_replace(array(chr(0),chr(1),chr(2)),' ',$cancel_reason) . "',
							`order_driver`.`cancel_datetime` = now(),
							`order_driver`.`not_deleted` = NULL
						WHERE
							`order`.`id_order` = '" . $id_order . "' AND 
							`order`.`id_order` = `order_driver`.`id_order` AND
							`order_driver`.`id_order` = '" . $id_order . "' AND 
							`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND
							`order_driver`.`id_order_driver_status` = '1'
						";

					query($s);
			
					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'driver update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'driver modified data not found');
					}

					$q = query("COMMIT");
					if ($q === false) return $this->showError('404', 'error', 'commit query failed');
				}
				elseif ($d['id_order_driver_status'] == 2)
				{
					return $this->showError('404', 'error', 'canceled performer');
				}
				elseif ($d['id_order_driver_status'] == 3 || $d['id_order_driver_status'] == 4)
				{
					$q = query("BEGIN");
					if ($q === false) return $this->showError('404', 'error', 'begin query failed');
					
					if (!empty($s_cancel_states))
					{
						$q = query($s_cancel_states);
						if ($q === false) return $this->showError('404', 'error', 'booking_cancel_states insert failed');
					}
					
					$s = "UPDATE `order`,`order_driver`
						SET 
							`order`.`id_order_status` = IF(
								(SELECT 
									current_car_count 
								 FROM (
										SELECT
											COUNT(`id_order`) as current_car_count
										FROM
											`order_driver`
										WHERE
											`id_order` = '" . $id_order . "' AND 
											`id_order_driver_status` in (3,4,5,6)
									) od
								) < `order`.`car_count`+1,
								IF(`order`.`id_order_status` in (1,5,6),`order`.`id_order_status`,1),2),
							`order_driver`.`id_order_driver_status` = '2',
							`order_driver`.`cancel_reason` = '" . str_replace(array(chr(0),chr(1),chr(2)),' ',$cancel_reason) . "',
							`order_driver`.`cancel_datetime` = now(),
							`order_driver`.`not_deleted` = NULL
						WHERE
							`order`.`id_order` = '" . $id_order . "' AND `order`.`id_order_status` in (1,2,5,6) AND
							`order`.`id_order` = `order_driver`.`id_order` AND 
							`order_driver`.`id_order`='" . $id_order . "' AND 
							`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND 
							`order_driver`.`id_order_driver_status` in (3,4)
						";
					
					query($s);

					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'database update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'modified data not found');
					}
					
					$s = "UPDATE `order`
						SET 
							`last_edit_datetime` = now(),
							`last_edit_user` = '" .  $_SESSION[UID] . "',
							`price_estimate` = IF(`id_car_class` IS NULL,
								(SELECT 
									SUM(`price_estimate`)
								 FROM `order_driver`
								 WHERE
									`id_order` = '" . $id_order . "' AND 
									`id_order_driver_status` in (3,4,5,6)
								),`price_estimate`)
						WHERE `id_order` = '" . $id_order . "'
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');

					$q = query("COMMIT");
					if ($q === false) return $this->showError('404', 'error', 'commit query failed');
				}
				elseif ($d['id_order_driver_status'] == 5)
				{
					$q = query("BEGIN");
					if ($q === false) return $this->showError('404', 'error', 'begin query failed');
					
					if (!empty($s_cancel_states))
					{
						$q = query($s_cancel_states);
						if ($q === false) return $this->showError('404', 'error', 'booking_cancel_states insert failed');
					}
				
					$s = "UPDATE `order`,`order_driver`
						SET 
							`order`.`last_edit_datetime` = now(),
							`order`.`last_edit_user` = '" .  $_SESSION[UID] . "',
							`order`.`id_order_status` = '3',
							`order`.`cancel_datetime` = now(),
							`order_driver`.`id_order_driver_status` = '2',
							`order_driver`.`cancel_reason` = '" . str_replace(array(chr(0),chr(1),chr(2)),' ',$cancel_reason) . "',
							`order_driver`.`cancel_datetime` = now(),
							`order_driver`.`not_deleted` = NULL
						WHERE
							`order`.`id_order` = '" . $id_order . "' AND `order`.`id_order_status` in (6,1,2) AND

							`order`.`id_order` = `order_driver`.`id_order` AND 
							`order_driver`.`id_order`='" . $id_order . "' AND 
							`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND 
							`order_driver`.`id_order_driver_status` = '5'
						";
						
					query($s);

					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'update of database failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'database modified data not found');
					}

					$q = query("COMMIT");
					if ($q === false) return $this->showError('404', 'error', 'commit query failed');
				}
				elseif ($d['id_order_driver_status'] == 6)
				{
					return $this->showError('404', 'error', 'completed booking');
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function rateOrder($id_order = "", $rating = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			if ($this->id_role == 1 || $this->id_role == 5)
			{
				$s = "SELECT
						`id_order`,
						`client`,
						`id_order_status`,
						`rating`
					FROM `order` 		
					WHERE	
						`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 4) return $this->showError('404', 'error', 'wrong booking state');
				if ($d['client'] != $_SESSION[UID]) 
				{
					return $this->showError('404', 'error', 'user is not author');
				}
				if ($d['rating'] !== NULL) return $this->showError('404', 'error', 'booking already rated');

				$s = "UPDATE `order`
					SET 
						`rating` = '" . $rating  . "',
						`last_edit_datetime` = now(),
						`last_edit_user` = '" .  $_SESSION[UID] . "'
					WHERE
						`id_order` = '" . $id_order . "' AND `rating` IS NULL
					";

				query($s);
		
				global $link;
				if (mysqli_affected_rows($link) === -1)
				{
					return $this->showError('404', 'error', 'database update failed');
				}
				elseif (mysqli_affected_rows($link) === 0)
				{

					return $this->showError('404', 'error', 'modified data not found');
				}
			}
			else
			{
				$s = "SELECT
						`order`.`id_order`,
						`order`.`id_order_status`,
						od.`id_user`,
						od.`id_order_driver_status`,
						od.`rating`
					FROM `order`
					LEFT JOIN (
							SELECT
								`id_order`,
								`id_user`,
								`id_order_driver_status`,
								`rating`
							FROM
								`order_driver`
							WHERE
								`id_order` = '" . $id_order . "' AND `id_user` = '" . $_SESSION[UID] . "'
						) od USING (`id_order`)				
					WHERE	
						`order`.`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 4) return $this->showError('404', 'error', 'wrong booking state');
				if (empty($d['id_user'])) 
				{
					return $this->showError('404', 'error', 'user is not performer');
				}
				if ($d['rating'] !== NULL) return $this->showError('404', 'error', 'booking already rated');
				if ($d['id_order_driver_status'] == 1 || $d['id_order_driver_status'] == 2) 
				{
					return $this->showError('404', 'error', 'wrong booking driver state');
				}

				$s = "UPDATE `order`,`order_driver`
					SET 
						`order`.`last_edit_datetime` = now(),
						`order`.`last_edit_user` = '" .  $_SESSION[UID] . "',
						`order_driver`.`rating` = '" . $rating  . "'
					WHERE
						`order`.`id_order` = '" . $id_order . "' AND
						`order`.`id_order` = `order_driver`.`id_order` AND 
						`order_driver`.`id_order` = '" . $id_order . "' AND 
						`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND
						`order_driver`.`rating` IS NULL
					";

				query($s);

				global $link;
				if (mysqli_affected_rows($link) === -1) 
				{
					return $this->showError('404', 'error', 'driver update failed');
				}
				elseif (mysqli_affected_rows($link) === 0) 
				{
					return $this->showError('404', 'error', 'driver modified data not found');
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function selectOrder($id_order = "", $fields = 0)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 4 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}			

			$sql_order = $sql_order_driver = $sql_c_options = $sql_left_join = '';
			if (empty($id_order))
			{
				$sql_where = '1=1';
			}
			else
			{
				$sql_where = "`order`.`id_order` in (" . $id_order . ")";
			}

			$field_flag = array();
			if (!empty($fields))
			{
				$field_arr	= get_field_arr('order',$this->id_role);
				$bin_arr = get_bin_arr();

				foreach(str_split($fields) as $index => $char)
				{
					$value = get_0_64($char);
					if (empty($value)) continue;
					foreach($bin_arr as $bin_i)
					{
						if ($value & $bin_i) 
						{
							if (isset($field_arr[$index][$bin_i]))
							{
								$field_flag[$field_arr[$index][$bin_i]] = true;
							}
						}
					}
				}
			}
			if (!empty($field_flag['b_offers']))
			{
				$sql_order .= "(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',
								`id_user`,
								`create_datetime`
							)
						SEPARATOR ';') 
					 FROM `order_driver_select`
					 WHERE `order_driver_select`.`id_order` = `order`.`id_order`
					 ORDER BY `order_driver_select`.`id_user`
					) as b_offers,";
			}
			if (!empty($field_flag['b_offer']))
			{
				$sql_order .= "(SELECT
						COUNT(`id_user`)
					 FROM `order_driver_select`
					 WHERE 
						`order_driver_select`.`id_order` = `order`.`id_order` AND
						`order_driver_select`.`id_user` = '" . $_SESSION[UID] . "'
					 LIMIT 1
					) as b_offer,";
			}

			if ($this->id_role == 1 || $this->id_role == 4 || $this->id_role == 5)
			{
				$sql_order .= "
					`order`.`id_payment_method` as b_payment_way,
					`order`.`id_payment_card` as b_payment_card,
					`order`.`confirm_limit_datetime` as b_confirmation_limit,
					`order`.`confirm_datetime` as b_confirmation_datetime,
					`order`.`sum` as b_payment_sum,
					`order`.`pay_datetime` as b_payment_datetime,
					`order`.`code` as b_driver_code,
					(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',
								`id_user`,
								`datetime`
							)
						SEPARATOR ';') 
					 FROM `order_driver_attempt`
					 WHERE `order_driver_attempt`.`id_order` = `order`.`id_order`
					 ORDER BY `order_driver_attempt`.`id_user`
					) as b_attempts,
					";
				$sql_c_options .= "`order_driver`.`options`";
			}
			elseif ($this->id_role == 2)
			{
				$sql_order .= "
					(SELECT
							GROUP_CONCAT(
							CONCAT_WS('|',
								`id_user`,
								`datetime`
							)
						SEPARATOR ';') 
					 FROM `order_driver_attempt`
					 WHERE 
						`order_driver_attempt`.`id_order` = `order`.`id_order` AND 
						`order_driver_attempt`.`id_user`= '" . $_SESSION[UID] . "'
					) as b_attempts,
					";	
				$sql_c_options .= "IF(`order_driver`.`id_user` = '" . $_SESSION[UID] . "',
									`order_driver`.`options`,0x02)";
			}

			if ($this->id_role == 2 || $this->id_role == 4)
			{
				$sql_order_driver .= "
							`order_driver`.`id_payment_method`,
							IFNULL(`order_driver`.`id_payment_card`,0x02),
							IFNULL(`order_driver`.`sum`,0x02),
							`order_driver`.`pay_datetime`,
							";
			}

			if ($this->id_role == 2)
			{
				$sql_left_join .= "
					LEFT JOIN (
							SELECT
								`id_order`,
								`id_user`	
							FROM
								`order_driver`
							WHERE
								`id_user` = '" . $_SESSION[UID] . "'
						) od USING (`id_order`)";
				$sql_where .= " AND ((`order`.`id_order_status` = '1' AND `order`.`max_waiting_datetime` > now() AND od.`id_user` IS NULL AND
					(SELECT
							COUNT(`order_driver_attempt`.`id_order`)
						FROM `order_driver_attempt`
						WHERE 
							`order_driver_attempt`.`id_order` = `order`.`id_order` AND 
							`order_driver_attempt`.`id_user`= '" . $_SESSION[UID] . "'
					) < " . $this->constant['driver_code_attempt_count_max'] . ") OR 
					od.`id_user` = '" . $_SESSION[UID] . ("' OR (SELECT
							`order_driver_select`.`cancel`
						FROM `order_driver_select`
						WHERE 
							`order_driver_select`.`id_order` = `order`.`id_order` AND 
							`order_driver_select`.`id_user` = '" . $_SESSION[UID] . "' 
					) IS NOT NULL") . ") AND `order`.`client` != '" . $_SESSION[UID] . "'";	
			}
			elseif ($this->id_role == 1 || $this->id_role == 5)
			{
				$sql_where .= " AND `order`.`client` = '" . $_SESSION[UID] . "'";
			}
			if (DEFAULT_PROFILE == 'stadium')
			{
				$sql_order .= "(SELECT
							GROUP_CONCAT(CONCAT_WS(0x00,`id_seat`,`id_trip`,`id_trip_seat`) SEPARATOR 0x01)
						 FROM
							`ticket`
						 WHERE `ticket`.`id_order` = `order`.`id_order`
						) as fix_seats,";
			}

			$s = "SELECT
					`order`.`id_order` as b_id,
					`order`.`client` as u_id,
					`order`.`from` as b_start_address,
					`order`.`from_lat` as b_start_latitude,
					`order`.`from_lng` as b_start_longitude,
					`order`.`to` as b_destination_address,
					`order`.`to_lat` as b_destination_latitude,
					`order`.`to_lng` as b_destination_longitude,
					`order`.`datetime_start_plan` as b_start_datetime,
					`order`.`comment` as b_custom_comment,
					`order`.`flight_number` as b_flight_number,
					`order`.`terminal` as b_terminal,
					`order`.`passenger_count` as b_passengers_count,
					`order`.`luggage_count` as b_luggage_count,
					`order`.`placard` as b_placard,
					`order`.`id_car_class` as b_car_class,
					" . $sql_order . "
					`order`.`tips` as b_tips,
					`order`.`id_order_status` as b_state,
					`order`.`rating` as b_rating,
					`order`.`create_datetime` as b_created,
					`order`.`is_confirmed` as b_confirm_state,
					`order`.`car_count` as b_cars_count,
					`order`.`cancel_reason` as b_cancel_reason,
					(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',
								`id_user`,
								`id_order_cancel`
							)
						SEPARATOR ';')
						FROM `order_cancel_items`
						WHERE `order_cancel_items`.`id_order` = `order`.`id_order`
						ORDER BY `id_user`
					) as b_cancel_states,
					`order`.`approve_datetime` as b_approved,
					`order`.`cancel_datetime` as b_canceled,
					`order`.`complete_datetime` as b_completed,
					`order`.`max_waiting_datetime` as b_max_waiting,
					(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',
								`interval`,
								`datetime`,
								`index`
							)
						SEPARATOR ';') 
					 FROM `order_waiting_time`
					 WHERE `order_waiting_time`.`id_order` = `order`.`id_order`
					) as b_max_waiting_list,				
					`order`.`estimated_waiting_datetime` as b_estimate_waiting,
					`order`.`options` as b_options,
					`order`.`contact` as b_contact,
					`order`.`id_order_location` as b_location_class,
					`order`.`distance_estimate` as b_distance_estimate,
					`order`.`price_estimate` as b_price_estimate,
					`order`.`currency` as b_currency,
					`order`.`night_time` as b_night,
					IF(`order_driver`.`id_order` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS(0x00,
								`order_driver`.`id_user`,
								`order_driver`.`id_car`,
								`order_driver`.`id_order_driver_status`,
								IFNULL(`users_location`.`lat`,''),
								IFNULL(`users_location`.`lng`,''),
								IFNULL(`users_location`.`datetime`,''),
								" . $sql_order_driver . "
								IFNULL(`order_driver`.`cancel_reason`,0x02),
								IFNULL(`order_driver`.`rating`,0x02),
								`order_driver`.`candidacy_datetime`,
								`order_driver`.`appoint_datetime`,
								`order_driver`.`cancel_datetime`,
								`order_driver`.`arrive_datetime`,
								`order_driver`.`start_datetime`,
								`order_driver`.`complete_datetime`,
								IFNULL(`order_driver`.`tips`,0x02),
								" . $sql_c_options . "
							)
						SEPARATOR 0x01) 
					) as drivers,
					(SELECT
						GROUP_CONCAT(`order_comment_items`.`id_order_comment` SEPARATOR ',')
					 FROM `order_comment_items`
					 WHERE `order_comment_items`.`id_order` = `order`.`id_order`
					) as b_comments,
					(SELECT
						GROUP_CONCAT(`order_service`.`id_service` SEPARATOR ',')
					 FROM `order_service`
					 WHERE `order_service`.`id_order` = `order`.`id_order`
					) as b_services
				FROM `order` 
				" . $sql_left_join . "
				LEFT JOIN `order_driver` USING (`id_order`)
				LEFT JOIN `users_location` ON `users_location`.`id_user` = `order_driver`.`id_user`
				WHERE	
					" . $sql_where . "
				GROUP BY `order`.`id_order`
				ORDER BY `order`.`last_edit_datetime` DESC
				LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('booking' => array());
			while ($d = fetch_assoc($q))
			{
				if (!empty($d['b_cancel_states']))
				{
					$b_c_s = explode(';',$d['b_cancel_states']);
					$d['b_cancel_states'] = array();
					foreach ($b_c_s as $key=>$value)
					{
						$b_c_s[$key] = array();
						list(
							$b_c_s[$key]['u_id'],
							$b_c_s[$key]['id_order_cancel']
							)= explode('|',$value);
						$d['b_cancel_states'][$b_c_s[$key]['u_id']][] = $b_c_s[$key]['id_order_cancel'];
					}
				}
				if (!empty($d['b_max_waiting_list']))
				{
					$b_m_w_l = explode(';',$d['b_max_waiting_list']);
					$d['b_max_waiting_list'] = array();
					foreach ($b_m_w_l as $key=>$value)
					{
						$b_m_w_l[$key] = array();
						list(
							$b_m_w_l[$key]['interval'],
							$b_m_w_l[$key]['datetime'],
							$b_m_w_l[$key]['index']
							)= explode('|',$value);	
						$d['b_max_waiting_list'][$b_m_w_l[$key]['index']] = array(
													'additional'	=>	$b_m_w_l[$key]['interval'],
													'created'		=>	$b_m_w_l[$key]['datetime']
						);
						add_time_zone($d['b_max_waiting_list'][$b_m_w_l[$key]['index']]['created']);
					}
				}

				if (!empty($d['b_attempts']))
				{
					$d['b_attempts'] = explode(';',$d['b_attempts']);
					foreach ($d['b_attempts'] as $key=>$value)
					{
						$d['b_attempts'][$key] = array();
						list(
							$d['b_attempts'][$key]['u_id'],
							$d['b_attempts'][$key]['datetime']
							)= explode('|',$value);
						add_time_zone($d['b_attempts'][$key]['datetime']);
					}
				}

				if (!empty($d['b_offers']))
				{
					$d['b_offers'] = explode(';',$d['b_offers']);
					foreach ($d['b_offers'] as $key=>$value)
					{
						$d['b_offers'][$key] = array();
						list(
							$d['b_offers'][$key]['u_id'],
							$d['b_offers'][$key]['created']
							)= explode('|',$value);
						add_time_zone($d['b_offers'][$key]['created']);
					}
				}

				if (isset($d['b_offer']))
				{
					$d['b_offer'] = (int)$d['b_offer'];
				}

				if (!empty($d['drivers']))
				{
					$d['drivers'] = explode(chr(1),$d['drivers']);
					foreach ($d['drivers'] as $key=>$value)
					{
						$d['drivers'][$key] = array();
						if ($this->id_role == 1 || $this->id_role == 5)
						{
							list(
								$d['drivers'][$key]['u_id'],
								$d['drivers'][$key]['c_id'],
								$d['drivers'][$key]['c_state'],
								$d['drivers'][$key]['c_latitude'],
								$d['drivers'][$key]['c_longitude'],
								$d['drivers'][$key]['l_datetime'],
								$d['drivers'][$key]['c_cancel_reason'],
								$d['drivers'][$key]['c_rating'],
								$d['drivers'][$key]['c_becomed_candidate'],
								$d['drivers'][$key]['c_appointed'],
								$d['drivers'][$key]['c_canceled'],
								$d['drivers'][$key]['c_arrived'],
								$d['drivers'][$key]['c_started'],
								$d['drivers'][$key]['c_completed'],
								$d['drivers'][$key]['c_tips'],
								$d['drivers'][$key]['c_options']
								)= explode(chr(0),$value);
						}
						else
						{
							list(
								$d['drivers'][$key]['u_id'],
								$d['drivers'][$key]['c_id'],
								$d['drivers'][$key]['c_state'],
								$d['drivers'][$key]['c_latitude'],
								$d['drivers'][$key]['c_longitude'],
								$d['drivers'][$key]['l_datetime'],
								$d['drivers'][$key]['c_payment_way'],
								$d['drivers'][$key]['c_payment_card'],
								$d['drivers'][$key]['c_payment_sum'],
								$d['drivers'][$key]['c_payment_datetime'],
								$d['drivers'][$key]['c_cancel_reason'],
								$d['drivers'][$key]['c_rating'],
								$d['drivers'][$key]['c_becomed_candidate'],
								$d['drivers'][$key]['c_appointed'],
								$d['drivers'][$key]['c_canceled'],
								$d['drivers'][$key]['c_arrived'],
								$d['drivers'][$key]['c_started'],
								$d['drivers'][$key]['c_completed'],
								$d['drivers'][$key]['c_tips'],
								$d['drivers'][$key]['c_options']
								)= explode(chr(0),$value);
								if ($d['drivers'][$key]['c_payment_card'] === chr(2))
								{
									$d['drivers'][$key]['c_payment_card'] = NULL;
								}
								if ($d['drivers'][$key]['c_payment_sum'] === chr(2))
								{
									$d['drivers'][$key]['c_payment_sum'] = NULL;
								}
								if ($this->id_role != 4 && $_SESSION[UID] != $d['drivers'][$key]['u_id'])
								{
									unset($d['drivers'][$key]['c_payment_way']);
									unset($d['drivers'][$key]['c_payment_card']);
									unset($d['drivers'][$key]['c_payment_sum']);
									unset($d['drivers'][$key]['c_payment_datetime']);
								}
								else
								{
									add_time_zone($d['drivers'][$key]['c_payment_datetime']);
								}
								if ($d['drivers'][$key]['c_options'] === chr(2))
								{
									unset($d['drivers'][$key]['c_options']);
								}
						}
						if ($d['drivers'][$key]['c_cancel_reason'] === chr(2))
						{
							$d['drivers'][$key]['c_cancel_reason'] = NULL;
						}
						if ($d['drivers'][$key]['c_rating'] === chr(2))
						{
							$d['drivers'][$key]['c_rating'] = NULL;
						}
						if ($d['drivers'][$key]['c_tips'] === chr(2))
						{
							$d['drivers'][$key]['c_tips'] = NULL;
						}

						if ($d['drivers'][$key]['c_arrived'] === '0000-00-00 00:00:00')
						{
							$d['drivers'][$key]['c_arrive_state'] = 0;
						}
						else
						{
							$d['drivers'][$key]['c_arrive_state'] = 1;
						}
						add_time_zone($d['drivers'][$key]['l_datetime']);
						add_time_zone($d['drivers'][$key]['c_becomed_candidate']);
						add_time_zone($d['drivers'][$key]['c_appointed']);
						add_time_zone($d['drivers'][$key]['c_canceled']);
						add_time_zone($d['drivers'][$key]['c_arrived']);
						add_time_zone($d['drivers'][$key]['c_started']);
						add_time_zone($d['drivers'][$key]['c_completed']);
						if (!empty($d['drivers'][$key]['c_options'])) $d['drivers'][$key]['c_options'] = json_decode($d['drivers'][$key]['c_options'],true);
					}
				}


				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);
				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);


				if ($d['b_max_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_max_waiting'] = NULL;
				}
				else
				{

					$d['b_max_waiting'] = strtotime($d['b_max_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}

				if ($d['b_estimate_waiting'] == '0000-00-00 00:00:00')
				{
					$d['b_estimate_waiting'] = NULL;
				}
				else
				{
					$d['b_estimate_waiting'] = strtotime($d['b_estimate_waiting']) - strtotime($d['b_start_datetime'] !== '0000-00-00 00:00:00' ? $d['b_start_datetime'] : $d['b_created']);
				}


				$d['b_options'] = json_decode($d['b_options'],true);

				$d['b_contact'] = json_decode($d['b_contact'],true);


				if (isset($d['b_services']) && @in_array('5', $d['b_services'])) {$d['b_voting'] = 1;}


				add_time_zone($d['b_start_datetime']);
				add_time_zone($d['b_created']);
				if ($this->id_role == 1 || $this->id_role == 4 || $this->id_role == 5)
				{
					add_time_zone($d['b_confirmation_limit']);
					add_time_zone($d['b_confirmation_datetime']);
					add_time_zone($d['b_payment_datetime']);
				}

				add_time_zone($d['b_approved']);
				add_time_zone($d['b_canceled']);
				add_time_zone($d['b_completed']);

				$d['b_confirm_state'] = (int)$d['b_confirm_state'];
				if ($d['b_night'] !== NULL) $d['b_night'] = (int)$d['b_night'];

				if (DEFAULT_PROFILE == 'stadium')
				{
					$fix_seats = array();
					if (!empty($d['fix_seats']))
					{
						$fix_seats = explode(chr(1),$d['fix_seats']);
						$d['fix_seats'] = array();
						foreach ($fix_seats as $key=>$value)
						{
							list(
								$id_seat,
								$id_trip,
								$id_trip_seat
								)= explode(chr(0),$value);
							$d['fix_seats'][$id_trip][$id_trip_seat] = $id_seat;
						}
						$fix_seats = $d['fix_seats'];
						unset($d['fix_seats']);
					}
					if (!empty($d['b_options']['tickets']['seats']))
					{
						$b_options_seats = $d['b_options']['tickets']['seats'];
						$d['b_options']['tickets']['seats'] = array();
						foreach($b_options_seats as $id_trip=>$seats)
						{
							if (is_array($seats))
							{
								foreach($seats as $seat=>$val)
								{
									$d['b_options']['tickets']['seats'][$id_trip][isset($fix_seats[$id_trip][$seat]) ? $fix_seats[$id_trip][$seat] : $seat] = $val;
								}
							}
							else
							{
								$d['b_options']['tickets']['seats'] = $seats;
							}
						}
					}
				}

				$out['booking'][$d['b_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['booking'] =  array_values($out['booking']);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,

									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function setLocation($lat = "", $lng = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			$s = "REPLACE INTO `users_location`
				SET 
					`id_user` = '" . $_SESSION[UID]  . "',
					`lat` = '" . $lat  . "',
					`lng` = '" . $lng  . "',
					`datetime` = now()
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database replace failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}
		
		public function confirmOrder($id_order = "", $estimated_waiting_time = NULL)
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			$s = "SELECT
					`id_order`,
					`client`,
					`id_order_status`,
					`is_confirmed`
				FROM `order` 		
				WHERE	
					`id_order` = '" . $id_order . "'
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
			if ($d['client'] != $_SESSION[UID]) 
			{
				return $this->showError('404', 'error', 'user is not author');

			}
			if ($d['id_order_status'] != 1 && $d['id_order_status'] != 2 && $d['id_order_status'] != 5
				&& $d['id_order_status'] != 6)
			{
				return $this->showError('404', 'error', 'wrong booking state');
			}		
			if (!empty($d['is_confirmed'])) return $this->showError('404', 'error', 'booking already confirmed');

			$s = "UPDATE `order`
				SET 
					`is_confirmed` = '1',
					`confirm_datetime` = now() " . ($estimated_waiting_time !== NULL ? ",
					`estimated_waiting_datetime` = IF(`datetime_start_plan` = 0,`create_datetime`,`datetime_start_plan`) + INTERVAL '" . $estimated_waiting_time . "' SECOND" : '') . ",
					`last_edit_datetime` = now(),
					`last_edit_user` = '" .  $_SESSION[UID] . "'
				WHERE
					`id_order` = '" . $id_order . "' AND `is_confirmed` = '0'
				";

			query($s);
	
			global $link;
			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database update failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'modified data not found');
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}
		
		public function startOrder($id_order = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 2)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			$s = "SELECT
					`order`.`id_order`,
					`order`.`id_order_status`,
					od.`id_user`,
					od.`id_order_driver_status`
				FROM `order` 
				LEFT JOIN (
						SELECT
							`id_order`,
							`id_user`,
							`id_order_driver_status`
						FROM
							`order_driver`
						WHERE
							`id_order` = '" . $id_order . "' AND `id_user` = '" . $_SESSION[UID] . "'
					) od USING (`id_order`)				
				WHERE	
					`order`.`id_order` = '" . $id_order . "'
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
			if ($d['id_order_status'] != 2) 
			{
				return $this->showError('404', 'error', 'wrong booking state');
			}
			if (empty($d['id_user'])) 
			{
				return $this->showError('404', 'error', 'user is not performer');
			}
			
			if ($d['id_order_driver_status'] == 1) 
			{
				return $this->showError('404', 'error', 'not appointed performer');
			}
			elseif ($d['id_order_driver_status'] == 2)
			{
				return $this->showError('404', 'error', 'canceled performer');
			}
			elseif ($d['id_order_driver_status'] == 5)
			{
				return $this->showError('404', 'error', 'already started ride');
			}
			elseif ($d['id_order_driver_status'] == 6)
			{
				return $this->showError('404', 'error', 'completed booking');
			}
			
			$s = "UPDATE `order`,`order_driver`
				SET 
					`order`.`last_edit_datetime` = now(),
					`order`.`last_edit_user` = '" .  $_SESSION[UID] . "',
					`order_driver`.`id_order_driver_status` = '5',
					`order_driver`.`start_datetime` = now()
				WHERE
					`order`.`id_order` = '" . $id_order . "' AND `order`.`id_order` = `order_driver`.`id_order` AND
					`order_driver`.`id_order` = '" . $id_order . "' AND 
					`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND
					`order_driver`.`id_order_driver_status` in (3,4)
				";

			query($s);
			global $link;
			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database update failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'modified data not found');
			}
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public $associativeArray = true;

		public function selectToken($id_user = "", $token = array())
		{
			if (empty($_SESSION[UID])) {
				if (!empty($_POST['auth_hash']))
				{
					list($_COOKIE[session_name()],$_COOKIE['vfoc']) = array_merge(explode('|', openssl____decrypt($_POST['auth_hash'])),array(''));
					if (!empty($_COOKIE[session_name()])) session_start();
					if (!empty($_SESSION[UID]))
					{
						if (empty($_COOKIE['vfoc']) 
							||$_COOKIE['vfoc'] != md5(session_id() . strtolower(dechex(crc32($_SESSION[UID])))) 
							|| empty($_SESSION['auth_time']) 
							|| time() > $_SESSION['auth_time'] + $this->constant['token_interval_for_auth_hash'])
						{

							session_unset();

						}
					}
				}

				if (empty($_SESSION[UID])) return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_user) || $id_user == 'authorized')
			{
				if (empty($token))
				{
					$token[0] = get_token($_SESSION[UID]);
					if (gettype($token[0]) !== 'string')
					{
						return $this->showError('404', 'error', 'token error: ' . $token[0]);
					}
					else
					{
						$token[1] = get_u_hash($token[0],$_SESSION[UID]);
					}
				}
			}
			else
			{
				return $this->showError('404', 'error', 'not enough rights');
			}
			
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	array('token' => $token[0], 'u_hash' => $token[1]),
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);

		}

		private $constant = array(
			'waiting_interval_or'					=>	array(
														'default'	=>	180,
														'type'		=>	'non-zero unsigned integer'
													),
			'waiting_interval'						=>	array(
														'default'	=>	180,
														'type'		=>	'unsigned integer'
													),
			'waiting_interval_add'					=>	array(
														'default'	=>	180,
														'type'		=>	'non-zero unsigned integer'
													),

			'token_interval_for_auth_hash'			=>	array(
														'default'	=>	10,
														'type'		=>	'unsigned integer'
													),

			'limit_row_count'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'limit_row_count_max'					=>	array(
														'default'	=>	30,
														'type'		=>	'non-zero unsigned integer'
													),

			'average_speed'							=>	array(
														'default'	=>	60,
														'type'		=>	'non-zero unsigned integer'
													),

			'rating_max_b_c'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_b_d'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_b_a'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_u_c'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_u_d'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_u_a'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_s_c'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_s_d'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'rating_max_s_a'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),
			'priority_max_t'						=>	array(
														'default'	=>	5,
														'type'		=>	'non-zero unsigned integer'
													),

			'driver_code_attempt_count_max'			=>	array(
														'default'	=>	3,
														'type'		=>	'unsigned integer'
													),
			'driver_code_only_numbers'				=>	array(
														'default'	=>	true,
														'type'		=>	'boolean'
													),
			'driver_code_length'					=>	array(
														'default'	=>	1,
														'type'		=>	'non-zero unsigned integer'
													),

			'waiting_interval_any'					=>	array(
														'default'	=>	86400,
														'type'		=>	'non-zero unsigned integer'
													),

			'attachment_file_max_size'				=>	array(
														'default'	=>	5242880,
														'type'		=>	'unsigned integer'
													),
			'attachment_file_max_size_sum'			=>	array(
														'default'	=>	10485760,
														'type'		=>	'unsigned integer'
													),
			'attachment_file_max_count'				=>	array(
														'default'	=>	4,
														'type'		=>	'unsigned integer'
													),
			'attachment_file_allow'					=>	array(
														'default'	=>	true,
														'type'		=>	'boolean'
													),

			'max_active_drive_count_client'			=>	array(
														'default'	=>	2,
														'type'		=>	'unsigned integer'
													),
			'max_active_drive_count_ip'				=>	array(
														'default'	=>	10,
														'type'		=>	'unsigned integer'
													),

			'work_geojson'							=>	array(
														'default'	=>	'',
														'type'		=>	'json',
														'required'	=> array(
																		array('type'),
																		array('coordinates')
																	)
													),
			'work_geojson_border_width'				=>	array(
														'default'	=>	0,
														'type'		=>	'unsigned integer'
													),

			'max_cancel_count_client'				=>	array(
														'default'	=>	5,
														'type'		=>	'unsigned integer'
													),
			'max_cancel_count_driver'				=>	array(
														'default'	=>	15,
														'type'		=>	'unsigned integer'
													),

			'max_cancel_count_ban_duration_client'	=>	array(
														'default'	=>	36000,
														'type'		=>	'non-zero unsigned integer'
													),
			'max_cancel_count_ban_duration_driver'	=>	array(
														'default'	=>	36000,
														'type'		=>	'non-zero unsigned integer'
													),
			'auto_cancel_time'						=>	array(
														'default'	=>	86400,
														'type'		=>	'unsigned integer'
													),
			'auto_complete_time'					=>	array(
														'default'	=>	172800,
														'type'		=>	'unsigned integer'
													),
			'max_active_drive_count_duration_ip'	=>	array(
														'default'	=>	18000,
														'type'		=>	'non-zero unsigned integer'
													),

			'set_performer_appointed_allow'			=>	array(
														'default'	=>	true,
														'type'		=>	'boolean'
													),

			'd_s_bot'								=>	array(
														'default'	=>	false,
														'type'		=>	'boolean'
													),

			'start_of_night_time'					=>	array(
														'default'	=>	'20:00',
														'type'		=>	'H:i'
													),	
			'the_end_of_the_night_time'				=>	array(
														'default'	=>	'05:00',
														'type'		=>	'H:i'
													),		
			'extra_charge_for_night_time'			=>	array(
														'default'	=>	2,
														'type'		=>	'unsigned float'
													),	
			'courier_call_rate'						=>	array(
														'default'	=>	10,
														'type'		=>	'unsigned float'
													),			
			'courier_fare_per_1_km'					=>	array(
														'default'	=>	2.5,
														'type'		=>	'unsigned float'
													),
			'distance_coefficient'					=>	array(
														'default'	=>	1,
														'type'		=>	'non-zero unsigned float'
													),
			'b_options_valid_keys'					=>	array(
														'default'	=>	array(),
														'type'		=>	'json multidimensional associative list'
													),								
			'c_options_valid_keys'					=>	array(
														'default'	=>	array(),
														'type'		=>	'json multidimensional associative list'
													),	
			'u_details_valid_keys'					=>	array(
														'default'	=>	array(),
														'type'		=>	'json multidimensional associative list'
													),	
			'b_options_edit_list_keys'				=>	array(
														'default'	=>	array(),
														'type'		=>	'json multidimensional associative list'
													),	
			'b_options_edit_list_readonly'			=>	array(
														'default'	=>	false,
														'type'		=>	'boolean'
													),
			'c_options_edit_list_keys'				=>	array(
														'default'	=>	array(),
														'type'		=>	'json multidimensional associative list'
													),
			'c_options_edit_list_readonly'			=>	array(
														'default'	=>	false,
														'type'		=>	'boolean'
													),
			't_options_valid_keys'					=>	array(
														'default'	=>	array(),
														'type'		=>	'json multidimensional associative list'
													),
			't_options_edit_list_keys'				=>	array(
														'default'	=>	array(),
														'type'		=>	'json multidimensional associative list'
													),		
			't_options_edit_list_readonly'			=>	array(
														'default'	=>	false,
														'type'		=>	'boolean'
													),
			'start_datetime_interval'				=>	array(
														'default'	=>	86400,
														'type'		=>	'unsigned integer'
													),
			'auth_code_interval'			=>	array(
														'default'	=>	600,
														'type'		=>	'unsigned integer'
													),
			'ticket_booking_duration'			=>	array(
														'default'	=>	3600,
														'type'		=>	'unsigned integer'
													),		
			'query_extended_statements'			=>	array(
														'default'	=>	false,
														'type'		=>	'boolean'
													),
			'email_date_format'			=>	array(
														'default'	=>	'Y-m-d H:i:s',
														'type'		=>	'date format'
													),
			'order_payment'				=>	array(
														'default'	=>	0,
														'type'		=>	'unsigned integer'
													),								
			'session_token_duration'	=>	array(
														'default'	=>	86400,
														'type'		=>	'unsigned integer'
													),
			'placing_order_duration'	=>	array(
														'default'	=>	300,
														'type'		=>	'unsigned integer'
													)
		);
		
		private $car_class = array();

		public function editWaitingTime($id_order = "", $previous = NULL, $additional = NULL)
		{
			if ($previous === NULL) return $this->showError('404', 'error', 'empty previous');
			if ($additional === NULL) $additional = $this->constant['waiting_interval_add'];

			$additional = (int)$additional;
			if (empty($additional)) return $this->showError('404', 'error', 'empty additional');
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			$s = "SELECT
					`order`.`id_order`,
					`order`.`client`,
					`order`.`id_order_status`,
					TIMESTAMPDIFF(SECOND,IF(`order`.`datetime_start_plan` = 0,`order`.`create_datetime`,`order`.`datetime_start_plan`),`order`.`max_waiting_datetime`) as max_waiting_time,
					MAX(`order_waiting_time`.`index`) as max_index
				FROM `order` 
				LEFT JOIN `order_waiting_time` USING (`id_order`)		
				WHERE	
					`order`.`id_order` = '" . $id_order . "'
				LIMIT 1
				FOR UPDATE
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
			if ($d['client'] != $_SESSION[UID]) 
			{
				return $this->showError('404', 'error', 'user is not author');
			}
			if ($d['id_order_status'] != 1 && $d['id_order_status'] != 5 && $d['id_order_status'] != 6) 
			{
				return $this->showError('404', 'error', 'wrong booking state');
			}	

			$d['max_waiting_time'] = (int)$d['max_waiting_time'];
			$previous = (int)$previous;
			if ($d['max_waiting_time'] !== $previous)
			{
				return $this->showError('404', 'error', 'wrong previous');
			}
			$d['max_index'] = (int)$d['max_index'];

			$s = "INSERT INTO `order_waiting_time`
				SET 
					`id_order` = '" . $id_order . "',
					`interval` = '" . $additional . "',
					`datetime` = now(),
					`index` = '" . ($d['max_index'] + 1) . "'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database insert failed');
			
			$s = "UPDATE `order`
				SET 
					`max_waiting_datetime` =  IF(`datetime_start_plan` = 0,`create_datetime`,`datetime_start_plan`) + INTERVAL '" . ($previous + $additional) . "' SECOND,
					`last_edit_datetime` = now(),
					`last_edit_user` = '" .  $_SESSION[UID] . "'
				WHERE
					`id_order` = '" . $id_order . "'
				";

			query($s);
	
			global $link;

			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database update failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'modified data not found');

			}

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		private $limit_offset = 0;
		private $limit_row_count = NULL;

		public function tuneLimit($lo = NULL, $lc = NULL)
		{
			if ($lo !== NULL) $this->limit_offset = abs((int)$lo);
			if ($lc ===	NULL)
			{
				$this->limit_row_count = $this->constant['limit_row_count'];
			}
			else
			{
				$lc = abs((int)$lc);
				$this->limit_row_count = min($lc,$this->constant['limit_row_count_max']);
			}

		}

		public function __construct($constant = array(), $car_class = array())
		{
			foreach($this->constant as $key=>$val){
				switch ($this->constant[$key]['type']) {
					case 'unsigned integer':
						if (isset($constant[$key]['value'])) 
						{
							$this->constant[$key] = abs((int)$constant[$key]['value']);
						}
						break;
					case 'non-zero unsigned integer':
						if (!empty($constant[$key]['value'])) 
						{
							$this->constant[$key] = abs((int)$constant[$key]['value']) ? : $this->constant[$key]['default'];
						}
						break;
					case 'unsigned float':
						if (isset($constant[$key]['value'])) 
						{
							$this->constant[$key] = abs((float)$constant[$key]['value']);
						}
						break;				
					case 'non-zero unsigned float':
						if (!empty($constant[$key]['value'])) 
						{
							$this->constant[$key] = abs((float)$constant[$key]['value']) ? : $this->constant[$key]['default'];
						}
						break;				
					case 'boolean':
						if (isset($constant[$key]['value'])) 
						{
							$this->constant[$key] = (bool)$constant[$key]['value'];
						}
						break;
					case 'json':
						if (!empty($constant[$key]['value']))
						{
							$json = json_decode($constant[$key]['value'],true);
							if (is_array($json))
							{
								while (true) {
									foreach($this->constant[$key]['value']['required'] as $json_keys)
									{
										$json_temp = $json;
										foreach($json_keys as $json_key)
										{
											if (empty($json_temp[$json_key])) break 3;
											$json_temp = $json_temp[$json_key];
										}
									}
									$this->constant[$key] = $json;
								}
							}
						}
						break;
					case 'H:i':
						if (isset($constant[$key]['value'])) 
						{
							preg_match('/^\s*([0-9]{1,2})\:([0-9]{1,2})\s*$/',$constant[$key]['value'],$border);
							if (!empty($border))
							{
								$this->constant[$key] = str_pad($border[1],2,'0',STR_PAD_LEFT) . ':' . str_pad($border[2],2,'0',STR_PAD_LEFT);
							}
						}
						break;
					case 'json array list':
						if (isset($constant[$key]['value'])) 
						{
							@$array_list = json_decode($constant[$key]['value'],true);
							if (is_array($array_list))
							{
								$this->constant[$key] = array();
								foreach($array_list as $value)
								{
									$this->constant[$key][$value] = true;
								}
							}
						}
						break;
					case 'json associative list':
						if (isset($constant[$key]['value'])) 
						{
							@$associative_list = json_decode($constant[$key]['value'],true);
							if (is_array($associative_list))
							{
								$this->constant[$key] = array();
								foreach($associative_list as $a_key => $value)
								{
									$this->constant[$key][$a_key] = true;
								}
							}
						}
						break;
					case 'json multidimensional associative list':
						if (isset($constant[$key]['value'])) 
						{
							@$associative_list = json_decode($constant[$key]['value'],true);
							if (is_array($associative_list))
							{
								$this->constant[$key] = validate_multi_assoc_list($associative_list);
							}
						}
						break;
					default:
						if (isset($constant[$key]['value'])) 
						{
							$this->constant[$key] = $constant[$key]['value'];
						}
				}
				
				if (!empty($this->constant[$key]['type'])) $this->constant[$key] = $this->constant[$key]['default'];
			}

			$this->limit_row_count = $this->constant['limit_row_count'];

			$this->car_class = $car_class;
		}
		
		public function setCarUsed($id_car = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 2)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}
			if ($_SESSION['id_verification_status'] != 2)
			{
				return $this->showError('404', 'error', 'wrong user check state');
			}

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');
			
			$s = "SELECT
					`car`.`id_car`,
					GROUP_CONCAT(IF(`car_users`.`id_user` = '" . $_SESSION[UID] . "',`car_users`.`id_user`,NULL) SEPARATOR ',') as u_id,
					GROUP_CONCAT(IF(`car_users`.`used` = '1',`car_users`.`id_user`,NULL) SEPARATOR ',') as u_d_id
				FROM `car`
				LEFT JOIN `car_users` USING (`id_car`)
				WHERE
					`car`.`id_car` = '" . $id_car . "'
				GROUP BY
					`car_users`.`id_car`
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_car'])) 
			{
				return $this->showError('404', 'error', 'car not found');
			}
			if (empty($d['u_id'])) 
			{
				return $this->showError('404', 'error', 'car is not this driver');
			}
			if ($d['u_d_id'] === $_SESSION[UID]) 
			{
				return $this->showError('404', 'error', 'car is already driven by this user');
			}
			elseif (!empty($d['u_d_id']))
			{
				return $this->showError('404', 'error', 'car is already driven');
			}

			global $link;

			$s = "UPDATE `car_users`
				SET 
					`used` = NULL
				WHERE
					`id_user` = '" . $_SESSION[UID] . "' AND `id_car` != '" . $id_car . "' AND `used` = '1'
				";

			query($s);

			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'update of database failed');
			}
			
			$s = "UPDATE `car_users`
				SET 
					`used` = '1'
				WHERE
					`id_car` = '" . $id_car . "' AND `id_user` = '" . $_SESSION[UID] . "'
				";

			query($s);
			
			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database update failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'modified data not found');
			}

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function remind($email = "", $phone = "", $tg = "", $wa = "")
		{
		
			$phone = preg_replace('/[^0-9]+/','',$phone);
			while (true){
				$u_data = array('email','phone','tg','wa');
				foreach($u_data as $u_str)
				{
					if (empty($$u_str)) continue;
					$sql = "`$u_str` = '" . $$u_str . "'";
					break 2;
				}
				return array('error' => 'empty user login');
			}

			$s = "SELECT 
					`id_user`,
					`deleted`,
					`name`,
					`family`,
					`middle`,
					`email`
				FROM `users`
				WHERE 
					$sql
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			$d = fetch_assoc($q);

			if (empty($d['id_user']))
			{
				return $this->showError('404', 'error', 'wrong login');
			}
			elseif (!empty($d['deleted']))
			{
				return $this->showError('404', 'error', 'deleted user');
			}
			$user_ban_status = get_user_ban_status($d['id_user']);
			if (!empty($user_ban_status['auth']))
			{
				return $this->showError('404', 'error', 'banned user');
			}

			$pwd = generate_password(10);

			$s = "UPDATE `users`
				SET 
					`pwd` = '" . md5(md5($pwd)) . "'
				WHERE
					`id_user` = '" . $d['id_user'] . "'
				";

			query($s);
		
			if ($q === false) return $this->showError('404', 'error', 'database update failed');

			if (!empty($d['email']))
			{
			
				$dataForEmail = array(
					'{$u_id}' 			=> $d['id_user'],
					'{$password}' 		=> $pwd,			
					'{$locationPath}' 	=> url('',CONFIG_URL),
					'{$u_name}' 		=> $d['name'],
					'{$u_family}' 		=> $d['family'],
					'{$u_middle}' 		=> $d['middle']
				);
				
				$subject = lang('email_remind_subject','New password for user {$u_id} from {$locationPath}',2);
				$body = lang('email_remind_body','Password: {$password}',2);
				list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);
			
				$emailStatus = send_mail($d['email'],$subject,$body);
				if ($emailStatus === false) return $this->showError('404', 'error', 'sending message failed');
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
			
		}

		public function newpass($password = "", $new_password = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			$s = "SELECT 
					`id_user`
				FROM `users`
				WHERE 
					`id_user` = '" . $_SESSION[UID] . "' AND `pwd` = '" . md5(md5($password)) . "'
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			$d = fetch_assoc($q);

			if (empty($d['id_user']))
			{
				return $this->showError('404', 'error', 'wrong password');
			}

			$s = "UPDATE `users`
				SET 
					`pwd` = '" . md5(md5($new_password)) . "'
				WHERE
					`id_user` = '" . $_SESSION[UID] . "'
				";

			query($s);
		
			if ($q === false) return $this->showError('404', 'error', 'database update failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);			
		}

		public function sendMailToSite($site_email = array(), $id_site_email = "", $subject = "", $body = "", $file = '')
		{
			if (empty($site_email[$id_site_email]))
			{
				return $this->showError('404', 'error', 'wrong id');
			}
			if (empty($site_email[$id_site_email]['value']))
			{
				return $this->showError('404', 'error', 'empty address for this id');
			}

			$file_decoded = array();
			if (!empty($file))
			{
				@$file = json_decode($file,true);
				
				if (empty($file) || !is_array($file)) 
				{
					return $this->showError('404', 'error', 'wrong file data');
				}
				$i = 0;
				foreach ($file as $f)
				{
					if (isset($f['base64']))
					{
						@$content = (string)$f['base64'];
						list($type, $content) = array_merge(explode(';', $content),array(''));
						list(, $content) = array_merge(explode(',', $content),array(''));
						$content = base64_decode($content);
						if (gettype($content) !== 'string') return $this->showError('404', 'error', 'wrong base64');
					}
					else
					{
						return $this->showError('404', 'error', 'base64 key not found');

					}
					if (isset($f['name']))
					{
						@$filename = (string)$f['name'];

						if (strlen($filename) === 0) $filename = 'file' . $i;
					}
					else
					{
						$filename = 'file' . $i;
					}
					$file_decoded[] = array('content' => $content, 'name' => $filename);
					$i++;
				}
			}

			$body = preg_replace_callback('/(<)script(?:\s*|[^>]+\s*=\s*(?:"[^"]*"|\'[^\']*\'|[^>"\'\s]*))*(>)[\s\S]*?(<\/script\s*>)/',function($matches){return htmlspecialchars($matches[0]);},$body);

			$emailStatus = send_mail($site_email[$id_site_email]['value'],$subject,$body,$file_decoded);

			if (empty($emailStatus)) return $this->showError('404', 'error', 'send failed');
			
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'

			);
		}
		
		public function editOrder($data = "", $id_order = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(
									'b_start_address'			=>		'from',
									'b_start_latitude'			=>		'from_lat',
									'b_start_longitude'			=>		'from_lng',
									'b_destination_address'		=>		'to',
									'b_destination_latitude'	=>		'to_lat',
									'b_destination_longitude'	=>		'to_lng',
									'b_start_datetime'			=>		'datetime_start_plan',
									'b_custom_comment'			=>		'comment',
									'b_flight_number'			=>		'flight_number',
									'b_terminal'				=>		'terminal',
									'b_passengers_count'		=>		'passenger_count',
									'b_luggage_count'			=>		'luggage_count',
									'b_placard'					=>		'placard',
									'b_car_class'				=>		'id_car_class',
									'b_payment_way'				=>		'id_payment_method',
									'b_payment_card'			=>		'id_payment_card',
									'b_tips'					=>		'tips',
									'b_cars_count'				=>		'car_count',
//									'b_max_waiting'				=>		true,
									'b_options'					=>		'options',
//									'b_comments'				=>		true,
//									'b_services'				=>		true,
									'b_contact'					=>		'contact'





			);
		
			$forbidden_fields = array();
			$affected_fields = array();
			$affected_keys = array();
			$filtered_data = array();
			$wrong_data_fields = array();

			if ($this->id_role == 1 || $this->id_role == 5)
			{

				$s = "SELECT
						`order`.`id_order`,
						`order`.`client`,
						`order`.`id_order_status`,
						COUNT(IF(`order_driver`.`id_order_driver_status` in (5,6),1,NULL)) as started,
						`order`.`night_time`,
						`order`.`distance_estimate`,
						`order`.`id_car_class`,
						`order`.`from_lat`,
						`order`.`from_lng`,
						`order`.`to_lat`,
						`order`.`to_lng`,
						`order`.`car_count`,
						`order`.`datetime_start_plan`,
						GROUP_CONCAT(`order_driver`.`id_car`) as cars,
						`order`.`options`
					FROM `order` 
					LEFT JOIN `order_driver` USING (`id_order`)	
					WHERE	
						`id_order` = '" . $id_order . "'
					LIMIT 1
					FOR UPDATE
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['client'] != $_SESSION[UID]) 
				{
					return $this->showError('404', 'error', 'user is not author');
				}
				$d['options'] = json_decode($d['options'],true);

				switch ($d['id_order_status']) {
					case '1':
						$allowed_fields = array(
												'b_start_address'			=>		'from',				
												'b_start_latitude'			=>		'from_lat',
												'b_start_longitude'			=>		'from_lng',
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'b_options'					=>		'options'
						);
						break;
					case '2':
						$allowed_fields = array(
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'b_options'					=>		'options'

						);
						if (empty($d['started']))
						{
							$allowed_fields['b_start_address'] = 'from';
							$allowed_fields['b_start_latitude'] = 'from_lat';
							$allowed_fields['b_start_longitude'] = 'from_lng';
						}
						break;
					case '5':
						$allowed_fields = array(
												'b_start_address'			=>		'from',						
												'b_start_latitude'			=>		'from_lat',
												'b_start_longitude'			=>		'from_lng',
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'b_options'					=>		'options'
						);
						break;
					case '6':
						$allowed_fields = array(
												'b_start_address'			=>		'from',						
												'b_start_latitude'			=>		'from_lat',
												'b_start_longitude'			=>		'from_lng',
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'b_options'					=>		'options'
						);
						break;
					default:
						return $this->showError('404', 'error', 'wrong booking state');
				}

				foreach ($data as $key => $value)
				{
					if (!empty($allowed_fields[$key]))
					{
						if (is_string($value)) $data[$key] = trim($value);
						$affected_fields[] = $key;
						$affected_keys[$key] = true;
						if ($allowed_fields[$key] !== true) $filtered_data[$allowed_fields[$key]] = $data[$key];
					}
					else
					{
						$forbidden_fields[] = $key;
					}
				}
				
				if (empty($affected_fields)) return $this->showError('404', 'error', 'allowed data not found');
				
				if (!empty($affected_keys['b_options']))
				{
					$options = $d['options'];
					if (!is_array($filtered_data['options'])) return $this->showError('404', 'error', 'b_options not array');
					$options_is_updated = false;
					foreach($filtered_data['options'] as $options_element)
					{
						if (!is_array($options_element)) return $this->showError('404', 'error', 'b_options element not array');
						if (empty($options_element[0]))	return $this->showError('404', 'error', 'b_options element without operator');
						$options_element[0] = trim($options_element[0]);
						switch ($options_element[0]){
							case '=':
								if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty b_options element keys for assignment');
								if (!is_array($options_element[1])) return $this->showError('404', 'error', 'b_options element keys for assignment not array');
								if (!isset($options_element[2])) return $this->showError('404', 'error', 'empty b_options element value for assignment');
								$options_prev = $options;
								$arr_o = &$options;
								$check_create_list = $check_edit_list = false;
								if (!empty($this->constant['b_options_valid_keys'])) 
								{
									$arr_v = $this->constant['b_options_valid_keys'];
									$check_create_list = true;
								}
								if (!empty($this->constant['b_options_edit_list_keys'])) 
								{
									$arr_e = $this->constant['b_options_edit_list_keys'];
									$check_edit_list = true;
								}
								$options_element_is_updated = false;
								foreach($options_element[1] as $options_key)
								{
									@$options_key = (string)$options_key;
									if (!is_array($arr_o)) 
									{
										return $this->showError('404', 'error', 'b_options value for element key' . $options_key . ' for assignment not array');
									}
									if ($check_create_list === true)
									{
										if (!array_key_exists($options_key,$arr_v)) return $this->showError('404', 'error', 'wrong b_options element keys for assignment');
										$arr_v = $arr_v[$options_key];
										if ($arr_v === true) 
										{
											$check_create_list = false;
										}
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['b_options_edit_list_readonly']))
										{				
											if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 'b_options element keys for assignment not editable');
											$arr_e = $arr_e[$options_key];
											if ($arr_e === true) 
											{
												$check_edit_list = false;
											}
										}
										else
										{
											if (array_key_exists($options_key,$arr_e))
											{
												$arr_e = $arr_e[$options_key];
											}
											else
											{
												$check_edit_list = false;
											}
											if ($arr_e === true) return $this->showError('404', 'error', 'b_options element keys for assignment readonly');
										}
									}
									if (!array_key_exists($options_key,$arr_o)) 
									{
										$arr_o[$options_key] = array();
										$options_element_is_updated = true;
									}
									$arr_o = &$arr_o[$options_key];
								}
								if ($arr_o !== $options_element[2])
								{				
									$arr_o = $options_element[2];
									$add = $options_element[2];								
									if ($check_create_list === true)
									{
										if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong b_options element value keys for assignment');
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['b_options_edit_list_readonly']))
										{
											if (array_includes_only_add_keys_from_assoc_list($add,$arr_e) === false) return $this->showError('404', 'error', 'b_options element value keys for assignment not editable');
										}
										else
										{
											if (array_includes_add_keys_from_assoc_list($add,$arr_e) === true) return $this->showError('404', 'error', 'b_options element value keys for assignment readonly');
										}
									}
									$check_create_list = false;
									$check_edit_list = false;
									$options_element_is_updated = true;
								}
								unset($arr_o);
								if ($options_element_is_updated === true && $check_create_list === false &&  $check_edit_list === false) 
								{
									$options_is_updated = true;
								}
								else
								{
									$options = $options_prev;
								}
								break;
							case '+':
								if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty b_options element keys for addition');
								if (!is_array($options_element[1])) return $this->showError('404', 'error', 'b_options element keys for addition not array');
								if (!isset($options_element[2])) return $this->showError('404', 'error', 'empty b_options element value for addition');
								$options_prev = $options;
								$arr_o = &$options;
								$check_create_list = $check_edit_list = false;
								if (!empty($this->constant['b_options_valid_keys'])) 
								{
									$arr_v = $this->constant['b_options_valid_keys'];
									$check_create_list = true;
								}
								if (!empty($this->constant['b_options_edit_list_keys'])) 
								{
									$arr_e = $this->constant['b_options_edit_list_keys'];
									$check_edit_list = true;
								}
								$options_element_is_updated = false;
								foreach($options_element[1] as $options_key)
								{
									@$options_key = (string)$options_key;
									if (!is_array($arr_o)) 
									{
										return $this->showError('404', 'error', 'b_options value for element key' . $options_key . ' for addition not array');
									}
									if ($check_create_list === true)
									{
										if (!array_key_exists($options_key,$arr_v)) return $this->showError('404', 'error', 'wrong b_options element keys for addition');
										$arr_v = $arr_v[$options_key];
										if ($arr_v === true) 
										{
											$check_create_list = false;
										}
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['b_options_edit_list_readonly']))
										{				
											if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 'b_options element keys for addition not editable');
											$arr_e = $arr_e[$options_key];
											if ($arr_e === true) 
											{
												$check_edit_list = false;
											}
										}
										else
										{
											if (array_key_exists($options_key,$arr_e))
											{
												$arr_e = $arr_e[$options_key];
											}
											else
											{
												$check_edit_list = false;
											}
											if ($arr_e === true) return $this->showError('404', 'error', 'b_options element keys for addition readonly');
										}
									}
									if (!array_key_exists($options_key,$arr_o)) 
									{
										$arr_o[$options_key] = array();
										$options_element_is_updated = true;
									}
									$arr_o = &$arr_o[$options_key];
								}
								if (is_array($arr_o))
								{
									$arr_o[] = $options_element[2];
									end($arr_o);
									$add = array(key($arr_o)=>$options_element[2]);								
									if ($check_create_list === true)
									{
										if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong b_options element value keys for addition');
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['b_options_edit_list_readonly']))
										{
											if (array_includes_only_add_keys_from_assoc_list($add,$arr_e) === false) return $this->showError('404', 'error', 'b_options element value keys for addition not editable');
										}
										else
										{
											if (array_includes_add_keys_from_assoc_list($add,$arr_e) === true) return $this->showError('404', 'error', 'b_options element value keys for addition readonly');
										}
									}
									$check_create_list = false;
									$check_edit_list = false;
									$options_element_is_updated = true;
								}
								else
								{
									if ($check_create_list === false && $check_edit_list === false)
									{
										if (is_array($options_element[2]))
										{
											$arr_o .= json_encode($options_element[2]);
										}
										else
										{
											$arr_o .= $options_element[2];
										}
										$options_element_is_updated = true;
									}
									else
									{
										return $this->showError('404', 'error', 'wrong b_options structure for addition');
									}
								}
								unset($arr_o);
								if ($options_element_is_updated === true && $check_create_list === false &&  $check_edit_list === false) 
								{
									$options_is_updated = true;
								}
								else
								{
									$options = $options_prev;
								}
								break;
							case '-':
								if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty b_options element keys for removal');
								if (!is_array($options_element[1])) return $this->showError('404', 'error', 'b_options element keys for removal not array');
								if (empty($options_element[1]) || !is_array($options) || empty($options)) break;
								$arr_o = &$options;
								$check_edit_list = false;
								if (!empty($this->constant['b_options_edit_list_keys'])) 
								{
									$arr_e = $this->constant['b_options_edit_list_keys'];
									$check_edit_list = true;
								}
								$count_key = count($options_element[1]);
								$i = 0;
								$options_element_is_updated = true;
								foreach($options_element[1] as $options_key)
								{
									@$options_key = (string)$options_key;
									$i++;
									if (!is_array($arr_o) || !array_key_exists($options_key,$arr_o)) 
									{
										$check_edit_list = false;
										$options_element_is_updated = false;

										break;
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['b_options_edit_list_readonly']))
										{				
											if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 'b_options element keys for removal not editable');
											$arr_e = $arr_e[$options_key];
											if ($arr_e === true) 
											{
												$check_edit_list = false;
											}
										}
										else
										{
											if (array_key_exists($options_key,$arr_e))
											{
												$arr_e = $arr_e[$options_key];
											}
											else
											{
												$check_edit_list = false;
											}
											if ($arr_e === true) return $this->showError('404', 'error', 'b_options element keys for removal readonly');
										}
									}
									if ($i < $count_key) {$arr_o = &$arr_o[$options_key];}
								}
								if ($check_edit_list === true)
								{
									return $this->showError('404', 'error', 'b_options element keys for removal part of not editable or readonly');
								}
								if ($options_element_is_updated === true) 
								{
									unset($arr_o[$options_key]);
									$options_is_updated = true;
								}
								unset($arr_o);
								break;
							default:
								return $this->showError('404', 'error', 'wrong b_options element operator');
						}
					}
					if ($options_is_updated === true)
					{
						$filtered_data['options'] = real_escape_string(json_encode($options));
					}
					else
					{
						unset($filtered_data['options']);
					}
				}
				if (!empty($affected_keys['b_contact']))
				{
					$filtered_data['contact'] = real_escape_string(json_encode($filtered_data['contact']));
				}

				$s_edit_o_d = $s_add = "";
				if (isset($filtered_data['from_lat']) || isset($filtered_data['from_lng'])
					|| isset($filtered_data['to_lat']) || isset($filtered_data['to_lng']))
				{
					$from_lat = isset($filtered_data['from_lat']) ? $filtered_data['from_lat'] : $d['from_lat'];
					$from_lng = isset($filtered_data['from_lng']) ? $filtered_data['from_lng'] : $d['from_lng'];
					$to_lat = isset($filtered_data['to_lat']) ? $filtered_data['to_lat'] : $d['to_lat'];
					$to_lng = isset($filtered_data['to_lng']) ? $filtered_data['to_lng'] : $d['to_lng'];
					$place_from = get_place($from_lat,$from_lng);
					$place_to = get_place($to_lat,$to_lng );

					$filtered_data['night_time'] = NULL;
					$filtered_data['distance_estimate'] = NULL;	
					$filtered_data['price_estimate'] = NULL;
					$s_edit_o_d = "UPDATE `order_driver`
								SET
									`price_estimate` = NULL
								WHERE `id_order` = '" . $id_order . "'
								";
					$s_add = ",
						`price_estimate` = IF(`id_car_class` IS NULL,
							(SELECT 
								SUM(`price_estimate`)
							 FROM `order_driver`
							 WHERE
								`id_order` = '" . $id_order . "' AND 
								`id_order_driver_status` in (3,4,5,6)
							),`price_estimate`)
						";

					if (!empty($place_from) && !empty($place_to) && $place_from['id'] == $place_to['id'])
					{
						$distance_estimate = get_distance($place_from['id'],lat_lng_to_square($from_lat,$from_lng,$place_from),lat_lng_to_square($to_lat,$to_lng,$place_from));
						if (gettype($distance_estimate) === 'double') 
						{
							$filtered_data['distance_estimate'] = $distance_estimate;					
						}
					}

					if ($d['datetime_start_plan'] !== '0000-00-00 00:00:00' && (!empty($place_from) || !empty($place_to)))
					{			
						 if (!empty($place_from)) 
						 {
							$timezone = $place_from['timezone'];
						 }
						 elseif (!empty($place_to))
						 {
							$timezone = $place_to['timezone'];
						 }
						
						preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',$timezone,$parsed_time_zone);
						$h = gmdate("H:i",strtotime($d['datetime_start_plan'] . MYSQL_TIME_ZONE) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
						$extra_charge_for_night_time = 1;
						$filtered_data['night_time'] = 0;
						if ($this->constant['the_end_of_the_night_time'] > $this->constant['start_of_night_time'])
						{
							if ($h >= $this->constant['start_of_night_time'] && $h < $this->constant['the_end_of_the_night_time']) 
							{
								$extra_charge_for_night_time = $this->constant['extra_charge_for_night_time'];
								$filtered_data['night_time'] = 1;
							}
						}
						else
						{
							if ($h >= $this->constant['start_of_night_time'] || $h < $this->constant['the_end_of_the_night_time']) 
							{
								$extra_charge_for_night_time = $this->constant['extra_charge_for_night_time'];
								$filtered_data['night_time'] = 1;
							}
						}

						if (isset($filtered_data['distance_estimate']))
						{
							if (isset($d['id_car_class']))
							{
								if (!empty($this->car_class[$d['id_car_class']]))
								{
									$courier_call_rate = (float)$this->car_class[$d['id_car_class']]['courier_call_rate'];
									$courier_fare_per_1_km = (float)$this->car_class[$d['id_car_class']]['courier_fare_per_1_km'];			
									
									$filtered_data['price_estimate'] = ($d['car_count'])*$extra_charge_for_night_time*($courier_call_rate + $courier_fare_per_1_km*round($this->constant['distance_coefficient']*$filtered_data['distance_estimate']/1000,2));
								}
							}
							elseif (!empty($d['cars']))
							{
								$s = "SELECT
										`id_car`,
										`id_car_class`
									FROM `car`					
									WHERE
										`id_car` in (" . $d['cars'] . ")
									";

								$q = query($s);
								if ($q === false) return $this->showError('404', 'error', 'database select of cars failed');

								$s_case = array();
								while ($d_c = fetch_assoc($q))
								{
									if (!empty($this->car_class[$d_c['id_car_class']]))
									{
										$courier_call_rate = (float)$this->car_class[$d_c['id_car_class']]['courier_call_rate'];
										$courier_fare_per_1_km = (float)$this->car_class[$d_c['id_car_class']]['courier_fare_per_1_km'];
										
										$s_case[] = "WHEN " . $d_c['id_car'] . " THEN " . $extra_charge_for_night_time*($courier_call_rate + $courier_fare_per_1_km*round($this->constant['distance_coefficient']*$filtered_data['distance_estimate']/1000,2));
									}
								}

								if (!empty($s_case))
								{
									$s_edit_o_d = "UPDATE `order_driver`
									SET
										`price_estimate` = CASE `id_car`
											" . implode(",\n", $s_case) ."
											ELSE NULL END
									WHERE `id_order` = '" . $id_order . "'
									";
								}
							}
						}
					}
				}

				$q = query("BEGIN");
				if ($q === false) return $this->showError('404', 'error', 'begin query failed');

				if (!empty($s_edit_o_d))
				{
					$q = query($s_edit_o_d);
					if ($q === false) return $this->showError('404', 'error', 'database update of drivers failed');
				}

				$s = array();
				foreach ($filtered_data as $key => $value)
				{
					$s[] = "`" . $key . "` = " 
						 . ($value === NULL ? "NULL" : "'" . $value . "'");
				}

				$s = "UPDATE `order`
					SET 
						" . implode(",\n", $s) ."
					WHERE
						`id_order` = '" . $id_order . "'
					";

				query($s);
		
				global $link;
				if (mysqli_affected_rows($link) === -1) 
				{
					return $this->showError('404', 'error', 'database update failed');
				}
				elseif (mysqli_affected_rows($link) === 0) 
				{
					return $this->showError('404', 'error', 'modified data not found');
				}

				$s = "UPDATE `order`
					SET
						`last_edit_datetime` = now(),
						`last_edit_user` = '" .  $_SESSION[UID] . "'" . $s_add . "
					WHERE
						`id_order` = '" . $id_order . "'
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');

				$q = query("COMMIT");
				if ($q === false) return $this->showError('404', 'error', 'commit query failed');	
			}
			else
			{
			
				$s = "SELECT
						`order`.`id_order`,
						`order`.`id_order_status`,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $_SESSION[UID] 
							. "',`order_driver`.`id_user`,NULL)) as u_id,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $_SESSION[UID] 
							. "',`order_driver`.`id_order_driver_status`,NULL)) as c_state,
						COUNT(IF(`order_driver`.`id_order_driver_status` in (5,6),1,NULL)) as started,
						`order`.`night_time`,
						`order`.`distance_estimate`,
						`order`.`id_car_class`,
						`order`.`from_lat`,
						`order`.`from_lng`,
						`order`.`to_lat`,
						`order`.`to_lng`,
						`order`.`car_count`,
						`order`.`datetime_start_plan`,
						GROUP_CONCAT(`order_driver`.`id_car`) as cars,
						GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $_SESSION[UID] 
							. "',`order_driver`.`options`,NULL)) as c_options
					FROM `order` 
					LEFT JOIN `order_driver` USING (`id_order`)				
					WHERE	
						`order`.`id_order` = '" . $id_order . "'
					LIMIT 1
					FOR UPDATE
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if (empty($d['u_id'])) 
				{
					return $this->showError('404', 'error', 'user is not performer');
				}
				if ($d['c_state'] == 1 || $d['c_state'] == 2)
				{
					return $this->showError('404', 'error', 'wrong booking driver state');
				}
				$d['c_options'] = json_decode($d['c_options'],true);

				switch ($d['id_order_status']) {
					case '1':
						$allowed_fields = array(
												'b_start_address'			=>		'from',	
												'b_start_latitude'			=>		'from_lat',
												'b_start_longitude'			=>		'from_lng',
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'c_options'					=>		true
						);
						break;
					case '2':
						$allowed_fields = array(
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'c_options'					=>		true
						);
						if (empty($d['started']))
						{
							$allowed_fields['b_start_address'] = 'from';
							$allowed_fields['b_start_latitude'] = 'from_lat';
							$allowed_fields['b_start_longitude'] = 'from_lng';
						}
						break;
					case '5':
						$allowed_fields = array(
												'b_start_address'			=>		'from',	
												'b_start_latitude'			=>		'from_lat',
												'b_start_longitude'			=>		'from_lng',
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'c_options'					=>		true
						);
						break;
					case '6':
						$allowed_fields = array(
												'b_start_address'			=>		'from',	
												'b_start_latitude'			=>		'from_lat',
												'b_start_longitude'			=>		'from_lng',
												'b_destination_address'		=>		'to',
												'b_destination_latitude'	=>		'to_lat',
												'b_destination_longitude'	=>		'to_lng',
												'c_options'					=>		true
						);
						break;
					default:
						return $this->showError('404', 'error', 'wrong booking state');
				}

				foreach ($data as $key => $value)
				{
					if (!empty($allowed_fields[$key]))
					{
						if (is_string($value)) $data[$key] = trim($value);
						$affected_fields[] = $key;
						$affected_keys[$key] = true;
						if ($allowed_fields[$key] !== true) $filtered_data[$allowed_fields[$key]] = $data[$key];
					}
					else
					{
						$forbidden_fields[] = $key;
					}
				}
				
				if (empty($affected_fields)) return $this->showError('404', 'error', 'allowed data not found');

				if (!empty($affected_keys['b_options']))
				{
					$filtered_data['options'] = real_escape_string(json_encode($filtered_data['options']));
				}
				if (!empty($affected_keys['b_contact']))
				{
					$filtered_data['contact'] = real_escape_string(json_encode($filtered_data['contact']));
				}
				if (!empty($affected_keys['c_options']))
				{
					$options = $d['c_options'];
					if (!is_array($data['c_options'])) return $this->showError('404', 'error', 'c_options not array');
					$options_is_updated = false;
					foreach($data['c_options'] as $options_element)
					{
						if (!is_array($options_element)) return $this->showError('404', 'error', 'c_options element not array');
						if (empty($options_element[0]))	return $this->showError('404', 'error', 'c_options element without operator');
						$options_element[0] = trim($options_element[0]);
						switch ($options_element[0]){
							case '=':
								if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty c_options element keys for assignment');
								if (!is_array($options_element[1])) return $this->showError('404', 'error', 'c_options element keys for assignment not array');
								if (!isset($options_element[2])) return $this->showError('404', 'error', 'empty c_options element value for assignment');
								$options_prev = $options;
								$arr_o = &$options;
								$check_create_list = $check_edit_list = false;
								if (!empty($this->constant['c_options_valid_keys'])) 
								{
									$arr_v = $this->constant['c_options_valid_keys'];
									$check_create_list = true;
								}
								if (!empty($this->constant['c_options_edit_list_keys'])) 
								{
									$arr_e = $this->constant['c_options_edit_list_keys'];
									$check_edit_list = true;
								}
								$options_element_is_updated = false;
								foreach($options_element[1] as $options_key)
								{
									@$options_key = (string)$options_key;
									if (!is_array($arr_o)) 
									{
										return $this->showError('404', 'error', 'c_options value for element key' . $options_key . ' for assignment not array');
									}
									if ($check_create_list === true)
									{
										if (!array_key_exists($options_key,$arr_v)) return $this->showError('404', 'error', 'wrong c_options element keys for assignment');
										$arr_v = $arr_v[$options_key];
										if ($arr_v === true) 
										{
											$check_create_list = false;
										}
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['c_options_edit_list_readonly']))
										{				
											if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 'c_options element keys for assignment not editable');
											$arr_e = $arr_e[$options_key];
											if ($arr_e === true) 
											{
												$check_edit_list = false;
											}
										}
										else
										{
											if (array_key_exists($options_key,$arr_e))
											{
												$arr_e = $arr_e[$options_key];
											}
											else
											{
												$check_edit_list = false;
											}
											if ($arr_e === true) return $this->showError('404', 'error', 'c_options element keys for assignment readonly');
										}
									}
									if (!array_key_exists($options_key,$arr_o)) 
									{
										$arr_o[$options_key] = array();
										$options_element_is_updated = true;
									}
									$arr_o = &$arr_o[$options_key];
								}
								if ($arr_o !== $options_element[2])
								{
									if (!empty($this->constant['c_options_edit_list_readonly']) && array_includes_add_keys_from_assoc_list($arr_o,$arr_e) === true)
									{
										return $this->showError('404', 'error', 'c_options element try to replace readonly for assignment');
									}
									$arr_o = $options_element[2];
									$add = $options_element[2];								
									if ($check_create_list === true)
									{
										if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong c_options element value keys for assignment');
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['c_options_edit_list_readonly']))
										{
											if (array_includes_only_add_keys_from_assoc_list($add,$arr_e) === false) return $this->showError('404', 'error', 'c_options element value keys for assignment not editable');
										}
										else
										{
											if (array_includes_add_keys_from_assoc_list($add,$arr_e) === true) return $this->showError('404', 'error', 'c_options element value keys for assignment readonly');
										}
									}
									$check_create_list = false;
									$check_edit_list = false;
									$options_element_is_updated = true;
								}
								unset($arr_o);
								if ($options_element_is_updated === true && $check_create_list === false &&  $check_edit_list === false) 
								{
									$options_is_updated = true;
								}
								else
								{
									$options = $options_prev;
								}
								break;
							case '+':
								if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty c_options element keys for addition');
								if (!is_array($options_element[1])) return $this->showError('404', 'error', 'c_options element keys for addition not array');
								if (!isset($options_element[2])) return $this->showError('404', 'error', 'empty c_options element value for addition');
								$options_prev = $options;
								$arr_o = &$options;
								$check_create_list = $check_edit_list = false;
								if (!empty($this->constant['c_options_valid_keys'])) 
								{
									$arr_v = $this->constant['c_options_valid_keys'];
									$check_create_list = true;
								}
								if (!empty($this->constant['c_options_edit_list_keys'])) 
								{
									$arr_e = $this->constant['c_options_edit_list_keys'];
									$check_edit_list = true;
								}
								$options_element_is_updated = false;
								foreach($options_element[1] as $options_key)
								{
									@$options_key = (string)$options_key;
									if (!is_array($arr_o)) 
									{
										return $this->showError('404', 'error', 'c_options value for element key' . $options_key . ' for addition not array');
									}
									if ($check_create_list === true)
									{
										if (!array_key_exists($options_key,$arr_v)) return $this->showError('404', 'error', 'wrong c_options element keys for addition');
										$arr_v = $arr_v[$options_key];
										if ($arr_v === true) 
										{
											$check_create_list = false;
										}
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['c_options_edit_list_readonly']))
										{				
											if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 'c_options element keys for addition not editable');
											$arr_e = $arr_e[$options_key];
											if ($arr_e === true) 
											{
												$check_edit_list = false;
											}
										}
										else
										{
											if (array_key_exists($options_key,$arr_e))
											{
												$arr_e = $arr_e[$options_key];
											}
											else
											{
												$check_edit_list = false;
											}
											if ($arr_e === true) return $this->showError('404', 'error', 'c_options element keys for addition readonly');
										}
									}
									if (!array_key_exists($options_key,$arr_o)) 
									{
										$arr_o[$options_key] = array();
										$options_element_is_updated = true;
									}
									$arr_o = &$arr_o[$options_key];
								}
								if (is_array($arr_o))
								{
									$arr_o[] = $options_element[2];
									end($arr_o);
									$add = array(key($arr_o)=>$options_element[2]);								
									if ($check_create_list === true)
									{
										if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong c_options element value keys for addition');
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['c_options_edit_list_readonly']))
										{
											if (array_includes_only_add_keys_from_assoc_list($add,$arr_e) === false) return $this->showError('404', 'error', 'c_options element value keys for addition not editable');
										}
										else
										{
											if (array_includes_add_keys_from_assoc_list($add,$arr_e) === true) return $this->showError('404', 'error', 'c_options element value keys for addition readonly');

										}
									}
									$check_create_list = false;
									$check_edit_list = false;
									$options_element_is_updated = true;

								}
								else
								{
									if ($check_create_list === false && $check_edit_list === false)
									{
										if (is_array($options_element[2]))
										{
											$arr_o .= json_encode($options_element[2]);
										}
										else
										{
											$arr_o .= $options_element[2];
										}
										$options_element_is_updated = true;
									}
									else
									{
										return $this->showError('404', 'error', 'wrong c_options structure for addition');
									}
								}
								unset($arr_o);

								if ($options_element_is_updated === true && $check_create_list === false &&  $check_edit_list === false) 
								{
									$options_is_updated = true;
								}
								else
								{
									$options = $options_prev;
								}
								break;
							case '-':
								if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty c_options element keys for removal');
								if (!is_array($options_element[1])) return $this->showError('404', 'error', 'c_options element keys for removal not array');
								if (empty($options_element[1]) || !is_array($options) || empty($options)) break;
								$arr_o = &$options;
								$check_edit_list = false;
								if (!empty($this->constant['c_options_edit_list_keys'])) 
								{
									$arr_e = $this->constant['c_options_edit_list_keys'];
									$check_edit_list = true;
								}
								$count_key = count($options_element[1]);
								$i = 0;
								$options_element_is_updated = true;
								foreach($options_element[1] as $options_key)
								{
									@$options_key = (string)$options_key;
									$i++;
									if (!is_array($arr_o) || !array_key_exists($options_key,$arr_o)) 
									{
										$check_edit_list = false;
										$options_element_is_updated = false;
										break;
									}
									if ($check_edit_list === true)
									{
										if (empty($this->constant['c_options_edit_list_readonly']))
										{				
											if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 'c_options element keys for removal not editable');
											$arr_e = $arr_e[$options_key];
											if ($arr_e === true) 
											{
												$check_edit_list = false;
											}
										}
										else
										{
											if (array_key_exists($options_key,$arr_e))
											{
												$arr_e = $arr_e[$options_key];
											}
											else
											{
												$check_edit_list = false;
											}
											if ($arr_e === true) return $this->showError('404', 'error', 'c_options element keys for removal readonly');
										}
									}
									if ($i < $count_key) {$arr_o = &$arr_o[$options_key];}
								}
								if ($check_edit_list === true)
								{
									return $this->showError('404', 'error', 'c_options element keys for removal part of not editable or readonly');
								}
								if ($options_element_is_updated === true) 
								{
									unset($arr_o[$options_key]);

									$options_is_updated = true;
								}
								unset($arr_o);
								break;
							default:
								return $this->showError('404', 'error', 'wrong c_options element operator');
						}
					}
					if ($options_is_updated === true)
					{
						$data['c_options'] = real_escape_string(json_encode($options));
					}
					else
					{
						unset($affected_keys['c_options']);
					}
				}

				$s_edit_o_d = $s_add = "";
				if (isset($filtered_data['from_lat']) || isset($filtered_data['from_lng'])
					|| isset($filtered_data['to_lat']) || isset($filtered_data['to_lng']))
				{
					$from_lat = isset($filtered_data['from_lat']) ? $filtered_data['from_lat'] : $d['from_lat'];
					$from_lng = isset($filtered_data['from_lng']) ? $filtered_data['from_lng'] : $d['from_lng'];
					$to_lat = isset($filtered_data['to_lat']) ? $filtered_data['to_lat'] : $d['to_lat'];
					$to_lng = isset($filtered_data['to_lng']) ? $filtered_data['to_lng'] : $d['to_lng'];
					$place_from = get_place($from_lat,$from_lng);
					$place_to = get_place($to_lat,$to_lng );

					$filtered_data['night_time'] = NULL;
					$filtered_data['distance_estimate'] = NULL;	
					$filtered_data['price_estimate'] = NULL;
					$s_edit_o_d = "UPDATE `order_driver`
								SET
									`price_estimate` = NULL
								WHERE `id_order` = '" . $id_order . "'
								";
					$s_add = ",
						`price_estimate` = IF(`id_car_class` IS NULL,
							(SELECT 
								SUM(`price_estimate`)
							 FROM `order_driver`
							 WHERE
								`id_order` = '" . $id_order . "' AND 
								`id_order_driver_status` in (3,4,5,6)
							),`price_estimate`)
						";

					if (!empty($place_from) && !empty($place_to) && $place_from['id'] == $place_to['id'])
					{
						$distance_estimate = get_distance($place_from['id'],lat_lng_to_square($from_lat,$from_lng,$place_from),lat_lng_to_square($to_lat,$to_lng,$place_from));
						if (gettype($distance_estimate) === 'double') 
						{
							$filtered_data['distance_estimate'] = $distance_estimate;					
						}
					}

					if ($d['datetime_start_plan'] !== '0000-00-00 00:00:00' && (!empty($place_from) || !empty($place_to)))
					{			
						 if (!empty($place_from)) 
						 {
							$timezone = $place_from['timezone'];
						 }
						 elseif (!empty($place_to))
						 {
							$timezone = $place_to['timezone'];
						 }
						
						preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',$timezone,$parsed_time_zone);
						$h = gmdate("H:i",strtotime($d['datetime_start_plan'] . MYSQL_TIME_ZONE) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
						$extra_charge_for_night_time = 1;
						$filtered_data['night_time'] = 0;
						if ($this->constant['the_end_of_the_night_time'] > $this->constant['start_of_night_time'])
						{
							if ($h >= $this->constant['start_of_night_time'] && $h < $this->constant['the_end_of_the_night_time']) 
							{
								$extra_charge_for_night_time = $this->constant['extra_charge_for_night_time'];
								$filtered_data['night_time'] = 1;
							}
						}
						else
						{
							if ($h >= $this->constant['start_of_night_time'] || $h < $this->constant['the_end_of_the_night_time']) 
							{
								$extra_charge_for_night_time = $this->constant['extra_charge_for_night_time'];
								$filtered_data['night_time'] = 1;
							}
						}

						if (isset($filtered_data['distance_estimate']))
						{
							if (isset($d['id_car_class']))
							{
								if (!empty($this->car_class[$d['id_car_class']]))
								{
									$courier_call_rate = (float)$this->car_class[$d['id_car_class']]['courier_call_rate'];
									$courier_fare_per_1_km = (float)$this->car_class[$d['id_car_class']]['courier_fare_per_1_km'];			
									
									$filtered_data['price_estimate'] = ($d['car_count'])*$extra_charge_for_night_time*($courier_call_rate + $courier_fare_per_1_km*round($this->constant['distance_coefficient']*$filtered_data['distance_estimate']/1000,2));
								}
							}
							elseif (!empty($d['cars']))
							{
								$s = "SELECT
										`id_car`,
										`id_car_class`
									FROM `car`					
									WHERE
										`id_car` in (" . $d['cars'] . ")
									";

								$q = query($s);
								if ($q === false) return $this->showError('404', 'error', 'database select of cars failed');

								$s_case = array();
								while ($d_c = fetch_assoc($q))
								{
									if (!empty($this->car_class[$d_c['id_car_class']]))
									{
										$courier_call_rate = (float)$this->car_class[$d_c['id_car_class']]['courier_call_rate'];
										$courier_fare_per_1_km = (float)$this->car_class[$d_c['id_car_class']]['courier_fare_per_1_km'];
										
										$s_case[] = "WHEN " . $d_c['id_car'] . " THEN " . $extra_charge_for_night_time*($courier_call_rate + $courier_fare_per_1_km*round($this->constant['distance_coefficient']*$filtered_data['distance_estimate']/1000,2));
									}
								}

								if (!empty($s_case))
								{
									$s_edit_o_d = "UPDATE `order_driver`
									SET
										`price_estimate` = CASE `id_car`
											" . implode(",\n", $s_case) ."
											ELSE NULL END
									WHERE `id_order` = '" . $id_order . "'
									";
								}
							}
						}
					}
				}

				$q = query("BEGIN");
				if ($q === false) return $this->showError('404', 'error', 'begin query failed');

				if (!empty($s_edit_o_d))
				{
					$q = query($s_edit_o_d);
					if ($q === false) return $this->showError('404', 'error', 'database update of drivers failed');
				}
				if (!empty($affected_keys['c_options']))
				{
					$s_edit_o_d = "UPDATE `order_driver`
								SET
									`options` = '" . $data['c_options'] . "'
								WHERE `id_order` = '" . $id_order . "' AND `id_user` = '" . $_SESSION[UID] . "'
								";
					$q = query($s_edit_o_d);
					if ($q === false) return $this->showError('404', 'error', 'drivers database update failed');
				}

				$s = array();
				foreach ($filtered_data as $key => $value)
				{
					$s[] = "`order`.`" . $key . "` = " 
						 . ($value === NULL ? "NULL" : "'" . $value . "'");
				}
				if (!empty($s))
				{
					$s = "UPDATE `order`
						SET 
							" . implode(",\n", $s) ."
						WHERE
							`order`.`id_order` = '" . $id_order . "' 
						";

					query($s);
					global $link;
					if (mysqli_affected_rows($link) === -1) 
					{
						return $this->showError('404', 'error', 'driver update failed');
					}
					elseif (mysqli_affected_rows($link) === 0) 
					{
						return $this->showError('404', 'error', 'driver modified data not found');
					}
				}
				$s = "UPDATE `order`
					SET
						`last_edit_datetime` = now(),
						`last_edit_user` = '" .  $_SESSION[UID] . "'" . $s_add . "

					WHERE
						`id_order` = '" . $id_order . "'
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');

				$q = query("COMMIT");
				if ($q === false) return $this->showError('404', 'error', 'commit query failed');
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	array(
									'affected_fields' 	=> 	$affected_fields,
									'forbidden_fields'	=>	$forbidden_fields,
									'wrong_data_fields' =>	$wrong_data_fields
								)
			);
		}

		private function generateDriverCode()
		{
			if ($this->constant['driver_code_only_numbers'])
			{
				$arr = array('0','1','2','3','4','5','6','7','8','9');
			}
			else
			{
				$arr = array('a','b','c','e','f','g','h','j',
							 'k','*','m','n','p','r','s','t',
							 'u','v','w','x','y','z','0','1',
							 '2','3','4','5','6','7','8','9');
			}
			$code = "";
			for($i = 0; $i < $this->constant['driver_code_length']; $i++)
			{
				$index = rand(0, count($arr) - 1);
				$code.= $arr[$index];
			}
			return $code;
		}

		private function prepareForDriverCode($str = "")
		{
			return strtr(strtolower((string)$str),array('d'=>'a','o'=>'0','q'=>'0','i'=>'1','l'=>'1'));
		}

		public function selectFavoriteUser($id_user = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			$sql_add = "
					`users`.`phone` as u_phone,
					`users`.`phone_is_verified` as u_phone_checked,
					`users`.`email` as u_email,
					`users`.`birthday_date` as u_birthday,
					`users`.`referral_code` as ref_code,
					`users`.`referrer` as referrer_u_id,
					`tg` as u_tg,
					`tg_is_verified` as u_tg_checked,
					`id_user_upper` as u_upper,
					`wa` as u_wa,
					`wa_is_verified` as u_wa_checked,";
			if (empty($id_user) || $id_user == 'authorized' || $id_user == $_SESSION[UID])
			
			{
				$id_user = $_SESSION[UID];
				if ($this->id_role != 4) $sql_add = "";
			}
			else
			{	
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
			}

			$s = "SELECT 
					`users`.`id_user` as u_id,
					`users`.`id_role` as u_role,
					`users`.`name` as u_name,
					`users`.`family` as u_family,
					`users`.`middle` as u_middle,
					" . $sql_add . "
					`users`.`photo_link` as u_photo,
					`users`.`id_lang` as u_lang,
					`users`.`currency` as u_currency,
					`users`.`id_city` as u_city,
					`users`.`tips` as u_tips,
					`users`.`language_skills` as u_lang_skills,
					`users`.`description` as u_description,
					`users`.`id_navigation` as u_gps_software,
					`users`.`id_verification_status` as u_check_state,
					`users`.`active` as u_active,			
					`users`.`out_order` as out_drive,
					`users`.`out_order_to` as out_address,
					`users`.`out_order_to_lat` as out_latitude,
					`users`.`out_order_to_lng` as out_longitude,
					`users`.`out_order_complete_datetime` as out_est_datetime,
					`users`.`out_order_from` as out_s_address,
					`users`.`out_order_from_lat` as out_s_latitude,
					`users`.`out_order_from_lng` as out_s_longitude,
					`users`.`out_order_passengers_count` as out_passengers,
					`users`.`out_order_luggage_count` as out_luggage,
					`json` as u_details,
					(SELECT
						GROUP_CONCAT(`users_order_comment`.`id_order_comment` SEPARATOR ',')
					 FROM `users_order_comment`
					 WHERE `users_order_comment`.`id_user` = `users`.`id_user`
					) as b_comments,
					(SELECT
						GROUP_CONCAT(`users_service`.`id_service` SEPARATOR ',')
					 FROM `users_service`
					 WHERE `users_service`.`id_user` = `users`.`id_user`
					) as b_services,
					(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',`users_order_location`.`id_order_location`,`users_order_location`.`basic`) 
						SEPARATOR ';')
					 FROM `users_order_location`
					 WHERE `users_order_location`.`id_user` = `users`.`id_user`
					) as b_location_classes,
					`id_schedule` as sc_id
				FROM `users`
				LEFT JOIN `users_favorite` ON `users_favorite`.`id_favorite` = `users`.`id_user`
				WHERE
					`users`.`deleted` = '0' AND `users_favorite`.`id_user` = '" . $id_user . "'
				LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('user' => array());

			while ($d = fetch_assoc($q))
			{
				$d['u_ban'] = get_user_ban_status($d['u_id']);

				$d['u_photo'] = $d['u_photo'] ? url($d['u_photo'],FILE_PATH) : '';

				add_time_zone($d['out_est_datetime']);

				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);		

				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);	
				
				if (!empty($d['b_location_classes']))
				{
					$d['b_location_classes'] = explode(';',$d['b_location_classes']);
					foreach ($d['b_location_classes'] as $key=>$value)
					{
						$d['b_location_classes'][$key] = array();
						list(
							$d['b_location_classes'][$key]['b_location_class'],
							$d['b_location_classes'][$key]['basic']
							)= explode('|',$value);
						$d['b_location_classes'][$key]['basic'] = (int)$d['b_location_classes'][$key]['basic'];
					}
				}

				if (isset($d['u_phone_checked'])) $d['u_phone_checked'] = (int)$d['u_phone_checked'];

				$d['u_active'] = (int)$d['u_active'];		
				
				$d['out_drive'] = (int)$d['out_drive'];	

				$d['u_details'] = json_decode($d['u_details'],true);


				$out['user'][$d['u_id']] = $d;
			}

			if (empty($this->associativeArray)) $out['user'] =  array_values($out['user']);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}
		
		public function addFavoriteUser($id_user = "", $id_favorite = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_user) || $id_user == 'authorized' || $id_user == $_SESSION[UID])
			{	
				$id_user = $_SESSION[UID];
			}
			else
			{	
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
				$s = "SELECT
						`id_user`
					FROM `users`
					WHERE `id_user` = '" . $id_user . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database user select failed');
				$d = fetch_assoc($q);
				
				if (empty($d['id_user'])) return $this->showError('404', 'error', 'user ' . $id_user . ' not found');
			}

			if (empty($id_favorite)) return $this->showError('404', 'error', 'empty favorite');
			$favorite = explode(',', $id_favorite);
			$favorite_count = count($favorite );
			if (in_array($id_user, $favorite))
			{
				return $this->showError('404', 'error', 'trying to make user favorite for yourself');
			}

			$s = "SELECT 
					COUNT(`users`.`id_user`) as f_in_u_count,
					GROUP_CONCAT(`users`.`id_user` SEPARATOR ',') as  f_in_u,
					GROUP_CONCAT(IF(`users`.`deleted`,`users`.`id_user`,NULL) SEPARATOR ',') as deleted,
					GROUP_CONCAT(uf.`id_favorite` SEPARATOR ',') as f_in_f
				FROM `users`
				LEFT JOIN (
						SELECT
							`id_favorite`,
							`id_user`
						FROM
							`users_favorite`
						WHERE
							`id_user` = '" . $id_user . "'
					) uf ON uf.`id_favorite` = `users`.`id_user`
				WHERE
					`users`.`id_user` in (" .  $id_favorite . ")
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			$d = fetch_assoc($q);

			if ($d['f_in_u_count'] != $favorite_count) 
			{
				return $this->showError('404', 'error', 'only ' . $d['f_in_u_count'] . ' users:' . $d['f_in_u'] .' of ' . $favorite_count . ' found');
			}
			if (!empty($d['deleted'])) 
			{
				return $this->showError('404', 'error', 'users ' . $d['deleted'] . ' deleted');
			}
			if (!empty($d['f_in_f']))
			{
				return $this->showError('404', 'error', 'users ' . $d['f_in_f'] . ' are already favorite for ' . $id_user);
			}

			$s = array();
			foreach ($favorite as $f)
			{
				$s[] = "('" . $f . "', '" . $id_user . "')";
			}
			$s = "INSERT INTO `users_favorite` (`id_favorite`,`id_user`) VALUES " . implode(",", $s);

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'services insert failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}
		
		public function removeFavoriteUser($id_user = "", $id_favorite = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_user) || $id_user == 'authorized' || $id_user == $_SESSION[UID])
			{	
				$id_user = $_SESSION[UID];
			}
			else
			{	
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
				$s = "SELECT
						`id_user`
					FROM `users`
					WHERE `id_user` = '" . $id_user . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database user select failed');
				$d = fetch_assoc($q);
				
				if (empty($d['id_user'])) return $this->showError('404', 'error', 'user ' . $id_user . ' not found');
			}

			$s = "DELETE
				FROM `users_favorite`
				WHERE 
					`id_user` = '" . $id_user . "' AND `id_favorite` in (" . $id_favorite  . ")
				";
			$q = query($s);
			
			if ($q === false) return $this->showError('404', 'error', 'database delete failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function selectReferralUrl($id_user = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			$sql_limit = "LIMIT 1";

			if (empty($id_user) || $id_user == 'authorized' || $id_user == $_SESSION[UID])
			{
				$sql_where = "AND `id_user` = '" . $_SESSION[UID] . "'";
			}
			else
			{	
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

				$sql_where = "AND `id_user` in (" . $id_user . ")";

				$sql_limit = "LIMIT " . $this->limit_offset . ", " . $this->limit_row_count;
			}

			$s = "SELECT 
					`id_user` as u_id
				FROM `users`
				WHERE
					`deleted` = '0'
				" . $sql_where . "
				" . $sql_limit . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('user' => array());

			while ($d = fetch_assoc($q))
			{
				$path = url('app/' . get_path_from_user($d['u_id']),CONFIG_URL);
				$d['url'] = array(								
								'register'	=>	$path . '/register/',
								'download'	=>	$path . '/download/'
							);

				$out['user'][$d['u_id']] = $d;
			}


			if (empty($this->associativeArray)) $out['user'] =  array_values($out['user']);



			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function checkReferralCode($str = "")
		{
			if (empty($str)) return $this->showError('404', 'error', 'empty string');

			$s = "SELECT 
					`referral_code` 
				FROM `users`
				WHERE `referral_code` = '" . $str . "'
				LIMIT 1";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'mysql select failed');
			$d = fetch_assoc($q);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	array('ref_code_free' => empty($d['referral_code']) ? true : false)
			);
		}

		public function selectData($version = NULL, $server_version = '', $data = array())
		{
			if ($version === $server_version)
			{
				return array(
					'code' 		=>	'304',
					'status' 	=>	'success'			
				);
			}
			else
			{
				$json = array(
							'version'			=>		$server_version,
							'default_lang'		=>		DEFAULT_LANG,
							'default_currency'	=>		DEFAULT_CURRENCY,
							'default_country'	=>		DEFAULT_COUNTRY,
							'default_profile'	=>		DEFAULT_PROFILE,
							'data'				=>		$data
				);			
			}
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$json
			);
		
		}

		public function selectReferralUser($id_user = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			$sql_add = "
					`phone` as u_phone,
					`phone_is_verified` as u_phone_checked,
					`email` as u_email,
					`birthday_date` as u_birthday,
					`referral_code` as ref_code,
					`referrer` as referrer_u_id,
					`tg` as u_tg,
					`tg_is_verified` as u_tg_checked,
					`id_user_upper` as u_upper,
					`wa` as u_wa,
					`wa_is_verified` as u_wa_checked,";
			if (empty($id_user) || $id_user == 'authorized' || $id_user == $_SESSION[UID])
			{
				$id_user = $_SESSION[UID];
				if ($this->id_role != 4) $sql_add = "";
			}
			else
			{	
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
			}

			$s = "SELECT 
					`id_user` as u_id,
					`id_role` as u_role,
					`name` as u_name,
					`family` as u_family,
					`middle` as u_middle,
					" . $sql_add . "
					`photo_link` as u_photo,
					`id_lang` as u_lang,
					`currency` as u_currency,
					`id_city` as u_city,
					`tips` as u_tips,
					`language_skills` as u_lang_skills,
					`description` as u_description,
					`id_navigation` as u_gps_software,
					`id_verification_status` as u_check_state,
					`active` as u_active,			
					`out_order` as out_drive,
					`out_order_to` as out_address,
					`out_order_to_lat` as out_latitude,
					`out_order_to_lng` as out_longitude,
					`out_order_complete_datetime` as out_est_datetime,
					`out_order_from` as out_s_address,
					`out_order_from_lat` as out_s_latitude,
					`out_order_from_lng` as out_s_longitude,
					`out_order_passengers_count` as out_passengers,
					`out_order_luggage_count` as out_luggage,
					`json` as u_details,
					(SELECT
						GROUP_CONCAT(`users_order_comment`.`id_order_comment` SEPARATOR ',')
					 FROM `users_order_comment`
					 WHERE `users_order_comment`.`id_user` = `users`.`id_user`
					) as b_comments,
					(SELECT
						GROUP_CONCAT(`users_service`.`id_service` SEPARATOR ',')
					 FROM `users_service`
					 WHERE `users_service`.`id_user` = `users`.`id_user`
					) as b_services,
					(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',`users_order_location`.`id_order_location`,`users_order_location`.`basic`) 
						SEPARATOR ';')
					 FROM `users_order_location`
					 WHERE `users_order_location`.`id_user` = `users`.`id_user`
					) as b_location_classes,
					`id_schedule` as sc_id
				FROM `users`
				WHERE
					`users`.`deleted` = '0' AND `referrer` = '" . $id_user . "'
				LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('user' => array());
			while ($d = fetch_assoc($q))
			{
				$d['u_ban'] = get_user_ban_status($d['u_id']);
				$d['u_photo'] = $d['u_photo'] ? url($d['u_photo'],FILE_PATH) : '';
				add_time_zone($d['out_est_datetime']);
				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);		
				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);			
				if (!empty($d['b_location_classes']))
				{
					$d['b_location_classes'] = explode(';',$d['b_location_classes']);
					foreach ($d['b_location_classes'] as $key=>$value)
					{
						$d['b_location_classes'][$key] = array();
						list(
							$d['b_location_classes'][$key]['b_location_class'],
							$d['b_location_classes'][$key]['basic']
							)= explode('|',$value);
						$d['b_location_classes'][$key]['basic'] = (int)$d['b_location_classes'][$key]['basic'];
					}
				}
				if (isset($d['u_phone_checked'])) $d['u_phone_checked'] = (int)$d['u_phone_checked'];
				$d['u_active'] = (int)$d['u_active'];			
				$d['out_drive'] = (int)$d['out_drive'];	
				$d['u_details'] = json_decode($d['u_details'],true);
				$out['user'][$d['u_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['user'] =  array_values($out['user']);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function setOrderTips($id_order = "", $b_tips = NULL, $c_tips = NULL)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			if ($this->id_role == 1 || $this->id_role == 5)
			{
				if ($b_tips === NULL) return $this->showError('404', 'error', 'null b_tips');
				$tips = $b_tips;

				$s = "SELECT
						`id_order`,
						`client`,
						`id_order_status`,
						`tips`
					FROM `order` 		
					WHERE	
						`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 4) return $this->showError('404', 'error', 'wrong booking state');
				if ($d['client'] != $_SESSION[UID]) 
				{
					return $this->showError('404', 'error', 'user is not author');
				}
				if ($d['tips'] !== NULL) return $this->showError('404', 'error', 'c_tips already inputed');

				$s = "UPDATE `order`
					SET 
						`tips` = '" . $tips  . "',
						`last_edit_datetime` = now(),
						`last_edit_user` = '" .  $_SESSION[UID] . "'
					WHERE
						`id_order` = '" . $id_order . "' AND `tips` IS NULL
					";

				query($s);
		
				global $link;
				if (mysqli_affected_rows($link) === -1) 
				{
					return $this->showError('404', 'error', 'database update failed');
				}
				elseif (mysqli_affected_rows($link) === 0) 
				{
					return $this->showError('404', 'error', 'modified data not found');
				}
			}
			else
			{
				if ($c_tips === NULL) return $this->showError('404', 'error', 'null c_tips');
				$tips = $c_tips;

				$s = "SELECT
						`order`.`id_order`,
						`order`.`id_order_status`,
						od.`id_user`,
						od.`id_order_driver_status`,
						od.`tips`
					FROM `order`
					LEFT JOIN (
							SELECT
								`id_order`,
								`id_user`,
								`id_order_driver_status`,
								`tips`
							FROM
								`order_driver`
							WHERE
								`id_order` = '" . $id_order . "' AND `id_user` = '" . $_SESSION[UID] . "'
						) od USING (`id_order`)				
					WHERE	
						`order`.`id_order` = '" . $id_order . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
				if ($d['id_order_status'] != 4) return $this->showError('404', 'error', 'wrong booking state');

				if (empty($d['id_user'])) 
				{
					return $this->showError('404', 'error', 'user is not performer');
				}

				if ($d['tips'] !== NULL) return $this->showError('404', 'error', 'b_tips already inputed');

				if ($d['id_order_driver_status'] == 1 || $d['id_order_driver_status'] == 2) 
				{
					return $this->showError('404', 'error', 'wrong booking driver state');
				}

				$s = "UPDATE `order`,`order_driver`
					SET 
						`order`.`last_edit_datetime` = now(),
						`order`.`last_edit_user` = '" .  $_SESSION[UID] . "',
						`order_driver`.`tips` = '" . $tips  . "'
					WHERE
						`order`.`id_order` = '" . $id_order . "' AND
						`order`.`id_order` = `order_driver`.`id_order` AND 
						`order_driver`.`id_order` = '" . $id_order . "' AND 
						`order_driver`.`id_user` = '" . $_SESSION[UID] . "' AND
						`order_driver`.`tips` IS NULL
					";

				query($s);

				global $link;
				if (mysqli_affected_rows($link) === -1) 
				{
					return $this->showError('404', 'error', 'driver update failed');
				}
				elseif (mysqli_affected_rows($link) === 0) 
				{
					return $this->showError('404', 'error', 'driver modified data not found');
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public $id_role = NULL;

		public function selectUsersCargoCase($id_user = "")
		{
/*			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}*/

			$s = "SELECT
					`id_cargo_case`
				FROM `cargo_case_users` 		
				WHERE	
					`id_user` = '" . $id_user . "'
				";

			$q = query($s);
			/*if ($q === false) return $this->showError('404', 'error', 'database select failed');*/

			$out = array();
			while ($d = fetch_assoc($q))
			{
				$out[$d['id_cargo_case']] = true;
			}
			return $out;
		}

		public function createTrip($id_user = "", $data = "", $langs = array(), $s_data = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_user) || $id_user == $_SESSION[UID])
			{
				if ($this->id_role != 2)
				{
					if ($this->id_role != 4) return $this->showError('404', 'error', 'wrong user role');
				}
				else
				{
					if ($_SESSION['id_verification_status'] != 2)
					{
						return $this->showError('404', 'error', 'wrong user check state');
					}
					if (!empty($_SESSION['user_ban_status']['order']))
					{
						return $this->showError('404', 'error', 'user banned');
					}
				}
				$id_user = $_SESSION[UID];
			}
			else
			{
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
				$s = "SELECT 
						`id_user`
					FROM `users`
					WHERE 
						`id_user` = '" . $id_user . "'
					LIMIT 1
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'user select failed');
				$d = fetch_assoc($q);
				if (empty($d['id_user'])) return $this->showError('404', 'error', 'user not found');
			}

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}
			$iso = array();
			foreach ($langs as $lang)
			{
				$iso[$lang['iso']] = array(
										'name'				=>$lang['iso'],
										'type'				=>'string',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>NULL
				);
			}
			$options_valid_keys = array();
			foreach ($this->constant['t_options_valid_keys'] as $key => $value)
			{
				$options_valid_keys[$key] = array(
										'name'				=>$key,
										'type'				=>'string',
										'NULL'				=>false,
										'values'			=>NULL,
										'default'			=>NULL
				);
			}		
			$allowed_fields = array(						
				't_start_address'			=>		array(
							'name'				=>'from',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(""),
							'error'				=>array(
								'requirement'     =>array(
									array('empty','from'),
									array('&&'),
									array(
										array('!isset','from_lat'),
										array('||'),
										array('!isset','from_lng'),
									)
								),
								'msg' 			=>'empty start address'
							)
				),

				't_start_latitude'			=>		array(
							'name'				=>'from_lat',
							'type'				=>'latitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				't_start_longitude'			=>		array(
							'name'				=>'from_lng',
							'type'				=>'longitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				't_destination_address'		=>		array(
							'name'				=>'to',
							'type'				=>'string',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array("")
				),
				't_destination_latitude'	=>		array(
							'name'				=>'to_lat',
							'type'				=>'latitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				't_destination_longitude'	=>		array(
							'name'				=>'to_lng',
							'type'				=>'longitude',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),				
				't_start_datetime_interval'	=>		array(
							'name'				=>'start_plan_datetime_interval',
							'type'				=>'second',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(0)
				),				
				't_start_datetime'			=>		array(
							'name'				=>'start_plan_datetime',
							'type'				=>'datetime',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array('0000-00-00 00:00:00'),
							'error'				=>array(
								'requirement'     =>array(
									array('empty','start_plan_datetime')
								),
								'msg' 			=>'empty trip datetime'
							)
				),
				't_complete_datetime'		=>		array(
							'name'				=>'complete_plan_datetime',
							'type'				=>'datetime',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array('0000-00-00 00:00:00')
				),
				't_options'					=>		array(
							'name'				=>'json',
							'type'				=>'associative for json',
							'NULL'				=>false,
							'values'			=>NULL,
							'default'			=>array(""),
							'keys'				=>$options_valid_keys ? : NULL
				),
				'price_time_function'					=>		array(
							'name'				=>'id_price_time_function',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'sc_id'					=>		array(
							'name'				=>'id_schedule',
							'type'				=>'integer',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'currency'				=>		array(
							'name'				=>'currency',
							'type'				=>'ISO 4217 alpha code',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'currency_priority'		=>		array(
							'name'				=>'currency_priority',
							'type'				=>'boolean integer',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'fee'					=>		array(
							'name'				=>'fee',
							'type'				=>'double',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'tariff'				=>		array(
							'name'				=>'tariff',
							'type'				=>'double',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				),
				'tariff_priority'		=>		array(
							'name'				=>'tariff_priority',
							'type'				=>'boolean integer',
							'NULL'				=>true,
							'values'			=>NULL,
							'default'			=>array(NULL)
				)
			);
			$forbidden_fields = array();
			$affected_fields = array();
			$affected_keys = array();
			$filtered_data = array();
			
			foreach ($data as $key => $value)
			{
				if (!empty($allowed_fields[$key]))
				{
					if (is_string($value)) $data[$key] = trim($value);
					$affected_fields[] = $key;
					$affected_keys[$key] = true;
					if ($allowed_fields[$key]['name'] !== NULL && !in_array($allowed_fields[$key]['type'], array('second to datetime','associative for json','array list for table','array list'))) $filtered_data[$allowed_fields[$key]['name']] = $data[$key];
				}
				else
				{
					$forbidden_fields[] = $key;
				}
			}	
			if (empty($affected_fields)) return $this->showError('404', 'error', 'allowed data not found');

			if (!empty($affected_keys['t_options']))
			{
				if (!is_array($data['t_options'])) return $this->showError('404', 'error', 'options not array');

				if (!empty($this->constant['t_options_valid_keys'])) 
				{
					if (array_includes_only_add_keys_from_assoc_list($data['t_options'],$this->constant['t_options_valid_keys']) === false) return $this->showError('404', 'error', 'wrong t_options keys');
				}

				$filtered_data['json'] = real_escape_string(json_encode($data['t_options']));
			}

			switch (DEFAULT_PROFILE)
			{
				case 'stadium':
					if (isset($filtered_data['id_schedule']))
					{
						$id_schedule = $filtered_data['id_schedule'];
						$data_ =  empty($s_data[0]) ? array() : $s_data[0];
						$data_stt = empty($s_data[1]) ? array() : $s_data[1];
						$data_sc =  empty($s_data[2]) ? array() : $s_data[2];
					}
					else
					{
						if (empty($filtered_data['from']))
						{
							return $this->showError('404', 'error', 'empty start address');
						}
						if (empty($data['t_options']['seats_sold'])) return $this->showError('404', 'error', 'empty sold seats');
						if (!is_array($data['t_options']['seats_sold'])) return $this->showError('404', 'error', 'wrong seats data');
						$start_address = explode(chr(0),$filtered_data['from']);
						$data_ =  empty($s_data[0]) ? array() : $s_data[0];
						$data_stt = empty($s_data[1]) ? array() : $s_data[1];
						$data_sc =  empty($s_data[2]) ? array() : $s_data[2];
						if (count($start_address) == 1 || $start_address[0] == 'st_id')
						{
							if (count($start_address) > 1)
							{
								$id_stadium = $start_address[1];
								if (empty($data_stt['stadiums'][$id_stadium])) return $this->showError('404', 'error', 'stadium not found');
							}
							else
							{
								if (empty($data['t_options']['s_name'])) return $this->showError('404', 'error', 'empty stadium name');
							}
							if (empty($filtered_data['start_plan_datetime']))
							{
								return $this->showError('404', 'error', 'empty trip datetime');
							}
							else
							{
								preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['start_plan_datetime'],$parsed_datetime);
								if (empty($parsed_datetime))
								{
									return $this->showError('404', 'error', 'wrong t_start_datetime');
								}
								else
								{
									$filtered_data['start_plan_datetime'] = $parsed_datetime[1] . " " . $parsed_datetime[2];
									if ($filtered_data['start_plan_datetime'] == '0000-00-00 00:00:00')
									{
										return $this->showError('404', 'error', '0000-00-00 00:00:00 t_start_datetime');
									}
									else
									{
										preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
										$datetime_start_plan = gmdate("Y-m-d H:i:s",strtotime($filtered_data['start_plan_datetime'] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
									}
								}
							}
							if (empty($data['t_options']['team1']['id']) || empty($data['t_options']['team1']['val'])) return $this->showError('404', 'error', 'empty team1');
							if (!empty($data['t_options']['team1']['id']))
							{
								if (empty($data_stt['teams'][$data['t_options']['team1']['id']])) return $this->showError('404', 'error', 'team1 not found');	
							}
							if (empty($data['t_options']['team2']['id']) || empty($data['t_options']['team2']['val'])) return $this->showError('404', 'error', 'empty team2');
							if (!empty($data['t_options']['team2']['id']))
							{
								if (empty($data_stt['teams'][$data['t_options']['team2']['id']])) return $this->showError('404', 'error', 'team2 not found');
							}
							if (empty($data['t_options']['tournament']['id']) || empty($data['t_options']['tournament']['val'])) return $this->showError('404', 'error', 'empty tournament');
							if (!empty($data['t_options']['tournament']['id']))
							{
								if (empty($data_stt['tournament'][$data['t_options']['tournament']['id']])) return $this->showError('404', 'error', 'tournament not found');
							}
							$filtered_data = array(
								'from' => $filtered_data['from'],
								'start_plan_datetime' => $filtered_data['start_plan_datetime'],
								'json' =>$filtered_data['json']
							);
							$affected_fields =  array('t_start_address','t_start_datetime','t_options');
							if (isset($data['price_time_function']))
							{
								$filtered_data['id_price_time_function'] = $data['price_time_function'];
								$affected_fields[] = 'price_time_function';
							}
							if (isset($data['currency']))
							{
								$filtered_data['currency'] = $data['currency'];
								$affected_fields[] = 'currency';
							}
							if (isset($data['currency_priority']))
							{
								$filtered_data['currency_priority'] = $data['currency_priority'];
								$affected_fields[] = 'currency_priority';
							}
							if (isset($data['fee']))
							{
								$filtered_data['fee'] = $data['fee'];
								$affected_fields[] = 'fee';
							}
							if (isset($data['tariff']))
							{
								$filtered_data['tariff'] = $data['tariff'];
								$affected_fields[] = 'tariff';
							}
							if (isset($data['tariff_priority']))
							{
								$filtered_data['tariff_priority'] = $data['tariff_priority'];
								$affected_fields[] = 'tariff_priority';
							}
						}
						elseif ($start_address[0] == 'sc_id')
						{
							$id_schedule = $start_address[1];
						}
						else
						{
							return $this->showError('404', 'error', 'wrong start address prefix');
						}
					}

					if (isset($id_schedule))
					{
						if (empty($data_sc['schedule'][$id_schedule])) return $this->showError('404', 'error', 'schedule not found');
						$seat_arr = array();
						$blocks = array();
						$sql_seats = array();
						$seat_blocks = array();
						foreach($data['t_options']['seats_sold'] as $seat=>$val)
						{
							$seat_arr[$seat] = true;
							$seat_b_r_s = explode(';',$seat);
							if (count($seat_b_r_s) < 4) return $this->showError('404', 'error', 'wrong seat');
							if (isset($blocks[$seat_b_r_s[1]])) $blocks[$seat_b_r_s[1]]++; else $blocks[$seat_b_r_s[1]] = 1;
							$seat_blocks[$seat] = $seat_b_r_s[1];
							$sql_seats[] = $seat;
						}

						$s = "SELECT	
								`trip`.`id_trip`,
								`trip`.`json` as t_options,
								COUNT(`ticket`.`id_seat`) as seats_count
							FROM `trip`
							LEFT JOIN `ticket` ON `ticket`.`id_trip` = `trip`.`id_trip` AND `ticket`.`id_seat` in ('" . implode("','",$sql_seats) . "')
							WHERE	
								`trip`.`id_schedule` =  '$id_schedule'
							";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'trip select failed');
						
						while ($d = fetch_assoc($q))
						{
							if ($d['id_trip'] === NULL) continue;
							$d['t_options'] = json_decode($d['t_options'],true);
							if (!empty($d['seats_count'])) return $this->showError('404', 'error', "busy seat");
							if (!empty($d['t_options']['seats_sold']))
							{
								if (!empty($d['t_options']['seats_sold']) && is_array($d['t_options']['seats_sold']))
								{
									foreach($d['t_options']['seats_sold'] as $seat=>$val)
									{
										if (!empty($seat_arr[$seat])) return $this->showError('404', 'error', 'busy seats');
									}
								}
							}
						}

						$filtered_data['json'] = $data['t_options'];
						unset($filtered_data['json']['seats_sold']);
						unset($filtered_data['json']['price']);
						$filtered_data['json'] = real_escape_string(json_encode($filtered_data['json']));
						$filtered_data = array(
							'from' => 'sc_id' . chr(0) . $id_schedule,
							'json' =>$filtered_data['json'],
							'id_schedule' => $id_schedule
						);
						$affected_fields = array('t_start_address','t_options','sc_id');
						if (isset($data['price_time_function']))
						{
							$filtered_data['id_price_time_function'] = $data['price_time_function'];
							$affected_fields[] = 'price_time_function';
						}
						if (isset($data['currency']))
						{
							$filtered_data['currency'] = $data['currency'];
							$affected_fields[] = 'currency';
						}
						if (isset($data['currency_priority']))
						{
							$filtered_data['currency_priority'] = $data['currency_priority'];
							$affected_fields[] = 'currency_priority';
						}
						if (isset($data['fee']))
						{
							$filtered_data['fee'] = $data['fee'];
							$affected_fields[] = 'fee';
						}
						if (isset($data['tariff']))
						{
							$filtered_data['tariff'] = $data['tariff'];
							$affected_fields[] = 'tariff';
						}
						if (isset($data['tariff_priority']))
						{
							$filtered_data['tariff_priority'] = $data['tariff_priority'];
							$affected_fields[] = 'tariff_priority';
						}
					}
					break;
				default:
					if (empty($filtered_data['from']) 
						&& (!isset($filtered_data['from_lat']) || !isset($filtered_data['from_lng'])))
					{
						return $this->showError('404', 'error', 'empty start address');
					}
					$start_plan_datetime_interval = $this->constant['start_datetime_interval'];
					if (empty($filtered_data['start_plan_datetime']))
					{
						return $this->showError('404', 'error', 'empty trip datetime');
					}
					else
					{
						switch ($filtered_data['start_plan_datetime']) {
							case 'now':
								preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
								$filtered_data['start_plan_datetime'] = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
								break;
							default:
								preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['start_plan_datetime'],$parsed_datetime);
								if (empty($parsed_datetime))
								{
									return $this->showError('404', 'error', 'wrong t_start_datetime');
								}
								else
								{
									$filtered_data['start_plan_datetime'] = $parsed_datetime[1] . " " . $parsed_datetime[2];
									if ($filtered_data['start_plan_datetime'] == '0000-00-00 00:00:00')
									{
										return $this->showError('404', 'error', '0000-00-00 00:00:00 t_start_datetime');
									}
									else
									{
										preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
										$datetime_start_plan = gmdate("Y-m-d H:i:s",strtotime($filtered_data['start_plan_datetime'] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
									}
								}
						}
					}
					if (!empty($affected_keys['t_complete_datetime']))
					{
						switch ($filtered_data['complete_plan_datetime']) {
							case 'now':
								preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
								$filtered_data['complete_plan_datetime'] = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
								break;
							default:
								preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['complete_plan_datetime'],$parsed_datetime);
								if (empty($parsed_datetime))
								{
									return $this->showError('404', 'error', 'wrong t_complete_datetime');
								}
								else
								{						
									$filtered_data['complete_plan_datetime'] = $parsed_datetime[1] . " " . $parsed_datetime[2];
									if ($filtered_data['complete_plan_datetime'] == '0000-00-00 00:00:00')
									{
										return $this->showError('404', 'error', '0000-00-00 00:00:00 complete_datetime');
									}
									else
									{
										preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
										$filtered_data['complete_plan_datetime'] = gmdate("Y-m-d H:i:s",strtotime($filtered_data['complete_plan_datetime'] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
									}
								}
						}
					}


					if (empty($affected_keys['t_start_datetime_interval'])) $filtered_data['start_plan_datetime_interval'] = $start_plan_datetime_interval;

					if (empty($filtered_data['from']))
					{
						$place_from = get_place($filtered_data['from_lat'],$filtered_data['from_lng']);
					}
					else
					{
						if (!isset($filtered_data['from_lat']) || !isset($filtered_data['from_lng']))
						{
							list($filtered_data['from_lat'],$filtered_data['from_lng']) = address_to_lat_lng($filtered_data['from']);
						}
						$place_from = get_place($filtered_data['from_lat'],$filtered_data['from_lng']);
					}

					if (!isset($filtered_data['to_lat']) || !isset($filtered_data['to_lng']))
					{
						if (!empty($filtered_data['to']))
						{
							list($filtered_data['to_lat'],$filtered_data['to_lng']) = address_to_lat_lng($filtered_data['to']);
							$place_to = get_place($filtered_data['to_lat'],$filtered_data['to_lng']);
						}		
					}
					else
					{
						$place_to = get_place($filtered_data['to_lat'],$filtered_data['to_lng']);
					}

					if (!empty($place_from) && !empty($place_to) && $place_from['id'] == $place_to['id'])
					{
						$distance_estimate = get_distance($place_from['id'],lat_lng_to_square($filtered_data['from_lat'],$filtered_data['from_lng'],$place_from),lat_lng_to_square($filtered_data['to_lat'],$filtered_data['to_lng'],$place_from));
						if (gettype($distance_estimate) === 'double') 
						{
							$filtered_data['distance_estimate'] = $distance_estimate;	
							unset($filtered_data['distance_estimate']);
						}
					}
			}

			$s = array();
			foreach ($filtered_data as $key => $value)
			{
				if ($value !== NULL) {
					$s[] = "`" . $key . "` = '" . $value . "'";
				}
			}

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			$s = "INSERT INTO `trip`
				SET 
					" . implode(",\n", $s) .",
					`driver` = '" . $id_user . "',
					`last_edit_datetime` = now(),
					`last_edit_user` = '" . $_SESSION[UID] . "',
					`create_datetime` = now(),
					`create_user` = '" . $_SESSION[UID] . "'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database insert failed');

			$id_trip = insert_id();
			$out = array(						
						'affected_fields' 	=> 	$affected_fields,
						'forbidden_fields'	=>	$forbidden_fields
					);
			$out['t_id'] = $id_trip;

			if (DEFAULT_PROFILE == 'stadium')
			{
				$s = array();
				$id_trip_seat = 0;
				foreach($data['t_options']['seats_sold'] as $seat=>$val)
				{
					$id_trip_seat++;
					$tariff = $number = $status = $currency = NULL;
					if (is_array($val))
					{
						if (count($val) > 0 && isset($data['t_options']['price'][$val[0]]))
						{
							$tariff =  explode(' ',$data['t_options']['price'][$val[0]]);
							if (count($tariff) > 1)
							{
								$currency = $tariff[1];
							}
							$tariff = $tariff[0];
							if (isset($val[1])) $number = $val[1];
							if (isset($val[2])) $status = $val[2];
						}
					}
					else
					{
						if (isset($data['t_options']['price'][$val]))
						{
							$tariff =  explode(' ', $data['t_options']['price'][$val]);
							if (count($tariff) > 1)
							{
								$currency = $tariff[1];
							}
							$tariff = $tariff[0];
						}
					}
					if (isset($status) && $status != 1)
					{
						$blocks[$seat_blocks[$seat]]--;
						if ($blocks[$seat_blocks[$seat]] <= 0) unset($blocks[$seat_blocks[$seat]]);
					}
					$s[] = "('" . implode("','", array($id_schedule,$seat,$id_trip_seat,$id_trip)) . "'," . (isset($tariff) ? "'$tariff'" : 'NULL') . "," . (isset($currency) ? "'$currency'" : 'NULL') . "," . (isset($number) ? "'$number'" : 'NULL') . "," . (isset($status) ? "'$status'" : 'DEFAULT') . ",CONCAT_WS('-',$id_trip,$id_trip_seat,LOWER(HEX(CRC32(CONCAT($id_trip_seat,now()))))))";
				}
				$s = "INSERT INTO `ticket` (`" . implode("`,`", array('id_schedule','id_seat','id_trip_seat','id_trip','tariff','currency','number','status','code')) . "`) VALUES " . implode(",", $s);	

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'insert failed');
			}
			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			if (DEFAULT_PROFILE == 'stadium' && !empty($blocks))
			{
				$sql_where = array("''");
				foreach($blocks as $block=>$val)
				{
					$sql_where[] = "'$block'";
				}
				$sql_where = implode(',',$sql_where);

				$s = "SELECT 
						`cart_block`.`id_user`,
						`users`.`email`,
						`users`.`name`,
						`users`.`family`,
						`users`.`middle`,
						 GROUP_CONCAT(`id_cart_block` SEPARATOR ',') as cart_block,					 
						 GROUP_CONCAT(`property` SEPARATOR ';') as block_list
					FROM `cart_block`
					LEFT JOIN `users` USING (`id_user`)	
					WHERE
						`cart_block`.`product` = '" . $id_schedule . "' AND `cart_block`.`property` in (" . $sql_where . ") AND `cart_block`.`active` = 1  AND `cart_block`.`notification` = 1 AND `users`.`email` IS NOT NULL
					GROUP BY
						`cart_block`.`id_user`
					";		

				$q = query($s);
				if ($q === false)
				{
					$out['warning'][]  = 'users select failed';
				}
				else
				{
					while ($d = fetch_assoc($q))
					{
						$block_list = explode(';',$d['block_list']);
						$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
						$lang = $data_['langs'][$lang]['iso'];
						$lang_name = "{$lang}";
						$datetime_str = $data_sc['schedule'][$id_schedule]['datetime'];				
						$datetime_for_str = $datetime_str;
						if (!empty( $data_sc['schedule'][$id_schedule]['only_date'])) $datetime_for_str = @substr($datetime_for_str,0,10);
						$format = $this->constant['email_date_format'];
						preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
						list($datetime_for_str,$datetime_int,$datetime_int_tz) = get_date_arr_for_email($datetime_for_str,$data_sc['schedule'][$id_schedule]['only_date'],$data_sc['schedule'][$id_schedule]['time_zone'],$format,$format_with_tz);
						$dataForEmail = array(
							'{$u_id}' 			=> $d['id_user'],		
							'{$locationPath}' 	=> url('',CONFIG_URL),
							'{$u_name}' 		=> $d['name'],
							'{$u_family}' 		=> $d['family'],
							'{$u_middle}' 		=> $d['middle'],
							'{$schedule_arr}'	=>	array(
														'sc_id' 			=>	$id_schedule,
														'team1' 			=>	$data_stt['teams'][$data_sc['schedule'][$id_schedule]['team1']][$lang_name],
														'team2' 			=>	$data_stt['teams'][$data_sc['schedule'][$id_schedule]['team2']][$lang_name],
														'stadium'			=>	empty($data_sc['schedule'][$id_schedule]['id_stadium']) ? '' : $data_stt['stadiums'][$data_sc['schedule'][$id_schedule]['id_stadium']][$lang_name],
														'datetime'			=>	$datetime_for_str,
														'datetime_int'		=>	$datetime_int,
														'datetime_int_tz'	=>	$datetime_int_tz,
														'tournament'		=>	$data_stt['tournaments'][$data_sc['schedule'][$id_schedule]['tournament']][$lang_name]
													),
							'{$block}'		=>	implode(",", $block_list),
							'{$block_arr}'	=>	$block_list
						);
						$subject = lang('email_available_seats_subject','Message for user {$u_id} from {$locationPath}',2);
						$body = lang('email_available_seats_body','available seats',2);
						list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);
						$out['email status'] = send_mail($d['email'],$subject,$body);
						if (!empty($out['email status']))
						{
							$s = "UPDATE `cart_block`
								SET 
									`status_sys` = IF(`status_sys` = 1,2,`status_sys`)
								WHERE
									`id_cart_block` in (" . $d['cart_block'] . ")
								";

							query($s);
					
							if ($q === false) $out['warning'][]  = 'cart_block update failed';

							$s = array();
							foreach (explode(',',$d['cart_block']) as $id_cart_block)
							{
								$s[] = "('" . $id_cart_block. "', '" . $id_trip . "', 2)";
							}
							$s = "INSERT INTO `cart_block_trip` (`id_cart_block`, `id_trip`, `status_sys`) VALUES " . implode(",", $s);				

							query($s);
					
							if ($q === false) $out['warning'][]  = 'cart_block trip update failed';
						}
					}
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		public function selectTrip($id_trip = "", $type = NULL, $id_order = "", $filter = NULL, $fields = 0, $price_time_functions = array())
		{
			if (empty($_SESSION[UID])) {
				if ($type !== NULL) return $this->showError('404', 'error', 'unauthorized access');
			}
			else
			{
				if ($this->id_role != 1 && $this->id_role != 2 && $this->id_role != 4 && $this->id_role != 5)
				{
					if ($type !== NULL) return $this->showError('404', 'error', 'wrong user role');
				}
			}

			$sql_left_join = $orders = $cart = '';
			if (empty($id_trip))
			{
				$sql_where = '1=1';
			}
			else
			{
				$sql_where = "`trip`.`id_trip` in (" . $id_trip . ")";
			}
			$cart_sold_seats = "";
			$field_flag = array();
			if (!empty($fields))
			{
				$field_arr	= get_field_arr(empty($type) ? 'trip' : "{$type}Trip",$this->id_role);
				$bin_arr = get_bin_arr();
				foreach(str_split($fields) as $index => $char)
				{
					$value = get_0_64($char);
					if (empty($value)) continue;
					foreach($bin_arr as $bin_i)
					{
						if ($value & $bin_i) 
						{
							if (isset($field_arr[$index][$bin_i]))
							{
								$field_flag[$field_arr[$index][$bin_i]] = true;
							}
						}
					}
				}
			}
			$sql_left_join_schedule = '';
			if (DEFAULT_PROFILE == 'stadium')
			{
				$cart_sold_seats = ",
					(SELECT
						GROUP_CONCAT(CONCAT_WS(0x00,`id_user`,`property`,`booking_limit`) SEPARATOR 0x01)
					 FROM `cart`
					 WHERE `product` = `trip`.`id_trip` AND `booking_limit` > now()
					) as cart_seats,
					(SELECT
						GROUP_CONCAT(CONCAT_WS(0x00,`ticket`.`id_seat`,`ticket`.`id_trip_seat`,IFNULL(`ticket`.`tariff`,0x02),IFNULL(`ticket`.`currency`,0x02),IFNULL(`order`.`client`,0x02),IFNULL(`order`.`id_order`,0x02),IF(`order`.`pay_datetime`,'',IFNULL(`order`.`confirm_limit_datetime`,0x02)),IFNULL(`order`.`pay_datetime`,0x02),IFNULL(`ticket`.`number`,0x02),`status`) SEPARATOR 0x01)
					FROM `ticket`
					LEFT JOIN `order` ON `order`.`id_order` = `ticket`.`id_order`
					WHERE 
						 `ticket`.`id_trip` = `trip`.`id_trip`
					ORDER BY `ticket`.`id_seat`
					) as sold_seats,
					`trip`.`id_schedule` as sc_id,
					`schedule`.`start_datetime` as sc_datetime,
					`schedule`.`only_date` as sc_only_date,
					`schedule`.`time_zone` as sc_time_zone,
					`schedule`.`id_price_time_function` as sc_price_time_function,
					`schedule`.`currency` as sc_currency,
					`schedule`.`currency_priority` as sc_currency_priority,
					`schedule`.`fee` as sc_fee,
					`schedule`.`tariff` as sc_tariff,
					`schedule`.`tariff_priority` as sc_tariff_priority
					";
				$sql_left_join_schedule = "LEFT JOIN `schedule` USING (`id_schedule`)";
				if (!empty($filter))
				{
					$filter = explode(',',$filter);
					foreach($filter as $key=>$value)
					{
						$filter[$key] = 'sc_id' . chr(0) . trim($value);
					}
					$filter = implode("','",$filter);
					$sql_where .= " AND `trip`.`from` in ('" . $filter . "')";
				}
			}
			else
			{
				if (!empty($filter))
				{
					if ($filter = 'sd_cd')
					{
						$sql_where .= " AND (`start_plan_datetime` < now() AND `complete_plan_datetime` > now())";
					}
				}
			}
			if (!empty($id_order) && $type !== 'processing')
			{
				$sql_where .= " AND `order_trip`.`id_order` in (" . $id_order . ")";
			}
			if ($this->id_role == 2 || $this->id_role == 4)
			{
				$orders = ",
					IF(`order_trip`.`id_order` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS(0x00,
								`order_trip`.`id_order`,
								`order_trip`.`offer_order_datetime`,
								`order_trip`.`select_trip_datetime`
							)
						SEPARATOR 0x01) 
					) as orders";
				$sql_left_join = "LEFT JOIN `order_trip` USING (`id_trip`)";
				if ($this->id_role == 2) $sql_where .= " AND `trip`.`driver` = '" . $_SESSION[UID] . "'";
			}
			elseif ($this->id_role == 1 || $this->id_role == 5)
			{
				$sql_where .= " AND `trip`.`driver` != '" . $_SESSION[UID] . "'";
			}
			if ($type == 'active')
			{
				if ($this->id_role == 1 || $this->id_role == 5)
				{
					$orders = ",
						IF(`order_trip`.`id_order` IS NULL,NULL,
							GROUP_CONCAT(IF(`order`.`client` = '" . $_SESSION[UID] . "',
								CONCAT_WS(0x00,
									`order_trip`.`id_order`,
									`order_trip`.`offer_order_datetime`,
									`order_trip`.`select_trip_datetime`
								),
							NULL) SEPARATOR 0x01) 
						) as orders";
					$sql_left_join = "LEFT JOIN `order_trip` USING (`id_trip`)
					LEFT JOIN `order` ON `order`.`id_order` = `order_trip`.`id_order`";
					$sql_where .= " AND (
								SELECT
									`order_trip`.`id_trip`
								FROM
									`order_trip`
								LEFT JOIN `order` USING (`id_order`)
								WHERE
									`order_trip`.`id_trip` = `trip`.`id_trip` AND 
									`order`.`client` = '" . $_SESSION[UID] . "' AND 
									IF(`trip`.`looking_for_clients` = 1,1,IF(`order_trip`.`select_trip_datetime` = 0,0,1))
								LIMIT 1
							) IS NOT NULL";
				}
				$sql_where .= " AND `trip`.`complete_datetime` = 0";
			}
			elseif ($type == 'processing')
			{
				if ($this->id_role == 1 || $this->id_role == 5)
				{
					$sql_left_join = "LEFT JOIN (
								SELECT
									`order_trip`.`id_trip`
								FROM
									`order_trip`
								LEFT JOIN `order` USING (`id_order`)
								WHERE
									`order`.`client` = '" . $_SESSION[UID] . "'
								LIMIT 1
							) ot USING (`id_trip`)";
					$sql_where .= " AND `ot`.`id_trip` IS NULL AND `trip`.`looking_for_clients` = 1 AND `trip`.`complete_datetime` = 0";
				}
				else
				{
					return $this->showError('404', 'error', 'wrong role of user');
				}
			}
			else
			{
				if ($this->id_role == 1 || $this->id_role == 5)
				{
					$orders = ",
						IF(`order_trip`.`id_order` IS NULL,NULL,
							GROUP_CONCAT(IF(`order`.`client` = '" . $_SESSION[UID] . "',
								CONCAT_WS(0x00,
									`order_trip`.`id_order`,
									`order_trip`.`offer_order_datetime`,
									`order_trip`.`select_trip_datetime`
								),
							NULL) SEPARATOR 0x01) 
						) as orders";
					$sql_left_join = "LEFT JOIN `order_trip` USING (`id_trip`)
					LEFT JOIN `order` ON `order`.`id_order` = `order_trip`.`id_order`";
				}
			}

			$s = "SELECT			
					`trip`.`id_trip` as t_id,
					`trip`.`driver` as u_id,
					`trip`.`from` as t_start_address,
					`trip`.`from_lat` as t_start_latitude,
					`trip`.`from_lng` as t_start_longitude,
					`trip`.`to` as t_destination_address,
					`trip`.`to_lat` as t_destination_latitude,
					`trip`.`to_lng` as t_destination_longitude,
					`trip`.`start_plan_datetime_interval` as t_start_datetime_interval,
					`trip`.`start_plan_datetime` as t_start_datetime,
					`trip`.`complete_plan_datetime` as t_complete_datetime,
					`trip`.`start_datetime` as t_start_real_datetime,
					`trip`.`complete_datetime` as t_complete_real_datetime,
					`trip`.`last_edit_datetime` as t_edit_datetime,
					`trip`.`last_edit_user` as e_u_id,
					`trip`.`create_datetime` as t_create_datetime,
					`trip`.`create_user` as c_u_id,
					`trip`.`json` as t_options,
					`trip`.`looking_for_clients` as t_looking_for_clients,
					`trip`.`canceled` as t_canceled,
					`trip`.`id_price_time_function` as price_time_function,
					`trip`.`currency`,
					`trip`.`currency_priority`,
					`trip`.`fee`,
					`trip`.`tariff`,
					`trip`.`tariff_priority`
					" . $orders . "
					" . $cart_sold_seats . "
				FROM `trip`
				" . $sql_left_join . "
				" . $sql_left_join_schedule . "
				WHERE	
					" . $sql_where . "
				GROUP BY `trip`.`id_trip`
				ORDER BY `trip`.`last_edit_datetime` DESC
				" . (DEFAULT_PROFILE == 'stadium' && empty($this->limit_row_count) ? "" : "LIMIT " . $this->limit_offset . ", " . $this->limit_row_count) . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('trip' => array());
			while ($d = fetch_assoc($q))
			{
				$d['t_options'] = json_decode($d['t_options'],true);
				add_time_zone($d['t_create_datetime']);
				if (DEFAULT_PROFILE == 'stadium')
				{
					add_time_zone($d['sc_datetime']);
					$fix_seats = array();
					if (!empty($d['sold_seats']))
					{
						if (!empty($d['sc_datetime']))
						{
							$ptfd = $this->createPriceTimeFunctionData($d,$price_time_functions);
						}
						$currency = $currency_priority = NULL;
						if (isset($d['currency']))
						{
							$currency = $d['currency'];
						}
						elseif (isset($d['sc_currency']))
						{
							$currency = $d['sc_currency'];
						}
						if (isset($currency))
						{
							if (isset($d['currency_priority']))
							{
								$currency_priority = $d['currency_priority'];
							}
							else
							{
								$currency_priority = $d['sc_currency_priority'];
							}
							if (empty($currency_priority))
							{
								$currency_function = 'getTripCurrencyString10';
							}
							else
							{
								$currency_function = 'getTripCurrencyString11';
							}
						}
						else
						{					
							$currency_function = 'getTripCurrencyString0';
						}
						$tariff_ = $tariff_priority = NULL;
						if (isset($d['tariff']))
						{
							$tariff_ = $d['tariff'];
						}
						elseif (isset($d['sc_tariff']))
						{
							$tariff_ = $d['sc_tariff'];
						}
						if (isset($tariff_))
						{
							if (isset($d['tariff_priority']))
							{
								$tariff_priority = $d['tariff_priority'];
							}
							else
							{
								$tariff_priority = $d['sc_tariff_priority'];
							}
							if (empty($tariff_priority))
							{
								$tariff_function = 'getTripTariff10';
							}
							else
							{
								$tariff_function = 'getTripTariff11';
							}
						}
						else
						{					
							$tariff_function = 'getTripTariff0';
						}
						$d['sold_seats'] = explode(chr(1),$d['sold_seats']);
						$d['t_options']['seats_sold'] = array();
						$d['t_options']['price'] = array();
						$price = array();
						foreach ($d['sold_seats'] as $key=>$value)
						{
							$d['sold_seats'][$key] = array();
							list(
								$d['sold_seats'][$key]['id_seat'],
								$d['sold_seats'][$key]['id_trip_seat'],
								$d['sold_seats'][$key]['tariff'],
								$d['sold_seats'][$key]['currency'],
								$d['sold_seats'][$key]['client'],
								$d['sold_seats'][$key]['id_order'],
								$d['sold_seats'][$key]['pay_limit'],
								$d['sold_seats'][$key]['pay'],
								$d['sold_seats'][$key]['number'],
								$d['sold_seats'][$key]['status']
								)= explode(chr(0),$value);
							$seat = $d['sold_seats'][$key]['id_seat'];
							$d['sold_seats'][$key]['tariff'] = $this->$tariff_function($tariff_,$d['sold_seats'][$key]['tariff']);
							if ($d['sold_seats'][$key]['tariff'] !== '')
							{
								if (isset($ptfd['price_time_function']))
								{
									$var = $ptfd['var'];
									if (!empty($ptfd['dp'])) $var['dp'] = $d['sold_seats'][$key]['tariff'];
									$d['sold_seats'][$key]['tariff'] = $ptfd['price_time_function']($var);
								}
								$tariff = $d['sold_seats'][$key]['tariff'] . $this->$currency_function($currency,$d['sold_seats'][$key]['currency']);
								$tariff = strtoupper($tariff);
								if (!isset($price[$tariff]))
								{
									$price[$tariff] = count($d['t_options']['price']);
									$d['t_options']['price'][] = $tariff;
								}
								$d['t_options']['seats_sold'][$seat] = array($price[$tariff]);
							}
							else
							{
								$d['t_options']['seats_sold'][$seat] = array('');
							}
							if ($d['sold_seats'][$key]['number'] === chr(2)) $d['sold_seats'][$key]['number'] = NULL;
							if ($d['sold_seats'][$key]['client'] === chr(2))
							{
								switch($d['sold_seats'][$key]['status'])
								{
									case 2:
										$d['t_options']['seats_sold'][$seat] = array(
											$d['t_options']['seats_sold'][$seat][0],
											-1,
											-1
										);
										break;								
									case 3:
										$d['t_options']['seats_sold'][$seat] = array(
											$d['t_options']['seats_sold'][$seat][0],
											-1
										);
										break;
								}
							}
							else
							{
								add_time_zone($d['sold_seats'][$key]['pay_limit']);
								add_time_zone($d['sold_seats'][$key]['pay']);
								$d['t_options']['seats_sold'][$seat] = array(
									$d['t_options']['seats_sold'][$seat][0],
									$d['sold_seats'][$key]['client'],
									$d['sold_seats'][$key]['id_order']
								);
								if ($d['sold_seats'][$key]['pay'] === NULL)
								{
									$d['t_options']['seats_sold'][$seat][] = $d['sold_seats'][$key]['pay_limit'];
								}
							}
							if (!empty($field_flag['seats_sold with number, status']))
							{
								$d['t_options']['seats_sold'][$seat][0] = array($d['t_options']['seats_sold'][$seat][0],$d['sold_seats'][$key]['number'],$d['sold_seats'][$key]['status']);
							
							}
							$fix_seats[$d['sold_seats'][$key]['id_trip_seat']] = $d['sold_seats'][$key]['id_seat'];
						}
						unset($d['sold_seats']);
					}
					if (!empty($d['cart_seats']))
					{
						$d['cart_seats'] = explode(chr(1),$d['cart_seats']);
						foreach ($d['cart_seats'] as $key=>$value)
						{
							$d['cart_seats'][$key] = array();
							list(
								$d['cart_seats'][$key]['id_user'],
								$d['cart_seats'][$key]['property'],
								$d['cart_seats'][$key]['limit']
								)= explode(chr(0),$value);
							$seat = $d['cart_seats'][$key]['property'];
							if (!empty($fix_seats[$seat]) && isset($d['t_options']['seats_sold'][$fix_seats[$seat]]))
							{
								$seat = $fix_seats[$seat];
								add_time_zone($d['cart_seats'][$key]['limit']);
								if (is_array($d['t_options']['seats_sold'][$seat]))
								{
									if (count($d['t_options']['seats_sold'][$seat]) > 1) continue;
									$d['t_options']['seats_sold'][$seat] = array(
										isset($d['t_options']['seats_sold'][$seat][0])?$d['t_options']['seats_sold'][$seat][0]:"",
										$d['cart_seats'][$key]['id_user'],
										NULL,
										$d['cart_seats'][$key]['limit']
									);
								}
								else
								{
									$d['t_options']['seats_sold'][$seat] = array(
										$d['t_options']['seats_sold'][$seat],
										$d['cart_seats'][$key]['id_user'],
										NULL,
										$d['cart_seats'][$key]['limit']
									);
								}
							}
						}
					}
					unset($d['cart_seats']);
					if (!empty($d['t_options']['seats_sold']) && is_array($d['t_options']['seats_sold']))
					{
						$a_z_digit_flag = array('','','');
						$seats_sold_sort = array();
						$max_length = array(0,0,0);
						$replace_arr = array(
								'a' => '','b' => '','c' => '','d' => '','e' => '',
								'f' => '','g' => '','h' => '','i' => '','j' => '',
								'k' => '','l' => '','m' => '','n' => '','o' => '',
								'p' => '','q' => '','r' => '','s' => '','t' => '',
								'u' => '','v' => '','w' => '','x' => '','y' => '',
								'z' => ''
						);						
						if ($this->id_role != 2 && $this->id_role != 4)
						{
							foreach($d['t_options']['seats_sold'] as $seat=>$val)
							{
								if (is_array($val) && count($val) > 1)
								{
									$id = $val[1];
									if (empty($_SESSION[UID]) || trim($id) != $_SESSION[UID]) 
									{
										unset($d['t_options']['seats_sold'][$seat]);
										continue;
									}
								}
								else
								{
									if (!is_array($val)) $val = array($val);
								}
								$seat_s_b_r_s = explode(';',$seat);
								if (count($seat_s_b_r_s) < 4) continue;
								$d['stadium'] = $seat_s_b_r_s[0];
								$parsed_block = $seat_s_b_r_s[1];
								$parsed_row = $seat_s_b_r_s[2];
								$parsed_seat = $seat_s_b_r_s[3];
								$seats_sold_sort[] = array(array($parsed_block,$parsed_row,$parsed_seat),$val);
								if (($c_length = strlen($parsed_block)) > $max_length[0]) $max_length[0] = $c_length;
								if (($c_length = strlen($parsed_row)) > $max_length[1]) $max_length[1] = $c_length;
								if (($c_length = strlen($parsed_seat)) > $max_length[2]) $max_length[2] = $c_length;
								if (ctype_digit($parsed_seat) === true)
								{
									if ($a_z_digit_flag[2] === '' || $a_z_digit_flag[2] === 'd') 
									{
										$a_z_digit_flag[2] = 'd';
									}
									else
									{
										$a_z_digit_flag[2] = '?';
									}
								}
								elseif (strtr($parsed_seat,$replace_arr) === '')
								{
									if ($a_z_digit_flag[2] === '' || $a_z_digit_flag[2] === 'a') 
									{
										$a_z_digit_flag[2] = 'a';
									}
									else
									{
										$a_z_digit_flag[2] = '?';
									}
								}
								else
								{
									$a_z_digit_flag[2] = '?';
								}
							}
						}
						else
						{
							foreach($d['t_options']['seats_sold'] as $seat=>$val)
							{
								$seat_s_b_r_s = explode(';',$seat);
								if (count($seat_s_b_r_s) < 4) continue;
								$d['stadium'] = $seat_s_b_r_s[0];
								$parsed_block = $seat_s_b_r_s[1];
								$parsed_row = $seat_s_b_r_s[2];
								$parsed_seat = $seat_s_b_r_s[3];
								$seats_sold_sort[] = array(array($parsed_block,$parsed_row,$parsed_seat),$val);
								if (($c_length = strlen($parsed_block)) > $max_length[0]) $max_length[0] = $c_length;
								if (($c_length = strlen($parsed_row)) > $max_length[1]) $max_length[1] = $c_length;
								if (($c_length = strlen($parsed_seat)) > $max_length[2]) $max_length[2] = $c_length;
								if (ctype_digit($parsed_seat) === true){
									if ($a_z_digit_flag[2] === '' || $a_z_digit_flag[2] === 'd') 
									{
										$a_z_digit_flag[2] = 'd';
									}
									else
									{
										$a_z_digit_flag[2] = '?';
									}
								}
								elseif (strtr($parsed_seat,$replace_arr) === '')
								{
									if ($a_z_digit_flag[2] === '' || $a_z_digit_flag[2] === 'a') 
									{
										$a_z_digit_flag[2] = 'a';
									}
									else
									{
										$a_z_digit_flag[2] = '?';
									}
								}
								else
								{
									$a_z_digit_flag[2] = '?';
								}
							}
						}
						if (!empty($seats_sold_sort))
						{
							usort(
								$seats_sold_sort,
								function ($arr1, $arr2) use ($a_z_digit_flag,$max_length)
								{
									$block1 = strtolower($arr1[0][0]);
									$block2 = strtolower($arr2[0][0]);
									$row1 = strtolower($arr1[0][1]);
									$row2 = strtolower($arr2[0][1]);
									if ($block1 > $block2) return 1;
									if ($block1 < $block2) return -1;
									if ($row1 > $row2) return 1;
									if ($row1 < $row2) return -1;
									$flag1 = $a_z_digit_flag[2] === 'd' ? (int)$arr1[0][2] : str_repeat(' ',$max_length[2]-strlen($str = strtolower($arr1[0][2]))) . $str;
									$flag2 = $a_z_digit_flag[2] === 'd' ? (int)$arr2[0][2] : str_repeat(' ',$max_length[2]-strlen($str = strtolower($arr2[0][2]))) . $str;
									if ($flag1 > $flag2) 
									{
										return 1;
									}
									elseif ($flag1 < $flag2)
									{
										return -1;
									}
									else
									{
										return 0;
									}
								}
							);
							$compressed = array();
							if ($a_z_digit_flag[2] == '?' || !empty($field_flag['seats_sold with number, status']) || count($seats_sold_sort) < 2)
							{
								foreach($seats_sold_sort as $value)
								{
									$val = $value[1];
									$parsed_block =$value[0][0];
									$parsed_row = $value[0][1];
									$parsed_seat = $value[0][2];
									$compressed[$parsed_block][$parsed_row][$parsed_seat] = $val;
								}
							}
							else
							{
								$value = $seats_sold_sort[0];
								$val = $value[1];
								$parsed_block =$value[0][0];
								$parsed_row = $value[0][1];
								$parsed_seat = $value[0][2];
								$group_val = $val;
								$group_0 = array($parsed_block,$parsed_row,$parsed_seat);
								$group_1 = array($parsed_block,$parsed_row,$parsed_seat);
								$group_prev = array($parsed_block,$parsed_row,$parsed_seat);
								$imax = count($seats_sold_sort);
								for($i = 1; $i < $imax; $i++)
								{
									$value = $seats_sold_sort[$i];
									$val = $value[1];
									$parsed_block =$value[0][0];
									$parsed_row = $value[0][1];
									$parsed_seat = $value[0][2];
									if ($val === $group_val)
									{
										if ($parsed_block === $group_prev[0] && $parsed_row === $group_prev[1])
										{
											if (is_prev_value($group_prev[2],$parsed_seat,$a_z_digit_flag[2]) === true)
											{
												$group_1 = array($parsed_block,$parsed_row,$parsed_seat);
												$group_prev = array($parsed_block,$parsed_row,$parsed_seat);
											}
											else
											{
												if ($group_0[2] === $group_1[2])
												{
													$compressed[$group_0[0]][$group_0[1]][$group_0[2]] = $group_val;
												}
												else
												{
													$compressed[$group_0[0]][$group_0[1]][$group_0[2] . ';' . $group_1[2]] = $group_val;
												}
												$group_val = $val;
												$group_0 = array($parsed_block,$parsed_row,$parsed_seat);
												$group_1 = array($parsed_block,$parsed_row,$parsed_seat);
												$group_prev = array($parsed_block,$parsed_row,$parsed_seat);
											}
										}
										else
										{
											if ($group_0[2] === $group_1[2])
											{
												$compressed[$group_0[0]][$group_0[1]][$group_0[2]] = $group_val;
											}
											else
											{
												$compressed[$group_0[0]][$group_0[1]][$group_0[2] . ';' . $group_1[2]] = $group_val;
											}
											$group_val = $val;
											$group_0 = array($parsed_block,$parsed_row,$parsed_seat);
											$group_1 = array($parsed_block,$parsed_row,$parsed_seat);
											$group_prev = array($parsed_block,$parsed_row,$parsed_seat);
										}
									}
									else
									{
										if ($group_0[2] === $group_1[2])
										{
											$compressed[$group_0[0]][$group_0[1]][$group_0[2]] = $group_val;
										}
										else
										{
											$compressed[$group_0[0]][$group_0[1]][$group_0[2] . ';' . $group_1[2]] = $group_val;
										}
										$group_val = $val;
										$group_0 = array($parsed_block,$parsed_row,$parsed_seat);
										$group_1 = array($parsed_block,$parsed_row,$parsed_seat);
										$group_prev = array($parsed_block,$parsed_row,$parsed_seat);
									}
								}
								if ($group_0[2] === $group_1[2])
								{
									$compressed[$group_0[0]][$group_0[1]][$group_0[2]] = $group_val;
								}
								else
								{
									$compressed[$group_0[0]][$group_0[1]][$group_0[2] . ';' . $group_1[2]] = $group_val;
								}
							}
							$d['t_options']['seats_sold'] = $compressed;
						}
					}
				}
				if (!empty($d['orders']))
				{
					$d['orders'] = explode(chr(1),$d['orders']);
					foreach ($d['orders'] as $key=>$value)
					{
						$d['orders'][$key] = array();
						list(
							$d['orders'][$key]['b_id'],
							$d['orders'][$key]['b_offer_datetime'],
							$d['orders'][$key]['b_select_datetime']
							)= explode(chr(0),$value);

						add_time_zone($d['orders'][$key]['b_offer_datetime']);
						add_time_zone($d['orders'][$key]['b_select_datetime']);
					}
				}

				add_time_zone($d['t_start_datetime']);
				add_time_zone($d['t_complete_datetime']);
				add_time_zone($d['t_start_real_datetime']);
				add_time_zone($d['t_complete_real_datetime']);
				add_time_zone($d['t_edit_datetime']);
				$d['t_looking_for_clients'] = (int)$d['t_looking_for_clients'];	
				$d['t_canceled'] = (int)$d['t_canceled'];	
				$out['trip'][$d['t_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['trip'] =  array_values($out['trip']);

			if (!empty($_SESSION[UID]))
			{
				$auth_user = array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
				);
			}
			else
			{
				$auth_user = array();
			}
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	$auth_user
			);
		}

		public function editTrip($data = "", $id_trip = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 2 && $this->id_role != 4)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(
									't_start_address'			=>		'from',
									't_start_latitude'			=>		'from_lat',
									't_start_longitude'			=>		'from_lng',
									't_destination_address'		=>		'to',
									't_destination_latitude'	=>		'to_lat',
									't_destination_longitude'	=>		'to_lng',			
									't_start_datetime_interval'	=>		'start_plan_datetime_interval',		
									't_start_datetime'			=>		'start_plan_datetime',
									't_complete_datetime'		=>		'complete_plan_datetime',
									't_options'					=>		'json',
									't_start_real_datetime'		=>		'start_datetime',
									't_complete_real_datetime'	=>		'complete_datetime',	
									't_looking_for_clients'		=>		'looking_for_clients',
									't_canceled'				=>		'canceled',
									'price_time_function'		=>		'id_price_time_function',
									'currency'					=>		'currency',
									'currency_priority'			=>		'currency_priority',	
									'fee'						=>		'fee',
									'tariff'					=>		'tariff',
									'tariff_priority'			=>		'tariff_priority'								
			);

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			$s = "SELECT			
					`trip`.`id_trip`,
					`trip`.`driver`,
					`trip`.`from`,
					`trip`.`from_lat`,
					`trip`.`from_lng`,
					`trip`.`to`,
					`trip`.`to_lat`,
					`trip`.`to_lng`,
					`trip`.`start_plan_datetime_interval`,
					`trip`.`start_plan_datetime`,
					`trip`.`complete_plan_datetime`,
					`trip`.`start_datetime`,
					`trip`.`complete_datetime`,
					`trip`.`json`,
					`trip`.`looking_for_clients`,
					`trip`.`canceled`,
					IF(`order_trip`.`id_order` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS(0x00,
								`order_trip`.`id_order`,
								`order_trip`.`offer_order_datetime`,
								`order_trip`.`select_trip_datetime`,
								`order`.`id_order_status`,
								IFNULL(od.`id_order_driver_status`,0x02)
							)
						SEPARATOR 0x01) 
					) as orders
				FROM `trip`
				LEFT JOIN `order_trip` USING (`id_trip`)
				LEFT JOIN `order` ON `order`.`id_order` = `order_trip`.`id_order`
				LEFT JOIN (
					SELECT
						`id_order_driver_status`,
						`id_order`
					FROM
						`order_driver`
					WHERE
						`id_user` = '" . $_SESSION[UID] . "'
					LIMIT 1
				) od ON od.`id_order` = `order`.`id_order`
				WHERE	
					`id_trip` = '" . $id_trip . "'
				GROUP BY `trip`.`id_trip`
				LIMIT 1
				FOR UPDATE
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_trip'])) return $this->showError('404', 'error', 'trip not found');
			if ($this->id_role != 4 && $d['driver'] != $_SESSION[UID]) 
			{
				return $this->showError('404', 'error', 'user is not author');
			}
			if ($d['complete_datetime'] != "0000-00-00 00:00:00") return $this->showError('404', 'error', 'completed trip');
			if (!empty($d['canceled'])) return $this->showError('404', 'error', 'canceled trip');

			$d['json'] = json_decode($d['json'],true);

			if (!empty($d['orders']))
			{
				$d['orders'] = explode(chr(1),$d['orders']);
				foreach ($d['orders'] as $key=>$value)
				{
					$d['orders'][$key] = array();
					list(
						$d['orders'][$key]['id_order'],
						$d['orders'][$key]['offer_order_datetime'],
						$d['orders'][$key]['select_trip_datetime'],
						$d['orders'][$key]['id_order_status'],
						$d['orders'][$key]['id_order_driver_status']
						)= explode(chr(0),$value);

					if ($d['orders'][$key]['id_order_driver_status'] === chr(2))
					{
						$d['orders'][$key]['id_order_driver_status'] = NULL;
					}
				}

				unset($allowed_fields['t_start_address']);
				unset($allowed_fields['t_start_latitude']);
				unset($allowed_fields['t_start_longitude']);
				unset($allowed_fields['t_destination_address']);
				unset($allowed_fields['t_destination_latitude']);
				unset($allowed_fields['t_destination_longitude']);
				unset($allowed_fields['t_start_datetime_interval']);
				unset($allowed_fields['t_start_datetime']);
				unset($allowed_fields['t_complete_datetime']);
			}

			$forbidden_fields = array();
			$affected_fields = array();
			$affected_keys = array();
			$filtered_data = array();

			foreach ($data as $key => $value)
			{
				if (!empty($allowed_fields[$key]))
				{
					if (is_string($value)) $data[$key] = trim($value);
					$affected_fields[] = $key;
					$affected_keys[$key] = true;
					if ($allowed_fields[$key] !== true) $filtered_data[$allowed_fields[$key]] = $data[$key];
				}
				else
				{
					$forbidden_fields[] = $key;
				}
			}

			if (!empty($filtered_data['canceled']))
			{
				if (empty($affected_keys['t_start_real_datetime']))	
				{
					$filtered_data['complete_datetime'] = 'now';
					$filtered_data['canceled'] = 1;
				}
			}
			else
			{
				if (!empty($affected_keys['t_canceled'])) $filtered_data['canceled'] = 0;
			}

			if (!empty($affected_keys['t_looking_for_clients'])) 
			{
				if (empty($filtered_data['looking_for_clients']))
				{
					$filtered_data['looking_for_clients'] = 0;
				}
				else
				{
					$filtered_data['looking_for_clients'] = 1;
				}			
			}

			if (!empty($affected_keys['t_start_datetime']))
			{
				switch ($filtered_data['start_plan_datetime']) {
					case 'now':
						preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
						$filtered_data['start_plan_datetime'] = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
						break;
					default:
						preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['start_plan_datetime'],$parsed_datetime);
						if (empty($parsed_datetime))
						{
							return $this->showError('404', 'error', 'wrong t_start_datetime');
						}
						else
						{
							$filtered_data['start_plan_datetime'] = $parsed_datetime[1] . " " . $parsed_datetime[2];
							if ($filtered_data['start_plan_datetime'] == '0000-00-00 00:00:00')
							{
								return $this->showError('404', 'error', '0000-00-00 00:00:00 t_start_datetime');
							}
							else
							{
								preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
								$datetime_start_plan = gmdate("Y-m-d H:i:s",strtotime($filtered_data['start_plan_datetime'] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
							}
						}
				}
			}
			if (!empty($affected_keys['t_complete_datetime']))
			{
				switch ($filtered_data['complete_plan_datetime']) {
					case 'now':
						preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
						$filtered_data['complete_plan_datetime'] = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
						break;
					default:
						preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['complete_plan_datetime'],$parsed_datetime);
						if (empty($parsed_datetime))
						{
							return $this->showError('404', 'error', 'wrong t_complete_datetime');
						}
						else
						{						
							$filtered_data['complete_plan_datetime'] = $parsed_datetime[1] . " " . $parsed_datetime[2];
							if ($filtered_data['complete_plan_datetime'] == '0000-00-00 00:00:00')
							{
								return $this->showError('404', 'error', '0000-00-00 00:00:00 t_complete_datetime');
							}
							else
							{
								preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
								$filtered_data['complete_plan_datetime'] = gmdate("Y-m-d H:i:s",strtotime($filtered_data['complete_plan_datetime'] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
							}
						}
				}
			}

			if (!empty($affected_keys['t_start_real_datetime']))
			{
				if ($d['start_datetime'] != "0000-00-00 00:00:00") return $this->showError('404', 'error', 't_start_real_datetime already defined');

				switch ($filtered_data['start_datetime']) {
					case 'now':
						preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
						$filtered_data['start_datetime'] = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
						break;
					default:
						preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['start_datetime'],$parsed_datetime);
						if (empty($parsed_datetime))
						{
							return $this->showError('404', 'error', 'wrong t_start_real_datetime');
						}
						else
						{						
							$filtered_data['start_datetime'] = $parsed_datetime[1] . " " . $parsed_datetime[2];
							if ($filtered_data['start_datetime'] == '0000-00-00 00:00:00')
							{
								return $this->showError('404', 'error', '0000-00-00 00:00:00 t_start_real_datetime');
							}
							else
							{
								preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
								$filtered_data['start_datetime'] = gmdate("Y-m-d H:i:s",strtotime($filtered_data['start_datetime'] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
							}
						}
				}
			}

			if (array_key_exists('complete_datetime',$filtered_data))
			{
				switch ($filtered_data['complete_datetime']) {
					case 'now':
						preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
						$filtered_data['complete_datetime'] = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
						break;
					default:
						preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$filtered_data['complete_datetime'],$parsed_datetime);
						if (empty($parsed_datetime))
						{
							return $this->showError('404', 'error', 'wrong t_complete_real_datetime');
						}
						else
						{						
							$filtered_data['complete_datetime'] = $parsed_datetime[1] . " " . $parsed_datetime[2];
							if ($filtered_data['complete_datetime'] == '0000-00-00 00:00:00')
							{
								return $this->showError('404', 'error', '0000-00-00 00:00:00 t_complete_real_datetime');
							}
							else
							{
								preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
								$filtered_data['complete_datetime'] = gmdate("Y-m-d H:i:s",strtotime($filtered_data['complete_datetime'] .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
							}
						}
				}
			}
			
			if (!empty($affected_keys['t_options']))
			{
				$options = $d['json'];
				if (!is_array($options)) $options = array();
				
				if (!is_array($filtered_data['json'])) return $this->showError('404', 'error', 't_options not array');
				$options_is_updated = false;
				foreach($filtered_data['json'] as $options_element)
				{
					if (!is_array($options_element)) return $this->showError('404', 'error', 't_options element not array');
					if (empty($options_element[0]))	return $this->showError('404', 'error', 't_options element without operator');
					$options_element[0] = trim($options_element[0]);
					switch ($options_element[0]){
						case '=':
							if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty t_options element keys for assignment');
							if (!is_array($options_element[1])) return $this->showError('404', 'error', 't_options element keys for assignment not array');
							if (!isset($options_element[2])) return $this->showError('404', 'error', 'empty t_options element value for assignment');
							$options_prev = $options;
							$arr_o = &$options;
							$check_create_list = $check_edit_list = false;
							if (!empty($this->constant['t_options_valid_keys'])) 
							{
								$arr_v = $this->constant['t_options_valid_keys'];
								$check_create_list = true;
							}
							if (!empty($this->constant['t_options_edit_list_keys'])) 
							{
								$arr_e = $this->constant['t_options_edit_list_keys'];
								$check_edit_list = true;
							}
							$options_element_is_updated = false;
							foreach($options_element[1] as $options_key)
							{
								@$options_key = (string)$options_key;
								if (!is_array($arr_o)) 
								{
									return $this->showError('404', 'error', 't_options value for element key' . $options_key . ' for assignment not array');
								}
								if ($check_create_list === true)
								{
									if (!array_key_exists($options_key,$arr_v)) return $this->showError('404', 'error', 'wrong t_options element keys for assignment');
									$arr_v = $arr_v[$options_key];
									if ($arr_v === true) 
									{
										$check_create_list = false;
									}
								}
								if ($check_edit_list === true)
								{
									if (empty($this->constant['t_options_edit_list_readonly']))
									{				
										if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 't_options element keys for assignment not editable');
										$arr_e = $arr_e[$options_key];
										if ($arr_e === true) 
										{
											$check_edit_list = false;
										}
									}
									else
									{
										if (array_key_exists($options_key,$arr_e))
										{
											$arr_e = $arr_e[$options_key];
										}
										else
										{
											$check_edit_list = false;
										}
										if ($arr_e === true) return $this->showError('404', 'error', 't_options element keys for assignment readonly');
									}
								}
								if (!array_key_exists($options_key,$arr_o)) 
								{
									$arr_o[$options_key] = array();
									$options_element_is_updated = true;
								}
								$arr_o = &$arr_o[$options_key];
							}
							if ($arr_o !== $options_element[2])
							{					
								$arr_o = $options_element[2];
								$add = $options_element[2];								
								if ($check_create_list === true)
								{
									if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong t_options element value keys for assignment');
								}
								if ($check_edit_list === true)
								{
									if (empty($this->constant['t_options_edit_list_readonly']))
									{
										if (array_includes_only_add_keys_from_assoc_list($add,$arr_e) === false) return $this->showError('404', 'error', 't_options element value keys for assignment not editable');
									}
									else
									{
										if (array_includes_add_keys_from_assoc_list($add,$arr_e) === true) return $this->showError('404', 'error', 't_options element value keys for assignment readonly');
									}
								}
								$check_create_list = false;
								$check_edit_list = false;
								$options_element_is_updated = true;
							}
							unset($arr_o);
							if ($options_element_is_updated === true && $check_create_list === false &&  $check_edit_list === false) 
							{
								$options_is_updated = true;
							}
							else
							{
								$options = $options_prev;
							}
							break;
						case '+':
							if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty t_options element keys for addition');
							if (!is_array($options_element[1])) return $this->showError('404', 'error', 't_options element keys for addition not array');
							if (!isset($options_element[2])) return $this->showError('404', 'error', 'empty t_options element value for addition');
							$options_prev = $options;
							$arr_o = &$options;
							$check_create_list = $check_edit_list = false;
							if (!empty($this->constant['t_options_valid_keys'])) 
							{
								$arr_v = $this->constant['t_options_valid_keys'];
								$check_create_list = true;
							}
							if (!empty($this->constant['t_options_edit_list_keys'])) 
							{
								$arr_e = $this->constant['t_options_edit_list_keys'];
								$check_edit_list = true;
							}
							$options_element_is_updated = false;
							foreach($options_element[1] as $options_key)
							{
								@$options_key = (string)$options_key;
								if (!is_array($arr_o))
								{
									return $this->showError('404', 'error', 't_options value for element key' . $options_key . ' for addition not array');
								}
								if ($check_create_list === true)
								{
									if (!array_key_exists($options_key,$arr_v)) return $this->showError('404', 'error', 'wrong t_options element keys for addition');
									$arr_v = $arr_v[$options_key];
									if ($arr_v === true) 
									{
										$check_create_list = false;
									}
								}

								if ($check_edit_list === true)
								{
									if (empty($this->constant['t_options_edit_list_readonly']))
									{				
										if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 't_options element keys for addition not editable');
										$arr_e = $arr_e[$options_key];

										if ($arr_e === true) 
										{
											$check_edit_list = false;
										}
									}
									else
									{
										if (array_key_exists($options_key,$arr_e))
										{
											$arr_e = $arr_e[$options_key];
										}
										else
										{
											$check_edit_list = false;
										}
										if ($arr_e === true) return $this->showError('404', 'error', 't_options element keys for addition readonly');
									}
								}
								if (!array_key_exists($options_key,$arr_o)) 
								{
									$arr_o[$options_key] = array();
									$options_element_is_updated = true;
								}

								$arr_o = &$arr_o[$options_key];
							}
							if (is_array($arr_o))
							{
								$arr_o[] = $options_element[2];
								end($arr_o);
								$add = array(key($arr_o)=>$options_element[2]);								
								if ($check_create_list === true)
								{
									if (array_includes_only_add_keys_from_assoc_list($add,$arr_v) === false) return $this->showError('404', 'error', 'wrong t_options element value keys for addition');
								}
								if ($check_edit_list === true)
								{
									if (empty($this->constant['t_options_edit_list_readonly']))
									{
										if (array_includes_only_add_keys_from_assoc_list($add,$arr_e) === false) return $this->showError('404', 'error', 't_options element value keys for addition not editable');
									}
									else
									{
										if (array_includes_add_keys_from_assoc_list($add,$arr_e) === true) return $this->showError('404', 'error', 't_options element value keys for addition readonly');
									}
								}
								$check_create_list = false;
								$check_edit_list = false;
								$options_element_is_updated = true;
							}
							else
							{
								if ($check_create_list === false && $check_edit_list === false)
								{
									if (is_array($options_element[2]))
									{
										$arr_o .= json_encode($options_element[2]);
									}
									else
									{
										$arr_o .= $options_element[2];
									}
									$options_element_is_updated = true;
								}
								else
								{
									return $this->showError('404', 'error', 'wrong b_options structure for addition');
								}
							}
							unset($arr_o);
							if ($options_element_is_updated === true && $check_create_list === false &&  $check_edit_list === false) 
							{
								$options_is_updated = true;
							}
							else
							{
								$options = $options_prev;
							}
							break;
						case '-':
							if (!isset($options_element[1])) return $this->showError('404', 'error', 'empty t_options element keys for removal');
							if (!is_array($options_element[1])) return $this->showError('404', 'error', 't_options element keys for removal not array');
							if (empty($options_element[1]) || !is_array($options) || empty($options)) break;
							$arr_o = &$options;
							$check_edit_list = false;
							if (!empty($this->constant['t_options_edit_list_keys'])) 
							{
								$arr_e = $this->constant['t_options_edit_list_keys'];
								$check_edit_list = true;
							}
							$count_key = count($options_element[1]);
							$i = 0;

							$options_element_is_updated = true;
							foreach($options_element[1] as $options_key)
							{
								@$options_key = (string)$options_key;
								$i++;
								if (!is_array($arr_o) || !array_key_exists($options_key,$arr_o)) 
								{
									$check_edit_list = false;
									$options_element_is_updated = false;

									break;
								}
								if ($check_edit_list === true)
								{
									if (empty($this->constant['t_options_edit_list_readonly']))
									{				
										if (!array_key_exists($options_key,$arr_e)) return $this->showError('404', 'error', 't_options element keys for removal not editable');
										$arr_e = $arr_e[$options_key];
										if ($arr_e === true) 
										{
											$check_edit_list = false;
										}
									}
									else
									{
										if (array_key_exists($options_key,$arr_e))
										{
											$arr_e = $arr_e[$options_key];
										}
										else
										{
											$check_edit_list = false;
										}
										if ($arr_e === true) return $this->showError('404', 'error', 't_options element keys for removal readonly');
									}
								}
								if ($i < $count_key) {$arr_o = &$arr_o[$options_key];}
							}
							if ($check_edit_list === true)
							{
								return $this->showError('404', 'error', 't_options element keys for removal part of not editable or readonly');
							}
							if ($options_element_is_updated === true) 
							{
								unset($arr_o[$options_key]);
								$options_is_updated = true;
							}
							unset($arr_o);
							break;
						default:
							return $this->showError('404', 'error', 'wrong t_options element operator');
					}
				}
				if ($options_is_updated === true)
				{
					$filtered_data['json'] = real_escape_string(json_encode($options));
				}
				else
				{
					unset($filtered_data['json']);
					unset($affected_keys['t_options']);
				}
			}
		
			if (empty($affected_keys)) return $this->showError('404', 'error', 'allowed data not found');

			if (isset($filtered_data['from_lat']) || isset($filtered_data['from_lng'])
				|| isset($filtered_data['to_lat']) || isset($filtered_data['to_lng']))
			{
				$from_lat = isset($filtered_data['from_lat']) ? $filtered_data['from_lat'] : $d['from_lat'];
				$from_lng = isset($filtered_data['from_lng']) ? $filtered_data['from_lng'] : $d['from_lng'];
				$to_lat = isset($filtered_data['to_lat']) ? $filtered_data['to_lat'] : $d['to_lat'];
				$to_lng = isset($filtered_data['to_lng']) ? $filtered_data['to_lng'] : $d['to_lng'];
				$place_from = get_place($from_lat,$from_lng);
				$place_to = get_place($to_lat,$to_lng );

				if (!empty($place_from) && !empty($place_to) && $place_from['id'] == $place_to['id'])
				{
					$distance_estimate = get_distance($place_from['id'],lat_lng_to_square($from_lat,$from_lng,$place_from),lat_lng_to_square($to_lat,$to_lng,$place_from));
					if (gettype($distance_estimate) === 'double') 
					{
						$filtered_data['distance_estimate'] = $distance_estimate;	
						unset($filtered_data['distance_estimate']);
					}
				}
			}

			$s = array();
			foreach ($filtered_data as $key => $value)
			{
				$s[] = "`" . $key . "` = " 
					 . ($value === NULL ? "NULL" : "'" . $value . "'");
			}

			$s = "UPDATE `trip`
				SET 
					" . implode(",\n", $s) ."
				WHERE
					`id_trip` = '" . $id_trip . "'
				";

			query($s);
	
			global $link;
			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database update failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'modified data not found');
			}

			$s = "UPDATE `trip`
				SET
					`last_edit_datetime` = now(),
					`last_edit_user` = '" .  $_SESSION[UID] . "'
				WHERE
					`id_trip` = '" . $id_trip . "'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	array(
									'affected_fields' 	=> 	$affected_fields,
									'forbidden_fields'	=>	$forbidden_fields
								)
			);
		}

		public function offerOrder($id_order = "", $id_user = "", $trips = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 1 && $this->id_role != 5)
			{
				return $this->showError('404', 'error', 'wrong user role');
			}
			if ($id_user == $_SESSION[UID]) return $this->showError('404', 'error', 'trying to offer yourself');
			if (empty($id_order)) return $this->showError('404', 'error', 'empty booking');
			if (empty($id_user)) return $this->showError('404', 'error', 'empty driver');

			$s = "SELECT
					`id_order`,
					`client`,
					`id_order_status`,
					GROUP_CONCAT(IF(`order_driver`.`id_user` = '" . $id_user 
						. "',`order_driver`.`id_user`,NULL)) as u_id
				FROM `order` 	
				LEFT JOIN `order_driver` USING (`id_order`)	
				WHERE	
					`id_order` = '" . $id_order . "'
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_order'])) return $this->showError('404', 'error', 'booking not found');
			if ($d['id_order_status'] == 3 || $d['id_order_status'] == 4) return $this->showError('404', 'error', 'wrong booking state');
			if ($d['client'] != $_SESSION[UID]) 
			{
				return $this->showError('404', 'error', 'user is not author');
			}
			if (!empty($d['u_id'])) 
			{
				return $this->showError('404', 'error', $id_user . ' is performer');
			}

			$s = "SELECT
					`id_user`
				FROM `users` 		
				WHERE	
					`id_user` = '" . $id_user. "'
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'select of database failed');

			$d = fetch_assoc($q);
			if (empty($d['id_user'])) return $this->showError('404', 'error', 'driver not found');
			
			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			$s = "INSERT IGNORE INTO `order_driver_select`
					SET
						`id_order` = '" . $id_order . "',
						`id_user` = '" . $id_user . "',
						`create_datetime` = now()
			";

			$q = query($s);
	
			global $link;
			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database insert failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'offered booking');
			}
			
			if (!empty($trips))
			{
				$s = "SELECT
						COUNT(`id_trip`) as trips_count
					FROM `trip` 		
					WHERE	
						`id_trip` in (" . $trips . ") AND `driver` = '" . $id_user . "'
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select failed');

				$d = fetch_assoc($q);
				$trips = explode(',', $trips);
				if ($d['trips_count'] != count($trips)) return $this->showError('404', 'error', 'driver is not trip author');
				
				$s = array();
				foreach ($trips as $id_trip)
				{
					$s[] = "('" . $id_order . "', '" . $id_trip . "', now(), now())";
				}
				$s = "INSERT INTO `order_trip` (`id_order`,  `id_trip`, `create_datetime`, `offer_order_datetime`) VALUES " . implode(",", $s) . "ON DUPLICATE KEY UPDATE `offer_order_datetime` = IF(`offer_order_datetime` = 0,now(),`offer_order_datetime`)";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'insert in database failed');
			}
	
			$s = "UPDATE `order`
				SET
					`last_edit_datetime` = now(),
					`last_edit_user` = '" .  $_SESSION[UID] . "'
				WHERE
					`id_order` = '" . $id_order . "'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');
	
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function addPush($id_user = "", $id_push = "")
		{
			if (empty($_POST['token']) || empty($_POST['u_hash'])) return $this->showError('404', 'error', 'unauthorized access');
			if ($_POST['token'] == 'test token' && $_POST['u_hash'] == 'test u_hash'){
				if (empty($id_user) || empty($id_push))
				{
					return $this->showError('404', 'error', 'empty u_id or p_id');
				}
			}
			else
			{
				return $this->showError('404', 'error', 'wrong token or u_hash');
			}
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'u_id'		=>	$id_user,
				'p_id'		=>	$id_push
			);
		}

		public function createDropboxFile($file = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			@$file = json_decode($file,true);
		
			if (empty($file) || !is_array($file)) 
			{
				return $this->showError('404', 'error', 'wrong file data');
			}
			$id_user = $_SESSION[UID];
			if (isset($file['u_id']))
			{
				$id_user = trim($file['u_id']);	
				if ($id_user != $_SESSION[UID])
				{
					if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

					$s = "SELECT
							`id_user`
						FROM `users` 		
						WHERE	
							`id_user` = '" . $id_user. "'
						LIMIT 1
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'select failed');

					$d = fetch_assoc($q);
					if (empty($d['id_user'])) return $this->showError('404', 'error', 'user not found');	
				}
			}

			if (isset($file['dl_id']))
			{
				$id_dropbox_link = $file['dl_id'];
				if ($this->id_role == 4)
				{
					$sql = '';
					if (isset($file['u_id']))
					{
						$sql = ",
							IF(`deleted` = 0,(
								SELECT
									`id_user`
								FROM
									`users_dropbox_link`
								WHERE
									`users_dropbox_link`.`id_dropbox_link` = `dropbox_link`.`id_dropbox_link` AND 
									`id_user` = '$id_user'
							),'') as user";
					}
					$s = "SELECT
							`id_dropbox_link`,
							`json`,
							`private`,
							`deleted`$sql
						FROM `dropbox_link` 				
						WHERE	
							`id_dropbox_link` = '$id_dropbox_link'
						LIMIT 1
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'database select failed');

					$d = fetch_assoc($q);
					if (empty($d['id_dropbox_link'])) return $this->showError('404', 'error', 'dropbox link not found');
					if (!empty($d['deleted']))return $this->showError('404', 'error', 'deleted dropbox link');
					if (isset($file['u_id']) && !empty($d['user'])) unset($file['u_id']);
				}
				else
				{
					$s = "SELECT
							`id_dropbox_link`,
							`json`,
							`private`,
							`deleted`,
							IF(`deleted` = 0,(
								SELECT
									`id_user`
								FROM
									`users_dropbox_link`
								WHERE
									`users_dropbox_link`.`id_dropbox_link` = `dropbox_link`.`id_dropbox_link` AND 
									`id_user` = '{$_SESSION[UID]}'
							),'') as user
						FROM `dropbox_link` 				
						WHERE	
							`id_dropbox_link` = '$id_dropbox_link'
						LIMIT 1
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'select failed');

					$d = fetch_assoc($q);
					if (empty($d['id_dropbox_link'])) return $this->showError('404', 'error', 'dropbox link for dl_id not found');
					if (!empty($d['deleted']))return $this->showError('404', 'error', 'dropbox link is deleted');
					if (empty($d['user']))
					{
						return $this->showError('404', 'error', 'not enough rights');
					}
					unset($file['u_id']);
				}
				$json = json_decode($d['json'],true);
				$name_upload = $json['name_upload'];
				
				if (isset($file['private']))
				{
					$file['private'] = (int)$file['private'];
					if ($file['private'] == $d['private']) unset($file['private']);
				}
			}

			if (isset($file['base64']))
			{
				@$content = (string)$file['base64'];
				list($type, $content) = array_merge(explode(';', $content),array(''));
				list(, $type) = array_merge(explode(':', $type),array(''));
				if (empty($type)) return $this->showError('404', 'error', 'wrong file string');
				list($base64, $content) = array_merge(explode(',', $content),array(''));
				if ($base64 !== 'base64') return $this->showError('404', 'error', 'wrong string of file');
				$content = base64_decode($content);
				if (gettype($content) !== 'string') return $this->showError('404', 'error', 'wrong base64');
			}
			else
			{
				if (isset($file['dl_id']))
				{
					if (!isset($file['private']) && !isset($file['u_id'])) return $this->showError('404', 'error', 'new data not found');
				}
				else
				{
					return $this->showError('404', 'error', 'base64 key not found');
				}
			}

			if (isset($file['dl_id']))
			{
				$s = array();
				if (isset($content)) 
				{
					$json['type'] = $type;
					$json['size'] = strlen($content);
					$response = upload_to_dropbox($content,$name_upload,$id_dropbox_link,'overwrite');			
					if (!empty($response['error'])) return $this->showError('404', 'error', array('response' => $response['error']));				
					$json['response'] = $response['data'];
					$s[] = "`json` = '" . real_escape_string(json_encode($json)) . "'";
				}
				if (isset($file['private'])) $s[] = "`private` = '{$file['private']}'";
			
				if (!empty($s))
				{
					$s = implode(',',$s);
					$s = "UPDATE `dropbox_link`
						SET
							$s
						WHERE
							`id_dropbox_link` = '" . $id_dropbox_link . "'
						";

					$q = query($s);

					$qs = affected_rows();
					if ($qs === -1) 
					{
						$warning = 'update query failed';
					}
					elseif ($qs === 0) 
					{
						$warning = 'modified data not found for query';
					}
				}

				if (isset($file['u_id']))
				{				
					$s = "DELETE
						FROM `users_dropbox_link`
						WHERE 
							`id_dropbox_link` = ' $id_dropbox_link'
						";
					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'delete failed');

					$s = "INSERT INTO `users_dropbox_link`
						SET 
							`id_user` = '$id_user',
							`id_dropbox_link` = ' $id_dropbox_link'
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'binding failed');
				}
			}
			else
			{
				$filename_upload = 'file';
				$filename = '';
				if (isset($file['name']))
				{
					@$filename = (string)$file['name'];
					if (strlen($filename) !== 0) 
					{
						$filename_upload = substr($filename ,0,115);
					}
				}
				$sql = "";
				if (isset($file['private']))
				{
					$sql = ",`private` = '{$file['private']}'";
				}
				$json = array('name' => $filename, 'name_upload' => $filename_upload, 'type' => $type, 'size' => strlen($content));

				$q = query("BEGIN");
				if ($q === false) return $this->showError('404', 'error', 'begin query failed');

				$s = "INSERT INTO `dropbox_link`
					SET 
						`json` = '" . real_escape_string(json_encode($json)) . "'
						" . $sql . "
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database insert failed');

				$id_dropbox_link = insert_id();

				$s = "INSERT INTO `users_dropbox_link`
					SET 
						`id_user` = '" . $id_user . "',
						`id_dropbox_link` = '" . $id_dropbox_link . "'
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'user binding failed');

				$response = upload_to_dropbox($content,$filename_upload,$id_dropbox_link);
				if (!empty($response['error'])) return $this->showError('404', 'error', $response['error']);
				$json['response'] = $response['data'];

				$s = "UPDATE `dropbox_link`
					SET
						`json` = '" . real_escape_string(json_encode($json)) . "'
					WHERE
						`id_dropbox_link` = '" . $id_dropbox_link . "'
					";

				$q = query($s);

				global $link;
				if (mysqli_affected_rows($link) === -1) 
				{
					$warning = 'update failed';
				}
				elseif (mysqli_affected_rows($link) === 0) 
				{
					$warning = 'modified data not found';
				}		

				$q = query("COMMIT");
				if ($q === false) return $this->showError('404', 'error', 'commit query failed');
			}

			$out = array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	array('dl_id'=>$id_dropbox_link)
			);
			if (!empty($warning)) $out['warning'] = $warning;
	
			return $out;
		}

		public function selectDropboxFile($id_dropbox_link = '')
		{
			if (empty($id_dropbox_link)) 
			{
				return $this->showError('404', 'error', 'empty dl_id');
			}
			if (empty($_SESSION[UID]))
			{
				$s = "SELECT
						`id_dropbox_link`,
						`json`,
						`private`,
						`deleted`
					FROM `dropbox_link` 				
					WHERE	
						`id_dropbox_link` = '" . $id_dropbox_link  . "'
					LIMIT 1
					";
			}
			elseif ($this->id_role == 4)
			{
				$s = "SELECT
						`id_dropbox_link`,
						`json`,
						`deleted`
					FROM `dropbox_link` 				
					WHERE	
						`id_dropbox_link` = '" . $id_dropbox_link  . "'
					LIMIT 1
					";
			}
			else
			{
				$s = "SELECT
						`id_dropbox_link`,
						`json`,
						`private`,
						`deleted`,
						IF(`deleted` = 0 AND `private` = '1',(
							SELECT
								`id_user`
							FROM
								`users_dropbox_link`
							WHERE
								`users_dropbox_link`.`id_dropbox_link` = `dropbox_link`.`id_dropbox_link` AND 
								`id_user` = '" . $_SESSION[UID] . "'
						),'') as user
					FROM `dropbox_link` 				
					WHERE	
						`id_dropbox_link` = '" . $id_dropbox_link  . "'
					LIMIT 1
					";
			}

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_dropbox_link'])) return $this->showError('404', 'error', 'dropbox link not found');
			if (!empty($d['deleted']))return $this->showError('404', 'error', 'deleted dropbox link');
			if (empty($_SESSION[UID]))
			{
				if ($d['private'] != -1)
				{
					return $this->showError('404', 'error', 'unauthorized access');
				}
			}
			else
			{
				if (isset($d['private']) && $d['private'] == 1 && empty($d['user']))
				{
					return $this->showError('404', 'error', 'not enough rights');
				}
			}

			$json = json_decode($d['json'],true);
			$response = download_from_dropbox($json['name_upload'],$id_dropbox_link,$json['type']);
			if (!empty($response['error'])) return $this->showError('404', 'error', $response['error']);
		}

		public function updateDropbox($code = '', $hash = '')
		{
			if ($hash === md5('checking' . md5(API_KEY)))
			{
				$res = update_dropbox($code);
				if (!empty($res['error']))
				{
					return $this->showError('404', 'error', $res['error']);
				}
				return array(
					'code' 		=>	'200',
					'status' 	=>	'success',
					'data'		=>	$res
				);
			}
			return $this->showError('404', 'error', 'wrong hash');
		}

		public function selectDataExt($fields = 0, $easy = 0, $key = false, $nocache = false, $team = false, $tournament = false, $version = NULL, $version_stt = NULL, $version_sc = NULL, $server_version = '', $data = array(), $server_version_stt = '', $data_stt = array(), $server_version_sc = '', $data_sc = array())
		{
			$flag = $flag_stt = $flag_sc = true;
			if ($version === $server_version) $flag = false;
			if ($version_stt === $server_version_stt) $flag_stt = false;
			if ($version_sc === $server_version_sc) $flag_sc = false;

			$out = array();
			$out_304 = array();
			$field_arr	= get_field_arr('data');
			$bin_arr = get_bin_arr();
			foreach(str_split($fields) as $index => $char)
			{
				$value = get_0_64($char);
				if (empty($value)) continue;
				foreach($bin_arr as $bin_i)
				{
					if ($value & $bin_i) 
					{
						if (isset($field_arr[$index][$bin_i]))
						{
							$field = $field_arr[$index][$bin_i];
							$is_updated = true;
							if (array_key_exists($field_arr[$index][$bin_i],$data_stt))
							{
								if ($flag_stt === false) $is_updated = false;
								$data_arr = "data_stt";
							}
							elseif (array_key_exists($field_arr[$index][$bin_i],$data_sc))
							{
								if ($flag_sc === false) $is_updated = false;
								$data_arr = "data_sc";
							}
							elseif (array_key_exists($field_arr[$index][$bin_i],$data))
							{
								if ($flag === false) $is_updated = false;
								$data_arr = "data";
							}
							else
							{
								continue;
							}
							if ($is_updated === false && ($field != 'schedule' || $key === false || $nocache === false))
							{
								$out_304[] = $field;
								continue;
							}
							if ($key !== false)
							{
								if ($field == 'schedule' && $nocache === true)
								{
									$s = "SELECT 
											`id_schedule` as id,
											`team1`,
											`team2`,
											`id_stadium` as stadium,
											`id_tournament` as tournament,
											`start_datetime` as datetime,
											`duration`,
											`only_date`,
											`top`,
											`options`,
											`time_zone`,
											`id_price_time_function` as price_time_function,
											`currency`,
											`currency_priority`,
											`fee`,
											`tariff`,
											`tariff_priority`,
											`code_ean_base64`,
											`active`
										FROM `schedule`
										WHERE
											`id_schedule` in (" . $key . ")
										";

									$q = query($s);
									if ($q === false) return $this->showError('404', 'error', "$field select failed");
									$schedule_select = array();
									while (@$d = fetch_assoc($q))
									{
										$key = $d['id'];
										add_time_zone($d['datetime']);
										$d['options'] = json_decode($d['options'],true);
										unset($d['id']);
										$schedule_select[$key] = $d;
									}
									${$data_arr}[$field] = $schedule_select;
								}
								else
								{
									$filtered = array();
									foreach(explode(',',$key) as $val)
									{
										$key = trim($val);
										if (array_key_exists($key,${$data_arr}[$field]))
										{
											$filtered[$key] = ${$data_arr}[$field][$key];
										}
										else
										{
											return $this->showError('404', 'error', "$key for $field not found");
										}
									}
									${$data_arr}[$field] = $filtered;
								}
							}
							elseif ($field == 'schedule' && ($team !==  false || $tournament !== false))
							{
								$team_arr = array();
								foreach(explode(',',$team) as $val)
								{
									$team_arr[trim($val)] = true;	
								}
								$tournament_arr = array();
								foreach(explode(',',$tournament) as $val)
								{
									$tournament_arr[trim($val)] = true;	
								}
								$filtered = array();
								if (empty($team))
								{
									foreach(${$data_arr}[$field] as $id_key=>$val)
									{
										if (isset($tournament_arr[$val['tournament']]))
										{
											$filtered[$id_key] = ${$data_arr}[$field][$id_key];
										}
									}
								}
								elseif (empty($tournament))
								{
									foreach(${$data_arr}[$field] as $id_key=>$val)
									{
										if (isset($team_arr[$val['team1']]) || isset($team_arr[$val['team2']]))
										{
											$filtered[$id_key] = ${$data_arr}[$field][$id_key];
										}
									}
								}
								else
								{
									foreach(${$data_arr}[$field] as $id_key=>$val)
									{
										if (isset($tournament_arr[$val['tournament']])
											&& (isset($team_arr[$val['team1']]) || isset($team_arr[$val['team2']])))
										{
											$filtered[$id_key] = ${$data_arr}[$field][$id_key];
										}
									}
								}
								${$data_arr}[$field] = $filtered;
							}							
							
							if (!(empty($easy)) && $field == 'stadiums')
							{
								foreach(${$data_arr}[$field] as $id_key=>$val)
								{
									unset(${$data_arr}[$field][$id_key]['scheme']);
									unset(${$data_arr}[$field][$id_key]['seats']);
								}
							}
							$out[$field] = ${$data_arr}[$field];
						}
					}
				}
			}
			$json = array(
						'version'			=>		$server_version,
						'version2'			=>		$server_version_stt,
						'version3'			=>		$server_version_sc,
						'default_lang'		=>		DEFAULT_LANG,
						'default_currency'	=>		DEFAULT_CURRENCY,
						'default_country'	=>		DEFAULT_COUNTRY,
						'default_profile'	=>		DEFAULT_PROFILE,
						'data'				=>		$out
			);
			if (!empty($out_304)) $json['304'] = $out_304;
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$json
			);
		}

		public function editData($data = 0, $s_date = array(), $s_date_private = array(), $s_data_stt = array(), $s_data_sc = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role == 2 && $_SESSION['id_verification_status'] != 2)
			{
				return $this->showError('404', 'error', 'wrong user check state');
			}
			
			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$data_template = array(
				'langs'	=>	array(
					'table'			=>	'lang',
					'id'			=>	'id_lang',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'native'	=>		array(
												'name'	=>	'native_name',
												'NULL'	=>	false,
											),
						'iso'		=>		array(
												'name'	=>	function($val){if($val === NULL)return 'ISO 639-1';if(strlen($val) === 2)return 'ISO 639-1';return 'ISO 639-3';},
												'NULL'	=>	true
											),
						'logo'		=>		array(
												'name'	=>	'logo_link',
												'NULL'	=>	false,
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				
				),
				'lang_vls'	=>	array(
					'table'			=>	'lang_values',
					'key'			=>	array('name','id_lang','value'),
					'data_suffix'	=>	''
				),
				'accounts'	=>	array(
					'table'			=>	'account',
					'id'			=>	'id_account',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'date_place'	=>		array(
												'name'	=>	'id_date_place',
												'NULL'	=>	true
											),										
						'login'	=>		array(
												'name'	=>	'login',
												'NULL'	=>	true
											),
						'email'	=>		array(
												'name'	=>	'email',
												'NULL'	=>	true
											),
						'phone'	=>		array(
												'name'	=>	'phone',
												'NULL'	=>	true
											),
						'p_word'	=>		array(
												'name'	=>	'pwd',
												'NULL'	=>	true
											),
						'auth'	=>		array(
												'name'	=>	'auth',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : ((int)$val < 0 ? - 1 : 1);}
											),
						'json'	=>		array(
												'name'	=>	'json',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'aggregators'	=>	array(
					'table'			=>	'aggregator',
					'id'			=>	'id_aggregator',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'json'	=>		array(
												'name'	=>	'json',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'car_bodies'	=>	array(
					'table'			=>	'car_body',
					'id'			=>	'id_car_body',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'car_classes'	=>	array(
					'table'			=>	'car_class',
					'id'			=>	'id_car_class',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'seats'		=>		array(
												'name'	=>	'seats',
												'NULL'	=>	false
											),
						'luggage'		=>		array(
												'name'	=>	'luggage',
												'NULL'	=>	false
											),
						'photo'		=>	array(
												'name'	=>	'photo_link',
												'NULL'	=>	false,
												'format'=>	function($val){
																list($type, $image) = array_merge(explode(';', $val),array(''));
																list(, $image) = array_merge(explode(',', $image),array(''));
																$image = base64_decode($image);
																if (!empty($image))
																{
																	$ext = mimeToext($type);
																	if (empty($ext)) return array('error' => 'wrong image type');				
																	while (file_exists($file = $_SERVER['DOCUMENT_ROOT'] . FILE_PATH . ($name_file = md5(md5(rand() . " " . rand())) . "." . $ext)));
																	@$file = file_put_contents($file, $image);
																	if (!$file) return array('error' => 'file not created');
																}
																else
																{
																	return array('error' => 'wrong photo base64 sequence');
																}
																return $name_file;
												}
											),
						'courier_call_rate'	=>		array(
												'name'	=>	'courier_call_rate',
												'NULL'	=>	true
											),
						'courier_fare_per_1_km'	=>		array(
												'name'	=>	'courier_fare_per_1_km',
												'NULL'	=>	true
											),
						'booking_location_classes'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'car_class_order_location',
												'key'	=>	'id_order_location',
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'car_colors'	=>	array(
					'table'			=>	'car_color',
					'id'			=>	'id_car_color',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'hex'	=>		array(
												'name'	=>	'hex',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'car_makes'	=>	array(
					'table'			=>	'car_make',
					'id'			=>	'id_car_make',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'car_models'	=>	array(
					'table'			=>	'car_model',
					'id'			=>	'id_car_model',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'make'	=>		array(
												'name'	=>	'id_car_make',
												'NULL'	=>	false
											),
						'class'	=>		array(
												'name'	=>	'id_car_class',
												'NULL'	=>	true
											),
						'body'	=>		array(
												'name'	=>	'id_car_body',
												'NULL'	=>	false
											),
						'year'	=>		array(
												'name'	=>	'year',
												'NULL'	=>	false
											),
						'door'	=>		array(
												'name'	=>	'door',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'cargo_case_models'	=>	array(
					'table'			=>	'cargo_case_model',
					'id'			=>	'id_cargo_case_model',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'type'	=>		array(
												'name'	=>	'id_cargo_case_type',
												'NULL'	=>	false
											)
					)
				),
				'cargo_case_types'	=>	array(
					'table'			=>	'cargo_case_type',
					'id'			=>	'id_cargo_case_type',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array()
				),
				'cargo_categories'	=>	array(
					'table'			=>	'cargo_category',
					'id'			=>	'id_cargo_category',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'upper'	=>		array(
												'name'	=>	'id_cargo_category_upper',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : $val;}
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'cargo_value_types'	=>	array(
					'table'			=>	'cargo_value_type',
					'id'			=>	'id_cargo_value_type',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array()
				),			
				'cart_block_statuses_sys'	=>	array(
					'table'			=>	'cart_block_status_sys',
					'id'			=>	'id_cart_block_status_sys',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'cities'	=>	array(
					'table'			=>	'city',
					'id'			=>	'id_city',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'country'	=>		array(
												'name'	=>	'country',
												'NULL'	=>	false
											),
						'zone'	=>		array(
												'name'	=>	'timezone',
												'NULL'	=>	false
											),
						'region'	=>		array(
												'name'	=>	'id_region',
												'NULL'	=>	true
											)
					)
				),
				'contact_classes'	=>	array(
					'table'			=>	'contact_type',
					'id'			=>	'id_contact_type',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array()
				),
				'countries'	=>	array(
					'table'			=>	'countries_list',
					'id'			=>	'ISO 3166-1 alpha-2 code',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array()
				),
				'currencies'	=>	array(
					'table'			=>	'currency',
					'id'			=>	'iso4217_code_a',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'abbr'	=>		array(
												'name'	=>	'abbr',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'currencies_rate'	=>	array(
					'table'			=>	'currency_usd_rate',
					'key'			=>	array('currency','usd_this_rate'),
					'format'		=>	array(function($val){return substr($val,4);},''),
					'data_suffix'	=>	''
				),
				'date_features'	=>	array(
					'table'			=>	'date_feature',
					'id'			=>	'id_date_feature',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),				
				'date_places'	=>	array(
					'table'			=>	'date_place',
					'id'			=>	'id_date_place',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(					
						'time_zone_n'	=>		array(
												'name'	=>	'time_zone_n',
												'NULL'	=>	true,
												'format'=>	function($val){
																$val = trim($val);
																if (!preg_match('/^(?:\+|-)[0-9]{2}\:[0-9]{2}$/',$val))
																{
																	return array('error'=>'wrong time zone');
																}
																return $val;
												}
											),
						'timezone_a'	=>		array(
												'name'	=>	'timezone_a',
												'NULL'	=>	true
											),
						'work_time_start'	=>		array(
												'name'	=>	'work_time_start',
												'NULL'	=>	true,
											),
						'work_time_complete'	=>	array(
												'name'	=>	'work_time_complete',
												'NULL'	=>	true
											),
						'even_time_start'	=>		array(
												'name'	=>	'even_time_start',
												'NULL'	=>	true
											),
						'even_time_complete'	=>		array(
												'name'	=>	'even_time_complete',
												'NULL'	=>	true
											),
						'date_select'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'date_place_select',
												'key'	=>	'id_date_select'
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'date_select'	=>	array(
					'table'			=>	'date_select',
					'id'			=>	'id_date_select',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(		
						'date_feature'	=>		array(
												'name'	=>	'id_date_feature',
												'NULL'	=>	false
											),
						'date_select_frequency'	=>		array(
												'name'	=>	'id_date_select_frequency',
												'NULL'	=>	false
											),
						'time'	=>		array(
												'name'	=>	'time',
												'NULL'	=>	true,
											),
						'day'	=>	array(
												'name'	=>	'day',
												'NULL'	=>	true
											),
						'day_week'	=>		array(
												'name'	=>	'day_week',
												'NULL'	=>	true
											),
						'month'	=>		array(
												'name'	=>	'month',
												'NULL'	=>	true
											),
						'year'	=>		array(
												'name'	=>	'year',
												'NULL'	=>	true
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'date_select_frequencies'	=>	array(
					'table'			=>	'date_select_frequency',
					'id'			=>	'id_date_select_frequency',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'drivers_select_sorting'	=>	array(
					'table'			=>	'driver_select_sorting',
					'id'			=>	'id_driver_select_sorting',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'faqs'	=>	array(
					'table'			=>	'faq',
					'id'			=>	'id_faq',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'group'	=>		array(
												'name'	=>	'id_faq_category',
												'NULL'	=>	false
											)
					)
				),
				'faq_groups'	=>	array(
					'table'			=>	'faq_category',
					'id'			=>	'id_faq_category',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array()
				),
				'field_types'	=>	array(
					'table'			=>	'field_type',
					'id'			=>	'id_field_type',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'var'	=>		array(
												'name'	=>	'var',
												'NULL'	=>	false
											),
						'json'	=>		array(
												'name'	=>	'json',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'map_places'	=>	array(
					'table'			=>	'map_place',
					'id'			=>	'id_map_place',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'max_lat'	=>		array(
												'name'	=>	'max_lat',
												'NULL'	=>	false
											),
						'min_lat'	=>		array(
												'name'	=>	'min_lat',
												'NULL'	=>	false
											),
						'max_lng'	=>		array(
												'name'	=>	'max_lng',
												'NULL'	=>	false
											),
						'min_lng'	=>		array(
												'name'	=>	'min_lng',
												'NULL'	=>	false
											),
						'split_depth'	=>		array(
												'name'	=>	'split_depth',
												'NULL'	=>	false
											),
						'timezone'	=>		array(
												'name'	=>	'timezone',
												'NULL'	=>	false
											),
						'upper'	=>		array(
												'name'	=>	'id_map_place_upper',
												'NULL'	=>	true
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),	
				'message_types'	=>	array(
					'table'			=>	'message_type',
					'id'			=>	'id_message_type',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'gps_softwares'	=>	array(
					'table'			=>	'navigation_software',
					'id'			=>	'id_navigation',
					'data_suffix'	=>	'',
					'allowed_fields'	=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'booking_cancel_states'	=>	array(
					'table'			=>	'order_cancel',
					'id'			=>	'id_order_cancel',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'user_roles'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'user_roles',
												'key'	=>	'id_role',
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'booking_comments'	=>	array(
					'table'			=>	'order_comment',
					'id'			=>	'id_order_comment',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'booking_driver_states'	=>	array(
					'table'			=>	'order_driver_status',
					'id'			=>	'id_order_driver_status',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'booking_location_classes'	=>	array(
					'table'			=>	'order_location',
					'id'			=>	'id_order_location',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'alias'	=>		array(
												'name'	=>	'location_table_name',
												'NULL'	=>	true
											),
						'upper'	=>		array(
												'name'	=>	'id_order_location_upper',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'column'	=>		array(
												'name'	=>	'location_table_column',
												'NULL'	=>	true
											)						
					)
				),	
				'booking_props'	=>	array(
					'table'			=>	'order_prop',
					'id'			=>	'id_order_prop',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'var'	=>		array(
												'name'	=>	'var',
												'NULL'	=>	false
											),
						'value_type'	=>		array(
												'name'	=>	'value_type',
												'NULL'	=>	false
											),
						'some'	=>		array(
												'name'	=>	'some',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'booking_states'	=>	array(
					'table'			=>	'order_status',
					'id'			=>	'id_order_status',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'outer_script_templates'	=>	array(
					'table'			=>	'outer_script_template',
					'id'			=>	'id_outer_script_template',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'var'	=>		array(
												'name'	=>	'var',
												'NULL'	=>	false
											),
						'url'	=>		array(
												'name'	=>	'url',
												'NULL'	=>	false
											),
						'headers_json'	=>		array(
												'name'	=>	'headers_json',
												'NULL'	=>	false
											),
						'headers_json_export'	=>		array(
												'name'	=>	'headers_json_export',
												'NULL'	=>	false
											),
						'post_json'	=>		array(
												'name'	=>	'post_json',
												'NULL'	=>	false
											),
						'post_json_export'	=>		array(
												'name'	=>	'post_json_export',
												'NULL'	=>	false
											),
						'urlencoded'	=>		array(
												'name'	=>	'urlencoded',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'u_id_export'	=>		array(
												'name'	=>	'u_id_export',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),					
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'only_admin'	=>		array(
												'name'	=>	'only_admin',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : ((int)$val < 0 ? - 1 : 1);}
											)
						)
				),
				'owner_types'	=>	array(
					'table'			=>	'owner_types',
					'id'			=>	'id_owner_type',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'table'	=>		array(
												'name'	=>	'table',
												'NULL'	=>	true
											),
						'column'	=>		array(
												'name'	=>	'column',
												'NULL'	=>	true
											),
						'sql'	=>		array(
												'name'	=>	'sql',
												'NULL'	=>	true
											),				
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
						)
				),
				'payment_ways'	=>	array(
					'table'			=>	'payment_method',
					'id'			=>	'id_payment_method',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'price_time_functions'	=>	array(
					'table'			=>	'price_time_function',
					'id'			=>	'id_price_time_function',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'parameter'	=>		array(
												'name'	=>	'parameter',
												'NULL'	=>	false
											),
						'formula'	=>		array(
												'name'	=>	'formula',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'programming_languages'	=>	array(
					'table'			=>	'programming_language',
					'id'			=>	'var',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'promocodes'	=>	array(
					'table'			=>	'promocode',
					'id'			=>	'id_promocode',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'value'	=>		array(
												'name'	=>	'value',
												'NULL'	=>	false
											),
						'discount'	=>		array(
												'name'	=>	'discount',
												'NULL'	=>	true
											),
						'max_products'	=>		array(
												'name'	=>	'max_products',
												'NULL'	=>	false
											),
						'max_payments'	=>		array(
												'name'	=>	'max_payments',
												'NULL'	=>	false
											),
						'json'	=>		array(
												'name'	=>	'json',
												'NULL'	=>	false
											),
						'limit'	=>		array(
												'name'	=>	'limit',
												'NULL'	=>	false,
												'format'=>	function($val){
																preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$val,$parsed_datetime);
																if (empty($parsed_datetime))
																{
																	return '0000-00-00 00:00:00';
																}
																else
																{
																	preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
																	$val = gmdate("Y-m-d H:i:s",strtotime($val .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
																}
																return $val;
												}
											),
						'schedule'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'promocode_schedule',
												'key'	=>	'id_schedule',
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'regions'	=>	array(
					'table'			=>	'region',
					'id'			=>	'id_region',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'country'	=>		array(
												'name'	=>	'country',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'upper'	=>		array(
												'name'	=>	'id_region_upper',
												'NULL'	=>	true
											),
						'sub_national'	=>		array(
												'name'	=>	'sub-national',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'code'	=>		array(
												'name'	=>	'code',
												'NULL'	=>	true
											)					
					)
				),
				'script_templates'	=>	array(
					'table'			=>	'script_template',
					'id'			=>	'id_script_template',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'var'	=>		array(
												'name'	=>	'var',
												'NULL'	=>	false
											),
						'file'	=>	array(
												'name'	=>	'value',
												'NULL'	=>	false,
												'format'=>	function($val){
													@$content = (string)$val;
													$folder = CONFIG_USER_FILE_PATH . 'script_templates/file/';			
													$htaccess = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH;
													if (is_file($htaccess))
													{
														return array('error'=>CONFIG_USER_FILE_PATH . " is file");
													}
													else
													{
														if (!file_exists($htaccess)) 
														{
															@$dir = mkdir($htaccess,0777,true);
															if (!$dir) return array('error'=>CONFIG_USER_FILE_PATH . " create error");
														}
													}	
													$htaccess = $htaccess . '.htaccess';
													if (!file_exists($htaccess))
													{
														@$file = file_put_contents($htaccess,'deny from all');
														if ($file === false) return array('error'=>"htaccess write error");
													}
													return array('wait_create_id'=>array('value',$content,".php",$folder));
												}
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'only_admin'	=>		array(
												'name'	=>	'only_admin',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
						)
				),
				'services'	=>	array(
					'table'			=>	'service',
					'id'			=>	'id_service',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'site_constants'	=>	array(
					'table'			=>	'site_constant',
					'id'			=>	'var',
					'data_suffix'	=>	'',//function($arr){return empty($arr['private']) ? '' : '_private';},
					'allowed_fields'=>	array(
						'group'	=>		array(
												'name'	=>	'id_category',
												'NULL'	=>	false
											),
						'value'	=>		array(
												'name'	=>	'value',
												'NULL'	=>	false
											),
						'private'	=>		array(
												'name'	=>	'private',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'site_constant_groups'	=>	array(
					'table'			=>	'site_constant_category',
					'id'			=>	'id_site_constant_category',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array()
				),
				'site_emails'	=>	array(
					'table'			=>	'site_email',
					'id'			=>	'id_site_email',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'site_images'	=>	array(
					'table'			=>	'site_image',
					'id'			=>	'var',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'file'	=>	array(
												'name'	=>	'value',
												'NULL'	=>	false,
												'format'=>	function($val){
													@$content = (string)$val;
													list($type, $content) = array_merge(explode(';', $content),array(''));
													list(, $type) = array_merge(explode(':', $type),array(''));
													if (empty($type)) return array('error'=>'wrong file string');
													list($base64, $content) = array_merge(explode(',', $content),array(''));
													if ($base64 !== 'base64') return array('error'=>'wrong string of file');
													$content = base64_decode($content);
													if (gettype($content) !== 'string') return array('error'=>'wrong base64');
													$ext = mimeToext($type);
													if (!empty($ext)) $ext = ".$ext";
													$folder = CONFIG_FILE_PATH . 'site_images/file/';
													return array('wait_create_id'=>array('value',$content,$ext,$folder));
												}
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
						)
				),			
				'site_word_items'	=>	array(
					'table'			=>	'site_word_table_items',
					'id'			=>	'id_site_word_table_items',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'table'	=>	array(
												'name'	=>	'id_site_word_table',
												'NULL'	=>	false
											),
						'key1'	=>	array(
												'name'	=>	'key1',
												'NULL'	=>	false
											),
						'key2'	=>	array(
												'name'	=>	'key2',
												'NULL'	=>	false
											),
						'translators'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'site_word_table_items_translator',
												'key'	=>	'id_translator',
											),
						'webapps'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'site_word_table_items_webapp',
												'key'	=>	'id_webapp',
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
						)
				),
				'sql_classes'	=>	array(
					'table'			=>	'sql_category',
					'id'			=>	'id_sql_category',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'upper'	=>	array(
												'name'	=>	'id_sql_category_upper',
												'NULL'	=>	false
											),
						'var'	=>	array(
												'name'	=>	'var',
												'NULL'	=>	true
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
						)
				),
				'sql_templates'	=>	array(
					'table'			=>	'sql_template',
					'id'			=>	'id_sql_template',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'value'	=>	array(
												'name'	=>	'value',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'only_admin'	=>		array(
												'name'	=>	'only_admin',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),				
						'sql_classes'	 	=>	array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'sql_category_template',
												'allowed_fields'=>	array(
													'0'	=>	array(
																		'name'	=>	'id_sql_category',
																		'NULL'	=>	false,
																		'format'=>	function($val,$id_val){
																			$id_sql_category = $val;
																			return array(
																				'formated'	=>	$val,
																				'sql_if' 	=>	compact('id_sql_category'),			
																			);
																		}
																	),
													'1'	=>	array(
																		'name'	=>	'default',
																		'NULL'	=>	true,
																		'format'=>	function($val){return empty($val) ? NULL : 1;}
																	)
												)
											)
						)
				),
				'tariffs'	=>	array(
					'table'			=>	'tariff',
					'id'			=>	'id_tariff',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'price'	=>		array(
												'name'	=>	'price',
												'NULL'	=>	false
											),
						'currency'	=>		array(
												'name'	=>	'currency',
												'NULL'	=>	false
											),
						'duration_class'	=>		array(
												'name'	=>	'id_tariff_duration_type',
												'NULL'	=>	false
											),
						'max_priority_value'	=>		array(
												'name'	=>	'max_priority',
												'NULL'	=>	false
											),
						'priority_value'	=>		array(
												'name'	=>	'priority',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'tariff_duration_classes'	=>	array(
					'table'			=>	'tariff_duration_type',
					'id'			=>	'id_tariff_duration_type',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'duration_sec'	=>		array(
												'name'	=>	'duration',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				

				'task_actions'	=>	array(
					'table'			=>	'task_action',
					'id'			=>	'id_task_action',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'parameter'	=>		array(
												'name'	=>	'parameter',
												'NULL'	=>	false
											),
						'json'	=>		array(
												'name'	=>	'json',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),			
				'task_action_controls'	=>	array(
					'table'			=>	'task_action_control',
					'id'			=>	'id_task_action_control',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'json'	=>		array(
												'name'	=>	'json',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'task_action_functions'	=>	array(
					'table'			=>	'task_action_function',
					'id'			=>	'id_task_action_function',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'json'	=>		array(
												'name'	=>	'json',
												'NULL'	=>	false
											),
						'row'	 	=>	array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'task_action_function_row',
												'allowed_fields'=>	array(
													'index'	=>	array(
																		'name'	=>	'index',
																		'NULL'	=>	false
																	),
													'task_action'	=>	array(
																		'name'	=>	'id_task_action',
																		'NULL'	=>	false,
																	/*	'format'=>	function($val,$id_val){
																			$id_task_action = $val;
																			return array(
																				'formated'	=>	$val,
																				'sql_if' 	=>	compact('id_task_action'),			
																			);
																		}*/
																	),
													'parameter'	=>	array(
																		'name'	=>	'parameter',
																		'NULL'	=>	false,
																		/*'format'=>	function($val,$id_val){
																			return array(
																				'formated'	=>	str_replace(array(chr(0),chr(1),chr(2)),' ',$val)
																			);
																		}*/
																	)
												)
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'task_comments'	=>	array(
					'table'			=>	'task_comment',
					'id'			=>	'id_task_comment',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'value'	=>		array(
												'name'	=>	'value',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),			
				'task_statuses'	=>	array(
					'table'			=>	'task_status',
					'id'			=>	'id_task_status',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'ticket_props'	=>	array(
					'table'			=>	'ticket_prop',
					'id'			=>	'id_ticket_prop',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'var'	=>		array(
												'name'	=>	'var',
												'NULL'	=>	false
											),
						'value_type'	=>		array(
												'name'	=>	'value_type',
												'NULL'	=>	false
											),
						'some'	=>		array(
												'name'	=>	'some',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),							
						'roles_edit'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'ticket_prop_roles_edit',
												'key'	=>	'id_role',
											),
						'roles_view'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'ticket_prop_roles_view',
												'key'	=>	'id_role',
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'ticket_statuses'	=>	array(
					'table'			=>	'ticket_status',
					'id'			=>	'id_ticket_status',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),	
				'translate_types'	=>	array(
					'table'			=>	'translate_type',
					'id'			=>	'id_translate_type',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),			
				'translators'	=>	array(
					'table'			=>	'translator',
					'id'			=>	'id_translator',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'type'	=>		array(
												'name'	=>	'id_translate_type',
												'NULL'	=>	false
											),
						'u_id'	=>		array(
												'name'	=>	'id_user',
												'NULL'	=>	false
											)
					)
				),
				
				'units_of_length'	=>	array(
					'table'			=>	'unit_of_length',
					'id'			=>	'id_unit_of_length',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'this_mm_rate'	=>		array(
												'name'	=>	'this_mm_rate',
												'NULL'	=>	true
											)
					)
				),
				'units_of_mass'	=>	array(
					'table'			=>	'unit_of_mass',
					'id'			=>	'id_unit_of_mass',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'this_gram_rate'	=>		array(
												'name'	=>	'this_gram_rate',
												'NULL'	=>	true
											)
					)
				),
				'units_of_volume'	=>	array(
					'table'			=>	'unit_of_volume',
					'id'			=>	'id_unit_of_volume',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'this_mm³_rate'	=>		array(
												'name'	=>	'this_mm³_rate',
												'NULL'	=>	true
											)
					)
				),
				'unit_sets'	=>	array(
					'table'			=>	'unit_set',
					'id'			=>	'unit_set_str',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'weight'	=>		array(
												'name'	=>	'weight',
												'NULL'	=>	false
											),
						'volume'	=>		array(
												'name'	=>	'volume',
												'NULL'	=>	false
											),
						'height'	=>		array(
												'name'	=>	'height',
												'NULL'	=>	false
											),
						'length'	=>		array(
												'name'	=>	'length',
												'NULL'	=>	false
											),
						'width'	=>		array(
												'name'	=>	'width',
												'NULL'	=>	false
											)
					)
				),
				'user_roles'	=>	array(
					'table'			=>	'users_roles',
					'id'			=>	'id_role',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),	
				'users_props'	=>	array(
					'table'			=>	'users_prop',
					'id'			=>	'id_users_prop',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'var'	=>		array(
												'name'	=>	'var',
												'NULL'	=>	false
											),
						'value_type'	=>		array(
												'name'	=>	'value_type',
												'NULL'	=>	false
											),
						'some'	=>		array(
												'name'	=>	'some',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'private'	=>		array(
												'name'	=>	'private',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'roles_edit'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'users_prop_roles_edit',
												'key'	=>	'id_role',
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'user_check_states'	=>	array(
					'table'			=>	'users_verification_status',
					'id'			=>	'id_users_verification_status',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),		
				'webapps'	=>	array(
					'table'			=>	'webapp',
					'id'			=>	'id_webapp',
					'data_suffix'	=>	'',
					'allowed_fields'=>	array(
						'var'	=>		array(
												'name'	=>	'var',
												'NULL'	=>	false
											),
						'host'	=>		array(
												'name'	=>	'host',
												'NULL'	=>	false
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'stadiums'	=>	array(
					'table'			=>	'stadium',
					'id'			=>	'id_stadium',
					'data_suffix'	=>	'_stt',
					'allowed_fields'=>	array(
						'scheme'	=>		array(
												'name'	=>	'scheme',
												'NULL'	=>	false
											),
						'seats'	=>		array(
												'name'	=>	'seats',
												'NULL'	=>	false
											),
						'city'	=>		array(
												'name'	=>	'id_city',
												'NULL'	=>	true
											),
						'country'	=>		array(
												'name'	=>	'country',
												'NULL'	=>	true
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'seats_obj'	 	=>	array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'stadium_seats',
												'allowed_fields'=>	array(
													'0'	=>	array(
																		'name'	=>	'id_seat',
																		'NULL'	=>	false,
																		'format'=>	function($val,$id_val){
																			if (is_array($val))
																			{
																				$block = isset($val[0])?$val[0]:'';
																				$row = isset($val[1])?$val[1]:'';
																				$seat = isset($val[2])?$val[2]:'';
																			}
																			else
																			{
																				$block = $val;
																				$row = '';
																				$seat = '';	
																			}
																			$id_seat = implode(';',array($id_val,$block,$row,$seat));
																			return array(
																				'formated'	=>	$id_seat,
																				'filtered' 	=>	compact('block','row','seat'),
																				'sql_if' 	=>	compact('id_seat','block','row','seat'),			
																			);
																		}
																	),
													'1'	=>	array(
																		'name'	=>	'tariff',
																		'NULL'	=>	true
																	),
													'2'	=>	array(
																		'name'	=>	'currency',
																		'NULL'	=>	true
																	)
												)
											),
						'scheme_blob'	 	=>	array(
												'name'	=>	'scheme_link',
												'NULL'	=>	false,
												'format'=>	function($val){
													@$content = (string)$val;
													list($type, $content) = array_merge(explode(';', $content),array(''));
													list(, $type) = array_merge(explode(':', $type),array(''));
													if (empty($type)) return array('error'=>'wrong file string');
													list($base64, $content) = array_merge(explode(',', $content),array(''));
													if ($base64 !== 'base64') return array('error'=>'wrong string of file');
													$content = base64_decode($content);
													if (gettype($content) !== 'string') return array('error'=>'wrong base64');
													$ext = mimeToext($type);
													if (!empty($ext)) $ext = ".$ext";
													$folder = CONFIG_FILE_PATH . 'stadiums/scheme_blob/';
													return array('wait_create_id'=>array('scheme_link',$content,$ext,$folder));
												}
											)
					)
				),
				'teams'	=>	array(
					'table'			=>	'team',
					'id'			=>	'id_team',
					'data_suffix'	=>	'_stt',
					'allowed_fields'=>	array(
						'stadium'	=>		array(
												'name'	=>	'id_stadium',
												'NULL'	=>	true
											),
						'city'	=>		array(
												'name'	=>	'id_city',
												'NULL'	=>	true
											),
						'country'	=>		array(
												'name'	=>	'country',
												'NULL'	=>	true
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'logo'	=>		array(
												'name'	=>	'logo',
												'NULL'	=>	false,
												'format'=>	function($val){
													@$content = (string)$val;
													list($type, $content) = array_merge(explode(';', $content),array(''));
													list(, $type) = array_merge(explode(':', $type),array(''));
													if (empty($type)) return array('error'=>'wrong file string');
													list($base64, $content) = array_merge(explode(',', $content),array(''));
													if ($base64 !== 'base64') return array('error'=>'wrong string of file');
													$content = base64_decode($content);
													if (gettype($content) !== 'string') return array('error'=>'wrong base64');	
													while (true)
													{
														$info = getimagesizefromstring($content);
														if ($info === false) return array('error'=>'wrong image');
														$width = $info[0];
														$height = $info[1];
														$type = $info['mime'];
														$img = @imagecreatefromstring($content);
														if ($img === false) return array('error'=>'image type is unsupported');
														$max_w_h = 120;
														if ($width >= $height)
														{
															if ($width <= $max_w_h) break;
															$resized_width = $max_w_h;
															$resized_height = (int)round($height/($width/$max_w_h));
														}
														else
														{
															if ($height <= $max_w_h) break;
															$resized_width = (int)round($width/($height/$max_w_h));
															$resized_height = $max_w_h;
														}
														$resized_img = imagecreatetruecolor($resized_width,$resized_height);														
														imagealphablending($resized_img,false);
														imagesavealpha($resized_img,true);
														imagecopyresampled($resized_img,$img,0,0,0,0,$resized_width,$resized_height,$width,$height);
														ob_start();
														imagepng($resized_img);
														$content = ob_get_contents();
														ob_end_clean();
														imagedestroy($img);
														imagedestroy($resized_img);
														$folder = CONFIG_FILE_PATH . 'teams/logo/';													
														return array('wait_create_id'=>array('logo',$content,'.png',$folder));
													}
													$ext = mimeToext($type);
													if (!empty($ext)) $ext = ".$ext";
													if (empty($ext)) return array('error' => 'wrong image type');
													$folder = CONFIG_FILE_PATH . 'teams/logo/';
													return array('wait_create_id'=>array('logo',$content,$ext,$folder));
												}
											),
						'sub_country'	=>	array(
												'name'	=>	'autonomous area',
												'NULL'	=>	true
											)
					)
				),
				'tournaments'	=>	array(
					'table'			=>	'tournament',
					'id'			=>	'id_tournament',
					'data_suffix'	=>	'_stt',
					'allowed_fields'=>	array(
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											)
					)
				),
				'schedule'	=>	array(
					'table'			=>	'schedule',
					'id'			=>	'id_schedule',
					'data_suffix'	=>	'_sc',
					'allowed_fields'=>	array(
						'team1'	=>		array(
												'name'	=>	'team1',
												'NULL'	=>	false
											),
						'team2'	=>		array(
												'name'	=>	'team2',
												'NULL'	=>	false
											),
						'stadium'	=>		array(
												'name'	=>	'id_stadium',
												'NULL'	=>	true
											),
						'tournament'	=>		array(
												'name'	=>	'id_tournament',
												'NULL'	=>	true
											),
						'datetime'	=>		array(
												'name'	=>	'start_datetime',
												'NULL'	=>	false,
												'format'=>	function($val){
																preg_match('/^([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\s+([0-9]{1,2}\:[0-9]{1,2}\:[0-9]{1,2})\s*((?:\+|-)[0-9]{2}\:[0-9]{2})$/',$val,$parsed_datetime);
																if (empty($parsed_datetime))
																{
																	return array('error'=>'wrong datetime');
																}
																else
																{						
																	$val = $parsed_datetime[1] . " " . $parsed_datetime[2];
																	if ($val == '0000-00-00 00:00:00')
																	{
																		return array('error', '0000-00-00 00:00:00 datetime');
																	}
																	else
																	{
																		preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
																		$val = gmdate("Y-m-d H:i:s",strtotime($val .  $parsed_datetime[3]) + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
																	}
																}
																return $val;
												}
											),
						'duration'	=>		array(
												'name'	=>	'duration',
												'NULL'	=>	true
											),
						'active'	=>		array(
												'name'	=>	'active',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'only_date'	=>		array(
												'name'	=>	'only_date',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'top'	=>		array(
												'name'	=>	'top',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'options'	=>		array(
												'name'	=>	'options',
												'NULL'	=>	false
											),
						'time_zone'	=>		array(
												'name'	=>	'time_zone',
												'NULL'	=>	true,
												'format'=>	function($val){
																$val = trim($val);
																if (!preg_match('/^(?:\+|-)[0-9]{2}\:[0-9]{2}$/',$val))
																{
																	return array('error'=>'wrong time zone');
																}
																return $val;
												}
											),
						'price_time_function'	=>		array(
												'name'	=>	'id_price_time_function',
												'NULL'	=>	true
											),
						'currency'	=>		array(
												'name'	=>	'currency',
												'NULL'	=>	true
											),
						'currency_priority'	=>		array(
												'name'	=>	'currency_priority',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),				
						'fee'	=>		array(
												'name'	=>	'fee',
												'NULL'	=>	true
											),											
						'tariff'	=>		array(
												'name'	=>	'tariff',
												'NULL'	=>	true
											),
						'tariff_priority'	=>		array(
												'name'	=>	'tariff_priority',
												'NULL'	=>	false,
												'format'=>	function($val){return empty($val) ? 0 : 1;}
											),
						'code_ean_base64'	=>		array(
												'name'	=>	'code_ean_base64',
												'NULL'	=>	false,
												'format'=>	function($val){
													@$content = (string)$val;
													list($type, $content) = array_merge(explode(';', $content),array(''));
													list($data_str, $type) = array_merge(explode(':', $type),array(''));
													if ($data_str !== 'data') return array('error'=>'wrong string');
													if (empty($type)) return array('error'=>'wrong file string');
													list($base64, $content) = array_merge(explode(',', $content),array(''));
													if ($base64 !== 'base64') return array('error'=>'wrong string of file');
													$content = base64_decode($content);
													if (gettype($content) !== 'string') return array('error'=>'wrong base64');
													return $val;

												}
											)					
					)
				)
			);

			fields_for_langs($s_date['langs'],$data_template['langs'],'','name_',true);	
			fields_for_langs($s_date['langs'],$data_template['aggregators'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['aggregators'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['car_bodies'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['car_classes'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['car_classes'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['car_colors'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['car_makes'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['car_models'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['cargo_case_models'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['cargo_case_models'],'','about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['cargo_case_types'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['cargo_case_types'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['cargo_categories'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['cargo_categories'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['cargo_value_types'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['cargo_value_types'],'about_','description_',false);	
			fields_for_langs($s_date['langs'],$data_template['cart_block_statuses_sys'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['cart_block_statuses_sys'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['cities'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['cities'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['contact_classes'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['contact_classes'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['countries'],'','country_name_',true);
			fields_for_langs($s_date['langs'],$data_template['currencies'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['currencies'],'about_','country_',false);	
			fields_for_langs($s_date['langs'],$data_template['date_features'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['date_features'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['date_places'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['date_places'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['date_select'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['date_select'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['date_select_frequencies'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['date_select_frequencies'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['drivers_select_sorting'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['drivers_select_sorting'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['faqs'],'title_','name_',true);
			fields_for_langs($s_date['langs'],$data_template['faqs'],'content_','value_',false);
			fields_for_langs($s_date['langs'],$data_template['faq_groups'],'','name_',true);	
			fields_for_langs($s_date['langs'],$data_template['field_types'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['field_types'],'about_','description_',false);		
			fields_for_langs($s_date['langs'],$data_template['map_places'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['map_places'],'about_','description_',false);	
			fields_for_langs($s_date['langs'],$data_template['message_types'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['message_types'],'about_','description_',false);	
			fields_for_langs($s_date['langs'],$data_template['booking_cancel_states'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['booking_comments'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['booking_driver_states'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['booking_location_classes'],'','name_',true);	
			fields_for_langs($s_date['langs'],$data_template['booking_props'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['booking_props'],'about_','description_',false);		
			fields_for_langs($s_date['langs'],$data_template['booking_states'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['outer_script_templates'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['outer_script_templates'],'about_','description_',false);	
			fields_for_langs($s_date['langs'],$data_template['owner_types'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['owner_types'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['payment_ways'],'','name_',true);		
			fields_for_langs($s_date['langs'],$data_template['price_time_functions'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['price_time_functions'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['programming_languages'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['programming_languages'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['regions'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['regions'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['script_templates'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['script_templates'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['services'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['site_constants'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['site_constants'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['site_constant_groups'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['site_emails'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['site_emails'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['site_images'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['site_images'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['sql_classes'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['sql_classes'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['sql_templates'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['sql_templates'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['tariffs'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['tariffs'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['tariff_duration_classes'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['task_actions'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['task_actions'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['task_action_controls'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['task_action_controls'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['task_action_functions'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['task_action_functions'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['task_statuses'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['task_statuses'],'','name_',true);			
			fields_for_langs($s_date['langs'],$data_template['ticket_props'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['ticket_props'],'about_','description_',false);		
			fields_for_langs($s_date['langs'],$data_template['ticket_statuses'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['ticket_statuses'],'about_','description_',false);	
			fields_for_langs($s_date['langs'],$data_template['translate_types'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['translate_types'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['translators'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['translators'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['units_of_length'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['units_of_length'],'symbol_','symbol_',true);
			fields_for_langs($s_date['langs'],$data_template['units_of_mass'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['units_of_mass'],'symbol_','symbol_',true);
			fields_for_langs($s_date['langs'],$data_template['units_of_volume'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['units_of_volume'],'symbol_','symbol_',true);
			fields_for_langs($s_date['langs'],$data_template['user_roles'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['users_props'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['users_props'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['user_check_states'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['webapps'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['webapps'],'about_','description_',false);	
			fields_for_langs($s_date['langs'],$data_template['stadiums'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['stadiums'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['stadiums'],'address_','address_',true);
			fields_for_langs($s_date['langs'],$data_template['teams'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['teams'],'about_','description_',false);
			fields_for_langs($s_date['langs'],$data_template['tournaments'],'','name_',true);
			fields_for_langs($s_date['langs'],$data_template['tournaments'],'about_','description_',false);

			if (empty($s_date['site_constants']['data_edit_users_roles_rights']['value']) || empty($data_edit_users_roles_rights = json_decode($s_date['site_constants']['data_edit_users_roles_rights']['value'],true)) || !is_array($data_edit_users_roles_rights))
			{
				if ($this->id_role != 4)
				{
					return $this->showError('404', 'error', 'not enough rights');			
				}
			}
			else
			{
				if (isset($data_edit_users_roles_rights[$this->id_role]))
				{
					$table_arr = $data_edit_users_roles_rights[$this->id_role];
					if ($table_arr !== true)
					{
						if (!is_array($table_arr) || empty($table_arr)) return $this->showError('404', 'error', 'not enough rights for role ' . $this->id_role);	
						foreach($data_template as $key=>$val)
						{
							if (empty($table_arr[$key])) unset($data_template[$key]);
						}
					}
				}
				else
				{
					return $this->showError('404', 'error', 'not enough rights for ' . $this->id_role);	
				}
			}

			$forbidden_fields = array();
			$affected_fields = array();
			$affected_keys = array();
			$created_id = array();

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			foreach($data as $d_key=>$d_list)
			{			
				if (isset($data_template[$d_key]))
				{						
					$table = $data_template[$d_key]['table'];
					$data_arr = "s_data{$data_template[$d_key]['data_suffix']}";
					if (isset($data_template[$d_key]['id']))
					{
						$id_key = $data_template[$d_key]['id'];
						$forbidden_fields_inner = array();
						$affected_fields_inner = array();
						$created_id_inner = array();
						if (!is_array($d_list)) return $this->showError('404', 'error', "$d_key: wrong data");
						foreach($d_list as $i=>$d_arr)
						{
							$filtered_data = array();
							$filtered_fields = array();
							$add_table_list = array();
							$wait_create_id = array();
							if (!is_array($d_arr)) return $this->showError('404', 'error', "$d_key $i: wrong data");
							foreach($d_arr as $key=>$value)
							{
								if (isset($data_template[$d_key]['allowed_fields'][$key]))
								{
									$affected_fields_inner[$i][] = $key;
									if (!empty($data_template[$d_key]['allowed_fields'][$key]['format']))
									{
										$value = $data_template[$d_key]['allowed_fields'][$key]['format']($value);
									}
									if (empty($value['error']))
									{
										if ($data_template[$d_key]['allowed_fields'][$key]['name'] === NULL)
										{
											$add_table_list[] = array(
												$data_template[$d_key]['allowed_fields'][$key]['table'],
												empty($data_template[$d_key]['allowed_fields'][$key]['key']) ? array() : $data_template[$d_key]['allowed_fields'][$key]['key'],
												$value,
												$key,
												empty($data_template[$d_key]['allowed_fields'][$key]['allowed_fields']) ? array() : $data_template[$d_key]['allowed_fields'][$key]['allowed_fields'],
												empty($d_arr['exact']) ? false : true
											);
										}
										else
										{
											if (empty($value['wait_create_id']))
											{
												$name = $data_template[$d_key]['allowed_fields'][$key]['name'];
												if (gettype($name) === 'object')
												{
													$name = $name($value);
												}
												$null_on = $data_template[$d_key]['allowed_fields'][$key]['NULL'];
												if ($null_on === true || $value !== NULL)
												{
													$filtered_data[$name] = $value;
													$filtered_fields[] = $key;
												}											
											}
											else
											{
												$wait_create_id[] = $value['wait_create_id'];
											}
										}
									}
								}
								else
								{
									if ($key !== 'id' && $key !== 'exact') $forbidden_fields_inner[$i][] = $key;
								}
							}
							$s = array();
							foreach ($filtered_data as $key => $value)
							{
								$s[] = "`" . $key . "` = " 
									 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
							}

							if (empty($s))
							{
								$affected_fields_inner[$i] = array();
							}
							if (empty($d_arr['id']))
							{
								if (empty($s))
								{
									$id_val = NULL;
								}
								else
								{
									$s = "INSERT INTO `" . $table . "`
										SET 
											" . implode(",\n", $s) ."
										";

									$q = query($s);
									if ($q === false) return $this->showError('404', 'error', "$d_key $i : insert failed");

									$id_val = insert_id();
									$created_id_inner[$i] = $id_val;
								}
							}
							else
							{
								$id_val = $d_arr['id'];											
								$ss = "SELECT 
										`" . $id_key . "` 
									FROM `" . $table . "`
									WHERE `" . $id_key . "` = '" . $id_val . "'
									LIMIT 1
									";

								$q = query($ss);
								if ($q === false) return $this->showError('404', 'error', "$d_key $i : select failed");
								$d = fetch_assoc($q);			
								if (empty($d[$id_key]))
								{
									$s = "INSERT INTO `" . $table . "`
										SET 
											" . (empty($s) ? "" : implode(",\n", $s) .",") . "
											`" . $id_key . "` = '" . $id_val . "'
										";

									$q = query($s);
									if ($q === false) return $this->showError('404', 'error', "$d_key $i : insert with id failed");
									$created_id_inner[$i] = $id_val;
								}
								else
								{
									if (!empty($s))
									{
										$s = "UPDATE `" . $table . "`
											SET 
												" . implode(",\n", $s) ."
											WHERE
												`" . $id_key . "` = '" . $id_val . "'
											";

										query($s);

										global $link;
										if (mysqli_affected_rows($link) === -1) 
										{
											return $this->showError('404', 'error', "$d_key $i : update failed'");
										}
										elseif (mysqli_affected_rows($link) === 0) 
										{
											$affected_fields_inner[$i] = array();
										}
									}
								}
							}

							if (!empty($affected_fields_inner[$i]))
							{
								$affected_fields_inner[$i] = $filtered_fields;
							}

							if (!empty($wait_create_id))
							{
								$affected_fields_inner_backup = $affected_fields_inner[$i];
								if ($id_val === NULL) return $this->showError('404', 'error', "$d_key $i: empty id");
								$s = array();
								foreach ($wait_create_id as $value)
								{
									$folder = $_SERVER['DOCUMENT_ROOT'] . $value[3];
									if (is_file($folder))
									{
										return $this->showError('404', 'error', "$d_key $i: {$value[3]} is file");
									}
									else
									{
										if (!file_exists($folder)) mkdir($folder,0777,true);
									}
									$f_name = "$id_val{$value[2]}";
									@$file = file_put_contents("$folder$f_name",$value[1]);
									if ($file === false) return $this->showError('404', 'error', "$d_key $i: failed to create {$value[3]}$f_name");
									$s[] = "`" . $value[0] . "` = '$f_name'";
									$affected_fields_inner[$i][] = $value[0];
								}
								$s = "UPDATE `" . $table . "`
									SET 
										" . implode(",\n", $s) ."
									WHERE
										`" . $id_key . "` = '" . $id_val . "'
									";

								query($s);

								global $link;
								if (mysqli_affected_rows($link) === -1) 
								{
									return $this->showError('404', 'error', "$d_key $i : database update failed'");
								}
								elseif (mysqli_affected_rows($link) === 0) 
								{
									$affected_fields_inner[$i] = $affected_fields_inner_backup;
								}
							}

							foreach($add_table_list as $id_list)
							{
								if ($id_val === NULL) return $this->showError('404', 'error', "$d_key $i {$id_list[3]} : empty id for list");
								if (!is_array($id_list[2])) return $this->showError('404', 'error', "$d_key $i {$id_list[3]} : wrong data");
								$s = array();
								$list_table = $id_list[0];
								if (empty($id_list[1])){
									if (empty($id_list[4])) continue;
									if (!empty($id_list[5]))
									{
										$s_d = "DELETE
											FROM `" . $list_table . "`
											WHERE 
												`" . $id_key . "` = '" . $id_val . "'
											";
										$q = query($s_d);
							
										if ($q === false) return $this->showError('404', 'error', "$d_key $i {$id_list[3]}: database delete failed");
									}
									$allowed_fields = $id_list[4];
									$forbidden_fields_inner_add = array();
									$affected_fields_inner_add = array();
									foreach ($id_list[2] as $j=>$d_arr_add)
									{	
										$filtered_data = array();
										$sql_if = array();
										foreach ($d_arr_add as $key_add => $value)
										{
											if (isset($allowed_fields[$key_add]))
											{
												$affected_fields_inner_add[$j][] = $key_add;
												if (!empty($allowed_fields[$key_add]['format']))
												{
													$value = $allowed_fields[$key_add]['format']($value,$id_val);
												}
												if (empty($value['error']))
												{
													if (isset($value['formated']))
													{
														if (isset($value['filtered']))
														{
															$filtered_data += $value['filtered'];
														}
														if (isset($value['sql_if']))
														{
															$sql_if += $value['sql_if'];
														}
														$value = $value['formated'];
													}
													if ($allowed_fields[$key_add]['name'] !== NULL)
													{
														$name = $allowed_fields[$key_add]['name'];
														if (gettype($name) === 'object')
														{
															$name = $name($value);
														}
														$null_on = $allowed_fields[$key_add]['NULL'];
														if ($null_on === true || $value !== NULL)
														{
															$filtered_data[$name] = $value;
														}
													}
												}
											}
											else
											{
												$forbidden_fields_inner_add[$j][] = $key_add;
											}
										}
//										if (empty($affected_fields_inner_add[$j])) return array('error' => "empty $d_key $i {$id_list[3]} $j allowed data");

										$s = array();
										foreach ($filtered_data as $key => $value)
										{
											$s[] = "`" . $key . "` = " 
												 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
										}
										$s = implode(",", $s);
										if (!empty($s)) $s = ", $s";
										if (!empty($sql_if))
										{
											foreach ($sql_if as $key => $value)
											{
												$sql_if[$key] = "`$key` = '$value'";
											}
											$sql_if = implode(' AND ',$sql_if);//IF(`id_seat` = ' ' AND `block` = ' ','..',``)
											$s_d = array();
											foreach ($filtered_data as $key => $value)
											{
												$s_d[] = "`" . $key . "` = IF($sql_if," 
													 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'") 
													 . ",`$key`)";
											}
											$sql_if = ',' . implode(",", $s_d);
										}
										if (empty($sql_if)) $sql_if = $s;
										$s = "`" . $id_key . "` = '" . $id_val . "'" . $s;
										$sql_if = "`" . $id_key . "` = '" . $id_val . "'" . $sql_if;

										if (empty($id_list[5]))
										{
											$s = "INSERT INTO `" . $list_table . "`
												SET 
													" . $s . " ON DUPLICATE KEY UPDATE " . $sql_if . "
												";

											$q = query($s);
											if ($q === false) return $this->showError('404', 'error', "$d_key $i {$id_list[3]} $j: insert update failed");
										}
										else
										{
											$s = "INSERT INTO `" . $list_table . "`
												SET 
													" . $s ."
												";

											$q = query($s);
											if ($q === false) return $this->showError('404', 'error', "$d_key $i {$id_list[3]} $j: insert failed");	
										}
									}
									if (!empty($affected_fields_inner_add)) $affected_fields_inner[$i][] = array($id_list[3]=>$affected_fields_inner_add);
									if (!empty($forbidden_fields_inner_add)) $forbidden_fields_inner[$i][] = array($id_list[3]=>$forbidden_fields_inner_add);
								}
								else
								{
									$id_list_key = $id_list[1];
									if (!empty($id_list[5]))
									{
										$s_d = "DELETE
											FROM `" . $list_table . "`
											WHERE 
												`" . $id_key . "` = '" . $id_val . "'
											";
										$q = query($s_d);
							
										if ($q === false) return $this->showError('404', 'error', "$d_key $i {$id_list[3]} : list delete failed ");
									}
									foreach ($id_list[2] as $id_item)
									{
										$s[] = "('" . $id_item . "', '" . $id_val . "')";
									}
									$s = "INSERT IGNORE INTO `" . $list_table . "` (`" . $id_list_key . "`,`" . $id_key . "`) VALUES " . implode(",", $s);
	
									$q = query($s);
									if ($q === false) return $this->showError('404', 'error', "$d_key $i {$id_list[3]} : list insert failed");
									$affected_fields_inner[$i][] = $id_list[3];
								}
							}
							if (empty($affected_fields_inner[$i])) unset($affected_fields_inner[$i]);
						}
						if (!empty($affected_fields_inner)) $affected_fields[] = array($d_key=>$affected_fields_inner);
						if (!empty($forbidden_fields_inner)) $forbidden_fields[] = array($d_key=>$forbidden_fields_inner);
						if (!empty($created_id_inner)) $created_id[$d_key] = $created_id_inner;
					}
					else
					{
						list($s_items,$affected_fields_inner) = get_sql_from_arr($d_list,$data_template[$d_key]['key'],isset($data_template[$d_key]['format']) ? $data_template[$d_key]['format'] : array());

						foreach($s_items as $i=>$s_item)
						{
							$s = "INSERT INTO `" . $table . "`
								SET 
									" . implode(",\n", $s_item) . " ON DUPLICATE KEY UPDATE " . $s_item[count($s_item)-1] . "
								";

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', "$table $i : insert failed");
						}
						if (!empty($affected_fields_inner)) $affected_fields[] = array($d_key=>$affected_fields_inner);
					}
				}
				else
				{
					$forbidden_fields[] = $d_key;
				}
			}

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			$out = array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	array(
									'affected_fields' 	=> 	$affected_fields,
									'forbidden_fields'	=>	$forbidden_fields,
									'created_id'		=>	$created_id
								)
			);

			if (!empty($affected_fields))
			{
				$res = update_cache();
				if (empty($res['error']))
				{
					$out['data']['version'] = $res['version'];
				}
				else
				{
					$out['warning']['update cache'] = $res['error'];
				}
			}

			return $out;
		}

		public function selectDataPrivate($data_private = array(), $json_like = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if ($this->id_role != 4)
			{
				return $this->showError('404', 'error', 'not enough rights');
			}

			if (empty($json_like))
			{
				$data_private_out = $data_private;
			}
			else
			{
				@$json_like = json_decode($json_like,true);
				if (empty($json_like) || !is_array($json_like)) 
				{
					return $this->showError('404', 'error', 'wrong json_like');
				}
				find_arr_like($data_private,$json_like);
				$data_private_out = $json_like;
			}
			
			if (isset($data_private_out['script_templates']))
			{
				foreach($data_private_out['script_templates'] as $id=>$template)
				{
					if (!empty($template['file']))
					{
						$data_private_out['script_templates'][$id]['file'] = file_get_contents($_SERVER['DOCUMENT_ROOT'] . $template['file']);
					}
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$data_private_out
			);
		}

		public function selectCart($filter = NULL)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			$sql_user = "`id_user` as u_id,";
			if ($filter == 'all')
			{
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
				$sql_where = "1 = 1";
			}
			elseif ($filter == 'trip')	
			{
				if ($this->id_role != 2 && $this->id_role != 4) return $this->showError('404', 'error', 'wrong role for filter');
				$sql_where = "`trip`.`driver` = '" . $_SESSION[UID] . "'";
			}
			else
			{
				$sql_where = "`id_user` = '" . $_SESSION[UID] . "'";
				$sql_user = "";
			}

			$s = "SELECT 
					$sql_user
					`product` as prod,
					`ticket`.`id_seat` as prop,
					`count`,
					`booking_limit`,
					`trip`.`from` as sc_id,
					`trip`.`json`,
					IF(`order`.`id_order` IS NULL AND `ticket`.`status` NOT in (2,3),IF(`ticket`.`tariff` IS NULL,NULL,IF(`ticket`.`currency` IS NULL,`ticket`.`tariff`,CONCAT_WS(' ',`ticket`.`tariff`,`ticket`.`currency`))),'taken') as price
				FROM `cart`
				LEFT JOIN `trip` ON `trip`.`id_trip` = `cart`.`product`
				LEFT JOIN `ticket` ON `ticket`.`id_trip` = `cart`.`product` AND `ticket`.`id_trip_seat` = `cart`.`property`
				LEFT JOIN `order` ON `order`.`id_order` = `ticket`.`id_order`
				WHERE
					$sql_where
				";		
	
			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('cart' => array());
			while ($d = fetch_assoc($q))
			{
				$sc_id = explode(chr(0),$d['sc_id']);
				if (count($sc_id) > 1 || $sc_id[0] == 'sc_id')
				{
					$d['sc_id'] = $sc_id[1];
				}
				else
				{
					unset($d['sc_id']);
				}
				if (isset($d['price']))
				{		
					if ($d['price'] == 'taken') $d['busy'] = 1;
				}
				else
				{
					$d['json'] = json_decode($d['json'],true);
					if (!empty($d['json']['seats_sold']))
					{
						foreach($d['json']['seats_sold'] as $seat=>$val)
						{
							if ($seat == $d['prop'])
							{
								if (is_array($val))
								{
									if (count($val) > 0 && isset($d['json']['price'][$val[0]]))
									{
										$d['price'] = $d['json']['price'][$val[0]];
									}
									if (count($val) > 1) $d['busy'] = 1;
								}
								else
								{
									if (isset($d['json']['price'][$val]))
									{
										$d['price'] = $d['json']['price'][$val];
									}
								}
							}
						}
					}
				}
				unset($d['json']);
				$d['count'] = (int)$d['count'];
				add_time_zone($d['booking_limit']);
				$out['cart'][] = $d;
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function updateCart($product = "", $property = "", $product_count = 1, $item = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (strlen($product) === 0) return $this->showError('404', 'error', 'empty prod');
			if ($property === NULL || strlen($property) == 0) $property = "";

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');
			
			$sql_delete = "DELETE
						FROM `cart`
						WHERE 
							`id_user` = '" . $_SESSION[UID] . "' AND 
							`product` = '" . $product . "' AND `property` = '" . $property . "'
						";
			switch (DEFAULT_PROFILE)
			{
			
	/*			if (!empty($item))
				{
					@$item = json_decode($item,true);
					if (empty($item) || !is_array($item)) 
					{
						return $this->showError('404', 'error', 'wrong item data');
					}
					$sql_where = array();
					@$item = json_decode($item,true);
					if (empty($item) || !is_array($item)) 
					{
						return $this->showError('404', 'error', 'wrong item data');
					}
					foreach($item as $product=>$property)
					{
						$str = "(`product` = '$product' AND `property` in ";
						if (is_array($property))
						{
							$property = implode("','",$property);
						}
						$property = "(SELECT
											`id_trip_seat`
										FROM `ticket`
										WHERE 
											`id_trip` = '" . $product . "' AND `id_seat` in ('" . $property . "'))";
						$str .= "$property)";
						$sql_where[] = $str;
					}
					$sql_where = " AND (" . implode(" OR ",$sql_where) . ")";
				}*/
			
			
			
			
			
			
			
				case 'stadium':
					$sql_delete = "DELETE
								FROM `cart`
								WHERE 
									`id_user` = '" . $_SESSION[UID] . "' AND 
									`product` = '" . $product . "' AND `property` = (SELECT
										`id_trip_seat`
									FROM `ticket`
									WHERE 
										`id_trip` = '" . $product . "' AND `id_seat` = '" . $property . "'
									LIMIT 1)
								";
					$sql_insert = "INSERT IGNORE INTO `cart`
					SET 
						`id_user` = '" . $_SESSION[UID] . "',
						`product` = '" . $product . "',
						`property` = (SELECT
										`id_trip_seat`
									FROM `ticket`
									WHERE 
										`id_trip` = '" . $product . "' AND `id_seat` = '" . $property . "'
									LIMIT 1),
						`booking_limit` = now() + INTERVAL " . $this->constant['ticket_booking_duration'] . " SECOND
					";
					$sql_update = $sql_delete;
					if ($product_count < 0) $product_count = 0;
					break;
				default:
					$sql_insert = "INSERT INTO `cart`
					SET 
						`id_user` = '" . $_SESSION[UID] . "',
						`product` = '" . $product . "',
						`property` = '" . $property . "',
						" .  ($product_count === 1 ? "" : "`count` = '" . $product_count . "',") . "
						`booking_limit` = now() + INTERVAL " . $this->constant['ticket_booking_duration'] . " SECOND
					ON DUPLICATE KEY UPDATE 
						`count` = `count` + " . $product_count . "
					";
					$sql_update = "UPDATE `cart`
					SET 
						`count` = `count` + " . $product_count . "
					WHERE  
						`id_user` = '" . $_SESSION[UID] . "' AND 
						`product` = '" . $product . "' AND `property` = '" . $property . "'
					";
			}

			if (DEFAULT_PROFILE == 'stadium')
			{
				$s = "SELECT
						`trip`.`id_trip`,
						`trip`.`json`,
						(SELECT
							`product`
						FROM `cart`
						WHERE 
							`product` = '" . $product . "' AND `property` = `ticket`.`id_trip_seat` AND `id_user` != '" . $_SESSION[UID] . "' AND `booking_limit` > now()
						LIMIT 1
						) as busy,
						(SELECT
							`product`
						FROM `cart`
						WHERE 
							`product` = '" . $product . "' AND `property` = `ticket`.`id_trip_seat` AND `id_user` = '" . $_SESSION[UID] . "'
						LIMIT 1
						) as booked,
						`ticket`.`id_seat`,
						`ticket`.`id_order`,
						`ticket`.`id_order`,
						`ticket`.`id_trip_seat`,
						`ticket`.`status`
					FROM `trip`
					LEFT JOIN `ticket` ON `ticket`.`id_trip` = `trip`.`id_trip` AND `ticket`.`id_seat` = '" . $property . "'
					WHERE `trip`.`id_trip` = '" . $product . "'
					LIMIT 1
					FOR UPDATE
				";
;
				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select failed');
				$d = fetch_assoc($q);
				if (empty($d['id_trip'])) 
				{
					return $this->showError('404', 'error', 'trip not found');
				}
				if (empty($d['booked']) && !empty($d['busy'])) 
				{
					return $this->showError('404', 'error', 'busy seat');
				}
				if (empty($d['booked'])) 
				{
					$c_product_count = 0;
					$t_options = json_decode($d['json'],true);
					if (empty($t_options['seats_sold']))
					{
						if (empty($d['id_seat'])) return $this->showError('404', 'error', "seat $property not found");	
						if (!empty($d['id_order'])) return $this->showError('404', 'error', "seat is busy");
						if ($d['status'] == 2) return $this->showError('404', 'error', "seat is busy (out of service)");
						if ($d['status'] == 3) return $this->showError('404', 'error', "busy seat (out of service)");
					}
					else
					{
						if (!isset($t_options['seats_sold'][$property])) return $this->showError('404', 'error', "seat not found");	
						if (is_array($t_options['seats_sold'][$property]) && count($t_options['seats_sold'][$property]) > 1)
						{
							return $this->showError('404', 'error', "busy seat: $property");
						}
					}
				}
				else
				{
					$c_product_count = 1;
				}
			}
			else
			{
				$s = "SELECT
						`id_user`,
						`count`
					FROM `cart`
					WHERE
						`id_user` = '" . $_SESSION[UID] . "' AND
						`product` = '" . $product . "' AND `property` = '" . $property . "'
					FOR UPDATE
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select failed');
				$d = fetch_assoc($q);
				if (empty($d['id_user'])) 
				{
					$c_product_count = 0;
				}
				else
				{
					$c_product_count = (int)$d['count'];
				}
			}

			if ($product_count === 0)
			{
				if ($c_product_count !== 0)
				{
					$s = $sql_delete;
					$q = query($s);
					
					if ($q === false) return $this->showError('404', 'error', 'database delete failed');
				}
			}
			elseif ($product_count > 0)
			{
				$s = $sql_insert;
				$q = query($s);

				if ($q === false) return $this->showError('404', 'error', 'database insert failed');
			}
			else
			{
				if ($c_product_count > 0)
				{
					$u_product_count = $c_product_count + $product_count;
					if ($u_product_count > 0)
					{
						$s = $sql_update;
						$q = query($s);
						
						if ($q === false) return $this->showError('404', 'error', 'update failed');
					}
					else
					{
						$s = $sql_delete;
						$q = query($s);
						
						if ($q === false) return $this->showError('404', 'error', 'cart delete failed');
					}
				}
				elseif ($c_product_count < 0)
				{
					$s = $sql_delete;
					$q = query($s);
					
					if ($q === false) return $this->showError('404', 'error', 'delete failed');
				}
			}

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			$out = array();

			if (DEFAULT_PROFILE == 'stadium')
			{
				if ($product_count > 0)
				{
					$s = "UPDATE `cart`
					LEFT JOIN `cart` as c ON c.`product` = `cart`.`product` AND c.`property` = `cart`.`property` AND c.`id_user` != '" . $_SESSION[UID] . "' AND c.`booking_limit` > now()
					SET 
						`cart`.`booking_limit` = IF((SELECT
								1
							FROM `ticket`
							WHERE 
								`ticket`.`id_trip` = `cart`.`product` AND `ticket`.`id_trip_seat` = `cart`.`property` AND (`ticket`.`id_order` IS NOT NULL OR `ticket`.`status` in (2,3))
							LIMIT 1
						) = 1,0,now() + INTERVAL " . $this->constant['ticket_booking_duration'] . " SECOND)				
					WHERE  
						`cart`.`id_user` = '" . $_SESSION[UID] . "' AND c.`id_user` IS NULL
					";

					$q = query($s);
					if ($q === false) $out['warning'][] = 'limit update failed';	
					
					$s = "DELETE
						FROM `cart`
						WHERE 
							`id_user` = '" . $_SESSION[UID] . "' AND 
							`booking_limit` < now()
						";

					$q = query($s);
					if ($q === false) $out['warning'][] = 'limit delete failed';
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		public function queryString($sql = "", $statement = "select", $var = NULL, $query_roles = '')
		{		
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}			

			if (!empty($query_roles))
			{
				if ($this->id_role == 2 && $_SESSION['id_verification_status'] != 2)
				{
					return $this->showError('404', 'error', 'wrong user check state');
				}
				$query_roles = explode(',',$query_roles);
				$query_roles = array_flip($query_roles);
				if (!isset($query_roles[$this->id_role])) return $this->showError('404', 'error', 'forbidden role');
			}

			$statement = strtolower($statement);
			if ($statement !== 'select')
			{
				if (in_array($statement,array('update','insert','delete','replace'))){
					if ($this->constant['query_extended_statements'] === false){
						return $this->showError('404', 'error', 'statement disabled');
					}
				}
				else
				{
					return $this->showError('404', 'error', 'forbidden statement');
				}
			}
			if (empty($sql)) return $this->showError('404', 'error', 'empty sql string');
			$s = trim($sql);
			if (trim(strtolower(substr($s,0,strlen($statement)+1))) !== $statement)
			{
				$s = "$statement $s";
			}
//			mysqli_report(MYSQLI_REPORT_OFF);
			$sys_data = array(
								'{$_SYS[AUTH][u_id]}' => $_SESSION[UID],
								'{$_SYS[AUTH][u_name]}' => $_SESSION['name'],
								'{$_SYS[AUTH][u_family]}' => $_SESSION['family'],
								'{$_SYS[AUTH][u_middle]}' => $_SESSION['middle'],
								'{$_SYS[AUTH][u_email]}' => $_SESSION['email'] === NULL ? 'NULL' : $_SESSION['email'],
								'{$_SYS[AUTH][u_phone]}' => $_SESSION['phone'] === NULL ? 'NULL' : $_SESSION['phone'],
								'{$_SYS[AUTH][u_tg]}' => $_SESSION['tg'] === NULL ? 'NULL' : $_SESSION['tg'],
								'{$_SYS[AUTH][u_role]}' => $_SESSION['id_role'],
								'{$_SYS[AUTH][u_a_role]}' => $this->id_role === NULL ? 'NULL' : $this->id_role,
								'{$_SYS[AUTH][u_check_state]}' => $_SESSION['id_verification_status'] === NULL ? 'NULL' : $_SESSION['id_verification_status'],
								'{$_SYS[AUTH][u_ban]}' => empty($_SESSION['user_ban_status']) ? 0 : 1,
								'{$_SYS[AUTH][u_active]}' => $_SESSION['active'],
								'{$_SYS[AUTH][u_birthday]}' => $_SESSION['birthday_date'] === NULL ? 'NULL' : $_SESSION['birthday_date'],
								'{$_SYS[AUTH][u_lang]}' => $_SESSION['id_lang'] === NULL ? 'NULL' : $_SESSION['id_lang'],
								'{$_SYS[AUTH][lang]}' => $_SESSION['lang'],
								'{$_SYS[AUTH][u_currency]}' => $_SESSION['currency'] === NULL ? 'NULL' : $_SESSION['currency']
			);
			foreach($sys_data as $d_var=>$val)
			{		
				$s = str_replace($d_var,real_escape_string($val),$s);
			}

			if ($var !== NULL && $var !== "")
			{
				$q = query("BEGIN");
				if ($q === false) return $this->showError('404', 'error', error_db());
			}
			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', error_db());

			$out = array();

			if ($q !== true)
			{
				while ($d = fetch_assoc($q))
				{
					$out[] = $d;
				}
			}
			else
			{
				$out['id'] = insert_id();
				global $link;
				$out['rows'] = mysqli_affected_rows($link);
			}

			if ($var !== NULL && $var !== "")
			{
				if ($var[0] !== '@') $var = "@$var";
				$q = query("SELECT $var");
				if ($q === false) return $this->showError('404', 'error', error_db());
				$d = fetch_assoc($q);
				if ($d !== NULL && array_key_exists($var,$d))
				{
					$out[] = array('{is_var}'=>1,'var'=>$d[$var]);
				}
				$q = query("COMMIT");
				if ($q === false) return $this->showError('404', 'error', error_db());
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$out
			);
		}

		public function writeTicket($id_trip = "", $data = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_trip)) return $this->showError('404', 'error', 'empty t_id');

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}
			
			$filtered_data = array();
			$seats = array();
			$folder = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH . "trips/$id_trip/ticket/";
			foreach($data as $i=>$file_arr)
			{
				if(!is_array($file_arr)) return $this->showError('404', 'error', "$i: wrong data");
				if (isset($file_arr['base64']))
				{
					if (empty($file_arr['seat'])) return $this->showError('404', 'error', "$i: empty seat");
					$seat = trim($file_arr['seat']);
					$seats[] = $seat;
					$filtered_data[$i]['seat'] = $seat;
					$val = trim($file_arr['base64']);
					if ($val === '')
					{
						$filtered_data[$i]['blob_link'] = '';
						$filtered_data[$i]['blob_mime'] = '';
						$filtered_data[$i]['blob'] = false;
						$filtered_data[$i]['blob_ext_w._dot'] = '';
						$filtered_data[$i]['path'] = "$folder";	
					}
					else
					{
						$filtered_data[$i]['blob_link'] = $seat;
						@$content = (string)$val;
						list($type, $content) = array_merge(explode(';', $content),array(''));
						list(, $type) = array_merge(explode(':', $type),array(''));
						if (empty($type)) return $this->showError('404', 'error', 'wrong file string');
						list($base64, $content) = array_merge(explode(',', $content),array(''));
						if ($base64 !== 'base64') return $this->showError('404', 'error', 'wrong string of file');
						$content = base64_decode($content);
						if (gettype($content) !== 'string') return $this->showError('404', 'error', 'wrong base64');
						$filtered_data[$i]['blob_mime'] = $type;
						$filtered_data[$i]['blob'] = $content;
						$filtered_data[$i]['blob_ext_w._dot'] = isset($file_arr['extW.Dot']) ? trim($file_arr['extW.Dot']) : '';
						$filtered_data[$i]['path'] = "$folder";	
					}
				}
				else
				{
					return $this->showError('404', 'error', "$i: base64 not found");
				}
			}

			$s = "SELECT			
					`trip`.`id_trip`,
					`trip`.`driver`,
					`trip`.`json`,
					COUNT(`ticket`.`id_seat`) as seats_count,				
					GROUP_CONCAT(
						CONCAT_WS(0x00,
							`ticket`.`id_seat`,
							`ticket`.`id_trip_seat`
						)
					SEPARATOR 0x01) as fix_seats			
				FROM `trip`
				LEFT JOIN `ticket` ON `ticket`.`id_trip` = `trip`.`id_trip` AND `ticket`.`id_seat` in ('" . implode("','",$seats) . "')
				WHERE	
					`trip`.`id_trip` = '" . $id_trip . "'
				LIMIT 1
				";
			
			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_trip'])) return $this->showError('404', 'error', 'trip not found');
			if ($this->id_role != 4 && $d['driver'] != $_SESSION[UID]) 
			{
				return $this->showError('404', 'error', 'user is not author');
			}

			$t_options = json_decode($d['json'],true);
			
			if (empty($t_options['seats_sold']))
			{
				if ((int)$d['seats_count'] != count($seats)) return $this->showError('404', 'error', "seat not found");
			}
			else
			{
				foreach($seats as $seat)
				{
					if (!isset($t_options['seats_sold'][$seat])) return $this->showError('404', 'error', "$seat not found");	
				}
			}
			$fix_seats = array();
			if (!empty($d['fix_seats']))
			{
				$fix_seats = explode(chr(1),$d['fix_seats']);
				$d['fix_seats'] = array();
				foreach ($fix_seats as $key=>$value)
				{
					list(
						$id_seat,
						$id_trip_seat
						)= explode(chr(0),$value);
					$d['fix_seats'][$id_seat] = $id_trip_seat;
				}
				$fix_seats = $d['fix_seats'];
			}

			if (is_file($folder))
			{
				return $this->showError('404', 'error', "trips/$id_trip/ticket/ is file");
			}
			else
			{
				if (!file_exists($folder)) 
				{
					@$dir = mkdir($folder,0777,true);
					if (!$dir) return $this->showError('404', 'error', "trips/$id_trip/ticket/ create error");
				}
			}

			$htaccess = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH . '.htaccess';
			if (!file_exists($htaccess))
			{
				@$file = file_put_contents($htaccess,'deny from all');
				if (!$file) return $this->showError('404', 'error', "htaccess write error");
			}

			$out = array();

			foreach($filtered_data as $i=>$arr)
			{
				$arr['path'] = $arr['path'] . $fix_seats[$arr['seat']];
				if ($arr['blob'] === false)
				{
					if (!@unlink($arr['path']))
					{
						$out['warning'][] = "{$arr['seat']} delete error";
						continue;
					}
				}
				else
				{
					@$file = file_put_contents($arr['path'],$arr['blob']);
					if ($file === false) 
					{
						$out['warning'][] = "{$arr['seat']} write error";
						continue;
					}
				}

				$s = "UPDATE `ticket`
					SET
						`blob_link` = '" . $fix_seats[$arr['seat']] . "',
						`blob_mime` = '" . $arr['blob_mime'] . "',
						`blob_ext_w._dot` = '" . $arr['blob_ext_w._dot'] . "'
					WHERE
						`id_trip` = '" . $id_trip . "' AND `id_seat` = '" . $arr['seat'] . "'
					";

				$q = query($s);
				if ($q === false) $out['warning'][] = "{$arr['seat']} update failed";
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$out
			);
		}

		public function readTicket($id_trip = "", $seat = "", $pdf = false, $lang_vls = array(), $price_time_functions = array(), $s_data_stt = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_trip)) return $this->showError('404', 'error', 'empty t_id');
			
			if (empty($seat))
			{
				$s = "SELECT			
						`trip`.`id_trip`,
						`trip`.`driver`,
						`trip`.`json`,
						GROUP_CONCAT(`ticket`.`id_seat` SEPARATOR ',') as seats
					FROM `trip`
					LEFT JOIN `ticket` ON `ticket`.`id_trip` = `trip`.`id_trip` AND `ticket`.`blob_link` != ''
					WHERE	
						`trip`.`id_trip` = '" . $id_trip . "'
					LIMIT 1
					";
				
				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_trip'])) return $this->showError('404', 'error', 'trip not found');
				if ($this->id_role != 4 && $d['driver'] != $_SESSION[UID]) 
				{
					return $this->showError('404', 'error', 'user is not author');
				}

				$t_options = json_decode($d['json'],true);
				if (empty($t_options['seats_sold']))
				{
					$seats = empty($d['seats']) ? array() : explode(',',$d['seats']);
				}
				else
				{
					$folder = CONFIG_USER_FILE_PATH . "trips/$id_trip/ticket/";
					$seats = array();				
					if ($dir = scandir($folder))
					{
						foreach($dir as $obj)
						{
							if ($obj != "." && $obj != ".." && is_file("$folder$obj"))
							{
								$seats[] = $obj;
							}
						}
					}
				}

				return array(
					'code' 		=>	'200',
					'status' 	=>	'success',
					'data'		=>	array('seats' => $seats)
				);
			}
			else
			{
				$sql_field = $sql_left_join = '';
				if ($pdf === true)
				{
					$sql_field = ",
						`order`.`options`,
						`order`.`sum`,
						`order`.`currency` as sum_currency,
						`ticket`.`id_order`,
						`ticket`.`number`,
						`ticket`.`code`,
						`ticket`.`code_qr_base64`,
						`ticket`.`tariff` as ti_tariff,
						`ticket`.`currency` as ti_currency,
						`schedule`.`id_schedule`,
						`schedule`.`team1`,
						`schedule`.`team2`,
						`schedule`.`id_stadium` as stadium,
						`schedule`.`id_tournament` as tournament,
						`schedule`.`start_datetime` as datetime,
						`schedule`.`only_date`,
						`schedule`.`time_zone`,
						`schedule`.`code_ean_base64`,						
						`schedule`.`id_price_time_function` as sc_price_time_function,
						`schedule`.`currency` as sc_currency,
						`schedule`.`currency_priority` as sc_currency_priority,
						`schedule`.`fee` as sc_fee,
						`schedule`.`tariff` as sc_tariff,
						`schedule`.`tariff_priority` as sc_tariff_priority,						
						`trip`.`id_price_time_function` as price_time_function,
						`trip`.`currency`,
						`trip`.`currency_priority`,
						`trip`.`fee`,
						`trip`.`tariff`,
						`trip`.`tariff_priority`,
						`trip`.`create_datetime`,
						`users`.`email`,
						`users`.`name`,
						`users`.`family`,
						`users`.`middle`";
					$sql_left_join = "LEFT JOIN `schedule` ON `schedule`.`id_schedule` = `trip`.`id_schedule`
					LEFT JOIN `users` ON `users`.`id_user` = `order`.`client`";
				}

				$s = "SELECT			
						`trip`.`id_trip`,
						`trip`.`driver`,
						`trip`.`json`,
						`ticket`.`blob_link`,
						`ticket`.`blob_mime`,
						`ticket`.`blob_ext_w._dot`,
						`ticket`.`id_seat`,
						`ticket`.`id_trip_seat`,
						`order`.`client`,
						`order`.`pay_datetime`$sql_field
					FROM `trip`
					LEFT JOIN `ticket` ON `ticket`.`id_trip` = `trip`.`id_trip` AND `ticket`.`id_seat` = '" . $seat . "'
					LEFT JOIN `order` ON `order`.`id_order` = `ticket`.`id_order`
					$sql_left_join
					WHERE	
						`trip`.`id_trip` = '" . $id_trip . "'
					LIMIT 1
					";
				
				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$d = fetch_assoc($q);
				if (empty($d['id_trip'])) return $this->showError('404', 'error', 'trip not found');

				$t_options = json_decode($d['json'],true);
				if (empty($t_options['seats_sold']))
				{
					if (empty($d['id_seat'])) return $this->showError('404', 'error', "seat not found for trip");
					if ($this->id_role != 4 && $d['driver'] != $_SESSION[UID]) 
					{
						if (empty($d['client']) || $d['client'] != $_SESSION[UID]) return $this->showError('404', 'error', 'user is not seller or buyer');
						if ($d['pay_datetime'] == '0000-00-00 00:00:00') return $this->showError('404', 'error', 'unpaid order');
					}
				}
				else
				{
					if (!isset($t_options['seats_sold'][$seat])) return $this->showError('404', 'error', "$seat not found for trip");
					if ($this->id_role != 4 && $d['driver'] != $_SESSION[UID]) 
					{
						if (!array($t_options['seats_sold'][$seat]) || count($t_options['seats_sold'][$seat]) < 2 || $t_options['seats_sold'][$seat][1] != $_SESSION[UID]) return $this->showError('404', 'error', 'user is not seller and buyer');
					}
				}
				$blob_link = 0;
				if ($d['blob_link'] === '') 
				{
					if ($pdf === true)
					{
						$blob_link = 1;
					}
					else
					{
						return $this->showError('404', 'error', 'empty ticket file link');
					}
				}

				if ($pdf === true)
				{
					$sc_id = $d['id_schedule'];

					$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
					$lang_name = taxi::$data['langs'][$lang]['iso'];

					$html_pdf_ticket_paid_body = 'html_pdf_ticket_paid_body';
					foreach(array($html_pdf_ticket_paid_body) as $lang_vls_name_base)
					{
						foreach(array("_$sc_id","_tournament_{$d['tournament']}") as $suffix)		 
						{
							$lang_vls_name = "$lang_vls_name_base$suffix";
							if (isset($lang_vls[$lang_vls_name][$lang]) && substr($lang_vls[$lang_vls_name][$lang],0,1) !== chr(0))
							{
								$$lang_vls_name_base = $lang_vls_name;
								break;
							}
						}
					}
					$pdf = lang($html_pdf_ticket_paid_body);
					if (empty($pdf)) return $this->showError('404', 'error', 'empty template');

					if(!empty($d['options'])) $d['options'] = json_decode($d['options'],true);
					
					$seat_s_b_r_s = explode(';',$d['id_seat']);							
					$ticket = $seats = array();

					$format = $this->constant['email_date_format'];
					preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
					add_time_zone($d['datetime']);
					add_time_zone($d['create_datetime']);

					if (isset($d['options']['tickets']['seats'][$id_trip][$d['id_trip_seat']]))
					{
						$price = $d['options']['tickets']['seats'][$id_trip][$d['id_trip_seat']];
					}
					else
					{
						if (!empty($d['datetime']))
						{
							$ptfd = $this->createPriceTimeFunctionData(array(
								'price_time_function'		=>	$d['price_time_function'],
								'sc_price_time_function'	=>	$d['sc_price_time_function'],
								't_create_datetime'			=>	$d['create_datetime'],
								'sc_datetime'				=>	$d['datetime']
							),$price_time_functions);
						}
						$currency = $currency_priority = NULL;
						if (isset($d['currency']))
						{
							$currency = $d['currency'];
						}
						elseif (isset($d['sc_currency']))
						{
							$currency = $d['sc_currency'];
						}
						if (isset($currency))
						{
							if (isset($d['currency_priority']))
							{
								$currency_priority = $d['currency_priority'];
							}
							else
							{
								$currency_priority = $d['sc_currency_priority'];
							}
							if (empty($currency_priority))
							{
								$currency_function = 'getTripCurrencyString10';
							}
							else
							{
								$currency_function = 'getTripCurrencyString11';
							}
						}
						else
						{					
							$currency_function = 'getTripCurrencyString0';
						}
						$tariff_ = $tariff_priority = NULL;
						if (isset($d['tariff']))
						{
							$tariff_ = $d['tariff'];
						}
						elseif (isset($d['sc_tariff']))
						{
							$tariff_ = $d['sc_tariff'];
						}
						if (isset($tariff_))
						{
							if (isset($d['tariff_priority']))
							{
								$tariff_priority = $d['tariff_priority'];
							}
							else
							{
								$tariff_priority = $d['sc_tariff_priority'];
							}
							if (empty($tariff_priority))
							{
								$tariff_function = 'getTripTariff10';
							}
							else
							{
								$tariff_function = 'getTripTariff11';
							}
						}
						else
						{					
							$tariff_function = 'getTripTariff0';
						}
						
						$d['ti_tariff'] = $this->$tariff_function($tariff_,$d['ti_tariff']);
						if ($d['ti_tariff'] !== '')
						{
							if (isset($ptfd['price_time_function']))
							{
								$var = $ptfd['var'];
								if (!empty($ptfd['dp'])) $var['dp'] = $d['ti_tariff'];
								$d['ti_tariff'] = $ptfd['price_time_function']($var);
							}
							$price = $d['ti_tariff'] . $this->$currency_function($currency,$d['ti_currency']);
							$price = strtoupper($price);
						}
						else
						{
							$price = '';
						}
					}

					$datetime_for_str = $d['datetime'];
					if (!empty($d['only_date'])) $datetime_for_str = @substr($datetime_for_str,0,10);
					list($d['datetime'],$datetime_int,$datetime_int_tz) = get_date_arr_for_email($d['datetime'],$d['only_date'],$d['time_zone'],$format,$format_with_tz);

					$seats[] =  array(
								'block'	=>	isset($seat_s_b_r_s[1])?$seat_s_b_r_s[1]:'',
								'row'	=>	isset($seat_s_b_r_s[2])?$seat_s_b_r_s[2]:'',
								'seat'	=>	isset($seat_s_b_r_s[3])?$seat_s_b_r_s[3]:'',
								'price'	=>	round_price($price,2),
								'file'	=>	$blob_link,
								'number'=>	$d['number'],
								'code'	=>	$d['code'],
								'code_qr_base64'=>	empty($d['code_qr_base64']) ? string_to_base64_png_qr(implode(';',array($d['id_seat'],$d['code'],$d['datetime']))) : $d['code_qr_base64']
					);

					$ticket[] = array(
											'schedule'	=>	array(
												'sc_id' 			=>	$sc_id,
												'team1' 			=>	empty($d['team1']) ? '' : $s_data_stt['teams'][$d['team1']][$lang_name],
												'team2' 			=>	empty($d['team2']) ? '' : $s_data_stt['teams'][$d['team2']][$lang_name],
												'stadium'			=>	empty($d['stadium']) ? '' : $s_data_stt['stadiums'][$d['stadium']][$lang_name],
												'datetime'			=>	$d['datetime'],
												'tournament'		=>	empty($d['tournament']) ? '' : $s_data_stt['tournaments'][$d['tournament']][$lang_name],
												'str'				=>	empty($d['team1']) || empty($d['team2']) || empty($d['tournament']) ? '' : $s_data_stt['teams'][$d['team1']][$lang_name] . ' - ' . $s_data_stt['teams'][$d['team2']][$lang_name] . ', ' . $datetime_for_str . ', '. $s_data_stt['tournaments'][$d['tournament']][$lang_name],
												'datetime_int'		=>	$datetime_int,
												'datetime_int_tz'	=>	$datetime_int_tz,
												'code_ean_base64'	=>	$d['code_ean_base64']
											),
											'count'		=>	1,
											'trips'		=>	array(
												array(
													't_id'	=>	$id_trip,
													'seats'	=>	$seats
												)
											)
									   );								  

					$filename = implode(" - ",array($ticket[0]['schedule']['str'],$seats[0]['block'],$seats[0]['row'],$seats[0]['seat']));
					$filename = "$filename.pdf";

					$u_name = empty($d['name']) ? '' : $d['name'];
					$u_family = empty($d['family']) ? '' : $d['family'];
					$u_middle = empty($d['middle']) ? '' : $d['middle'];
					$dataForEmail = array(
						'{$b_id}' 			=> empty($d['id_order']) ? '' : $d['id_order'],		
						'{$locationPath}' 	=> url('',CONFIG_URL),
						'{$clientFullname}'	=> "$u_name $u_family $u_middle",
						'{$u_name}' 		=> $u_name,
						'{$u_family}' 		=> $u_family,
						'{$u_middle}' 		=> $u_middle,
						'{$this_seat}'		=> array(
												'sc_id_i'	=>	0,
												't_id_i'	=>	0,
												'seat_i'	=>	0,
												'filename'	=>	$filename
											),
						'{$ticket}' 		=> $ticket,
						'{$sum}' 			=> isset($d['sum']) ? round((float)$d['sum'],2) . ' ' . $d['sum_currency'] : ''
					);

					list($pdf_body) = fill_in_template(array($pdf),$dataForEmail);
					$file = html_to_pdf($pdf_body);

					header("Content-Type: application/pdf");
					set_header_content_disposition($filename);
					echo $file;
				}
				else
				{
					$folder = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH . "trips/$id_trip/ticket/";
					$name = $d['blob_link'] !== NULL ? $d['blob_link'] : $d['id_trip_seat'];
					$path = "$folder$name";
					if (!file_exists($path)) return $this->showError('404', 'error', 'file not found');
					if ($d['blob_mime'] !== NULL && $d['blob_mime'] !== '') header("Content-Type: {$d['blob_mime']}");
					echo @file_get_contents($path);
				}
				exit;
			}
		}

		public function selectCartBlock($filter = NULL)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			$sql_group_concat = "CONCAT_WS(0x00,
										`cart_block_trip`.`id_trip`,
										IFNULL(`cart_block_trip`.`status`,0x02),
										`cart_block_trip`.`status_sys`
									)";
			 $sql_left_trip = $sql_left = "";
			if ($filter == 'all')
			{
				if ($this->id_role != 2 && $this->id_role != 4) return $this->showError('404', 'error', 'wrong role for filter all');
				$sql_field = "`cart_block`.`id_user` as u_id,
				`cart_block`.`active`,";
				if ($this->id_role != 4)
				{
					$sql_group_concat = "IF(`trip`.`driver` = '{$_SESSION[UID]}',
								CONCAT_WS(0x00,
									`cart_block_trip`.`id_trip`,
									IFNULL(`cart_block_trip`.`status`,0x02),
									`cart_block_trip`.`status_sys`
								),NULL)";
				}
				$sql_left_trip = "LEFT JOIN `trip` USING (`id_trip`)";
				$sql_where = "1 = 1";
			}
			elseif ($filter == 'trip')
			{
				if ($this->id_role != 2 && $this->id_role != 4) return $this->showError('404', 'error', 'wrong role for filter trip');
				$sql_field = "`cart_block`.`id_user` as u_id,
				`cart_block`.`active`,";
				if ($this->id_role != 4)
				{
					$sql_group_concat = "IF(`trip`.`driver` = '{$_SESSION[UID]}',
								CONCAT_WS(0x00,
									`cart_block_trip`.`id_trip`,
									IFNULL(`cart_block_trip`.`status`,0x02),
									`cart_block_trip`.`status_sys`
								),NULL)";
				}
				$sql_left_trip = "LEFT JOIN `trip` USING (`id_trip`)";
				$sql_left = "LEFT JOIN (
				SELECT
					`schedule`.`id_schedule`
				FROM `schedule`
				LEFT JOIN `trip` ON `trip`.`id_schedule` = `schedule`.`id_schedule`
				WHERE
					`schedule`.`active` = '1' AND `trip`.`driver` = '{$_SESSION[UID]}'
				GROUP BY
					`schedule`.`id_schedule`
				ORDER BY `schedule`.`id_schedule` DESC
				) sc ON sc.`id_schedule` = `cart_block`.`product`";
				$sql_where = "sc.`id_schedule` IS NOT NULL";
			}
			else
			{
				$sql_field = "";
				$sql_where = "`cart_block`.`id_user` = '" . $_SESSION[UID] . "' AND `cart_block`.`active` = 1";
			}

			$s = "SELECT 
					$sql_field
					`cart_block`.`product` as prod,
					`cart_block`.`property` as prop,
					`cart_block`.`count`, 
					`cart_block`.`create_datetime` as created,
					`cart_block`.`notification` as notice,
					`cart_block`.`status`,
					`cart_block`.`status_sys`,
					(SELECT
						IF(`cart_block_trip`.`id_cart_block` IS NULL,NULL,
							GROUP_CONCAT(
								$sql_group_concat 
							SEPARATOR 0x01) 
						)
					 FROM `cart_block_trip`
					 $sql_left_trip
					 WHERE `cart_block_trip`.`id_cart_block` = `cart_block`.`id_cart_block`
					) as statuses
				FROM `cart_block`
				$sql_left
				WHERE
					$sql_where
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('cart' => array());
			while ($d = fetch_assoc($q))
			{
				$d['count'] = (int)$d['count'];
				add_time_zone($d['created']);	
				if (!empty($d['statuses']))
				{
					$d['statuses'] = explode(chr(1),$d['statuses']);
					foreach ($d['statuses'] as $key=>$value)
					{
						$d['statuses'][$key] = array();
						list(
							$d['statuses'][$key]['t_id'],
							$d['statuses'][$key]['status'],
							$d['statuses'][$key]['status_sys'],
							)= explode(chr(0),$value);

						if ($d['statuses'][$key]['status'] === chr(2))
						{
							$d['statuses'][$key]['status'] = NULL;
						}
					}
				}
				$out['cart'][] = $d;
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function updateCartBlock($product = "", $property = "", $product_count = 1, $notice = 1, $data = array(), $data_stt = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (strlen($product) === 0) return $this->showError('404', 'error', 'empty prod');
			if ($property === NULL) $property = "";

			if ($product_count < 0) $product_count = 0;

			$out = array();
			if (empty($product_count))
			{
				$s = "UPDATE `cart_block`
					SET
						`active` = 0
					WHERE 
						`id_user` = '" . $_SESSION[UID] . "' AND 
						`product` = '" . $product . "' AND `property` in ('" . str_replace(';',"','",$property) . "')
					";

				$q = query($s);
					
				if ($q === false) return $this->showError('404', 'error', 'database delete failed');
			}
			else
			{	
				$sql_property = str_replace(';',"','",$property);
				$s = "SELECT 
						`schedule`.`id_schedule`,
						`schedule`.`id_stadium`,
						`schedule`.`team1`,
						`schedule`.`team2`,
						`schedule`.`id_tournament` as tournament,
						`schedule`.`start_datetime` as datetime,
						`schedule`.`only_date`,
						`schedule`.`time_zone`,
						(SELECT
							COUNT(`stadium_seats`.`block`)
						 FROM `stadium_seats`
						 WHERE `stadium_seats`.`id_stadium` = `schedule`.`id_stadium` AND `stadium_seats`.`block` in ('" . $sql_property  . "')
						) as block,
						cb.prop_list
					FROM `schedule`
					LEFT JOIN (
						SELECT 
							GROUP_CONCAT(
								IF(`count` = '$product_count' AND `notification` = '$notice' AND `active` = 1,
								CONCAT('|','na',`property`),
								CONCAT('|','ua',`property`))
							SEPARATOR ';') as prop_list,
							`product`
						FROM `cart_block`
						WHERE
							`id_user` = '" . $_SESSION[UID] . "' AND `product` = '" . $product . "' AND `property` in ('" . $sql_property  . "')
						GROUP BY `product`
						) cb ON cb.`product` = `schedule`.`id_schedule`
					WHERE	
						`schedule`.`id_schedule` = '" . $product . "'
					LIMIT 1
				";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select failed');
				$d = fetch_assoc($q);
				if (empty($d['id_schedule'])) 
				{
					return $this->showError('404', 'error', 'schedule not found');
				}
/*				if (empty($d['id_stadium'])) 
				{
					return array('error' => 'empty stadium');
				}
				if (empty($d['block']) && $property !== '') 
				{
					return array('error' => 'block not found');
				}*/

				$property = explode(';',$property);
				$property = array_flip($property);
				$prop_arr_insert_action = $property;
				$prop_arr_no_action = array();
				$prop_arr_update_action = array();
				if (!empty($d['prop_list']))
				{
					foreach(explode(';',$d['prop_list']) as $prop_str)
					{
						list($status,$prop) = explode('|',$prop_str);
						unset($prop_arr_insert_action[$prop]);
						if ($status == 'na')
						{
							$prop_arr_no_action[] = $prop;
						}
						else
						{
							$prop_arr_update_action[] = $prop;
						}
					}
				}
	
				if (!empty($prop_arr_insert_action))
				{
					$s = array();
					foreach($prop_arr_insert_action as $prop=>$val)
					{
						$s[] = "('{$_SESSION[UID]}','$product','$prop','$product_count',now(),'$notice')";
					}
					$s = implode(",", $s);
					$s = "INSERT INTO `cart_block` (`id_user`, `product`, `property`, `count`, `create_datetime`,`notification`) VALUES $s";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'database insert failed');
				}
				if (!empty($prop_arr_update_action))
				{
					$sql_property = implode("','",$prop_arr_update_action);
					$s = "UPDATE `cart_block`
						SET 
							`count` = '" . $product_count . "',
							`notification` = '" . $notice . "',
							`active` = 1
						WHERE 
							`id_user` = '" . $_SESSION[UID] . "' AND 
							`product` = '" . $product . "' AND `property` in ('" . $sql_property  . "')
					";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'database update failed');
				}
				if (count($property) !== count($prop_arr_no_action))
				{
					if (!empty($notice) && !empty($_SESSION['email']))
					{
						$property = array_keys($property);
						$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
						$lang = $data['langs'][$lang]['iso'];
						$lang_name = "{$lang}";	
						add_time_zone($d['datetime']);
						$datetime_for_str = $d['datetime'];
						if (!empty($d['only_date'])) $datetime_for_str = @substr($datetime_for_str,0,10);
						$format = $this->constant['email_date_format'];
						preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
						list($d['datetime'],$datetime_int,$datetime_int_tz) = get_date_arr_for_email($d['datetime'],$d['only_date'],$d['time_zone'],$format,$format_with_tz);
						$dataForEmail = array(
							'{$u_id}' 			=>	$_SESSION[UID],
							'{$u_name}' 		=>	$_SESSION['name'],
							'{$u_family}' 		=>	$_SESSION['family'],
							'{$u_middle}' 		=>	$_SESSION['middle'],
							'{$locationPath}' 	=> 	url('',CONFIG_URL),
							'{$schedule}'	 	=>	$data_stt['teams'][$d['team1']][$lang_name] . ' - ' . $data_stt['teams'][$d['team2']][$lang_name] . ', ' . $datetime_for_str . ', '. $data_stt['tournaments'][$d['tournament']][$lang_name],
							'{$schedule_arr}'	=>	array(
														'sc_id' 			=>	$d['id_schedule'],
														'team1' 			=>	$data_stt['teams'][$d['team1']][$lang_name],
														'team2' 			=>	$data_stt['teams'][$d['team2']][$lang_name],
														'stadium'			=>	empty($d['id_stadium']) ? '' : $data_stt['stadiums'][$d['id_stadium']][$lang_name],
														'datetime'			=>	$d['datetime'],
														'datetime_int'		=>	$datetime_int,
														'datetime_int_tz'	=>	$datetime_int_tz,
														'tournament'		=>	$data_stt['tournaments'][$d['tournament']][$lang_name]
													),
							'{$section}'		=>	implode(",", $property),
							'{$block_arr}'		=>	$property,
							'{$seat_count}'		=>	$product_count
						);
						$dataForEmail['{$block}'] = $dataForEmail['{$section}'];
						$subject = lang('email_ticket_block_cart_subject');
						$body = lang('email_ticket_block_cart_body');
						list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);
						$out['email status'] = send_mail($_SESSION['email'],$subject,$body);
					}
				
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$out
			);
		}
		
		public function selectTicket($sc_id = "")
		{	
			$s = "SELECT
					`id_schedule` as sc_id,
					`id_trip` as t_id,
					COUNT(IF(`id_order` IS NULL AND `status` NOT in (2,3),`id_schedule`,NULL)) as available,
					COUNT(IF(`id_order` IS NOT NULL OR `status` = 2,`id_schedule`,NULL)) as taken,
					COUNT(IF(
						(SELECT
							`product`
						FROM `cart`
						WHERE 
							`product` = `ticket`.`id_trip` AND `property` = `ticket`.`id_trip_seat` AND `booking_limit` > now()
						LIMIT 1
						) IS NULL,IF(`ticket`.`id_order` IS NULL AND `status` NOT in (2,3),`ticket`.`id_schedule`,NULL),NULL
					)) as full_available
				FROM `ticket`
				WHERE 
					 `id_schedule` in (" . $sc_id . ")
				GROUP BY `id_trip`
				";

			if (empty($_SESSION[UID]) || $this->id_role != 2) {
				if (empty($sc_id)) return $this->showError('404', 'error', 'empty sc_id');
			}
			else
			{
				if (empty($sc_id)) 
				{
					$s = "SELECT
							`ticket`.`id_schedule` as sc_id,
							`ticket`.`id_trip` as t_id,
							COUNT(IF(`ticket`.`id_order` IS NULL AND `ticket`.`status` NOT in (2,3),`ticket`.`id_schedule`,NULL)) as available,
							COUNT(IF(`ticket`.`id_order` IS NOT NULL OR `ticket`.`status` = 2,`ticket`.`id_schedule`,NULL)) as taken,
							COUNT(IF(
								(SELECT
									`product`
								FROM `cart`
								WHERE 
									`product` = `ticket`.`id_trip` AND `property` = `ticket`.`id_trip_seat` AND `booking_limit` > now()
								LIMIT 1
								) IS NULL,IF(`ticket`.`id_order` IS NULL AND `ticket`.`status` NOT in (2,3),`ticket`.`id_schedule`,NULL),NULL
							)) as full_available
						FROM `ticket`
						LEFT JOIN `trip` USING (`id_trip`)
						WHERE 
							 `trip`.`driver` = '" . $_SESSION[UID] . "'
						GROUP BY `ticket`.`id_trip`
						";
				}
			}

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('schedule' => array());
			while ($d = fetch_assoc($q))
			{
				if (empty($d['sc_id'])) continue;
				$d['available'] = (int)$d['available'];
				$d['taken'] = (int)$d['taken'];
				$out['schedule'][$d['sc_id']][] = $d;
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$out
			);	
		}

		public function sendToTicketBuyerEmail($resend = false, $id_trip = "", $seat = "", $subject = "", $body = "", $file = '', $id_user = "", $u_name = NULL, $email = "", $ignore_order = false, $price = NULL)
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_trip)) return $this->showError('404', 'error', 'empty t_id');

			if (empty($seat)) return $this->showError('404', 'error', 'empty seat');

			if ($ignore_order === false)
			{
				$id_user = '';
				$price = NULL;
			}

			if (!empty($file))
			{
				@$file = json_decode($file,true);				
				if (empty($file) || !is_array($file)) 
				{
					return $this->showError('404', 'error', 'wrong file data');
				}
			}

			$extended = false;
			if ($subject == 'template' || $body == 'template')
			{
				$extended = true;
			}
			elseif (!empty($file))
			{
				foreach ($file as $f)
				{
					if (isset($f['base64']))
					{
						if ($f['base64'] == 'pdf')
						{
							$extended = true;
							break;
						}
					}
				}
			}

			$sql_field = $sql_left_join = '';
			if ($extended == true)
			{
				$sql_field = ",
					`order`.`options`,
					`order`.`sum`,
					`order`.`currency` as sum_currency,
					`ticket`.`number`,
					`ticket`.`code`,
					`ticket`.`code_qr_base64`,
					`ticket`.`tariff` as ti_tariff,
					`ticket`.`currency` as ti_currency,
					`schedule`.`id_schedule`,
					`schedule`.`team1`,
					`schedule`.`team2`,
					`schedule`.`id_stadium` as stadium,
					`schedule`.`id_tournament` as tournament,
					`schedule`.`start_datetime` as datetime,
					`schedule`.`only_date`,
					`schedule`.`time_zone`,
					`schedule`.`code_ean_base64`,						
					`schedule`.`id_price_time_function` as sc_price_time_function,
					`schedule`.`currency` as sc_currency,
					`schedule`.`currency_priority` as sc_currency_priority,
					`schedule`.`fee` as sc_fee,
					`schedule`.`tariff` as sc_tariff,
					`schedule`.`tariff_priority` as sc_tariff_priority,						
					`trip`.`id_price_time_function` as price_time_function,
					`trip`.`currency`,
					`trip`.`currency_priority`,
					`trip`.`fee`,
					`trip`.`tariff`,
					`trip`.`tariff_priority`,
					`trip`.`create_datetime`,
					`users`.`name`,
					`users`.`family`,
					`users`.`middle`";
				$sql_left_join = "LEFT JOIN `schedule` ON `schedule`.`id_schedule` = `trip`.`id_schedule`";
			}

			$s = "SELECT			
					`trip`.`id_trip`,
					`trip`.`driver`,
					`trip`.`json`,
					`ticket`.`blob_link`,
					`ticket`.`blob_mime`,
					`ticket`.`blob_ext_w._dot`,
					`ticket`.`id_seat`,				
					`ticket`.`id_trip_seat`,
					`ticket`.`id_order`,
					`order`.`client`,
					`users`.`email`,
					`order`.`pay_datetime`$sql_field
				FROM `trip`
				LEFT JOIN `ticket` ON `ticket`.`id_trip` = `trip`.`id_trip` AND `ticket`.`id_seat` = '" . $seat . "'
				LEFT JOIN `order` ON `order`.`id_order` = `ticket`.`id_order`
				LEFT JOIN `users` ON `users`.`id_user` = `order`.`client`
				$sql_left_join
				WHERE	
					`trip`.`id_trip` = '" . $id_trip . "'
				LIMIT 1
				";
			
			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_trip'])) return $this->showError('404', 'error', 'trip not found');

			$t_options = json_decode($d['json'],true);
			if (empty($t_options['seats_sold']))
			{
				if (empty($d['id_seat'])) return $this->showError('404', 'error', "seat not found for trip");
				if ($this->id_role != 4 && $d['driver'] != $_SESSION[UID]) return $this->showError('404', 'error', 'user is not seller');
				if ($ignore_order === false && empty($d['client'])) return $this->showError('404', 'error', 'buyer not found');				
				if ($ignore_order === false && $d['pay_datetime'] == '0000-00-00 00:00:00') return $this->showError('404', 'error', 'unpaid order');
				if (empty($email) && empty($id_user))
				{
					if (empty($d['email'])) return $this->showError('404', 'error', 'empty buyer email');
					$email = $d['email'];
				}
			}
			else
			{
				if (!isset($t_options['seats_sold'][$seat])) return $this->showError('404', 'error', "$seat not found for trip");
				if ($this->id_role != 4 && $d['driver'] != $_SESSION[UID]) return $this->showError('404', 'error', 'user is not seller of trip');
				if (!array($t_options['seats_sold'][$seat]) || count($t_options['seats_sold'][$seat]) < 2) 
				{
					if ($ignore_order === false) return $this->showError('404', 'error', 'seat buyer not found');
				}
				else
				{
					$buyer = $t_options['seats_sold'][$seat][1];

					$s = "SELECT 
							`id_user`,
							`email`,
							`users`.`name`,
							`users`.`family`,
							`users`.`middle`
						FROM `users`
						WHERE
							`id_user` = '" . $buyer . "'
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'user select failed');

					$d_u = fetch_assoc($q);
					if (empty($d_u['id_user'])) return $this->showError('404', 'error', 'buyer user not found');
					if (empty($email) && empty($id_user))
					{
						if (empty($d_u['email'])) return $this->showError('404', 'error', 'buyer with empty email');
						$email = $d_u['email'];
					}
				}
			}

			if ($resend === true)
			{
				if (empty($d['client'])) return $this->showError('404', 'error', 'ticket without buyer');	
				$api_use = true;
				$order = $d['id_order'];
				$status = 'succeeded';
				$res = require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_stripe.php');
				if (!empty($res['error'])) return $this->showError('404', 'error', $res['error']);
				return array(
					'code' 		=>	'200',
					'status' 	=>	'success'
				);
			}

			if (!empty($id_user))
			{
				$s = "SELECT 
						`id_user`,
						`email`,
						`users`.`name`,
						`users`.`family`,
						`users`.`middle`
					FROM `users`
					WHERE
						`id_user` = '" . $id_user . "'
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select of user failed');

				$d_u = fetch_assoc($q);
				if (empty($d_u['id_user'])) return $this->showError('404', 'error', 'user not found');
				if (empty($email))
				{
					if (empty($d_u['email'])) return $this->showError('404', 'error', 'user with empty email');
					$email = $d_u['email'];
				}
			}

			$ticket_file_name = false;
			if ($d['blob_link'] === '')
			{
				$ticket_file = false;
			}
			else
			{
				$folder = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH . "trips/$id_trip/ticket/";
				$name = $d['blob_link'] !== NULL ? $d['blob_link'] : $d['id_trip_seat'];
				$path = "$folder$name";
				if (!file_exists($path)) 
				{
					$ticket_file = false;
				}
				else
				{
					$ticket_file = file_get_contents($path);
					$ext = '';
					if ($d['blob_ext_w._dot'] !== NULL && $d['blob_ext_w._dot'] !== '')
					{
						$ext = $d['blob_ext_w._dot'];
					}
					elseif ($d['blob_mime'] !== NULL && $d['blob_mime'] !== '')
					{
						$ext = mimeToext($d['blob_mime']);
						if (!empty($ext)) $ext = ".$ext";
					}
					$ticket_file_name = "$name$ext";
				}
			}

			if ($extended === true)
			{
				$sc_id = $d['id_schedule'];

				$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
				$lang_name = taxi::$data['langs'][$lang]['iso'];

				$email_ticket_send_subject = 'email_ticket_send_subject';
				$email_ticket_send_body = 'email_ticket_send_body';
				$html_pdf_ticket_paid_body = 'html_pdf_ticket_paid_body';
				foreach(array($email_ticket_send_subject,$email_ticket_send_body,$html_pdf_ticket_paid_body) as $lang_vls_name_base)
				{
					foreach(array("_$sc_id","_tournament_{$d['tournament']}") as $suffix)		 
					{
						$lang_vls_name = "$lang_vls_name_base$suffix";
						if (isset($lang_vls[$lang_vls_name][$lang]) && substr($lang_vls[$lang_vls_name][$lang],0,1) !== chr(0))
						{
							$$lang_vls_name_base = $lang_vls_name;
							break;
						}
					}
				}
				$pdf = lang($html_pdf_ticket_paid_body);
				if (empty($pdf)) return $this->showError('404', 'error', 'empty template');

				if(!empty($d['options'])) $d['options'] = json_decode($d['options'],true);

				$seat_s_b_r_s = explode(';',$d['id_seat']);							
				$ticket = $seats = array();

				$format = $this->constant['email_date_format'];
				preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
				add_time_zone($d['datetime']);
				add_time_zone($d['create_datetime']);

				if ($ignore_order === false && isset($d['options']['tickets']['seats'][$id_trip][$d['id_trip_seat']]))
				{
					$price = $d['options']['tickets']['seats'][$id_trip][$d['id_trip_seat']];
				}
				elseif ($price === NULL)
				{
					if (!empty($d['datetime']))
					{
						$ptfd = $this->createPriceTimeFunctionData(array(
							'price_time_function'		=>	$d['price_time_function'],
							'sc_price_time_function'	=>	$d['sc_price_time_function'],
							't_create_datetime'			=>	$d['create_datetime'],
							'sc_datetime'				=>	$d['datetime']
						),$price_time_functions);
					}
					$currency = $currency_priority = NULL;
					if (isset($d['currency']))
					{
						$currency = $d['currency'];
					}
					elseif (isset($d['sc_currency']))
					{
						$currency = $d['sc_currency'];
					}
					if (isset($currency))
					{
						if (isset($d['currency_priority']))
						{
							$currency_priority = $d['currency_priority'];
						}
						else
						{
							$currency_priority = $d['sc_currency_priority'];
						}
						if (empty($currency_priority))
						{
							$currency_function = 'getTripCurrencyString10';
						}
						else
						{
							$currency_function = 'getTripCurrencyString11';
						}
					}
					else
					{					
						$currency_function = 'getTripCurrencyString0';
					}
					$tariff_ = $tariff_priority = NULL;
					if (isset($d['tariff']))
					{
						$tariff_ = $d['tariff'];
					}
					elseif (isset($d['sc_tariff']))
					{
						$tariff_ = $d['sc_tariff'];
					}
					if (isset($tariff_))
					{
						if (isset($d['tariff_priority']))
						{
							$tariff_priority = $d['tariff_priority'];
						}
						else
						{
							$tariff_priority = $d['sc_tariff_priority'];
						}
						if (empty($tariff_priority))
						{
							$tariff_function = 'getTripTariff10';
						}
						else
						{
							$tariff_function = 'getTripTariff11';
						}
					}
					else
					{					
						$tariff_function = 'getTripTariff0';
					}
					
					$d['ti_tariff'] = $this->$tariff_function($tariff_,$d['ti_tariff']);
					if ($d['ti_tariff'] !== '')
					{
						if (isset($ptfd['price_time_function']))
						{
							$var = $ptfd['var'];
							if (!empty($ptfd['dp'])) $var['dp'] = $d['ti_tariff'];
							$d['ti_tariff'] = $ptfd['price_time_function']($var);
						}
						$price = $d['ti_tariff'] . $this->$currency_function($currency,$d['ti_currency']);
						$price  = strtoupper($price);
					}
					else
					{
						$price = '';
					}
				}
				
				$datetime_for_str = $d['datetime'];
				if (!empty($d['only_date'])) $datetime_for_str = @substr($datetime_for_str,0,10);
				list($d['datetime'],$datetime_int,$datetime_int_tz) = get_date_arr_for_email($d['datetime'],$d['only_date'],$d['time_zone'],$format,$format_with_tz);

				$seats[] =  array(
							'block'	=>	isset($seat_s_b_r_s[1])?$seat_s_b_r_s[1]:'',
							'row'	=>	isset($seat_s_b_r_s[2])?$seat_s_b_r_s[2]:'',
							'seat'	=>	isset($seat_s_b_r_s[3])?$seat_s_b_r_s[3]:'',
							'price'	=>	round_price($price,2),
							'file'	=>	$ticket_file === false ? 0 : 1,
							'number'=>	$d['number'],
							'code'	=>	$d['code'],
							'code_qr_base64'=>	empty($d['code_qr_base64']) ? string_to_base64_png_qr(implode(';',array($d['id_seat'],$d['code'],$d['datetime']))) : $d['code_qr_base64']
				);
		
				$ticket[] = array(
										'schedule'	=>	array(
											'sc_id' 			=>	$sc_id,
											'team1' 			=>	empty($d['team1']) ? '' : $s_data_stt['teams'][$d['team1']][$lang_name],
											'team2' 			=>	empty($d['team2']) ? '' : $s_data_stt['teams'][$d['team2']][$lang_name],
											'stadium'			=>	empty($d['stadium']) ? '' : $s_data_stt['stadiums'][$d['stadium']][$lang_name],
											'datetime'			=>	$d['datetime'],
											'tournament'		=>	empty($d['tournament']) ? '' : $s_data_stt['tournaments'][$d['tournament']][$lang_name],
											'str'				=>	empty($d['team1']) || empty($d['team2']) || empty($d['tournament']) ? '' : $s_data_stt['teams'][$d['team1']][$lang_name] . ' - ' . $s_data_stt['teams'][$d['team2']][$lang_name] . ', ' . $datetime_for_str . ', '. $s_data_stt['tournaments'][$d['tournament']][$lang_name],
											'datetime_int'		=>	$datetime_int,
											'datetime_int_tz'	=>	$datetime_int_tz,
											'code_ean_base64'	=>	$d['code_ean_base64']
										),
										'count'		=>	1,
										'trips'		=>	array(
											array(
												't_id'	=>	$id_trip,
												'seats'	=>	$seats
											)
										)
								   );

				$pdf_filename = implode(" - ",array($ticket[0]['schedule']['str'],$seats[0]['block'],$seats[0]['row'],$seats[0]['seat']));
				$pdf_filename = "$pdf_filename.pdf";
				
				if ($u_name === NULL)
				{
					if (empty($d_u['id_user']))
					{
						$u_name = empty($d['name']) ? '' : $d['name'];
						$u_family = empty($d['family']) ? '' : $d['family'];
						$u_middle = empty($d['middle']) ? '' : $d['middle'];
						$clientFullname = "$u_name $u_family $u_middle";
					}
					else
					{
						$u_name = $d_u['name'];
						$u_family = $d_u['family'];
						$u_middle = $d_u['middle'];
						$clientFullname = "$u_name $u_family $u_middle";
					}
				}
				else
				{
					$clientFullname = $u_name;	
					if (preg_match('/^(\S+)(?:\s+(?:(.*?)\s+)?(\S+))?$/',$u_name,$name_middle_family))
					{
						$u_name = $name_middle_family[1];
						$u_family = $name_middle_family[3];
						$u_middle = $name_middle_family[2];
					}
					else
					{
						$u_name = $u_family = $u_middle = '';
					}
				}

				$dataForEmail = array(
					'{$b_id}' 			=> empty($d['id_order']) ? '' : $d['id_order'],		
					'{$locationPath}' 	=> url('',CONFIG_URL),
					'{$clientFullname}'	=> $clientFullname,
					'{$u_name}' 		=> $u_name,
					'{$u_family}' 		=> $u_family,
					'{$u_middle}' 		=> $u_middle,
					'{$this_seat}'		=> array(
											'sc_id_i'	=>	0,
											't_id_i'	=>	0,
											'seat_i'	=>	0,
											'filename'	=>	$pdf_filename
										),
					'{$ticket}' 		=> $ticket,
					'{$sum}' 			=> isset($d['sum']) ? round((float)$d['sum'],2) . ' ' . $d['sum_currency'] : ''
				);

				list($pdf_body) = fill_in_template(array($pdf),$dataForEmail);
				$pdf_file = html_to_pdf($pdf_body);
				unset($dataForEmail['{$this_seat}']);
							
				if ($subject == 'template')
				{
					$subject = lang($email_ticket_send_subject);
					list($subject) = fill_in_template(array($subject),$dataForEmail);
				}
				if ($body == 'template')
				{
					$body = lang($email_ticket_send_body);
					list($body) = fill_in_template(array($body),$dataForEmail);
				}
				else
				{
					$body = preg_replace_callback('/(<)script(?:\s*|[^>]+\s*=\s*(?:"[^"]*"|\'[^\']*\'|[^>"\'\s]*))*(>)[\s\S]*?(<\/script\s*>)/',function($matches){return htmlspecialchars($matches[0]);},$body);
				}
			}

			$file_decoded = array();
			if (!empty($file))
			{
				$i = 0;
				foreach ($file as $f)
				{
					if (isset($f['base64']))
					{
						if ($f['base64'] == 'uploaded') {
							if ($ticket_file === false) return $this->showError('404', 'error', 'empty uploaded file');
							$content = $ticket_file;
							if ($ticket_file_name !== false)
							{
								if (empty($f['name'])) $f['name'] = $ticket_file_name;
							}
						}
						elseif ($f['base64'] == 'pdf')
						{
							$content = $pdf_file;
							if (empty($f['name'])) $f['name'] = $pdf_filename;
						}
						else 
						{
							@$content = (string)$f['base64'];
							list($type, $content) = array_merge(explode(';', $content),array(''));
							list(, $type) = array_merge(explode(':', $type),array(''));
							if (empty($type)) return $this->showError('404', 'error', 'wrong file string');	
							list($base64, $content) = array_merge(explode(',', $content),array(''));
							if ($base64 !== 'base64') return $this->showError('404', 'error', 'wrong string of file');
							$content = base64_decode($content);
							if (gettype($content) !== 'string') return $this->showError('404', 'error', 'wrong base64');	
						}
					}
					else
					{
						return $this->showError('404', 'error', 'base64 key not found');

					}
					if (isset($f['name']))
					{
						@$filename = (string)$f['name'];
						if (strlen($filename) === 0)
						{
							$filename = 'file' . $i;
						}
					}
					else
					{
						$filename = 'file' . $i;
					}
					$file_decoded[] = array('content' => $content, 'name' => $filename);
					$i++;
				}
			}

			$emailStatus = send_mail($email,$subject,$body,$file_decoded);

			if (empty($emailStatus)) return $this->showError('404', 'error', 'send failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function clearCart($item = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($item))
			{
				$sql_where = '';
			}
			else		
			{
				$sql_where = array();
				@$item = json_decode($item,true);
				if (empty($item) || !is_array($item)) 
				{
					return $this->showError('404', 'error', 'wrong item data');
				}
				foreach($item as $product=>$property)
				{
					$str = "(`product` = '$product' AND `property` in ";
					if (is_array($property))
					{
						$property = implode("','",$property);
					}
					$property = "(SELECT
										`id_trip_seat`
									FROM `ticket`
									WHERE 
										`id_trip` = '" . $product . "' AND `id_seat` in ('" . $property . "'))";
					$str .= "$property)";
					$sql_where[] = $str;
				}
				$sql_where = " AND (" . implode(" OR ",$sql_where) . ")";
			}

			$s = "DELETE
				FROM `cart`
				WHERE 
					`id_user` = '" . $_SESSION[UID] . "'$sql_where
				";

			$q = query($s);
				
			if ($q === false) return $this->showError('404', 'error', 'database delete failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function clearCartBlock($item = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($item))
			{
				$sql_where = '';
			}
			else		
			{
				$sql_where = array();
				@$item = json_decode($item,true);
				if (empty($item) || !is_array($item)) 
				{
					return $this->showError('404', 'error', 'wrong item data');
				}
				foreach($item as $product=>$property)
				{
					$str = "(`product` = '$product' AND `property` in (";
					if (is_array($property))
					{
						$property = implode("','",$property);
					}
					$str .= "'$property'))";
					$sql_where[] = $str;
				}
				$sql_where = " AND (" . implode(" OR ",$sql_where) . ")";
			}

			$s = "UPDATE `cart_block`
				SET 
					`active` = 0
				WHERE 
					`id_user` = '" . $_SESSION[UID] . "'$sql_where
				";

			$q = query($s);
				
			if ($q === false) return $this->showError('404', 'error', 'database delete failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function startEmailVerification()
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			$s = "SELECT 
					`email`,
					`name`,
					`family`,
					`middle`,
					`email_is_verified`
				FROM `users`
				WHERE
					`id_user` = '" . $_SESSION[UID] . "'
				";		

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'user select failed');

			$d = fetch_assoc($q);
			if (empty($d['email'])) return $this->showError('404', 'error', 'empty email');
			$email = $d['email'];
			if (!empty($d['email_is_verified'])) return $this->showError('404', 'error', 'verified email');

			preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',MYSQL_TIME_ZONE,$parsed_time_zone);
			$start_datetime = gmdate("Y-m-d H:i:s",time() + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60);
			$arr = array(
				'k:id'			=>	$_SESSION[UID],
				'k:email'		=>	$email,
				'k:datetime'	=>	$start_datetime
			);
			$ev_hash = urlencode(openssl____encrypt(json_encode($arr)));
			$link = url("api/v1/email/verification/complete?ev_hash=$ev_hash",CONFIG_URL);

			$dataForEmail = array(
				'{$u_id}' 			=> $_SESSION[UID],		
				'{$locationPath}' 	=> url('',CONFIG_URL),
				'{$clientFullname}'	=> "{$d['name']} {$d['middle']} {$d['family']}",
				'{$u_name}' 		=> $d['name'],
				'{$u_family}' 		=> $d['family'],
				'{$u_middle}' 		=> $d['middle'],
				'{$link}' 			=> $link
			);
			$subject = lang('email_verification_start_subject');
			$body = lang('email_verification_start_body');
			list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);
			$emailStatus = send_mail($email,$subject,$body);

			if (empty($emailStatus)) return $this->showError('404', 'error', 'send failed');

			$s = "UPDATE `users`
				SET 
					`email_verification_start` = '" . $start_datetime . "',
					`last_edit_datetime` = now(),
					`last_edit_user` = " . $_SESSION[UID] . "
				WHERE 
					`id_user` = '" . $_SESSION[UID] . "'
			";

			$q = query($s);

			if ($q === false) return $this->showError('404', 'error', 'database update failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function completeEmailVerification($ev_hash = '')
		{
			@$arr = json_decode(openssl____decrypt($ev_hash),true);
			if (!is_array($arr)) return $this->showError('404', 'error', 'wrong ev_hash');
			if (!isset($arr['k:id'])) return $this->showError('404', 'error', 'wrong ev_hash value');
			if (!isset($arr['k:email'])) return $this->showError('404', 'error', 'ev_hash with wrong value');
			if (!isset($arr['k:datetime'])) return $this->showError('404', 'error', 'wrong value of ev_hash');
			
			$id_user = $arr['k:id'];
			$email = $arr['k:email'];
			$start_datetime = $arr['k:datetime'];
			
			$s = "SELECT 
					`id_user`,
					`email_is_verified`
				FROM `users`
				WHERE
					`id_user` = '" . $id_user . "' AND `email` = '" . $email . "' AND `email_verification_start` = '" . $start_datetime . "'
				";		

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'user select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_user'])) return $this->showError('404', 'error', 'email for this link not found');
			if (!empty($d['email_is_verified'])) return $this->showError('404', 'error', 'verified email');

			$s = "UPDATE `users`
				SET 
					`email_is_verified` = '1',
					`email_verification_complete` = now(),
					`last_edit_datetime` = now(),
					`last_edit_user` = " . $id_user . "
				WHERE 
					`id_user` = '" . $id_user . "'
			";

			$q = query($s);

			if ($q === false) return $this->showError('404', 'error', 'database update failed');

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function editTicket($id_trip = "", $data = "", $s_data = array(), $s_data_stt = array(), $s_data_sc = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_trip)) return $this->showError('404', 'error', 'empty t_id');

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$s = "SELECT			
					`trip`.`id_trip`,
					`trip`.`driver`,
					`trip`.`from`
				FROM `trip`
				WHERE	
					`trip`.`id_trip` = '" . $id_trip . "'
				LIMIT 1
				";
			
			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_trip'])) return $this->showError('404', 'error', 'trip not found');
			$id_schedule = explode(chr(0),$d['from']);
			if (count($id_schedule) > 1 || $id_schedule[0] == 'sc_id')
			{
				$id_schedule = $id_schedule[1];
			}
			else
			{
				return $this->showError('404', 'error', 'sc_id not defined');
			}
			$is_usher = false;
			if ($this->id_role != 4 && ($d['driver'] != $_SESSION[UID] || $this->id_role == 6)) 
			{
				if ($this->id_role == 6)
				{
				
					$s = "SELECT
							`id_user` as u_id,
							`id_schedule` as sc_id
						FROM `users`
						WHERE
							`id_user` = '" . $_SESSION[UID]. "'
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'usher select failed');

					$d_u = fetch_assoc($q);
					if (empty($d_u['sc_id']) || $d_u['sc_id'] != $id_schedule) return $this->showError('404', 'error', 'usher for other schedule');
					$is_usher = true;
				}
				else
				{
					return $this->showError('404', 'error', 'user is not author');
				}
			}

			$out = array();
			$s_insert = array();
			$blocks = array();
			$delete_sql = array();
			$warning = array();
			foreach($data as $i=>$arr)
			{
				if (empty($arr['seat'])) {$warning["$i"] = 'empty seat'; continue;}
				$filtered_data = array();
				$filtered_data['id_seat'] = $arr['seat'];
				if ($is_usher === true)
				{
					if (isset($arr['pass']))
					{
						$arr = array('seat' => $arr['seat'], 'pass' => $arr['pass']);
					}
					else
					{
						$arr = array('seat' => $arr['seat']);
					}
				}
				elseif ($this->id_role != 4)
				{
					unset($arr['pass']);
				}
				if (!empty($arr['del']))
				{
					$delete_sql[] = $arr['seat'];
					continue;
				}
				if (isset($arr['price']))
				{
					if ($arr['price'] === "")
					{
						$filtered_data['currency'] = NULL;
						$filtered_data['tariff'] = NULL;
					}
					else
					{
						$tariff = explode(' ',$arr['price']);
						if (count($tariff) > 1)
						{
							$filtered_data['currency'] = $tariff[1];
						}
						else
						{
							$filtered_data['currency'] = NULL;
						}
						$filtered_data['tariff'] = $tariff[0];
					}
				}
				if (array_key_exists('number',$arr))
				{
					$filtered_data['number'] = $arr['number'];
				}
				if (array_key_exists('code',$arr))
				{
					$filtered_data['code'] = $arr['code'];
				}
				if (array_key_exists('code_qr_base64',$arr))
				{
					$filtered_data['code_qr_base64'] = $arr['code_qr_base64'];
				}

				if (empty($arr['new']))
				{
					$var_block = false;
					$sql_status = "";
					if (isset($arr['status']))
					{
						$status = $arr['status'];
						if ($status == 1)
						{
							$var_block = true;
							$sql_status = ",
								`status` = IF(`id_order` IS NULL,
									IF(`status` in (2,3),@block:=1,@block:=0) IS NOT NULL AND '$status',
									@block:=0 = 0 AND `status`)";
							$q = query("BEGIN");
							if ($q === false) return $this->showError('404', 'error', "$i begin query failed");
						}
						else
						{
							$sql_status = ",
								`status` = IF(`id_order` IS NULL,'$status',`status`)";
						}
					}

					$sql_pass = '';
					if (isset($arr['pass']))
					{
						$pass_val = empty($arr['pass']) ? 0 : 1;
						if ($pass_val === 0)
						{
							$pass_datetime = 'out_datetime';
						}
						else
						{
							$pass_datetime = 'pass_datetime';
						}
						$sql_pass = ",
							`pass` = '$pass_val',
							`$pass_datetime` = now()";
					}

					if (isset($arr['name']))
					{
						$filtered_data['id_seat'] = $arr['name'];
					}
					else
					{
						if (count(($filtered_data)) == 1 && empty($sql_status) && empty($sql_pass)) {$warning["$i"] = 'empty data'; continue;}
					}

					$s = array();
					foreach ($filtered_data as $key => $value)
					{
					
						$s[] = "`" . $key . "` = " 
								   . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
					}

					$s = "UPDATE `ticket`
						SET 
							" . implode(",\n", $s) ."$sql_status$sql_pass
						WHERE
							`id_seat` = '" . $arr['seat'] . "' AND `id_trip` = '" . $id_trip . "'
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', "database $i update failed");

					if ($var_block === true)
					{
						$s = "SELECT @block";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'variable select failed');
						if (!empty($block = fetch_assoc($q)['@block']))
						{
							$seat_b_r_s = explode(';',$filtered_data['id_seat']);						
							if (count($seat_b_r_s) < 4) return $this->showError('404', 'error', 'wrong seat');
							if (isset($blocks[$seat_b_r_s[1]])) $blocks[$seat_b_r_s[1]]++; else $blocks[$seat_b_r_s[1]] = 1;
						}
						$q = query("COMMIT");
						if ($q === false) return $this->showError('404', 'error', '$i commit query failed');
					}
				}
				else
				{
					if (!isset($arr['status']) || $arr['status'] == 1)
					{
						$seat_b_r_s = explode(';',$filtered_data['id_seat']);						
						if (count($seat_b_r_s) < 4) return $this->showError('404', 'error', 'wrong seat');
						if (isset($blocks[$seat_b_r_s[1]])) $blocks[$seat_b_r_s[1]]++; else $blocks[$seat_b_r_s[1]] = 1;
					}
					$s_insert[] = "('" . implode("','", array($id_schedule,$filtered_data['id_seat'],$id_trip)) . "',@i:=@i+1," . (isset($filtered_data['tariff']) ? "'{$filtered_data['tariff']}'" : 'NULL') . "," . (isset($filtered_data['currency']) ? "'{$filtered_data['currency']}'" : 'NULL'). "," . (isset($filtered_data['number']) ? "'{$filtered_data['number']}'" : 'NULL') . "," . (isset($arr['status']) ? "'{$arr['status']}'" : 'DEFAULT') . "," . (isset($arr['code']) ? "'{$arr['code']}'" : "CONCAT_WS('-',$id_trip,@i,LOWER(HEX(CRC32(CONCAT(@i,now())))))") . "," . (isset($arr['code_qr_base64']) ? "'{$arr['code_qr_base64']}'" : "''") . ")";
				}
			}
			if (!empty($s_insert))
			{
			
				$q = query("SELECT @i:= MAX(`id_trip_seat`) FROM `ticket` WHERE `id_trip` = '" . $id_trip . "'");
				if ($q === false) return $this->showError('404', 'error', "insert failed");

				$s_insert = "INSERT INTO `ticket` (`ticket`.`" . implode("`,`ticket`.`", array('id_schedule','id_seat','id_trip','id_trip_seat','tariff','currency','number','status','code','code_qr_base64')) . "`) VALUES " . implode(",", $s_insert);	

				$q = query($s_insert);
				if ($q === false) return $this->showError('404', 'error', "database insert failed");
			}

			if (!empty($delete_sql))
			{
				$delete_sql = implode("','",$delete_sql);
				$s = "DELETE
					FROM `ticket`
					WHERE 
						`id_trip` = '$id_trip' AND `id_seat` in ('$delete_sql') AND `id_order` IS NULL AND (SELECT `property` FROM `cart` WHERE `product` = `id_trip` AND `property` = `id_trip_seat`) IS NULL
					";
				$q = query($s);
				
				if ($q === false) return $this->showError('404', 'error', 'delete failed');
			}

			if (!empty($blocks) && $s_data_sc['schedule'][$id_schedule])
			{
				$sql_where = array("''");
				foreach($blocks as $block=>$val)
				{
					$sql_where[] = "'$block'";
				}
				$sql_where = implode(',',$sql_where);

				$s = "SELECT 
						`cart_block`.`id_user`,
						`users`.`email`,
						`users`.`name`,
						`users`.`family`,
						`users`.`middle`,
						 GROUP_CONCAT(`id_cart_block` SEPARATOR ',') as cart_block, 
						 GROUP_CONCAT(`property` SEPARATOR ';') as block_list
					FROM `cart_block`
					LEFT JOIN `users` USING (`id_user`)	
					WHERE
						`cart_block`.`product` = '" . $id_schedule . "' AND `cart_block`.`property` in (" . $sql_where . ") AND `cart_block`.`active` = 1  AND `cart_block`.`notification` = 1 AND `users`.`email` IS NOT NULL
					GROUP BY
						`cart_block`.`id_user`
					";		

				$q = query($s);
				if ($q === false)
				{
					$out['warning'][]  = 'users select failed';
				}
				else
				{
					while ($d = fetch_assoc($q))
					{
						$block_list = explode(';',$d['block_list']);
						$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
						$lang = $s_data['langs'][$lang]['iso'];
						$lang_name = "{$lang}";
						$datetime_str = $s_data_sc['schedule'][$id_schedule]['datetime'];				
						$datetime_for_str = $datetime_str;
						if (!empty( $s_data_sc['schedule'][$id_schedule]['only_date'])) $datetime_for_str = @substr($datetime_for_str,0,10);
						$format = $this->constant['email_date_format'];
						preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
						list($datetime_for_str,$datetime_int,$datetime_int_tz) = get_date_arr_for_email($datetime_for_str,$s_data_sc['schedule'][$id_schedule]['only_date'],$s_data_sc['schedule'][$id_schedule]['time_zone'],$format,$format_with_tz);
						$dataForEmail = array(
							'{$u_id}' 			=> $d['id_user'],		
							'{$locationPath}' 	=> url('',CONFIG_URL),
							'{$u_name}' 		=> $d['name'],
							'{$u_family}' 		=> $d['family'],
							'{$u_middle}' 		=> $d['middle'],
							'{$schedule_arr}'	=>	array(
														'sc_id' 			=>	$id_schedule,
														'team1' 			=>	$s_data_stt['teams'][$s_data_sc['schedule'][$id_schedule]['team1']][$lang_name],
														'team2' 			=>	$s_data_stt['teams'][$s_data_sc['schedule'][$id_schedule]['team2']][$lang_name],
														'stadium'			=>	empty($s_data_sc['schedule'][$id_schedule]['id_stadium']) ? '' : $s_data_stt['stadiums'][$s_data_sc['schedule'][$id_schedule]['id_stadium']][$lang_name],
														'datetime'			=>	$datetime_for_str,
														'datetime_int'		=>	$datetime_int,
														'datetime_int_tz'	=>	$datetime_int_tz,
														'tournament'		=>	$s_data_stt['tournaments'][$s_data_sc['schedule'][$id_schedule]['tournament']][$lang_name]
													),
							'{$block}'		=>	implode(",", $block_list),
							'{$block_arr}'	=>	$block_list
						);
						
						$subject = lang('email_available_seats_subject','Message for user {$u_id} from {$locationPath}',2);
						$body = lang('email_available_seats_body','available seats',2);
						list($subject,$body) = fill_in_template(array($subject,$body),$dataForEmail);
						$out['email status'] = send_mail($d['email'],$subject,$body);
						if (!empty($out['email status']))
						{
							$s = "UPDATE `cart_block`
								SET 
									`status_sys` = IF(`status_sys` = 1,2,`status_sys`)
								WHERE
									`id_cart_block` in (" . $d['cart_block'] . ")
								";

							query($s);
					
							if ($q === false) $out['warning'][]  = 'cart_block update failed';

							$s = array();
							foreach(explode(',',$d['cart_block']) as $id_cart_block)
							{
								$s[] = "('" . $id_cart_block . "', '" . $id_trip . "', 2)";
							}
							$s = "INSERT INTO `cart_block_trip` (`id_cart_block`, `id_trip`, `status_sys`) VALUES " . implode(",", $s) . "ON DUPLICATE KEY UPDATE `status_sys` = IF(`status_sys` = 1,2,`status_sys`)";

							query($s);
					
							if ($q === false) $out['warning'][]  = 'cart_block trip update failed';
						}
					}
				}
			}

			$out['code'] = '200';
			$out['status'] = '200';
			if (!empty($warning)) $out['warning'] = $warning;
			return $out;
		}
		
		public function queryTemplate($data = "", $template = "", $var = NULL, $sql_templates = array())
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}			

			if (empty($template)) return $this->showError('404', 'error', 'empty template');
			
			if (!isset($sql_templates[$template])) return $this->showError('404', 'error', 'template not found');

			if (!empty($sql_templates[$template]['only_admin']) && $this->id_role != 4)
			{
				return $this->showError('404', 'error', 'not enough rights');
			}
			$statement_arr = empty($sql_templates[$template]['statement']) ? array() : $sql_templates[$template]['statement'];

			if (empty($sql_templates[$template]['value']['code'])) return $this->showError('404', 'error', 'wrong template');
			$s = $sql_templates[$template]['value']['code'];

			if (count($statement_arr))
			{
				while (true)
				{
					foreach($statement_arr as $statement)
					{
						if (trim(strtolower(substr($s,0,strlen($statement)+1))) === $statement) break 2;
					}
					return $this->showError('404', 'error', 'wrong template statement');
					break;
				}
			}

			if (!empty($data))
			{
				$data = json_decode($data,true);

				if (empty($data) || !is_array($data)) 
				{
					return $this->showError('404', 'error', 'wrong data');
				}
				foreach($data as $d_var=>$val)
				{		
					$s = str_replace($d_var,real_escape_string($val),$s);
				}
				$sys_data = array(
									'{$_SYS[AUTH][u_id]}' => $_SESSION[UID],
									'{$_SYS[AUTH][u_name]}' => $_SESSION['name'],
									'{$_SYS[AUTH][u_family]}' => $_SESSION['family'],
									'{$_SYS[AUTH][u_middle]}' => $_SESSION['middle'],
									'{$_SYS[AUTH][u_email]}' => $_SESSION['email'] === NULL ? 'NULL' : $_SESSION['email'],
									'{$_SYS[AUTH][u_phone]}' => $_SESSION['phone'] === NULL ? 'NULL' : $_SESSION['phone'],
									'{$_SYS[AUTH][u_tg]}' => $_SESSION['tg'] === NULL ? 'NULL' : $_SESSION['tg'],
									'{$_SYS[AUTH][u_role]}' => $_SESSION['id_role'],
									'{$_SYS[AUTH][u_a_role]}' => $this->id_role === NULL ? 'NULL' : $this->id_role,
									'{$_SYS[AUTH][u_check_state]}' => $_SESSION['id_verification_status'] === NULL ? 'NULL' : $_SESSION['id_verification_status'],
									'{$_SYS[AUTH][u_ban]}' => empty($_SESSION['user_ban_status']) ? 0 : 1,
									'{$_SYS[AUTH][u_active]}' => $_SESSION['active'],
									'{$_SYS[AUTH][u_birthday]}' => $_SESSION['birthday_date'] === NULL ? 'NULL' : $_SESSION['birthday_date'],
									'{$_SYS[AUTH][u_lang]}' => $_SESSION['id_lang'] === NULL ? 'NULL' : $_SESSION['id_lang'],
									'{$_SYS[AUTH][lang]}' => $_SESSION['lang'],
									'{$_SYS[AUTH][u_currency]}' => $_SESSION['currency'] === NULL ? 'NULL' : $_SESSION['currency']
				);
				foreach($sys_data as $d_var=>$val)
				{		
					$s = str_replace($d_var,real_escape_string($val),$s);
				}
			}

			if ($var !== NULL && $var !== "")
			{
				$q = query("BEGIN");
				if ($q === false) return $this->showError('404', 'error', error_db());
			}
			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', error_db());

			$out = array();
			if ($q !== true)
			{
				while ($d = fetch_assoc($q))
				{
					$out[] = $d;
				}
			}
			else		
			{
				$out['id'] = insert_id();
				global $link;
				$out['rows'] = mysqli_affected_rows($link);
			}

			if ($var !== NULL && $var !== "")
			{
				if ($var[0] !== '@') $var = "@$var";
				$q = query("SELECT $var");
				if ($q === false) return $this->showError('404', 'error', error_db());
				$d = fetch_assoc($q);
				if ($d !== NULL && array_key_exists($var,$d))
				{
					$out[] = array('{is_var}'=>1,'var'=>$d[$var]);
				}
				$q = query("COMMIT");
				if ($q === false) return $this->showError('404', 'error', error_db());
			}		

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$out
			);
		}

		public function includeTemplate($template = "", $is_var = false, $script_templates = array())
		{	
			if (!isset($_POST['s_t_data'])) $_POST['s_t_data'] = array();

			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}			

			if (empty($template)) return $this->showError('404', 'error', 'empty template');

			if (empty($is_var))
			{
				if (!isset($script_templates[$template])) return $this->showError('404', 'error', 'template not found');
				$script_file = $_SERVER['DOCUMENT_ROOT'] . $script_templates[$template]['file'];
				$script_template =  $script_templates[$template];
			}
			else
			{
				foreach($script_templates as $script_template)
				{
					if ($script_template['var'] == $template) 
					{
						$script_file = $_SERVER['DOCUMENT_ROOT'] . $script_template['file'];
						break;
					}
				}
				if (empty($script_file)) return $this->showError('404', 'error', 'script template not found');
			}

			if (!empty($script_template['only_admin']) && $this->id_role != 4)
			{
				return $this->showError('404', 'error', 'not enough rights');
			}

			$out = array();

			if (!is_file($script_file))	return $this->showError('404', 'error', 'include failed');
			include($script_file);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$out
			);
		}

		public function translate($data = "", $from = "ru", $to = "en")
		{	
			if (empty($_SESSION[UID])) {
				if (empty($_SESSION['edit_langs'])) return $this->showError('404', 'error', 'unauthorized access');
			} else {
				if ($this->id_role != 4)
				{
					return $this->showError('404', 'error', 'not enough rights');
				}
			}

			if (empty($from)) $from = "ru";
			if (empty($to)) $to = "ru";
			
			$out = array();
			if (!empty($data))
			{
				$data = json_decode($data,true);

				if (empty($data) || !is_array($data)) 
				{
					return $this->showError('404', 'error', 'wrong data');
				}
				$formated = array();
				foreach($data as $str)
				{		
					@$formated[] = (string)$str;
				}
				$out = batch_translate($formated,$from,$to);
				if (!empty($out['error'])) return $this->showError('404', 'error', $out['error']);
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$out,
				'translator'=>	2
			);
		}

		public function statusCartBlock($data = "")
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 4)
			{
				if ($this->id_role != 2) return $this->showError('404', 'error', 'wrong user role');
				if ($_SESSION['id_verification_status'] != 2)
				{
					return $this->showError('404', 'error', 'wrong user check state');
				}
			}

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$out = array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);		
			foreach($data as $i=>$c_b_arr)
			{
				if (!isset($c_b_arr['u_id'])) continue;
				$id_user = $c_b_arr['u_id'];
				if (!isset($c_b_arr['sc_id'])) continue;
				$product = $c_b_arr['sc_id'];
				if (!isset($c_b_arr['block'])) continue;
				$property = $c_b_arr['block'];
				$filtered_data = array();
				if (array_key_exists('status',$c_b_arr))
				{
					$filtered_data['status'] = $c_b_arr['status'];
				}
				if (isset($c_b_arr['status_sys']))
				{
					$filtered_data['status_sys'] = $c_b_arr['status_sys'];
				}
				$s = "SELECT 
						`id_cart_block`
					FROM `cart_block`
					WHERE
						`id_user` = '$id_user' AND `product` = '$product' AND `property` = '$property'
					LIMIT 1
					";		

				$q = query($s);
				if ($q === false)
				{
					$out['warning'][]  = "$i cart_block select failed";
				}
				else
				{
					$d = fetch_assoc($q);
					if ($d === NULL)
					{
						$out['warning'][]  = "$i cart_block not found";
					}
					$id_cart_block = $d['id_cart_block'];
				}
				if (!empty($filtered_data)) 
				{
					if ($this->id_role != 4) {$out['warning'][]  = "$i update wrong user role"; continue;}
	
					$s = array();
					foreach ($filtered_data as $key => $value)
					{
					
						$s[] = "`" . $key . "` = " 
								   . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
					}

					$s = "UPDATE `cart_block`
						SET 
							" . implode(",\n", $s) ."
						WHERE
							`id_cart_block` = '$id_cart_block'
						";

					$q = query($s);

					if ($q === false) $out['warning'][]  = "$i update failed";	
				}
				if (!empty($c_b_arr['statuses']) && is_array($c_b_arr['statuses']))
				{
					foreach($c_b_arr['statuses'] as $j=>$c_b_arr_statuses)
					{
						if (!isset($c_b_arr_statuses['t_id'])) continue;
						$id_trip = $c_b_arr_statuses['t_id'];

						$s = "SELECT 
								`driver`
							FROM `trip`
							WHERE
								`id_trip` = '$id_trip'
							LIMIT 1
							";		

						$q = query($s);
						if ($q === false)
						{
							$out['warning'][]  = "$i $j trip select failed";
						}
						else
						{
							$d = fetch_assoc($q);
							if ($d === NULL)
							{
								$out['warning'][]  = "$i $j trip not found";
								continue;
							}
							$driver = $d['driver'];
							if ($driver != $_SESSION[UID] && $this->id_role != 4)
							{
								$out['warning'][]  = "$i $j foreign trip";
								continue;
							}
						}
						$filtered_data = array();
						if (array_key_exists('status',$c_b_arr_statuses))
						{
							$filtered_data['status'] = $c_b_arr_statuses['status'];
						}
						if (isset($c_b_arr_statuses['status_sys']))
						{
							$filtered_data['status_sys'] = $c_b_arr_statuses['status_sys'];
						}
						$s = array();
						foreach ($filtered_data as $key => $value)
						{
						
							$s[] = "`" . $key . "` = " 
									   . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
						}

						$s = "UPDATE `cart_block_trip`
							SET 
								" . implode(",\n", $s) ."
							WHERE
								`id_cart_block` = '$id_cart_block' AND `id_trip` = '$id_trip'
							";

						$q = query($s);

						if ($q === false) $out['warning'][]  = "$i $j  update failed";
					}
				}
			}

			return $out;
		}

		public function selectInnerUser($id_user = "")
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			$sql_add = "
					`phone` as u_phone,
					`phone_is_verified` as u_phone_checked,
					`email` as u_email,
					`birthday_date` as u_birthday,
					`referral_code` as ref_code,
					`referrer` as referrer_u_id,
					`tg` as u_tg,
					`tg_is_verified` as u_tg_checked,
					`id_user_upper` as u_upper,
					`wa` as u_wa,
					`wa_is_verified` as u_wa_checked,";
			if (empty($id_user) || $id_user == 'authorized' || $id_user == $_SESSION[UID])
			{
				$id_user = $_SESSION[UID];
				if ($this->id_role != 4) $sql_add = "";
			}
			else
			{	
				if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
			}

			$s = "SELECT 
					`id_user` as u_id,
					`id_role` as u_role,
					`name` as u_name,
					`family` as u_family,
					`middle` as u_middle,
					" . $sql_add . "
					`photo_link` as u_photo,
					`id_lang` as u_lang,
					`currency` as u_currency,
					`id_city` as u_city,
					`tips` as u_tips,
					`language_skills` as u_lang_skills,
					`description` as u_description,
					`id_navigation` as u_gps_software,
					`id_verification_status` as u_check_state,
					`active` as u_active,			
					`out_order` as out_drive,
					`out_order_to` as out_address,
					`out_order_to_lat` as out_latitude,
					`out_order_to_lng` as out_longitude,
					`out_order_complete_datetime` as out_est_datetime,
					`out_order_from` as out_s_address,
					`out_order_from_lat` as out_s_latitude,
					`out_order_from_lng` as out_s_longitude,
					`out_order_passengers_count` as out_passengers,
					`out_order_luggage_count` as out_luggage,
					`json` as u_details,
					(SELECT
						GROUP_CONCAT(`users_order_comment`.`id_order_comment` SEPARATOR ',')
					 FROM `users_order_comment`
					 WHERE `users_order_comment`.`id_user` = `users`.`id_user`
					) as b_comments,
					(SELECT
						GROUP_CONCAT(`users_service`.`id_service` SEPARATOR ',')
					 FROM `users_service`
					 WHERE `users_service`.`id_user` = `users`.`id_user`
					) as b_services,
					(SELECT
						GROUP_CONCAT(
							CONCAT_WS('|',`users_order_location`.`id_order_location`,`users_order_location`.`basic`) 
						SEPARATOR ';')
					 FROM `users_order_location`
					 WHERE `users_order_location`.`id_user` = `users`.`id_user`
					) as b_location_classes,
					`id_schedule` as sc_id
				FROM `users`
				WHERE
					`users`.`deleted` = '0' AND `id_user_upper` = '" . $id_user . "'
				LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('user' => array());
			while ($d = fetch_assoc($q))
			{
				$d['u_ban'] = get_user_ban_status($d['u_id']);
				$d['u_photo'] = $d['u_photo'] ? url($d['u_photo'],FILE_PATH) : '';
				add_time_zone($d['out_est_datetime']);
				if (!empty($d['b_comments'])) $d['b_comments'] = explode(',',$d['b_comments']);		
				if (!empty($d['b_services'])) $d['b_services'] = explode(',',$d['b_services']);			
				if (!empty($d['b_location_classes']))
				{
					$d['b_location_classes'] = explode(';',$d['b_location_classes']);
					foreach ($d['b_location_classes'] as $key=>$value)
					{
						$d['b_location_classes'][$key] = array();
						list(
							$d['b_location_classes'][$key]['b_location_class'],
							$d['b_location_classes'][$key]['basic']
							)= explode('|',$value);
						$d['b_location_classes'][$key]['basic'] = (int)$d['b_location_classes'][$key]['basic'];
					}
				}
				if (isset($d['u_phone_checked'])) $d['u_phone_checked'] = (int)$d['u_phone_checked'];
				$d['u_active'] = (int)$d['u_active'];			
				$d['out_drive'] = (int)$d['out_drive'];	
				$d['u_details'] = json_decode($d['u_details'],true);
				$out['user'][$d['u_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['user'] =  array_values($out['user']);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function requestTemplate($template = "", $is_var = false, $outer_script_templates = array())
		{	
			if (empty($template)) return $this->showError('404', 'error', 'empty template');

			if (empty($is_var))
			{
				if (!isset($outer_script_templates[$template])) return $this->showError('404', 'error', 'template not found');
				$outer_script_template =  $outer_script_templates[$template];
			}
			else
			{
				while (true)
				{
					foreach($outer_script_templates as $outer_script_template)
					{
						if ($outer_script_template['var'] == $template) 
						{
							break 2;
						}
					}
					return $this->showError('404', 'error', 'outer script template not found');
				}
			}

			switch ($outer_script_template['only_admin'])
			{
				case '-1':
					$u_id_export = isset($_SESSION[UID]) ? $_SESSION[UID] : '';
					break;
				case '0':
					if (empty($_SESSION[UID])) {
						return $this->showError('404', 'error', 'unauthorized access');
					}
					$u_id_export = $_SESSION[UID];
					break;
				case '1':
					if ($this->id_role != 4)
					{
						return $this->showError('404', 'error', 'not enough rights');
					}
					$u_id_export = $_SESSION[UID];
					break;
			}

			$post_json = $outer_script_template['post_json'];
			$post_json_export = $outer_script_template['post_json_export'];
			if (empty($post_json) || !is_array($post_json))
			{
				$arr = array();
			}
			else
			{
				$arr = $post_json;
			}
			if (!empty($post_json_export) && is_array($post_json_export))
			{
				foreach($post_json_export as $key=>$val)
				{
					if (isset($_REQUEST[$key]))
					{
						if (empty($val) && $val !== '0')
						{
							$arr[$key] = $_REQUEST[$key];
						}
						elseif (!is_array($val))
						{
							$arr[$val] = $_REQUEST[$key];
						}
						elseif (empty($val[0]) && (!isset($val[0]) || $val[0] !== '0'))
						{
							$arr[$key] = $_REQUEST[$key];
						}
						else
						{
							if (is_array($val[0]))
							{
								$arr = set_val_for_array($arr,$val[0],$_REQUEST[$key]);
							}
							else
							{
								$arr[$val[0]] = $_REQUEST[$key];
							}
						}
					}
					elseif (!empty($val) && is_array($val) && isset($val[1]))
					{
						if (empty($val[0]) && (!isset($val[0]) || $val[0] !== '0'))
						{
							$arr[$key] = $val[1];
						}
						elseif (is_array($val[0]))
						{
							$arr = set_val_for_array($arr,$val[0],$val[1]);
						}
						else
						{
							$arr[$val[0]] = $val[1];
						}
					}
				}
			}
			if (!empty($outer_script_template['u_id_export'])) $arr['u_id'] = $u_id_export;
			$headers_json = $outer_script_template['headers_json'];
			$headers_json_export = $outer_script_template['headers_json_export'];
			if (empty($headers_json) || !is_array($headers_json))
			{
				$headers = array();
			}
			else
			{
				$headers = $headers_json;
			}
			if (empty($outer_script_template['urlencoded']))
			{
				$data_str = json_encode($arr);
				$headers[] = "Content-Type: application/json";
			}
			else
			{
				$data_str = array();
				foreach($arr as $key=>$val)
				{
					$data_str[] = urlencode($key) . '=' . urlencode(is_array($val) ? json_encode($val) : $val);		 
				}
				$data_str = implode('&',$data_str);
				$headers[] = "Content-Type: application/x-www-form-urlencoded";
			}
			
			$url = $outer_script_template['url'];
			$c = curl_init();
			curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c,CURLOPT_URL, $url);
			curl_setopt($c,CURLOPT_FOLLOWLOCATION, true);
			curl_setopt($c,CURLOPT_POST, 1);
			curl_setopt($c,CURLOPT_POSTFIELDS,$data_str);
			curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
			if (!empty($headers_json_export) && is_array($headers_json_export))
			{
				$h_arr = getallheaders();
				$h_arr_lower = array();
				foreach($h_arr as $key=>$val)
				{
					$h_arr_lower[strtolower($key)] = $val;
				}
				unset($h_arr);
				foreach($headers_json_export as $h=>$v)
				{
					if (isset($h_arr_lower[$h]))
					{
						if (empty($v) && $v !== '0')
						{
							$headers[] = "$h: {$h_arr_lower[$h]}";
						}
						elseif (!is_array($v))
						{
							$headers[] = "$v: {$h_arr_lower[$h]}";
						}
						elseif (empty($v[0]) && (!isset($v[0]) || $v[0] !== '0'))
						{
							$headers[] = "$h: {$h_arr_lower[$h]}";
						}
						else
						{
							$headers[] = "{$v[0]}: {$h_arr_lower[$h]}";
						}
					}
					elseif (!empty($v) && is_array($v) && isset($v[1]))
					{
						if (empty($v[0]) && (!isset($v[0]) || $v[0] !== '0'))
						{
							$headers[] = "$h: {$v[1]}";
						}
						else
						{
							$headers[] = "{$v[0]}: {$v[1]}";
						}
					}
				}
			}
			if (!empty($headers)) curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($c);
			curl_close($c);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data'		=>	$response
			);
		}

		public function selectContact($id_contact_item = NULL, $id_user = NULL, $id_owner_type = NULL, $id_contact_type = NULL, $owner_types = array(), $langs = array())
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			$sql_list = array();
			$sql_where = array();
			if (!empty($id_contact_type))
			{
				$sql_where[] = "`contact_items`.`id_contact_type` in ($id_contact_type)";
			}
			if (empty($id_owner_type))
			{
				$sql_where_owner_type = '';
				$id_owner_type = array_keys($owner_types);
			}
			else
			{
				$sql_where_owner_type = "`contact_items`.`id_owner_type` in ($id_owner_type)";
				$id_owner_type = explode(',',$id_owner_type);
			}
			if (!empty($id_contact_item))
			{
				$sql_where[] = "`contact_items`.`id_contact_item` in ($id_contact_item)";
			}
			$sql_private_o_type_all = $sql_private_o_type_1 = $sql_private_o_type_other = ",`contact_items`.`contact_number` as 'number',
						`contact_items`.`key1`,
						`contact_items`.`key2`,
						`contact_items`.`token`,
						`contact_items`.`hash`,
						`contact_items`.`secret`,
						`contact_items`.`host`,
						`contact_items`.`port`,
						`contact_items`.`login`,
						`contact_items`.`password`,
						`contact_items`.`smtpsecure`,
						`contact_items`.`fromname`";
			if ($this->id_role != 4) $sql_private_o_type_other = ",NULL as 'number',
						NULL as 'key1',
						NULL as 'key2',
						NULL as 'token',
						NULL as 'hash',
						NULL as 'secret',
						NULL as 'host',
						NULL as 'port',
						NULL as 'login',
						NULL as 'password',
						NULL as 'smtpsecure',
						NULL as 'fromname'";
			if ($id_user === NULL)
			{
				if ($this->id_role != 4) $id_user = $_SESSION[UID];
			}
			else
			{
				if ($this->id_role != 4 && $id_user != $_SESSION[UID]) return $this->showError('404', 'error', 'not enough rights');
			}
			$sql_name = $sql_description = array();
			foreach ($langs as $lang)
			{
				$sql_name[] = "`contact_items`.`name_{$lang['iso']}` as {$lang['iso']}";
				$sql_description[] = "`contact_items`.`description_{$lang['iso']}` as about_{$lang['iso']}";
			}
			$sql_name = implode(',',$sql_name);
			$sql_description = implode(',',$sql_description);
			if ($id_user === NULL)
			{
				$sql_list[] = array(
								'field' => $sql_private_o_type_all,
								'left_join' => '',
								'where' => $sql_where,
								'where_owner_type' => $sql_where_owner_type,
								'group' => ''
				);
			}
			else
			{
				$sql_list = array();
				foreach($id_owner_type as $o_type)
				{
					if (empty($owner_types[$o_type])) return $this->showError('404', 'error', "owner type $o_type not found");
					$table = $owner_types[$o_type]['table'];
					$column = $owner_types[$o_type]['column'];
					$sql = $owner_types[$o_type]['sql'];
					if ($table !== NULL && $table !== "" && $column!== NULL && $column!== "")
					{
						if ($table == 'users')
						{
							if ($column == 'id_user')
							{
								$id_user_str = str_replace(',',"','",$id_user);
								$id_user_str = "'$id_user_str'";
								$sql_list[] = array(
												'field' => "$sql_private_o_type_1,`owner` as u_id",
												'left_join' => '',
												'where' => $sql_where,
												'where_owner_type' => "(`contact_items`.`id_owner_type` = $o_type AND `contact_items`.`owner` in ($id_user_str))",
												'group' => ''
								);
								
							}
							elseif ($column == 'id_role')
							{
								if ($id_user == $_SESSION[UID])
								{
									$id_role = $this->id_role;
									$sql_list[] = array(
													'field' => "$sql_private_o_type_other,`owner` as u_id",
													'left_join' => '',
													'where' => $sql_where,
													'where_owner_type' => "(`contact_items`.`id_owner_type` = $o_type AND `contact_items`.`owner` = '$id_role')",
													'group' => ''
									);
								}
								else
								{							
									$sql_list[] = array(
													'field' => "$sql_private_o_type_other,GROUP_CONCAT(ow.`id_user` SEPARATOR ',') as u_id",
													'left_join' => "LEFT JOIN (
																SELECT
																	`id_user`,
																	CONCAT(`id_role`,'') as owner
																FROM
																	`users`
																WHERE
																	`id_user` in ($id_user)
															) ow USING (`owner`)",
													'where' => $sql_where,
													'where_owner_type' => "(`contact_items`.`id_owner_type` = $o_type AND ow.`id_user` in ($id_user))",
													'group' => "GROUP BY `contact_items`.`id_contact_item`"
									);
								}
							}
							elseif (array_key_exists($column,$_SESSION))
							{
								$sql_list[] = array(
												'field' => "$sql_private_o_type_other,GROUP_CONCAT(ow.`id_user` SEPARATOR ',') as u_id",
												'left_join' => "LEFT JOIN (
															SELECT
																`id_user`,
																CONCAT(`$column`,'') as owner
															FROM
																`users`
															WHERE
																`id_user` in ($id_user)
														) ow USING (`owner`)",
												'where' => $sql_where,
												'where_owner_type' => "(`contact_items`.`id_owner_type` = $o_type AND ow.`id_user` in ($id_user))",
												'group' => "GROUP BY `contact_items`.`id_contact_item`"
								);
							}
							else
							{
								$sql_list[] = array(
												'field' => "$sql_private_o_type_other,GROUP_CONCAT(ow.`id_user` SEPARATOR ',') as u_id",
												'left_join' => "LEFT JOIN (
															SELECT
																`id_user`,
																CONCAT(`$column`,'') as owner
															FROM
																`users`
															WHERE
																`id_user` in ($id_user)
														) ow USING (`owner`)",
												'where' => $sql_where,
												'where_owner_type' => "(`contact_items`.`id_owner_type` = $o_type AND ow.`id_user` in ($id_user))",
												'group' => "GROUP BY `contact_items`.`id_contact_item`"
								);
							}
						}
						else
						{

							$delimiter = $owner_types[$o_type]['delimiter'] === NULL ? ',' : $owner_types[$o_type]['delimiter'];
							$delimiter = real_escape_string($delimiter);
							$sql_list[] = array(
											'field' => "$sql_private_o_type_other,GROUP_CONCAT(ow.`id_user` SEPARATOR ',') as u_id",
											'left_join' => "LEFT JOIN (
														SELECT
															`id_user`,
															CONCAT(GROUP_CONCAT(`$column` SEPARATOR '$delimiter'),'') as owner
														FROM
															`$table`
														WHERE
															`id_user` in ($id_user)
														GROUP BY
															`id_user`
														ORDER BY
															`$column`
													) ow USING (`owner`)",
											'where' => $sql_where,
											'where_owner_type' => "(`contact_items`.`id_owner_type` = $o_type AND ow.`id_user` in ($id_user))",
											'group' => "GROUP BY `contact_items`.`id_contact_item`"
							);
						}
					}
					else
					{		
						if ($sql === NULL) continue;
						$sql = str_replace('{$id_user}',$id_user,$sql);
						$sql_list[] = array(
										'field' => "$sql_private_o_type_other,GROUP_CONCAT(ow.`id_user` SEPARATOR ',') as u_id",
										'left_join' => "LEFT JOIN ($sql) ow USING (`owner`)",
										'where' => $sql_where,
										'where_owner_type' => "(`contact_items`.`id_owner_type` = $o_type AND ow.`id_user` in ($id_user))",
										'group' => "GROUP BY `contact_items`.`id_contact_item`"
						);
					}
				}
			}
			if (empty($sql_list)) return $this->showError('404', 'error', "valid owner type not found");
			$s = array();
			foreach($sql_list as $list_val)
			{
				$sql_field = $list_val['field'];
				$sql_left_join = $list_val['left_join'];
				$sql_where = $list_val['where'];
				$sql_where[] = $list_val['where_owner_type'];
				$sql_where = implode(' AND ',$sql_where);
				if (!empty($sql_where)) $sql_where = "WHERE
						$sql_where";
				$sql_group = $list_val['group'];
				$s[] = "SELECT 
						`contact_items`.`id_contact_item`as co_id,
						`contact_items`.`owner`,
						`contact_items`.`id_owner_type` as o_type,
						`contact_items`.`id_contact_type` as co_class,
						`contact_items`.`contact_id` as cid,
						`contact_items`.`contact_link` as link,
						`contact_items`.`is_bot`,
						`contact_items`.`active`$sql_field,
						$sql_name,
						$sql_description
					FROM `contact_items`
					$sql_left_join
					$sql_where
					$sql_group
					";
			}
			$s = implode(' UNION ',$s);
			$s = "$s
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array('contact' => array());
			while ($d = fetch_assoc($q))
			{
				$out['contact'][$d['co_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['contacts'] =  array_values($out['contacts']);
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function createContact($data = '', $langs = array())
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(
				'owner'	=>		array(
										'name'	=>	'owner',
										'NULL'	=>	false
									),
				'o_type'	=>		array(
										'name'	=>	'id_owner_type',
										'NULL'	=>	false
									),
				'co_class'	=>		array(
										'name'	=>	'id_contact_type',
										'NULL'	=>	false
									),
				'number'	=>	array(
										'name'	=>	'contact_number',
										'NULL'	=>	true
									),
				'cid'	=>		array(
										'name'	=>	'contact_id',
										'NULL'	=>	true
									),
				'link'	=>		array(
										'name'	=>	'contact_link',
										'NULL'	=>	true
									),
				'is_bot'	=>		array(
										'name'	=>	'is_bot',
										'NULL'	=>	false,
										'format'=>	function($val){return empty($val) ? 0 : 1;}
									),
				'key1'	=>		array(
										'name'	=>	'key1',
										'NULL'	=>	true
									),
				'key2'	=>		array(
										'name'	=>	'key2',
										'NULL'	=>	true
									),
				'token'	=>		array(
										'name'	=>	'token',
										'NULL'	=>	true
									),
				'hash'	=>		array(
										'name'	=>	'hash',
										'NULL'	=>	true
									),
				'secret'	=>		array(
										'name'	=>	'secret',
										'NULL'	=>	true
									),
				'host'	=>		array(
										'name'	=>	'host',
										'NULL'	=>	true
									),	
				'port'	=>		array(
										'name'	=>	'port',
										'NULL'	=>	true
									),
				'login'	=>		array(
										'name'	=>	'login',
										'NULL'	=>	true
									),
				'password'	=>		array(
										'name'	=>	'password',
										'NULL'	=>	true
									),
				'smtpsecure'	=>		array(
										'name'	=>	'smtpsecure',
										'NULL'	=>	true
									),
				'fromname'	=>		array(
										'name'	=>	'fromname',
										'NULL'	=>	true
									),			
				'active'	=>		array(
										'name'	=>	'active',
										'NULL'	=>	false,
										'format'=>	function($val){return empty($val) ? 0 : 1;}
									)
			);
			foreach ($langs as $lang)
			{
				$out_key = $lang['iso'];
				$db_key = 'name_' . $lang['iso'];
				$null_on = true;
				$allowed_fields[$out_key] = array(
									'name'	=>	$db_key ,
									'NULL'	=>	$null_on
				);				
				$out_key = 'about_' . $lang['iso'];
				$db_key = 'description_' . $lang['iso'];
				$null_on = false;
				$allowed_fields[$out_key] = array(
									'name'	=>	$db_key ,
									'NULL'	=>	$null_on
				);
			}

			if (!isset($data['co_class'])) return $this->showError('404', 'error', 'empty co_class');
			$forbidden_fields = array();
			$affected_fields = array();
			$filtered_data = array();
			foreach ($data as $key => $value)
			{
				if (isset($allowed_fields[$key]))
				{
					$affected_fields[] = $key;
					if (!empty($allowed_fields[$key]['format']))
					{
						$value = $allowed_fields[$key]['format']($value);
					}
					if (empty($value['error']))
					{
						$name = $allowed_fields[$key]['name'];
						$null_on = $allowed_fields[$key]['NULL'];
						if ($null_on === true || $value !== NULL)
						{
							$filtered_data[$name] = $value;
						}
						else
						{
							return $this->showError('404', 'error', "$key: null value");
						}
					}
					else
					{
						return $this->showError('404', 'error', "$key: {$value['error']}");
					}
				}
				else
				{
					$forbidden_fields[] = $key;
				}
			}

			if (isset($filtered_data['owner'])) 
			{
				if (isset($filtered_data['id_owner_type']) && $filtered_data['id_owner_type'] != 1) 
				{
					if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');
				}
				else
				{
					if ($filtered_data['owner'] != $_SESSION[UID] && $this->id_role != 4) return $this->showError('404', 'error', 'not enough rights for action');
				}
			}
			else
			{
				if (isset($filtered_data['id_owner_type']) && $filtered_data['id_owner_type'] != 1) return $this->showError('404', 'error', 'empty owner');
				$filtered_data['owner'] = $_SESSION[UID];
				$affected_fields[] = 'owner';
			}

			$s = array();
			foreach ($filtered_data as $key => $value)
			{
				$s[] = "`$key` = " 
					 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
			}

			$s = "INSERT INTO `contact_items`
				SET 
					" . implode(",\n", $s) .",
					`last_edit_datetime` = now(),
					`last_edit_user` = '" . $_SESSION[UID] . "',
					`create_datetime` = now(),
					`create_user` = '" . $_SESSION[UID] . "'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database insert failed');

			$id_contact_item = insert_id();
			$out = array('affected_fields' 	=> 	$affected_fields);
			if (!empty($forbidden_fields)) $out['forbidden_fields'] = $forbidden_fields;
			$out['co_id'] = $id_contact_item;

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		public function editContact($data = '', $id_contact_item = '', $langs = array())
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_contact_item)) return $this->showError('404', 'error', 'empty co_id');

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(
				'owner'	=>		array(
										'name'	=>	'owner',
										'NULL'	=>	false
									),
				'o_type'	=>		array(
										'name'	=>	'id_owner_type',
										'NULL'	=>	false
									),
				'co_class'	=>		array(
										'name'	=>	'id_contact_type',
										'NULL'	=>	false
									),
				'number'	=>	array(
										'name'	=>	'contact_number',
										'NULL'	=>	true
									),
				'cid'	=>		array(
										'name'	=>	'contact_id',
										'NULL'	=>	true
									),
				'link'	=>		array(
										'name'	=>	'contact_link',
										'NULL'	=>	true
									),
				'is_bot'	=>		array(
										'name'	=>	'is_bot',
										'NULL'	=>	false,
										'format'=>	function($val){return empty($val) ? 0 : 1;}
									),
				'key1'	=>		array(
										'name'	=>	'key1',
										'NULL'	=>	true
									),
				'key2'	=>		array(
										'name'	=>	'key2',
										'NULL'	=>	true
									),
				'token'	=>		array(
										'name'	=>	'token',
										'NULL'	=>	true
									),
				'hash'	=>		array(
										'name'	=>	'hash',
										'NULL'	=>	true
									),
				'secret'	=>		array(
										'name'	=>	'secret',
										'NULL'	=>	true
									),
				'host'	=>		array(
										'name'	=>	'host',
										'NULL'	=>	true
									),	
				'port'	=>		array(
										'name'	=>	'port',
										'NULL'	=>	true
									),
				'login'	=>		array(
										'name'	=>	'login',
										'NULL'	=>	true
									),
				'password'	=>		array(
										'name'	=>	'password',
										'NULL'	=>	true
									),
				'smtpsecure'	=>		array(
										'name'	=>	'smtpsecure',
										'NULL'	=>	true
									),
				'fromname'	=>		array(
										'name'	=>	'fromname',
										'NULL'	=>	true
									),
				'active'	=>		array(
										'name'	=>	'active',
										'NULL'	=>	false,
										'format'=>	function($val){return empty($val) ? 0 : 1;}
									)
			);
			foreach ($langs as $lang)
			{
				$out_key = $lang['iso'];
				$db_key = 'name_' . $lang['iso'];
				$null_on = true;
				$allowed_fields[$out_key] = array(
									'name'	=>	$db_key ,
									'NULL'	=>	$null_on
				);				
				$out_key = 'about_' . $lang['iso'];
				$db_key = 'description_' . $lang['iso'];
				$null_on = false;
				$allowed_fields[$out_key] = array(
									'name'	=>	$db_key ,
									'NULL'	=>	$null_on
				);
			}

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			$s = "SELECT			
					`contact_items`.`id_contact_item`,
					`contact_items`.`owner`,
					`contact_items`.`id_owner_type`
				FROM `contact_items`
				WHERE	
					`id_contact_item` = '$id_contact_item'
				LIMIT 1
				FOR UPDATE
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_contact_item'])) return $this->showError('404', 'error', 'contact not found');
			if ($this->id_role != 4 && ($d['id_owner_type'] != 1 || $d['owner'] != $_SESSION[UID])) return $this->showError('404', 'error', 'not enough rights');

			if ($this->id_role != 4)
			{
				unset($allowed_fields['owner']);
				unset($allowed_fields['o_type']);
			}
			$forbidden_fields = array();
			$affected_fields = array();
			$filtered_data = array();
			foreach ($data as $key => $value)
			{
				if (isset($allowed_fields[$key]))
				{
					$affected_fields[] = $key;
					if (!empty($allowed_fields[$key]['format']))
					{
						$value = $allowed_fields[$key]['format']($value);
					}
					if (empty($value['error']))
					{
						$name = $allowed_fields[$key]['name'];
						$null_on = $allowed_fields[$key]['NULL'];
						if ($null_on === true || $value !== NULL)
						{
							$filtered_data[$name] = $value;
						}
						else
						{
							return $this->showError('404', 'error', "$key: null value");
						}
					}
					else
					{
						return $this->showError('404', 'error', "$key: {$value['error']}");
					}
				}
				else
				{
					$forbidden_fields[] = $key;
				}
			}

			$s = array();
			foreach ($filtered_data as $key => $value)
			{
				$s[] = "`$key` = " 
					 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
			}

			if (empty($s)) return $this->showError('404', 'error', 'allowed data not found');
	
			$s = "UPDATE `contact_items`
				SET 
					" . implode(",\n", $s) ."
				WHERE
					`id_contact_item` = '$id_contact_item'
				";

			query($s);
	
			global $link;
			if (mysqli_affected_rows($link) === -1) 
			{
				return $this->showError('404', 'error', 'database update failed');
			}
			elseif (mysqli_affected_rows($link) === 0) 
			{
				return $this->showError('404', 'error', 'modified data not found');
			}

			$s = "UPDATE `contact_items`
				SET
					`last_edit_datetime` = now(),
					`last_edit_user` = '" .  $_SESSION[UID] . "'
				WHERE
					`id_contact_item` = '$id_contact_item'
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database timestamp update failed');
			
			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			$out = array('affected_fields' 	=> 	$affected_fields);
			if (!empty($forbidden_fields)) $out['forbidden_fields'] = $forbidden_fields;

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		public function selectMessage($id_message= NULL, $from_to = '', $owner_types = array())
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (!empty($from_to))
			{
				$from_to = $this->parseOwnerFromTo($from_to,$owner_types);
				if (!empty($from_to['error'])) return $this->showError('404', 'error', $from_to['error']);
				list($from_owner,$from_o_type,$to_owner,$to_o_type,$owner_types) = $from_to;
			}

			$id_user = $_SESSION[UID];
			list($error,$available_owner,$sql_where_owner,$sql_where_from,$sql_where_to) = array_pad($this->parseOwnerAvailable($id_user,$owner_types),5,'');
			if (!empty($error)) return $this->showError('404', 'error', $error);
			if (empty($sql_where_owner)) return $this->showError('404', 'error', 'owners not found');

			while (true)
			{
				$sql_where = array();
				if (!empty($id_message))
				{			
					$sql_where[] = "`message`.`id_message` in ($id_message)";
				}
				if (empty($from_to))
				{
					if (empty($sql_where))
					{
						$s = "SELECT 
							  COUNT(`message`.`id_message`) as 'all',
							  NULL as 'read',						
							  `message`.`sender_owner` as from_owner,
							  `message`.`sender_owner_type` as from_o_type,
							  `message`.`recipient_owner` as to_owner,
							  `message`.`recipient_owner_type` as to_o_type,
							  'from' as type
							FROM `message`
							WHERE
								$sql_where_from
							GROUP BY
								`message`.`sender_owner_type`, `message`.`sender_owner`, `message`.`recipient_owner_type`, `message`.`recipient_owner`

							UNION
							
							SELECT 
							  COUNT(`message`.`id_message`) as 'all',
							  COUNT((SELECT
									`messages_read`.`id_message`
								 FROM `messages_read`
								 WHERE `messages_read`.`id_message` = `message`.`id_message` AND `messages_read`.`id_user` = '$id_user'
								)) as 'read',						
							  `message`.`sender_owner` as from_owner,
							  `message`.`sender_owner_type` as from_o_type,
							  `message`.`recipient_owner` as to_owner,
							  `message`.`recipient_owner_type` as to_o_type,
							  'to' as type
							FROM `message`
							WHERE
								$sql_where_to
							GROUP BY
								`message`.`sender_owner_type`, `message`.`sender_owner`, `message`.`recipient_owner_type`, `message`.`recipient_owner`
							";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'select of database failed');

						$out = array('correspondence' => array());
						while ($d = fetch_assoc($q))
						{
							$out['correspondence'][] = $d;
						}
						break;
					}
					else
					{
						$sql_where[] = $sql_where_owner;
						$sql_where = implode(' AND ',$sql_where);
					}
				}
				else
				{
					if (empty($available_owner[$from_o_type][$from_owner])) return $this->showError('404', 'error', 'forbidden from_owner');
					$sql_where[] = "((`message`.`sender_owner_type`= '$from_o_type' AND `message`.`sender_owner`= '$from_owner' AND `message`.`recipient_owner_type`= '$to_o_type' AND `message`.`recipient_owner`= '$to_owner') OR (`message`.`sender_owner_type`= '$to_o_type' AND `message`.`sender_owner`= '$to_owner' AND `message`.`recipient_owner_type`= '$from_o_type' AND `message`.`recipient_owner`= '$from_owner'))";
					$sql_where = implode(' AND ',$sql_where);
				}
				
				$s = "SELECT 
					  `message`.`id_message` as m_id,
					  `message`.`sender_owner` as from_owner,
					  `message`.`sender_owner_type` as from_o_type,
					  `message`.`recipient_owner` as to_owner,
					  `message`.`recipient_owner_type` as to_o_type,
					  `message`.`name`as title,
					  `message`.`value` as text,
					  `message`.`last_edit_datetime` as m_edited,
					  `message`.`create_datetime` as m_created,
					  `message`.`id_message_type` as m_type,
					  `message`.`id_message_upper` as m_upper,
					  `message`.`sender_contact_item` as s_co_id,
					  `message`.`recipient_contact_item` as r_co_id,
					  `message`.`unread`,
					  `message`.`active_status`,
					  (SELECT
							GROUP_CONCAT(
								CONCAT_WS('|',`message_contact_items`.`sender_contact_item`,`message_contact_items`.`recipient_contact_item`) 
							SEPARATOR ';')
						 FROM `message_contact_items`
						 WHERE `message_contact_items`.`id_message` = `message`.`id_message`
						) as co_ids,
						(SELECT
							`messages_read`.`read`
						 FROM `messages_read`
						 WHERE `messages_read`.`id_message` = `message`.`id_message` AND `messages_read`.`id_user` = '$id_user'
						) as 'read'
					FROM `message`
					WHERE
						$sql_where
					ORDER BY `message`.`create_datetime` DESC
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'database select failed');

				$out = array('message' => array());
				while ($d = fetch_assoc($q))
				{
					if (!empty($d['co_ids']))
					{
						$d['co_ids'] = explode(';',$d['co_ids']);
						foreach ($d['co_ids'] as $key=>$value)
						{
							$d['co_ids'][$key] = explode('|',$value);
						}
					}
					add_time_zone($d['m_edited']);
					add_time_zone($d['m_created']);	
					$out['message'][$d['m_id']] = $d;
				}
				if (empty($this->associativeArray)) $out['contacts'] =  array_values($out['contacts']);
				break;
			}
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out,
				'auth_user' =>	array(
									'u_id' => $_SESSION[UID],
									'u_name' => $_SESSION['name'],
									'u_family' => $_SESSION['family'],
									'u_middle' => $_SESSION['middle'],
									'u_email' => $_SESSION['email'],
									'u_phone' => $_SESSION['phone'],
									'u_role' => $_SESSION['id_role'],
									'u_a_role' => $this->id_role,
									'u_check_state' => $_SESSION['id_verification_status'],
									'u_ban' => $_SESSION['user_ban_status'],
									'u_active' => $_SESSION['active'],
									'u_photo' => $_SESSION['photo_link'],
									'u_birthday' => $_SESSION['birthday_date'],
									'u_lang' => $_SESSION['id_lang'],
									'u_currency' => $_SESSION['currency'],
									'u_gps_software' => $_SESSION['id_navigation']
								)
			);
		}

		public function sendMessage($name = '', $value = '', $id_message_upper = NULL, $id_message_type = NULL, $from_to = '', $co_ids = '', $co_id = NULL, $code = NULL, $owner_types = array(), $roles = array())
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			
			if (empty($id_message_type)) $id_message_type = 1;
			$id_user = $_SESSION[UID];
			if ($code !== NULL)
			{
				if (empty($co_id)) return $this->showError('404', 'error', 'empty co_id');
				$from_to = NULL;
				$co_ids = NULL;
			}
			elseif ($id_message_type == 2 || $id_message_type == 5)
			{
				if (empty($co_ids)) return $this->showError('404', 'error', 'empty co_ids');
				$co_id = NULL;
			}
			elseif ($id_message_type == 3 || $id_message_type == 4)
			{
				$co_id = NULL;
				$co_ids = NULL;
			}
			elseif ($id_message_type == 6)
			{
				if (empty($co_id)) return $this->showError('404', 'error', 'empty co_id for message');
				$co_ids = NULL;
			}
			else
			{
				$co_id = NULL;
			}

			if ($code === NULL && empty($from_to))
			{
				return $this->showError('404', 'error', 'empty from_to');
			}

			if (!empty($from_to))
			{
				$from_to = $this->parseOwnerFromTo($from_to,$owner_types);
				if (!empty($from_to['error'])) return $this->showError('404', 'error', $from_to['error']);
				list($from_owner,$from_o_type,$to_owner,$to_o_type,$owner_types_filtered) = $from_to;
		
				if ($id_message_type == 2 || $id_message_type == 5 || $id_message_type == 3 || $id_message_type == 4)
				{
					if ($from_o_type != 1 || $to_o_type != 1)
					{
						return $this->showError('404', 'error', 'forbidden m_type');
					}
				}
			}
			
			$co_id_list = array();
			if (!empty($co_id))
			{
				$co_id_list[$co_id] = true;
			}
			if (!empty($co_ids))
			{
				$co_ids = json_decode($co_ids,true);
				
				if (empty($co_ids) || !is_array($co_ids)) 
				{
					return $this->showError('404', 'error', 'wrong co_ids');
				}
				foreach($co_ids as $val_arr)
				{
					if (!is_array($val_arr) || !isset($val_arr[0]) || !isset($val_arr[1])) return $this->showError('404', 'error', 'wrong co_ids element');
					if ($val_arr[0] != (int)$val_arr[0] || $val_arr[1] != (int)$val_arr[1]) return $this->showError('404', 'error', 'wrong co_ids element number');
					$co_id_list[$val_arr[0]] = true;
					$co_id_list[$val_arr[1]] = true;
				}
			}
			if (!empty($co_id_list))
			{
				$where_co_id = implode(',',array_keys($co_id_list));
				$s = "SELECT 
						`id_contact_item`,
						`owner`,
						`id_owner_type`,
						`id_contact_type`,
						`contact_number`,
						`contact_id`,
						`contact_link`
					FROM `contact_items`
					WHERE
						`id_contact_item` in ($where_co_id)
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'co_id: select failed');
				
				$contacts = array();
				while ($d = fetch_assoc($q))
				{
					$contacts[$d['id_contact_item']] = $d;
				}
			}
			if (!empty($co_ids))
			{
				foreach($co_ids as $val_arr)
				{
					if (empty($contacts[$val_arr[0]]) || empty($contacts[$val_arr[1]])) return $this->showError('404', 'error', 'co_ids element not found');
					$co_id_from = $contacts[$val_arr[0]];
					$co_id_to = $contacts[$val_arr[1]];
					if ($co_id_from['owner'] != $from_owner || $co_id_from['id_owner_type'] != $from_o_type
						|| $co_id_to['owner'] != $to_owner || $co_id_to['id_owner_type'] != $to_o_type) return $this->showError('404', 'error', 'contact does not belong to sender or recipient');
					if ($co_id_from['id_contact_type'] != $co_id_to['id_contact_type']) return $this->showError('404', 'error', 'different types of contacts');

					if ($co_id_from['id_contact_type'] != 7) return $this->showError('404', 'error', 'types of contact does not support sending');
					if (empty($co_id_from['contact_number'])) return $this->showError('404', 'error', 'sender contact without number');
					if (empty($co_id_to['contact_link'])) return $this->showError('404', 'error', 'recipient contact without requisite');
				}
			}
			if (!empty($co_id))
			{
				if (empty($contacts[$co_id])) return $this->showError('404', 'error', 'co_id not found');
				if ($code === NULL)
				{
					if ($contacts[$co_id]['owner'] != $from_owner || $contacts[$co_id]['id_owner_type'] != $from_o_type) return $this->showError('404', 'error', 'contact does not belong to sender');
				}
				else
				{
					if ($contacts[$co_id]['id_contact_type'] != 7) return $this->showError('404', 'error', 'code: types of contact does not support sending');
					if (empty($contacts[$co_id]['contact_number'])) return $this->showError('404', 'error', 'code: sender contact without number');
					$from_owner = $contacts[$co_id]['owner'];
					$from_o_type = $contacts[$co_id]['id_owner_type'];
					if ($this->id_role != 4 && $from_o_type != 1) return $this->showError('404', 'error', 'code: not enough rights');
					$owner_types_filtered = array($from_o_type => $owner_types[$from_o_type]);
				}
			}

			list($error,$available_owner,$sql_where_owner,$sql_where_from,$sql_where_to) = array_pad($this->parseOwnerAvailable($id_user,$owner_types_filtered),5,'');
			if (!empty($error)) return $this->showError('404', 'error', $error);
			if (empty($available_owner[$from_o_type][$from_owner])) return $this->showError('404', 'error', 'forbidden from_owner');

			if ($code !== NULL)
			{
				$response = send_msg_to_tg('','', $contacts[$co_id]['contact_number'],'',$code);
				if (!empty($response['error'])) return $this->showError('404', 'error', array('code send error'=>$response['error']));
				if ($response == 'code sent') return $this->showError('404', 'error', 'new code sent');
				return array('code'=>'200','status'=>'success');
			}

			$to_owner_exist = $this->parseOwnerExists($to_o_type,$to_owner,$owner_types,$roles);
			if (!empty($to_owner_exist['error'])) return $this->showError('404', 'error', $to_owner_exist['error']);
			if (empty($to_owner_exist)) return $this->showError('404', 'error', 'to_owner not found');

			$out = array();
			
			if ($id_message_type == 1 || $id_message_type == 6 || $id_message_type == 2 || $id_message_type == 5)
			{
				if ($from_o_type == 1 && $to_o_type == 1)
				{
					$s = "SELECT 
							(SELECT 
								IF(`message`.`id_message_type` = 3, 1, 0)
							FROM `message`
							WHERE
								`message`.`id_message_type` in (3,4) AND `message`.`sender_owner_type`= '$from_o_type' AND `message`.`sender_owner`= '$from_owner' AND `message`.`recipient_owner_type`= '$to_o_type' AND `message`.`recipient_owner`= '$to_owner' AND `message`.`active_status` = 1
							) as sender,
							(SELECT
								IF(`message`.`id_message_type` = 3, 1, 0) as status
							FROM `message`
							WHERE
								`message`.`id_message_type` in (3,4) AND `message`.`sender_owner_type`= '$to_o_type' AND `message`.`sender_owner`= '$to_owner' AND `message`.`recipient_owner_type`= '$from_o_type' AND `message`.`recipient_owner`= '$from_owner' AND `message`.`active_status` = 1
							) as recipient
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'select status failed');
					
					$msg = array();
					$d = fetch_assoc($q);
					foreach(array('sender','recipient') as $participant)
					{
						if (isset($d[$participant]))
						{
							if (empty($d[$participant]))
							{
								$msg[] = "$participant blocked correspondence";
							}
						}
						else
						{
							$msg[] = "$participant must open a correspondence";
						}
					}
					if (!empty($msg)) return $this->showError('404', 'error', $msg);

					if (!empty($co_ids))
					{
						if ($id_message_type == 1)
						{
							$s = array();
							foreach($co_ids as $val_arr)
							{
								$co_id_from = $val_arr[0];
								$co_id_to = $val_arr[1];
								
								$s[] = "SELECT 
										(SELECT 
											IF(`message`.`id_message_type` = 2, 1, 0)
										FROM `message`
										WHERE
											`message`.`id_message_type` in (2,5) AND `message`.`sender_contact_item`= '$co_id_from' AND `message`.`recipient_contact_item`= '$co_id_to' AND `message`.`active_status` = 1
										) as sender,
										(SELECT
											IF(`message`.`id_message_type` = 2, 1, 0)
										FROM `message`
										WHERE
											`message`.`id_message_type` in (2,5) AND `message`.`sender_contact_item`= '$co_id_to' AND `message`.`recipient_contact_item`= '$co_id_from' AND `message`.`active_status` = 1
										) as recipient
									";
							}
							$s = implode(' UNION ', $s);

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', 'union select status failed');
							
							$msg = array();
							$i = 0;
							while ($d = fetch_assoc($q))
							{
								foreach(array('sender','recipient') as $participant)
								{
									if (isset($d[$participant]))
									{
										if (empty($d[$participant]))
										{
											$msg[] = "$participant blocked contact {$co_ids[$i][0]} - {$co_ids[$i][1]}";
										}
									}
									else
									{
										$msg[] = "$participant must open a contact {$co_ids[$i][0]} - {$co_ids[$i][1]}";
									}
								}
								$i++;
							}
							if (!empty($msg)) return $this->showError('404', 'error', $msg);
						}
						elseif ($id_message_type == 2 || $id_message_type == 5)
						{
							$msg_status = array('2'=>'opened','5'=>'closed');			
							$s = array();
							foreach($co_ids as $val_arr)
							{
								$co_id_from = $val_arr[0];
								$co_id_to = $val_arr[1];
								
								$s = "SELECT 
										`message`.`id_message_type`,
										`message`.`sender_contact_item`,
										`message`.`recipient_contact_item`
									FROM `message`
									WHERE
										`message`.`id_message_type` in (2,5) AND `message`.`sender_contact_item`= '$co_id_from' AND `message`.`recipient_contact_item`= '$co_id_to' AND `message`.`active_status` = 1
									";
							}

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', "select status $id_message_type failed");

							$msg = array();
							$id_message_type_prev = array();
							while ($d = fetch_assoc($q))
							{
								if ($d['id_message_type'] == $id_message_type) $msg[] = "contact already {$msg_status[$id_message_type]}";
								$id_message_type_prev[] = '(' . implode(' AND ', array("`id_message_type` = '{$d['id_message_type']}'","`sender_contact_item` = '{$d['sender_contact_item']}'","`recipient_contact_item` = '{$d['recipient_contact_item']}'")) . ')';
							}
							if (!empty($msg)) return $this->showError('404', 'error', $msg);
						}
					}
				}

				if ($id_message_type == 6) $value = $co_id;
				
				if (!empty($co_ids))
				{
					if ($id_message_type == 1)
					{
						foreach($co_ids as $val_arr)
						{
							$co_id_from = $val_arr[0];
							$co_id_to = $val_arr[1];
							$response = send_msg_to_tg($name,$value,$contacts[$co_id_from]['contact_number'],$contacts[$co_id_to]['contact_link']);
							if (!empty($response['error'])) return $this->showError('404', 'error', array("$co_id_from - $co_id_to send error"=>$response['error']));
							if ($response == 'code sent') return $this->showError('404', 'error', "$co_id_from - $co_id_to send error: code sent");
						}
					}
					elseif ($id_message_type == 2 || $id_message_type == 5)
					{
						if (!empty($id_message_type_prev))
						{
							$q = query("BEGIN");
							if ($q === false) return $this->showError('404', 'error', 'm_type 2,5: begin query failed');

							$id_message_type_prev = implode(' OR ',$id_message_type_prev);
							$s = "UPDATE `message`
								SET
									`active_status` = 0
								WHERE
									($id_message_type_prev) AND `message`.`active_status` = 1
								";

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', 'm_type 2,5: update failed');
						}
					}
				}

				if ($id_message_type == 2 || $id_message_type == 5)
				{
					$name = '';
					$value = '';
				}
				$name_escape = real_escape_string($name);
				$value_escape = real_escape_string($value);
				$s = array();
				if ($id_message_type == 2 || $id_message_type == 5)
				{
					foreach($co_ids as $val_arr)
					{
						$co_id_from = $val_arr[0];
						$co_id_to = $val_arr[1];
						$s[] = '(' . implode(', ',array("'$from_owner'","'$from_o_type'","'$to_owner'","'$to_o_type'","'$name_escape'","'$value_escape'","now()","'$id_user'","now()","'$id_user'","'$id_message_type'","'$co_id_from'","'$co_id_to'")) . ')';
					}
				}
				else
				{
					$s[] = '(' . implode(', ',array("'$from_owner'","'$from_o_type'","'$to_owner'","'$to_o_type'","'$name_escape'","'$value_escape'","now()","'$id_user'","now()","'$id_user'","'$id_message_type'","NULL","NULL")) . ')';
				}

				$s = "INSERT INTO `message` (`sender_owner`, `sender_owner_type`, `recipient_owner`,`recipient_owner_type`, `name`, `value`, `last_edit_datetime`,`last_edit_user`,`create_datetime`, `create_user`, `id_message_type`,`sender_contact_item`,`recipient_contact_item`) VALUES " . implode(",", $s);

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', "$id_message_type: database insert failed");

				$id_message = insert_id();
				$out['m_id'] = $id_message;

				if ($id_message_type == 1)
				{
					if (!empty($co_ids))
					{
						$s = array();
						foreach($co_ids as $val_arr)
						{
							$co_id_from = $val_arr[0];
							$co_id_to = $val_arr[1];
							$s[] = "('$id_message','$co_id_from', '$co_id_to')";
						}
						$s = "INSERT INTO `message_contact_items` (`id_message`, `sender_contact_item`, `recipient_contact_item`) VALUES " . implode(",", $s);

						query($s);
						if ($q === false) return $this->showError('404', 'error', 'insert failed');
					}
				}
				elseif (!empty($id_message_type_prev))
				{
					$q = query("COMMIT");
					if ($q === false) return $this->showError('404', 'error', 'm_type 3,4: commit query failed');
				}
			}
			else
			{
				if ($id_message_type == 3 || $id_message_type == 4) 
				{
					$msg = array('3'=>'opened','4'=>'closed');
					$s = "SELECT 
							`message`.`id_message_type`
						FROM `message`
						WHERE
							`message`.`id_message_type` in (3,4) AND `message`.`sender_owner_type`= '$from_o_type' AND `message`.`sender_owner`= '$from_owner' AND `message`.`recipient_owner_type`= '$to_o_type' AND `message`.`recipient_owner`= '$to_owner' AND `message`.`active_status` = 1
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', "select status $id_message_type failed");
					
					$d = fetch_assoc($q);
					if (isset($d['id_message_type']))
					{
						if ($d['id_message_type'] == $id_message_type) return $this->showError('404', 'error', "correspondence already {$msg[$id_message_type]}");
						$id_message_type_prev = $d['id_message_type'];
					}

					if (isset($id_message_type_prev))
					{
						$q = query("BEGIN");
						if ($q === false) return $this->showError('404', 'error', 'm_type 3,4: begin query failed');

						$s = "UPDATE `message`
							SET
								`active_status` = 0
							WHERE
								`message`.`id_message_type` = $id_message_type_prev AND `message`.`sender_owner_type`= '$from_o_type' AND `message`.`sender_owner`= '$from_owner' AND `message`.`recipient_owner_type`= '$to_o_type' AND `message`.`recipient_owner`= '$to_owner' AND `message`.`active_status` = 1
							";

						$q = query($s);
						if ($q === false) return $this->showError('404', 'error', 'm_type 3,4: update failed');
					}

					$s = "INSERT INTO `message`
						SET 
							`sender_owner` = '$from_owner',
							`sender_owner_type` = '$from_o_type',
							`recipient_owner` = '$to_owner',
							`recipient_owner_type` = '$to_o_type',					
							`last_edit_datetime` = now(),
							`last_edit_user` = '$id_user',
							`create_datetime` = now(),
							`create_user` = '$id_user',
							`id_message_type` = '$id_message_type'
						";

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', 'm_type 3,4: insert failed');

					$id_message = insert_id();
					$out['m_id'] = $id_message;

					if (isset($id_message_type_prev))
					{
						$q = query("COMMIT");
						if ($q === false) return $this->showError('404', 'error', 'm_type 3,4: commit query failed');
					}
				}
				else
				{
					return $this->showError('404', 'error', 'unknown m_type');
				}
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}

		private function parseOwnerFromTo($from_to = '', $owner_types = false)
		{
			$from_to = json_decode($from_to,true);
			
			if (empty($from_to) || !is_array($from_to)) 
			{
				return array('error' => 'wrong from_to');
			}
			if (!isset($from_to[0]) || !isset($from_to[1])) array('error' => 'empty from or to');
			if (is_array($from_to[0]))
			{
				if (!isset($from_to[0][0])) return array('error' => 'empty from');
				$from_owner = $from_to[0][0];
				if (isset($from_to[0][1]))
				{
					$from_o_type = $from_to[0][1];
				}
				else
				{
					$from_o_type = 1;
				}
			}
			else
			{
				$from_owner = $from_to[0];
				$from_o_type = 1;
			}
			if (is_array($from_to[1]))
			{
				if (!isset($from_to[1][0])) return array('error' => 'empty to');
				$to_owner = $from_to[1][0];
				if (isset($from_to[1][1]))
				{
					$to_o_type = $from_to[1][1];
				}
				else
				{
					$to_o_type = 1;
				}
			}
			else
			{
				$to_owner = $from_to[1];
				$to_o_type = 1;
			}
			$res = array($from_owner,$from_o_type,$to_owner,$to_o_type);
			if ($owner_types !== false) 
			{
				if (empty($owner_types[$from_o_type]) || empty($owner_types[$to_o_type])) return array('error' => 'from_o_type or to_o_type not found');
				$owner_types = array($from_o_type=>$owner_types[$from_o_type]);
				$res[] = $owner_types;
			}
			return $res;
		}

		private function parseOwnerAvailable($id_user = '', $owner_types = array())
		{
			$sql_where_simple = array();
			$sql_table = array();
			$sql_raw = array();
			foreach($owner_types as $o_type=>$owner_type)
			{
				$table = $owner_type['table'];
				$column = $owner_type['column'];
				$sql = $owner_type['sql'];
				$delimiter = $owner_type['delimiter'];
				$owner = false;
				if ($table !== NULL && $table !== "" && $column!== NULL && $column!== "")
				{
					if ($table == 'users')
					{
						if ($column == 'id_user')
						{
							$owner = $id_user;
						}
						elseif ($column == 'id_role')
						{
							$owner = $this->id_role;
						}
						elseif (array_key_exists($column,$_SESSION))
						{
							$owner = $_SESSION[$column];	
						}
						if ($owner !== false)
						{
							$sql_where_simple[] = array($o_type,$owner);
							continue;
						}
					}
					$sql_table[$table][] = array($o_type,$column,$delimiter);
				}
				else
				{		
					if ($sql === NULL) continue;
					$sql = str_replace('{$id_user}',$id_user,$sql);
					$sql_raw[] = array($o_type,$sql);
				}
			}

			$sql_union = array();
			$j = 0;
			foreach($sql_table as $table=>$value)
			{
				$field_len = count($value);
				$sql_field_case_type = $sql_field_case_owner = $sql_field_add = array();
				$i = 0;
				foreach($value as $val)
				{
					$i++;
					$o_type = $val[0];
					$column = $val[1];
//					$delimiter = $val[3] === NULL ? ',' : $val[3];
//					$delimiter = real_escape_string($delimiter);
					$sql_field_case_type[] = "WHEN $i THEN '$o_type'";
					$sql_field_case_owner[] = "WHEN $i THEN ow.`$column`";
					$sql_field_add[] = "GROUP_CONCAT(`$column` SEPARATOR 0x00) as '$column'";
				}
				$sql_field_case_type = implode("\n",$sql_field_case_type);
				$sql_field_case_owner = implode("\n",$sql_field_case_owner);
				$sql_field_add = implode(',',$sql_field_add);
				$sql_union[] = "SELECT			
						(CASE @i$j:=@i$j + 1
							$sql_field_case_type
						END) as o_type,
						(CASE @i$j
							$sql_field_case_owner
						END) as owner
				FROM `technical_counter`, 
					 (SELECT
							$sql_field_add
						FROM
							`$table`
						WHERE
							`id_user` = $id_user
						GROUP BY
							`id_user`
					  ) ow, 
					(select @i$j:=0) count
				WHERE	
					`technical_counter`.`id_technical_counter` <= $field_len
				";
				$j++;
			}
			foreach($sql_raw as $val)
			{
				$o_type = $val[0];
				$sql = $val[1];
				$sql_union[] = "SELECT			
						$o_type as o_type,
						ow.owner
				FROM ($sql) ow
				";
			}
			if (!empty($sql_union))
			{
				$s = implode(' UNION ',$sql_union);

				$q = query($s);
				if ($q === false) return array('error' => 'parse owner: select failed');
				
				while ($d = fetch_assoc($q))
				{
					$o_type = $d['o_type'];
					$owner = $d['owner'];
					if ($owner === NULL) continue;
					$owner_temp = explode(chr(0),$owner);
					if (count($owner_temp) > 1)
					{
						sort($owner_temp);
						$delimiter = $owner_types[$o_type]['delimiter'] === NULL ? ',' : $owner_types[$o_type]['delimiter'];
						$owner = implode($delimiter,$owner_temp);
					}
					$sql_where_simple[] = array($o_type,$owner);
				}
			}
			$available_owner = array();
			$sql_where_owner = array();
			$sql_where_from = array();
			$sql_where_to = array();
			foreach($sql_where_simple as $val)
			{
				$o_type = $val[0];
				$owner = $val[1];
				$from_str = "(`message`.`sender_owner_type` = $o_type AND `message`.`sender_owner` = '$owner')";
				$to_str = "(`message`.`recipient_owner_type` = $o_type AND `message`.`recipient_owner` = '$owner')";
				$sql_where_owner[] = "$from_str OR $to_str";
				$sql_where_from[] = $from_str;
				$sql_where_to[] = $to_str;
				$available_owner[$o_type][$owner] = true;
			}

			$sql_where_owner = implode(' OR ',$sql_where_owner);
			$sql_where_owner = "($sql_where_owner)";		
			$sql_where_from = implode(' OR ',$sql_where_from);	
			$sql_where_to = implode(' OR ',$sql_where_to);

			return array(false,$available_owner,$sql_where_owner,$sql_where_from,$sql_where_to);
		}

		private function parseOwnerExists($id_owner_type = '', $owner = '', $owner_types = array(), $roles = array())
		{
			$owner = (string)$owner;
			if ($id_owner_type == 1)
			{
				$s = "SELECT
						`id_user`
					FROM
						`users`
					WHERE
						`id_user` = '$owner'
				";

				$q = query($s);
				if ($q === false) return array('error'=>'parse o_type 1: select failed');	
				$d = fetch_assoc($q);
				if (empty($d['id_user']))
				{
					return false;
				}
				else
				{
					return true;
				}
			}
			elseif ($id_owner_type == 2)
			{
				return isset($roles[$owner]);
			}
			return true;
			foreach($owner_types as $o_type=>$owner_type)
			{
				if ($o_type != $id_owner_type) continue;
				$table = $owner_type['table'];
				$column = $owner_type['column'];
				$sql = $owner_type['sql'];
				$owner = false;
				if ($table !== NULL && $table !== "" && $column!== NULL && $column!== "")
				{
					$delimiter = $owner_type['delimiter'] === NULL ? ',' : $owner_type['delimiter'];
					$delimiter = real_escape_string($delimiter);
					$s = "SELECT
							GROUP_CONCAT(`column` SEPARATOR '$delimiter') as owner
						FROM
							`$table`
						GROUP BY
							`id_user`
						ORDER BY
							`column`
					";

					$q = query($s);
					if ($q === false) return array('error'=>'parse owner exist: select failed');	
					while ($d = fetch_assoc($q))
					{
						if ($d['owner'] === $owner) return true;
					}
					
					$d = fetch_assoc($q);
					if (!empty($d['owner'])) return true;
				}
				else
				{		
					if ($sql === NULL) continue;
					$s = preg_replace('/in\s+\(\{\$id_user\}\)/i','is not NULL',$sql);

					$q = query($s);
					if ($q === false) return array('error'=>'parse owner exist: select for sql failed');		
					while ($d = fetch_assoc($q))
					{
						if ($d['owner'] === $owner) return true;
					}
				}
				break;
			}
			return false;
		}

		public function readMessage($id_message = NULL, $owner_types = array())
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if (empty($id_message)) return $this->showError('404', 'error', 'empty m_id');

			$id_user = $_SESSION[UID];

			$s = "SELECT 
				  `message`.`id_message` as m_id,
				  `message`.`sender_owner` as from_owner,
				  `message`.`sender_owner_type` as from_o_type,
				  `message`.`recipient_owner` as to_owner,
				  `message`.`recipient_owner_type` as to_o_type,
				  `message`.`unread`,
					(SELECT
						`messages_read`.`read`
					 FROM `messages_read`
					 WHERE `messages_read`.`id_message` = `message`.`id_message` AND `messages_read`.`id_user` = '$id_user'
					) as 'read'
				FROM `message`
				WHERE
					`message`.`id_message` in ($id_message)
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'select failed');

			$id_message_arr = explode(',',$id_message);
			if (mysqli_num_rows($q) != count($id_message_arr)) return $this->showError('404', 'error', 'message not found');
			$message_unread_any = array();
			$message_unread_user = array();
			$owner_types_filtered = array();
			$owner = array();
			while ($d = fetch_assoc($q))
			{
				$owner_types_filtered[$d['to_o_type']] = $owner_types[$d['to_o_type']];
				$owner[] = array($d['to_o_type'],$d['to_owner']);
				if (!empty($d['unread'])) $message_unread_any[] = $d['m_id'];
				if (empty($d['read'])) $message_unread_user[] = $d['m_id'];
			}

			if (empty($message_unread_user) && empty($message_unread_any)) return $this->showError('404', 'error', 'message already read');

			list($error,$available_owner,$sql_where_owner,$sql_where_from,$sql_where_to) = array_pad($this->parseOwnerAvailable($id_user,$owner_types_filtered),5,'');
			if (!empty($error)) return $this->showError('404', 'error', $error);
			foreach($owner as $arr)
			{
				if (empty($available_owner[$arr[0]][$arr[1]])) return $this->showError('404', 'error', 'forbidden to_owner');
			}
	
			if (!empty($message_unread_any))
			{
				$s = "UPDATE `message`
					SET
						`message`.`unread` = 0
					WHERE
						`message`.`id_message` in (" . implode(',',$message_unread_any) . ")
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'update failed');
			}

			if (!empty($message_unread_user))
			{
				$s = array();
				foreach($message_unread_user as $m_id)
				{
					$s[] = "('$m_id','$id_user', now())";
				}
				$s = "INSERT INTO `messages_read` (`id_message`, `id_user`, `read`) VALUES " . implode(",", $s);

				query($s);
				if ($q === false) return $this->showError('404', 'error', 'insert failed');	
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		private function createPriceTimeFunctionData($d = array(), $price_time_functions = array())
		{
			if (empty($d['price_time_function']))
			{
				if (!empty($d['sc_price_time_function']))
				{
					$price_time_function = "table__price_time_function__formula__{$d['sc_price_time_function']}";
					if (empty($price_time_functions[$d['sc_price_time_function']])) return array();
					$price_time_function_need = $price_time_functions[$d['sc_price_time_function']]['need'];
				}
			}
			else
			{
					$price_time_function = "table__price_time_function__formula__{$d['price_time_function']}";
					if (empty($price_time_functions[$d['price_time_function']])) return array();
					$price_time_function_need = $price_time_functions[$d['price_time_function']]['need'];
			}
			if (isset($price_time_function))
			{
				$res = array('price_time_function' => $price_time_function);
				$var = array();
				$create_datetime = date_create($d['t_create_datetime']);
				$sc_datetime = date_create($d['sc_datetime']);
				$now_datetime = new DateTime('now', new DateTimeZone(MYSQL_TIME_ZONE));
				$ib = date_diff($sc_datetime,$now_datetime);
				$se = date_diff($sc_datetime,$create_datetime);
				if (isset($price_time_function_need['dp'])) $res['dp'] = true;
				$ib_s = $ib->s;
				$ib_m = $ib->i;
				$ib_h = $ib->h;
				$ib_d = $ib->days;
				$ib_M = $ib->m;
				$ib_y = $ib->y;
				$se_s = $se->s;
				$se_m = $se->i;
				$se_h = $se->h;
				$se_d = $se->days;
				$se_M = $se->m;
				$se_y = $se->y;
				if (isset($price_time_function_need['ibh']))
				{
					$var['ibh'] = $ib_d * 24 + $ib_h;
				}
				if (isset($price_time_function_need['ibm']))
				{
					$var['ibm'] = $ib_d * 24 * 60 + $ib_h * 60 + $ib_m;
				}
				if (isset($price_time_function_need['ibs']))
				{
					$var['ibs'] = $ib_d * 24 * 60 * 60 + $ib_h * 60 * 60 + $ib_m * 60 + $ib_s;
				}
				if (isset($price_time_function_need['ibd']))
				{
					$var['ibd'] = $ib_d;
				}
				if (isset($price_time_function_need['ibM']))
				{
					$var['ibM'] = $ib_y * 12 + $ib_M;
				}
				if (isset($price_time_function_need['iby']))
				{
					$var['iby'] = $ib_y;
				}
				if (isset($price_time_function_need['seh']))
				{
					$var['seh'] = $se_d * 24 + $se_h;
				}
				if (isset($price_time_function_need['sem']))
				{
					$var['sem'] = $se_d * 24 * 60 + $se_h * 60 + $se_m;
				}
				if (isset($price_time_function_need['ses']))
				{
					$var['ses'] = $se_d * 24 * 60 * 60 + $se_h * 60 * 60 + $se_m * 60 + $se_s;
				}
				if (isset($price_time_function_need['sed']))
				{
					$var['sed'] = $se_d;
				}
				if (isset($price_time_function_need['seM']))
				{
					$var['seM'] = $se_y * 12 + $se_M;
				}
				if (isset($price_time_function_need['sey']))
				{
					$var['sey'] = $se_y;
				}
				$res['var'] = $var;
				return $res;
			}
			else
			{
				return array();
			}
		}

		public function createTask($data = '')
		{	
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(
				'min_action_interval'	=>		array(
										'name'	=>	'min_action_interval',
										'NULL'	=>	false
									),
				'max_action_interval'	=>		array(
										'name'	=>	'max_action_interval',
										'NULL'	=>	false
									),
				'comment'	=>		array(
										'name'	=>	'comment',
										'NULL'	=>	false
									),
				'account'	=>	array(
										'name'	=>	'account',
										'NULL'	=>	false
									),
				'json'	=>		array(
										'name'	=>	'json',
										'NULL'	=>	false
									),
				'active'	=>		array(
										'name'	=>	'active',
										'NULL'	=>	false,
										'format'=>	function($val){return empty($val) ? 0 : 1;}
									),							
				'bind_account'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'task_list_account',
												'key'	=>	'id_account'
											),
				'bind_comment'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'task_list_comment',
												'key'	=>	'id_task_comment'
											),
				'bind_action_function'	=>		array(
												'name'	=>	NULL,
												'NULL'	=>	true,
												'table'	=>	'task_list_action_function',
												'allowed_fields'=>	array(
													'task_action_function'	=>	array(
																		'name'	=>	'id_task_action_function',
																		'NULL'	=>	false
																	),
													'parameter'	=>	array(
																		'name'	=>	'parameter',
																		'NULL'	=>	false,
																		/*'format'=>	function($val,$id_val){
																			return array(
																				'formated'	=>	str_replace(array(chr(0),chr(1),chr(2)),' ',$val)
																			);
																		}*/
																	)
												)
											)
			);

			$forbidden_fields = array();
			$affected_fields = array();
			$filtered_data = array();
			$add_table_list = array();
			foreach ($data as $key => $value)
			{
				if (isset($allowed_fields[$key]))
				{
					if (!empty($allowed_fields[$key]['format']))
					{
						$value = $allowed_fields[$key]['format']($value);
					}
					if (empty($value['error']))
					{
						if ($allowed_fields[$key]['name'] === NULL)
						{
							$add_table_list[] = array(
								$allowed_fields[$key]['table'],
								empty($allowed_fields[$key]['key']) ? array() : $allowed_fields[$key]['key'],
								$value,
								$key,
								empty($allowed_fields[$key]['allowed_fields']) ? array() : $allowed_fields[$key]['allowed_fields'],
								empty($data['exact']) ? false : true
							);
						}
						else
						{									
							$name = $allowed_fields[$key]['name'];
							$null_on = $allowed_fields[$key]['NULL'];
							if ($null_on === true || $value !== NULL)
							{
								$affected_fields[] = $key;
								$filtered_data[$name] = $value;
							}
							else
							{
								return $this->showError('404', 'error', "$key: null value");
							}
						}
					}
					else
					{
						return $this->showError('404', 'error', "$key: {$value['error']}");
					}
				}
				else
				{
					$forbidden_fields[] = $key;
				}
			}

			$s = array();
			$filtered_data['id_task_status'] = 1;
			foreach ($filtered_data as $key => $value)
			{
				$s[] = "`$key` = " 
					 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
			}

			$q = query("BEGIN");
			if ($q === false) return $this->showError('404', 'error', 'begin query failed');

			$s = "INSERT INTO `task_list`
				SET 
					" . implode(",\n", $s) ."
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database insert failed');

			$id_val = $id_task_list = insert_id();
			$id_key = 'id_task_list';

			foreach($add_table_list as $id_list)
			{
				if (!is_array($id_list[2])) return $this->showError('404', 'error', "{$id_list[3]} : wrong data");
				$s = array();
				$list_table = $id_list[0];
				if (empty($id_list[1])){
					if (empty($id_list[4])) continue;
					if (!empty($id_list[5]))
					{
						$s_d = "DELETE
							FROM `" . $list_table . "`
							WHERE 
								`" . $id_key . "` = '" . $id_val . "'
							";
						$q = query($s_d);
			
						if ($q === false) return $this->showError('404', 'error', "{$id_list[3]}: database delete failed");
					}
					$allowed_fields = $id_list[4];
					$forbidden_fields_inner = array();
					$affected_fields_inner = array();
					foreach ($id_list[2] as $j=>$d_arr)
					{	
						$filtered_data = array();
						$sql_if = array();
						foreach ($d_arr as $key => $value)
						{
							if (isset($allowed_fields[$key]))
							{
								$affected_fields_inner[$j][] = $key;
								if (!empty($allowed_fields[$key]['format']))
								{
									$value = $allowed_fields[$key]['format']($value,$id_val);
								}
								if (empty($value['error']))
								{
									$name = $allowed_fields[$key]['name'];
									$null_on = $allowed_fields[$key]['NULL'];
									if ($null_on === true || $value !== NULL)
									{
										$filtered_data[$name] = $value;
									}
									else
									{
										return $this->showError('404', 'error', "{$id_list[3]} $key: null value");
									}
								}
								else
								{
									return $this->showError('404', 'error', "{$id_list[3]} $j $key: {$value['error']}");
								}
							}
							else
							{
								$forbidden_fields_inner[$j][] = $key;
							}
						}

						$s = array();
						foreach ($filtered_data as $key => $value)
						{
							$s[] = "`" . $key . "` = " 
								 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
						}
						$s = implode(",", $s);
						if (!empty($s)) $s = ", $s";
						$s = "`" . $id_key . "` = '" . $id_val . "'" . $s;

						if (empty($id_list[5]))
						{
							$s = "INSERT INTO `" . $list_table . "`
								SET 
									" . $s . " ON DUPLICATE KEY UPDATE " . $s . "
								";

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', "{$id_list[3]} $j: insert update failed");
						}
						else
						{
							$s = "INSERT INTO `" . $list_table . "`
								SET 
									" . $s ."
								";

							$q = query($s);
							if ($q === false) return $this->showError('404', 'error', "{$id_list[3]} $j: insert failed");	
						}
					}
					if (!empty($affected_fields_inner)) $affected_fields[] = array($id_list[3]=>$affected_fields_inner);
					if (!empty($forbidden_fields_inner)) $forbidden_fields[] = array($id_list[3]=>$forbidden_fields_inner);
				}
				else
				{
					$id_list_key = $id_list[1];
					if (!empty($id_list[5]))
					{
						$s_d = "DELETE
							FROM `" . $list_table . "`
							WHERE 
								`" . $id_key . "` = '" . $id_val . "'
							";
						$q = query($s_d);
			
						if ($q === false) return $this->showError('404', 'error', " {$id_list[3]} : list delete failed ");
					}
					foreach ($id_list[2] as $id_item)
					{
						$s[] = "('" . $id_item . "', '" . $id_val . "')";
					}
					$s = "INSERT IGNORE INTO `" . $list_table . "` (`" . $id_list_key . "`,`" . $id_key . "`) VALUES " . implode(",", $s);

					$q = query($s);
					if ($q === false) return $this->showError('404', 'error', "{$id_list[3]} : list insert failed");
					$affected_fields[] = $id_list[3];
				}
			}

			$q = query("COMMIT");
			if ($q === false) return $this->showError('404', 'error', 'commit query failed');

			$out = array('affected_fields' 	=> 	$affected_fields);
			if (!empty($forbidden_fields)) $out['forbidden_fields'] = $forbidden_fields;
			$out['tl_id'] = $id_task_list;

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',
				'data' 		=>	$out
			);
		}
		
		public function controlTask($id_task_list = '', $id_task_action_control = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

			if (empty($id_task_list)) return $this->showError('404', 'error', 'empty tl_id');

			if (empty($id_task_action_control)) return $this->showError('404', 'error', 'empty action');
			
			$s = "INSERT INTO `task_list_action_control`
				SET 
				  `id_task_list` = '$id_task_list',
				  `id_task_action_control` = '$id_task_action_control',
				  `last_edit_timestamp` = now(),
				  `create_timestamp` = now(),
				  `last_edit_datetime` = now(),
				  `create_datetime` = now()
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', "insert failed");	

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function selectTask($id_task_list = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

			$sql_where = '1 = 1';
			if (!empty($id_task_list))
			{
				$sql_where = "`id_task_list` in ($id_task_list)";
			}
			$s = "SELECT 
				  `id_task_list` as tl_id,
				  `id_task_status` as task_status,
				  `min_action_interval`,
				  `max_action_interval`,
				  `comment`,
				  `account`,
				  `json`,
				  `active`,
				  `last_edit_datetime` as tl_edited,
				  `create_datetime` as tl_created,	  
				 (SELECT
					GROUP_CONCAT(`id_account` SEPARATOR ',')
				  FROM `task_list_account`
				  WHERE `task_list_account`.`id_task_list` = `task_list`.`id_task_list`
				 ) as bind_account,
				 (SELECT
					GROUP_CONCAT(`id_task_comment` SEPARATOR ',')
				  FROM `task_list_comment`
				  WHERE `task_list_comment`.`id_task_list` = `task_list`.`id_task_list`
				 ) as bind_comment, 
				(SELECT
					IF(`id_task_action_function` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS(0x00,
								`id_task_action_function`,
								`parameter`
							)
						SEPARATOR 0x01)
					)
				 FROM `task_list_action_function`
				 WHERE `task_list_action_function`.`id_task_list` = `task_list`.`id_task_list`
				) as bind_action_function,	
				(SELECT
					IF(`id_task_action_control` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS(0x00,
								`id_task_action_control`,
								UNIX_TIMESTAMP(`create_timestamp`),
								`complete`,
								`active`
							)
						SEPARATOR 0x01)
					)
				 FROM `task_list_action_control`
				 WHERE `task_list_action_control`.`id_task_list` = `task_list`.`id_task_list`
				) as bind_action_control
			FROM `task_list`
			WHERE
				$sql_where
			LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
			";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'select failed');

			$out = array('task list' => array());
			while ($d = fetch_assoc($q))
			{
				$d['comment'] = json_decode($d['comment'],true);
				$d['account'] = json_decode($d['account'],true);
				$d['json'] = json_decode($d['json'],true);
				add_time_zone($d['tl_edited']);
				add_time_zone($d['tl_created']);
				if (!empty($d['bind_account'])) $d['bind_account'] = explode(',',$d['bind_account']);
				if (!empty($d['bind_comment'])) $d['bind_comment'] = explode(',',$d['bind_comment']);
				if (!empty($d['bind_action_function']))
				{
					$d['bind_action_function'] = explode(chr(1),$d['bind_action_function']);
					foreach ($d['bind_action_function'] as $key=>$value)
					{
						$d['bind_action_function'][$key] = array();
						list(
							$d['bind_action_function'][$key]['task_action_function'],
							$d['bind_action_function'][$key]['parameter']
						)= explode(chr(0),$value);
						$d['bind_action_function'][$key]['parameter'] = json_decode($d['bind_action_function'][$key]['parameter'],true);
					}
				}
	
				if (!empty($d['bind_action_control']))
				{
					$d['bind_action_control'] = explode(chr(1),$d['bind_action_control']);
					foreach ($d['bind_action_control'] as $key=>$value)
					{
						$d['bind_action_control'][$key] = array();
						list(
							$d['bind_action_control'][$key]['task_action_control'],
							$d['bind_action_control'][$key]['unix_timestamp_created'],
							$d['bind_action_control'][$key]['complete'],
							$d['bind_action_control'][$key]['active']
						)= explode(chr(0),$value);
					}
				}

				$out['task list'][$d['tl_id']] = $d;
			}
			if (empty($this->associativeArray)) $out['task list'] =  array_values($out['task list']);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out
			);
		}
		
		public function addTaskLog($data = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

			if (empty($data)) 
			{
				return $this->showError('404', 'error', 'empty data');
			}

			$data = json_decode($data,true);
			
			if (empty($data) || !is_array($data)) 
			{
				return $this->showError('404', 'error', 'wrong data');
			}

			$allowed_fields = array(
				'tl_id'	=>		array(
										'name'	=>	'id_task_list',
										'NULL'	=>	false
									),
				'account'	=>		array(
										'name'	=>	'id_account',
										'NULL'	=>	true
									),
				'task_comment'	=>		array(
										'name'	=>	'id_task_comment',
										'NULL'	=>	true
									),
				'task_action_function'	=>	array(
										'name'	=>	'id_task_action_function',
										'NULL'	=>	true
									),
				'task_action'	=>		array(
										'name'	=>	'id_task_action',
										'NULL'	=>	true
									),
				'task_action_control'	=>		array(
										'name'	=>	'id_task_action_control',
										'NULL'	=>	true
									),
				'custom_comment'	=>		array(
										'name'	=>	'comment',
										'NULL'	=>	true
									),
				'custom_account'	=>	array(
										'name'	=>	'account',
										'NULL'	=>	true
									),
				'send_account'	=>		array(
										'name'	=>	'send_account',
										'NULL'	=>	true
									),
				'json'	=>		array(
										'name'	=>	'json',
										'NULL'	=>	false
									)
			);

			$forbidden_fields = array();
			$affected_fields = array();
			$filtered_data = array();
			$add_table_list = array();
			foreach ($data as $key => $value)
			{
				if (isset($allowed_fields[$key]))
				{
					$affected_fields[] = $key;
					if (!empty($allowed_fields[$key]['format']))
					{
						$value = $allowed_fields[$key]['format']($value);
					}
					if (empty($value['error']))
					{								
						$name = $allowed_fields[$key]['name'];
						$null_on = $allowed_fields[$key]['NULL'];
						if ($null_on === true || $value !== NULL)
						{
							$filtered_data[$name] = $value;
						}
						else
						{
							return $this->showError('404', 'error', "$key: null value");
						}
					}
					else
					{
						return $this->showError('404', 'error', "$key: {$value['error']}");
					}
				}
				else
				{
					$forbidden_fields[] = $key;
				}
			}

			if (empty($filtered_data)) return $this->showError('404', 'error', 'allowed data not found');

			if (empty($filtered_data['id_task_list'])) return $this->showError('404', 'error', 'empty tl_id');

			$s = array();
			foreach ($filtered_data as $key => $value)
			{
				$s[] = "`$key` = " 
					 . ($value === NULL ? "NULL" : "'" . real_escape_string(is_array($value) ? json_encode($value) : $value) . "'");
			}

			$s = "INSERT INTO `task_list_log`
				SET 
					" . implode(",\n", $s) .",
				  `last_edit_timestamp` = now(),
				  `create_timestamp` = now(),
				  `last_edit_datetime` = now(),
				  `create_datetime` = now()
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'insert failed');

			$out = array('affected_fields' 	=> 	$affected_fields);
			if (!empty($forbidden_fields)) $out['forbidden_fields'] = $forbidden_fields;

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}
		
		public function getTaskLog($id_task_list = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

			if (empty($id_task_list)) return $this->showError('404', 'error', 'empty tl_id');

			$s = "SELECT 
				`id_task_list` as tl_id,
				`id_account` as account,
				`id_task_comment` as task_comment,
				`id_task_action_function` as task_action_function,
				`id_task_action` as task_action,
				`id_task_action_control` as task_action_control,
				`comment` as custom_comment,
				`account` as custom_account,
				`send_account`,
				`json`,
				`last_edit_timestamp` as timestamp_edited,
				`create_timestamp` as timestamp_created,
				UNIX_TIMESTAMP(`last_edit_timestamp`) as unix_timestamp_edited,
				UNIX_TIMESTAMP(`create_timestamp`) as unix_timestamp_created,
				`last_edit_datetime` as edited,
				`create_datetime` as created
			FROM `task_list_log`
			WHERE
				`id_task_list` = '$id_task_list'
			ORDER BY `create_datetime` 
			";
			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'select failed');

			$out = array('log' => array());
			while ($d = fetch_assoc($q))
			{
				if(!empty($d['custom_account'])) $d['custom_account'] = json_decode($d['custom_account'],true);
				if(!empty($d['send_account'])) $d['send_account'] = json_decode($d['send_account'],true);
				$d['json'] = json_decode($d['json'],true);
				add_time_zone($d['timestamp_edited']);
				add_time_zone($d['timestamp_created']);
				add_time_zone($d['edited']);
				add_time_zone($d['created']);
				$out['log'][] = $d;
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out
			);
		}

		public function setTaskStatus($id_task_list = '', $from_status = '', $to_status = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if ($this->id_role != 4) return $this->showError('404', 'error', 'not enough rights');

			if (empty($id_task_list)) return $this->showError('404', 'error', 'empty tl_id');
			$sql_where = "`id_task_list` = '$id_task_list'";

			if (!empty($from_status))
			{
				$sql_where .= " AND `id_task_status` = '$from_status'";
			}
			if (empty($to_status)) return $this->showError('404', 'error', 'empty to_status');
			
			$s = "UPDATE `task_list`
				SET
					`id_task_status` = '$to_status'
				WHERE
					$sql_where AND `active` = 1
				";

			$q = query($s);
			$update = affected_rows();
			if ($update === -1) 
			{
				return $this->showError('400','error','update failed'. error_db());
			}
			elseif ($update === 0) 
			{
				return $this->showError('400','error','modified data not found');
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function moveCart($item = '', $id_user = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}

			if (empty($id_user)) return $this->showError('404', 'error', 'empty u_id');
			if ($id_user == $_SESSION[UID])  return $this->showError('404', 'error', 'try to move yourself');

			if (empty($item))
			{
				$sql_where = '';
			}
			else
			{
				$sql_where = array();
				@$item = json_decode($item,true);
				if (empty($item) || !is_array($item)) 
				{
					return $this->showError('404', 'error', 'wrong item data');
				}
				foreach($item as $product=>$property)
				{
					$str = "(`product` = '$product' AND `property` in ";
					if (is_array($property))
					{
						$property = implode("','",$property);
					}
					$property = "(SELECT
										`id_trip_seat`
									FROM `ticket`
									WHERE 
										`id_trip` = '" . $product . "' AND `id_seat` in ('" . $property . "'))";
					$str .= "$property)";
					$sql_where[] = $str;
				}
				$sql_where = " AND (" . implode(" OR ",$sql_where) . ")";
			}

			$s = "UPDATE `cart`
				SET
					`id_user` = '$id_user'
				WHERE
					`id_user` = '" . $_SESSION[UID] . "'$sql_where
				";

			$q = query($s);
				
			$update = affected_rows();
			if ($update === -1) 
			{
				return $this->showError('400','error','update failed'. error_db());
			}
			elseif ($update === 0) 
			{
				return $this->showError('400','error','modified data not found');
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public $appUrl = '';
		
		private function getTripCurrencyString0($currency, $seat_currency)
		{
			return $seat_currency !== chr(2) ? " $seat_currency" : '';
		
		}

		private function getTripCurrencyString10($currency, $seat_currency)
		{
			return $seat_currency !== chr(2) ? " $seat_currency" : " $currency";
		}

		private function getTripCurrencyString11($currency, $seat_currency)
		{
			return " $currency";
		}

		public function deleteDropboxFile($id_dropbox_link = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if (empty($id_dropbox_link)) 
			{
				return $this->showError('404', 'error', 'empty dl_id');
			}

			$s = "SELECT
					`id_dropbox_link`,
					`json`,
					`deleted`,
					IF(`deleted` = 0,(
						SELECT
							`id_user`
						FROM
							`users_dropbox_link`
						WHERE
							`users_dropbox_link`.`id_dropbox_link` = `dropbox_link`.`id_dropbox_link` AND `owner` = '1'
					),'') as user
				FROM `dropbox_link` 				
				WHERE	
					`id_dropbox_link` = '" . $id_dropbox_link  . "'
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');

			$d = fetch_assoc($q);
			if (empty($d['id_dropbox_link'])) return $this->showError('404', 'error', 'dropbox link not found');
			if (!empty($d['deleted'])) return $this->showError('404', 'error', 'dropbox file already deleted');
			if ($this->id_role != 4 && $d['user'] != $_SESSION[UID]) return $this->showError('404', 'error', 'not enough rights');
			$json = json_decode($d['json'],true);
			
			$response = delete_from_dropbox($id_dropbox_link);
			if (!empty($response['error'])) return $this->showError('404', 'error', $response['error']);
			$json['response_del'] = $response['data'];
			$json['owner'] = $d['user'];

			$s = "DELETE
				FROM `users_dropbox_link`
				WHERE 
					`id_dropbox_link` = ' $id_dropbox_link'
				";
			$q = query($s);

			if ($q === false) return $this->showError('404', 'error', 'delete failed');
			
			$s = "UPDATE `dropbox_link`
				SET
					`json` = '" . real_escape_string(json_encode($json)) . "',
					`deleted` = 1
				WHERE
					`id_dropbox_link` = '" . $id_dropbox_link . "'
				";

			$q = query($s);

			$qs = affected_rows();
			if ($qs === -1) 
			{
				$warning = 'update query failed';
			}
			elseif ($qs === 0) 
			{
				$warning = 'modified data not found for query';
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success'
			);
		}

		public function getDropboxFileData($id_dropbox_link = '', $private = '', $deleted = '')
		{
			if ($id_dropbox_link == 'null') $id_dropbox_link = NULL;
			if (empty($_SESSION[UID]))
			{
				$sql_where = '1 = 1';
				if (!empty($id_dropbox_link))
				{
					$sql_where .= " AND `id_dropbox_link` in ($id_dropbox_link)";
				}
				$s = "SELECT
						`id_dropbox_link` as dl_id,
						`json`
					FROM `dropbox_link` 				
					WHERE	
						$sql_where AND `private` = '-1' AND `deleted` = 0
					ORDER BY `id_dropbox_link`
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select failed');

				$out = array('dropbox files' => array());
				while ($d = fetch_assoc($q))
				{
					$d['json'] = json_decode($d['json'],true);
					$d['json'] = array(
								'name' 			=> $d['json']['name'], 
								'name_upload' 	=> $d['json']['name_upload'], 
								'type' 			=> $d['json']['type'], 
								'size' 			=> $d['json']['size']
					);
/*					unset($d['json']['response']);
					unset($d['json']['response_del']);
					unset($d['json']['owner']);*/
					$out['dropbox files'][$d['dl_id']] = $d;
				}
				if (empty($this->associativeArray)) $out['contacts'] =  array_values($out['contacts']);
			}
			elseif ($this->id_role == 4)
			{
				$sql_where = '1 = 1';
				if (!empty($id_dropbox_link))
				{
					$sql_where .= " AND `id_dropbox_link` in ($id_dropbox_link)";
				}
				if ($private != '')
				{
					$sql_where .= " AND `private` in ($private)";
				}
				if ($deleted != '')
				{
					$sql_where .= " AND `deleted` in ($deleted)";
				}
				$s = "SELECT
						`dropbox_link`.`id_dropbox_link` dl_id,
						`dropbox_link`.`json`,
						`dropbox_link`.`private`,
						`dropbox_link`.`deleted`,
						GROUP_CONCAT(`users_dropbox_link`.`id_user` SEPARATOR ',') as users,
						GROUP_CONCAT(IF(`users_dropbox_link`.`owner` = 1,`users_dropbox_link`.`id_user`,NULL) SEPARATOR ',') as u_id
					FROM `dropbox_link`
					LEFT JOIN `users_dropbox_link` USING (`id_dropbox_link`)
					WHERE	
						$sql_where
					GROUP BY
						`dropbox_link`.`id_dropbox_link`
					ORDER BY `id_dropbox_link`
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";
	
				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select failed');

				$out = array('dropbox files' => array());
				while ($d = fetch_assoc($q))
				{
					$d['json'] = json_decode($d['json'],true);
					if (!empty($d['users']))
					{
						$d['users'] = explode(',',$d['users']);
					}
					$out['dropbox files'][$d['dl_id']] = $d;
				}
				if (empty($this->associativeArray)) $out['contacts'] =  array_values($out['contacts']);
			}
			else
			{
				$sql_where = '1 = 1';
				if (!empty($id_dropbox_link))
				{
					$sql_where .= " AND `dropbox_link`.`id_dropbox_link` in ($id_dropbox_link)";
				}
				if ($private != '')
				{
					$sql_where .= " AND `dropbox_link`.`private` in ($private)";
				}

				$s = "SELECT
						`dropbox_link`.`id_dropbox_link` as dl_id,
						`dropbox_link`.`json`,
						`dropbox_link`.`private`,
						IF(udl.`id_user` = '" . $_SESSION[UID] . "',(SELECT
							GROUP_CONCAT(`users_dropbox_link`.`id_user` SEPARATOR ',')
						 FROM `users_dropbox_link`
						 WHERE `users_dropbox_link`.`id_dropbox_link` = `dropbox_link`.`id_dropbox_link`
						),'') as users,
						udl.`id_user` as u_id
					FROM `dropbox_link`
					LEFT JOIN `users_dropbox_link` udl ON udl.`id_dropbox_link` = `dropbox_link`.`id_dropbox_link` AND udl.`owner` = 1
					WHERE	
						$sql_where AND (udl.`id_user` = '" . $_SESSION[UID] . "' OR `dropbox_link`.`private` in (-1,0)) AND `deleted` = 0
					GROUP BY
						`dropbox_link`.`id_dropbox_link`
					ORDER BY `dropbox_link`.`id_dropbox_link`
					LIMIT " . $this->limit_offset . ", " . $this->limit_row_count . "
					";

				$q = query($s);
				if ($q === false) return $this->showError('404', 'error', 'select failed');

				$out = array('dropbox files' => array());
				while ($d = fetch_assoc($q))
				{
					$d['json'] = json_decode($d['json'],true);
					if ($d['u_id'] != $_SESSION[UID])
					{
						$d['json'] = array(
									'name' 			=> $d['json']['name'], 
									'name_upload' 	=> $d['json']['name_upload'], 
									'type' 			=> $d['json']['type'], 
									'size' 			=> $d['json']['size']
						);
					}
					if (!empty($d['users']))
					{
						$d['users'] = explode(',',$d['users']);
					}
					$out['dropbox files'][$d['dl_id']] = $d;
				}
				if (empty($this->associativeArray)) $out['contacts'] =  array_values($out['contacts']);
			}
			
			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out
			);
		}

		public function getTicketData($id_schedule = "", $id_trip = '', $seat = '', $taken = false, $code_qr = false, $scheme = false, $full = false, $langs = array(), $price_time_functions = array())
		{
			if (empty($id_schedule)) return $this->showError('404', 'error', 'empty sc_id');
			$sql_where = "`ticket`.`id_schedule` = '$id_schedule'";
			$sql_field = $sql_field_code_qr = $sql_left_join = '';
			if ($code_qr == true){
				$sql_field_code_qr = "`ticket`.`code_qr_base64`,";
			}

			if (!empty($id_trip)) 
			{
				$sql_where .= "`ticket`.`id_trip`in ($id_trip)";
			}

			if (!empty($seat)) 
			{
				$seat = json_decode($seat,true);
				
				if (empty($seat) || !is_array($seat)) 
				{
					return $this->showError('404', 'error', 'wrong seat');
				}

				$sql_seat = array();
				foreach($seat as $s_el)
				{
					$sql_seat[] = "'$s_el'";
				}
				$sql_seat = implode(',',$sql_seat);
				$sql_where .= " AND `ticket`.`id_seat` in ($sql_seat)";
			}

			$sql_where_add = " AND (`ticket`.`id_order` IS NULL AND `cart`.`id_user` IS NULL AND `ticket`.`status` not in (2,3))";
			if ($taken == true && ($this->id_role == 1 || $this->id_role == 2 || $this->id_role == 4))
			{
				if ($this->id_role == 4)
				{
					$sql_field = $sql_field_code_qr;
					$sql_field .= "
					`ticket`.`code`,";
					$sql_where_add = " AND (`ticket`.`id_order` IS NOT NULL OR `cart`.`id_user` IS NOT NULL OR `ticket`.`status` in (2,3))";
				}
				elseif ($this->id_role == 1)
				{
					if ($code_qr == true){
						$sql_field = "IF(`ticket`.`id_order` IS NOT NULL,`ticket`.`code_qr_base64`,NULL) as 'code_qr_base64',";
					}
					$sql_field .= "
					IF(`ticket`.`id_order` IS NOT NULL,`ticket`.`code`,NULL) as 'code',";
					$sql_where_add = " AND ((`ticket`.`id_order` IS NOT NULL AND `order`.`client` = '{$_SESSION[UID]}') OR (`ticket`.`id_order` IS NULL AND `cart`.`id_user` IS NOT NULL AND `cart`.`id_user` = '{$_SESSION[UID]}'))";
					$sql_left_join = "LEFT JOIN `order` ON `order`.`id_order` = `ticket`.`id_order`";
				}
				elseif ($this->id_role == 2)
				{
					$sql_field = $sql_field_code_qr;
					$sql_field .= "
					`ticket`.`code`,";
					$sql_where_add = " AND `trip`.`driver` = '{$_SESSION[UID]}' AND (`ticket`.`id_order` IS NOT NULL OR `cart`.`id_user` IS NOT NULL OR `ticket`.`status` in (2,3))";
					$sql_left_join = "LEFT JOIN `trip` ON `trip`.`id_trip` = `ticket`.`id_trip`";
				}
			}
			else
			{
				if ($this->id_role == 4)
				{
					$sql_field = $sql_field_code_qr;
					$sql_field .= "
					`ticket`.`code`,";
					$sql_where_add = "";
				}
				elseif ($this->id_role == 1)
				{
					if ($code_qr == true){
						$sql_field = "IF(`ticket`.`id_order` IS NOT NULL,`ticket`.`code_qr_base64`,NULL) as 'code_qr_base64',";
					}
					$sql_field .= "
					IF(`ticket`.`id_order` IS NOT NULL,`ticket`.`code`,NULL) as 'code',";
					$sql_where_add = " AND ((`ticket`.`id_order` IS NOT NULL AND `order`.`client` = '{$_SESSION[UID]}') OR (`ticket`.`id_order` IS NULL AND `cart`.`id_user` IS NOT NULL AND `cart`.`id_user` = '{$_SESSION[UID]}') OR (`ticket`.`id_order` IS NULL AND `cart`.`id_user` IS NULL AND `ticket`.`status` not in (2,3)))";
					$sql_left_join = "LEFT JOIN `order` ON `order`.`id_order` = `ticket`.`id_order`";
				}
				elseif ($this->id_role == 2)
				{
					$sql_field = $sql_field_code_qr;
					$sql_field .= "
					`ticket`.`code`,";
					$sql_where_add = " AND `trip`.`driver` = '{$_SESSION[UID]}'";
					$sql_left_join = "LEFT JOIN `trip` ON `trip`.`id_trip` = `ticket`.`id_trip`";
				}
			}
			$sql_where .= $sql_where_add;
	
			$s = "SELECT
					`ticket`.`id_schedule` as sc_id,
					`ticket`.`id_seat` as seat,
					`ticket`.`id_trip` as t_id,
					`ticket`.`id_order` as b_id,
					`ticket`.`tariff`,
					`ticket`.`currency`,
					`ticket`.`id_trip_seat` as ti_t_id,
					`ticket`.`number`,
					`ticket`.`status`,
					$sql_field
					`cart`.`id_user` as cart_u_id,
					`cart`.`booking_limit` as cart_limit
				FROM `ticket`
				LEFT JOIN `cart` ON `cart`.`product` = `ticket`.`id_trip` AND `cart`.`property` = `ticket`.`id_trip_seat` AND `cart`.`booking_limit` > now()
				$sql_left_join
				WHERE 
					 $sql_where
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
			
			$out = array(
				'ticket' => array(),
				'schedule' => array(),
				'trip' => array(),
				'booking' => array(),
				'user' => array(),
				'price' => array(),
				'stadiums' => array(),
				'teams' => array(),
				'tournaments' => array(),
				'cities' => array(),
				'countries' => array(),
				'regions' => array()
			);
			$schedule = $trip = $booking = $user = $stadiums = $teams = $tournaments = $cities = $countries = $regions = array();
			while ($d = fetch_assoc($q))
			{
				$schedule[$d['sc_id']] = true;
				$trip[$d['t_id']] = true;
				if (!empty($d['b_id'])) $booking[$d['b_id']] = true;
				if (!empty($d['cart_u_id'])) $user[$d['cart_u_id']] = true;
				add_time_zone($d['cart_limit']);
				$out['ticket'][] = $d;
			}

			$sql_name = $sql_description = $sql_address = $sql_country = array();
			foreach ($langs as $lang)
			{
				$sql_name[] = "`name_{$lang['iso']}` as {$lang['iso']}";
				$sql_description[] = "`description_{$lang['iso']}` as about_{$lang['iso']}";
				$sql_address[] = "`address_{$lang['iso']}` as address_{$lang['iso']}";
				$sql_country[] = "`country_name_{$lang['iso']}` as {$lang['iso']}";
			}
			$sql_name = implode(',',$sql_name);
			$sql_description = implode(',',$sql_description);
			$sql_address = implode(',',$sql_address);
			$sql_country = implode(',',$sql_country);

			if (!empty($schedule))
			{
				$s = "SELECT
						`id_schedule` as sc_id,
						`team1`,
						`team2`,
						`id_stadium` as stadium,
						`id_tournament` as tournament,
						`start_datetime` as datetime,
						`duration`,
						`only_date`,
						`top`,
						`options`,
						`time_zone`,
						`id_price_time_function` as price_time_function,
						`currency`,
						`currency_priority`,
						`fee`,
						`tariff`,
						`tariff_priority`,
						`code_ean_base64`
					FROM `schedule`
					WHERE
						`id_schedule` in (" . implode(',',array_keys($schedule)) . ")
					";

				$q = query($s);

				if ($q === false) return $this->showError('404', 'error', 'schedule select failed');
				while ($d = fetch_assoc($q))
				{
					add_time_zone($d['datetime']);
					$d['options'] = json_decode($d['options'],true);
					if (!empty($d['team1'])) $teams[$d['team1']] = true;
					if (!empty($d['team2'])) $teams[$d['team2']] = true;
					if (!empty($d['stadium'])) $stadiums[$d['stadium']] = true;
					if (!empty($d['tournament'])) $tournaments[$d['tournament']] = true;
					$out['schedule'][$d['sc_id']] = $d;
				}
			}

			if (!empty($trip))
			{
				$s = "SELECT
						`id_trip` as t_id,
						`driver` as u_id,
						`id_schedule` as sc_id,
						`create_datetime` as t_create_datetime,
						`id_price_time_function` as price_time_function,
						`currency`,
						`currency_priority`,
						`fee`,
						`tariff`,
						`tariff_priority`
					FROM `trip`
					WHERE
						`id_trip` in (" . implode(',',array_keys($trip)) . ")
					";

				$q = query($s);

				if ($q === false) return $this->showError('404', 'error', 'trip select failed');
				while ($d = fetch_assoc($q))
				{
					$user[$d['u_id']] = true;
					add_time_zone($d['t_create_datetime']);
					$out['trip'][$d['t_id']] = $d;
				}
			}

			if (!empty($booking))
			{
				$s = "SELECT
						`id_order` as b_id,
						`client` as u_id,
						`pay_datetime` as b_payment_datetime,
						`confirm_limit_datetime` as b_confirmation_limit
					FROM `order`
					WHERE
						`id_order` in (" . implode(',',array_keys($booking)) . ")
					";

				$q = query($s);

				if ($q === false) return $this->showError('404', 'error', 'booking select failed');
				while ($d = fetch_assoc($q))
				{
					$user[$d['u_id']] = true;
					add_time_zone($d['b_payment_datetime']);
					add_time_zone($d['b_confirmation_limit']);
					$out['booking'][$d['b_id']] = $d;
				}
			}

			if (!empty($user))
			{
				$s = "SELECT
						`id_user` as u_id,
						`name` as u_name,
						`family` as u_family,
						`middle` as u_middle
					FROM `users`
					WHERE
						`id_user` in (" . implode(',',array_keys($user)) . ")
					";

				$q = query($s);

				if ($q === false) return $this->showError('404', 'error', 'user select failed');
				while ($d = fetch_assoc($q))
				{
					$out['user'][$d['u_id']] = $d;
				}
			}

			if ($full == true)
			{
				if (!empty($teams))
				{
					$s = "SELECT 
							`id_team` as id,
							$sql_name,
							$sql_description,
							`id_stadium` as stadium,
							`id_city` as city,
							`country`,
							`logo`,
							`autonomous area` as sub_country
						FROM `team`
						WHERE
							`id_team` in (" . implode(',',array_keys($teams)) . ")
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'teams select failed');
					while ($d = fetch_assoc($q))
					{
						$key = $d['id'];
						unset($d['id']);
						if (!empty($d['logo'])) $d['logo'] = url($d['logo'],CONFIG_FILE_PATH . trim('teams/logo/'));
						if (!empty($d['stadium'])) $stadiums[$d['stadium']] = true;
						if (!empty($d['city'])) $cities[$d['city']] = true;
						if (!empty($d['country'])) $countries[$d['country']] = true;
						if (!empty($d['sub_country'])) $regions[$d['sub_country']] = true;
						$out['teams'][$key] = $d;
					}
				}

				if (!empty($tournaments))
				{
					$s = "SELECT 
							`id_tournament` as id,
							$sql_name,
							$sql_description
						FROM `tournament`
						WHERE
							`id_tournament` in (" . implode(',',array_keys($tournaments)) . ")
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'tournaments select failed');
					while ($d = fetch_assoc($q))
					{
						$key = $d['id'];
						unset($d['id']);
						$out['tournaments'][$key] = $d;
					}
				}

				if (!empty($stadiums))
				{
					$sql_field = '';
					if ($scheme == true){
						$sql_field = ",
							`scheme`,
							`seats` as seats
						";
					}
					$s = "SELECT 
							`id_stadium` as id,
							$sql_name,
							$sql_description,
							$sql_address,
							`id_city` as city,
							`country`,
							`scheme_link` as scheme_blob$sql_field
						FROM `stadium`
						WHERE
							`id_stadium` in (" . implode(',',array_keys($stadiums)) . ")
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'stadiums select failed');
						
					while ($d = fetch_assoc($q))
					{
						$key = $d['id'];
						$d['seats_obj'] = url("{$d['id']}.json",CONFIG_FILE_PATH . trim('stadiums/seats_obj/'));
						if (!file_exists($d['seats_obj'])) unset($d['seats_obj']);
						unset($d['id']);
						if (!empty($d['seats'])) $d['seats'] = json_decode($d['seats'],true);
						if (!empty($d['scheme_blob'])) 
						{
							if ($scheme == true)
							{
								$d['scheme_blob_arr'] = rawurlencode(file_get_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_FILE_PATH . 'stadiums/scheme_blob/' . $d['scheme_blob']));
							}
							$d['scheme_blob'] = url($d['scheme_blob'],CONFIG_FILE_PATH . trim('stadiums/scheme_blob/'));
						}
						if (!empty($d['city'])) $cities[$d['city']] = true;
						if (!empty($d['country'])) $countries[$d['country']] = true;
						$out['stadiums'][$key] = $d;
					}
				}

				if (!empty($cities))
				{
					$s = "SELECT 
							`id_city` as id,
							`country`,
							`timezone` as zone,
							$sql_name,
							$sql_description,
							`id_region` as region
						FROM `city`
						WHERE
							`id_city` in (" . implode(',',array_keys($cities)) . ")
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'cities select failed');
					while ($d = fetch_assoc($q))
					{
						$key = $d['id'];
						unset($d['id']);
						$countries[$d['country']] = true;
						if (!empty($d['region'])) $regions[$d['region']] = true;
						$out['cities'][$key] = $d;
					}
				}

				if (!empty($regions))
				{
					$s = "SELECT 
							`id_region` as id,
							$sql_name,
							$sql_description,
							`country`,
							`id_region_upper` as upper,
							`sub-national` as sub_national,
							`code`
						FROM `region`
						WHERE
							`id_region` in (" . implode(',',array_keys($regions)) . ")
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'regions select failed');
					while ($d = fetch_assoc($q))
					{
						$key = $d['id'];
						unset($d['id']);
						$countries[$d['country']] = true;
						if (!empty($d['upper'])) $regions[$d['upper']] = true;
						$out['regions'][$key] = $d;
					}
				}

				if (!empty($countries))
				{
					$sql_country = array();
					foreach($countries as $c_el=>$bool_val)
					{
						$sql_country[] = "'$c_el'";
					}
					$sql_country = implode(',',$sql_country);
					$sql_where = "`ISO 3166-1 alpha-2 code` in ($sql_country)";
				
					$s = "SELECT 
							`ISO 3166-1 alpha-2 code` as code,
							$sql_country
						FROM `countries_list`
						WHERE
							$sql_where
						";

					$q = query($s);

					if ($q === false) return $this->showError('404', 'error', 'countries select failed');
					while (@$d = fetch_assoc($q))
					{
						$key = $d['code'];
						unset($d['code']);
						$out['countries'][$key] = $d;
					}			
				}
			}

			$ptfd = array();
			$currency = array();
			$currency_function = array();
			$tariff = array();
			$tariff_function = array();
			foreach($out['schedule'] as $sc)
			{
				foreach($out['trip'] as $t)
				{
					if (!empty($sc['datetime']))
					{
						$ptfd[$sc['sc_id']][$t['t_id']] = $this->createPriceTimeFunctionData(
							array(
								'price_time_function'		=>	$t['price_time_function'],
								'sc_price_time_function'	=>	$sc['price_time_function'],
								't_create_datetime'			=>	$t['t_create_datetime'],
								'sc_datetime'				=>	$sc['datetime']
							),
							$price_time_functions
						);
					}
					$currency_ = $currency_priority = NULL;
					if (isset($t['currency']))
					{
						$currency_ = $t['currency'];
					}
					elseif (isset($sc['currency']))
					{
						$currency_ = $sc['currency'];
					}
					if (isset($currency_))
					{
						if (isset($t['currency_priority']))
						{
							$currency_priority = $t['currency_priority'];
						}
						else
						{
							$currency_priority = $sc['currency_priority'];
						}
						if (empty($currency_priority))
						{
							$currency_function[$sc['sc_id']][$t['t_id']] = 'getTripCurrencyString10';
						}
						else
						{
							$currency_function[$sc['sc_id']][$t['t_id']] = 'getTripCurrencyString11';
						}
					}
					else
					{						
						$currency_function[$sc['sc_id']][$t['t_id']] = 'getTripCurrencyString0';
					}
					$currency[$sc['sc_id']][$t['t_id']] = $currency_;
					$tariff_ = $tariff_priority = NULL;
					if (isset($t['tariff']))
					{
						$tariff_ = $t['tariff'];
					}
					elseif (isset($sc['tariff']))
					{
						$tariff_ = $sc['tariff'];
					}
					if (isset($tariff_))
					{
						if (isset($t['tariff_priority']))
						{
							$tariff_priority = $t['tariff_priority'];
						}
						else
						{
							$tariff_priority = $sc['tariff_priority'];
						}
						if (empty($tariff_priority))
						{
							$tariff_function[$sc['sc_id']][$t['t_id']] = 'getTripTariff10';
						}
						else
						{
							$tariff_function[$sc['sc_id']][$t['t_id']] = 'getTripTariff11';
						}
					}
					else
					{					
						$tariff_function[$sc['sc_id']][$t['t_id']] = 'getTripTariff0';
					}
					$tariff[$sc['sc_id']][$t['t_id']] = $tariff_;
				}
			}

			$price_arr = array();
			foreach($out['ticket'] as $i=>$ticket)
			{		
				if ($this->id_role == 1 && !empty($ticket['b_id']) && empty($out['booking'][$ticket['b_id']]['b_payment_datetime']))
				{
					$out['ticket'][$i]['code_qr_base64'] = NULL;
					$out['ticket'][$i]['code'] = NULL;
				}

				$price = $this->{$tariff_function[$ticket['sc_id']][$ticket['t_id']]}($tariff[$ticket['sc_id']][$ticket['t_id']],$ticket['tariff'] === NULL ? chr(2) : $ticket['tariff']);
				if ($price !== '')
				{
					if (isset($ptfd[$ticket['sc_id']][$ticket['t_id']]['price_time_function']))
					{
						$var = $ptfd[$ticket['sc_id']][$ticket['t_id']]['var'];
						if (!empty($ptfd[$ticket['sc_id']][$ticket['t_id']]['dp'])) $var['dp'] = $price;
						$price = $ptfd[$ticket['sc_id']][$ticket['t_id']]['price_time_function']($var);
					}									
					$price .= $this->{$currency_function[$ticket['sc_id']][$ticket['t_id']]}($currency[$ticket['sc_id']][$ticket['t_id']],$ticket['currency'] === NULL ? chr(2) : $ticket['currency']);
					$price = strtoupper($price);
					if (!isset($price_arr[$price]))
					{
						$price_arr[$price] = count($out['price']);
						$out['price'][] = $price;
					}
					$out['ticket'][$i]['price'] = $price_arr[$price];
				}
				else
				{
					$out['ticket'][$i]['price'] = '';
				}			
			}

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$out
			);
		}

		private function getTripTariff0($tariff, $seat_tariff)
		{
			return $seat_tariff !== chr(2) ? $seat_tariff : '';
		
		}

		private function getTripTariff10($tariff, $seat_tariff)
		{
			return $seat_tariff !== chr(2) ? $seat_tariff : $tariff;
		}

		private function getTripTariff11($tariff, $seat_tariff)
		{
			return $tariff;
		}

		private function fillStripeTitle($str = '', $seat = '')
		{
			$seat_s_b_r_s = explode(';',$seat);
			if (count($seat_s_b_r_s) < 4)
			{
				$stadium = '';
				$block = '';
				$row = '';
				$seat = $seat;
			}
			else
			{
				$stadium = $seat_s_b_r_s[0];
				$block = $seat_s_b_r_s[1];
				$row = $seat_s_b_r_s[2];
				$seat = $seat_s_b_r_s[3];
			}
			$data = array(
						'{$block}'	=>	$block,		
						'{$row}' 	=>	$row,
						'{$seat}'	=>	$seat
					);
			return fill_in_template(array($str),$data)[0];
		}

		public function htmlToPdf($data = '')
		{
			header("Content-type: application/pdf");
			echo html_to_pdf($data);
			exit;
		}
		
		public function checkTicket($code = '')
		{
			if (empty($_SESSION[UID])) {
				return $this->showError('404', 'error', 'unauthorized access');
			}
			if (empty($code)) 
			{
				return $this->showError('404', 'error', 'empty code');
			}
			if ($this->id_role != 4 && $this->id_role != 6) 
			{
				return $this->showError('404', 'error', 'wrong role');
			}

			$sql_field = '`ticket`.`id_schedule` as sc_id,
					`ticket`.`id_order` as b_id,
					`ticket`.`id_trip_seat` as ti_t_id,';
			$sql_join = '';
			$sql_where = "`ticket`.`code` = '$code'";

			if ($this->id_role == 6)
			{
				$sql_field = '';
				$sql_join = "JOIN (
					SELECT
							`id_schedule`
						FROM
							`users`
						WHERE
							`id_user` = '" . $_SESSION[UID] . "'
						LIMIT 1
					) u";
				$sql_where .= " AND u.`id_schedule` = `ticket`.`id_schedule`";
			
			}

			$s = "SELECT
					$sql_field
					`ticket`.`id_seat` as seat,
					`ticket`.`id_trip` as t_id,
					`ticket`.`pass`,
					`ticket`.`pass_datetime`,
					`ticket`.`out_datetime`,
					`ticket`.`status`,
					`order`.`pay_datetime` as b_payment_datetime,
					`order`.`id_order_status` as b_state
				FROM `ticket`
				$sql_join
				LEFT JOIN `order` USING (`id_order`)
				WHERE 
					 $sql_where
				LIMIT 1
				";

			$q = query($s);
			if ($q === false) return $this->showError('404', 'error', 'database select failed');
	
			$d = fetch_assoc($q);
			if (empty($d['seat'])) return $this->showError('404', 'error', 'ticket not found');
			
			add_time_zone($d['pass_datetime']);
			add_time_zone($d['out_datetime']);
			add_time_zone($d['b_payment_datetime']);

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	$d
			);
		}

		public $session_token = NULL;

		private function createSessionToken()
		{
		
		
		}

		private function checkSessionToken($session_token = '')
		{
/*
			$this->constant['session_token_duration']*/
		
		}

		private function checkPromocode($value = '',$actual = false, $id_schedule = array())
		{
			$sql_if = '1';
			if ($actual == true)
			{
				$sql_if = "`active` = '1' AND now() < `limit`";
			}
			$sql_promocode = '`id_promocode`';
			$sql_schedule = '`id_schedule`';
			$sql_if_add = '';
			if (!empty($id_schedule))
			{ 
				$id_schedule = implode(',',$id_schedule);
				$sql_promocode = "IFNULL(@flag := NULL,`id_promocode`) as 'id_promocode'";
				$sql_schedule = "IF(`id_schedule` in ($id_schedule),
					IF((@flag := IF(@flag IS NULL,`id_schedule`,CONCAT_WS(',',@flag,`id_schedule`))) IS NOT NULL,`id_schedule`,''),
					`id_schedule`
				)";
				$sql_if_add = " AND @flag IS NOT NULL";
			}
			$s = "SELECT 
				$sql_promocode,
				`discount`,
				`max_products`,
				`max_payments`,
				`json`,
				`limit`,
				IF(now() < `limit`,0,1) as expire,
				`active`,
				IF($sql_if,(SELECT
					GROUP_CONCAT($sql_schedule SEPARATOR ',')
				 FROM `promocode_schedule`
				 WHERE `promocode_schedule`.`id_promocode` = `promocode`.`id_promocode`
				),NULL) as schedule,			
				IF($sql_if$sql_if_add,(SELECT
					CONCAT_WS(',',
						COUNT(DISTINCT `ticket`.`id_order`),
						COUNT(`ticket`.`id_order`)
					)
				 FROM `ticket_prop_items_int`
				 LEFT JOIN `ticket` ON `ticket`.`id_trip_seat` = `ticket_prop_items_int`.`id_trip_seat` AND `ticket`.`id_trip` = `ticket_prop_items_int`.`id_trip`
				 WHERE `ticket_prop_items_int`.`id_ticket_prop` = '7' AND `ticket_prop_items_int`.`value` = `promocode`.`id_promocode`
				),NULL) as order_count,
				IF($sql_if$sql_if_add,(SELECT
					CONCAT_WS(',',
						COUNT(`placing_order`.`id_promocode`),
						SUM(`placing_order`.`id_promocode`)
					)
				 FROM `placing_order`
				 WHERE `placing_order`.`id_promocode` = `promocode`.`id_promocode` AND now() < `placing_order`.`limit`
				),NULL) as placing_count,
				@flag as id_schedule
				FROM `promocode`
			WHERE
				`value` = '$value'
			";

			$q = query($s);
			if ($q === false) return array('error'=>'select failed');	
			$d = fetch_assoc($q);
			if (!empty($d['id_promocode']))
			{
				$d['json'] = json_decode($d['json'],true);
				add_time_zone($d['limit']);
				if (!empty($d['schedule'])) $d['schedule'] = explode(',',$d['schedule']);
				$d['payments'] = $d['products'] = 0;
				if (!empty($d['order_count']))
				{
					$d['order_count'] = explode(',',$d['order_count']);					
					$d['order_count'][0] = (int)$d['order_count'][0];
					$d['order_count'][1] = (int)$d['order_count'][1];				
					$d['payments'] = $d['order_count'][0];
					$d['products'] = $d['order_count'][1];
				}
				if (!empty($d['placing_count']))
				{
					$d['placing_count'] = explode(',',$d['placing_count']);
					$d['placing_count'][0] = (int)$d['placing_count'][0];
					$d['placing_count'][1] = (int)$d['placing_count'][1];				
					$d['payments'] += $d['placing_count'][0];
					$d['products'] += $d['placing_count'][1];
				}
				$d['max_products'] = (int)$d['max_products'];
				$d['max_payments'] = (int)$d['max_payments'];
				if (!empty($d['id_schedule'])) $d['id_schedule'] = explode(',',$d['id_schedule']);
			}
			return array('data'=>$d);
		}

		private function createPlacingOrder($data = '')
		{
/*
			$this->constant['placing_order_duration*/
		}

		private function selectPlacingOrder()
		{
		
		}

		private function pullSessionToUser()
		{
		
		}

		private function addPromocodeToPlacingOrder()
		{
		
		}

		public function selectPromocodeByValue($value = '', $count = NULL)
		{
			$promocode_arr = $this->checkPromocode($value,true);
			if (!empty($promocode_arr['error'])) return $this->showError('404', 'error', $promocode_arr['error']);
			if (empty($promocode_arr['data']['id_promocode'])) return $this->showError('404', 'error', 'wrong promocode');
			if (empty($promocode_arr['data']['active'])) return $this->showError('404', 'error', 'nonactive promocode');
			if (!empty($promocode_arr['data']['expire'])) return $this->showError('404', 'error', 'expired promocode');

			if ($promocode_arr['data']['payments'] >= $promocode_arr['data']['max_payments'])
			{
				return $this->showError('404', 'error', 'payment limit reached for promocode');
			}
			if ($promocode_arr['data']['products'] >= $promocode_arr['data']['max_products'])
			{
				return $this->showError('404', 'error', 'seat limit reached for promocode');
			}
			$pc_available_number = $promocode_arr['data']['max_products'] - $promocode_arr['data']['products'];

			return array(
				'code' 		=>	'200',
				'status' 	=>	'success',		
				'data' 		=>	array(
									'discount'		=>		$promocode_arr['data']['discount'],
									'schedule'		=>		$promocode_arr['data']['schedule'],
									'count'			=>		MIN((int)$count,$pc_available_number)
				)
			);
		}
	}