<?php

	$timezones = array(
	  	'(GMT-12:00) International Date Line West' => 'Pacific/Wake',
	  	'(GMT-11:00) Midway Island' => 'Pacific/Apia',
	  	'(GMT-11:00) Samoa' => 'Pacific/Apia',
	  	'(GMT-10:00) Hawaii' => 'Pacific/Honolulu',
	  	'(GMT-09:00) Alaska' => 'America/Anchorage',
	  	'(GMT-08:00) Pacific Time (US &amp; Canada); Tijuana' => 'America/Los_Angeles',
	  	'(GMT-07:00) Arizona' => 'America/Phoenix',
	  	'(GMT-07:00) Chihuahua' => 'America/Chihuahua',
	  	'(GMT-07:00) La Paz' => 'America/Chihuahua',
	  	'(GMT-07:00) Mazatlan' => 'America/Chihuahua',
	  	'(GMT-07:00) Mountain Time (US &amp; Canada)' => 'America/Denver',
	  	'(GMT-06:00) Central America' => 'America/Managua',
	  	'(GMT-06:00) Central Time (US &amp; Canada)' => 'America/Chicago',
	  	'(GMT-06:00) Guadalajara' => 'America/Mexico_City',
	  	'(GMT-06:00) Mexico City' => 'America/Mexico_City',
	  	'(GMT-06:00) Monterrey' => 'America/Mexico_City',
	  	'(GMT-06:00) Saskatchewan' => 'America/Regina',
	  	'(GMT-05:00) Bogota' => 'America/Bogota',
	  	'(GMT-05:00) Eastern Time (US &amp; Canada)' => 'America/New_York',
	  	'(GMT-05:00) Indiana (East)' => 'America/Indiana/Indianapolis',
	  	'(GMT-05:00) Lima' => 'America/Bogota',
	  	'(GMT-05:00) Quito' => 'America/Bogota',
	  	'(GMT-04:00) Atlantic Time (Canada)' => 'America/Halifax',
	  	'(GMT-04:00) Caracas' => 'America/Caracas',
	  	'(GMT-04:00) La Paz' => 'America/Caracas',
	  	'(GMT-04:00) Santiago' => 'America/Santiago',
	  	'(GMT-03:30) Newfoundland' => 'America/St_Johns',
	  	'(GMT-03:00) Brasilia' => 'America/Sao_Paulo',
	  	'(GMT-03:00) Buenos Aires' => 'America/Argentina/Buenos_Aires',
	  	'(GMT-03:00) Georgetown' => 'America/Argentina/Buenos_Aires',
	  	'(GMT-03:00) Greenland' => 'America/Godthab',
	  	'(GMT-02:00) Mid-Atlantic' => 'America/Noronha',
	  	'(GMT-01:00) Azores' => 'Atlantic/Azores',
	  	'(GMT-01:00) Cape Verde Is.' => 'Atlantic/Cape_Verde',
	  	'(GMT) Casablanca' => 'Africa/Casablanca',
	  	'(GMT) Edinburgh' => 'Europe/London',
	  	'(GMT) Greenwich Mean Time : Dublin' => 'Europe/London',
	  	'(GMT) Lisbon' => 'Europe/London',
	  	'(GMT) London' => 'Europe/London',
	  	'(GMT) Monrovia' => 'Africa/Casablanca',
	  	'(GMT+01:00) Amsterdam' => 'Europe/Berlin',
	  	'(GMT+01:00) Belgrade' => 'Europe/Belgrade',
	  	'(GMT+01:00) Berlin' => 'Europe/Berlin',
	  	'(GMT+01:00) Bern' => 'Europe/Berlin',
	  	'(GMT+01:00) Bratislava' => 'Europe/Belgrade',
	  	'(GMT+01:00) Brussels' => 'Europe/Paris',
	  	'(GMT+01:00) Budapest' => 'Europe/Belgrade',
	  	'(GMT+01:00) Copenhagen' => 'Europe/Paris',
	  	'(GMT+01:00) Ljubljana' => 'Europe/Belgrade',
	  	'(GMT+01:00) Madrid' => 'Europe/Paris',
	  	'(GMT+01:00) Paris' => 'Europe/Paris',
	  	'(GMT+01:00) Prague' => 'Europe/Belgrade',
	  	'(GMT+01:00) Rome' => 'Europe/Berlin',
	  	'(GMT+01:00) Sarajevo' => 'Europe/Sarajevo',
	  	'(GMT+01:00) Skopje' => 'Europe/Sarajevo',
	  	'(GMT+01:00) Stockholm' => 'Europe/Berlin',
	  	'(GMT+01:00) Vienna' => 'Europe/Berlin',
	  	'(GMT+01:00) Warsaw' => 'Europe/Sarajevo',
	  	'(GMT+01:00) West Central Africa' => 'Africa/Lagos',
	  	'(GMT+01:00) Zagreb' => 'Europe/Sarajevo',
	  	'(GMT+02:00) Athens' => 'Europe/Istanbul',
	  	'(GMT+02:00) Bucharest' => 'Europe/Bucharest',
	  	'(GMT+02:00) Cairo' => 'Africa/Cairo',
	  	'(GMT+02:00) Harare' => 'Africa/Johannesburg',
	  	'(GMT+02:00) Helsinki' => 'Europe/Helsinki',
	  	'(GMT+02:00) Istanbul' => 'Europe/Istanbul',
	  	'(GMT+02:00) Jerusalem' => 'Asia/Jerusalem',
	  	'(GMT+02:00) Kyiv' => 'Europe/Helsinki',
	  	'(GMT+02:00) Minsk' => 'Europe/Istanbul',
	  	'(GMT+02:00) Pretoria' => 'Africa/Johannesburg',
	  	'(GMT+02:00) Riga' => 'Europe/Helsinki',
	  	'(GMT+02:00) Sofia' => 'Europe/Helsinki',
	  	'(GMT+02:00) Tallinn' => 'Europe/Helsinki',
	  	'(GMT+02:00) Vilnius' => 'Europe/Helsinki',
	  	'(GMT+03:00) Baghdad' => 'Asia/Baghdad',
	  	'(GMT+03:00) Kuwait' => 'Asia/Riyadh',
	  	'(GMT+03:00) Moscow' => 'Europe/Moscow',
	  	'(GMT+03:00) Nairobi' => 'Africa/Nairobi',
	  	'(GMT+03:00) Riyadh' => 'Asia/Riyadh',
	  	'(GMT+03:00) St. Petersburg' => 'Europe/Moscow',
	  	'(GMT+03:00) Volgograd' => 'Europe/Moscow',
	  	'(GMT+03:30) Tehran' => 'Asia/Tehran',
	  	'(GMT+04:00) Abu Dhabi' => 'Asia/Muscat',
	  	'(GMT+04:00) Baku' => 'Asia/Tbilisi',
	  	'(GMT+04:00) Muscat' => 'Asia/Muscat',
	  	'(GMT+04:00) Tbilisi' => 'Asia/Tbilisi',
	  	'(GMT+04:00) Yerevan' => 'Asia/Tbilisi',
	  	'(GMT+04:30) Kabul' => 'Asia/Kabul',
	  	'(GMT+05:00) Ekaterinburg' => 'Asia/Yekaterinburg',
	  	'(GMT+05:00) Islamabad' => 'Asia/Karachi',
	  	'(GMT+05:00) Karachi' => 'Asia/Karachi',
	  	'(GMT+05:00) Tashkent' => 'Asia/Karachi',
	  	'(GMT+05:30) Chennai' => 'Asia/Calcutta',
	  	'(GMT+05:30) Kolkata' => 'Asia/Calcutta',
	  	'(GMT+05:30) Mumbai' => 'Asia/Calcutta',
	  	'(GMT+05:30) New Delhi' => 'Asia/Calcutta',
	  	'(GMT+05:45) Kathmandu' => 'Asia/Katmandu',
	  	'(GMT+06:00) Almaty' => 'Asia/Novosibirsk',
	  	'(GMT+06:00) Astana' => 'Asia/Dhaka',
	  	'(GMT+06:00) Dhaka' => 'Asia/Dhaka',
	  	'(GMT+06:00) Novosibirsk' => 'Asia/Novosibirsk',
	  	'(GMT+06:00) Sri Jayawardenepura' => 'Asia/Colombo',
	  	'(GMT+06:30) Rangoon' => 'Asia/Rangoon',
	  	'(GMT+07:00) Bangkok' => 'Asia/Bangkok',
	  	'(GMT+07:00) Hanoi' => 'Asia/Bangkok',
	  	'(GMT+07:00) Jakarta' => 'Asia/Bangkok',
	  	'(GMT+07:00) Krasnoyarsk' => 'Asia/Krasnoyarsk',
	  	'(GMT+08:00) Beijing' => 'Asia/Hong_Kong',
	  	'(GMT+08:00) Chongqing' => 'Asia/Hong_Kong',
	  	'(GMT+08:00) Hong Kong' => 'Asia/Hong_Kong',
	  	'(GMT+08:00) Irkutsk' => 'Asia/Irkutsk',
	  	'(GMT+08:00) Kuala Lumpur' => 'Asia/Singapore',
	  	'(GMT+08:00) Perth' => 'Australia/Perth',
	  	'(GMT+08:00) Singapore' => 'Asia/Singapore',
	  	'(GMT+08:00) Taipei' => 'Asia/Taipei',
	  	'(GMT+08:00) Ulaan Bataar' => 'Asia/Irkutsk',
	  	'(GMT+08:00) Urumqi' => 'Asia/Hong_Kong',
	  	'(GMT+09:00) Osaka' => 'Asia/Tokyo',
	  	'(GMT+09:00) Sapporo' => 'Asia/Tokyo',
	  	'(GMT+09:00) Seoul' => 'Asia/Seoul',
	  	'(GMT+09:00) Tokyo' => 'Asia/Tokyo',
	  	'(GMT+09:00) Yakutsk' => 'Asia/Yakutsk',
	  	'(GMT+09:30) Adelaide' => 'Australia/Adelaide',
	  	'(GMT+09:30) Darwin' => 'Australia/Darwin',
	  	'(GMT+10:00) Brisbane' => 'Australia/Brisbane',
	  	'(GMT+10:00) Canberra' => 'Australia/Sydney',
	  	'(GMT+10:00) Guam' => 'Pacific/Guam',
	  	'(GMT+10:00) Hobart' => 'Australia/Hobart',
	  	'(GMT+10:00) Melbourne' => 'Australia/Sydney',
	  	'(GMT+10:00) Port Moresby' => 'Pacific/Guam',
	  	'(GMT+10:00) Sydney' => 'Australia/Sydney',
	  	'(GMT+10:00) Vladivostok' => 'Asia/Vladivostok',
	  	'(GMT+11:00) Magadan' => 'Asia/Magadan',
	  	'(GMT+11:00) New Caledonia' => 'Asia/Magadan',
	  	'(GMT+11:00) Solomon Is.' => 'Asia/Magadan',
	  	'(GMT+12:00) Auckland' => 'Pacific/Auckland',
	  	'(GMT+12:00) Fiji' => 'Pacific/Fiji',
	  	'(GMT+12:00) Kamchatka' => 'Pacific/Fiji',
	  	'(GMT+12:00) Marshall Is.' => 'Pacific/Fiji',
	  	'(GMT+12:00) Wellington' => 'Pacific/Auckland',
	  	'(GMT+13:00) Nuku\'alofa' => 'Pacific/Tongatapu',
	);

	
	function clr_string($string)
	{
		return htmlspecialchars(trim(stripslashes(strip_tags($string))));
	}
	
	function url($url = '', $prefix = false, $absolute = true)
	{
		$url = (gettype($prefix) === 'string' ? $prefix : ROOT_URL) . $url;
		if ($absolute)
			return 'https://' . $_SERVER['HTTP_HOST'] . $url;
		else
			return $url;
	}
	
	function redirect($url = '')
	{
		header('Location: ' . $url);
		die();
	}

	function send_mail($emailAddress = '', $subject = '', $body = '', $file = array())
	{
		if (empty($emailAddress)) return NULL;
		$email = new PHPMailer;
		$email->IsSMTP();
		$email->Host       	= empty(taxi::$data_private['site_constants']['site_email_host']['value']) ? 'smtp.beget.com' : taxi::$data_private['site_constants']['site_email_host']['value'];
		$email->SMTPDebug  	= 0;
		$email->SMTPAuth   	= true;
		$email->Port       	= empty(taxi::$data_private['site_constants']['site_email_port']['value']) ? '2525' : taxi::$data_private['site_constants']['site_email_port']['value'];
		$email->Username   	= empty(taxi::$data_private['site_constants']['site_email_username']['value']) ? 'info@ibronevik.ru' : taxi::$data_private['site_constants']['site_email_username']['value'];
		$email->Password  	= empty(taxi::$data_private['site_constants']['site_email_password']['value']) ? 'xv*h8S3C' : taxi::$data_private['site_constants']['site_email_password']['value'];
		$email->SMTPSecure 	= empty(taxi::$data_private['site_constants']['site_email_smtpsecure']['value']) ? 'tsl' : taxi::$data_private['site_constants']['site_email_smtpsecure']['value'];
		$email->From      	= empty(taxi::$data_private['site_constants']['site_email_username']['value']) ? 'info@ibronevik.ru' : taxi::$data_private['site_constants']['site_email_username']['value'];
		$email->FromName  	= empty(taxi::$data_private['site_constants']['site_email_fromname']['value']) ? 'Ibronevik' : taxi::$data_private['site_constants']['site_email_fromname']['value'];
		$email->Subject 	= $subject;
		$email->AltBody 	= $body;
		$email->Body      	= $body;
		$email->AllowEmpty = true;
		$email->CharSet     = "utf-8";
		$email->IsHTML(true);
		$email->AddAddress($emailAddress);

		foreach ($file as $f)
		{
			$email->addStringAttachment($f['content'],$f['name']);
		}
		if (!$email->Send()) return false;
		return true;
	}

	function generate_password($number)
	{
	    $arr = array('a','b','c','d','e','f',
	                 'g','h','i','j','k','l',
	                 'm','n','o','p','r','s',
	                 't','u','v','x','y','z',
	                 'A','B','C','D','E','F',
	                 'G','H','I','J','K','L',
	                 'M','N','O','P','R','S',
	                 'T','U','V','X','Y','Z',
	                 '1','2','3','4','5','6',
	                 '7','8','9','0','.',',',
	                 '(',')','[',']','!','?',
	                 '&','^','%','@','*','$',
	                 '<','>','/','|','+','-',
	                 '{','}','`','~');
	    
	    $pass = "";
	    for($i = 0; $i < $number; $i++)
	    {
	      	$index = rand(0, count($arr) - 1);
	      	$pass .= $arr[$index];
	    }
	    
	    return $pass;
	}
	function get_user_ban_status($id_user = "")
	{
		if (empty($id_user)) return array();

		$s = "SELECT 
			  SUM(`auth`) as a,
			  SUM(`order`) as o,
			  SUM(`blog_topic`) as bt,
			  SUM(`blog_post`) as bp
			FROM `users_ban`
			WHERE
				`id_user` ='" . $id_user . "' AND (`expire_datetime` = 0 OR NOW() < `expire_datetime`)
			";

		$q = query($s);
		@$d = fetch_assoc($q);
		return array(
			  'auth'		=> $d !== NULL ? $d['a'] : true,
			  'order'		=> isset($d['o']) ? $d['o'] :  NULL,
			  'blog_topic'	=> isset($d['bt']) ? $d['bt'] :  NULL,
			  'blog_post'	=> isset($d['bp']) ? $d['bp'] :  NULL
		);
	}
	function check_auth_user()
	{
		taxi::$check_auth_user_count++;
		if (empty($_SESSION[UID])) return false;
		$s = "SELECT 
				`id_role`,
				`id_user`,
				`name`,
				`family`,
				`middle`,
				`phone`,
				`email`,
				`photo_link`,
				`id_lang`,
				`currency`,
				`id_navigation`,
				`id_verification_status`,
				`deleted`,
				`active`,
				`birthday_date`,
				`tg`,
				`wa`
			FROM `users`
			WHERE 
				`id_user` = '" . $_SESSION[UID] . "'
			LIMIT 1
			";

		$q = query($s);
		@$d = fetch_assoc($q);
		if (empty($d['id_user']) || !empty($d['deleted']))
		{
			unset($_SESSION); session_unset();
		}
		else
		{
			$user_ban_status = get_user_ban_status($d['id_user']);
			if (!empty($user_ban_status['auth']))
			{
				unset($_SESSION); session_unset();
			}
			else
			{
				$_SESSION['name'] = $d['name'];
				$_SESSION['family'] = $d['family'];
				$_SESSION['middle'] = $d['middle'];
				$_SESSION['email'] = $d['email'];
				$_SESSION['phone'] = $d['phone'];
				$_SESSION['id_role'] = $d['id_role'];
				$_SESSION['id_verification_status'] = $d['id_verification_status'];
				$_SESSION['user_ban_status'] = $user_ban_status;
				$_SESSION['active'] = (int)$d['active'];
				if (!isset($_REQUEST['lang']))
				$_SESSION['lang'] = $d['id_lang'] ? : (isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG);
				$_SESSION['photo_link'] = $d['photo_link'] ? url($d['photo_link'],FILE_PATH) : '';
				$_SESSION['birthday_date'] = $d['birthday_date'];
				$_SESSION['id_lang'] = $d['id_lang'];
				$_SESSION['currency'] = $d['currency'];
				$_SESSION['id_navigation'] = $d['id_navigation'];
				$_SESSION['tg'] = $d['tg'];
				$_SESSION['wa'] = $d['wa'];
				taxi::$id_role = $_SESSION['id_role'];
				if (isset($_REQUEST['u_a_role']))
				{
					$u_a_role = trim($_REQUEST['u_a_role']);
					if ($_SESSION['id_role'] == 4)
					{
						if (!empty(taxi::$data['user_roles'][$u_a_role]))
						{
							taxi::$id_role = $u_a_role;
						}
					}
					elseif ($_SESSION['id_role'] == 6)
					{
						if ($u_a_role != 4 && !empty(taxi::$data['user_roles'][$u_a_role]))
						{
							taxi::$id_role = $u_a_role;
						}
					}
					else
					{
						if ($u_a_role != 4 && $u_a_role != 6 && !empty(taxi::$data['user_roles'][$u_a_role]))
						{
							taxi::$id_role = $u_a_role;
						}
					}
				}
				
				$role_db_user = $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/list/' . CONFIG . '/role' . taxi::$id_role . '.php';
				if (taxi::$check_auth_user_count === 1 && is_file($role_db_user))
				{
					include_once($role_db_user);
					global $link;
					mysqli_close($link);
					define('USERNAME_F_R', $config_arr['USERNAME']);
					define('PASSWORD_F_R', $config_arr['PASSWORD']);
					if (!@$link = mysqli_connect(HOST, USERNAME_F_R, PASSWORD_F_R, DBNAME)) json_exit('400', 'error', 'Error with connection to database: ' . mysqli_connect_error(), NULL);
					if (!query("SET NAMES 'utf8';")) json_exit('400', 'error', 'MySQL Error: ' . error_db(), NULL);
					query("SET group_concat_max_len = 1024*1024;");
				}			
			}
		}
	}
	
	function mimeToext($type = '')
	{
		require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/mime.php');
		return isset(mime::$ext[$type]) ? mime::$ext[$type] : '';
	}
	
	function base64ImageToFile($image = '')
	{
		if (!empty($image))
		{
			if (strpos($image,':') === false) {
				$http = true;
				if (!(($url_http = substr($image,0,7)) === 'http://' 
					|| ($url_http = substr($image,0,8)) === 'https://' 
					|| ($url_http = substr($image,0,2)) === '//' 
					|| ($url_http = $image[0]) === '/'))
				{
					$url_http = '';
					$http = false;
				}
				$url_http .= $_SERVER['HTTP_HOST'] . ROOT_URL;
				$url_http_len = strlen($url_http);
				if (substr($image,0,$url_http_len) !== $url_http)
				{
					if ($image[0] == '/')
					{
						$url_http = ROOT_URL;
						$url_http_len = strlen(ROOT_URL);
						if (substr($image,0,$url_http_len) !== $url_http)
						{
							return array('image' => false,'error' => 'wrong photo url root or host');
						}
					}
					elseif ($http === false)
					{
						$url_http_len = 0;
					}
					else
					{
						return array('image' => false,'error' => 'wrong photo url host or root');
					}

				}
				$image = substr($image,$url_http_len);
				if (!file_exists($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . $image))
				{
					if ($url_http_len === 0 && file_exists($_SERVER['DOCUMENT_ROOT'] . FILE_PATH . $image))
					{
						$name_file = $image;
					}
					else
					{
						return array('image' => false,'error' => 'photo not found');
					}
				}
				else
				{
					$name_file = basename($image);
					if (ROOT_URL . $image !== FILE_PATH . $name_file)
					{
						return array('image' => false,'error' => 'wrong photo url path');
					}
				}
			}
			else
			{
				list($type, $image) = array_merge(explode(';', $image),array(''));
				list(, $type) = array_merge(explode(':', $type),array(''));
				list(, $image) = array_merge(explode(',', $image),array(''));
				$image = base64_decode($image);

				if (!empty($image))
				{
					$ext = mimeToext($type);
					if (empty($ext)) return array('image' => false,'error' => 'wrong image type');				
					while (file_exists('files' . ($name_file = md5(md5(rand() . " " . rand())) . "." . $ext)));
					@$file = file_put_contents($_SERVER['DOCUMENT_ROOT'] . FILE_PATH . $name_file, $image);
					if (!$file) return array('image' => false,'error' => 'file not created');
				}
				else
				{
					return array('image' => false,'error' => 'wrong photo base64 sequence');
				}
			}
			return array('image' => $name_file ,'error' => false);
		}
		else
		{
			return array('image' => '','error' => false);
		}
	}

	function lang($name = '', $value = '', $lang = DEFAULT_LANG)
	{
		if (!empty($value) && isset(taxi::$data['langs'][$lang]) 
			&& !isset(taxi::$data['lang_vls'][$name][$lang]))
		{
		
			$s = "INSERT INTO `lang_values`
				SET 
					`id_lang` = '" . $lang . "',
					`name` = '" . $name . "',
					`value` = '" . $value . "',
					`last_edit_datetime` = now(),
					`last_edit_user` = " . (empty($_SESSION[UID]) ? "NULL" : "'" . $_SESSION[UID] . "'") . "
				";

			query($s);
		}

		$lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;

		return isset(taxi::$data['lang_vls'][$name][$lang]) ? taxi::$data['lang_vls'][$name][$lang] : '';
	}

	function update_cache()
	{
		$data = array();
		$debug = array();
		$data_private = array();
		$data_stadium_team_tournament = array();
		$data_schedule = array();
		$data_private['_empty'] = array();
		$data_function = array();
		
		$s = "SELECT 
				`id_lang` as id,
				IFNULL(`ISO 639-1`,`ISO 639-3`) as iso
			FROM `lang`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'langs check';
		$langs = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			unset($d['id']);
			$langs[$key] = $d;
		}
		
		$s = "DESCRIBE `lang` 'name_%'";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'langs describe';
		$langs_find = array();
		while (@$d = fetch_assoc($q))
		{
			$langs_find[substr($d['Field'],5)] = true;
		}		

		$langs_for_insert = array();
		foreach ($langs as $lang)
		{
			if (!isset($langs_find[$lang['iso']]))
			{
				$langs_for_insert[] = $lang['iso'];
			}
		}
		
		$q = create_lang_field($langs_for_insert);
		if (!empty($q['error'])) $debug['mysql'][] = array('lang field create'=>$q['error']);
	
		$htaccess_folder = $_SERVER['DOCUMENT_ROOT'] . CONFIG_FILE_PATH;
		if (is_file($htaccess_folder))
		{
			$debug['htaccess'][] = "htaccess dir is file";
		}
		else
		{
			if (!file_exists($htaccess_folder)) 
			{
				@$dir = mkdir($htaccess_folder,0777,true);
				if (!$dir) $debug['htaccess'][] = "htaccess dir create error";
			}
			else
			{
				$dir = true;
			}
			if ($dir)
			{
				$htaccess_file = "$htaccess_folder.htaccess";
				if (is_dir($htaccess_file))
				{
					$debug['htaccess'][] = "htaccess file is dir";
				}
				else
				{
					if (!file_exists($htaccess_file))
					{
						@$file = file_put_contents($htaccess_file,'<IfModule mod_headers.c>
	SetEnvIf Origin ".+" Var_Origin=$0
	Header add Access-Control-Allow-Origin %{Var_Origin}e env=Var_Origin
</IfModule>');
						if ($file === false) $debug['htaccess'][] = "htaccess write error";
					}
				}
			}
		}	

		$s = "SELECT 
				`id_lang` as id,
				`native_name` as native,
				" . sql_for_langs($langs, 'name_', '') . ",
				IFNULL(`ISO 639-1`,`ISO 639-3`) as iso,
				`logo_link` as logo,
				`translate_code` as tr_code
			FROM `lang`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'langs';
		$data['langs'] = array();
		$data_private['_empty']['langs'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['langs'],$langs,array(''));
			unset($d['id']);
			$data['langs'][$key] = $d;
		}
		if (empty($data_private['_empty']['langs'])) unset($data_private['_empty']['langs']);



		$s = "SELECT 
				`id_lang`,
				`name`, 
				`value`
			FROM `lang_values`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'lang_vls';
		$data['lang_vls'] = array();
		$data_private['_empty']['lang_vls'] = array();
		while (@$d = fetch_assoc($q))
		{
			$data['lang_vls'][strtolower($d['name'])][$d['id_lang']] = $d['value'];
		}
		add_empty_for_langs($data['lang_vls'],$data_private['_empty']['lang_vls'],$langs,NULL);
		if (empty($data_private['_empty']['lang_vls'])) unset($data_private['_empty']['lang_vls']);
		
		$s = "SELECT 
				`id_account` as id,
				`id_date_place` as date_place,
				`login`,
				`email`,
				`phone`,
				`pwd` as p_word,
				`auth`,
				`json`
			FROM `account`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'accounts';
		$data_private['accounts'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			$d['json'] = json_decode($d['json'],true);
			unset($d['id']);
			$data_private['accounts'][$key] = $d;
		}	

		$s = "SELECT 
				`id_aggregator` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`json`
			FROM `aggregator`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'aggregators';
		$data['aggregators'] = array();
		$data_private['_empty']['aggregators'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['aggregators'],$langs,array('', 'about_'));
			$d['json'] = json_decode($d['json'],true);
			unset($d['id']);
			$data['aggregators'][$key] = $d;
		}
		if (empty($data_private['_empty']['aggregators'])) unset($data_private['_empty']['aggregators']);
		
		$s = "SELECT 
				`id_car_body` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `car_body`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'car_bodies';
		$data['car_bodies'] = array();
		$data_private['_empty']['car_bodies'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['car_bodies'],$langs,array(''));
			unset($d['id']);
			$data['car_bodies'][$key] = $d;
		}
		if (empty($data_private['_empty']['car_bodies'])) unset($data_private['_empty']['car_bodies']);

		$s = "SELECT 
				`id_car_class` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`seats`,
				`luggage`,
				`photo_link` as photo,
				`courier_call_rate`,
				`courier_fare_per_1_km`,
				(SELECT
					GROUP_CONCAT(`id_order_location` SEPARATOR ',')
				 FROM `car_class_order_location`
				 WHERE `car_class_order_location`.`id_car_class` = `car_class`.`id_car_class`
				) as booking_location_classes
			FROM `car_class`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'car_classes';
		$data['car_classes'] = array();
		$data_private['_empty']['car_classes'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['car_classes'],$langs,array('', 'about_'));
			unset($d['id']);
			$d['photo'] = $d['photo'] ? url($d['photo'],FILE_PATH) : '';
			if (!empty($d['booking_location_classes'])) $d['booking_location_classes'] = explode(',',$d['booking_location_classes']);
			$data['car_classes'][$key] = $d;
		}
		if (empty($data_private['_empty']['car_classes'])) unset($data_private['_empty']['car_classes']);

		$s = "SELECT 
				`id_car_color` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				`hex`
			FROM `car_color`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'car_colors';
		$data['car_colors'] = array();
		$data_private['_empty']['car_colors'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['car_colors'],$langs,array(''));
			unset($d['id']);
			$data['car_colors'][$key] = $d;
		}
		if (empty($data_private['_empty']['car_colors'])) unset($data_private['_empty']['car_colors']);

		$s = "SELECT 
				`id_car_make` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `car_make`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'car_makes';
		$data['car_makes'] = array();
		$data_private['_empty']['car_makes'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['car_makes'],$langs,array(''));
			unset($d['id']);
			$data['car_makes'][$key] = $d;
		}
		if (empty($data_private['_empty']['car_makes'])) unset($data_private['_empty']['car_makes']);

		$s = "SELECT 
				`id_car_model` as id,
				`id_car_make` as make,
				`id_car_class` as class,
				`id_car_body` as body,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				`year`,
				`door`
			FROM `car_model`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'car_models';
		$data['car_models'] = array();
		$data_private['_empty']['car_models'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['car_models'],$langs,array(''));
			unset($d['id']);
			$data['car_models'][$key] = $d;
		}
		if (empty($data_private['_empty']['car_models'])) unset($data_private['_empty']['car_models']);

		$s = "SELECT 
				`id_cargo_case_model` as id,
				`id_cargo_case_type` as type,
				" . sql_for_langs($data['langs'], 'name_', '') . ",	
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `cargo_case_model`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'cargo_case_models';
		$data['cargo_case_models'] = array();
		$data_private['_empty']['cargo_case_models'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['cargo_case_models'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['cargo_case_models'][$key] = $d;
		}
		if (empty($data_private['_empty']['cargo_case_models'])) unset($data_private['_empty']['cargo_case_models']);
		
		$s = "SELECT 
				`id_cargo_case_type` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",	
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `cargo_case_type`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'cargo_case_types';
		$data['cargo_case_types'] = array();
		$data_private['_empty']['cargo_case_types'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['cargo_case_types'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['cargo_case_types'][$key] = $d;
		}
		if (empty($data_private['_empty']['cargo_case_types'])) unset($data_private['_empty']['cargo_case_types']);

		$s = "SELECT 
				`id_cargo_category` as id,
				IF(`id_cargo_category_upper` = '0',NULL,`id_cargo_category_upper`) as upper,
				" . sql_for_langs($data['langs'], 'name_', '') . ",	
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `cargo_category`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'cargo_categories';
		$data['cargo_categories'] = array();
		$data_private['_empty']['cargo_categories'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['cargo_categories'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['cargo_categories'][$key] = $d;
		}
		if (empty($data_private['_empty']['cargo_categories'])) unset($data_private['_empty']['cargo_categories']);

		$s = "SELECT 
				`id_cargo_value_type` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",	
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `cargo_value_type`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'cargo_value_types';
		$data['cargo_value_types'] = array();
		$data_private['_empty']['cargo_value_types'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['cargo_value_types'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['cargo_value_types'][$key] = $d;
		}
		if (empty($data_private['_empty']['cargo_value_types'])) unset($data_private['_empty']['cargo_value_types']);

		$s = "SELECT 
				`id_cart_block_status_sys` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",	
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `cart_block_status_sys`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'cart_block_statuses_sys';
		$data['cart_block_statuses_sys'] = array();
		$data_private['_empty']['cart_block_statuses_sys'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['cart_block_statuses_sys'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['cart_block_statuses_sys'][$key] = $d;
		}
		if (empty($data_private['_empty']['cart_block_statuses_sys'])) unset($data_private['_empty']['cart_block_statuses_sys']);

		$s = "SELECT 
				`id_city` as id,
				`country`,
				`timezone` as zone,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`id_region` as region
			FROM `city`
			";

		$q = query($s);

		if ($q === false) $debug['mysql'][] = 'cities';
		$data['cities'] = array();
		$data_private['_empty']['cities'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['cities'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['cities'][$key] = $d;
		}
		if (empty($data_private['_empty']['cities'])) unset($data_private['_empty']['cities']);

		$s = "SELECT 
				`id_contact_type` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `contact_type`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'contact_classes';
		$data['contact_classes'] = array();
		$data_private['_empty']['contact_classes'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['contact_classes'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['contact_classes'][$key] = $d;
		}
		if (empty($data_private['_empty']['contact_classes'])) unset($data_private['_empty']['contact_classes']);

		$s = "SELECT 
				`ISO 3166-1 alpha-2 code` as code,
				" . sql_for_langs($data['langs'], 'country_name_', '') . "
			FROM `countries_list`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'countries';
		$data['countries'] = array();
		$data_private['_empty']['countries'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['code'];
			add_empty_for_langs($d,$data_private['_empty']['countries'],$langs,array(''));
			unset($d['code']);
			$data['countries'][$key] = $d;
		}
		if (empty($data_private['_empty']['countries'])) unset($data_private['_empty']['countries']);

		$s = "SELECT 
				`iso4217_code_a` as code,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				`abbr`,
				" . sql_for_langs($data['langs'], 'country_', 'about_') . "
			FROM `currency`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'currencies';
		$data['currencies'] = array();
		$data_private['_empty']['currencies'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['code'];
			add_empty_for_langs($d,$data_private['_empty']['currencies'],$langs,array('', 'about_'));
			unset($d['code']);
			$data['currencies'][$key] = $d;
		}
		if (empty($data_private['_empty']['currencies'])) unset($data_private['_empty']['currencies']);
		
		$s = "SELECT 
				`currency` as code,
				`usd_this_rate`
			FROM `currency_usd_rate`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'currencies_rate';
		$data['currencies_rate'] = array();
		while (@$d = fetch_assoc($q))
		{
			$data['currencies_rate']['USD/' . $d['code']] = $d['usd_this_rate'];
		}

		$s = "SELECT 
				`id_date_feature` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `date_feature`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'date_features';
		$data['date_features'] = array();
		$data_private['_empty']['date_features'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['date_features'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['date_features'][$key] = $d;
		}
		if (empty($data_private['_empty']['date_features'])) unset($data_private['_empty']['date_features']);

		$s = "SELECT 
				`id_date_place` as id,
				`time_zone_n`,
				`timezone_a`,
				`work_time_start`,
				`work_time_complete`,
				`even_time_start`,
				`even_time_complete`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				(SELECT
					GROUP_CONCAT(`id_date_select` SEPARATOR ',')
				 FROM `date_place_select`
				 WHERE `date_place_select`.`id_date_place` = `date_place`.`id_date_place`
				) as date_select
			FROM `date_place`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'date_places';
		$data['date_places'] = array();
		$data_private['_empty']['date_places'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['date_places'],$langs,array('', 'about_'));
			unset($d['id']);
			if (!empty($d['date_select'])) $d['date_select'] = explode(',',$d['date_select']);
			$data['date_places'][$key] = $d;
		}
		if (empty($data_private['_empty']['date_places'])) unset($data_private['_empty']['date_places']);

		$s = "SELECT 
				`id_date_select` as id,
				`id_date_feature` as date_feature,
				`id_date_select_frequency` as date_select_frequency,
				`time`,
				`day`,
				`day_week`,
				`month`,
				`year`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `date_select`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'date_select';
		$data['date_select'] = array();
		$data_private['_empty']['date_select'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['date_select'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['date_select'][$key] = $d;
		}
		if (empty($data_private['_empty']['date_select'])) unset($data_private['_empty']['date_select']);		

		$s = "SELECT 
				`id_date_select_frequency` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `date_select_frequency`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'date_select_frequencies';
		$data['date_select_frequencies'] = array();
		$data_private['_empty']['date_select_frequencies'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['date_select_frequencies'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['date_select_frequencies'][$key] = $d;
		}
		if (empty($data_private['_empty']['date_select_frequencies'])) unset($data_private['_empty']['date_select_frequencies']);		

		$s = "SELECT 
				`id_driver_select_sorting` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `driver_select_sorting`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'drivers_select_sorting';
		$data['drivers_select_sorting'] = array();
		$data_private['_empty']['drivers_select_sorting'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['drivers_select_sorting'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['drivers_select_sorting'][$key] = $d;
		}
		if (empty($data_private['_empty']['drivers_select_sorting'])) unset($data_private['_empty']['drivers_select_sorting']);

		$s = "SELECT 
				`id_faq` as id,
				`id_faq_category` as 'group',
				" . sql_for_langs($data['langs'], 'name_', 'title_') . ",
				" . sql_for_langs($data['langs'], 'value_', 'content_') . "
			FROM `faq`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'faqs';
		$data['faqs'] = array();
		$data_private['_empty']['faqs'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['faqs'],$langs,array('title_','content_'));
			unset($d['id']);
			$data['faqs'][$key] = $d;
		}
		if (empty($data_private['_empty']['faqs'])) unset($data_private['_empty']['faqs']);

		$s = "SELECT 
				`id_faq_category` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `faq_category`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'faq_groups';
		$data['faq_groups'] = array();
		$data_private['_empty']['faq_groups'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['faq_groups'],$langs,array(''));
			unset($d['id']);
			$data['faq_groups'][$key] = $d;
		}
		if (empty($data_private['_empty']['faq_groups'])) unset($data_private['_empty']['faq_groups']);
	
		$s = "SELECT 
				`id_field_type` as id,
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`json`
			FROM `field_type`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'field_types';
		$data['field_types'] = array();
		$data_private['_empty']['field_types'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['field_types'],$langs,array('', 'about_'));
			$d['json'] = json_decode($d['json'],true);
			unset($d['id']);
			$data['field_types'][$key] = $d;
		}
		if (empty($data_private['_empty']['field_types'])) unset($data_private['_empty']['field_types']);	

		$s = "SELECT 
				`id_map_place` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`max_lat`,
				`min_lat`,
				`max_lng`,
				`min_lng`,
				`split_depth`,
				`timezone`,
				`id_map_place_upper` as upper
			FROM `map_place`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'map_places';
		$error_msg = array();
		$data['map_places'] = array();
		$data_private['_empty']['map_places'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['map_places'],$langs,array('','about_'));
			unset($d['id']);
			$d['max_lat'] = (float)$d['max_lat'];
			$d['min_lat'] = (float)$d['min_lat'];
			if ($d['max_lat'] <= $d['min_lat']) $error_msg[$key][] = 'maximum latitude less or equal than minimum';
			$d['max_lng'] = (float)$d['max_lng'];
			$d['min_lng'] = (float)$d['min_lng'];
			if ($d['max_lng'] <= $d['min_lng']) $error_msg[$key][] = 'maximum longitude less or equal than minimum';
			$d['split_depth'] = abs((int)$d['split_depth']);
			if (empty($d['split_depth'])) $error_msg[$key][] = 'empty split depth';
			$d['timezone'] = preg_replace('/\s+/','',$d['timezone']);
			preg_match('/(\+|-)[0-9]{2}\:[0-9]{2}/',$d['timezone'],$parsed_time_zone);
			if (empty($parsed_time_zone))
			{
				$error_msg[$key][] = 'wrong timezone';
			}
			else
			{
				$d['timezone'] = $parsed_time_zone[0];
			}
			if (!empty($error_msg))
			{
				$debug['mysql'][] = array('map_places' => $error_msg);
				continue;
			}
			$d['side_squares'] = pow(3,$d['split_depth']);		
			$d['square_lng']=($d['max_lng'] - $d['min_lng'])/$d['side_squares'];
			$d['square_lat']=($d['max_lat'] - $d['min_lat'])/$d['side_squares'];	
			$data['map_places'][$key] = $d;
		}
		if (empty($data_private['_empty']['map_places'])) unset($data_private['_empty']['map_places']);

		$s = "SELECT 
				`id_message_type` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `message_type`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'message_types';
		$data['message_types'] = array();
		$data_private['_empty']['message_types'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['message_types'],$langs,array('','about_'));
			unset($d['id']);
			$data['message_types'][$key] = $d;
		}
		if (empty($data_private['_empty']['message_types'])) unset($data_private['_empty']['message_types']);

		$s = "SELECT 
				`id_navigation`,
				`name`
			FROM `navigation_software`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'gps_softwares';
		$data['gps_softwares'] = array();
		while (@$d = fetch_assoc($q))
		{
			$data['gps_softwares'][$d['id_navigation']] = $d['name'];
		}
	
		$s = "SELECT 
				`id_order_cancel` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				(SELECT
					GROUP_CONCAT(`id_role` SEPARATOR ',')
				 FROM `roles_order_cancel`
				 WHERE `roles_order_cancel`.`id_order_cancel` = `order_cancel`.`id_order_cancel`
				) as user_roles
			FROM `order_cancel`
			WHERE
				`active` = '1'
			";

		$q = query($s);

		if ($q === false) $debug['mysql'][] = 'booking_cancel_states';
		$data['booking_cancel_states'] = array();
		$data_private['_empty']['booking_cancel_states'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['booking_cancel_states'],$langs,array(''));
			unset($d['id']);
			if (!empty($d['user_roles'])) $d['user_roles'] = explode(',',$d['user_roles']);
			$data['booking_cancel_states'][$key] = $d;
		}
		if (empty($data_private['_empty']['booking_cancel_states'])) unset($data_private['_empty']['booking_cancel_states']);

		$s = "SELECT 
				`id_order_comment` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `order_comment`
			WHERE
				`active` = '1'
			";

		$q = query($s);

		if ($q === false) $debug['mysql'][] = 'booking_comments';
		$data['booking_comments'] = array();
		$data_private['_empty']['booking_comments'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['booking_comments'],$langs,array(''));
			unset($d['id']);
			$data['booking_comments'][$key] = $d;
		}
		if (empty($data_private['_empty']['booking_comments'])) unset($data_private['_empty']['booking_comments']);

		$s = "SELECT 
				`id_order_driver_status` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `order_driver_status`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'booking_driver_states';
		$data['booking_driver_states'] = array();
		$data_private['_empty']['booking_driver_states'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['booking_driver_states'],$langs,array(''));
			unset($d['id']);
			$data['booking_driver_states'][$key] = $d;
		}
		if (empty($data_private['_empty']['booking_driver_states'])) unset($data_private['_empty']['booking_driver_states']);
	
		$s = "SELECT 
				`id_order_location` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				`location_table_name` as alias,
				IF(`id_order_location_upper` = '0',NULL,`id_order_location_upper`) as upper
			FROM `order_location`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'booking_location_classes';
		$data['booking_location_classes'] = array();
		$data_private['_empty']['booking_location_classes'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['booking_location_classes'],$langs,array(''));
			unset($d['id']);
			$data['booking_location_classes'][$key] = $d;
		}
		if (empty($data_private['_empty']['booking_location_classes'])) unset($data_private['_empty']['booking_location_classes']);
		uksort($data['booking_location_classes'],function ($id1,$id2) use ($data)
		{
			$upper1 = $data['booking_location_classes'][$id1]['upper'];
			$upper2 = $data['booking_location_classes'][$id2]['upper'];
			if (empty($upper1))
			{
				if (empty($upper2)) 
				{
					return 0;
				}
				else
				{
					return -1;
				}
			}
			elseif (empty($upper2))
			{
				return 1;
			}
			elseif ($id1 == $upper2)
			{
				if ($id2 == $upper1)
				{
					return 0;
				}
				else
				{
					return -1;
				}
			}
			elseif ($id2 == $upper1)
			{
				return 1;
			}
			return 0;
		});
		$data['booking_location_classes_sort'] = array();
		foreach($data['booking_location_classes'] as $key=>$value)
		{
			$data['booking_location_classes_sort'][] = $key;
		}
	
		$s = "SELECT 
				`id_order_prop` as id,
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`value_type`,
				`some`
			FROM `order_prop`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'order_props';
		$data['order_props'] = array();
		$data_private['_empty']['order_props'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['order_props'],$langs,array('', 'about_'));
			unset($d['id']);
			$data['order_props'][$key] = $d;
		}
		if (empty($data_private['_empty']['order_props'])) unset($data_private['_empty']['order_props']);	

		$s = "SELECT 
				`id_order_status` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `order_status`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'booking_states';
		$data['booking_states'] = array();
		$data_private['_empty']['booking_states'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['booking_states'],$langs,array(''));
			unset($d['id']);
			$data['booking_states'][$key] = $d;
		}
		if (empty($data_private['_empty']['booking_states'])) unset($data_private['_empty']['booking_states']);
		
		$s = "SELECT 
				`id_outer_script_template` as id,
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`url`,
				`headers_json`,
				`headers_json_export`,
				`post_json`,
				`post_json_export`,
				`urlencoded`,
				`u_id_export`,
				`only_admin`
			FROM `outer_script_template`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'outer_script_templates';
		$data_private['outer_script_templates'] = array();
		$data_private['_empty']['outer_script_templates'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['outer_script_templates'],$langs,array('','about_'));
			$d['headers_json'] = json_decode($d['headers_json'],true);
			$d['headers_json_export'] = json_decode($d['headers_json_export'],true);			
			$lower_arr = array();
			if (is_array($d['headers_json_export']))
			{
				foreach($d['headers_json_export'] as $key=>$arr)
				{
					$lower_arr[strtolower($key)] = $arr;
				}
			}
			$d['headers_json_export'] = $lower_arr;
			$d['post_json'] = json_decode($d['post_json'],true);
			$d['post_json_export'] = json_decode($d['post_json_export'],true);
			unset($d['id']);
			$data_private['outer_script_templates'][$key] = $d;
		}
		if (empty($data_private['_empty']['outer_script_templates'])) unset($data_private['_empty']['outer_script_templates']);

		$s = "SELECT 
				`id_owner_type` as id,
				`table`,
				`column`,
				`sql`,
				`delimiter`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `owner_type`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'owner_types';
		$data_private['owner_types'] = array();
		$data_private['_empty']['owner_types'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['owner_types'],$langs,array('','about_'));
			unset($d['id']);
			$data_private['owner_types'][$key] = $d;
		}
		if (empty($data_private['_empty']['owner_types'])) unset($data_private['_empty']['owner_types']);

		$s = "SELECT 
				`id_payment_method` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `payment_method`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'payment_ways';
		$data['payment_ways'] = array();
		$data_private['_empty']['payment_ways'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['payment_ways'],$langs,array(''));
			unset($d['id']);
			$data['payment_ways'][$key] = $d;
		}
		if (empty($data_private['_empty']['payment_ways'])) unset($data_private['_empty']['payment_ways']);

		$s = "SELECT 
				`id_price_time_function` as id,
				`parameter`,
				`formula`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "			
			FROM `price_time_function`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'price_time_functions';
		$data_private['price_time_functions'] = array();
		$data_private['_empty']['price_time_functions'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['price_time_functions'],$langs,array('','about_'));
			$d['parameter'] = json_decode($d['parameter'],true);
			$res = create_formula($d['formula'],$d['parameter'],"table__price_time_function__formula__$key");
			if (!empty($res['error']))
			{
				$debug['mysql'][] = "price_time_functions $key {$res['error']}";
				continue;
			}
			$d['formula_res'] = $res['formula'];
			$d['need'] = $res['need'];
			$data_function[] = $res['code'];
			unset($d['id']);
			$data_private['price_time_functions'][$key] = $d;
		}
		if (empty($data_private['_empty']['price_time_functions'])) unset($data_private['_empty']['price_time_functions']);		

		$s = "SELECT 
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `programming_language`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'programming_languages';
		$data['programming_languages'] = array();
		$data_private['_empty']['programming_languages'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['var'];
			add_empty_for_langs($d,$data_private['_empty']['programming_languages'],$langs,array('','about_'));
			unset($d['var']);
			$data['programming_languages'][$key] = $d;
		}
		if (empty($data_private['_empty']['programming_languages'])) unset($data_private['_empty']['programming_languages']);

		$s = "SELECT 
				`id_promocode` as id,
				`value`,
				`discount`,
				`max_products`,
				`max_payments`,
				`json`,
				`limit`,
				(SELECT
					GROUP_CONCAT(`id_schedule` SEPARATOR ',')
				 FROM `promocode_schedule`
				 WHERE `promocode_schedule`.`id_promocode` = `promocode`.`id_promocode`
				) as schedule
			FROM `promocode`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'promocodes';
		$data_private['promocodes'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			$d['json'] = json_decode($d['json'],true);
			add_time_zone($d['limit']);
			if (!empty($d['schedule'])) $d['schedule'] = explode(',',$d['schedule']);
			unset($d['id']);
			$data_private['promocodes'][$key] = $d;
		}

		$s = "SELECT 
				`id_region` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`active`,
				`country`,
				`id_region_upper` as upper,
				`sub-national` as sub_national,
				`code`
			FROM `region`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'regions';
		$data['regions'] = array();
		$data_private['_empty']['regions'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['regions'],$langs,array('','about_'));
			unset($d['id']);
			$data['regions'][$key] = $d;
		}
		if (empty($data_private['_empty']['regions'])) unset($data_private['_empty']['regions']);

		$s = "SELECT 
				`id_script_template` as id,
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`value` as file,
				`only_admin`
			FROM `script_template`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'script_templates';
		$data_private['script_templates'] = array();
		$data_private['_empty']['script_templates'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['script_templates'],$langs,array('','about_'));
			unset($d['id']);
			if (!empty($d['file'])) 
			{
				
				$id_file = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH . trim('script_templates/file/') . $d['file'];
				$id_value_file = $_SERVER['DOCUMENT_ROOT'] . CONFIG_USER_FILE_PATH . trim('script_templates/file/') . "{$key}_{$d['var']}.php";
				if ($id_file == $id_value_file)
				{
					$d['file'] = CONFIG_USER_FILE_PATH . trim('script_templates/file/') . "{$key}_{$d['var']}.php";
				}
				else
				{
					$s = "UPDATE `script_template`
						SET 
							`value` = '{$key}_{$d['var']}.php'
						WHERE
							`id_script_template` = '" . $key . "'
						";

					if (!query($s)) $debug['mysql'][] = "script_templates $key update";
					if (@rename($id_file,$id_value_file)) 
					{
						$d['file'] = CONFIG_USER_FILE_PATH . trim('script_templates/file/') . "{$key}_{$d['var']}.php";	
					}
					else
					{
						unset($d['file']);
						$debug['mysql'][] = "script_templates $key rename";
					}
				}
			}
			$data_private['script_templates'][$key] = $d;
		}
		if (empty($data_private['_empty']['script_templates'])) unset($data_private['_empty']['script_templates']);

		$s = "SELECT 
				`id_service` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `service`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'services';
		$data['services'] = array();
		$data_private['_empty']['services'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['services'],$langs,array(''));
			unset($d['id']);
			$data['services'][$key] = $d;
		}
		if (empty($data_private['_empty']['services'])) unset($data_private['_empty']['services']);

		$s = "SELECT 
				`var`,
				`id_category` as 'group',
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`value`,
				`private`
			FROM `site_constant`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'site_constants';
		$data['site_constants'] = array();
		$data_private['site_constants'] = array();
		$data_private['_empty']['site_constants'] = array();
		while (@$d = fetch_assoc($q))
		{
			$var = $d['var'];
			add_empty_for_langs($d,$data_private['_empty']['site_constants'],$langs,array('','about_'));
			unset($d['var']);
			if (!empty($d['private'])) 
			{
				unset($d['private']);
				$data_private['site_constants'][$var] = $d;
			}
			else
			{
				unset($d['private']);
				$data['site_constants'][$var] = $d;
			}
		}
		if (empty($data_private['_empty']['site_constants'])) unset($data_private['_empty']['site_constants']);

		$s = "SELECT 
				`id_site_constant_category` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `site_constant_category`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'site_constant_groups';
		$data['site_constant_groups'] = array();
		$data_private['_empty']['site_constant_groups'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['site_constant_groups'],$langs,array(''));
			unset($d['id']);
			$data['site_constant_groups'][$key] = $d;
		}
		if (empty($data_private['_empty']['site_constant_groups'])) unset($data_private['_empty']['site_constant_groups']);
	
		$s = "SELECT 
				`id_site_email` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`value`
			FROM `site_email`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'site_site_emails';
		$data['site_emails'] = array();
		$data_private['_empty']['site_emails'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['site_emails'],$langs,array('','about_'));
			unset($d['id']);
			$data['site_emails'][$key] = $d;
		}
		if (empty($data_private['_empty']['site_emails'])) unset($data_private['_empty']['site_emails']);
		
		$s = "SELECT 
				`var`,
				`value` as file,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `site_image`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'site_images';
		$data['site_images'] = array();
		$data_private['_empty']['site_images'] = array();
		while (@$d = fetch_assoc($q))
		{
			$var = $d['var'];
			add_empty_for_langs($d,$data_private['_empty']['site_images'],$langs,array('','about_'));
			unset($d['var']);
			if (!empty($d['file'])) $d['file'] = url($d['file'],CONFIG_FILE_PATH . trim('site_images/file/'));
			$data['site_images'][$var] = $d;
		}
		if (empty($data_private['_empty']['site_images'])) unset($data_private['_empty']['site_images']);

		$s = "SELECT 
				`id_site_word_table` as id,
				`table_web_alias` as alias
			FROM `site_word_table`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'site_word_tables';
		$data_private['site_word_tables'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			unset($d['id']);
			$data_private['site_word_tables'][$key] = $d;
		}	

		$s = "SELECT 
				`id_site_word_table_items` as id,
				`id_site_word_table` as 'table',
				`key1`,
				`key2`,
				(SELECT
					GROUP_CONCAT(`id_translator` SEPARATOR ',')
				 FROM `site_word_table_items_translator`
				 WHERE `site_word_table_items_translator`.`id_site_word_table_items` = `site_word_table_items`.`id_site_word_table_items`
				) as translators,
				(SELECT
					GROUP_CONCAT(`id_webapp` SEPARATOR ',')
				 FROM `site_word_table_items_webapp`
				 WHERE `site_word_table_items_webapp`.`id_site_word_table_items` = `site_word_table_items`.`id_site_word_table_items`
				) as webapps
			FROM `site_word_table_items`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'site_word_items';
		$data_private['site_word_items'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			if (!empty($d['translators'])) $d['translators'] = explode(',',$d['translators']);
			if (!empty($d['webapps'])) $d['webapps'] = explode(',',$d['webapps']);
			unset($d['id']);
			$data_private['site_word_items'][$key] = $d;
		}

		$s = "SELECT 
				`id_sql_category` as id,
				IF(`id_sql_category_upper` = '0',NULL,`id_sql_category_upper`) as upper,
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `sql_category`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'sql_classes';
		$data_private['sql_classes'] = array();
		$data_private['_empty']['sql_classes'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['sql_classes'],$langs,array('','about_'));
			unset($d['id']);
			$data_private['sql_classes'][$key] = $d;
		}
		if (empty($data_private['_empty']['sql_classes'])) unset($data_private['_empty']['sql_classes']);

		$s = "SELECT 
				`id_sql_template` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`value`,
				`only_admin`,
				(SELECT
					GROUP_CONCAT(CONCAT_WS('|',`id_sql_category`,`default`) SEPARATOR ';')
				 FROM `sql_category_template`
				 WHERE `sql_category_template`.`id_sql_template` = `sql_template`.`id_sql_template`
				) as sql_classes	
			FROM `sql_template`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'sql_templates';
		$data_private['sql_templates'] = array();
		$data_private['_empty']['sql_templates'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['sql_templates'],$langs,array('','about_'));
			$d['value'] = json_decode($d['value'],true);
			$statement = array();
			if (!empty($d['sql_classes']))
			{
				$d['sql_classes'] = explode(';',$d['sql_classes']);
				foreach ($d['sql_classes'] as $sc_key=>$value)
				{
					$d['sql_classes'][$sc_key] = explode('|',$value);
					
					$sql_class = $d['sql_classes'][$sc_key][0];
					$prev_sql_class = NULL;
					$sql_classes_find = array();
					$sql_classes_find[$sql_class] = true;
					if (empty($data_private['sql_classes'][$sql_class]) || empty($data_private['sql_classes'][$sql_class]['upper'])) continue;
					while (true)
					{
						$prev_sql_class = $sql_class;
						$sql_class = $data_private['sql_classes'][$sql_class]['upper'];
						if (isset($sql_classes_find[$sql_class])) continue 2;
						$sql_classes_find[$sql_class] = true;
						if (empty($data_private['sql_classes'][$sql_class]))
						{
							continue 2;
						}
						elseif (empty($data_private['sql_classes'][$sql_class]['upper'])) 
						{
							break;
						}
					}
					if ($data_private['sql_classes'][$sql_class]['var'] == 'statement')
					{
						if (isset($data_private['sql_classes'][$prev_sql_class]['var']) && substr($data_private['sql_classes'][$prev_sql_class]['var'],0,10) == 'statement_')
						{
							$statement_val = substr($data_private['sql_classes'][$prev_sql_class]['var'],10);
							if ($statement_val === '') continue;
							$statement[] = trim(strtolower(substr($data_private['sql_classes'][$prev_sql_class]['var'],10)));
						}
					}
				}
			}
			$d['statement'] = $statement;
			unset($d['id']);
			$data_private['sql_templates'][$key] = $d;
		}
		if (empty($data_private['_empty']['sql_classes'])) unset($data_private['_empty']['sql_classes']);

		$s = "SELECT 
				`id_tariff` as id,
				`price`,
				`currency`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`id_tariff_duration_type` as duration_class,	
				`max_priority` as max_priority_value,
				`priority` as priority_value
			FROM `tariff`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'tariffs';
		$data['tariffs'] = array();
		$data_private['_empty']['tariffs'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['tariffs'],$langs,array('','about_'));
			unset($d['id']);
			$data['tariffs'][$id] = $d;
		}
		if (empty($data_private['_empty']['tariffs'])) unset($data_private['_empty']['tariffs']);

		$s = "SELECT 
				`id_tariff_duration_type` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				`duration` as duration_sec
			FROM `tariff_duration_type`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'tariff_duration_classes';
		$data['tariff_duration_classes'] = array();
		$data_private['_empty']['tariff_duration_classes'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['tariff_duration_classes'],$langs,array(''));
			unset($d['id']);
			$data['tariff_duration_classes'][$key] = $d;
		}
		if (empty($data_private['_empty']['tariff_duration_classes'])) unset($data_private['_empty']['tariff_duration_classes']);

		$s = "SELECT 
				`id_task_action` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`parameter`,
				`json`
			FROM `task_action`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'task_actions';
		$data['task_actions'] = array();
		$data_private['_empty']['task_actions'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['task_actions'],$langs,array('','about_'));
			$d['json'] = json_decode($d['json'],true);
			unset($d['id']);
			$data['task_actions'][$id] = $d;
		}
		if (empty($data_private['_empty']['task_actions'])) unset($data_private['_empty']['task_actions']);

		$s = "SELECT 
				`id_task_action_control` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`json`
			FROM `task_action_control`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'task_action_controls';
		$data['task_action_controls'] = array();
		$data_private['_empty']['task_action_controls'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['task_action_controls'],$langs,array('','about_'));
			$d['json'] = json_decode($d['json'],true);
			unset($d['id']);
			$data['task_action_controls'][$id] = $d;
		}
		if (empty($data_private['_empty']['task_action_controls'])) unset($data_private['_empty']['task_action_controls']);
		
		$s = "SELECT 
				`id_task_action_function` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`json`,
				(SELECT
					IF(`index` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS(0x00,
								`index`,
								`id_task_action`,
								`parameter`
							)
						SEPARATOR 0x01)
					)
				 FROM `task_action_function_row`
				 WHERE `id_task_action_function` = `task_action_function`.`id_task_action_function`
				) as 'row'
			FROM `task_action_function`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'task_action_functions';
		$data['task_action_functions'] = array();
		$data_private['_empty']['task_action_functions'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['task_action_functions'],$langs,array('','about_'));
			if (!empty($d['row']))
			{
				$d['row'] = explode(chr(1),$d['row']);
				foreach ($d['row'] as $sbkey=>$value)
				{
					$d['row'][$sbkey] = array();
					list(
						$d['row'][$sbkey]['index'],
						$d['row'][$sbkey]['task_action'],
						$d['row'][$sbkey]['parameter']
					)= explode(chr(0),$value);
				}
				usort($d['row'],function ($arr1,$arr2)
				{
					$index1 = $arr1['index'];
					$index2 = $arr2['index'];
					if ($index1 > $index1) 
					{
						return 1;
					}
					elseif ($index1 < $index2)
					{
						return -1;
					}
					else
					{
						return 0;
					}
				});	
			}
			$d['json'] = json_decode($d['json'],true);
			unset($d['id']);
			$data['task_action_functions'][$id] = $d;
		}
		if (empty($data_private['_empty']['task_action_functions'])) unset($data_private['_empty']['task_action_functions']);	
		
		$s = "SELECT 
				`id_task_comment` as id,
				`value`
			FROM `task_comment`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'task_comments';
		$data_private['task_comments'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			unset($d['id']);
			$data_private['task_comments'][$id] = $d;
		}

		$s = "SELECT 
				`id_task_status` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `task_status`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'task_statuses';
		$data['task_statuses'] = array();
		$data_private['_empty']['task_statuses'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['task_statuses'],$langs,array('','about_'));
			unset($d['id']);
			$data['task_statuses'][$id] = $d;
		}
		if (empty($data_private['_empty']['task_statuses'])) unset($data_private['_empty']['task_statuses']);

		$s = "SELECT 
				`id_ticket_prop` as id,
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`value_type`,
				`some`,
				(SELECT
					GROUP_CONCAT(`id_role` SEPARATOR ',')
				 FROM `ticket_prop_roles_edit`
				 WHERE `ticket_prop_roles_edit`.`id_ticket_prop` = `ticket_prop`.`id_ticket_prop`
				) as roles_edit,
				(SELECT
					GROUP_CONCAT(`id_role` SEPARATOR ',')
				 FROM `ticket_prop_roles_view`
				 WHERE `ticket_prop_roles_view`.`id_ticket_prop` = `ticket_prop`.`id_ticket_prop`
				) as roles_view
			FROM `ticket_prop`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'ticket_props';
		$data['ticket_props'] = array();
		$data_private['_empty']['ticket_props'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['ticket_props'],$langs,array('', 'about_'));
			if (!empty($d['roles_edit'])) $d['roles_edit'] = explode(',',$d['roles_edit']);
			if (!empty($d['roles_view'])) $d['roles_view'] = explode(',',$d['roles_view']);
			unset($d['id']);
			$data['ticket_props'][$key] = $d;
		}
		if (empty($data_private['_empty']['ticket_props'])) unset($data_private['_empty']['ticket_props']);	

		$s = "SELECT 
				`id_ticket_status` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `ticket_status`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'ticket_statuses';
		$data['ticket_statuses'] = array();
		$data_private['_empty']['ticket_statuses'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['ticket_statuses'],$langs,array('','about_'));
			unset($d['id']);
			$data['ticket_statuses'][$id] = $d;
		}
		if (empty($data_private['_empty']['ticket_statuses'])) unset($data_private['_empty']['ticket_statuses']);

		$s = "SELECT 
				`id_translate_type` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `translate_type`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'translate_types';
		$data['translate_types'] = array();
		$data_private['_empty']['translate_types'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['translate_types'],$langs,array('','about_'));
			unset($d['id']);
			$data['translate_types'][$id] = $d;
		}
		if (empty($data_private['_empty']['translate_types'])) unset($data_private['_empty']['translate_types']);
		
		$s = "SELECT 
				`id_translator` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`id_translate_type`	as type,
				`id_user` as u_id
			FROM `translator`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'translators';
		$data_private['translators'] = array();
		$data_private['_empty']['translators'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['translators'],$langs,array('','about_'));
			unset($d['id']);
			$data_private['translators'][$id] = $d;
		}
		if (empty($data_private['_empty']['translators'])) unset($data_private['_empty']['translators']);		

		$s = "SELECT 
				`id_unit_of_length` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'symbol_', 'symbol_') . ",
				`this_mm_rate`
			FROM `unit_of_length`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'units_of_length';
		$data['units_of_length'] = array();
		$data_private['_empty']['units_of_length'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['units_of_length'],$langs,array('','symbol_'));
			unset($d['id']);
			$data['units_of_length'][$key] = $d;
		}
		if (empty($data_private['_empty']['units_of_length'])) unset($data_private['_empty']['units_of_length']);
		
		$s = "SELECT 
				`id_unit_of_mass` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'symbol_', 'symbol_') . ",
				`this_gram_rate`
			FROM `unit_of_mass`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'units_of_mass';
		$data['units_of_mass'] = array();
		$data_private['_empty']['units_of_mass'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['units_of_mass'],$langs,array('','symbol_'));
			unset($d['id']);
			$data['units_of_mass'][$key] = $d;
		}
		if (empty($data_private['_empty']['units_of_mass'])) unset($data_private['_empty']['units_of_mass']);
		
		$s = "SELECT 
				`id_unit_of_volume` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'symbol_', 'symbol_') . ",
				`this_mm³_rate`
			FROM `unit_of_volume`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'units_of_volume';
		$data['units_of_volume'] = array();
		$data_private['_empty']['units_of_volume'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['units_of_volume'],$langs,array('','symbol_'));
			unset($d['id']);
			$data['units_of_volume'][$key] = $d;
		}
		if (empty($data_private['_empty']['units_of_volume'])) unset($data_private['_empty']['units_of_volume']);
		
		$s = "SELECT 
				`unit_set_str` as id,
				`weight`,
				`volume`,
				`height`,
				`length`,
				`width`
			FROM `unit_set`
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'unit_sets';
		$data['unit_sets'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			unset($d['id']);
			$data['unit_sets'][$key] = $d;
		}
		
		$s = "SELECT 
				`id_role` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `users_roles`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'user_roles';
		$data['user_roles'] = array();
		$data_private['_empty']['user_roles'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['user_roles'],$langs,array(''));
			unset($d['id']);
			$data['user_roles'][$key] = $d;
		}
		if (empty($data_private['_empty']['user_roles'])) unset($data_private['_empty']['user_roles']);

		$s = "SELECT 
				`id_users_prop` as id,
				`var`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`value_type`,
				`some`,
				`private`,
				(SELECT
					GROUP_CONCAT(`id_role` SEPARATOR ',')
				 FROM `users_prop_roles_edit`
				 WHERE `users_prop_roles_edit`.`id_users_prop` = `users_prop`.`id_users_prop`
				) as roles_edit
			FROM `users_prop`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'users_props';
		$data['users_props'] = array();
		$data_private['_empty']['users_props'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['users_props'],$langs,array('', 'about_'));
			if (!empty($d['roles_edit'])) $d['roles_edit'] = explode(',',$d['roles_edit']);
			unset($d['id']);
			$data['users_props'][$key] = $d;
		}
		if (empty($data_private['_empty']['users_props'])) unset($data_private['_empty']['users_props']);

		$s = "SELECT 
				`id_users_verification_status` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . "
			FROM `users_verification_status`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'user_check_states';
		$data['user_check_states'] = array();
		$data_private['_empty']['user_check_states'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['user_check_states'],$langs,array(''));
			unset($d['id']);
			$data['user_check_states'][$key] = $d;
		}
		if (empty($data_private['_empty']['user_check_states'])) unset($data_private['_empty']['user_check_states']);

		$s = "SELECT 
				`id_webapp` as id,
				`var`,
				`host`,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `webapp`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'webapps';
		$data['webapps'] = array();
		$data_private['_empty']['webapps'] = array();
		while (@$d = fetch_assoc($q))
		{
			$id = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['webapps'],$langs,array('','about_'));
			unset($d['id']);
			$data['webapps'][$id] = $d;
		}
		if (empty($data_private['_empty']['webapps'])) unset($data_private['_empty']['webapps']);

		$s = "SELECT 
				`id_stadium` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				" . sql_for_langs($data['langs'], 'address_', 'address_') . ",
				`scheme`,
				`id_city` as city,
				`country`,
				(SELECT
					IF(`id_seat` IS NULL,NULL,
						GROUP_CONCAT(
							CONCAT_WS(0x00,
								`block`,
								`row`,
								`seat`,
								IFNULL(`tariff`,0x02),
								IFNULL(`currency`,0x02)
							)
						SEPARATOR 0x01)
					)
				 FROM `stadium_seats`
				 WHERE `id_stadium` = `stadium`.`id_stadium` AND `active` = '1'
				) as seats_obj,
				`seats` as seats,
				`scheme_link` as scheme_blob
			FROM `stadium`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'stadiums';
		$data_stadium_team_tournament['stadiums'] = array();
		$data_private['_empty']['stadiums'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['stadiums'],$langs,array('','about_','address_'));
			if (!empty($d['seats_obj'])){
				$d['seats_obj'] = explode(chr(1),$d['seats_obj']);
				foreach ($d['seats_obj'] as $sbkey=>$value)
				{
					$d['seats_obj'][$sbkey] = array();
					list(
						$d['seats_obj'][$sbkey][0][0],		//block
						$d['seats_obj'][$sbkey][0][1],		//row
						$d['seats_obj'][$sbkey][0][2],		//seat
						$d['seats_obj'][$sbkey][1],			//tariff
						$d['seats_obj'][$sbkey][2]			//currency
					)= explode(chr(0),$value);
					if ($d['seats_obj'][$sbkey][1] == chr(2)) 
					{
						unset($d['seats_obj'][$sbkey][1]);
						unset($d['seats_obj'][$sbkey][2]);
					}
					elseif ($d['seats_obj'][$sbkey][2] == chr(2)) 
					{
						unset($d['seats_obj'][$sbkey][2]);
					}
				}

				$folder = $_SERVER['DOCUMENT_ROOT'] . CONFIG_FILE_PATH . 'stadiums/seats_obj/';
				if (is_file($folder))
				{
					$debug['mysql'][] = 'stadiums/seats_obj/ is file';
				}
				else
				{
					if (!file_exists($folder)) mkdir($folder,0777,true);
				}
				@$file = file_put_contents("$folder{$d['id']}.json",json_encode($d['seats_obj']));
				if (!$file) $debug['mysql'][] = 'stadiums/seats_obj/ write';
				$d['seats_obj'] = url("{$d['id']}.json",CONFIG_FILE_PATH . trim('stadiums/seats_obj/'));
			}
			unset($d['id']);
			$d['seats'] = json_decode($d['seats'],true);
			if (!empty($d['scheme_blob'])) $d['scheme_blob'] = url($d['scheme_blob'],CONFIG_FILE_PATH . trim('stadiums/scheme_blob/'));
			$data_stadium_team_tournament['stadiums'][$key] = $d;
		}
		if (empty($data_private['_empty']['stadiums'])) unset($data_private['_empty']['stadiums']);

		$s = "SELECT 
				`id_team` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . ",
				`id_stadium` as stadium,
				`id_city` as city,
				`country`,
				`logo`,
				`autonomous area` as sub_country
			FROM `team`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'teams';
		$data_stadium_team_tournament['teams'] = array();
		$data_private['_empty']['teams'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['teams'],$langs,array('','about_'));
			unset($d['id']);
			if (!empty($d['logo'])) $d['logo'] = url($d['logo'],CONFIG_FILE_PATH . trim('teams/logo/'));
			$data_stadium_team_tournament['teams'][$key] = $d;
		}
		if (empty($data_private['_empty']['teams'])) unset($data_private['_empty']['teams']);
		
		$s = "SELECT 
				`id_tournament` as id,
				" . sql_for_langs($data['langs'], 'name_', '') . ",
				" . sql_for_langs($data['langs'], 'description_', 'about_') . "
			FROM `tournament`
			WHERE
				`active` = '1'
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'tournaments';
		$data_stadium_team_tournament['tournaments'] = array();
		$data_private['_empty']['tournaments'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_empty_for_langs($d,$data_private['_empty']['tournaments'],$langs,array('','about_'));
			unset($d['id']);
			$data_stadium_team_tournament['tournaments'][$key] = $d;
		}
		if (empty($data_private['_empty']['tournaments'])) unset($data_private['_empty']['tournaments']);

		$s = "SELECT
				`id_schedule` as id,
				`team1`,
				`team2`,
				`id_stadium` as stadium,
				`id_tournament` as tournament,
				`start_datetime` as datetime,
				`duration`,
				`only_date`,
				`top`,
				`options`,
				`time_zone`,
				`id_price_time_function` as price_time_function,
				`currency`,
				`currency_priority`,
				`fee`,
				`tariff`,
				`tariff_priority`,
				`code_ean_base64`
			FROM `schedule`
			WHERE
				`active` = '1' and `start_datetime` >= now()
			";

		$q = query($s);
		if ($q === false) $debug['mysql'][] = 'schedule';
		$data_schedule['schedule'] = array();
		while (@$d = fetch_assoc($q))
		{
			$key = $d['id'];
			add_time_zone($d['datetime']);
			$d['options'] = json_decode($d['options'],true);
			unset($d['id']);
			$data_schedule['schedule'][$key] = $d;
		}			

		if (empty($data['site_constants']['the_language_of_the_service']['value'])
			|| empty($data['langs'][$js_default_lang = abs((int)$data['site_constants']['the_language_of_the_service']['value'])])) 
		{
			$js_default_lang = 1;
		}
		if (empty($data['site_constants']['currency_of_the_service']['value'])
			|| empty($data['currencies'][$js_default_currency = strtoupper(trim($data['site_constants']['currency_of_the_service']['value']))])) 
		{
			$js_default_currency = 'RUB';
		}

		if (empty($data['site_constants']['service_country']['value'])
			|| empty($data['countries'][$js_default_country = strtolower(trim($data['site_constants']['service_country']['value']))])) 
		{
			$js_default_country = '';
		}

		if (empty($data['site_constants']['service_profile']['value']) )
		{
			$js_default_profile = '';
		}
		else
		{
			$js_default_profile = strtolower(trim($data['site_constants']['service_profile']['value']));
		}

		$php = 'taxi::$data = ' . var_export($data,true) . ';';
		$php .= "\n".'taxi::$data_private = ' . var_export($data_private,true) . ';';
		if (!empty($data_function))
		{
			$data_function = implode("\n",$data_function);
			$php .= "\n$data_function";
		}
		$js = 'var default_lang = ' . $js_default_lang . ";\n"
			. 'var default_currency = \'' . $js_default_currency . "';\n"
			. 'var default_country = \'' . $js_default_country . "';\n"
			. 'var default_profile = \'' . $js_default_profile . "';\n"
			. 'var data = ' . json_encode($data) . ';';

		$version = var_export(microtime(true),true) . '_' . md5($js) . '_' . strtolower(dechex(crc32($js))) . '_' . strlen($js);

		$php = '<?php taxi::$version = \'' . $version . "';\n" . $php;
		$js = "var version = '" . $version . "';\n" . $js;
		$json = array(
					'version'			=>		$version,
					'default_lang'		=>		$js_default_lang,
					'default_currency'	=>		$js_default_currency,
					'default_country'	=>		$js_default_country,
					'default_profile'	=>		$js_default_profile,
					'data'				=>		$data
		);
		
		$php2 = 'taxi::$data_stt = ' . var_export($data_stadium_team_tournament,true) . ';';
		$php2 = '<?php taxi::$version_stt = \'' . $version . "';\n" . $php2;
		
		$php3 = 'taxi::$data_sc = ' . var_export($data_schedule,true) . ';';
		$php3 = '<?php taxi::$version_sc = \'' . $version . "';\n" . $php3;
			
		@$file = file_put_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.php', $php);
		if (!$file) $debug['php'][] = 'write';

		@$file = file_put_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.js', $js);
		if (!$file) $debug['js'][] = 'write';

		@$file = file_put_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(iso).json', json_encode($json));
		if (!$file) $debug['iso json'][] = 'write';

		foreach(array('car_bodies','car_colors','car_makes','car_models','countries','faq_groups','booking_cancel_states','booking_comments','booking_driver_states','booking_location_classes','booking_states','payment_ways','services','site_constant_groups','tariff_duration_classes','user_roles','user_check_states') as $d_key)
		{
			foreach ($data['langs'] as $id=>$lang)
			{
				foreach($json['data'][$d_key] as $key=>$value)
				{
					$json['data'][$d_key][$key][$id] = $json['data'][$d_key][$key][$lang['iso']];
					unset($json['data'][$d_key][$key][$lang['iso']]);
				}
			}	
		}
		foreach(array('car_classes','cities','contact_classes','currencies','drivers_select_sorting','site_constants','site_emails','tariffs') as $d_key)
		{
			foreach ($data['langs'] as $id=>$lang)
			{
				foreach($json['data'][$d_key] as $key=>$value)
				{	
					$json['data'][$d_key][$key][$id] = $json['data'][$d_key][$key][$lang['iso']];
					unset($json['data'][$d_key][$key][$lang['iso']]);
					$json['data'][$d_key][$key]['about_' . $id] = $json['data'][$d_key][$key]['about_' . $lang['iso']];
					unset($json['data'][$d_key][$key]['about_' . $lang['iso']]);
				}
			}	
		}
		foreach(array('faqs') as $d_key)
		{
			foreach ($data['langs'] as $id=>$lang)
			{
				foreach($json['data'][$d_key] as $key=>$value)
				{
					$json['data'][$d_key][$key]['title_' . $id] = $json['data'][$d_key][$key]['title_' . $lang['iso']];
					unset($json['data'][$d_key][$key]['title_' . $lang['iso']]);
					$json['data'][$d_key][$key]['content_' . $id] = $json['data'][$d_key][$key]['content_' . $lang['iso']];
					unset($json['data'][$d_key][$key]['content_' . $lang['iso']]);
				}
			}	
		}

		$json = json_encode($json);

		@$file = file_put_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.json', $json);
		if (!$file) $debug['json'][] = 'write';

		@$file = file_put_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(stt).php', $php2);
		if (!$file) $debug['php2'][] = 'write';

		@$file = file_put_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(sc).php', $php3);
		if (!$file) $debug['php3'][] = 'write';
		
		if (empty($debug['php']))
		{
			@$php = file($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.php');
			if (!$php) 
			{
				$debug['php'][] = 'read';
			}
			else
			{
				$php_version = explode("'", $php[0]);
				if (!empty($php_version[1])) 
				{
					$php_version = $php_version[1];
				}
				else
				{
					$php_version = '';
				}
				if ($php_version !== $version) $debug['php'][] = 'version';
			}
		}

		if (empty($debug['js']))
		{
			@$js = file($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.js');
			if (!$js) 
			{
				$debug['js'][] = 'read';
			}
			else
			{
				$js_version = explode("'", $js[0]);
				if (!empty($js_version[1])) 
				{
					$js_version = $js_version[1];
				}
				else
				{
					$js_version = '';
				}
				if ($js_version !== $version) $debug['js'][] = 'version';
			}
		}

		if (empty($debug['iso json']))
		{
			@$json = file_get_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(iso).json');
			if (!$json) 
			{
				$debug['iso json'][] = 'read';
			}
			else
			{
				$json = json_decode($json,true);
				if (!empty($json['version'])) 
				{
					$json_version = $json['version'];
				}
				else
				{
					$json_version = '';
				}
				if ($json_version !== $version) $debug['iso json'][] = 'version';
			}
		}

		if (empty($debug['json']))
		{
			@$json = file_get_contents($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.json');
			if (!$json) 
			{
				$debug['json'][] = 'read';
			}
			else
			{
				$json = json_decode($json,true);
				if (!empty($json['version'])) 
				{
					$json_version = $json['version'];
				}
				else
				{
					$json_version = '';
				}
				if ($json_version !== $version) $debug['json'][] = 'version';
			}
		}

		if (empty($debug['php2']))
		{
			@$php = file($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(stt).php');
			if (!$php) 
			{
				$debug['php2'][] = 'read';
			}
			else
			{
				$php_version = explode("'", $php[0]);
				if (!empty($php_version[1])) 
				{
					$php_version = $php_version[1];
				}
				else
				{
					$php_version = '';
				}
				if ($php_version !== $version) $debug['php2'][] = 'version';
			}
		}

		if (empty($debug['php3']))
		{
			@$php = file($_SERVER['DOCUMENT_ROOT'] . CONFIG_CACHE . '.(sc).php');
			if (!$php) 
			{
				$debug['php3'][] = 'read';
			}
			else
			{
				$php_version = explode("'", $php[0]);
				if (!empty($php_version[1])) 
				{
					$php_version = $php_version[1];
				}
				else
				{
					$php_version = '';
				}
				if ($php_version !== $version) $debug['php3'][] = 'version';
			}
		}

		return array('error' => $debug, 'version' => $version);
	}

	function sql_for_langs($langs = array(), $db_prefix = '', $out_prefix = '')
	{
		if (empty($langs)) return '';
		$sql = array();
		foreach ($langs as $lang)
		{
			$sql[] = '`' . str_replace("`","``",$db_prefix) . $lang['iso'] . '` as \'' 
				   . str_replace("'","\\'",str_replace("\\","\\\\",$out_prefix)) . $lang['iso'] . '\'';	
		}
		return implode(",\n",$sql);
	}

	function openssl____encrypt($str = '')
	{
		$key = md5(OPENSSL____ENCRYPT_KEY);
		$ivlen = openssl_cipher_iv_length($cipher="AES-128-CBC");
		$iv = openssl_random_pseudo_bytes($ivlen);
		$ciphertext_raw = openssl_encrypt($str, $cipher, $key, $options=OPENSSL_RAW_DATA, $iv);
		$hmac = hash_hmac('sha256', $ciphertext_raw, $key, $as_binary=true);
		$ciphertext = base64_encode( $iv.$hmac.$ciphertext_raw );
		return $ciphertext;
	}

	function openssl____decrypt($str = '')
	{
		$key = md5(OPENSSL____ENCRYPT_KEY);
		$c = base64_decode($str);
		$ivlen = openssl_cipher_iv_length($cipher="AES-128-CBC");
		$iv = substr($c, 0, $ivlen);
		$hmac = substr($c, $ivlen, $sha2len=32);
		$ciphertext_raw = substr($c, $ivlen+$sha2len);
		$original_plaintext = openssl_decrypt($ciphertext_raw, $cipher, $key, $options=OPENSSL_RAW_DATA, $iv);
		$calcmac = hash_hmac('sha256', $ciphertext_raw, $key, $as_binary=true);
		if (@hash_equals($hmac, $calcmac)) return $original_plaintext; else return false;
	}

	function create_token()
	{
		return md5(microtime() . md5(CREATE_TOKEN_STRING . time()));
	}

	function get_u_hash($token = '', $id_user = '')
	{
		return openssl____encrypt($id_user . '_' . md5(U_HASH_SECRET . md5($token)));
	}

	function parse_u_hash($str = '', $token = '')
	{
		$str = openssl____decrypt($str);
		if ($str === false) return false;
		$arr = explode('_', $str);
		if (isset($arr[1]) && $arr[1] === md5(U_HASH_SECRET . md5($token)))
		{
			return $arr[0];
		}
		return false;
	}

	if(!function_exists('hash_equals')) {
		function hash_equals($str1, $str2) {
			if(strlen($str1) != strlen($str2)) 
			{
				return false;
			} 
			else 
			{
				$res = $str1 ^ $str2;
				$ret = 0;
				for($i = strlen($res) - 1; $i >= 0; $i--) $ret |= ord($res[$i]);
				return !$ret;
			}
		}
	}

	function get_token($id_user = '')
	{
		$q = query("BEGIN");
		if ($q === false) return 0;
		
		$s = "SELECT 
				`token`
			FROM `token`
			WHERE
				`id_user` = '" . $id_user . "'
			FOR UPDATE
			";

		$q = query($s);
		if ($q === false) 
		{
			$q = query("ROLLBACK");
			if ($q === false) {return -2;} else {return -1;}
		}
		$d = fetch_assoc($q);
		if (isset($d['token']))
		{
			return $d['token'];
		}
		else
		{
			global $link;
			do {
				$token = create_token();
				$s = "INSERT IGNORE INTO `token`
					SET 
						`token` = '" . $token . "',
						`id_user` = '" . $id_user . "'
					";

				$q = query($s);
			} while (mysqli_affected_rows($link) == 0);
			if (mysqli_affected_rows($link) == -1) return -3;

			$q = query("COMMIT");
			if ($q === false) return -4;

			return $token;
		}
	}

	function token_exists($token = '', $id_user = '')
	{
		$s = "SELECT 
				`token`
			FROM `token`
			WHERE
				`id_user` = '" . $id_user . "' AND `token` = '" . $token . "'
			";

		$q = query($s);
		if ($q === false) return 0;
		$d = fetch_assoc($q);
		if (isset($d['token']))
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	function add_time_zone(&$date_str)
	{
		$date_str = empty($date_str) || $date_str === '0000-00-00 00:00:00' ? NULL : $date_str . MYSQL_TIME_ZONE;
	}

	function replaceIfBlocks($key = "", $value = "", $str = "")
	{
		if (empty($key))
		{
			return $str;
		}
		else
		{
			$resStr = "";
			$strLen = strlen($str);
			$keyStr = 'if' . substr($key,0,strlen($key) - 1) . '=';
			$keyStrLen = strlen($keyStr);

			$searchPos = 0;
			while ($searchPos < $strLen) 
			{
				$keyStrPos = strpos($str,$keyStr,$searchPos);
				if ($keyStrPos === false) 
				{
					$resStr .= substr($str,$searchPos);
					break;
				}
				$searchStartQuotePos = $keyStrPos + $keyStrLen;
				$l_o = substr($str,$searchStartQuotePos,2);
				if ($l_o != '="' && $l_o != '<"' && $l_o != '>"') {
					$resStr .= substr($str,$searchPos,$searchStartQuotePos - $searchPos);
					$searchPos = $searchStartQuotePos;
					continue;
				}
				$l_o = $l_o[0];
				$searchStartQuotePos += 2;
				$searchQuotePos = $searchStartQuotePos;

				$quotePos = false;
				while ($searchQuotePos < $strLen) 
				{
					$quotePos = strpos($str,'"}`',$searchQuotePos);
					if ($quotePos !== false) {
						$valStr = substr($str,$searchQuotePos,$quotePos - $searchQuotePos);
						$i = strlen($valStr) - 1;
						if ($i < 0 || substr($valStr,$i,1) != "\\")
						{
							break;
						}
						else
						{
							$count = 1;
							for ($i--; $i >= 0; $i--) 
							{
								if (substr($valStr,$i,1) != "\\") 
								{
									break;
								}
								$count++;
							}
							if ($count % 2 == 0)
							{
								break;
							}
							else
							{
								$searchQuotePos = $quotePos + 3;
								$quotePos = false;
							}
						}
					} else {
						break;
					}
				}
				
				$resStr .= substr($str,$searchPos,$keyStrPos - $searchPos);
				
				if ($quotePos !== false) 
				{
					$valStr = substr($str,$searchStartQuotePos,$quotePos - $searchStartQuotePos);
					$searchQuotePos = $quotePos + 3;
					$quotePos = strpos($str,'`',$searchQuotePos);
					if ($quotePos !== false) 
					{
						$valStr = stripslashesQuoteSlash($valStr);
						if (c_if($value,$l_o,$valStr)) {$ifFlag = true;} else {$ifFlag = false;};
						if ($ifFlag === true) 
						{
							$resStr .= substr($str,$searchQuotePos,$quotePos - $searchQuotePos);
						}
						$searchQuotePos = $quotePos + 1;
						if ($str[$searchQuotePos] == '`')
						{
							$searchQuotePos++;
							$quotePos = strpos($str,'`',$searchQuotePos);
							if ($quotePos !== false) 
							{
								if ($ifFlag === false) 
								{
									$resStr .= substr($str,$searchQuotePos,$quotePos - $searchQuotePos);
								}
							}
							else
							{
								$resStr .= substr($str,--$searchQuotePos);
								break;
							}
						}
						$searchPos = $quotePos + 1;
					}
					else
					{
						$resStr .= substr($str,$keyStrPos);
						break;
					}
				}
				else
				{
					$resStr .= substr($str,$keyStrPos);
					break;
				}
			}
			return $resStr;
		}
	}

	function stripslashesQuoteSlash($str = "")
	{
		$resStr = "";
		$strLen = strlen($str);
		$searchPos = 0;

		while ($searchPos < $strLen) 
		{
			$slashePos = strpos($str,'\\',$searchPos);

			if ($slashePos !== false) 
			{
				$resStr .= substr($str,$searchPos,$slashePos - $searchPos);
				$slashePos++;

				if ($slashePos < $strLen && ($str[$slashePos] == '\\' || $str[$slashePos ] == '"'))
				{
					$resStr .= $str[$slashePos];
				}
				else
				{
					$resStr .= substr($str,$slashePos-1,2);
				}
				$searchPos = $slashePos + 1;

			}
			else
			{
				$resStr .= substr($str,$searchPos);
				break;
			}
		}
		return $resStr;
	}

	function c_if($x, $o, $y)
	{
		if ($o == '=') return $x == $y;
		if ($o == '<') return $x < $y;
		if ($o == '>') return $x > $y;
	}

	function replaceForeachBlocks($key = "", $value = "", $str = "")
	{
		if (empty($key))
		{
			return $str;
		}
		else
		{
			if (!is_array($value)) return $str;
			$resStr = "";
			$strLen = strlen($str);
			$keyStr = substr($key,0,strlen($key) - 1) . ';foreach';
			$keyStrLen = strlen($keyStr);

			$searchPos = 0;
			while ($searchPos < $strLen) 
			{
				$opt = false;
				$keyStrPos = strpos($str,$keyStr,$searchPos);
				if ($keyStrPos === false) 
				{
					$resStr .= substr($str,$searchPos);
					break;
				}
				$searchStartPos = $keyStrPos + $keyStrLen;
				$sub_str = substr($str,$searchStartPos,1);
				if ($sub_str == ';') {
					if (substr($str,$searchStartPos+1,1) == '}')
					{
						if (substr($str,$searchStartPos+2,1) == '`')
						{
							$opt = array('key'	=>	array('*'),
										 'if'	=>	array('')
									);
							$charPos = $searchStartPos+3;
						}
						else
						{
							$resStr .= substr($str,$searchPos,$searchStartPos - $searchPos + 2);
							$searchPos = $searchStartPos+2;
							continue;
						}
					}
					else
					{
						$searchStartPos += 1;
						$searchCharPos = $searchStartPos;
						$charPos = false;
						while ($searchCharPos < $strLen) 
						{
							$charPos = strpos($str,'}`',$searchCharPos);
							if ($charPos !== false) {
								$optStr = substr($str,$searchCharPos,$charPos - $searchCharPos);
								$opt = array();
								list($opt['key'],$opt['if']) = array_merge(explode(';', $optStr),array(''));
								$opt['key'] = explode(',', $opt['key']);
								$opt['if'] = explode(',', $opt['if']);
								$charPos = $charPos + 2;
							}
							break;
						}
					}
				}
				elseif ($sub_str == '}')
				{
					if (substr($str,$searchStartPos+1,1) == '`')
					{
						$opt = array('key'	=>	array('*'),
									 'if'	=>	array('')
								);
						$charPos = $searchStartPos+2;
					}
					else
					{
						$resStr .= substr($str,$searchPos,$searchStartPos - $searchPos + 1);
						$searchPos = $searchStartPos+1;
						continue;
					}
				}
				else
				{
					$resStr .= substr($str,$searchPos,$searchStartPos - $searchPos);
					$searchPos = $searchStartPos;
					continue;
				}
				
				$resStr .= substr($str,$searchPos,$keyStrPos - $searchPos);
				
				if ($opt !== false) 
				{
					$searchCharPos = $charPos;
					$block = array();
					while (true)
					{
						$charPos = strpos($str,'`',$searchCharPos);
						if ($charPos !== false) 
						{
							$block[] = substr($str,$searchCharPos,$charPos - $searchCharPos);
							$searchCharPos = $charPos + 1;
							if (count($block) == count($opt['if'])) break;
						}
						else
						{
							break;
						}
					}
					if (count($block) !== count($opt['if']))
					{
						$resStr .= substr($str,$keyStrPos);
						break;
					}
					else
					{
						$key_set = array();
						$obj = array();
						foreach($opt['key'] as $key_val)
						{
							if ($key_val == '*')
							{
								if (empty($key_set))
								{
									foreach($value as $v_key=>$val){
										$key_set[] = array($v_key);
										$obj[] = $val;
									}
								}
								else
								{
									for($k_s_i = 0; $k_s_i < count($key_set); $k_s_i++)
									{
										if (!is_array($obj[$k_s_i]))
										{
											$resStr .= substr($str,$keyStrPos);
											break 3;
										}
										$i = 0;				
										foreach($obj[$k_s_i] as $v_key=>$val)
										{
											if ($i === 0)
											{
												$snapshot = $key_set[$k_s_i];
											}
											else
											{
												$k_s_i++;
												array_splice($key_set,$k_s_i,0,array($snapshot));
												array_splice($obj,$k_s_i,0,'');
											}
											$key_set[$k_s_i][] = $v_key;
											$obj[$k_s_i] = $val;
											$i++;
										};
									}
								}
							}
							else
							{
								if (empty($key_set))
								{
									if ($key_val === '') {$key_set[] = array();break;}
									if (!isset($value[$key_val]))
									{
										$resStr .= substr($str,$keyStrPos);
										break 2;
									}
									$key_set[] = array($key_val);
									$obj[] = $value[$key_val];
								}
								else
								{
									foreach($key_set as $k_s_i=>$arr){
										if (!isset($obj[$k_s_i][$key_val]))
										{
											$resStr .= substr($str,$keyStrPos);
											break 3;
										}
										$key_set[$k_s_i][] = $key_val;
										$obj[$k_s_i] = $obj[$k_s_i][$key_val];
									}
								}
							}
						}
						foreach($key_set as $k_s_i=>$arr)
						{
							$block_i = false;
							foreach($opt['if'] as $i=>$o_if)
							{
								if (empty($o_if)) {$block_i = $i;continue;}
								$o_if = explode('&', $o_if);
								foreach($o_if as $o_if_el)
								{
									$o_if_el = explode('=', $o_if_el);
									if ($o_if_el[0][0] === 'i') $o_if_el[0] = substr($o_if_el[0],1);
									if (isset($o_if_el[1]))
									{
										$res_obj = get_arr_for_replace_foreach($arr,$o_if_el[0],$value);
										if (!$res_obj['isset']) continue 2;
										if (!($res_obj['val'] ==  $o_if_el[1])) continue 2;
									}
									else
									{
										if (empty_for_replace_foreach($arr,$o_if_el[0])) continue 2;
									}
								}
								$block_i = $i;
								break;
							}
							if ($block_i === false)
							{
								$resStr .= substr($str,$keyStrPos);
								break 2;
							}							
							$escape_key = strtr($key,array('.'=>'\\.','*'=>'\\*','+'=>'\\+','['=>'\\[',']'=>'\\]','('=>'\\(',')'=>'\\)','{'=>'\\{','}'=>'\\}','^'=>'\\^','$'=>'\\$','/'=>'\\/','\\'=>'\\\\','!'=>'\\!','='=>'\\=',':'=>'\\:','?'=>'\\?','|'=>'\\|'));
							$block_filled = preg_replace_callback("/$escape_key\{([^{}]+)\}/",function($matches) use ($value,$arr) {
								$var_opt = $matches[1];
								$var_opt = explode(';', $var_opt);								
								if (empty($var_opt[1])) return '';

								if ($var_opt[0] === "")
								{
									$res = $value;
									$key_val = '';
								}
								else
								{
									$obj = $value;
									foreach(explode(',', $var_opt[0]) as $i=>$key_val)
									{
										if ($key_val == '*')
										{
											if (!isset($arr[$i])) return '';
											$key_val = $arr[$i];

										}
										if (!array_key_exists($key_val,$obj)) return '';
										$res = $obj[$key_val];
										$obj = $obj[$key_val];
									}
								}
								switch ($var_opt[1])
								{
									case "count":
										return is_array($res) ? count($res) : '';
									case "key":
										return $key_val;
									case "val":
										return $res;
									default:
										if (substr($var_opt[1],0,3) == 'val')
										{
											list($keys,$action) = array_pad(explode(':', str_replace('|','',substr($var_opt[1],3))),2,'');									
											@$keys = json_decode(urldecode($keys),true);
											if (!empty($keys) && is_array($keys))
											{
												foreach($keys as $key)
												{
													if ($key == '{$lang}') $key = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
													if (array_key_exists($key,$res))
													{
														$res = $res[$key];
													}
													else
													{
														return "";
													}
												}
											}
											$res = get_value_for_action_var_template($action,$res);
											return $res;
										} else {
											return '';
										}
								}
							},$block[$block_i]);
							$resStr .= $block_filled;	
						}				
						$searchPos = $charPos + 1;		
					}
				}
				else
				{
					$resStr .= substr($str,$keyStrPos);
					break;
				}
			}
			return $resStr;
		}
	}

	function fill_in_template($strings = array(), $data = array())
	{
/*				$data = array(
							'{$key}'	=>	'value',
							);
							
				if{$key=="val\\u\"e"}`string``alt_string`
				if{$key=>"value\\"}`string``alt_string`
				if{$key=<"value\""}`string``alt_string`	
				if{$key=="val\ue"}`string`	

				
*/

		$taxi_data = array();
		foreach(array(taxi::$data,taxi::$data_stt,taxi::$data_sc) as $block)
		{
			foreach($block as $section=>$obj)
			{
				if (!isset($data[$section])) $taxi_data[$section] = array();
				foreach($obj as $key=>$val)
				{
					$taxi_data[$section][$key] = $val;
				}
			}
		}

		$filled_strings = $strings;

		foreach ($filled_strings as $f_s_key=>$str)
		{
			$id_lang = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
			$iso_val = $taxi_data['langs'][$id_lang]['iso'];
			foreach ($data as $key=>$value)
			{
				$str = replaceForeachBlocks($key,$value,$str);
				if (!is_array($value))
				{
					$str = str_replace($key,$value,$str);
					$str = replaceIfBlocks($key,$value,$str);

					if (substr($key,-1,1) !== '}') continue;
					preg_match('/\:([^:]+)\}$/',$key,$action_key);
					if (!empty($action_key))
					{
						$action_key = $action_key[1];
						$escape_key = strtr(substr($key,0,-1),array('.'=>'\\.','*'=>'\\*','+'=>'\\+','['=>'\\[',']'=>'\\]','('=>'\\(',')'=>'\\)','{'=>'\\{','}'=>'\\}','^'=>'\\^','$'=>'\\$','/'=>'\\/','\\'=>'\\\\','!'=>'\\!','='=>'\\=',':'=>'\\:','?'=>'\\?','|'=>'\\|'));
						$str = preg_replace_callback("/$escape_key(\=[^{}]+)\}/",function($matches) use ($value,$action_key) {
							return get_value_for_action_var_template($action_key.$matches[1],$value);
						},$str);
					}
				}
			}
/*
			taxi::$data['lang_vls'][$name][$lang]				'{$so_data['+encodeURIComponent(JSON.stringify(['lang_vls',$name,$lang]))+']}'
			taxi::$data['lang_vls'][$name]						'{$so_data['+encodeURIComponent(JSON.stringify(['lang_vls',$name,'{$lang}']))+']}'
			taxi::$data['site_images'][$var]["file"]			'{$so_data['+encodeURIComponent(JSON.stringify(['site_images',$var,"file"]))+']}'
			taxi::$data['site_constants'][$var]["value"]		'{$so_data['+encodeURIComponent(JSON.stringify(['site_constants',$var,"value"]))+']}'
*/
			$str = preg_replace_callback('/\{\$so_data\[([^\]]+)\](?:\:([^}]*))?\}/',function($matches) use ($taxi_data,$id_lang,$iso_val){
				@$keys = json_decode(urldecode($matches[1]),true);
				if (empty($keys) || !is_array($keys))
				{
					return '';
				}
				$target = $taxi_data;
				foreach($keys as $key)
				{
					if ($key == '{$lang}') {$key = $id_lang;} else {$key = str_replace('{$iso}',$iso_val,$key);}	
					if (array_key_exists($key,$target))
					{
						$target = $target[$key];
					}
					else
					{
						return "";
					}
				}
				if(!empty($matches[2])) $target = get_value_for_action_var_template($matches[2],$target);
				return $target;
			},$str);
			$filled_strings[$f_s_key] = $str;
		}
		return $filled_strings;
	}

	function get_user_from_path($str = "")
	{
		if (gettype($str) !== 'string') return false;
		
/*		$chars = array(
					'a','b','c','d','e','f','g','h','i','j',
					'k','l','m','n','o','p','q','r','s','t',
					'u','w','x','z','A','B','D','E','F','G',
					'H','I','J','L','M','N','Q','R','T','V',
					'Y'
				);
		$chars_len = count($chars);
		for ($i = 0; $i < $chars_len; $i++)
		{
			$chars[$i] = array($chars[$i]=>(string)($i % 10));
		}*/
	
		$chars = array(
					'a'=>' ','b'=>'1','c'=>'2','d'=>'3','e'=>'4','f'=>'5','g'=>'6','h'=>'7','i'=>'8','j'=>'9',
					'k'=>' ','l'=>'1','m'=>'2','n'=>'3','o'=>'4','p'=>'5','q'=>'6','r'=>'7','s'=>'8','t'=>'9',
					'u'=>' ','w'=>'1','x'=>'2','z'=>'3','A'=>'4','B'=>'5','D'=>'6','E'=>'7','F'=>'8','G'=>'9',
					'H'=>' ','I'=>'1','J'=>'2','L'=>'3','M'=>'4','N'=>'5','Q'=>'6','R'=>'7','T'=>'8','V'=>'9',
					'Y'=>' '
				);
		$replace_pair = array(
					'0' => 'o','1' => 'l','5' => 's','y' => 'Y','v' => 'V',
					'C' => 'c','K' => 'k','O' => 'o','P' => 'p','S' => 's',
					'U' => 'u','W' => 'w','X' => 'x','Z' => 'z','|' => 'l'
				);
		$decoded_str = trim($str);
		if (strlen($decoded_str) === 0) return "";
		$decoded_str = strtr($decoded_str,$replace_pair);
		$decoded_str = strtr($decoded_str,$chars);
		$sign = "";
		if (isset($decoded_str[0]) && $decoded_str[0] == '-') 
		{
			$sign = '-';
			$decoded_str = substr($decoded_str,1);
		}
		$decoded_str = strtr(ltrim($decoded_str),' ','0');
		return empty($decoded_str) ? '0' : $sign . $decoded_str;
	}

	function get_path_from_user($id_user = "")
	{
		$sign = "";
		$str = $id_user;
		switch (gettype($str)) {
			case 'integer':
				if ($str < 0) {$sign = '-';$str = abs($str);}
				break;
			case 'string':
				$str = trim($str);
				if (strlen($str) === 0) return "";
				if (isset($str[0]) && $str[0] == '-') 
				{
					$sign = '-';
					$str = substr($str,1);
				}
				break;
			default:
				return false;
		}
		$chars = array(
					'a','b','c','d','e','f','g','h','i','j',
					'k','l','m','n','o','p','q','r','s','t',
					'u','w','x','z','A','B','D','E','F','G',
					'H','I','J','L','M','N','Q','R','T','V',
					'Y'
				);
/*		$chars_len = count($chars);
		$lens = array();
		for ($i = 0; $i < $chars_len; $i++)
		{
			$j = (string)($i % 10);
			if (isset($lens[$j]))
			{
				$lens[$j]++;
			}
			else
			{
				$lens[$j] = 1;
			}
		}*/

		$lens = array(
					'0'=>5,'1'=>4,'2'=>4,'3'=>4,'4'=>4,'5'=>4,'6'=>4,'7'=>4,'8'=>4,'9'=>4
				);

		$str = str_pad($str,10,'0',STR_PAD_LEFT);
		$str_len = strlen($str);
		$encoded_str = "";
		for($i = 0; $i < $str_len; $i++)
		{
			if (empty($lens[$str[$i]])) return false;
			$index = rand(0, $lens[$str[$i]] - 1)*10 + (int)$str[$i];
			$encoded_str .= $chars[$index];
		}

		return $sign . $encoded_str;
	}

	function insert_ref_ip($ip = "", $id_user = "")
	{
		$out = array('user_exists'=>true);
		if (empty($id_user)) return array('error'=>'empty user');

		$s = "SELECT 
				`id_user`
			FROM `users`
			WHERE `id_user` = '" . $id_user . "'
			LIMIT 1
			";

		$q = query($s);
		if ($q === false) return array('error'=>'database select failed');
		$d = fetch_assoc($q);
		if (empty($d['id_user'])) return array('user_exists'=>false);

		if (empty($ip)) 
		{
			$out['warning'] = 'empty ip';
			return $out;
		}

		$s = "INSERT INTO `ip_referral`
				SET
					`ip` = INET_ATON('" . $ip . "'),
					`id_user` = '" . $id_user . "',
					`datetime` = now()	
				ON DUPLICATE KEY UPDATE
					`id_user` = '" . $id_user . "',
					`datetime` = now()
		";

		$q = query($s);
		if ($q === false) $out['error'] = 'database insert failed';
		return $out;
	}

	function lat_lng_to_square($lat, $lng, $place)
	{
		$lat = (float)$lat;
		$lng = (float)$lng;

		$max_longitude = $place['max_lng'];
		$min_longitude = $place['min_lng'];
		$max_latitude = $place['max_lat'];
		$min_latitude = $place['min_lat'];
		$split_depth = $place['split_depth'];
		$side_length_in_squares = $place['side_squares'];
		$square_lng = $place['square_lng'];
		$square_lat = $place['square_lat'];

		$lng_rel = $lng - $min_longitude;
		$lng_side_length_in_squares = min((int)ceil($lng_rel/$square_lng),$side_length_in_squares);
		$lat_rel = $max_latitude - $lat;
		$lat_side_length_in_squares = min((int)($lat_rel/$square_lat + 1),$side_length_in_squares);

		$lng_side_number = $lat_side_number = array_fill(0,$split_depth,1);

		$sides_join = array(
							1 => array(1=>1,2=>4,3=>7),
							2 => array(1=>2,2=>5,3=>8),
							3 => array(1=>3,2=>6,3=>9)
		);

		if (!empty($lng_side_length_in_squares))
		{
			$inner_flag = true;
			for ($i = $split_depth - 1; $i >= 0; $i--)
			{
				list($lng_side_length_in_squares,$lng_side_number[$i]) = gmp_div_qr($lng_side_length_in_squares,3);
				$lng_side_length_in_squares = gmp_intval($lng_side_length_in_squares);
				$lng_side_number[$i] = gmp_intval($lng_side_number[$i]);
				if ($lng_side_number[$i] === 0) 
				{		 
					if ($inner_flag) 
					{
						$lng_side_number[$i] = 3;
						$inner_flag = true;
					}
					else
					{
						$lng_side_number[$i] = 1;
					}
				}
				else 
				{
					if (!$inner_flag) $lng_side_number[$i]++;
					$inner_flag = false;
				}
				if (empty($lng_side_length_in_squares)) break;
			}
		}
		if (!empty($lat_side_length_in_squares))
		{
			$inner_flag = true;
			for ($i = $split_depth - 1; $i >= 0; $i--)
			{
				list($lat_side_length_in_squares,$lat_side_number[$i]) = gmp_div_qr($lat_side_length_in_squares,3);
				$lat_side_length_in_squares = gmp_intval($lat_side_length_in_squares);
				$lat_side_number[$i] = gmp_intval($lat_side_number[$i]);
				if ($lat_side_number[$i] === 0) 
				{
					if ($inner_flag) 
					{
						$lat_side_number[$i] = 3;
						$inner_flag = true;
					}
					else
					{
						$lat_side_number[$i] = 1;
					}
				}
				else 
				{
					if (!$inner_flag) $lat_side_number[$i]++;
					$inner_flag = false;
				}
				if (empty($lat_side_length_in_squares)) break;
			}
		}
		$square_number = "";
		for ($i = 0; $i < $split_depth; $i++)
		{
			$square_number .= $sides_join[$lng_side_number[$i]][$lat_side_number[$i]];
		}
		return $square_number;
	}

	function address_to_lat_lng($str)
	{
		$lat = NULL;
		$lng = NULL;
		return array($lat,$lng);
	}

	function get_time_distance($loc,$speed)
	{
		//$loc[$order['place']][$square][$order['from_square']] = true;
		$s = array();
		$loc_res = array();
		foreach($loc as $place=>$squares)
		{
			foreach($squares as $user_square=>$orders)
			{
				foreach($orders as $order_square=>$val)
				{
						$s[] = "(`place` = '" .$place . "' AND `p1` = '" . $user_square . "' AND `p2` = '" . $order_square . "')";
				}
			}
		}
		if (!empty($s))
		{
			$s = "SELECT 
					`place`,
					`p1`,
					`p2`,
					`distance`
				FROM `map_distance`
				WHERE " . implode(" OR ", $s) . "
				";

			$q = query($s);
			if ($q === false) return false;
			while ($d = fetch_assoc($q))
			{
				$loc_res[$d['place']][$d['p1']][$d['p2']] = 3.6*(float)$d['distance']/$speed;
			}
		}
		return $loc_res;
	}

	function get_distance($place, $from_square, $to_square)
	{
		if ($from_square == $to_square) return 0;

		$s = "SELECT
				`distance`
			FROM `map_distance`
			WHERE `place` = '" .$place . "' AND `p1` = '" . $from_square . "' AND `p2` = '" . $to_square . "'
			LIMIT 1
			";

		$q = query($s);
		if ($q === false) return false;
		$d = fetch_assoc($q);
		return $d['distance'] === NULL ? NULL : (float)$d['distance'];
	}

	function get_place($lat, $lng)
	{
		if (isset($lat) && isset($lng))
		{
			foreach(taxi::$data['map_places'] as $id=>$place)
			{
				if ($lng >= $place['min_lng'] && $lng <= $place['max_lng'] 
					&& $lat >= $place['min_lat'] && $lat <= $place['max_lat'])
				{
					$place['id'] = $id;
					return $place;
				}
			}
		}
		return false;
	}

	function array_includes_add_keys_from_assoc_list($search_array = array(), $list = array())
	{
		if (!is_array($search_array) || empty($search_array) || !is_array($list) || empty($list)) return true;
		foreach($search_array as $key => $value)
		{
			if (array_key_exists($key,$list))
			{
				if (array_includes_add_keys_from_assoc_list($value,$list[$key]) === true) return true;
			}
		}
		return false;
	}

	function array_includes_only_add_keys_from_assoc_list($search_array = array(), $list = array())
	{
		if (!is_array($list) || empty($list)) return true;
		if (!is_array($search_array) || empty($search_array)) return false;
		foreach($search_array as $key => $value)
		{
			if (array_key_exists($key,$list))
			{
				if (array_includes_only_add_keys_from_assoc_list($value,$list[$key]) === false) return false;
			}
			else
			{
				return false;
			}
		}
		return true;
	}

	function validate_multi_assoc_list($associative_list = array())
	{
		if (!is_array($associative_list) || empty($associative_list)) return array();
		$valid_array = array();
		foreach($associative_list as $key => $value)
		{
			$valid_array[$key] = validate_multi_assoc_list_iterative($value);
		}
		return $valid_array;
	}

	function validate_multi_assoc_list_iterative($associative_list = array())
	{
		if (!is_array($associative_list) || empty($associative_list)) return true;
		$valid_array = array();
		foreach($associative_list as $key => $value)
		{
			$valid_array[$key] = validate_multi_assoc_list_iterative($value);
		}

		return $valid_array;
	}

	function get_0_64($char = "", $show_array = false)
	{
		$chars = array(
					"0" => 0,	"1" => 1,	"2" => 2,	"3" => 3,	"4" => 4, 
					"5" => 5,	"6" => 6,	"7" => 7,	"8" => 8,	"9" => 9, 
					"A" => 10,	"B" => 11,	"C" => 12,	"D" => 13,	"E" => 14, 
					"F" => 15,	"G" => 16,	"H" => 17,	"I" => 18,	"J" => 19, 
					"K" => 20,	"L" => 21,	"M" => 22,	"N" => 23,	"O" => 24, 
					"P" => 25,	"Q" => 26,	"R" => 27,	"S" => 28,	"T" => 29, 
					"U" => 30,	"V" => 31,	"W" => 32,	"X" => 33,	"Y" => 34, 
					"Z" => 35,	"a" => 36,	"b" => 37,	"c" => 38,	"d" => 39, 
					"e" => 40,	"f" => 41,	"g" => 42,	"h" => 43,	"i" => 44, 
					"j" => 45,	"k" => 46,	"l" => 47,	"m" => 48,	"n" => 49,
					"o" => 50,	"p" => 51,	"q" => 52,	"r" => 53,	"s" => 54,
					"t" => 55,	"u" => 56,	"v" => 57,	"w" => 58,	"x" => 59, 
					"y" => 60,	"'" => 61,	"-" => 62,	"." => 63,	"_" => 64,
		);
		if (!empty($show_array)) return $chars;
		if (isset($chars[$char])) return $chars[$char];
		return 0;
	}

	function get_field_arr($type = "", $id_role = "", $show_array = false)
	{
		$field_arr = array(
					'order'	=> array(
						1 =>	array(
							8 	=>	array(
								2	=>	'b_offers'
							)		
						),
						2	=>	array(
							8 	=>	array(
								4	=>	'b_offer'
							)		
						),
						4	=>	array(
							8 	=>	array(
								2	=>	'b_offers'
							)		
						),
						5	=>	array(
							8 	=>	array(
								2	=>	'b_offers'
								)		
							)
					),
					'activeOrder'	=> array(
						1 =>	array(
							8 	=>	array(
								2	=>	'b_offers'
							)		
						),
						2	=>	array(
							8 	=>	array(
								4	=>	'b_offer'
							)		
						),
						5	=>	array(
							8 	=>	array(
								2	=>	'b_offers'
								)		
							)
					),
					'processingOrder'	=> array(
						2	=>	array(
							8 	=>	array(
								4	=>	'b_offer'
							)		
						),
						4	=>	array(
							8 	=>	array(
								2	=>	'b_offers'
							)		
						)
					),
					'archiveOrder'	=> array(
						1 	=>	array(
							8 	=>	array(
								2	=>	'b_offers'
							)		
						),
						2	=>	array(
							8 	=>	array(
								4	=>	'b_offer'
							)		
						),
						5	=>	array(
							8 	=>	array(
								2	=>	'b_offers'
								)		
							)
					),
					'data'			=> array(
						0	=>	array(
							0 	=>	array(
								1	=>	'stadiums',
								2	=>	'schedule',
								4	=>	'teams',
								8	=>	'tournaments'
							)	
						)
					),
					'trip'			=> array(
						0 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						1 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						2 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						4 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						5 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						)
					),
					'activeTrip'		=> array(
						1 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						2 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						4 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						5 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)	
						)
					),
					'processingTrip'	=> array(
						1 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)		
						),
						5 =>	array(
							3 	=>	array(
								16	=>	'seats_sold with number, status'
							)
						)
					)
		);

		if (!empty($show_array)) return $field_arr;
		if (empty($id_role)) $id_role = 0;
		if (empty($field_arr[$type][$id_role])) return array();

		return $field_arr[$type][$id_role];
	}

	function get_bin_arr()
	{
		return array(1,2,4,8,16,32);
	}

	function get_id_user($id = "", $email = "", $phone = "", $tg = "", $wa = "")
	{
		$phone = preg_replace('/[^0-9]+/','',$phone);
		if (empty($id)){
			while (true){
				$u_data = array('email','phone','tg','wa');
				foreach($u_data as $u_str)
				{
					if (empty($$u_str)) continue;
					if (isset($_SESSION[$u_str]) && $$u_str == $_SESSION[$u_str]) return array('error' => "trying to imitate your $u_str");
					$sql_where = "`$u_str` = '" . $$u_str . "'";
					break 2;
				}
				return array('error' => 'empty user ' . implode(" and ", $u_data));
			}
		}
		else
		{
			if ($id == $_SESSION[UID]) return array('error' => 'trying to imitate your id');
			$sql_where = "`id_user` = '" . $id . "'";
		}
		$s = "SELECT 
				`id_user`
			FROM `users`
			WHERE 
				" . $sql_where . "
			LIMIT 1
			";

		$q = query($s);
		if ($q === false) return array('error' => 'u_id select failed');
		$d = fetch_assoc($q);
		if (empty($d['id_user'])) return array('error' => 'user not found');
		return $d['id_user'];
	}

	function show_error($msg) 
	{
		$_GET['route'] = 'api';
		$_GET['par'] = array('error' => $msg);
		require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'controllers/c_api.php');
	}

	function generate_code($number)
	{
	    $arr = array('0','1','2','3','4','5','6','7','8','9');
	    
	    $code = "";
	    for($i = 0; $i < $number; $i++)
	    {
	      	$index = rand(0, count($arr) - 1);
	      	$code .= $arr[$index];
	    }
	    
	    return $code;
	}

	function send_msg_to_whatsapp($phone = "", $body = "", $url = "", $key = "")
	{
		if (!empty(taxi::$data_private['site_constants']['whatsapp_send_message_url']['value'])) $url = trim(taxi::$data_private['site_constants']['whatsapp_send_message_url']['value']);
		if (!empty(taxi::$data_private['site_constants']['whatsapp_send_message_key']['value'])) $key = trim(taxi::$data_private['site_constants']['whatsapp_send_message_key']['value']);
		if (empty($phone) || empty($body) || empty($url) || empty($key)) return false;
		$postvars = "phone=" . urlencode($phone) . "&code=" . urlencode($body);
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, $url);
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,$postvars);
		$headers = array(
			"x-api-key: $key"
		);
		curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
		$contents = curl_exec($c);
		curl_close($c);
		if ($contents) return $contents; else return false;
	}

	 function auth_user($id_user)
	 {
		$_SESSION[UID] = $id_user;
		check_auth_user();
		if (empty($_SESSION[UID])) return false;
		$_SESSION['auth_time'] = time();
		$vfoc = md5(session_id() . strtolower(dechex(crc32($_SESSION[UID]))));
		setcookie("vfoc", $vfoc, 0, ROOT_URL);
		return openssl____encrypt(session_id() . "|" . $vfoc);
	 }

	function upload_to_dropbox($content,$filename_upload,$id_dropbox_link,$mode = 'add')
	{
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_id']['value'])) $client_id = trim(taxi::$data_private['site_constants']['dropbox_file_client_id']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value'])) $client_secret = trim(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value'])) $refresh_token = trim(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value']);
		if (empty($filename_upload) || empty($id_dropbox_link) || empty($client_id) || empty($client_secret) || empty($refresh_token)) return array('error'=>'empty parameters');
		switch ($mode)
		{
			case 'add':
				break;
			case 'overwrite':
				break;
			default:
				$mode = 'add';
		}

		@$dropbox_access_token = trim(file_get_contents($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/dropbox_access_token.txt'));
		$update = false;
		if (empty($dropbox_access_token))
		{
			$dropbox_access_token = update_dropbox_access_token();
			if (!empty($dropbox_access_token['error'])) return array('error'=>'new: ' . $dropbox_access_token['error']);
			$update = true;
			$dropbox_access_token = $dropbox_access_token['value'];
		}
		$constant = 'constant'; $path = "/c/{$constant('CONFIG')}/$id_dropbox_link/$filename_upload";
		while (true)
		{
			$c = curl_init();
			curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c,CURLOPT_URL, 'https://content.dropboxapi.com/2/files/upload');
			curl_setopt($c,CURLOPT_POST, 1);
			curl_setopt($c,CURLOPT_POSTFIELDS,$content);
			$headers = array(
				"Authorization: Bearer $dropbox_access_token",
				"Dropbox-API-Arg: {\"path\":\"$path\",\"mode\":\"$mode\"}",
				"Content-Type: application/octet-stream"
			);
			curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($c, CURLOPT_CAINFO, $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
			$response = curl_exec($c);
			curl_close($c);
			if (empty($response)) return array('error'=>'upload failed');
			@$response = json_decode($response,true);
			if (empty($response) || !is_array($response)) 
			{
				 return array('error'=>'upload response error');
			}
			if (!empty($response['error']))
			{
				if (!empty($response['error_summary']) && substr($response['error_summary'],0,20) == 'expired_access_token')
				{
					if ($update == true)
					{
						return array('error'=>'access_token error');
					}
					else
					{
						$dropbox_access_token = update_dropbox_access_token();
						if (!empty($dropbox_access_token['error'])) return array('error'=>'update: ' . $dropbox_access_token['error']);
						$update = true;
						$dropbox_access_token = $dropbox_access_token['value'];
						continue;
					}
				}
				else
				{
					 return array('error'=>'upload error');
				}
			}
			return array('data'=>$response);
		}	
	}

	function download_from_dropbox($filename_upload = '', $id_dropbox_link = '', $type = '')
	{
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_id']['value'])) $client_id = trim(taxi::$data_private['site_constants']['dropbox_file_client_id']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value'])) $client_secret = trim(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value'])) $refresh_token = trim(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value']);
		if (empty($filename_upload) || empty($id_dropbox_link) || empty($type) || empty($client_id) || empty($client_secret) || empty($refresh_token)) return array('error'=>'empty parameters');

		@$dropbox_access_token = trim(file_get_contents($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/dropbox_access_token.txt'));
		$update = false;
		if (empty($dropbox_access_token))
		{
			$dropbox_access_token = update_dropbox_access_token();
			if (!empty($dropbox_access_token['error'])) return array('error'=>'new: ' . $dropbox_access_token['error']);
			$update = true;
			$dropbox_access_token = $dropbox_access_token['value'];
		}
		$constant = 'constant'; $path = "/c/{$constant('CONFIG')}/$id_dropbox_link/$filename_upload";
		while (true)
		{
			$c = curl_init();
			curl_setopt($c,CURLOPT_URL, 'https://content.dropboxapi.com/2/files/download');
			$headers = array(
				"Authorization: Bearer $dropbox_access_token",
				"Dropbox-API-Arg: {\"path\":\"$path\"}"
			);
			curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($c, CURLOPT_HEADERFUNCTION, function($curl, $header) use (&$headers){
				$len = strlen($header);
				$header = explode(':', $header, 2);
				if (count($header) < 2) 
				{
					$header = trim($header[0]);				
					if (strlen($header) && mb_strpos($header,'200') === false) curl_setopt($curl,CURLOPT_RETURNTRANSFER, 1);
					return $len;
				}
				$header[0] = trim($header[0]);
				$header[1] = trim($header[1]);
				if (strtolower($header[0]) == 'content-length') header("Content-Length: {$header[1]}");
				$headers[$header[0]][] = $header[1];
				return $len;	
			});
			header("Content-Type: $type");
			header("Access-Control-Expose-Headers: Content-disposition");
			set_header_content_disposition($filename_upload);
			curl_setopt($c, CURLOPT_CAINFO, $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
			$response = curl_exec($c);
			curl_close($c);
			if ($response === true)
			{
				exit;
			}
			if (empty($response)) return array('error'=>'download failed');
			@$response = json_decode($response,true);
			if (empty($response) || !is_array($response)) 
			{
				 return array('error'=>'download response error');
			}
			if (!empty($response['error']))
			{
				if (!empty($response['error_summary']) && substr($response['error_summary'],0,20) == 'expired_access_token')
				{
					if ($update == true)
					{
						return array('error'=>'access_token error');
					}
					else
					{
						$dropbox_access_token = update_dropbox_access_token();
						if (!empty($dropbox_access_token['error'])) return array('error'=>'update: ' . $dropbox_access_token['error']);
						$update = true;
						$dropbox_access_token = $dropbox_access_token['value'];
						continue;
					}
				}
				else
				{
					 return array('error'=>'download error');
				}
			}
		}		
	}

	function update_dropbox($code = '')
	{
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_id']['value'])) $client_id = trim(taxi::$data_private['site_constants']['dropbox_file_client_id']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value'])) $client_secret = trim(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value']);
		if (strlen($code) == 0 || empty($client_id) || empty($client_secret)) return array('error'=>'empty parameters');
		
		$postvars = "code=" . urlencode($code) . "&grant_type=authorization_code&client_id=" . urlencode($client_id) . "&client_secret=" . urlencode($client_secret);
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, 'https://api.dropbox.com/oauth2/token');
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,$postvars);
		curl_setopt($c, CURLOPT_CAINFO, $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
		$headers = array(
			"Content-Type: application/x-www-form-urlencoded"
		);
		curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($c);
		curl_close($c);
		if (empty($response)) return array('error'=>'update failed');
		@$response = json_decode($response,true);
		if (empty($response) || !is_array($response)) 
		{
			 return array('error'=>'update response error');
		}
		if (!empty($response['error']))
		{
			if (!empty($response['error_description']) && substr($response['error_description'],0,16) == 'code has expired')
			{
				return array('error'=>'code expired');
			}
			else
			{
				return array('error'=>'update error');
			}
		}
		if (empty($response['refresh_token'])) return array('error'=>'empty refresh_token');
		$refresh_token = $response['refresh_token'];

		$s = "UPDATE `site_constant`
			SET
				`value` = '" . $refresh_token . "'
			WHERE
				`var` = 'dropbox_file_refresh_token'
			";

		$q = query($s);

		global $link;
		if (mysqli_affected_rows($link) === -1) 
		{
			return array('error'=>'database update failed');
		}
		elseif (mysqli_affected_rows($link) === 0) 
		{
			return array('error'=>'modified data not found');
		}

		$res = update_cache();
		if (!empty($res['error']))
		{
			return array('error'=>array('update_cache'=>$res));
		}

		if (@file_put_contents($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/dropbox_access_token.txt','') === false) return array('error'=>'access_token clear error');

		return array('refresh_token' => $refresh_token);
	}

	function update_dropbox_access_token()
	{
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_id']['value'])) $client_id = trim(taxi::$data_private['site_constants']['dropbox_file_client_id']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value'])) $client_secret = trim(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value'])) $refresh_token = trim(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value']);
		if (empty($client_id) || empty($client_secret) || empty($refresh_token)) return array('value'=>'','error'=>'access_token: empty parameters');

		$postvars = "grant_type=refresh_token&refresh_token=" . $refresh_token . "&client_id=" . urlencode($client_id) . "&client_secret=" . urlencode($client_secret);
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, 'https://api.dropbox.com/oauth2/token');
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,$postvars);
		$headers = array(
			"Content-Type: application/x-www-form-urlencoded"
		);
		curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($c, CURLOPT_CAINFO, $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
		$response = curl_exec($c);
		curl_close($c);
		if (empty($response)) return array('value'=>'','error'=>'exec failed');
		@$response = json_decode($response,true);
		if (empty($response) || !is_array($response)) 
		{
			 return array('value'=>'','error'=>'exec response error');
		}
		if (!empty($response['error_summary']))
		{
			return array('value'=>'','error'=>'exec error');
		}
		if (empty($response['access_token'])) return array('value'=>'','error'=>'empty access_token');
		$access_token = $response['access_token'];
		
		if (@file_put_contents($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/dropbox_access_token.txt',$access_token) === false) return array('error'=>'access_token write error');

		return array('value'=>$access_token);
	}

	function fields_for_langs($langs = array(), &$arr = array(), $out_prefix = '', $db_prefix = '', $null_on = false)
	{
		if (empty($langs)) return false;
		foreach ($langs as $lang)
		{
			$out_key = $out_prefix . $lang['iso'];
			$db_key = $db_prefix . $lang['iso'];
			$arr['allowed_fields'][$out_key] = array(
								'name'	=>	$db_key ,
								'NULL'	=>	$null_on
			);
		}
		return true;
	}

	function get_sql_from_arr($arr = array(), $keys = array(), $format = array(), $s = array(), $s_add = array(), $i = 0, $s_keys = array(), $s_keys_add = array())
	{
		if (isset($keys[$i]))
		{
			$id_key = $keys[$i];
			if (is_array($arr))
			{
				foreach($arr as $key=>$value)
				{
					if (!empty($format[$i])) $key = $format[$i]($key);
					$id_val = $key;
					list($s,$s_keys) = get_sql_from_arr($value,$keys,$format,$s,array_merge($s_add,array("`" . $id_key . "` = " 
						 . ($id_val === NULL ? "NULL" : "'" . $id_val . "'"))),$i+1,$s_keys,array_merge($s_keys_add,array($id_key)));
				}
			}
			else
			{
				if (!empty($format[$i])) $arr = $format[$i]($arr);
				$id_val = $arr;
				$s_add[] = "`" . $id_key . "` = " 
					 . ($id_val === NULL ? "NULL" : "'" . real_escape_string($id_val) . "'");
				$s[] = $s_add;
				$s_keys_add[] = $id_key;
				$s_keys[] = $s_keys_add;
			}
		}
		return array($s,$s_keys);
	}

	function get_stripe_link($order = '', $amount = 0, $currency = '', $appUrl = '',  $email = '')
	{
		if (empty($order)) return array('error'=>'empty b_id');
		if (empty($amount)) return array('error'=>'empty sum');	
		if (empty(taxi::$data['currencies'][$currency]))
		{
			$currency = DEFAULT_CURRENCY;
		}
		if (!empty(taxi::$data_private['site_constants']['stripe_request_url']['value'])) $url = trim(taxi::$data_private['site_constants']['stripe_request_url']['value']);
		if (!empty(taxi::$data_private['site_constants']['stripe_secret_key']['value'])) $key = trim(taxi::$data_private['site_constants']['stripe_secret_key']['value']);	
		$title = empty(taxi::$data['site_constants']['stripe_request_title']['value']) ? 'Service' : trim(taxi::$data['site_constants']['stripe_request_title']['value']);
		$duration = empty(taxi::$data['site_constants']['stripe_request_duration']['value']) ? '3600' : trim(taxi::$data['site_constants']['stripe_request_duration']['value']);	
		if (empty($url) || empty($key)) return array('error'=>'empty parameters');
		if ($appUrl === '')
		{
			$appUrl_str = '';
		}
		else
		{
			$appUrl = urlencode($appUrl);
			$appUrl_str = "?appUrl=$appUrl";
		}
		$arr = array(
							'amount'		=>		$amount,
							'currency'		=>		strtolower($currency),
							'redirect'		=>		url("stripe/redirect/$appUrl_str",CONFIG_URL,1),
							'order'			=>		$order,
							'c'				=>		CONFIG,
							'site'			=>		url('',0,1),
							'key'			=>		$key,
							'title'			=>		$title,
							'duration'		=>		$duration
		);
		if (!empty($email)) $arr['email'] = $email;
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, $url);
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,json_encode($arr));
		curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
		$headers = array(
			"Content-Type: application/json"
		);
		curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($c);
		curl_close($c);
		if (empty($response)) return array('error'=>'empty response');
		$response_str = $response;
		@$response = json_decode($response,true);
		if (empty($response) || !is_array($response)) 
		{
			 return array('error'=>'response error:' . $response_str);
		}
		if (!empty($response['error']))
		{
			return array('error'=>array('response with error',$response));
		}
		if (empty($response['url'])) return array('error'=>array('empty url',$response));
		return array($response['url'],$duration);
	}

	function get_stripe_status($order = '')
	{
		if (empty($order)) return array('error'=>'empty b_id');
		if (!empty(taxi::$data_private['site_constants']['stripe_status_url']['value'])) $url = trim(taxi::$data_private['site_constants']['stripe_status_url']['value']);
		if (!empty(taxi::$data_private['site_constants']['stripe_secret_key']['value'])) $key = trim(taxi::$data_private['site_constants']['stripe_secret_key']['value']);
		if (empty($url) || empty($key)) return array('error'=>'empty parameters');
		$arr = array(
							'order'			=>		$order,
							'c'				=>		CONFIG,
							'site'			=>		url('',0,1),
		);
		$c = $arr['c'];
		$site = $arr['site'];
		$hash = md5("$order$c$site$key");
		$arr['hash'] = $hash;
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, $url);
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,json_encode($arr));
		curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
		$headers = array(
			"Content-Type: application/json"
		);
		curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($c);
		curl_close($c);
		if (empty($response)) return array('error'=>'empty response');
		$response_str = $response;
		@$response = json_decode($response,true);
		if (empty($response) || !is_array($response)) 
		{
			 return array('error'=>'response error:' . $response_str);
		}
		if (!empty($response['error']))
		{
			return array('error'=>array('response with error',$response));
		}
		return $response;
	}
	
	function cancel_stripe_link($order = '')
	{
		if (empty($order)) return array('error'=>'empty b_id');
		if (!empty(taxi::$data_private['site_constants']['stripe_cancel_url']['value'])) $url = trim(taxi::$data_private['site_constants']['stripe_cancel_url']['value']);
		if (!empty(taxi::$data_private['site_constants']['stripe_secret_key']['value'])) $key = trim(taxi::$data_private['site_constants']['stripe_secret_key']['value']);
		if (empty($url) || empty($key)) return array('error'=>'empty parameters');
		$arr = array(
							'order'			=>		$order,
							'c'				=>		CONFIG,
							'site'			=>		url('',0,1),
		);
		$c = $arr['c'];
		$site = $arr['site'];
		$hash = md5("$order$c$site$key");
		$arr['hash'] = $hash;
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, $url);
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,json_encode($arr));
		curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
		$headers = array(
			"Content-Type: application/json"
		);
		curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
		$response = curl_exec($c);
		curl_close($c);
		if (empty($response)) return array('error'=>'empty response');
		$response_str = $response;
		@$response = json_decode($response,true);
		if (empty($response) || !is_array($response)) 
		{
			 return array('error'=>'response error:' . $response_str);
		}
		if (!empty($response['error']))
		{
			return array('error'=>array('response with error',$response['error']));
		}
		if (empty($response['status'])) return array('error'=>array('empty status',$response));
		return $response;
	}

	function pre_debug($str = "")
	{
		echo '<pre>' . htmlentities(var_export($str,true)). '</pre>';
		return true;
	}

	function is_prev_value($val1, $val2, $flag)
	{
		$val1 = strtolower($val1);
		$val2 = strtolower($val2);
		if ($val1 !== $val2)
		{
			switch ($flag)
			{
				case 'a':
					$val1_int = hexdec(bin2hex($val1));
					$val2_int = hexdec(bin2hex($val2));
					$diff = $val2_int - $val1_int;
					if ($diff === 1 || ($diff  % 256 === 256-25)) return true; else return false;
					break;
				case 'd':
					if (((int)$val2 - (int)$val1) === 1) return true; else return false;
				default:
					return false;
			}
		}
		else
		{
			return false;
		}
	}

	function create_lang_field($langs = array())
	{
		if (empty($langs)) return true;

		$sql_template = array(
			array(
				'lang',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),	
			array(
				'aggregator',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'car_body',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'car_class',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'car_color',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'car_make',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'car_model',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'cargo_case_model',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'cargo_case_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'cargo_category',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('','id_cargo_category_upper'))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'cargo_value_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'cart_block_status_sys',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'city',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'contact_items',
				array(
					array('name_','varchar(255) NOT NULL'),
					array('description_','text NOT NULL')
				)
			),
			array(
				'contact_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'countries_list',
				array(
					array('country_name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'currency',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('country_','text NOT NULL')
				)
			),
			array(
				'date_feature',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'date_place',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'date_select',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'date_select_frequency',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'driver_select_sorting',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'faq',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('value_','text NOT NULL')
				)
			),
			array(
				'faq_category',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'field_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'map_place',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'message_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'order_cancel',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'order_comment',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'order_driver_status',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'order_location',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),	
			array(
				'order_prop',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'order_status',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'outer_script_template',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),	
			array(
				'owner_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'payment_method',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'price_time_function',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'programming_language',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'region',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'script_template',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),		
			array(
				'service',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'site_constant',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('','id_category'))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'site_constant_category',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'site_email',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'site_image',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'sql_category',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('','id_sql_category_upper'))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'sql_template',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'tariff',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'tariff_duration_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),		
			array(
				'task_action',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'task_action_control',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'task_action_function',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'task_status',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'ticket_prop',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'ticket_status',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'translate_type',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),			
			array(
				'translator',
				array(
					array('name_','varchar(255) DEFAULT NULL'),
					array('description_','text NOT NULL')
				)
			),
			array(
				'unit_of_length',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('symbol_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'unit_of_mass',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('symbol_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'unit_of_volume',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('symbol_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'users_roles',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'users_prop',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),	
			array(
				'users_verification_status',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('')))
				)
			),
			array(
				'webapp',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),	
			array(
				'stadium',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('','id_city'))),
					array('description_','text NOT NULL'),
					array('address_','varchar(255) DEFAULT NULL')
				)
			),
			array(
				'team',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array('','id_city'))),
					array('description_','text NOT NULL'),
				)
			),
			array(
				'tournament',
				array(
					array('name_','varchar(255) DEFAULT NULL',array('',array(''))),
					array('description_','text NOT NULL')
				)
			),
			array(
				'taxi_license',
				array(
					array('name_','varchar(255) DEFAULT NULL'),
					array('description_','text NOT NULL')
				)
			)
		);

		$error = array();
		foreach($langs as $iso)
		{
			foreach($sql_template as $arr)
			{
				$s = array();
				foreach($arr[1] as $f_arr)
				{
					$s[] = "  ADD `{$f_arr[0]}$iso` {$f_arr[1]}";
					if (count($f_arr) > 2)
					{
						$key = $f_arr[2][0] === '' ? "{$f_arr[0]}$iso" : $f_arr[2][0];
						$keys = array();
						foreach($f_arr[2][1] as $key_el)
						{
							if ($key_el === '')
							{
								$keys[] = "`{$f_arr[0]}$iso`";
							}
							else
							{
								$keys[] = "`$key_el`";
							}
						}
						$keys = implode(',',$keys);
						$s[] = "  ADD UNIQUE KEY `$key` ($keys)";
					}
				}
				$s = "ALTER TABLE `{$arr[0]}`\n" . implode(",\n",$s);
				
				$q = query($s);
				if ($q === false) $error[] = $arr[0];			
			}
		}
		if (!empty($error)) return array('error'=>$error);

		return true;
	}

	function batch_translate($data = array(), $from = "ru", $to = "en")
	{
		if (empty($data)) return array();
		if (!empty(taxi::$data_private['site_constants']['batch_translate_url']['value'])) $url = trim(taxi::$data_private['site_constants']['batch_translate_url']['value']);
		if (!empty(taxi::$data_private['site_constants']['batch_translate_key']['value'])) $key = trim(taxi::$data_private['site_constants']['batch_translate_key']['value']);
		if (empty($url) || empty($key)) return array('error'=>'empty parameters');
		$arr = array(
							'input'			=>		$data,
							'from_code'		=>		$from,
							'to_code'		=>		$to
		);
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, $url);
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,json_encode($arr));
		curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
		$response = curl_exec($c);
		curl_close($c);
		if (empty($response)) return array('error'=>'empty response');
		$response_str = $response;
		@$response = json_decode($response,true);
		if (empty($response) || !is_array($response)) 
		{
			 return array('error'=>'response error:' . $response_str);
		}
		if (!empty($response['error']))
		{
			return array('error'=>array('response with error',$response));
		}
		if (empty($response['output'])) return array('error'=>'empty data');		
		$formated = array();
		foreach($response['input'] as $i=>$str)
		{		
			$formated[$str] = $response['output'][$i];
		}
		return $formated;
	}

	function get_arr_for_replace_foreach($arr = array(), $key = '', $value = array())
	{
		$key = explode('|', $key);
		$out = array(
			'val'	=> NULL,
			'isset' => false
		);
		if (isset($key[1]))
		{
			if (isset($arr[$key[0]])) 
			{
				while (true)
				{
					$obj = $value;
					foreach($arr as $i=>$key_val)
					{
						if (!array_key_exists($key_val,$obj)) return $out;
						$obj = $obj[$key_val];
						if ($i == $key[0]) break 2;
					}
					return $out;
				}

				@$key[1] = json_decode(urldecode($key[1]),true);
				if (empty($key[1]) || !is_array($key[1]))
				{
					return $out;
				}
				foreach($key[1] as $key_el)
				{
					if ($key_el== '{$lang}') $key_el = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
					if (array_key_exists($key_el,$obj))
					{
						$obj = $obj[$key_el];
					}
					else
					{
						return $out;
					}	
				}
				$out = array(
					'val'	=>	$obj,
					'isset' =>	true
				);
			}
		}
		else
		{
			if (isset($arr[$key[0]])) 
			{
				$out = array(
					'val'	=>	$arr[$key[0]],
					'isset' =>	true
				);
			}
		}
		return $out;
	}

	function empty_for_replace_foreach($arr = array(), $key = '', $value = array())
	{
		$key = explode('|', $key);
		$out = true;
		if (isset($key[1]))
		{
			if (isset($arr[$key[0]])) 
			{
				while (true)
				{
					$obj = $value;
					foreach($arr as $i=>$key_val)
					{
						if (!array_key_exists($key_val,$obj)) return $out;
						$obj = $obj[$key_val];
						if ($i == $key[0]) break 2;
					}
					return $out;
				}

				@$key[1] = json_decode(urldecode($key[1]),true);
				if (empty($key[1]) || !is_array($key[1]))
				{
					return $out;
				}
				foreach($key[1] as $key_el)
				{
					if ($key_el== '{$lang}') $key_el = isset($_SESSION['lang']) ? $_SESSION['lang'] : DEFAULT_LANG;
					if (array_key_exists($key_el,$obj))
					{
						$obj = $obj[$key_el];
					}
					else
					{
						return $out;
					}	
				}
				$out = false;
			}
		}
		else
		{
			if (!empty($arr[$key[0]]))
			{
				$out = false;
			}
		}
		return $out;
	}

	function add_empty_for_langs($data, &$arr, $langs = array(), $prefix = array())
	{
		if (!empty($data) && !empty($langs))
		{
			if (empty($prefix))
			{
				if ($prefix === NULL)
				{
					foreach ($data as $obj)
					{
						$find_nonempty = false;
						$empty_iso = array();
						foreach ($langs as $id=>$lang)
						{
							$key = $id;
							if (!isset($obj[$key]) || $obj[$key] === NULL || trim($obj[$key]) === '')
							{
								$empty_iso[] = $lang['iso'];
								if (isset($arr['iso'][$lang['iso']]['all'])) {$arr['iso'][$lang['iso']]['all']++;} else {$arr['iso'][$lang['iso']]['all'] = 1;}
							}
							else
							{
								$find_nonempty = true;
							}
						}
						if ($find_nonempty === true){
							foreach ($empty_iso as $iso)
							{
								if (isset($arr['iso'][$iso]['with_nonempty'])) {$arr['iso'][$iso]['with_nonempty']++;} else {$arr['iso'][$iso]['with_nonempty'] = 1;}
							}
						}
						else
						{
							if (!empty($empty_iso)) 
							{
								if (isset($arr['full_empty'])) {$arr['full_empty']++;} else {$arr['full_empty'] = 1;}
							}
						}
					}
				}
			}
			else
			{
				foreach ($prefix as $str)
				{
					$find_nonempty = false;
					$empty_iso = array();
					foreach ($langs as $lang)
					{
						$key = "$str{$lang['iso']}";
						if ($data[$key] === NULL || trim($data[$key]) === '')
						{
							$empty_iso[] = $lang['iso'];
							if (isset($arr['iso'][$lang['iso']]['all'])) {$arr['iso'][$lang['iso']]['all']++;} else {$arr['iso'][$lang['iso']]['all']= 1;}
						}
						else
						{
							$find_nonempty = true;
						}
					}
					if ($find_nonempty === true){
						foreach ($empty_iso as $iso)
						{
							if (isset($arr['iso'][$iso]['with_nonempty'])) {$arr['iso'][$iso]['with_nonempty']++;} else {$arr['iso'][$iso]['with_nonempty']= 1;}
						}
					}
					else
					{
						if (!empty($empty_iso)) 
						{
							if (isset($arr['full_empty'])) {$arr['full_empty']++;} else {$arr['full_empty'] = 1;}
						}
					}
				}
			}
		}
	}

	function get_date_arr_for_email($date_str, $only_date, $time_zone, $format, $format_with_tz)
	{
		if (empty($date_str))
		{
			$date_str = $datetime_int = $datetime_int_tz = '';
		}
		else
		{
			if (empty($only_date))
			{
				$datetime_int = strtotime($date_str);
				if (empty($time_zone))
				{
					$date_str = gmdate($format,$datetime_int);
					if (empty($format_with_tz)) $date_str = "$date_str GMT";
					$datetime_int_tz = $datetime_int;
				}
				else								
				{
					preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',$time_zone,$parsed_time_zone);
					if (empty($parsed_time_zone))
					{
						$date_str = gmdate($format,$datetime_int);
						if (empty($format_with_tz)) $date_str = "$date_str GMT";
						$datetime_int_tz = $datetime_int;
					}
					else
					{
						$datetime_int_tz = $datetime_int + ($parsed_time_zone[1] === '+' ? 1 : -1)*((int)$parsed_time_zone[2]*60 + (int)$parsed_time_zone[3])*60;
						if (empty($format_with_tz))
						{
							$date_str = gmdate($format,$datetime_int_tz);
						}
						else
						{
							$date_str = gmdate($format,$datetime_int);
						}
						$datetime_int_tz = " $datetime_int_tz";
					}
				}
			}
			else
			{
				$date_str = substr($date_str,0,10) . ' 00:00:00+00:00';
				$format = 'Y-m-d';
				$time_zone = '+00:00';
				$datetime_int = strtotime($date_str);
				$date_str = gmdate($format,$datetime_int);
				$datetime_int = $datetime_int_tz = "  $datetime_int";
			}
		}
		return array($date_str,$datetime_int,$datetime_int_tz);
	}	

	function get_value_for_action_var_template($action, $res)
	{
		if (empty($action)) return $res;
		$action = explode('=', $action);
		if (count($action) < 2) return $res;
		switch ($action[0])
		{
			case "date":
				$action[1] = explode(',', $action[1]);
				$format = urldecode($action[1][0]);
				$format_time_zone_input = count($action[1]) > 1 ? urldecode($action[1][1]) : '';
				$only_date = false;
				$time_zone = false;
				if (substr($res,0,2) === '  ')
				{
					$only_date = true;
					$time_zone = '+00:00';
				}
				elseif (substr($res,0,1) === ' ')
				{
					$only_date = false;
					$time_zone = true;
				}
				$res_trim = trim($res);
				if ($res_trim === '') return $res;
				$res = $res_trim;
				if (!preg_match('/^[0-9]+$/',$res)) $res = strtotime($res);
				preg_match('/[eIOPpTZcrU]/',$format ,$format_with_tz);
				if ($only_date === false)
				{
					if ($time_zone === false)
					{
						if (empty($format_with_tz))
						{
							if (empty($format_time_zone_input))
							{
								$res = gmdate($format,$res);
								$res = "$res GMT";
							}
							else
							{
								preg_match('/^(\+|-)([0-9]{2})\:([0-9]{2})$/',$format_time_zone_input,$format_time_zone);
								if (empty($format_time_zone)) return '';
								$res = $res + ($format_time_zone[1] === '+' ? 1 : -1)*((int)$format_time_zone[2]*60 + (int)$format_time_zone[3])*60;
								$res = gmdate($format,$res);
							}
						}
						else
						{
							$res = gmdate($format,$res);
						}
					}
					else
					{
						$res = gmdate($format,$res);
						if (!empty($format_with_tz) || !empty($format_time_zone_input))
						{
							return '';
						}	
					}
				}
				else
				{
					$format = 'Y-m-d';
					$res = gmdate($format,$res);
				}
		}
		return $res;
	}

	function json_exit($code, $status, $msg = NULL, $data = NULL)
	{
		header('Content-Type: application/json;charset=UTF-8');
		$out = array(
			'code' 		=> $code,
			'status' 	=> $status
		);
		if ($msg !== NULL) $out['message'] = $msg;
		if ($data !== NULL) $out['data'] = $data;
		echo json_encode($out);
		exit;
	}

    function createZipFile($data, $name, $time = 0)
    {
        $datasec = []; // Array to store compressed data
        $ctrlDir = []; // Central directory
        $oldOffset = 0; // Last offset position
        $eofCtrlDir = "\x50\x4b\x05\x06\x00\x00\x00\x00"; // End of central directory record

        if (is_string($data) && is_string($name)) {
            $data = [$name => $data];
        } elseif (is_array($data) && is_string($name)) {
            $extPos = (int) strpos($name, '.');
            $extension = substr($name, $extPos);
            $newData = [];
            foreach ($data as $key => $value) {
                $newName = str_replace($extension, '_' . $key . $extension, $name);
                $newData[$newName] = $value;
            }

            $data = $newData;
        } elseif (is_array($data) && is_array($name) && count($data) === count($name)) {
            /** @var array $data */
            $data = array_combine($name, $data);
        } else {
            return false;
        }

        foreach ($data as $table => $dump) {
            $tempName = str_replace('\\', '/', $table);

            /* Get Local Time */
            $timearray = getdate();

            if ($timearray['year'] < 1980) {
                $timearray['year'] = 1980;
                $timearray['mon'] = 1;
                $timearray['mday'] = 1;
                $timearray['hours'] = 0;
                $timearray['minutes'] = 0;
                $timearray['seconds'] = 0;
            }

            $time = $timearray['year'] - 1980 << 25
            | ($timearray['mon'] << 21)
            | ($timearray['mday'] << 16)
            | ($timearray['hours'] << 11)
            | ($timearray['minutes'] << 5)
            | ($timearray['seconds'] >> 1);

            $hexdtime = pack('V', $time);

            $uncLen = strlen($dump);
            $crc = crc32($dump);
            $zdata = (string) gzcompress($dump);
            $zdata = substr((string) substr($zdata, 0, strlen($zdata) - 4), 2); // fix crc bug
            $cLen = strlen($zdata);
            $fr = "\x50\x4b\x03\x04"
                . "\x14\x00" // ver needed to extract
                . "\x00\x00" // gen purpose bit flag
                . "\x08\x00" // compression method
                . $hexdtime // last mod time and date

                // "local file header" segment
                . pack('V', $crc) // crc32
                . pack('V', $cLen) // compressed filesize
                . pack('V', $uncLen) // uncompressed filesize
                . pack('v', strlen($tempName)) // length of filename
                . pack('v', 0) // extra field length
                . $tempName

                // "file data" segment
                . $zdata;

            $datasec[] = $fr;

            // now add to central directory record
            $cdrec = "\x50\x4b\x01\x02"
                . "\x00\x00" // version made by
                . "\x14\x00" // version needed to extract
                . "\x00\x00" // gen purpose bit flag
                . "\x08\x00" // compression method
                . $hexdtime // last mod time & date
                . pack('V', $crc) // crc32
                . pack('V', $cLen) // compressed filesize
                . pack('V', $uncLen) // uncompressed filesize
                . pack('v', strlen($tempName)) // length of filename
                . pack('v', 0) // extra field length
                . pack('v', 0) // file comment length
                . pack('v', 0) // disk number start
                . pack('v', 0) // internal file attributes
                . pack('V', 32) // external file attributes
                                                 // - 'archive' bit set
                . pack('V', $oldOffset) // relative offset of local header
                . $tempName; // filename
            $oldOffset += strlen($fr);
            // optional extra field, file comment goes here
            // save to central directory
            $ctrlDir[] = $cdrec;
        }

        /* Build string to return */
        $tempCtrlDir = implode('', $ctrlDir);
        $header = $tempCtrlDir .
            $eofCtrlDir .
            pack('v', count($ctrlDir)) . //total #of entries "on this disk"
            pack('v', count($ctrlDir)) . //total #of entries overall
            pack('V', strlen($tempCtrlDir)) . //size of central dir
            pack('V', $oldOffset) . //offset to start of central dir
            "\x00\x00"; //.zip file comment length

        $data = implode('', $datasec);

        return $data . $header;
    }

	function send_msg_to_tg($subject = "", $body = "", $sender_phone = "", $recipient = "", $code = "")
	{
		if ($subject === "" && $body === "" && $code === "") return array('error'=>'empty input data');
		if (!empty(taxi::$data_private['site_constants']['telegram_url']['value'])) $url = trim(taxi::$data_private['site_constants']['telegram_url']['value']);
		if (!empty(taxi::$data_private['site_constants']['telegram_token']['value'])) $token = trim(taxi::$data_private['site_constants']['telegram_token']['value']);
		if (empty($url) || empty($token)) return array('error'=>'empty parameters');
		$arr = array(
							'token'			=>		$token,
							'site'			=>		url('',0,1),
							'c'				=>		CONFIG

		);
		if ($sender_phone === "")
		{
			return array('error'=>'empty sender phone');
		}
		$arr['sender']['phone'] = $sender_phone;
		if ($code === "")
		{
			if ($recipient === "") return array('error'=>'empty recipient');
			$arr['recipient'] = $recipient;
			$msg = [];
			if ($subject !== "") $msg[] = $subject;
			if ($body !== "") $msg[] = $body;
			$arr['msg'] = implode("\n",$msg);
		}
		else
		{
			$arr['code'] = $code;
		}
	
		$c = curl_init();
		curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($c,CURLOPT_URL, $url);
		curl_setopt($c,CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($c,CURLOPT_POST, 1);
		curl_setopt($c,CURLOPT_POSTFIELDS,json_encode($arr));
		curl_setopt($c,CURLOPT_CAINFO,$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
		$response = curl_exec($c);
		curl_close($c);
		if (empty($response)) return array('error'=>'empty response');
		$response_str = $response;
		@$response = json_decode($response,true);
		if (empty($response) || !is_array($response)) 
		{
			 return array('error'=>'response error:' . $response_str);
		}
		if (empty($response['status']))
		{
			return array('error'=>array('response without status',$response));
		}
		if ($response['status'] !== 'success')
		{
			if ($response['status'] === 'error')
			{
				if (empty($response['message']))
				{
					return array('error'=>array('response with error without message',$response));
				}
				else
				{
					return array('error'=>array('response with error',$response['message']));
				}
			}
			else
			{
				return array('error'=>array('response with wrong status',$response));
			}
		}
		if (empty($response['message'])) return array('error'=>'empty output message');
		return $response['message'];
	}

	function set_val_for_array($arr,$keys,$value)
	{
		$target = &$arr;
		foreach($keys as $key)
		{
			if (!array_key_exists($key,$target))
			{
				$target[$key] = array();
			}
			$target = &$target[$key];
		}
		$target = $value;
		unset($target);
		return $arr;
	}

	function create_formula($formula,$parameter,$name)
	{
		$name = trim($name);
		if ($name === '') return array('error'=>'empty formula name');
		$reg_escape_arr = array(
			'.'=>'\\.',		'*'=>'\\*',		'+'=>'\\+',		'['=>'\\[',		']'=>'\\]',
			'('=>'\\(',		')'=>'\\)',		'{'=>'\\{',		'}'=>'\\}',		'^'=>'\\^',
			'$'=>'\\$',		'/'=>'\\/',		'\\'=>'\\\\',	'!'=>'\\!',		'='=>'\\=',
			':'=>'\\:',		'?'=>'\\?',		'|'=>'\\|'
		);
		$parse_arr = array(
			'var'	=>	array(
					//время до начала события 							- 	interval before
				'ibs'	=>	true	/*in seconds*/,	'ibm'	=>	true	/*in minutes*/,		
				'ibh'	=>	true	/*in hours	*/,	'ibd'	=>	true	/*in days	*/,	
				'ibM'	=>	true	/*in monthes*/,	'iby'	=>	true	/*in years	*/,
					//интевал между началом события и стартом продаж	-	start of sales and event interval
				'ses'	=>	true	/*in seconds*/,	'sem'	=>	true	/*in minutes*/,	
				'seh'	=>	true	/*in hours	*/,	'sed'	=>	true	/*in days	*/,
				'seM'	=>	true	/*in monthes*/,	'sey'	=>	true	/*in years	*/,
					//цена в базе										-	database price
				'dp'	=>	true
			),
			'parameter'	=>	array(
				/*'p_1'	=>	'value',*/
			),
			'operator'	=>	array(
		//				'+++'	=>	true,				подобные операторы упорядочить
		//				'++'	=>	true,				в обратном длине порядке	
						'+'		=>	true,		
						'-'		=>	true,
						'*'		=>	true,
						'/'		=>	true,
						'%'		=>	true
			),
			'function'	=>	array(
						'sin'	=>	1,
						'cos'	=>	1,
						'tan'	=>	1,
						'asin'	=>	1,
						'acos'	=>	1,
						'atan'	=>	1,
						'exp'	=>	1,
						'log'	=>	1,
						'pow'	=>	2,
						'sqrt'	=>	1,
						'pi'	=>	0,
						'abs'	=>	1,
						'max'	=>	array(2),
						'min'	=>	array(2)
			),
			'find'	=>	array(
		//				'$1'	=>	'value'
			),
			'need'	=>	array(
		//				'ibs'	=>	true
			)
		);
		$reg_operator_str = array();
		foreach($parse_arr['operator'] as $key=>$val)
		{
			$reg_operator_str[] = strtr($key,$reg_escape_arr);
		}
		$reg_operator_str = implode('|',$reg_operator_str);
		$reg_operator_str = "/$reg_operator_str/";

		@$str = (string)$formula;
		$str = preg_replace('/\s+|\$+/','',$str);
		if ($str === '') return array('error'=>'empty formula');

		if (!empty($parameter))
		{
			if (!is_array($parameter)) return array('error'=>'parameter is not array');
			foreach($parameter as $key=>$val)
			{
				switch (gettype($key))
				{
					case 'integer':
					case 'double':
						$key = var_export($key,true);
					default:
						$key = (string)$key;
				}
				if (!preg_match('/^p_[0-9]+$/',$key)) return array('error'=>'wrong parameter key');
				switch (gettype($val))
				{
					case 'integer':
					case 'double':
						$val = var_export($val,true);
					default:
						$val = (string)$val;
				}
				if (!preg_match('/^[0-9]+(:?\.[0-9]+)?$/',$val)) return array('error'=>'wrong parameter val');
				$parse_arr['parameter'][$key] = $val;
			}
		}

		$i = 0;
		if (!class_exists('MyException')) {class MyException extends Exception { };}
		try {
			while (true)
			{
				$str = preg_replace_callback('/([a-z]*)\(([^()]*)\)/i',function($matches) use (&$parse_arr,&$i,$reg_operator_str) {
					$find_str = array();
					$f_arg = array();
					if ($matches[1] === '')
					{
						$find_str[] = '(';
						if (strpos($matches[2],',') === false)
						{
							$f_arg = array($matches[2]);
						}
						else
						{
							throw new MyException('wrong comma');
						}
					}
					else
					{
						if (isset($parse_arr['function'][$matches[1]]))
						{
							$find_str[] = $matches[1];
							$find_str[] = '(';
							$f_info = $parse_arr['function'][$matches[1]];
							if ($matches[2] === '')
							{
								if ($f_info !== 0 || !empty($f_info[0])) throw new MyException('function needs arguments');
							}
							else
							{
								$f_arg = explode(',',$matches[2]);
								$f_arg_count = count($f_arg);
								if (is_array($f_info))
								{
									if ($f_arg_count < $f_info[0]) throw new MyException('number of arguments less than minimum');
								}
								else
								{
									if ($f_arg_count !== $f_info) throw new MyException('number of arguments is less than necessary');
								}
							}
						}
						else
						{
							throw new MyException('unknown function');
						}
					}
					$find_str_for_args = array();
					foreach($f_arg as $fa)
					{
						$find_str_for_arg = array();
						$search_pos = 0;
						$prev_val_str = false;
						while (true)
						{
							if (preg_match($reg_operator_str,$fa,$res,PREG_OFFSET_CAPTURE,$search_pos))
							{						
								$operator_str = $res[0][0];
								$val_str = substr($fa,$search_pos,$res[0][1]-$search_pos);
								if ($val_str === '')
								{
									if ($operator_str  !== '-')
									{
										throw new MyException('two wrong operators in row');
									}
								}
								else
								{
									if (isset($parse_arr['var'][$val_str]))
									{
										$find_str_for_arg[] = "\${$val_str}";
										$parse_arr['need'][$val_str] = true;
									}
									elseif (isset($parse_arr['parameter'][$val_str]))
									{
										$find_str_for_arg[] = $val_str;
										$parse_arr['need_par'][$val_str] = $parse_arr['parameter'][$val_str];
									}
									elseif (isset($parse_arr['find'][$val_str]))
									{
										$find_str_for_arg[] = $parse_arr['find'][$val_str];
										unset($parse_arr['find'][$val_str]);
									}
									elseif (preg_match('/[0-9]+(:?\.[0-9]+)?/',$val_str))
									{
										$find_str_for_arg[] = $val_str;
									}
									else
									{
										throw new MyException('wrong string content');
									}
								}
								$find_str_for_arg[] = $operator_str;					
								$prev_val_str = $val_str;
								$search_pos = $res[0][1] + strlen($operator_str);
							}
							else
							{
								$val_str = substr($fa,$search_pos);
								if (preg_match('/^[0-9]+(:?\.[0-9]+)?$/',$val_str))
								{
									if ($prev_val_str === '') throw new MyException('not number with minus');
									$find_str_for_arg[] = $val_str;
								}
								else
								{
									if (isset($parse_arr['var'][$val_str]))
									{
										$find_str_for_arg[] = "\${$val_str}";
										$parse_arr['need'][$val_str] = true;
									}
									elseif (isset($parse_arr['parameter'][$val_str]))
									{
										$find_str_for_arg[] = $val_str;
										$parse_arr['need_par'][$val_str] = $parse_arr['parameter'][$val_str];
									}
									elseif (isset($parse_arr['find'][$val_str]))
									{
										$find_str_for_arg[] = $parse_arr['find'][$val_str];
										unset($parse_arr['find'][$val_str]);
									}
									else
									{
										throw new MyException('wrong string');
									}
								}
								break;
							}
						}
						$find_str_for_args[] = implode('',$find_str_for_arg);
					}
					$find_str[] = implode(',',$find_str_for_args);
					$find_str[] = ')';
					$find_str_var = "\${$i}";
					$parse_arr['find'][$find_str_var] = implode('',$find_str);
					$i++;
					return $find_str_var;
				},$str,-1,$replace_count);
				if (empty($replace_count)) break;
			}
		} catch (MyException $e) {
			return array('error'=>'formula with error: ' . $e->getMessage());
		}

		$find_str = array();
		$search_pos = 0;
		$prev_val_str = false;
		while (true)
		{
			if (preg_match($reg_operator_str,$str,$res,PREG_OFFSET_CAPTURE,$search_pos))
			{						
				$operator_str = $res[0][0];
				$val_str = substr($str,$search_pos,$res[0][1]-$search_pos);
				if ($val_str === '')
				{
					if ($operator_str  !== '-')
					{
						return array('error'=>'two wrong operators in row');
					}
				}
				else
				{
					if (isset($parse_arr['var'][$val_str]))
					{
						$find_str[] = "\${$val_str}";
						$parse_arr['need'][$val_str] = true;
					}
					elseif (isset($parse_arr['parameter'][$val_str]))
					{
						$find_str[] = $val_str;
						$parse_arr['need_par'][$val_str] = $parse_arr['parameter'][$val_str];
					}
					elseif (isset($parse_arr['find'][$val_str]))
					{
						$find_str[] = $parse_arr['find'][$val_str];
						unset($parse_arr['find'][$val_str]);
					}
					elseif (preg_match('/[0-9]+(:?\.[0-9]+)?/',$val_str))
					{
						$find_str[] = $val_str;
					}
					else
					{
						return array('error'=>'wrong string content');
					}
				}
				$find_str[] = $operator_str;					
				$prev_val_str = $val_str;
				$search_pos = $res[0][1] + strlen($operator_str);
			}
			else
			{
				$val_str = substr($str,$search_pos);
				if (preg_match('/^[0-9]+(:?\.[0-9]+)?$/',$val_str))
				{
					if ($prev_val_str === '') return array('error'=>'not number with minus');
					$find_str[] = $val_str;
				}
				else
				{
					if (isset($parse_arr['var'][$val_str]))
					{
						$find_str[] = "\${$val_str}";
						$parse_arr['need'][$val_str] = true;
					}
					elseif (isset($parse_arr['parameter'][$val_str]))
					{
						$find_str[] = $val_str;
						$parse_arr['need_par'][$val_str] = $parse_arr['parameter'][$val_str];
					}
					elseif (isset($parse_arr['find'][$val_str]))
					{
						$find_str[] = $parse_arr['find'][$val_str];
						unset($parse_arr['find'][$val_str]);
					}
					else
					{
						return array('error'=>'wrong string');
					}
				}
				break;
			}
		}
		$str = implode('',$find_str);

		if (!empty($parse_arr['find'])) $str = strtr($str,$parse_arr['find']);
		if (!empty($parse_arr['need_par'])) $str = strtr($str,$parse_arr['need_par']);

		$code_need_str = '';
		foreach($parse_arr['need'] as $key=>$val)
		{
			$code_need_str .= "\${$key} = \$var['$key'];\n	";
		}
		$code = "function $name(\$var)
{
	{$code_need_str}return $str;
}";

		return array(
			'formula'	=>	$str,
			'need' 			=>	$parse_arr['need'],
			'code'			=>	$code
		);
	}

	function set_header_content_disposition($filename)
	{
		$filename_encoded = rawurlencode($filename);	
		if (preg_match('/MSIE (6|7|8)/', $_SERVER['HTTP_USER_AGENT']))
		{
			header("Content-disposition: inline; filename=$filename_encoded");
		}
		else
		{
			header("Content-disposition: inline; filename=\"$filename\"; filename*=UTF-8''$filename_encoded");
		}
	}

	function delete_from_dropbox($id_dropbox_link = '')
	{
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_id']['value'])) $client_id = trim(taxi::$data_private['site_constants']['dropbox_file_client_id']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value'])) $client_secret = trim(taxi::$data_private['site_constants']['dropbox_file_client_secret']['value']);
		if (!empty(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value'])) $refresh_token = trim(taxi::$data_private['site_constants']['dropbox_file_refresh_token']['value']);
		if (empty($id_dropbox_link) || empty($client_id) || empty($client_secret) || empty($refresh_token)) return array('error'=>'empty parameters');

		@$dropbox_access_token = trim(file_get_contents($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/dropbox_access_token.txt'));
		$update = false;
		if (empty($dropbox_access_token))
		{
			$dropbox_access_token = update_dropbox_access_token();
			if (!empty($dropbox_access_token['error'])) return array('error'=>'new: ' . $dropbox_access_token['error']);
			$update = true;
			$dropbox_access_token = $dropbox_access_token['value'];
		}
		$constant = 'constant'; $path = "/c/{$constant('CONFIG')}/$id_dropbox_link";
		while (true)
		{
			$c = curl_init();
			curl_setopt($c,CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($c,CURLOPT_URL, 'https://api.dropboxapi.com/2/files/delete_v2');
			curl_setopt($c,CURLOPT_POST, 1);
			curl_setopt($c,CURLOPT_POSTFIELDS,"{\"path\":\"$path\"}");
			$headers = array(
				"Authorization: Bearer $dropbox_access_token",
				"Content-Type: application/json"
			);
			curl_setopt($c, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($c, CURLOPT_CAINFO, $_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'config/cacert.pem');
			$response = curl_exec($c);
			curl_close($c);
			if (empty($response)) return array('error'=>'upload failed');
			@$response = json_decode($response,true);
			if (empty($response) || !is_array($response)) 
			{
				 return array('error'=>'upload response error');
			}
			if (!empty($response['error']))
			{
				if (!empty($response['error_summary']) && substr($response['error_summary'],0,20) == 'expired_access_token')
				{
					if ($update == true)
					{
						return array('error'=>'access_token error');
					}
					else
					{
						$dropbox_access_token = update_dropbox_access_token();
						if (!empty($dropbox_access_token['error'])) return array('error'=>'update: ' . $dropbox_access_token['error']);
						$update = true;
						$dropbox_access_token = $dropbox_access_token['value'];
						continue;
					}
				}
				else
				{
					 return array('error'=>'upload error');
				}
			}
			return array('data'=>$response);
		}	
	}

	function html_to_pdf($content)
	{
		require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'models/html2pdf-5.2.8/src/Html2Pdf.php');

		$format = 'A4';
		$content = preg_replace_callback('/<\!--format:(.+?)-->/i',function($matches) use (&$format) {
			$format_parse = preg_split('/\s*,\s*/',trim($matches[1]));
			if (isset($format_parse[1]))
			{
				$format = array($format_parse[0],$format_parse[1]);
			}
			else
			{
				$format = $format_parse[0];
			}
			return '';
		},$content,1);

		$margins = 3;
		$content = preg_replace_callback('/<\!--margins:(.+?)-->/i',function($matches) use (&$margins) {
			$margins_parse = preg_split('/\s*,\s*/',trim($matches[1]));
			switch (count($margins_parse))
			{
				case 1:
					$margins = $margins_parse[0];
				 break;
				case 2:
					$margins = array($margins_parse[0],$margins_parse[1],$margins_parse[0],$margins_parse[1]);
				 break;
				case 3:
					$margins = array($margins_parse[0],$margins_parse[1],$margins_parse[2],$margins_parse[1]);
				 break;
				default:
					$margins = array($margins_parse[0],$margins_parse[1],$margins_parse[2],$margins_parse[3]);
			}
			return '';
		},$content,1);		

		$html2pdf = new Spipu\Html2Pdf\Html2Pdf('P',$format,'en',true,"UTF-8",$margins); 
		$html2pdf->AddFont('Inter','',$_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'models/TCPDF-main/fonts/intervariablefont_opszwght.php');
		$html2pdf->setDefaultFont('freeserif');
		try {
			$html2pdf->writeHTML($content);
		} 
		catch (Exception $e) 
		{
			return '';
		}
		return $html2pdf->output('','S');
	}

	function string_to_base64_png_qr($content)
	{
		require_once($_SERVER['DOCUMENT_ROOT'] . ROOT_URL . 'models/TCPDF-main/tcpdf_barcodes_2d.php');
		$barcodeobj = new TCPDF2DBarcode($content,'QRCODE,H');
		return "data:image/png;base64," . base64_encode($barcodeobj->getBarcodePngData(10,10));
	}

	function round_price($sum, $par)
	{
		$sum = explode(' ',$sum);
		if (count($sum) > 1)
		{
			return round((float)$sum[0],2) . ' ' . $sum[1];
		}
		else
		{
			return round((float)$sum[0],2);
		}	
	}

	function find_arr_like($source,&$like)
	{
		while (true)
		{
			if (!is_array($like) || empty($like))
			{
				$like = array();
				break;
			}
			if (!is_array($source))
			{
				$like = array();
				break;
			}
			foreach($like as $key=>$val)
			{
				if (array_key_exists($key,$source))
				{
					if (!is_array($val) || empty($val))
					{
						$like[$key] = $source[$key];
					}
					elseif (!is_array($source[$key]))
					{
						unset($like[$key]);
					}
					else
					{
						find_arr_like($source[$key],$like[$key]);
					}
				}
				else
				{
					unset($like[$key]);
				}
			}
			break;
		}
	}